(function (root, factory) {
    if (typeof define === "function" && define.amd) {
        define(["exports"], factory);
    } else if (typeof exports === 'object' &&
               typeof exports.nodeName !== 'string') {
        factory(exports);
    } else {
        factory(root.libsodium = {});
    }
})(this, (function (exports) {
    "use strict";
    var Module = exports;
var Module;if(!Module)Module=(typeof Module!=="undefined"?Module:null)||{};var moduleOverrides={};for(var key in Module){if(Module.hasOwnProperty(key)){moduleOverrides[key]=Module[key]}}var ENVIRONMENT_IS_WEB=false;var ENVIRONMENT_IS_WORKER=false;var ENVIRONMENT_IS_NODE=false;var ENVIRONMENT_IS_SHELL=false;if(Module["ENVIRONMENT"]){if(Module["ENVIRONMENT"]==="WEB"){ENVIRONMENT_IS_WEB=true}else if(Module["ENVIRONMENT"]==="WORKER"){ENVIRONMENT_IS_WORKER=true}else if(Module["ENVIRONMENT"]==="NODE"){ENVIRONMENT_IS_NODE=true}else if(Module["ENVIRONMENT"]==="SHELL"){ENVIRONMENT_IS_SHELL=true}else{throw new Error("The provided Module['ENVIRONMENT'] value is not valid. It must be one of: WEB|WORKER|NODE|SHELL.")}}else{ENVIRONMENT_IS_WEB=typeof window==="object";ENVIRONMENT_IS_WORKER=typeof importScripts==="function";ENVIRONMENT_IS_NODE=typeof process==="object"&&typeof require==="function"&&!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_WORKER;ENVIRONMENT_IS_SHELL=!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_NODE&&!ENVIRONMENT_IS_WORKER}if(ENVIRONMENT_IS_NODE){if(!Module["print"])Module["print"]=console.log;if(!Module["printErr"])Module["printErr"]=console.warn;var nodeFS;var nodePath;Module["read"]=function read(filename,binary){if(!nodeFS)nodeFS=require("fs");if(!nodePath)nodePath=require("path");filename=nodePath["normalize"](filename);var ret=nodeFS["readFileSync"](filename);return binary?ret:ret.toString()};Module["readBinary"]=function readBinary(filename){var ret=Module["read"](filename,true);if(!ret.buffer){ret=new Uint8Array(ret)}assert(ret.buffer);return ret};Module["load"]=function load(f){globalEval(read(f))};if(!Module["thisProgram"]){if(process["argv"].length>1){Module["thisProgram"]=process["argv"][1].replace(/\\/g,"/")}else{Module["thisProgram"]="unknown-program"}}Module["arguments"]=process["argv"].slice(2);if(typeof module!=="undefined"){module["exports"]=Module}process["on"]("uncaughtException",(function(ex){if(!(ex instanceof ExitStatus)){throw ex}}));Module["inspect"]=(function(){return"[Emscripten Module object]"})}else if(ENVIRONMENT_IS_SHELL){if(!Module["print"])Module["print"]=print;if(typeof printErr!="undefined")Module["printErr"]=printErr;if(typeof read!="undefined"){Module["read"]=read}else{Module["read"]=function read(){throw"no read() available (jsc?)"}}Module["readBinary"]=function readBinary(f){if(typeof readbuffer==="function"){return new Uint8Array(readbuffer(f))}var data=read(f,"binary");assert(typeof data==="object");return data};if(typeof scriptArgs!="undefined"){Module["arguments"]=scriptArgs}else if(typeof arguments!="undefined"){Module["arguments"]=arguments}}else if(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER){Module["read"]=function read(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.send(null);return xhr.responseText};Module["readAsync"]=function readAsync(url,onload,onerror){var xhr=new XMLHttpRequest;xhr.open("GET",url,true);xhr.responseType="arraybuffer";xhr.onload=function xhr_onload(){if(xhr.status==200||xhr.status==0&&xhr.response){onload(xhr.response)}else{onerror()}};xhr.onerror=onerror;xhr.send(null)};if(typeof arguments!="undefined"){Module["arguments"]=arguments}if(typeof console!=="undefined"){if(!Module["print"])Module["print"]=function print(x){console.log(x)};if(!Module["printErr"])Module["printErr"]=function printErr(x){console.warn(x)}}else{var TRY_USE_DUMP=false;if(!Module["print"])Module["print"]=TRY_USE_DUMP&&typeof dump!=="undefined"?(function(x){dump(x)}):(function(x){})}if(ENVIRONMENT_IS_WORKER){Module["load"]=importScripts}if(typeof Module["setWindowTitle"]==="undefined"){Module["setWindowTitle"]=(function(title){document.title=title})}}else{throw"Unknown runtime environment. Where are we?"}function globalEval(x){abort("NO_DYNAMIC_EXECUTION=1 was set, cannot eval")}if(!Module["load"]&&Module["read"]){Module["load"]=function load(f){globalEval(Module["read"](f))}}if(!Module["print"]){Module["print"]=(function(){})}if(!Module["printErr"]){Module["printErr"]=Module["print"]}if(!Module["arguments"]){Module["arguments"]=[]}if(!Module["thisProgram"]){Module["thisProgram"]="./this.program"}Module.print=Module["print"];Module.printErr=Module["printErr"];Module["preRun"]=[];Module["postRun"]=[];for(var key in moduleOverrides){if(moduleOverrides.hasOwnProperty(key)){Module[key]=moduleOverrides[key]}}moduleOverrides=undefined;var Runtime={setTempRet0:(function(value){tempRet0=value}),getTempRet0:(function(){return tempRet0}),stackSave:(function(){return STACKTOP}),stackRestore:(function(stackTop){STACKTOP=stackTop}),getNativeTypeSize:(function(type){switch(type){case"i1":case"i8":return 1;case"i16":return 2;case"i32":return 4;case"i64":return 8;case"float":return 4;case"double":return 8;default:{if(type[type.length-1]==="*"){return Runtime.QUANTUM_SIZE}else if(type[0]==="i"){var bits=parseInt(type.substr(1));assert(bits%8===0);return bits/8}else{return 0}}}}),getNativeFieldSize:(function(type){return Math.max(Runtime.getNativeTypeSize(type),Runtime.QUANTUM_SIZE)}),STACK_ALIGN:16,prepVararg:(function(ptr,type){if(type==="double"||type==="i64"){if(ptr&7){assert((ptr&7)===4);ptr+=4}}else{assert((ptr&3)===0)}return ptr}),getAlignSize:(function(type,size,vararg){if(!vararg&&(type=="i64"||type=="double"))return 8;if(!type)return Math.min(size,8);return Math.min(size||(type?Runtime.getNativeFieldSize(type):0),Runtime.QUANTUM_SIZE)}),dynCall:(function(sig,ptr,args){if(args&&args.length){return Module["dynCall_"+sig].apply(null,[ptr].concat(args))}else{return Module["dynCall_"+sig].call(null,ptr)}}),functionPointers:[null,null,null,null,null,null,null,null],addFunction:(function(func){for(var i=0;i<Runtime.functionPointers.length;i++){if(!Runtime.functionPointers[i]){Runtime.functionPointers[i]=func;return 1*(1+i)}}throw"Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS."}),removeFunction:(function(index){Runtime.functionPointers[(index-1)/1]=null}),warnOnce:(function(text){if(!Runtime.warnOnce.shown)Runtime.warnOnce.shown={};if(!Runtime.warnOnce.shown[text]){Runtime.warnOnce.shown[text]=1;Module.printErr(text)}}),funcWrappers:{},getFuncWrapper:(function(func,sig){assert(sig);if(!Runtime.funcWrappers[sig]){Runtime.funcWrappers[sig]={}}var sigCache=Runtime.funcWrappers[sig];if(!sigCache[func]){if(sig.length===1){sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func)}}else if(sig.length===2){sigCache[func]=function dynCall_wrapper(arg){return Runtime.dynCall(sig,func,[arg])}}else{sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func,Array.prototype.slice.call(arguments))}}}return sigCache[func]}),getCompilerSetting:(function(name){throw"You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work"}),stackAlloc:(function(size){var ret=STACKTOP;STACKTOP=STACKTOP+size|0;STACKTOP=STACKTOP+15&-16;return ret}),staticAlloc:(function(size){var ret=STATICTOP;STATICTOP=STATICTOP+size|0;STATICTOP=STATICTOP+15&-16;return ret}),dynamicAlloc:(function(size){var ret=DYNAMICTOP;DYNAMICTOP=DYNAMICTOP+size|0;DYNAMICTOP=DYNAMICTOP+15&-16;if(DYNAMICTOP>=TOTAL_MEMORY){var success=enlargeMemory();if(!success){DYNAMICTOP=ret;return 0}}return ret}),alignMemory:(function(size,quantum){var ret=size=Math.ceil(size/(quantum?quantum:16))*(quantum?quantum:16);return ret}),makeBigInt:(function(low,high,unsigned){var ret=unsigned?+(low>>>0)+ +(high>>>0)*+4294967296:+(low>>>0)+ +(high|0)*+4294967296;return ret}),GLOBAL_BASE:8,QUANTUM_SIZE:4,__dummy__:0};Module["Runtime"]=Runtime;var ABORT=false;var EXITSTATUS=0;function assert(condition,text){if(!condition){abort("Assertion failed: "+text)}}function getCFunc(ident){var func=Module["_"+ident];if(!func){abort("NO_DYNAMIC_EXECUTION=1 was set, cannot eval")}assert(func,"Cannot call unknown function "+ident+" (perhaps LLVM optimizations or closure removed it?)");return func}var cwrap,ccall;((function(){var JSfuncs={"stackSave":(function(){Runtime.stackSave()}),"stackRestore":(function(){Runtime.stackRestore()}),"arrayToC":(function(arr){var ret=Runtime.stackAlloc(arr.length);writeArrayToMemory(arr,ret);return ret}),"stringToC":(function(str){var ret=0;if(str!==null&&str!==undefined&&str!==0){ret=Runtime.stackAlloc((str.length<<2)+1);writeStringToMemory(str,ret)}return ret})};var toC={"string":JSfuncs["stringToC"],"array":JSfuncs["arrayToC"]};ccall=function ccallFunc(ident,returnType,argTypes,args,opts){var func=getCFunc(ident);var cArgs=[];var stack=0;if(args){for(var i=0;i<args.length;i++){var converter=toC[argTypes[i]];if(converter){if(stack===0)stack=Runtime.stackSave();cArgs[i]=converter(args[i])}else{cArgs[i]=args[i]}}}var ret=func.apply(null,cArgs);if(returnType==="string")ret=Pointer_stringify(ret);if(stack!==0){if(opts&&opts.async){EmterpreterAsync.asyncFinalizers.push((function(){Runtime.stackRestore(stack)}));return}Runtime.stackRestore(stack)}return ret};cwrap=function cwrap(ident,returnType,argTypes){return(function(){return ccall(ident,returnType,argTypes,arguments)})}}))();Module["ccall"]=ccall;Module["cwrap"]=cwrap;function setValue(ptr,value,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":HEAP8[ptr>>0]=value;break;case"i8":HEAP8[ptr>>0]=value;break;case"i16":HEAP16[ptr>>1]=value;break;case"i32":HEAP32[ptr>>2]=value;break;case"i64":tempI64=[value>>>0,(tempDouble=value,+Math_abs(tempDouble)>=+1?tempDouble>+0?(Math_min(+Math_floor(tempDouble/+4294967296),+4294967295)|0)>>>0:~~+Math_ceil((tempDouble- +(~~tempDouble>>>0))/+4294967296)>>>0:0)],HEAP32[ptr>>2]=tempI64[0],HEAP32[ptr+4>>2]=tempI64[1];break;case"float":HEAPF32[ptr>>2]=value;break;case"double":HEAPF64[ptr>>3]=value;break;default:abort("invalid type for setValue: "+type)}}Module["setValue"]=setValue;function getValue(ptr,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":return HEAP8[ptr>>0];case"i8":return HEAP8[ptr>>0];case"i16":return HEAP16[ptr>>1];case"i32":return HEAP32[ptr>>2];case"i64":return HEAP32[ptr>>2];case"float":return HEAPF32[ptr>>2];case"double":return HEAPF64[ptr>>3];default:abort("invalid type for setValue: "+type)}return null}Module["getValue"]=getValue;var ALLOC_NORMAL=0;var ALLOC_STACK=1;var ALLOC_STATIC=2;var ALLOC_DYNAMIC=3;var ALLOC_NONE=4;Module["ALLOC_NORMAL"]=ALLOC_NORMAL;Module["ALLOC_STACK"]=ALLOC_STACK;Module["ALLOC_STATIC"]=ALLOC_STATIC;Module["ALLOC_DYNAMIC"]=ALLOC_DYNAMIC;Module["ALLOC_NONE"]=ALLOC_NONE;function allocate(slab,types,allocator,ptr){var zeroinit,size;if(typeof slab==="number"){zeroinit=true;size=slab}else{zeroinit=false;size=slab.length}var singleType=typeof types==="string"?types:null;var ret;if(allocator==ALLOC_NONE){ret=ptr}else{ret=[typeof _malloc==="function"?_malloc:Runtime.staticAlloc,Runtime.stackAlloc,Runtime.staticAlloc,Runtime.dynamicAlloc][allocator===undefined?ALLOC_STATIC:allocator](Math.max(size,singleType?1:types.length))}if(zeroinit){var ptr=ret,stop;assert((ret&3)==0);stop=ret+(size&~3);for(;ptr<stop;ptr+=4){HEAP32[ptr>>2]=0}stop=ret+size;while(ptr<stop){HEAP8[ptr++>>0]=0}return ret}if(singleType==="i8"){if(slab.subarray||slab.slice){HEAPU8.set(slab,ret)}else{HEAPU8.set(new Uint8Array(slab),ret)}return ret}var i=0,type,typeSize,previousType;while(i<size){var curr=slab[i];if(typeof curr==="function"){curr=Runtime.getFunctionIndex(curr)}type=singleType||types[i];if(type===0){i++;continue}if(type=="i64")type="i32";setValue(ret+i,curr,type);if(previousType!==type){typeSize=Runtime.getNativeTypeSize(type);previousType=type}i+=typeSize}return ret}Module["allocate"]=allocate;function getMemory(size){if(!staticSealed)return Runtime.staticAlloc(size);if(typeof _sbrk!=="undefined"&&!_sbrk.called||!runtimeInitialized)return Runtime.dynamicAlloc(size);return _malloc(size)}Module["getMemory"]=getMemory;function Pointer_stringify(ptr,length){if(length===0||!ptr)return"";var hasUtf=0;var t;var i=0;while(1){t=HEAPU8[ptr+i>>0];hasUtf|=t;if(t==0&&!length)break;i++;if(length&&i==length)break}if(!length)length=i;var ret="";if(hasUtf<128){var MAX_CHUNK=1024;var curr;while(length>0){curr=String.fromCharCode.apply(String,HEAPU8.subarray(ptr,ptr+Math.min(length,MAX_CHUNK)));ret=ret?ret+curr:curr;ptr+=MAX_CHUNK;length-=MAX_CHUNK}return ret}return Module["UTF8ToString"](ptr)}Module["Pointer_stringify"]=Pointer_stringify;function AsciiToString(ptr){var str="";while(1){var ch=HEAP8[ptr++>>0];if(!ch)return str;str+=String.fromCharCode(ch)}}Module["AsciiToString"]=AsciiToString;function stringToAscii(str,outPtr){return writeAsciiToMemory(str,outPtr,false)}Module["stringToAscii"]=stringToAscii;function UTF8ArrayToString(u8Array,idx){var u0,u1,u2,u3,u4,u5;var str="";while(1){u0=u8Array[idx++];if(!u0)return str;if(!(u0&128)){str+=String.fromCharCode(u0);continue}u1=u8Array[idx++]&63;if((u0&224)==192){str+=String.fromCharCode((u0&31)<<6|u1);continue}u2=u8Array[idx++]&63;if((u0&240)==224){u0=(u0&15)<<12|u1<<6|u2}else{u3=u8Array[idx++]&63;if((u0&248)==240){u0=(u0&7)<<18|u1<<12|u2<<6|u3}else{u4=u8Array[idx++]&63;if((u0&252)==248){u0=(u0&3)<<24|u1<<18|u2<<12|u3<<6|u4}else{u5=u8Array[idx++]&63;u0=(u0&1)<<30|u1<<24|u2<<18|u3<<12|u4<<6|u5}}}if(u0<65536){str+=String.fromCharCode(u0)}else{var ch=u0-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}}}Module["UTF8ArrayToString"]=UTF8ArrayToString;function UTF8ToString(ptr){return UTF8ArrayToString(HEAPU8,ptr)}Module["UTF8ToString"]=UTF8ToString;function stringToUTF8Array(str,outU8Array,outIdx,maxBytesToWrite){if(!(maxBytesToWrite>0))return 0;var startIdx=outIdx;var endIdx=outIdx+maxBytesToWrite-1;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){if(outIdx>=endIdx)break;outU8Array[outIdx++]=u}else if(u<=2047){if(outIdx+1>=endIdx)break;outU8Array[outIdx++]=192|u>>6;outU8Array[outIdx++]=128|u&63}else if(u<=65535){if(outIdx+2>=endIdx)break;outU8Array[outIdx++]=224|u>>12;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=2097151){if(outIdx+3>=endIdx)break;outU8Array[outIdx++]=240|u>>18;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=67108863){if(outIdx+4>=endIdx)break;outU8Array[outIdx++]=248|u>>24;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else{if(outIdx+5>=endIdx)break;outU8Array[outIdx++]=252|u>>30;outU8Array[outIdx++]=128|u>>24&63;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}}outU8Array[outIdx]=0;return outIdx-startIdx}Module["stringToUTF8Array"]=stringToUTF8Array;function stringToUTF8(str,outPtr,maxBytesToWrite){return stringToUTF8Array(str,HEAPU8,outPtr,maxBytesToWrite)}Module["stringToUTF8"]=stringToUTF8;function lengthBytesUTF8(str){var len=0;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){++len}else if(u<=2047){len+=2}else if(u<=65535){len+=3}else if(u<=2097151){len+=4}else if(u<=67108863){len+=5}else{len+=6}}return len}Module["lengthBytesUTF8"]=lengthBytesUTF8;function demangle(func){var hasLibcxxabi=!!Module["___cxa_demangle"];if(hasLibcxxabi){try{var buf=_malloc(func.length);writeStringToMemory(func.substr(1),buf);var status=_malloc(4);var ret=Module["___cxa_demangle"](buf,0,0,status);if(getValue(status,"i32")===0&&ret){return Pointer_stringify(ret)}}catch(e){}finally{if(buf)_free(buf);if(status)_free(status);if(ret)_free(ret)}return func}Runtime.warnOnce("warning: build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling");return func}function demangleAll(text){return text.replace(/__Z[\w\d_]+/g,(function(x){var y=demangle(x);return x===y?x:x+" ["+y+"]"}))}function jsStackTrace(){var err=new Error;if(!err.stack){try{throw new Error(0)}catch(e){err=e}if(!err.stack){return"(no stack trace available)"}}return err.stack.toString()}function stackTrace(){var js=jsStackTrace();if(Module["extraStackTrace"])js+="\n"+Module["extraStackTrace"]();return demangleAll(js)}Module["stackTrace"]=stackTrace;var PAGE_SIZE=4096;function alignMemoryPage(x){if(x%4096>0){x+=4096-x%4096}return x}var HEAP;var buffer;var HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64;function updateGlobalBufferViews(){Module["HEAP8"]=HEAP8=new Int8Array(buffer);Module["HEAP16"]=HEAP16=new Int16Array(buffer);Module["HEAP32"]=HEAP32=new Int32Array(buffer);Module["HEAPU8"]=HEAPU8=new Uint8Array(buffer);Module["HEAPU16"]=HEAPU16=new Uint16Array(buffer);Module["HEAPU32"]=HEAPU32=new Uint32Array(buffer);Module["HEAPF32"]=HEAPF32=new Float32Array(buffer);Module["HEAPF64"]=HEAPF64=new Float64Array(buffer)}var STATIC_BASE=0,STATICTOP=0,staticSealed=false;var STACK_BASE=0,STACKTOP=0,STACK_MAX=0;var DYNAMIC_BASE=0,DYNAMICTOP=0;function abortOnCannotGrowMemory(){abort("Cannot enlarge memory arrays. Either (1) compile with  -s TOTAL_MEMORY=X  with X higher than the current value "+TOTAL_MEMORY+", (2) compile with  -s ALLOW_MEMORY_GROWTH=1  which adjusts the size at runtime but prevents some optimizations, (3) set Module.TOTAL_MEMORY to a higher value before the program runs, or if you want malloc to return NULL (0) instead of this abort, compile with  -s ABORTING_MALLOC=0 ")}function enlargeMemory(){abortOnCannotGrowMemory()}var TOTAL_STACK=Module["TOTAL_STACK"]||5242880;var TOTAL_MEMORY=Module["TOTAL_MEMORY"]||35e6;var totalMemory=64*1024;while(totalMemory<TOTAL_MEMORY||totalMemory<2*TOTAL_STACK){if(totalMemory<16*1024*1024){totalMemory*=2}else{totalMemory+=16*1024*1024}}if(totalMemory!==TOTAL_MEMORY){TOTAL_MEMORY=totalMemory}if(Module["buffer"]){buffer=Module["buffer"]}else{buffer=new ArrayBuffer(TOTAL_MEMORY)}updateGlobalBufferViews();HEAP32[0]=255;if(HEAPU8[0]!==255||HEAPU8[3]!==0)throw"Typed arrays 2 must be run on a little-endian system";Module["HEAP"]=HEAP;Module["buffer"]=buffer;Module["HEAP8"]=HEAP8;Module["HEAP16"]=HEAP16;Module["HEAP32"]=HEAP32;Module["HEAPU8"]=HEAPU8;Module["HEAPU16"]=HEAPU16;Module["HEAPU32"]=HEAPU32;Module["HEAPF32"]=HEAPF32;Module["HEAPF64"]=HEAPF64;function callRuntimeCallbacks(callbacks){while(callbacks.length>0){var callback=callbacks.shift();if(typeof callback=="function"){callback();continue}var func=callback.func;if(typeof func==="number"){if(callback.arg===undefined){Runtime.dynCall("v",func)}else{Runtime.dynCall("vi",func,[callback.arg])}}else{func(callback.arg===undefined?null:callback.arg)}}}var __ATPRERUN__=[];var __ATINIT__=[];var __ATMAIN__=[];var __ATEXIT__=[];var __ATPOSTRUN__=[];var runtimeInitialized=false;var runtimeExited=false;function preRun(){if(Module["preRun"]){if(typeof Module["preRun"]=="function")Module["preRun"]=[Module["preRun"]];while(Module["preRun"].length){addOnPreRun(Module["preRun"].shift())}}callRuntimeCallbacks(__ATPRERUN__)}function ensureInitRuntime(){if(runtimeInitialized)return;runtimeInitialized=true;callRuntimeCallbacks(__ATINIT__)}function preMain(){callRuntimeCallbacks(__ATMAIN__)}function exitRuntime(){callRuntimeCallbacks(__ATEXIT__);runtimeExited=true}function postRun(){if(Module["postRun"]){if(typeof Module["postRun"]=="function")Module["postRun"]=[Module["postRun"]];while(Module["postRun"].length){addOnPostRun(Module["postRun"].shift())}}callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(cb){__ATPRERUN__.unshift(cb)}Module["addOnPreRun"]=addOnPreRun;function addOnInit(cb){__ATINIT__.unshift(cb)}Module["addOnInit"]=addOnInit;function addOnPreMain(cb){__ATMAIN__.unshift(cb)}Module["addOnPreMain"]=addOnPreMain;function addOnExit(cb){__ATEXIT__.unshift(cb)}Module["addOnExit"]=addOnExit;function addOnPostRun(cb){__ATPOSTRUN__.unshift(cb)}Module["addOnPostRun"]=addOnPostRun;function intArrayFromString(stringy,dontAddNull,length){var len=length>0?length:lengthBytesUTF8(stringy)+1;var u8array=new Array(len);var numBytesWritten=stringToUTF8Array(stringy,u8array,0,u8array.length);if(dontAddNull)u8array.length=numBytesWritten;return u8array}Module["intArrayFromString"]=intArrayFromString;function intArrayToString(array){var ret=[];for(var i=0;i<array.length;i++){var chr=array[i];if(chr>255){chr&=255}ret.push(String.fromCharCode(chr))}return ret.join("")}Module["intArrayToString"]=intArrayToString;function writeStringToMemory(string,buffer,dontAddNull){var array=intArrayFromString(string,dontAddNull);var i=0;while(i<array.length){var chr=array[i];HEAP8[buffer+i>>0]=chr;i=i+1}}Module["writeStringToMemory"]=writeStringToMemory;function writeArrayToMemory(array,buffer){for(var i=0;i<array.length;i++){HEAP8[buffer++>>0]=array[i]}}Module["writeArrayToMemory"]=writeArrayToMemory;function writeAsciiToMemory(str,buffer,dontAddNull){for(var i=0;i<str.length;++i){HEAP8[buffer++>>0]=str.charCodeAt(i)}if(!dontAddNull)HEAP8[buffer>>0]=0}Module["writeAsciiToMemory"]=writeAsciiToMemory;if(!Math["imul"]||Math["imul"](4294967295,5)!==-5)Math["imul"]=function imul(a,b){var ah=a>>>16;var al=a&65535;var bh=b>>>16;var bl=b&65535;return al*bl+(ah*bl+al*bh<<16)|0};Math.imul=Math["imul"];if(!Math["clz32"])Math["clz32"]=(function(x){x=x>>>0;for(var i=0;i<32;i++){if(x&1<<31-i)return i}return 32});Math.clz32=Math["clz32"];if(!Math["trunc"])Math["trunc"]=(function(x){return x<0?Math.ceil(x):Math.floor(x)});Math.trunc=Math["trunc"];var Math_abs=Math.abs;var Math_cos=Math.cos;var Math_sin=Math.sin;var Math_tan=Math.tan;var Math_acos=Math.acos;var Math_asin=Math.asin;var Math_atan=Math.atan;var Math_atan2=Math.atan2;var Math_exp=Math.exp;var Math_log=Math.log;var Math_sqrt=Math.sqrt;var Math_ceil=Math.ceil;var Math_floor=Math.floor;var Math_pow=Math.pow;var Math_imul=Math.imul;var Math_fround=Math.fround;var Math_min=Math.min;var Math_clz32=Math.clz32;var Math_trunc=Math.trunc;var runDependencies=0;var runDependencyWatcher=null;var dependenciesFulfilled=null;function addRunDependency(id){runDependencies++;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}}Module["addRunDependency"]=addRunDependency;function removeRunDependency(id){runDependencies--;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}if(runDependencies==0){if(runDependencyWatcher!==null){clearInterval(runDependencyWatcher);runDependencyWatcher=null}if(dependenciesFulfilled){var callback=dependenciesFulfilled;dependenciesFulfilled=null;callback()}}}Module["removeRunDependency"]=removeRunDependency;Module["preloadedImages"]={};Module["preloadedAudios"]={};var ASM_CONSTS=[(function(){{return Module.getRandomValue()}}),(function(){{if(Module.getRandomValue===undefined){try{var window_="object"===typeof window?window:self,crypto_=typeof window_.crypto!=="undefined"?window_.crypto:window_.msCrypto,randomValuesStandard=(function(){var buf=new Uint32Array(1);crypto_.getRandomValues(buf);return buf[0]>>>0});randomValuesStandard();Module.getRandomValue=randomValuesStandard}catch(e){try{var crypto=require("crypto"),randomValueNodeJS=(function(){var buf=crypto.randomBytes(4);return(buf[0]<<24|buf[1]<<16|buf[2]<<8|buf[3])>>>0});randomValueNodeJS();Module.getRandomValue=randomValueNodeJS}catch(e){throw"No secure random number generator found"}}}}})];function _emscripten_asm_const_i(code){return ASM_CONSTS[code]()}function _emscripten_asm_const_v(code){return ASM_CONSTS[code]()}STATIC_BASE=8;STATICTOP=STATIC_BASE+56416;__ATINIT__.push({func:(function(){__GLOBAL__I_000101()})},{func:(function(){__GLOBAL__sub_I_iostream_cpp()})});allocate([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,38,232,149,143,194,178,39,176,69,195,244,137,242,239,152,240,213,223,172,5,211,198,51,57,177,56,2,136,109,83,252,5,199,23,106,112,61,77,216,79,186,60,11,118,13,16,103,15,42,32,83,250,44,57,204,198,78,199,253,119,146,172,3,122,19,232,149,143,194,178,39,176,69,195,244,137,242,239,152,240,213,223,172,5,211,198,51,57,177,56,2,136,109,83,252,133,180,23,106,112,61,77,216,79,186,60,11,118,13,16,103,15,42,32,83,250,44,57,204,198,78,199,253,119,146,172,3,250,236,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,237,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,238,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,218,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,219,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,8,201,188,243,103,230,9,106,59,167,202,132,133,174,103,187,43,248,148,254,114,243,110,60,241,54,29,95,58,245,79,165,209,130,230,173,127,82,14,81,31,108,62,43,140,104,5,155,107,189,65,251,171,217,131,31,121,33,126,19,25,205,224,91,124,160,0,0,48,181,0,0,224,1,0,0,0,0,0,0,84,160,0,0,90,181,0,0,124,160,0,0,108,181,0,0,224,1,0,0,0,0,0,0,84,160,0,0,150,181,0,0,84,160,0,0,199,181,0,0,8,161,0,0,248,181,0,0,0,0,0,0,1,0,0,0,208,1,0,0,3,244,255,255,8,161,0,0,39,182,0,0,0,0,0,0,1,0,0,0,232,1,0,0,3,244,255,255,8,161,0,0,86,182,0,0,0,0,0,0,1,0,0,0,208,1,0,0,3,244,255,255,8,161,0,0,133,182,0,0,0,0,0,0,1,0,0,0,232,1,0,0,3,244,255,255,124,160,0,0,180,182,0,0,56,7,0,0,0,0,0,0,124,160,0,0,206,182,0,0,72,7,0,0,0,0,0,0,124,160,0,0,41,183,0,0,248,1,0,0,0,0,0,0,124,160,0,0,103,183,0,0,0,2,0,0,0,0,0,0,124,160,0,0,127,183,0,0,248,1,0,0,0,0,0,0,124,160,0,0,152,183,0,0,0,2,0,0,0,0,0,0,124,160,0,0,177,183,0,0,216,2,0,0,0,0,0,0,124,160,0,0,197,183,0,0,40,7,0,0,0,0,0,0,124,160,0,0,219,183,0,0,216,2,0,0,0,0,0,0,8,161,0,0,239,183,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,24,3,0,0,0,0,0,0,8,161,0,0,51,184,0,0,0,0,0,0,1,0,0,0,48,3,0,0,0,0,0,0,84,160,0,0,73,184,0,0,8,161,0,0,136,184,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,88,3,0,0,0,0,0,0,8,161,0,0,204,184,0,0,0,0,0,0,1,0,0,0,48,3,0,0,0,0,0,0,8,161,0,0,226,184,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,144,3,0,0,0,0,0,0,8,161,0,0,38,185,0,0,0,0,0,0,1,0,0,0,168,3,0,0,0,0,0,0,84,160,0,0,60,185,0,0,8,161,0,0,104,185,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,208,3,0,0,0,0,0,0,8,161,0,0,172,185,0,0,0,0,0,0,1,0,0,0,168,3,0,0,0,0,0,0,8,161,0,0,194,185,0,0,0,0,0,0,3,0,0,0,216,2,0,0,2,0,0,0,16,4,0,0,2,0,0,0,24,4,0,0,0,8,0,0,84,160,0,0,7,186,0,0,84,160,0,0,26,186,0,0,8,161,0,0,124,187,0,0,0,0,0,0,3,0,0,0,216,2,0,0,2,0,0,0,16,4,0,0,2,0,0,0,72,4,0,0,0,8,0,0,84,160,0,0,193,187,0,0,8,161,0,0,227,187,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,112,4,0,0,0,8,0,0,84,160,0,0,40,188,0,0,8,161,0,0,61,188,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,112,4,0,0,0,8,0,0,8,161,0,0,151,188,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,184,4,0,0,2,0,0,0,84,160,0,0,179,188,0,0,8,161,0,0,200,188,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,184,4,0,0,2,0,0,0,8,161,0,0,228,188,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,184,4,0,0,2,0,0,0,8,161,0,0,0,189,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,184,4,0,0,2,0,0,0,8,161,0,0,28,189,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,64,5,0,0,0,0,0,0,84,160,0,0,98,189,0,0,8,161,0,0,154,189,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,104,5,0,0,0,0,0,0,84,160,0,0,224,189,0,0,8,161,0,0,4,190,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,144,5,0,0,0,0,0,0,84,160,0,0,74,190,0,0,8,161,0,0,105,190,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,184,5,0,0,0,0,0,0,84,160,0,0,175,190,0,0,8,161,0,0,200,190,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,224,5,0,0,2,0,0,0,84,160,0,0,221,190,0,0,8,161,0,0,245,190,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,224,5,0,0,2,0,0,0,124,160,0,0,10,191,0,0,24,6,0,0,0,0,0,0,8,161,0,0,44,191,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,56,6,0,0,2,0,0,0,84,160,0,0,79,191,0,0,124,160,0,0,102,191,0,0,24,6,0,0,0,0,0,0,8,161,0,0,137,191,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,56,6,0,0,2,0,0,0,8,161,0,0,171,191,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,56,6,0,0,2,0,0,0,8,161,0,0,205,191,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,56,6,0,0,2,0,0,0,124,160,0,0,240,191,0,0,216,2,0,0,0,0,0,0,8,161,0,0,6,192,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,224,6,0,0,2,0,0,0,84,160,0,0,24,192,0,0,8,161,0,0,45,192,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,224,6,0,0,2,0,0,0,124,160,0,0,63,192,0,0,216,2,0,0,0,0,0,0,124,160,0,0,95,192,0,0,216,2,0,0,0,0,0,0,84,160,0,0,123,192,0,0,84,160,0,0,161,192,0,0,124,160,0,0,186,192,0,0,184,7,0,0,0,0,0,0,124,160,0,0,209,192,0,0,48,7,0,0,0,0,0,0,84,160,0,0,248,193,0,0,124,160,0,0,214,193,0,0,128,7,0,0,0,0,0,0,124,160,0,0,131,193,0,0,96,7,0,0,0,0,0,0,124,160,0,0,168,193,0,0,144,7,0,0,0,0,0,0,84,160,0,0,201,193,0,0,124,160,0,0,240,194,0,0,88,7,0,0,0,0,0,0,124,160,0,0,12,195,0,0,88,7,0,0,0,0,0,0,124,160,0,0,28,195,0,0,88,7,0,0,0,0,0,0,124,160,0,0,46,195,0,0,168,7,0,0,0,0,0,0,124,160,0,0,63,195,0,0,88,7,0,0,0,0,0,0,124,160,0,0,89,195,0,0,96,7,0,0,0,0,0,0,182,120,89,255,133,114,211,0,189,110,21,255,15,10,106,0,41,192,1,0,152,232,121,255,188,60,160,255,153,113,206,255,0,183,226,254,180,13,72,255,176,160,14,254,211,201,134,255,158,24,143,0,127,105,53,0,96,12,189,0,167,215,251,255,159,76,128,254,106,101,225,255,30,252,4,0,146,12,174,0,89,241,178,254,10,229,166,255,123,221,42,254,30,20,212,0,82,128,3,0,48,209,243,0,119,121,64,255,50,227,156,255,0,110,197,1,103,27,144,0,133,59,140,1,189,241,36,255,248,37,195,1,96,220,55,0,183,76,62,255,195,66,61,0,50,76,164,1,225,164,76,255,76,61,163,255,117,62,31,0,81,145,64,255,118,65,14,0,162,115,214,255,6,138,46,0,124,230,244,255,10,138,143,0,52,26,194,0,184,244,76,0,129,143,41,1,190,244,19,255,123,170,122,255,98,129,68,0,121,213,147,0,86,101,30,255,161,103,155,0,140,89,67,255,239,229,190,1,67,11,181,0,198,240,137,254,238,69,188,255,67,151,238,0,19,42,108,255,229,85,113,1,50,68,135,255,17,106,9,0,50,103,1,255,80,1,168,1,35,152,30,255,16,168,185,1,56,89,232,255,101,210,252,0,41,250,71,0,204,170,79,255,14,46,239,255,80,77,239,0,189,214,75,255,17,141,249,0,38,80,76,255,190,85,117,0,86,228,170,0,156,216,208,1,195,207,164,255,150,66,76,255,175,225,16,255,141,80,98,1,76,219,242,0,198,162,114,0,46,218,152,0,155,43,241,254,155,160,104,255,51,187,165,0,2,17,175,0,66,84,160,1,247,58,30,0,35,65,53,254,69,236,191,0,45,134,245,1,163,123,221,0,32,110,20,255,52,23,165,0,186,214,71,0,233,176,96,0,242,239,54,1,57,89,138,0,83,0,84,255,136,160,100,0,92,142,120,254,104,124,190,0,181,177,62,255,250,41,85,0,152,130,42,1,96,252,246,0,151,151,63,254,239,133,62,0,32,56,156,0,45,167,189,255,142,133,179,1,131,86,211,0,187,179,150,254,250,170,14,255,210,163,78,0,37,52,151,0,99,77,26,0,238,156,213,255,213,192,209,1,73,46,84,0,20,65,41,1,54,206,79,0,201,131,146,254,170,111,24,255,177,33,50,254,171,38,203,255,78,247,116,0,209,221,153,0,133,128,178,1,58,44,25,0,201,39,59,1,189,19,252,0,49,229,210,1,117,187,117,0,181,179,184,1,0,114,219,0,48,94,147,0,245,41,56,0,125,13,204,254,244,173,119,0,44,221,32,254,84,234,20,0,249,160,198,1,236,126,234,255,47,99,168,254,170,226,153,255,102,179,216,0,226,141,122,255,122,66,153,254,182,245,134,0,227,228,25,1,214,57,235,255,216,173,56,255,181,231,210,0,119,128,157,255,129,95,136,255,110,126,51,0,2,169,183,255,7,130,98,254,69,176,94,255,116,4,227,1,217,242,145,255,202,173,31,1,105,1,39,255,46,175,69,0,228,47,58,255,215,224,69,254,207,56,69,255,16,254,139,255,23,207,212,255,202,20,126,255,95,213,96,255,9,176,33,0,200,5,207,255,241,42,128,254,35,33,192,255,248,229,196,1,129,17,120,0,251,103,151,255,7,52,112,255,140,56,66,255,40,226,245,255,217,70,37,254,172,214,9,255,72,67,134,1,146,192,214,255,44,38,112,0,68,184,75,255,206,90,251,0,149,235,141,0,181,170,58,0,116,244,239,0,92,157,2,0,102,173,98,0,233,137,96,1,127,49,203,0,5,155,148,0,23,148,9,255,211,122,12,0,34,134,26,255,219,204,136,0,134,8,41,255,224,83,43,254,85,25,247,0,109,127,0,254,169,136,48,0,238,119,219,255,231,173,213,0,206,18,254,254,8,186,7,255,126,9,7,1,111,42,72,0,111,52,236,254,96,63,141,0,147,191,127,254,205,78,192,255,14,106,237,1,187,219,76,0,175,243,187,254,105,89,173,0,85,25,89,1,162,243,148,0,2,118,209,254,33,158,9,0,139,163,46,255,93,70,40,0,108,42,142,254,111,252,142,255,155,223,144,0,51,229,167,255,73,252,155,255,94,116,12,255,152,160,218,255,156,238,37,255,179,234,207,255,197,0,179,255,154,164,141,0,225,196,104,0,10,35,25,254,209,212,242,255,97,253,222,254,184,101,229,0,222,18,127,1,164,136,135,255,30,207,140,254,146,97,243,0,129,192,26,254,201,84,33,255,111,10,78,255,147,81,178,255,4,4,24,0,161,238,215,255,6,141,33,0,53,215,14,255,41,181,208,255,231,139,157,0,179,203,221,255,255,185,113,0,189,226,172,255,113,66,214,255,202,62,45,255,102,64,8,255,78,174,16,254,133,117,68,255,133,59,140,1,189,241,36,255,248,37,195,1,96,220,55,0,183,76,62,255,195,66,61,0,50,76,164,1,225,164,76,255,76,61,163,255,117,62,31,0,81,145,64,255,118,65,14,0,162,115,214,255,6,138,46,0,124,230,244,255,10,138,143,0,52,26,194,0,184,244,76,0,129,143,41,1,190,244,19,255,123,170,122,255,98,129,68,0,121,213,147,0,86,101,30,255,161,103,155,0,140,89,67,255,239,229,190,1,67,11,181,0,198,240,137,254,238,69,188,255,234,113,60,255,37,255,57,255,69,178,182,254,128,208,179,0,118,26,125,254,3,7,214,255,241,50,77,255,85,203,197,255,211,135,250,255,25,48,100,255,187,213,180,254,17,88,105,0,83,209,158,1,5,115,98,0,4,174,60,254,171,55,110,255,217,181,17,255,20,188,170,0,146,156,102,254,87,214,174,255,114,122,155,1,233,44,170,0,127,8,239,1,214,236,234,0,175,5,219,0,49,106,61,255,6,66,208,255,2,106,110,255,81,234,19,255,215,107,192,255,67,151,238,0,19,42,108,255,229,85,113,1,50,68,135,255,17,106,9,0,50,103,1,255,80,1,168,1,35,152,30,255,16,168,185,1,56,89,232,255,101,210,252,0,41,250,71,0,204,170,79,255,14,46,239,255,80,77,239,0,189,214,75,255,17,141,249,0,38,80,76,255,190,85,117,0,86,228,170,0,156,216,208,1,195,207,164,255,150,66,76,255,175,225,16,255,141,80,98,1,76,219,242,0,198,162,114,0,46,218,152,0,155,43,241,254,155,160,104,255,178,9,252,254,100,110,212,0,14,5,167,0,233,239,163,255,28,151,157,1,101,146,10,255,254,158,70,254,71,249,228,0,88,30,50,0,68,58,160,255,191,24,104,1,129,66,129,255,192,50,85,255,8,179,138,255,38,250,201,0,115,80,160,0,131,230,113,0,125,88,147,0,90,68,199,0,253,76,158,0,28,255,118,0,113,250,254,0,66,75,46,0,230,218,43,0,229,120,186,1,148,68,43,0,136,124,238,1,187,107,197,255,84,53,246,255,51,116,254,255,51,187,165,0,2,17,175,0,66,84,160,1,247,58,30,0,35,65,53,254,69,236,191,0,45,134,245,1,163,123,221,0,32,110,20,255,52,23,165,0,186,214,71,0,233,176,96,0,242,239,54,1,57,89,138,0,83,0,84,255,136,160,100,0,92,142,120,254,104,124,190,0,181,177,62,255,250,41,85,0,152,130,42,1,96,252,246,0,151,151,63,254,239,133,62,0,32,56,156,0,45,167,189,255,142,133,179,1,131,86,211,0,187,179,150,254,250,170,14,255,68,113,21,255,222,186,59,255,66,7,241,1,69,6,72,0,86,156,108,254,55,167,89,0,109,52,219,254,13,176,23,255,196,44,106,255,239,149,71,255,164,140,125,255,159,173,1,0,51,41,231,0,145,62,33,0,138,111,93,1,185,83,69,0,144,115,46,0,97,151,16,255,24,228,26,0,49,217,226,0,113,75,234,254,193,153,12,255,182,48,96,255,14,13,26,0,128,195,249,254,69,193,59,0,132,37,81,254,125,106,60,0,214,240,169,1,164,227,66,0,210,163,78,0,37,52,151,0,99,77,26,0,238,156,213,255,213,192,209,1,73,46,84,0,20,65,41,1,54,206,79,0,201,131,146,254,170,111,24,255,177,33,50,254,171,38,203,255,78,247,116,0,209,221,153,0,133,128,178,1,58,44,25,0,201,39,59,1,189,19,252,0,49,229,210,1,117,187,117,0,181,179,184,1,0,114,219,0,48,94,147,0,245,41,56,0,125,13,204,254,244,173,119,0,44,221,32,254,84,234,20,0,249,160,198,1,236,126,234,255,143,62,221,0,129,89,214,255,55,139,5,254,68,20,191,255,14,204,178,1,35,195,217,0,47,51,206,1,38,246,165,0,206,27,6,254,158,87,36,0,217,52,146,255,125,123,215,255,85,60,31,255,171,13,7,0,218,245,88,254,252,35,60,0,55,214,160,255,133,101,56,0,224,32,19,254,147,64,234,0,26,145,162,1,114,118,125,0,248,252,250,0,101,94,196,255,198,141,226,254,51,42,182,0,135,12,9,254,109,172,210,255,197,236,194,1,241,65,154,0,48,156,47,255,153,67,55,255,218,165,34,254,74,180,179,0,218,66,71,1,88,122,99,0,212,181,219,255,92,42,231,255,239,0,154,0,245,77,183,255,94,81,170,1,18,213,216,0,171,93,71,0,52,94,248,0,18,151,161,254,197,209,66,255,174,244,15,254,162,48,183,0,49,61,240,254,182,93,195,0,199,228,6,1,200,5,17,255,137,45,237,255,108,148,4,0,90,79,237,255,39,63,77,255,53,82,207,1,142,22,118,255,101,232,18,1,92,26,67,0,5,200,88,255,33,168,138,255,149,225,72,0,2,209,27,255,44,245,168,1,220,237,17,255,30,211,105,254,141,238,221,0,128,80,245,254,111,254,14,0,222,95,190,1,223,9,241,0,146,76,212,255,108,205,104,255,63,117,153,0,144,69,48,0,35,228,111,0,192,33,193,255,112,214,190,254,115,152,151,0,23,102,88,0,51,74,248,0,226,199,143,254,204,162,101,255,208,97,189,1,245,104,18,0,230,246,30,255,23,148,69,0,110,88,52,254,226,181,89,255,208,47,90,254,114,161,80,255,33,116,248,0,179,152,87,255,69,144,177,1,88,238,26,255,58,32,113,1,1,77,69,0,59,121,52,255,152,238,83,0,52,8,193,0,231,39,233,255,199,34,138,0,222,68,173,0,91,57,242,254,220,210,127,255,192,7,246,254,151,35,187,0,195,236,165,0,111,93,206,0,212,247,133,1,154,133,209,255,155,231,10,0,64,78,38,0,122,249,100,1,30,19,97,255,62,91,249,1,248,133,77,0,197,63,168,254,116,10,82,0,184,236,113,254,212,203,194,255,61,100,252,254,36,5,202,255,119,91,153,255,129,79,29,0,103,103,171,254,237,215,111,255,216,53,69,0,239,240,23,0,194,149,221,255,38,225,222,0,232,255,180,254,118,82,133,255,57,209,177,1,139,232,133,0,158,176,46,254,194,115,46,0,88,247,229,1,28,103,191,0,221,222,175,254,149,235,44,0,151,228,25,254,218,105,103,0,142,85,210,0,149,129,190,255,213,65,94,254,117,134,224,255,82,198,117,0,157,221,220,0,163,101,36,0,197,114,37,0,104,172,166,254,11,182,0,0,81,72,188,255,97,188,16,255,69,6,10,0,199,147,145,255,8,9,115,1,65,214,175,255,217,173,209,0,80,127,166,0,247,229,4,254,167,183,124,255,90,28,204,254,175,59,240,255,11,41,248,1,108,40,51,255,144,177,195,254,150,250,126,0,138,91,65,1,120,60,222,255,245,193,239,0,29,214,189,255,128,2,25,0,80,154,162,0,77,220,107,1,234,205,74,255,54,166,103,255,116,72,9,0,228,94,47,255,30,200,25,255,35,214,89,255,61,176,140,255,83,226,163,255,75,130,172,0,128,38,17,0,95,137,152,255,215,124,159,1,79,93,0,0,148,82,157,254,195,130,251,255,40,202,76,255,251,126,224,0,157,99,62,254,207,7,225,255,96,68,195,0,140,186,157,255,131,19,231,255,42,128,254,0,52,219,61,254,102,203,72,0,141,7,11,255,186,164,213,0,31,122,119,0,133,242,145,0,208,252,232,255,91,213,182,255,143,4,250,254,249,215,74,0,165,30,111,1,171,9,223,0,229,123,34,1,92,130,26,255,77,155,45,1,195,139,28,255,59,224,78,0,136,17,247,0,108,121,32,0,79,250,189,255,96,227,252,254,38,241,62,0,62,174,125,255,155,111,93,255,10,230,206,1,97,197,40,255,0,49,57,254,65,250,13,0,18,251,150,255,220,109,210,255,5,174,166,254,44,129,189,0,235,35,147,255,37,247,141,255,72,141,4,255,103,107,255,0,247,90,4,0,53,44,42,0,2,30,240,0,4,59,63,0,88,78,36,0,113,167,180,0,190,71,193,255,199,158,164,255,58,8,172,0,77,33,12,0,65,63,3,0,153,77,33,255,172,254,102,1,228,221,4,255,87,30,254,1,146,41,86,255,138,204,239,254,108,141,17,255,187,242,135,0,210,208,127,0,68,45,14,254,73,96,62,0,81,60,24,255,170,6,36,255,3,249,26,0,35,213,109,0,22,129,54,255,21,35,225,255,234,61,56,255,58,217,6,0,143,124,88,0,236,126,66,0,209,38,183,255,34,238,6,255,174,145,102,0,95,22,211,0,196,15,153,254,46,84,232,255,117,34,146,1,231,250,74,255,27,134,100,1,92,187,195,255,170,198,112,0,120,28,42,0,209,70,67,0,29,81,31,0,29,168,100,1,169,173,160,0,107,35,117,0,62,96,59,255,81,12,69,1,135,239,190,255,220,252,18,0,163,220,58,255,137,137,188,255,83,102,109,0,96,6,76,0,234,222,210,255,185,174,205,1,60,158,213,255,13,241,214,0,172,129,140,0,93,104,242,0,192,156,251,0,43,117,30,0,225,81,158,0,127,232,218,0,226,28,203,0,233,27,151,255,117,43,5,255,242,14,47,255,33,20,6,0,137,251,44,254,27,31,245,255,183,214,125,254,40,121,149,0,186,158,213,255,89,8,227,0,69,88,0,254,203,135,225,0,201,174,203,0,147,71,184,0,18,121,41,254,94,5,78,0,224,214,240,254,36,5,180,0,251,135,231,1,163,138,212,0,210,249,116,254,88,129,187,0,19,8,49,254,62,14,144,255,159,76,211,0,214,51,82,0,109,117,228,254,103,223,203,255,75,252,15,1,154,71,220,255,23,13,91,1,141,168,96,255,181,182,133,0,250,51,55,0,234,234,212,254,175,63,158,0,39,240,52,1,158,189,36,255,213,40,85,1,32,180,247,255,19,102,26,1,84,24,97,255,69,21,222,0,148,139,122,255,220,213,235,1,232,203,255,0,121,57,147,0,227,7,154,0,53,22,147,1,72,1,225,0,82,134,48,254,83,60,157,255,145,72,169,0,34,103,239,0,198,233,47,0,116,19,4,255,184,106,9,255,183,129,83,0,36,176,230,1,34,103,72,0,219,162,134,0,245,42,158,0,32,149,96,254,165,44,144,0,202,239,72,254,215,150,5,0,42,66,36,1,132,215,175,0,86,174,86,255,26,197,156,255,49,232,135,254,103,182,82,0,253,128,176,1,153,178,122,0,245,250,10,0,236,24,178,0,137,106,132,0,40,29,41,0,50,30,152,255,124,105,38,0,230,191,75,0,143,43,170,0,44,131,20,255,44,13,23,255,237,255,155,1,159,109,100,255,112,181,24,255,104,220,108,0,55,211,131,0,99,12,213,255,152,151,145,255,238,5,159,0,97,155,8,0,33,108,81,0,1,3,103,0,62,109,34,255,250,155,180,0,32,71,195,255,38,70,145,1,159,95,245,0,69,229,101,1,136,28,240,0,79,224,25,0,78,110,121,255,248,168,124,0,187,128,247,0,2,147,235,254,79,11,132,0,70,58,12,1,181,8,163,255,79,137,133,255,37,170,11,255,141,243,85,255,176,231,215,255,204,150,164,255,239,215,39,255,46,87,156,254,8,163,88,255,172,34,232,0,66,44,102,255,27,54,41,254,236,99,87,255,41,123,169,1,52,114,43,0,117,134,40,0,155,134,26,0,231,207,91,254,35,132,38,255,19,102,125,254,36,227,133,255,118,3,113,255,29,13,124,0,152,96,74,1,88,146,206,255,167,191,220,254,162,18,88,255,182,100,23,0,31,117,52,0,81,46,106,1,12,2,7,0,69,80,201,1,209,246,172,0,12,48,141,1,224,211,88,0,116,226,159,0,122,98,130,0,65,236,234,1,225,226,9,255,207,226,123,1,89,214,59,0,112,135,88,1,90,244,203,255,49,11,38,1,129,108,186,0,89,112,15,1,101,46,204,255,127,204,45,254,79,255,221,255,51,73,18,255,127,42,101,255,241,21,202,0,160,227,7,0,105,50,236,0,79,52,197,255,104,202,208,1,180,15,16,0,101,197,78,255,98,77,203,0,41,185,241,1,35,193,124,0,35,155,23,255,207,53,192,0,11,125,163,1,249,158,185,255,4,131,48,0,21,93,111,255,61,121,231,1,69,200,36,255,185,48,185,255,111,238,21,255,39,50,25,255,99,215,163,255,87,212,30,255,164,147,5,255,128,6,35,1,108,223,110,255,194,76,178,0,74,101,180,0,243,47,48,0,174,25,43,255,82,173,253,1,54,114,192,255,40,55,91,0,215,108,176,255,11,56,7,0,224,233,76,0,209,98,202,254,242,25,125,0,44,193,93,254,203,8,177,0,135,176,19,0,112,71,213,255,206,59,176,1,4,67,26,0,14,143,213,254,42,55,208,255,60,67,120,0,193,21,163,0,99,164,115,0,10,20,118,0,156,212,222,254,160,7,217,255,114,245,76,1,117,59,123,0,176,194,86,254,213,15,176,0,78,206,207,254,213,129,59,0,233,251,22,1,96,55,152,255,236,255,15,255,197,89,84,255,93,149,133,0,174,160,113,0,234,99,169,255,152,116,88,0,144,164,83,255,95,29,198,255,34,47,15,255,99,120,134,255,5,236,193,0,249,247,126,255,147,187,30,0,50,230,117,255,108,217,219,255,163,81,166,255,72,25,169,254,155,121,79,255,28,155,89,254,7,126,17,0,147,65,33,1,47,234,253,0,26,51,18,0,105,83,199,255,163,196,230,0,113,248,164,0,226,254,218,0,189,209,203,255,164,247,222,254,255,35,165,0,4,188,243,1,127,179,71,0,37,237,254,255,100,186,240,0,5,57,71,254,103,72,73,255,244,18,81,254,229,210,132,255,238,6,180,255,11,229,174,255,227,221,192,1,17,49,28,0,163,215,196,254,9,118,4,255,51,240,71,0,113,129,109,255,76,240,231,0,188,177,127,0,125,71,44,1,26,175,243,0,94,169,25,254,27,230,29,0,15,139,119,1,168,170,186,255,172,197,76,255,252,75,188,0,137,124,196,0,72,22,96,255,45,151,249,1,220,145,100,0,64,192,159,255,120,239,226,0,129,178,146,0,0,192,125,0,235,138,234,0,183,157,146,0,83,199,192,255,184,172,72,255,73,225,128,0,77,6,250,255,186,65,67,0,104,246,207,0,188,32,138,255,218,24,242,0,67,138,81,254,237,129,121,255,20,207,150,1,41,199,16,255,6,20,128,0,159,118,5,0,181,16,143,255,220,38,15,0,23,64,147,254,73,26,13,0,87,228,57,1,204,124,128,0,43,24,223,0,219,99,199,0,22,75,20,255,19,27,126,0,157,62,215,0,110,29,230,0,179,167,255,1,54,252,190,0,221,204,182,254,179,158,65,255,81,157,3,0,194,218,159,0,170,223,0,0,224,11,32,255,38,197,98,0,168,164,37,0,23,88,7,1,164,186,110,0,96,36,134,0,234,242,229,0,250,121,19,0,242,254,112,255,3,47,94,1,9,239,6,255,81,134,153,254,214,253,168,255,67,124,224,0,245,95,74,0,28,30,44,254,1,109,220,255,178,89,89,0,252,36,76,0,24,198,46,255,76,77,111,0,134,234,136,255,39,94,29,0,185,72,234,255,70,68,135,255,231,102,7,254,77,231,140,0,167,47,58,1,148,97,118,255,16,27,225,1,166,206,143,255,110,178,214,255,180,131,162,0,143,141,225,1,13,218,78,255,114,153,33,1,98,104,204,0,175,114,117,1,167,206,75,0,202,196,83,1,58,64,67,0,138,47,111,1,196,247,128,255,137,224,224,254,158,112,207,0,154,100,255,1,134,37,107,0,198,128,79,255,127,209,155,255,163,254,185,254,60,14,243,0,31,219,112,254,29,217,65,0,200,13,116,254,123,60,196,255,224,59,184,254,242,89,196,0,123,16,75,254,149,16,206,0,69,254,48,1,231,116,223,255,209,160,65,1,200,80,98,0,37,194,184,254,148,63,34,0,139,240,65,255,217,144,132,255,56,38,45,254,199,120,210,0,108,177,166,255,160,222,4,0,220,126,119,254,165,107,160,255,82,220,248,1,241,175,136,0,144,141,23,255,169,138,84,0,160,137,78,255,226,118,80,255,52,27,132,255,63,96,139,255,152,250,39,0,188,155,15,0,232,51,150,254,40,15,232,255,240,229,9,255,137,175,27,255,75,73,97,1,218,212,11,0,135,5,162,1,107,185,213,0,2,249,107,255,40,242,70,0,219,200,25,0,25,157,13,0,67,82,80,255,196,249,23,255,145,20,149,0,50,72,146,0,94,76,148,1,24,251,65,0,31,192,23,0,184,212,201,255,123,233,162,1,247,173,72,0,162,87,219,254,126,134,89,0,159,11,12,254,166,105,29,0,73,27,228,1,113,120,183,255,66,163,109,1,212,143,11,255,159,231,168,1,255,128,90,0,57,14,58,254,89,52,10,255,253,8,163,1,0,145,210,255,10,129,85,1,46,181,27,0,103,136,160,254,126,188,209,255,34,35,111,0,215,219,24,255,212,11,214,254,101,5,118,0,232,197,133,255,223,167,109,255,237,80,86,255,70,139,94,0,158,193,191,1,155,15,51,255,15,190,115,0,78,135,207,255,249,10,27,1,181,125,233,0,95,172,13,254,170,213,161,255,39,236,138,255,95,93,87,255,190,128,95,0,125,15,206,0,166,150,159,0,227,15,158,255,206,158,120,255,42,141,128,0,101,178,120,1,156,109,131,0,218,14,44,254,247,168,206,255,212,112,28,0,112,17,228,255,90,16,37,1,197,222,108,0,254,207,83,255,9,90,243,255,243,244,172,0,26,88,115,255,205,116,122,0,191,230,193,0,180,100,11,1,217,37,96,255,154,78,156,0,235,234,31,255,206,178,178,255,149,192,251,0,182,250,135,0,246,22,105,0,124,193,109,255,2,210,149,255,169,17,170,0,0,96,110,255,117,9,8,1,50,123,40,255,193,189,99,0,34,227,160,0,48,80,70,254,211,51,236,0,45,122,245,254,44,174,8,0,173,37,233,255,158,65,171,0,122,69,215,255,90,80,2,255,131,106,96,254,227,114,135,0,205,49,119,254,176,62,64,255,82,51,17,255,241,20,243,255,130,13,8,254,128,217,243,255,162,27,1,254,90,118,241,0,246,198,246,255,55,16,118,255,200,159,157,0,163,17,1,0,140,107,121,0,85,161,118,255,38,0,149,0,156,47,238,0,9,166,166,1,75,98,181,255,50,74,25,0,66,15,47,0,139,225,159,0,76,3,142,255,14,238,184,0,11,207,53,255,183,192,186,1,171,32,174,255,191,76,221,1,247,170,219,0,25,172,50,254,217,9,233,0,203,126,68,255,183,92,48,0,127,167,183,1,65,49,254,0,16,63,127,1,254,21,170,255,59,224,127,254,22,48,63,255,27,78,130,254,40,195,29,0,250,132,112,254,35,203,144,0,104,169,168,0,207,253,30,255,104,40,38,254,94,228,88,0,206,16,128,255,212,55,122,255,223,22,234,0,223,197,127,0,253,181,181,1,145,102,118,0,236,153,36,255,212,217,72,255,20,38,24,254,138,62,62,0,152,140,4,0,230,220,99,255,1,21,212,255,148,201,231,0,244,123,9,254,0,171,210,0,51,58,37,255,1,255,14,255,244,183,145,254,0,242,166,0,22,74,132,0,121,216,41,0,95,195,114,254,133,24,151,255,156,226,231,255,247,5,77,255,246,148,115,254,225,92,81,255,222,80,246,254,170,123,89,255,74,199,141,0,29,20,8,255,138,136,70,255,93,75,92,0,221,147,49,254,52,126,226,0,229,124,23,0,46,9,181,0,205,64,52,1,131,254,28,0,151,158,212,0,131,64,78,0,206,25,171,0,0,230,139,0,191,253,110,254,103,247,167,0,64,40,40,1,42,165,241,255,59,75,228,254,124,243,189,255,196,92,178,255,130,140,86,255,141,89,56,1,147,198,5,255,203,248,158,254,144,162,141,0,11,172,226,0,130,42,21,255,1,167,143,255,144,36,36,255,48,88,164,254,168,170,220,0,98,71,214,0,91,208,79,0,159,76,201,1,166,42,214,255,69,255,0,255,6,128,125,255,190,1,140,0,146,83,218,255,215,238,72,1,122,127,53,0,189,116,165,255,84,8,66,255,214,3,208,255,213,110,133,0,195,168,44,1,158,231,69,0,162,64,200,254,91,58,104,0,182,58,187,254,249,228,136,0,203,134,76,254,99,221,233,0,75,254,214,254,80,69,154,0,64,152,248,254,236,136,202,255,157,105,153,254,149,175,20,0,22,35,19,255,124,121,233,0,186,250,198,254,132,229,139,0,137,80,174,255,165,125,68,0,144,202,148,254,235,239,248,0,135,184,118,0,101,94,17,255,122,72,70,254,69,130,146,0,127,222,248,1,69,127,118,255,30,82,215,254,188,74,19,255,229,167,194,254,117,25,66,255,65,234,56,254,213,22,156,0,151,59,93,254,45,28,27,255,186,126,164,255,32,6,239,0,127,114,99,1,219,52,2,255,99,96,166,254,62,190,126,255,108,222,168,1,75,226,174,0,230,226,199,0,60,117,218,255,252,248,20,1,214,188,204,0,31,194,134,254,123,69,192,255,169,173,36,254,55,98,91,0,223,42,102,254,137,1,102,0,157,90,25,0,239,122,64,255,252,6,233,0,7,54,20,255,82,116,174,0,135,37,54,255,15,186,125,0,227,112,175,255,100,180,225,255,42,237,244,255,244,173,226,254,248,18,33,0,171,99,150,255,74,235,50,255,117,82,32,254,106,168,237,0,207,109,208,1,228,9,186,0,135,60,169,254,179,92,143,0,244,170,104,255,235,45,124,255,70,99,186,0,117,137,183,0,224,31,215,0,40,9,100,0,26,16,95,1,68,217,87,0,8,151,20,255,26,100,58,255,176,165,203,1,52,118,70,0,7,32,254,254,244,254,245,255,167,144,194,255,125,113,23,255,176,121,181,0,136,84,209,0,138,6,30,255,89,48,28,0,33,155,14,255,25,240,154,0,141,205,109,1,70,115,62,255,20,40,107,254,138,154,199,255,94,223,226,255,157,171,38,0,163,177,25,254,45,118,3,255,14,222,23,1,209,190,81,255,118,123,232,1,13,213,101,255,123,55,123,254,27,246,165,0,50,99,76,255,140,214,32,255,97,65,67,255,24,12,28,0,174,86,78,1,64,247,96,0,160,135,67,0,66,55,243,255,147,204,96,255,26,6,33,255,98,51,83,1,153,213,208,255,2,184,54,255,25,218,11,0,49,67,246,254,18,149,72,255,13,25,72,0,42,79,214,0,42,4,38,1,27,139,144,255,149,187,23,0,18,164,132,0,245,84,184,254,120,198,104,255,126,218,96,0,56,117,234,255,13,29,214,254,68,47,10,255,167,154,132,254,152,38,198,0,66,178,89,255,200,46,171,255,13,99,83,255,210,187,253,255,170,45,42,1,138,209,124,0,214,162,141,0,12,230,156,0,102,36,112,254,3,147,67,0,52,215,123,255,233,171,54,255,98,137,62,0,247,218,39,255,231,218,236,0,247,191,127,0,195,146,84,0,165,176,92,255,19,212,94,255,17,74,227,0,88,40,153,1,198,147,1,255,206,67,245,254,240,3,218,255,61,141,213,255,97,183,106,0,195,232,235,254,95,86,154,0,209,48,205,254,118,209,241,255,240,120,223,1,213,29,159,0,163,127,147,255,13,218,93,0,85,24,68,254,70,20,80,255,189,5,140,1,82,97,254,255,99,99,191,255,132,84,133,255,107,218,116,255,112,122,46,0,105,17,32,0,194,160,63,255,68,222,39,1,216,253,92,0,177,105,205,255,149,201,195,0,42,225,11,255,40,162,115,0,9,7,81,0,165,218,219,0,180,22,0,254,29,146,252,255,146,207,225,1,180,135,96,0,31,163,112,0,177,11,219,255,133,12,193,254,43,78,50,0,65,113,121,1,59,217,6,255,110,94,24,1,112,172,111,0,7,15,96,0,36,85,123,0,71,150,21,255,208,73,188,0,192,11,167,1,213,245,34,0,9,230,92,0,162,142,39,255,215,90,27,0,98,97,89,0,94,79,211,0,90,157,240,0,95,220,126,1,102,176,226,0,36,30,224,254,35,31,127,0,231,232,115,1,85,83,130,0,210,73,245,255,47,143,114,255,68,65,197,0,59,72,62,255,183,133,173,254,93,121,118,255,59,177,81,255,234,69,173,255,205,128,177,0,220,244,51,0,26,244,209,1,73,222,77,255,163,8,96,254,150,149,211,0,158,254,203,1,54,127,139,0,161,224,59,0,4,109,22,255,222,42,45,255,208,146,102,255,236,142,187,0,50,205,245,255,10,74,89,254,48,79,142,0,222,76,130,255,30,166,63,0,236,12,13,255,49,184,244,0,187,113,102,0,218,101,253,0,153,57,182,254,32,150,42,0,25,198,146,1,237,241,56,0,140,68,5,0,91,164,172,255,78,145,186,254,67,52,205,0,219,207,129,1,109,115,17,0,54,143,58,1,21,248,120,255,179,255,30,0,193,236,66,255,1,255,7,255,253,192,48,255,19,69,217,1,3,214,0,255,64,101,146,1,223,125,35,255,235,73,179,255,249,167,226,0,225,175,10,1,97,162,58,0,106,112,171,1,84,172,5,255,133,140,178,255,134,245,142,0,97,90,125,255,186,203,185,255,223,77,23,255,192,92,106,0,15,198,115,255,217,152,248,0,171,178,120,255,228,134,53,0,176,54,193,1,250,251,53,0,213,10,100,1,34,199,106,0,151,31,244,254,172,224,87,255,14,237,23,255,253,85,26,255,127,39,116,255,172,104,100,0,251,14,70,255,212,208,138,255,253,211,250,0,176,49,165,0,15,76,123,255,37,218,160,255,92,135,16,1,10,126,114,255,70,5,224,255,247,249,141,0,68,20,60,1,241,210,189,255,195,217,187,1,151,3,113,0,151,92,174,0,231,62,178,255,219,183,225,0,23,23,33,255,205,181,80,0,57,184,248,255,67,180,1,255,90,123,93,255,39,0,162,255,96,248,52,255,84,66,140,0,34,127,228,255,194,138,7,1,166,110,188,0,21,17,155,1,154,190,198,255,214,80,59,255,18,7,143,0,72,29,226,1,199,217,249,0,232,161,71,1,149,190,201,0,217,175,95,254,113,147,67,255,138,143,199,255,127,204,1,0,29,182,83,1,206,230,155,255,186,204,60,0,10,125,85,255,232,96,25,255,255,89,247,255,213,254,175,1,232,193,81,0,28,43,156,254,12,69,8,0,147,24,248,0,18,198,49,0,134,60,35,0,118,246,18,255,49,88,254,254,228,21,186,255,182,65,112,1,219,22,1,255,22,126,52,255,189,53,49,255,112,25,143,0,38,127,55,255,226,101,163,254,208,133,61,255,137,69,174,1,190,118,145,255,60,98,219,255,217,13,245,255,250,136,10,0,84,254,226,0,201,31,125,1,240,51,251,255,31,131,130,255,2,138,50,255,215,215,177,1,223,12,238,255,252,149,56,255,124,91,68,255,72,126,170,254,119,255,100,0,130,135,232,255,14,79,178,0,250,131,197,0,138,198,208,0,121,216,139,254,119,18,36,255,29,193,122,0,16,42,45,255,213,240,235,1,230,190,169,255,198,35,228,254,110,173,72,0,214,221,241,255,56,148,135,0,192,117,78,254,141,93,207,255,143,65,149,0,21,18,98,255,95,44,244,1,106,191,77,0,254,85,8,254,214,110,176,255,73,173,19,254,160,196,199,255,237,90,144,0,193,172,113,255,200,155,136,254,228,90,221,0,137,49,74,1,164,221,215,255,209,189,5,255,105,236,55,255,42,31,129,1,193,255,236,0,46,217,60,0,138,88,187,255,226,82,236,255,81,69,151,255,142,190,16,1,13,134,8,0,127,122,48,255,81,64,156,0,171,243,139,0,237,35,246,0,122,143,193,254,212,122,146,0,95,41,255,1,87,132,77,0,4,212,31,0,17,31,78,0,39,45,173,254,24,142,217,255,95,9,6,255,227,83,6,0,98,59,130,254,62,30,33,0,8,115,211,1,162,97,128,255,7,184,23,254,116,28,168,255,248,138,151,255,98,244,240,0,186,118,130,0,114,248,235,255,105,173,200,1,160,124,71,255,94,36,164,1,175,65,146,255,238,241,170,254,202,198,197,0,228,71,138,254,45,246,109,255,194,52,158,0,133,187,176,0,83,252,154,254,89,189,221,255,170,73,252,0,148,58,125,0,36,68,51,254,42,69,177,255,168,76,86,255,38,100,204,255,38,53,35,0,175,19,97,0,225,238,253,255,81,81,135,0,210,27,255,254,235,73,107,0,8,207,115,0,82,127,136,0,84,99,21,254,207,19,136,0,100,164,101,0,80,208,77,255,132,207,237,255,15,3,15,255,33,166,110,0,156,95,85,255,37,185,111,1,150,106,35,255,166,151,76,0,114,87,135,255,159,194,64,0,12,122,31,255,232,7,101,254,173,119,98,0,154,71,220,254,191,57,53,255,168,232,160,255,224,32,99,255,218,156,165,0,151,153,163,0,217,13,148,1,197,113,89,0,149,28,161,254,207,23,30,0,105,132,227,255,54,230,94,255,133,173,204,255,92,183,157,255,88,144,252,254,102,33,90,0,159,97,3,0,181,218,155,255,240,114,119,0,106,214,53,255,165,190,115,1,152,91,225,255,88,106,44,255,208,61,113,0,151,52,124,0,191,27,156,255,110,54,236,1,14,30,166,255,39,127,207,1,229,199,28,0,188,228,188,254,100,157,235,0,246,218,183,1,107,22,193,255,206,160,95,0,76,239,147,0,207,161,117,0,51,166,2,255,52,117,10,254,73,56,227,255,152,193,225,0,132,94,136,255,101,191,209,0,32,107,229,255,198,43,180,1,100,210,118,0,114,67,153,255,23,88,26,255,89,154,92,1,220,120,140,255,144,114,207,255,252,115,250,255,34,206,72,0,138,133,127,255,8,178,124,1,87,75,97,0,15,229,92,254,240,67,131,255,118,123,227,254,146,120,104,255,145,213,255,1,129,187,70,255,219,119,54,0,1,19,173,0,45,150,148,1,248,83,72,0,203,233,169,1,142,107,56,0,247,249,38,1,45,242,80,255,30,233,103,0,96,82,70,0,23,201,111,0,81,39,30,255,161,183,78,255,194,234,33,255,68,227,140,254,216,206,116,0,70,27,235,255,104,144,79,0,164,230,93,254,214,135,156,0,154,187,242,254,188,20,131,255,36,109,174,0,159,112,241,0,5,110,149,1,36,165,218,0,166,29,19,1,178,46,73,0,93,43,32,254,248,189,237,0,102,155,141,0,201,93,195,255,241,139,253,255,15,111,98,255,108,65,163,254,155,79,190,255,73,174,193,254,246,40,48,255,107,88,11,254,202,97,85,255,253,204,18,255,113,242,66,0,110,160,194,254,208,18,186,0,81,21,60,0,188,104,167,255,124,166,97,254,210,133,142,0,56,242,137,254,41,111,130,0,111,151,58,1,111,213,141,255,183,172,241,255,38,6,196,255,185,7,123,255,46,11,246,0,245,105,119,1,15,2,161,255,8,206,45,255,18,202,74,255,83,124,115,1,212,141,157,0,83,8,209,254,139,15,232,255,172,54,173,254,50,247,132,0,214,189,213,0,144,184,105,0,223,254,248,0,255,147,240,255,23,188,72,0,7,51,54,0,188,25,180,254,220,180,0,255,83,160,20,0,163,189,243,255,58,209,194,255,87,73,60,0,106,24,49,0,245,249,220,0,22,173,167,0,118,11,195,255,19,126,237,0,110,159,37,255,59,82,47,0,180,187,86,0,188,148,208,1,100,37,133,255,7,112,193,0,129,188,156,255,84,106,129,255,133,225,202,0,14,236,111,255,40,20,101],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE);allocate([172,172,49,254,51,54,74,255,251,185,184,255,93,155,224,255,180,249,224,1,230,178,146,0,72,57,54,254,178,62,184,0,119,205,72,0,185,239,253,255,61,15,218,0,196,67,56,255,234,32,171,1,46,219,228,0,208,108,234,255,20,63,232,255,165,53,199,1,133,228,5,255,52,205,107,0,74,238,140,255,150,156,219,254,239,172,178,255,251,189,223,254,32,142,211,255,218,15,138,1,241,196,80,0,28,36,98,254,22,234,199,0,61,237,220,255,246,57,37,0,142,17,142,255,157,62,26,0,43,238,95,254,3,217,6,255,213,25,240,1,39,220,174,255,154,205,48,254,19,13,192,255,244,34,54,254,140,16,155,0,240,181,5,254,155,193,60,0,166,128,4,255,36,145,56,255,150,240,219,0,120,51,145,0,82,153,42,1,140,236,146,0,107,92,248,1,189,10,3,0,63,136,242,0,211,39,24,0,19,202,161,1,173,27,186,255,210,204,239,254,41,209,162,255,182,254,159,255,172,116,52,0,195,103,222,254,205,69,59,0,53,22,41,1,218,48,194,0,80,210,242,0,210,188,207,0,187,161,161,254,216,17,1,0,136,225,113,0,250,184,63,0,223,30,98,254,77,168,162,0,59,53,175,0,19,201,10,255,139,224,194,0,147,193,154,255,212,189,12,254,1,200,174,255,50,133,113,1,94,179,90,0,173,182,135,0,94,177,113,0,43,89,215,255,136,252,106,255,123,134,83,254,5,245,66,255,82,49,39,1,220,2,224,0,97,129,177,0,77,59,89,0,61,29,155,1,203,171,220,255,92,78,139,0,145,33,181,255,169,24,141,1,55,150,179,0,139,60,80,255,218,39,97,0,2,147,107,255,60,248,72,0,173,230,47,1,6,83,182,255,16,105,162,254,137,212,81,255,180,184,134,1,39,222,164,255,221,105,251,1,239,112,125,0,63,7,97,0,63,104,227,255,148,58,12,0,90,60,224,255,84,212,252,0,79,215,168,0,248,221,199,1,115,121,1,0,36,172,120,0,32,162,187,255,57,107,49,255,147,42,21,0,106,198,43,1,57,74,87,0,126,203,81,255,129,135,195,0,140,31,177,0,221,139,194,0,3,222,215,0,131,68,231,0,177,86,178,254,124,151,180,0,184,124,38,1,70,163,17,0,249,251,181,1,42,55,227,0,226,161,44,0,23,236,110,0,51,149,142,1,93,5,236,0,218,183,106,254,67,24,77,0,40,245,209,255,222,121,153,0,165,57,30,0,83,125,60,0,70,38,82,1,229,6,188,0,109,222,157,255,55,118,63,255,205,151,186,0,227,33,149,255,254,176,246,1,227,177,227,0,34,106,163,254,176,43,79,0,106,95,78,1,185,241,122,255,185,14,61,0,36,1,202,0,13,178,162,255,247,11,132,0,161,230,92,1,65,1,185,255,212,50,165,1,141,146,64,255,158,242,218,0,21,164,125,0,213,139,122,1,67,71,87,0,203,158,178,1,151,92,43,0,152,111,5,255,39,3,239,255,217,255,250,255,176,63,71,255,74,245,77,1,250,174,18,255,34,49,227,255,246,46,251,255,154,35,48,1,125,157,61,255,106,36,78,255,97,236,153,0,136,187,120,255,113,134,171,255,19,213,217,254,216,94,209,255,252,5,61,0,94,3,202,0,3,26,183,255,64,191,43,255,30,23,21,0,129,141,77,255,102,120,7,1,194,76,140,0,188,175,52,255,17,81,148,0,232,86,55,1,225,48,172,0,134,42,42,255,238,50,47,0,169,18,254,0,20,147,87,255,14,195,239,255,69,247,23,0,238,229,128,255,177,49,112,0,168,98,251,255,121,71,248,0,243,8,145,254,246,227,153,255,219,169,177,254,251,139,165,255,12,163,185,255,164,40,171,255,153,159,27,254,243,109,91,255,222,24,112,1,18,214,231,0,107,157,181,254,195,147,0,255,194,99,104,255,89,140,190,255,177,66,126,254,106,185,66,0,49,218,31,0,252,174,158,0,188,79,230,1,238,41,224,0,212,234,8,1,136,11,181,0,166,117,83,255,68,195,94,0,46,132,201,0,240,152,88,0,164,57,69,254,160,224,42,255,59,215,67,255,119,195,141,255,36,180,121,254,207,47,8,255,174,210,223,0,101,197,68,255,255,82,141,1,250,137,233,0,97,86,133,1,16,80,69,0,132,131,159,0,116,93,100,0,45,141,139,0,152,172,157,255,90,43,91,0,71,153,46,0,39,16,112,255,217,136,97,255,220,198,25,254,177,53,49,0,222,88,134,255,128,15,60,0,207,192,169,255,192,116,209,255,106,78,211,1,200,213,183,255,7,12,122,254,222,203,60,255,33,110,199,254,251,106,117,0,228,225,4,1,120,58,7,255,221,193,84,254,112,133,27,0,189,200,201,255,139,135,150,0,234,55,176,255,61,50,65,0,152,108,169,255,220,85,1,255,112,135,227,0,162,26,186,0,207,96,185,254,244,136,107,0,93,153,50,1,198,97,151,0,110,11,86,255,143,117,174,255,115,212,200,0,5,202,183,0,237,164,10,254,185,239,62,0,236,120,18,254,98,123,99,255,168,201,194,254,46,234,214,0,191,133,49,255,99,169,119,0,190,187,35,1,115,21,45,255,249,131,72,0,112,6,123,255,214,49,181,254,166,233,34,0,92,197,102,254,253,228,205,255,3,59,201,1,42,98,46,0,219,37,35,255,169,195,38,0,94,124,193,1,156,43,223,0,95,72,133,254,120,206,191,0,122,197,239,255,177,187,79,255,254,46,2,1,250,167,190,0,84,129,19,0,203,113,166,255,249,31,189,254,72,157,202,255,208,71,73,255,207,24,72,0,10,16,18,1,210,81,76,255,88,208,192,255,126,243,107,255,238,141,120,255,199,121,234,255,137,12,59,255,36,220,123,255,148,179,60,254,240,12,29,0,66,0,97,1,36,30,38,255,115,1,93,255,96,103,231,255,197,158,59,1,192,164,240,0,202,202,57,255,24,174,48,0,89,77,155,1,42,76,215,0,244,151,233,0,23,48,81,0,239,127,52,254,227,130,37,255,248,116,93,1,124,132,118,0,173,254,192,1,6,235,83,255,110,175,231,1,251,28,182,0,129,249,93,254,84,184,128,0,76,181,62,0,175,128,186,0,100,53,136,254,109,29,226,0,221,233,58,1,20,99,74,0,0,22,160,0,134,13,21,0,9,52,55,255,17,89,140,0,175,34,59,0,84,165,119,255,224,226,234,255,7,72,166,255,123,115,255,1,18,214,246,0,250,7,71,1,217,220,185,0,212,35,76,255,38,125,175,0,189,97,210,0,114,238,44,255,41,188,169,254,45,186,154,0,81,92,22,0,132,160,193,0,121,208,98,255,13,81,44,255,203,156,82,0,71,58,21,255,208,114,191,254,50,38,147,0,154,216,195,0,101,25,18,0,60,250,215,255,233,132,235,255,103,175,142,1,16,14,92,0,141,31,110,254,238,241,45,255,153,217,239,1,97,168,47,255,249,85,16,1,28,175,62,255,57,254,54,0,222,231,126,0,166,45,117,254,18,189,96,255,228,76,50,0,200,244,94,0,198,152,120,1,68,34,69,255,12,65,160,254,101,19,90,0,167,197,120,255,68,54,185,255,41,218,188,0,113,168,48,0,88,105,189,1,26,82,32,255,185,93,164,1,228,240,237,255,66,182,53,0,171,197,92,255,107,9,233,1,199,120,144,255,78,49,10,255,109,170,105,255,90,4,31,255,28,244,113,255,74,58,11,0,62,220,246,255,121,154,200,254,144,210,178,255,126,57,129,1,43,250,14,255,101,111,28,1,47,86,241,255,61,70,150,255,53,73,5,255,30,26,158,0,209,26,86,0,138,237,74,0,164,95,188,0,142,60,29,254,162,116,248,255,187,175,160,0,151,18,16,0,209,111,65,254,203,134,39,255,88,108,49,255,131,26,71,255,221,27,215,254,104,105,93,255,31,236,31,254,135,0,211,255,143,127,110,1,212,73,229,0,233,67,167,254,195,1,208,255,132,17,221,255,51,217,90,0,67,235,50,255,223,210,143,0,179,53,130,1,233,106,198,0,217,173,220,255,112,229,24,255,175,154,93,254,71,203,246,255,48,66,133,255,3,136,230,255,23,221,113,254,235,111,213,0,170,120,95,254,251,221,2,0,45,130,158,254,105,94,217,255,242,52,180,254,213,68,45,255,104,38,28,0,244,158,76,0,161,200,96,255,207,53,13,255,187,67,148,0,170,54,248,0,119,162,178,255,83,20,11,0,42,42,192,1,146,159,163,255,183,232,111,0,77,229,21,255,71,53,143,0,27,76,34,0,246,136,47,255,219,39,182,255,92,224,201,1,19,142,14,255,69,182,241,255,163,118,245,0,9,109,106,1,170,181,247,255,78,47,238,255,84,210,176,255,213,107,139,0,39,38,11,0,72,21,150,0,72,130,69,0,205,77,155,254,142,133,21,0,71,111,172,254,226,42,59,255,179,0,215,1,33,128,241,0,234,252,13,1,184,79,8,0,110,30,73,255,246,141,189,0,170,207,218,1,74,154,69,255,138,246,49,255,155,32,100,0,125,74,105,255,90,85,61,255,35,229,177,255,62,125,193,255,153,86,188,1,73,120,212,0,209,123,246,254,135,209,38,255,151,58,44,1,92,69,214,255,14,12,88,255,252,153,166,255,253,207,112,255,60,78,83,255,227,124,110,0,180,96,252,255,53,117,33,254,164,220,82,255,41,1,27,255,38,164,166,255,164,99,169,254,61,144,70,255,192,166,18,0,107,250,66,0,197,65,50,0,1,179,18,255,255,104,1,255,43,153,35,255,80,111,168,0,110,175,168,0,41,105,45,255,219,14,205,255,164,233,140,254,43,1,118,0,233,67,195,0,178,82,159,255,138,87,122,255,212,238,90,255,144,35,124,254,25,140,164,0,251,215,44,254,133,70,107,255,101,227,80,254,92,169,55,0,215,42,49,0,114,180,85,255,33,232,27,1,172,213,25,0,62,176,123,254,32,133,24,255,225,191,62,0,93,70,153,0,181,42,104,1,22,191,224,255,200,200,140,255,249,234,37,0,149,57,141,0,195,56,208,255,254,130,70,255,32,173,240,255,29,220,199,0,110,100,115,255,132,229,249,0,228,233,223,255,37,216,209,254,178,177,209,255,183,45,165,254,224,97,114,0,137,97,168,255,225,222,172,0,165,13,49,1,210,235,204,255,252,4,28,254,70,160,151,0,232,190,52,254,83,248,93,255,62,215,77,1,175,175,179,255,160,50,66,0,121,48,208,0,63,169,209,255,0,210,200,0,224,187,44,1,73,162,82,0,9,176,143,255,19,76,193,255,29,59,167,1,24,43,154,0,28,190,190,0,141,188,129,0,232,235,203,255,234,0,109,255,54,65,159,0,60,88,232,255,121,253,150,254,252,233,131,255,198,110,41,1,83,77,71,255,200,22,59,254,106,253,242,255,21,12,207,255,237,66,189,0,90,198,202,1,225,172,127,0,53,22,202,0,56,230,132,0,1,86,183,0,109,190,42,0,243,68,174,1,109,228,154,0,200,177,122,1,35,160,183,255,177,48,85,255,90,218,169,255,248,152,78,0,202,254,110,0,6,52,43,0,142,98,65,255,63,145,22,0,70,106,93,0,232,138,107,1,110,179,61,255,211,129,218,1,242,209,92,0,35,90,217,1,182,143,106,255,116,101,217,255,114,250,221,255,173,204,6,0,60,150,163,0,73,172,44,255,239,110,80,255,237,76,153,254,161,140,249,0,149,232,229,0,133,31,40,255,174,164,119,0,113,51,214,0,129,228,2,254,64,34,243,0,107,227,244,255,174,106,200,255,84,153,70,1,50,35,16,0,250,74,216,254,236,189,66,255,153,249,13,0,230,178,4,255,221,41,238,0,118,227,121,255,94,87,140,254,254,119,92,0,73,239,246,254,117,87,128,0,19,211,145,255,177,46,252,0,229,91,246,1,69,128,247,255,202,77,54,1,8,11,9,255,153,96,166,0,217,214,173,255,134,192,2,1,0,207,0,0,189,174,107,1,140,134,100,0,158,193,243,1,182,102,171,0,235,154,51,0,142,5,123,255,60,168,89,1,217,14,92,255,19,214,5,1,211,167,254,0,44,6,202,254,120,18,236,255,15,113,184,255,184,223,139,0,40,177,119,254,182,123,90,255,176,165,176,0,247,77,194,0,27,234,120,0,231,0,214,255,59,39,30,0,125,99,145,255,150,68,68,1,141,222,248,0,153,123,210,255,110,127,152,255,229,33,214,1,135,221,197,0,137,97,2,0,12,143,204,255,81,41,188,0,115,79,130,255,94,3,132,0,152,175,187,255,124,141,10,255,126,192,179,255,11,103,198,0,149,6,45,0,219,85,187,1,230,18,178,255,72,182,152,0,3,198,184,255,128,112,224,1,97,161,230,0,254,99,38,255,58,159,197,0,151,66,219,0,59,69,143,255,185,112,249,0,119,136,47,255,123,130,132,0,168,71,95,255,113,176,40,1,232,185,173,0,207,93,117,1,68,157,108,255,102,5,147,254,49,97,33,0,89,65,111,254,247,30,163,255,124,217,221,1,102,250,216,0,198,174,75,254,57,55,18,0,227,5,236,1,229,213,173,0,201,109,218,1,49,233,239,0,30,55,158,1,25,178,106,0,155,111,188,1,94,126,140,0,215,31,238,1,77,240,16,0,213,242,25,1,38,71,168,0,205,186,93,254,49,211,140,255,219,0,180,255,134,118,165,0,160,147,134,255,110,186,35,255,198,243,42,0,243,146,119,0,134,235,163,1,4,241,135,255,193,46,193,254,103,180,79,255,225,4,184,254,242,118,130,0,146,135,176,1,234,111,30,0,69,66,213,254,41,96,123,0,121,94,42,255,178,191,195,255,46,130,42,0,117,84,8,255,233,49,214,254,238,122,109,0,6,71,89,1,236,211,123,0,244,13,48,254,119,148,14,0,114,28,86,255,75,237,25,255,145,229,16,254,129,100,53,255,134,150,120,254,168,157,50,0,23,72,104,255,224,49,14,0,255,123,22,255,151,185,151,255,170,80,184,1,134,182,20,0,41,100,101,1,153,33,16,0,76,154,111,1,86,206,234,255,192,160,164,254,165,123,93,255,1,216,164,254,67,17,175,255,169,11,59,255,158,41,61,255,73,188,14,255,195,6,137,255,22,147,29,255,20,103,3,255,246,130,227,255,122,40,128,0,226,47,24,254,35,36,32,0,152,186,183,255,69,202,20,0,195,133,195,0,222,51,247,0,169,171,94,1,183,0,160,255,64,205,18,1,156,83,15,255,197,58,249,254,251,89,110,255,50,10,88,254,51,43,216,0,98,242,198,1,245,151,113,0,171,236,194,1,197,31,199,255,229,81,38,1,41,59,20,0,253,104,230,0,152,93,14,255,246,242,146,254,214,169,240,255,240,102,108,254,160,167,236,0,154,218,188,0,150,233,202,255,27,19,250,1,2,71,133,255,175,12,63,1,145,183,198,0,104,120,115,255,130,251,247,0,17,212,167,255,62,123,132,255,247,100,189,0,155,223,152,0,143,197,33,0,155,59,44,255,150,93,240,1,127,3,87,255,95,71,207,1,167,85,1,255,188,152,116,255,10,23,23,0,137,195,93,1,54,98,97,0,240,0,168,255,148,188,127,0,134,107,151,0,76,253,171,0,90,132,192,0,146,22,54,0,224,66,54,254,230,186,229,255,39,182,196,0,148,251,130,255,65,131,108,254,128,1,160,0,169,49,167,254,199,254,148,255,251,6,131,0,187,254,129,255,85,82,62,0,178,23,58,255,254,132,5,0,164,213,39,0,134,252,146,254,37,53,81,255,155,134,82,0,205,167,238,255,94,45,180,255,132,40,161,0,254,111,112,1,54,75,217,0,179,230,221,1,235,94,191,255,23,243,48,1,202,145,203,255,39,118,42,255,117,141,253,0,254,0,222,0,43,251,50,0,54,169,234,1,80,68,208,0,148,203,243,254,145,7,135,0,6,254,0,0,252,185,127,0,98,8,129,255,38,35,72,255,211,36,220,1,40,26,89,0,168,64,197,254,3,222,239,255,2,83,215,254,180,159,105,0,58,115,194,0,186,116,106,255,229,247,219,255,129,118,193,0,202,174,183,1,166,161,72,0,201,107,147,254,237,136,74,0,233,230,106,1,105,111,168,0,64,224,30,1,1,229,3,0,102,151,175,255,194,238,228,255,254,250,212,0,187,237,121,0,67,251,96,1,197,30,11,0,183,95,204,0,205,89,138,0,64,221,37,1,255,223,30,255,178,48,211,255,241,200,90,255,167,209,96,255,57,130,221,0,46,114,200,255,61,184,66,0,55,182,24,254,110,182,33,0,171,190,232,255,114,94,31,0,18,221,8,0,47,231,254,0,255,112,83,0,118,15,215,255,173,25,40,254,192,193,31,255,238,21,146,255,171,193,118,255,101,234,53,254,131,212,112,0,89,192,107,1,8,208,27,0,181,217,15,255,231,149,232,0,140,236,126,0,144,9,199,255,12,79,181,254,147,182,202,255,19,109,182,255,49,212,225,0,74,163,203,0,175,233,148,0,26,112,51,0,193,193,9,255,15,135,249,0,150,227,130,0,204,0,219,1,24,242,205,0,238,208,117,255,22,244,112,0,26,229,34,0,37,80,188,255,38,45,206,254,240,90,225,255,29,3,47,255,42,224,76,0,186,243,167,0,32,132,15,255,5,51,125,0,139,135,24,0,6,241,219,0,172,229,133,255,246,214,50,0,231,11,207,255,191,126,83,1,180,163,170,255,245,56,24,1,178,164,211,255,3,16,202,1,98,57,118,255,141,131,89,254,33,51,24,0,243,149,91,255,253,52,14,0,35,169,67,254,49,30,88,255,179,27,36,255,165,140,183,0,58,189,151,0,88,31,0,0,75,169,66,0,66,101,199,255,24,216,199,1,121,196,26,255,14,79,203,254,240,226,81,255,94,28,10,255,83,193,240,255,204,193,131,255,94,15,86,0,218,40,157,0,51,193,209,0,0,242,177,0,102,185,247,0,158,109,116,0,38,135,91,0,223,175,149,0,220,66,1,255,86,60,232,0,25,96,37,255,225,122,162,1,215,187,168,255,158,157,46,0,56,171,162,0,232,240,101,1,122,22,9,0,51,9,21,255,53,25,238,255,217,30,232,254,125,169,148,0,13,232,102,0,148,9,37,0,165,97,141,1,228,131,41,0,222,15,243,255,254,18,17,0,6,60,237,1,106,3,113,0,59,132,189,0,92,112,30,0,105,208,213,0,48,84,179,255,187,121,231,254,27,216,109,255,162,221,107,254,73,239,195,255,250,31,57,255,149,135,89,255,185,23,115,1,3,163,157,255,18,112,250,0,25,57,187,255,161,96,164,0,47,16,243,0,12,141,251,254,67,234,184,255,41,18,161,0,175,6,96,255,160,172,52,254,24,176,183,255,198,193,85,1,124,121,137,255,151,50,114,255,220,203,60,255,207,239,5,1,0,38,107,255,55,238,94,254,70,152,94,0,213,220,77,1,120,17,69,255,85,164,190,255,203,234,81,0,38,49,37,254,61,144,124,0,137,78,49,254,168,247,48,0,95,164,252,0,105,169,135,0,253,228,134,0,64,166,75,0,81,73,20,255,207,210,10,0,234,106,150,255,94,34,90,255,254,159,57,254,220,133,99,0,139,147,180,254,24,23,185,0,41,57,30,255,189,97,76,0,65,187,223,255,224,172,37,255,34,62,95,1,231,144,240,0,77,106,126,254,64,152,91,0,29,98,155,0,226,251,53,255,234,211,5,255,144,203,222,255,164,176,221,254,5,231,24,0,179,122,205,0,36,1,134,255,125,70,151,254,97,228,252,0,172,129,23,254,48,90,209,255,150,224,82,1,84,134,30,0,241,196,46,0,103,113,234,255,46,101,121,254,40,124,250,255,135,45,242,254,9,249,168,255,140,108,131,255,143,163,171,0,50,173,199,255,88,222,142,255,200,95,158,0,142,192,163,255,7,117,135,0,111,124,22,0,236,12,65,254,68,38,65,255,227,174,254,0,244,245,38,0,240,50,208,255,161,63,250,0,60,209,239,0,122,35,19,0,14,33,230,254,2,159,113,0,106,20,127,255,228,205,96,0,137,210,174,254,180,212,144,255,89,98,154,1,34,88,139,0,167,162,112,1,65,110,197,0,241,37,169,0,66,56,131,255,10,201,83,254,133,253,187,255,177,112,45,254,196,251,0,0,196,250,151,255,238,232,214,255,150,209,205,0,28,240,118,0,71,76,83,1,236,99,91,0,42,250,131,1,96,18,64,255,118,222,35,0,113,214,203,255,122,119,184,255,66,19,36,0,204,64,249,0,146,89,139,0,134,62,135,1,104,233,101,0,188,84,26,0,49,249,129,0,208,214,75,255,207,130,77,255,115,175,235,0,171,2,137,255,175,145,186,1,55,245,135,255,154,86,181,1,100,58,246,255,109,199,60,255,82,204,134,255,215,49,230,1,140,229,192,255,222,193,251,255,81,136,15,255,179,149,162,255,23,39,29,255,7,95,75,254,191,81,222,0,241,81,90,255,107,49,201,255,244,211,157,0,222,140,149,255,65,219,56,254,189,246,90,255,178,59,157,1,48,219,52,0,98,34,215,0,28,17,187,255,175,169,24,0,92,79,161,255,236,200,194,1,147,143,234,0,229,225,7,1,197,168,14,0,235,51,53,1,253,120,174,0,197,6,168,255,202,117,171,0,163,21,206,0,114,85,90,255,15,41,10,255,194,19,99,0,65,55,216,254,162,146,116,0,50,206,212,255,64,146,29,255,158,158,131,1,100,165,130,255,172,23,129,255,125,53,9,255,15,193,18,1,26,49,11,255,181,174,201,1,135,201,14,255,100,19,149,0,219,98,79,0,42,99,143,254,96,0,48,255,197,249,83,254,104,149,79,255,235,110,136,254,82,128,44,255,65,41,36,254,88,211,10,0,187,121,187,0,98,134,199,0,171,188,179,254,210,11,238,255,66,123,130,254,52,234,61,0,48,113,23,254,6,86,120,255,119,178,245,0,87,129,201,0,242,141,209,0,202,114,85,0,148,22,161,0,103,195,48,0,25,49,171,255,138,67,130,0,182,73,122,254,148,24,130,0,211,229,154,0,32,155,158,0,84,105,61,0,177,194,9,255,166,89,86,1,54,83,187,0,249,40,117,255,109,3,215,255,53,146,44,1,63,47,179,0,194,216,3,254,14,84,136,0,136,177,13,255,72,243,186,255,117,17,125,255,211,58,211,255,93,79,223,0,90,88,245,255,139,209,111,255,70,222,47,0,10,246,79,255,198,217,178,0,227,225,11,1,78,126,179,255,62,43,126,0,103,148,35,0,129,8,165,254,245,240,148,0,61,51,142,0,81,208,134,0,15,137,115,255,211,119,236,255,159,245,248,255,2,134,136,255,230,139,58,1,160,164,254,0,114,85,141,255,49,166,182,255,144,70,84,1,85,182,7,0,46,53,93,0,9,166,161,255,55,162,178,255,45,184,188,0,146,28,44,254,169,90,49,0,120,178,241,1,14,123,127,255,7,241,199,1,189,66,50,255,198,143,101,254,189,243,135,255,141,24,24,254,75,97,87,0,118,251,154,1,237,54,156,0,171,146,207,255,131,196,246,255,136,64,113,1,151,232,57,0,240,218,115,0,49,61,27,255,64,129,73,1,252,169,27,255,40,132,10,1,90,201,193,255,252,121,240,1,186,206,41,0,43,198,97,0,145,100,183,0,204,216,80,254,172,150,65,0,249,229,196,254,104,123,73,255,77,104,96,254,130,180,8,0,104,123,57,0,220,202,229,255,102,249,211,0,86,14,232,255,182,78,209,0,239,225,164,0,106,13,32,255,120,73,17,255,134,67,233,0,83,254,181,0,183,236,112,1,48,64,131,255,241,216,243,255,65,193,226,0,206,241,100,254,100,134,166,255,237,202,197,0,55,13,81,0,32,124,102,255,40,228,177,0,118,181,31,1,231,160,134,255,119,187,202,0,0,142,60,255,128,38,189,255,166,201,150,0,207,120,26,1,54,184,172,0,12,242,204,254,133,66,230,0,34,38,31,1,184,112,80,0,32,51,165,254,191,243,55,0,58,73,146,254,155,167,205,255,100,104,152,255,197,254,207,255,173,19,247,0,238,10,202,0,239,151,242,0,94,59,39,255,240,29,102,255,10,92,154,255,229,84,219,255,161,129,80,0,208,90,204,1,240,219,174,255,158,102,145,1,53,178,76,255,52,108,168,1,83,222,107,0,211,36,109,0,118,58,56,0,8,29,22,0,237,160,199,0,170,209,157,0,137,71,47,0,143,86,32,0,198,242,2,0,212,48,136,1,92,172,186,0,230,151,105,1,96,191,229,0,138,80,191,254,240,216,130,255,98,43,6,254,168,196,49,0,253,18,91,1,144,73,121,0,61,146,39,1,63,104,24,255,184,165,112,254,126,235,98,0,80,213,98,255,123,60,87,255,82,140,245,1,223,120,173,255,15,198,134,1,206,60,239,0,231,234,92,255,33,238,19,255,165,113,142,1,176,119,38,0,160,43,166,254,239,91,105,0,107,61,194,1,25,4,68,0,15,139,51,0,164,132,106,255,34,116,46,254,168,95,197,0,137,212,23,0,72,156,58,0,137,112,69,254,150,105,154,255,236,201,157,0,23,212,154,255,136,82,227,254,226,59,221,255,95,149,192,0,81,118,52,255,33,43,215,1,14,147,75,255,89,156,121,254,14,18,79,0,147,208,139,1,151,218,62,255,156,88,8,1,210,184,98,255,20,175,123,255,102,83,229,0,220,65,116,1,150,250,4,255,92,142,220,255,34,247,66,255,204,225,179,254,151,81,151,0,71,40,236,255,138,63,62,0,6,79,240,255,183,185,181,0,118,50,27,0,63,227,192,0,123,99,58,1,50,224,155,255,17,225,223,254,220,224,77,255,14,44,123,1,141,128,175,0,248,212,200,0,150,59,183,255,147,97,29,0,150,204,181,0,253,37,71,0,145,85,119,0,154,200,186,0,2,128,249,255,83,24,124,0,14,87,143,0,168,51,245,1,124,151,231,255,208,240,197,1,124,190,185,0,48,58,246,0,20,233,232,0,125,18,98,255,13,254,31,255,245,177,130,255,108,142,35,0,171,125,242,254,140,12,34,255,165,161,162,0,206,205,101,0,247,25,34,1,100,145,57,0,39,70,57,0,118,204,203,255,242,0,162,0,165,244,30,0,198,116,226,0,128,111,153,255,140,54,182,1,60,122,15,255,155,58,57,1,54,50,198,0,171,211,29,255,107,138,167,255,173,107,199,255,109,161,193,0,89,72,242,255,206,115,89,255,250,254,142,254,177,202,94,255,81,89,50,0,7,105,66,255,25,254,255,254,203,64,23,255,79,222,108,255,39,249,75,0,241,124,50,0,239,152,133,0,221,241,105,0,147,151,98,0,213,161,121,254,242,49,137,0,233,37,249,254,42,183,27,0,184,119,230,255,217,32,163,255,208,251,228,1,137,62,131,255,79,64,9,254,94,48,113,0,17,138,50,254,193,255,22,0,247,18,197,1,67,55,104,0,16,205,95,255,48,37,66,0,55,156,63,1,64,82,74,255,200,53,71,254,239,67,125,0,26,224,222,0,223,137,93,255,30,224,202,255,9,220,132,0,198,38,235,1,102,141,86,0,60,43,81,1,136,28,26,0,233,36,8,254,207,242,148,0,164,162,63,0,51,46,224,255,114,48,79,255,9,175,226,0,222,3,193,255,47,160,232,255,255,93,105,254,14,42,230,0,26,138,82,1,208,43,244,0,27,39,38,255,98,208,127,255,64,149,182,255,5,250,209,0,187,60,28,254,49,25,218,255,169,116,205,255,119,18,120,0,156,116,147,255,132,53,109,255,13,10,202,0,110,83,167,0,157,219,137,255,6,3,130,255,50,167,30,255,60,159,47,255,129,128,157,254,94,3,189,0,3,166,68,0,83,223,215,0,150,90,194,1,15,168,65,0,227,83,51,255,205,171,66,255,54,187,60,1,152,102,45,255,119,154,225,0,240,247,136,0,100,197,178,255,139,71,223,255,204,82,16,1,41,206,42,255,156,192,221,255,216,123,244,255,218,218,185,255,187,186,239,255,252,172,160,255,195,52,22,0,144,174,181,254,187,100,115,255,211,78,176,255,27,7,193,0,147,213,104,255,90,201,10,255,80,123,66,1,22,33,186,0,1,7,99,254,30,206,10,0,229,234,5,0,53,30,210,0,138,8,220,254,71,55,167,0,72,225,86,1,118,190,188,0,254,193,101,1,171,249,172,255,94,158,183,254,93,2,108,255,176,93,76,255,73,99,79,255,74,64,129,254,246,46,65,0,99,241,127,254,246,151,102,255,44,53,208,254,59,102,234,0,154,175,164,255,88,242,32,0,111,38,1,0,255,182,190,255,115,176,15,254,169,60,129,0,122,237,241,0,90,76,63,0,62,74,120,255,122,195,110,0,119,4,178,0,222,242,210,0,130,33,46,254,156,40,41,0,167,146,112,1,49,163,111,255,121,176,235,0,76,207,14,255,3,25,198,1,41,235,213,0,85,36,214,1,49,92,109,255,200,24,30,254,168,236,195,0,145,39,124,1,236,195,149,0,90,36,184,255,67,85,170,255,38,35,26,254,131,124,68,255,239,155,35,255,54,201,164,0,196,22,117,255,49,15,205,0,24,224,29,1,126,113,144,0,117,21,182,0,203,159,141,0,223,135,77,0,176,230,176,255,190,229,215,255,99,37,181,255,51,21,138,255,25,189,89,255,49,48,165,254,152,45,247,0,170,108,222,0,80,202,5,0,27,69,103,254,204,22,129,255,180,252,62,254,210,1,91,255,146,110,254,255,219,162,28,0,223,252,213,1,59,8,33,0,206,16,244,0,129,211,48,0,107,160,208,0,112,59,209,0,109,77,216,254,34,21,185,255,246,99,56,255,179,139,19,255,185,29,50,255,84,89,19,0,74,250,98,255,225,42,200,255,192,217,205,255,210,16,167,0,99,132,95,1,43,230,57,0,254,11,203,255,99,188,63,255,119,193,251,254,80,105,54,0,232,181,189,1,183,69,112,255,208,171,165,255,47,109,180,255,123,83,165,0,146,162,52,255,154,11,4,255,151,227,90,255,146,137,97,254,61,233,41,255,94,42,55,255,108,164,236,0,152,68,254,0,10,140,131,255,10,106,79,254,243,158,137,0,67,178,66,254,177,123,198,255,15,62,34,0,197,88,42,255,149,95,177,255,152,0,198,255,149,254,113,255,225,90,163,255,125,217,247,0,18,17,224,0,128,66,120,254,192,25,9,255,50,221,205,0,49,212,70,0,233,255,164,0,2,209,9,0,221,52,219,254,172,224,244,255,94,56,206,1,242,179,2,255,31,91,164,1,230,46,138,255,189,230,220,0,57,47,61,255,111,11,157,0,177,91,152,0,28,230,98,0,97,87,126,0,198,89,145,255,167,79,107,0,249,77,160,1,29,233,230,255,150,21,86,254,60,11,193,0,151,37,36,254,185,150,243,255,228,212,83,1,172,151,180,0,201,169,155,0,244,60,234,0,142,235,4,1,67,218,60,0,192,113,75,1,116,243,207,255,65,172,155,0,81,30,156,255,80,72,33,254,18,231,109,255,142,107,21,254,125,26,132,255,176,16,59,255,150,201,58,0,206,169,201,0,208,121,226,0,40,172,14,255,150,61,94,255,56,57,156,255,141,60,145,255,45,108,149,255,238,145,155,255,209,85,31,254,192,12,210,0,99,98,93,254,152,16,151,0,225,185,220,0,141,235,44,255,160,172,21,254,71,26,31,255,13,64,93,254,28,56,198,0,177,62,248,1,182,8,241,0,166,101,148,255,78,81,133,255,129,222,215,1,188,169,129,255,232,7,97,0,49,112,60,255,217,229,251,0,119,108,138,0,39,19,123,254,131,49,235,0,132,84,145,0,130,230,148,255,25,74,187,0,5,245,54,255,185,219,241,1,18,194,228,255,241,202,102,0,105,113,202,0,155,235,79,0,21,9,178,255,156,1,239,0,200,148,61,0,115,247,210,255,49,221,135,0,58,189,8,1,35,46,9,0,81,65,5,255,52,158,185,255,125,116,46,255,74,140,13,255,210,92,172,254,147,23,71,0,217,224,253,254,115,108,180,255,145,58,48,254,219,177,24,255,156,255,60,1,154,147,242,0,253,134,87,0,53,75,229,0,48,195,222,255,31,175,50,255,156,210,120,255,208,35,222,255,18,248,179,1,2,10,101,255,157,194,248,255,158,204,101,255,104,254,197,255,79,62,4,0,178,172,101,1,96,146,251,255,65,10,156,0,2,137,165,255,116,4,231,0,242,215,1,0,19,35,29,255,43,161,79,0,59,149,246,1,251,66,176,0,200,33,3,255,80,110,142,255,195,161,17,1,228,56,66,255,123,47,145,254,132,4,164,0,67,174,172,0,25,253,114,0,87,97,87,1,250,220,84,0,96,91,200,255,37,125,59,0,19,65,118,0,161,52,241,255,237,172,6,255,176,191,255,255,1,65,130,254,223,190,230,0,101,253,231,255,146,35,109,0,250,29,77,1,49,0,19,0,123,90,155,1,22,86,32,255,218,213,65,0,111,93,127,0,60,93,169,255,8,127,182,0,17,186,14,254,253,137,246,255,213,25,48,254,76,238,0,255,248,92,70,255,99,224,139,0,184,9,255,1,7,164,208,0,205,131,198,1,87,214,199,0,130,214,95,0,221,149,222,0,23,38,171,254,197,110,213,0,43,115,140,254,215,177,118,0,96,52,66,1,117,158,237,0,14,64,182,255,46,63,174,255,158,95,190,255,225,205,177,255,43,5,142,255,172,99,212,255,244,187,147,0,29,51,153,255,228,116,24,254,30,101,207,0,19,246,150,255,134,231,5,0,125,134,226,1,77,65,98,0,236,130,33,255,5,110,62,0,69,108,127,255,7,113,22,0,145,20,83,254,194,161,231,255,131,181,60,0,217,209,177,255,229,148,212,254,3,131,184,0,117,177,187,1,28,14,31,255,176,102,80,0,50,84,151,255,125,31,54,255,21,157,133,255,19,179,139,1,224,232,26,0,34,117,170,255,167,252,171,255,73,141,206,254,129,250,35,0,72,79,236,1,220,229,20,255,41,202,173,255,99,76,238,255,198,22,224,255,108,198,195,255,36,141,96,1,236,158,59,255,106,100,87,0,110,226,2,0,227,234,222,0,154,93,119,255,74,112,164,255,67,91,2,255,21,145,33,255,102,214,137,255,175,230,103,254,163,246,166,0,93,247,116,254,167,224,28,255,220,2,57,1,171,206,84,0,123,228,17,255,27,120,119,0,119,11,147,1,180,47,225,255,104,200,185,254,165,2,114,0,77,78,212,0,45,154,177,255,24,196,121,254,82,157,182,0,90,16,190,1,12,147,197,0,95,239,152,255,11,235,71,0,86,146,119,255,172,134,214,0,60,131,196,0,161,225,129,0,31,130,120,254,95,200,51,0,105,231,210,255,58,9,148,255,43,168,221,255,124,237,142,0,198,211,50,254,46,245,103,0,164,248,84,0,152,70,208,255,180,117,177,0,70,79,185,0,243,74,32,0,149,156,207,0,197,196,161,1,245,53,239,0,15,93,246,254,139,240,49,255,196,88,36,255,162,38,123,0,128,200,157,1,174,76,103,255,173,169,34,254,216,1,171,255,114,51,17,0,136,228,194,0,110,150,56,254,106,246,159,0,19,184,79,255,150,77,240,255,155,80,162,0,0,53,169,255,29,151,86,0,68,94,16,0,92,7,110,254,98,117,149,255,249,77,230,255,253,10,140,0,214,124,92,254,35,118,235,0,89,48,57,1,22,53,166,0,184,144,61,255,179,255,194,0,214,248,61,254,59,110,246,0,121,21,81,254,166,3,228,0,106,64,26,255,69,232,134,255,242,220,53,254,46,220,85,0,113,149,247,255,97,179,103,255,190,127,11,0,135,209,182,0,95,52,129,1,170,144,206,255,122,200,204,255,168,100,146,0,60,144,149,254,70,60,40,0,122,52,177,255,246,211,101,255,174,237,8,0,7,51,120,0,19,31,173,0,126,239,156,255,143,189,203,0,196,128,88,255,233,133,226,255,30,125,173,255,201,108,50,0,123,100,59,255,254,163,3,1,221,148,181,255,214,136,57,254,222,180,137,255,207,88,54,255,28,33,251,255,67,214,52,1,210,208,100,0,81,170,94,0,145,40,53,0,224,111,231,254,35,28,244,255,226,199,195,254,238,17,230,0,217,217,164,254,169,157,221,0,218,46,162,1,199,207,163,255,108,115,162,1,14,96,187,255,118,60,76,0,184,159,152,0,209,231,71,254,42,164,186,255,186,153,51,254,221,171,182,255,162,142,173,0,235,47,193,0,7,139,16,1,95,164,64,255,16,221,166,0,219,197,16,0,132,29,44,255,100,69,117,255,60,235,88,254,40,81,173,0,71,190,61,255,187,88,157,0,231,11,23,0,237,117,164,0,225,168,223,255,154,114,116,255,163,152,242,1,24,32,170,0,125,98,113,254,168,19,76,0,17,157,220,254,155,52,5,0,19,111,161,255,71,90,252,255,173,110,240,0,10,198,121,255,253,255,240,255,66,123,210,0,221,194,215,254,121,163,17,255,225,7,99,0,190,49,182,0,115,9,133,1,232,26,138,255,213,68,132,0,44,119,122,255,179,98,51,0,149,90,106,0,71,50,230,255,10,153,118,255,177,70,25,0,165,87,205,0,55,138,234,0,238,30,97,0,113,155,207,0,98,153,127,0,34,107,219,254,117,114,172,255,76,180,255,254,242,57,179,255,221,34,172,254,56,162,49,255,83,3,255,255,113,221,189,255,188,25,228,254,16,88,89,255,71,28,198,254,22,17,149,255,243,121,254,255,107,202,99,255,9,206,14,1,220,47,153,0,107,137,39,1,97,49,194,255,149,51,197,254,186,58,11,255,107,43,232,1,200,6,14,255,181,133,65,254,221,228,171,255,123,62,231,1,227,234,179,255,34,189,212,254,244,187,249,0,190,13,80,1,130,89,1,0,223,133,173,0,9,222,198,255,66,127,74,0,167,216,93,255,155,168,198,1,66,145,0,0,68,102,46,1,172,90,154,0,216,128,75,255,160,40,51,0,158,17,27,1,124,240,49,0,236,202,176,255,151,124,192,255,38,193,190,0,95,182,61,0,163,147,124,255,255,165,51,255,28,40,17,254,215,96,78,0,86,145,218,254,31,36,202,255,86,9,5,0,111,41,200,255,237,108,97,0,57,62,44,0,117,184,15,1,45,241,116,0,152,1,220,255,157,165,188,0,250,15,131,1,60,44,125,255,65,220,251,255,75,50,184,0,53,90,128,255,231,80,194,255,136,129,127,1,21,18,187,255,45,58,161,255,71,147,34,0,174,249,11,254,35,141,29,0,239,68,177,255,115,110,58,0,238,190,177,1,87,245,166,255,190,49,247,255,146,83,184,255,173,14,39,255,146,215,104,0,142,223,120,0,149,200,155,255,212,207,145,1,16,181,217,0,173,32,87,255,255,35,181,0,119,223,161,1,200,223,94,255,70,6,186,255,192,67,85,255,50,169,152,0,144,26,123,255,56,243,179,254,20,68,136,0,39,140,188,254,253,208,5,255,200,115,135,1,43,172,229,255,156,104,187,0,151,251,167,0,52,135,23,0,151,153,72,0,147,197,107,254,148,158,5,255,238,143,206,0,126,153,137,255,88,152,197,254,7,68,167,0,252,159,165,255,239,78,54,255,24,63,55,255,38,222,94,0,237,183,12,255,206,204,210,0,19,39,246,254,30,74,231,0,135,108,29,1,179,115,0,0,117,118,116,1,132,6,252,255,145,129,161,1,105,67,141,0,82,37,226,255,238,226,228,255,204,214,129,254,162,123,100,255,185,121,234,0,45,108,231,0,66,8,56,255,132,136,128,0,172,224,66,254,175,157,188,0,230,223,226,254,242,219,69,0,184,14,119,1,82,162,56,0,114,123,20,0,162,103,85,255,49,239,99,254,156,135,215,0,111,255,167,254,39,196,214,0,144,38,79,1,249,168,125,0,155,97,156,255,23,52,219,255,150,22,144,0,44,149,165,255,40,127,183,0,196,77,233,255,118,129,210,255,170,135,230,255,214,119,198,0,233,240,35,0,253,52,7,255,117,102,48,255,21,204,154,255,179,136,177,255,23,2,3,1,149,130,89,255,252,17,159,1,70,60,26,0,144,107,17,0,180,190,60,255,56,182,59,255,110,71,54,255,198,18,129,255,149,224,87,255,223,21,152,255,138,22,182,255,250,156,205,0,236,45,208,255,79,148,242,1,101,70,209,0,103,78,174,0,101,144,172,255,152,136,237,1,191,194,136,0,113,80,125,1,152,4,141,0,155,150,53,255,196,116,245,0,239,114,73,254,19,82,17,255,124,125,234,255,40,52,191,0,42,210,158,255,155,132,165,0,178,5,42,1,64,92,40,255,36,85,77,255,178,228,118,0,137,66,96,254,115,226,66,0,110,240,69,254,151,111,80,0,167,174,236,255,227,108,107,255,188,242,65,255,183,81,255,0,57,206,181,255,47,34,181,255,213,240,158,1,71,75,95,0,156,40,24,255,102,210,81,0,171,199,228,255,154,34,41,0,227,175,75,0,21,239,195,0,138,229,95,1,76,192,49,0,117,123,87,1,227,225,130,0,125,62,63,255,2,198,171,0,254,36,13,254,145,186,206,0,148,255,244,255,35,0,166,0,30,150,219,1,92,228,212,0,92,198,60,254,62,133,200,255,201,41,59,0,125,238,109,255,180,163,238,1,140,122,82,0,9,22,88,255,197,157,47,255,153,94,57,0,88,30,182,0,84,161,85,0,178,146,124,0,166,166,7,255,21,208,223,0,156,182,242,0,155,121,185,0,83,156,174,254,154,16,118,255,186,83,232,1,223,58,121,255,29,23,88,0,35,125,127,255,170,5,149,254,164,12,130,255,155,196,29,0,161,96,136,0,7,35,29,1,162,37,251,0,3,46,242,255,0,217,188,0,57,174,226,1,206,233,2,0,57,187,136,254,123,189,9,255,201,117,127,255,186,36,204,0,231,25,216,0,80,78,105,0,19,134,129,255,148,203,68,0,141,81,125,254,248,165,200,255,214,144,135,0,151,55,166,255,38,235,91,0,21,46,154,0,223,254,150,255,35,153,180,255,125,176,29,1,43,98,30,255,216,122,230,255,233,160,12,0,57,185,12,254,240,113,7,255,5,9,16,254,26,91,108,0,109,198,203,0,8,147,40,0,129,134,228,255,124,186,40,255,114,98,132,254,166,132,23,0,99,69,44,0,9,242,238,255,184,53,59,0,132,129,102,255,52,32,243,254,147,223,200,255,123,83,179,254,135,144,201,255,141,37,56,1,151,60,227,255,90,73,156,1,203,172,187,0,80,151,47,255,94,137,231,255,36,191,59,255,225,209,181,255,74,215,213,254,6,118,179,255,153,54,193,1,50,0,231,0,104,157,72,1,140,227,154,255,182,226,16,254,96,225,92,255,115,20,170,254,6,250,78,0,248,75,173,255,53,89,6,255,0,180,118,0,72,173,1,0,64,8,206,1,174,133,223,0,185,62,133,255,214,11,98,0,197,31,208,0,171,167,244,255,22,231,181,1,150,218,185,0,247,169,97,1,165,139,247,255,47,120,149,1,103,248,51,0,60,69,28,254,25,179,196,0,124,7,218,254,58,107,81,0,184,233,156,255,252,74,36,0,118,188,67,0,141,95,53,255,222,94,165,254,46,61,53,0,206,59,115,255,47,236,250,255,74,5,32,1,129,154,238,255,106,32,226,0,121,187,61,255,3,166,241,254,67,170,172,255,29,216,178,255,23,201,252,0,253,110,243,0,200,125,57,0,109,192,96,255,52,115,238,0,38,121,243,255,201,56,33,0,194,118,130,0,75,96,25,255,170,30,230,254,39,63,253,0,36,45,250,255,251,1,239,0,160,212,92,1,45,209,237,0,243,33,87,254,237,84,201,255,212,18,157,254,212,99,127,255,217,98,16,254,139,172,239,0,168,201,130,255,143,193,169,255,238,151,193,1,215,104,41,0,239,61,165,254,2,3,242,0,22,203,177,254,177,204,22,0,149,129,213,254,31,11,41,255,0,159,121,254,160,25,114,255,162,80,200,0,157,151,11,0,154,134,78,1,216,54,252,0,48,103,133,0,105,220,197,0,253,168,77,254,53,179,23,0,24,121,240,1,255,46,96,255,107,60,135,254,98,205,249,255,63,249,119,255,120,59,211,255,114,180,55,254,91,85,237,0,149,212,77,1,56,73,49,0,86,198,150,0,93,209,160,0,69,205,182,255,244,90,43,0,20,36,176,0,122,116,221,0,51,167,39,1,231,1,63,255,13,197,134,0,3,209,34,255,135,59,202,0,167,100,78,0,47,223,76,0,185,60,62,0,178,166,123,1,132,12,161,255,61,174,43,0,195,69,144,0,127,47,191,1,34,44,78,0,57,234,52,1,255,22,40,255,246,94,146,0,83,228,128,0,60,78,224,255,0,96,210,255,153,175,236,0,159,21,73,0,180,115,196,254,131,225,106,0,255,167,134,0,159,8,112,255,120,68,194,255,176,196,198,255,118,48,168,255,93,169,1,0,112,200,102,1,74,24,254,0,19,141,4,254,142,62,63,0,131,179,187,255,77,156,155,255,119,86,164,0,170,208,146,255,208,133,154,255,148,155,58,255,162,120,232,254,252,213,155,0,241,13,42,0,94,50,131,0,179,170,112,0,140,83,151,255,55,119,84,1,140,35,239,255,153,45,67,1,236,175,39,0,54,151,103,255,158,42,65,255,196,239,135,254,86,53,203],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+10240);allocate([149,97,47,254,216,35,17,255,70,3,70,1,103,36,90,255,40,26,173,0,184,48,13,0,163,219,217,255,81,6,1,255,221,170,108,254,233,208,93,0,100,201,249,254,86,36,35,255,209,154,30,1,227,201,251,255,2,189,167,254,100,57,3,0,13,128,41,0,197,100,75,0,150,204,235,255,145,174,59,0,120,248,149,255,85,55,225,0,114,210,53,254,199,204,119,0,14,247,74,1,63,251,129,0,67,104,151,1,135,130,80,0,79,89,55,255,117,230,157,255,25,96,143,0,213,145,5,0,69,241,120,1,149,243,95,255,114,42,20,0,131,72,2,0,154,53,20,255,73,62,109,0,196,102,152,0,41,12,204,255,122,38,11,1,250,10,145,0,207,125,148,0,246,244,222,255,41,32,85,1,112,213,126,0,162,249,86,1,71,198,127,255,81,9,21,1,98,39,4,255,204,71,45,1,75,111,137,0,234,59,231,0,32,48,95,255,204,31,114,1,29,196,181,255,51,241,167,254,93,109,142,0,104,144,45,0,235,12,181,255,52,112,164,0,76,254,202,255,174,14,162,0,61,235,147,255,43,64,185,254,233,125,217,0,243,88,167,254,74,49,8,0,156,204,66,0,124,214,123,0,38,221,118,1,146,112,236,0,114,98,177,0,151,89,199,0,87,197,112,0,185,149,161,0,44,96,165,0,248,179,20,255,188,219,216,254,40,62,13,0,243,142,141,0,229,227,206,255,172,202,35,255,117,176,225,255,82,110,38,1,42,245,14,255,20,83,97,0,49,171,10,0,242,119,120,0,25,232,61,0,212,240,147,255,4,115,56,255,145,17,239,254,202,17,251,255,249,18,245,255,99,117,239,0,184,4,179,255,246,237,51,255,37,239,137,255,166,112,166,255,81,188,33,255,185,250,142,255,54,187,173,0,208,112,201,0,246,43,228,1,104,184,88,255,212,52,196,255,51,117,108,255,254,117,155,0,46,91,15,255,87,14,144,255,87,227,204,0,83,26,83,1,159,76,227,0,159,27,213,1,24,151,108,0,117,144,179,254,137,209,82,0,38,159,10,0,115,133,201,0,223,182,156,1,110,196,93,255,57,60,233,0,5,167,105,255,154,197,164,0,96,34,186,255,147,133,37,1,220,99,190,0,1,167,84,255,20,145,171,0,194,197,251,254,95,78,133,255,252,248,243,255,225,93,131,255,187,134,196,255,216,153,170,0,20,118,158,254,140,1,118,0,86,158,15,1,45,211,41,255,147,1,100,254,113,116,76,255,211,127,108,1,103,15,48,0,193,16,102,1,69,51,95,255,107,128,157,0,137,171,233,0,90,124,144,1,106,161,182,0,175,76,236,1,200,141,172,255,163,58,104,0,233,180,52,255,240,253,14,255,162,113,254,255,38,239,138,254,52,46,166,0,241,101,33,254,131,186,156,0,111,208,62,255,124,94,160,255,31,172,254,0,112,174,56,255,188,99,27,255,67,138,251,0,125,58,128,1,156,152,174,255,178,12,247,255,252,84,158,0,82,197,14,254,172,200,83,255,37,39,46,1,106,207,167,0,24,189,34,0,131,178,144,0,206,213,4,0,161,226,210,0,72,51,105,255,97,45,187,255,78,184,223,255,176,29,251,0,79,160,86,255,116,37,178,0,82,77,213,1,82,84,141,255,226,101,212,1,175,88,199,255,245,94,247,1,172,118,109,255,166,185,190,0,131,181,120,0,87,254,93,255,134,240,73,255,32,245,143,255,139,162,103,255,179,98,18,254,217,204,112,0,147,223,120,255,53,10,243,0,166,140,150,0,125,80,200,255,14,109,219,255,91,218,1,255,252,252,47,254,109,156,116,255,115,49,127,1,204,87,211,255,148,202,217,255,26,85,249,255,14,245,134,1,76,89,169,255,242,45,230,0,59,98,172,255,114,73,132,254,78,155,49,255,158,126,84,0,49,175,43,255,16,182,84,255,157,103,35,0,104,193,109,255,67,221,154,0,201,172,1,254,8,162,88,0,165,1,29,255,125,155,229,255,30,154,220,1,103,239,92,0,220,1,109,255,202,198,1,0,94,2,142,1,36,54,44,0,235,226,158,255,170,251,214,255,185,77,9,0,97,74,242,0,219,163,149,255,240,35,118,255,223,114,88,254,192,199,3,0,106,37,24,255,201,161,118,255,97,89,99,1,224,58,103,255,101,199,147,254,222,60,99,0,234,25,59,1,52,135,27,0,102,3,91,254,168,216,235,0,229,232,136,0,104,60,129,0,46,168,238,0,39,191,67,0,75,163,47,0,143,97,98,255,56,216,168,1,168,233,252,255,35,111,22,255,92,84,43,0,26,200,87,1,91,253,152,0,202,56,70,0,142,8,77,0,80,10,175,1,252,199,76,0,22,110,82,255,129,1,194,0,11,128,61,1,87,14,145,255,253,222,190,1,15,72,174,0,85,163,86,254,58,99,44,255,45,24,188,254,26,205,15,0,19,229,210,254,248,67,195,0,99,71,184,0,154,199,37,255,151,243,121,255,38,51,75,255,201,85,130,254,44,65,250,0,57,147,243,254,146,43,59,255,89,28,53,0,33,84,24,255,179,51,18,254,189,70,83,0,11,156,179,1,98,134,119,0,158,111,111,0,119,154,73,255,200,63,140,254,45,13,13,255,154,192,2,254,81,72,42,0,46,160,185,254,44,112,6,0,146,215,149,1,26,176,104,0,68,28,87,1,236,50,153,255,179,128,250,254,206,193,191,255,166,92,137,254,53,40,239,0,210,1,204,254,168,173,35,0,141,243,45,1,36,50,109,255,15,242,194,255,227,159,122,255,176,175,202,254,70,57,72,0,40,223,56,0,208,162,58,255,183,98,93,0,15,111,12,0,30,8,76,255,132,127,246,255,45,242,103,0,69,181,15,255,10,209,30,0,3,179,121,0,241,232,218,1,123,199,88,255,2,210,202,1,188,130,81,255,94,101,208,1,103,36,45,0,76,193,24,1,95,26,241,255,165,162,187,0,36,114,140,0,202,66,5,255,37,56,147,0,152,11,243,1,127,85,232,255,250,135,212,1,185,177,113,0,90,220,75,255,69,248,146,0,50,111,50,0,92,22,80,0,244,36,115,254,163,100,82,255,25,193,6,1,127,61,36,0,253,67,30,254,65,236,170,255,161,17,215,254,63,175,140,0,55,127,4,0,79,112,233,0,109,160,40,0,143,83,7,255,65,26,238,255,217,169,140,255,78,94,189,255,0,147,190,255,147,71,186,254,106,77,127,255,233,157,233,1,135,87,237,255,208,13,236,1,155,109,36,255,180,100,218,0,180,163,18,0,190,110,9,1,17,63,123,255,179,136,180,255,165,123,123,255,144,188,81,254,71,240,108,255,25,112,11,255,227,218,51,255,167,50,234,255,114,79,108,255,31,19,115,255,183,240,99,0,227,87,143,255,72,217,248,255,102,169,95,1,129,149,149,0,238,133,12,1,227,204,35,0,208,115,26,1,102,8,234,0,112,88,143,1,144,249,14,0,240,158,172,254,100,112,119,0,194,141,153,254,40,56,83,255,121,176,46,0,42,53,76,255,158,191,154,0,91,209,92,0,173,13,16,1,5,72,226,255,204,254,149,0,80,184,207,0,100,9,122,254,118,101,171,255,252,203,0,254,160,207,54,0,56,72,249,1,56,140,13,255,10,64,107,254,91,101,52,255,225,181,248,1,139,255,132,0,230,145,17,0,233,56,23,0,119,1,241,255,213,169,151,255,99,99,9,254,185,15,191,255,173,103,109,1,174,13,251,255,178,88,7,254,27,59,68,255,10,33,2,255,248,97,59,0,26,30,146,1,176,147,10,0,95,121,207,1,188,88,24,0,185,94,254,254,115,55,201,0,24,50,70,0,120,53,6,0,142,66,146,0,228,226,249,255,104,192,222,1,173,68,219,0,162,184,36,255,143,102,137,255,157,11,23,0,125,45,98,0,235,93,225,254,56,112,160,255,70,116,243,1,153,249,55,255,129,39,17,1,241,80,244,0,87,69,21,1,94,228,73,255,78,66,65,255,194,227,231,0,61,146,87,255,173,155,23,255,112,116,219,254,216,38,11,255,131,186,133,0,94,212,187,0,100,47,91,0,204,254,175,255,222,18,215,254,173,68,108,255,227,228,79,255,38,221,213,0,163,227,150,254,31,190,18,0,160,179,11,1,10,90,94,255,220,174,88,0,163,211,229,255,199,136,52,0,130,95,221,255,140,188,231,254,139,113,128,255,117,171,236,254,49,220,20,255,59,20,171,255,228,109,188,0,20,225,32,254,195,16,174,0,227,254,136,1,135,39,105,0,150,77,206,255,210,238,226,0,55,212,132,254,239,57,124,0,170,194,93,255,249,16,247,255,24,151,62,255,10,151,10,0,79,139,178,255,120,242,202,0,26,219,213,0,62,125,35,255,144,2,108,255,230,33,83,255,81,45,216,1,224,62,17,0,214,217,125,0,98,153,153,255,179,176,106,254,131,93,138,255,109,62,36,255,178,121,32,255,120,252,70,0,220,248,37,0,204,88,103,1,128,220,251,255,236,227,7,1,106,49,198,255,60,56,107,0,99,114,238,0,220,204,94,1,73,187,1,0,89,154,34,0,78,217,165,255,14,195,249,255,9,230,253,255,205,135,245,0,26,252,7,255,84,205,27,1,134,2,112,0,37,158,32,0,231,91,237,255,191,170,204,255,152,7,222,0,109,192,49,0,193,166,146,255,232,19,181,255,105,142,52,255,103,16,27,1,253,200,165,0,195,217,4,255,52,189,144,255,123,155,160,254,87,130,54,255,78,120,61,255,14,56,41,0,25,41,125,255,87,168,245,0,214,165,70,0,212,169,6,255,219,211,194,254,72,93,164,255,197,33,103,255,43,142,141,0,131,225,172,0,244,105,28,0,68,68,225,0,136,84,13,255,130,57,40,254,139,77,56,0,84,150,53,0,54,95,157,0,144,13,177,254,95,115,186,0,117,23,118,255,244,166,241,255,11,186,135,0,178,106,203,255,97,218,93,0,43,253,45,0,164,152,4,0,139,118,239,0,96,1,24,254,235,153,211,255,168,110,20,255,50,239,176,0,114,41,232,0,193,250,53,0,254,160,111,254,136,122,41,255,97,108,67,0,215,152,23,255,140,209,212,0,42,189,163,0,202,42,50,255,106,106,189,255,190,68,217,255,233,58,117,0,229,220,243,1,197,3,4,0,37,120,54,254,4,156,134,255,36,61,171,254,165,136,100,255,212,232,14,0,90,174,10,0,216,198,65,255,12,3,64,0,116,113,115,255,248,103,8,0,231,125,18,255,160,28,197,0,30,184,35,1,223,73,249,255,123,20,46,254,135,56,37,255,173,13,229,1,119,161,34,255,245,61,73,0,205,125,112,0,137,104,134,0,217,246,30,255,237,142,143,0,65,159,102,255,108,164,190,0,219,117,173,255,34,37,120,254,200,69,80,0,31,124,218,254,74,27,160,255,186,154,199,255,71,199,252,0,104,81,159,1,17,200,39,0,211,61,192,1,26,238,91,0,148,217,12,0,59,91,213,255,11,81,183,255,129,230,122,255,114,203,145,1,119,180,66,255,72,138,180,0,224,149,106,0,119,82,104,255,208,140,43,0,98,9,182,255,205,101,134,255,18,101,38,0,95,197,166,255,203,241,147,0,62,208,145,255,133,246,251,0,2,169,14,0,13,247,184,0,142,7,254,0,36,200,23,255,88,205,223,0,91,129,52,255,21,186,30,0,143,228,210,1,247,234,248,255,230,69,31,254,176,186,135,255,238,205,52,1,139,79,43,0,17,176,217,254,32,243,67,0,242,111,233,0,44,35,9,255,227,114,81,1,4,71,12,255,38,105,191,0,7,117,50,255,81,79,16,0,63,68,65,255,157,36,110,255,77,241,3,255,226,45,251,1,142,25,206,0,120,123,209,1,28,254,238,255,5,128,126,255,91,222,215,255,162,15,191,0,86,240,73,0,135,185,81,254,44,241,163,0,212,219,210,255,112,162,155,0,207,101,118,0,168,72,56,255,196,5,52,0,72,172,242,255,126,22,157,255,146,96,59,255,162,121,152,254,140,16,95,0,195,254,200,254,82,150,162,0,119,43,145,254,204,172,78,255,166,224,159,0,104,19,237,255,245,126,208,255,226,59,213,0,117,217,197,0,152,72,237,0,220,31,23,254,14,90,231,255,188,212,64,1,60,101,246,255,85,24,86,0,1,177,109,0,146,83,32,1,75,182,192,0,119,241,224,0,185,237,27,255,184,101,82,1,235,37,77,255,253,134,19,0,232,246,122,0,60,106,179,0,195,11,12,0,109,66,235,1,125,113,59,0,61,40,164,0,175,104,240,0,2,47,187,255,50,12,141,0,194,139,181,255,135,250,104,0,97,92,222,255,217,149,201,255,203,241,118,255,79,151,67,0,122,142,218,255,149,245,239,0,138,42,200,254,80,37,97,255,124,112,167,255,36,138,87,255,130,29,147,255,241,87,78,255,204,97,19,1,177,209,22,255,247,227,127,254,99,119,83,255,212,25,198,1,16,179,179,0,145,77,172,254,89,153,14,255,218,189,167,0,107,233,59,255,35,33,243,254,44,112,112,255,161,127,79,1,204,175,10,0,40,21,138,254,104,116,228,0,199,95,137,255,133,190,168,255,146,165,234,1,183,99,39,0,183,220,54,254,255,222,133,0,162,219,121,254,63,239,6,0,225,102,54,255,251,18,246,0,4,34,129,1,135,36,131,0,206,50,59,1,15,97,183,0,171,216,135,255,101,152,43,255,150,251,91,0,38,145,95,0,34,204,38,254,178,140,83,255,25,129,243,255,76,144,37,0,106,36,26,254,118,144,172,255,68,186,229,255,107,161,213,255,46,163,68,255,149,170,253,0,187,17,15,0,218,160,165,255,171,35,246,1,96,13,19,0,165,203,117,0,214,107,192,255,244,123,177,1,100,3,104,0,178,242,97,255,251,76,130,255,211,77,42,1,250,79,70,255,63,244,80,1,105,101,246,0,61,136,58,1,238,91,213,0,14,59,98,255,167,84,77,0,17,132,46,254,57,175,197,255,185,62,184,0,76,64,207,0,172,175,208,254,175,74,37,0,138,27,211,254,148,125,194,0,10,89,81,0,168,203,101,255,43,213,209,1,235,245,54,0,30,35,226,255,9,126,70,0,226,125,94,254,156,117,20,255,57,248,112,1,230,48,64,255,164,92,166,1,224,214,230,255,36,120,143,0,55,8,43,255,251,1,245,1,106,98,165,0,74,107,106,254,53,4,54,255,90,178,150,1,3,120,123,255,244,5,89,1,114,250,61,255,254,153,82,1,77,15,17,0,57,238,90,1,95,223,230,0,236,52,47,254,103,148,164,255,121,207,36,1,18,16,185,255,75,20,74,0,187,11,101,0,46,48,129,255,22,239,210,255,77,236,129,255,111,77,204,255,61,72,97,255,199,217,251,255,42,215,204,0,133,145,201,255,57,230,146,1,235,100,198,0,146,73,35,254,108,198,20,255,182,79,210,255,82,103,136,0,246,108,176,0,34,17,60,255,19,74,114,254,168,170,78,255,157,239,20,255,149,41,168,0,58,121,28,0,79,179,134,255,231,121,135,255,174,209,98,255,243,122,190,0,171,166,205,0,212,116,48,0,29,108,66,255,162,222,182,1,14,119,21,0,213,39,249,255,254,223,228,255,183,165,198,0,133,190,48,0,124,208,109,255,119,175,85,255,9,209,121,1,48,171,189,255,195,71,134,1,136,219,51,255,182,91,141,254,49,159,72,0,35,118,245,255,112,186,227,255,59,137,31,0,137,44,163,0,114,103,60,254,8,213,150,0,162,10,113,255,194,104,72,0,220,131,116,255,178,79,92,0,203,250,213,254,93,193,189,255,130,255,34,254,212,188,151,0,136,17,20,255,20,101,83,255,212,206,166,0,229,238,73,255,151,74,3,255,168,87,215,0,155,188,133,255,166,129,73,0,240,79,133,255,178,211,81,255,203,72,163,254,193,168,165,0,14,164,199,254,30,255,204,0,65,72,91,1,166,74,102,255,200,42,0,255,194,113,227,255,66,23,208,0,229,216,100,255,24,239,26,0,10,233,62,255,123,10,178,1,26,36,174,255,119,219,199,1,45,163,190,0,16,168,42,0,166,57,198,255,28,26,26,0,126,165,231,0,251,108,100,255,61,229,121,255,58,118,138,0,76,207,17,0,13,34,112,254,89,16,168,0,37,208,105,255,35,201,215,255,40,106,101,254,6,239,114,0,40,103,226,254,246,127,110,255,63,167,58,0,132,240,142,0,5,158,88,255,129,73,158,255,94,89,146,0,230,54,146,0,8,45,173,0,79,169,1,0,115,186,247,0,84,64,131,0,67,224,253,255,207,189,64,0,154,28,81,1,45,184,54,255,87,212,224,255,0,96,73,255,129,33,235,1,52,66,80,255,251,174,155,255,4,179,37,0,234,164,93,254,93,175,253,0,198,69,87,255,224,106,46,0,99,29,210,0,62,188,114,255,44,234,8,0,169,175,247,255,23,109,137,255,229,182,39,0,192,165,94,254,245,101,217,0,191,88,96,0,196,94,99,255,106,238,11,254,53,126,243,0,94,1,101,255,46,147,2,0,201,124,124,255,141,12,218,0,13,166,157,1,48,251,237,255,155,250,124,255,106,148,146,255,182,13,202,0,28,61,167,0,217,152,8,254,220,130,45,255,200,230,255,1,55,65,87,255,93,191,97,254,114,251,14,0,32,105,92,1,26,207,141,0,24,207,13,254,21,50,48,255,186,148,116,255,211,43,225,0,37,34,162,254,164,210,42,255,68,23,96,255,182,214,8,255,245,117,137,255,66,195,50,0,75,12,83,254,80,140,164,0,9,165,36,1,228,110,227,0,241,17,90,1,25,52,212,0,6,223,12,255,139,243,57,0,12,113,75,1,246,183,191,255,213,191,69,255,230,15,142,0,1,195,196,255,138,171,47,255,64,63,106,1,16,169,214,255,207,174,56,1,88,73,133,255,182,133,140,0,177,14,25,255,147,184,53,255,10,227,161,255,120,216,244,255,73,77,233,0,157,238,139,1,59,65,233,0,70,251,216,1,41,184,153,255,32,203,112,0,146,147,253,0,87,101,109,1,44,82,133,255,244,150,53,255,94,152,232,255,59,93,39,255,88,147,220,255,78,81,13,1,32,47,252,255,160,19,114,255,93,107,39,255,118,16,211,1,185,119,209,255,227,219,127,254,88,105,236,255,162,110,23,255,36,166,110,255,91,236,221,255,66,234,116,0,111,19,244,254,10,233,26,0,32,183,6,254,2,191,242,0,218,156,53,254,41,60,70,255,168,236,111,0,121,185,126,255,238,142,207,255,55,126,52,0,220,129,208,254,80,204,164,255,67,23,144,254,218,40,108,255,127,202,164,0,203,33,3,255,2,158,0,0,37,96,188,255,192,49,74,0,109,4,0,0,111,167,10,254,91,218,135,255,203,66,173,255,150,194,226,0,201,253,6,255,174,102,121,0,205,191,110,0,53,194,4,0,81,40,45,254,35,102,143,255,12,108,198,255,16,27,232,255,252,71,186,1,176,110,114,0,142,3,117,1,113,77,142,0,19,156,197,1,92,47,252,0,53,232,22,1,54,18,235,0,46,35,189,255,236,212,129,0,2,96,208,254,200,238,199,255,59,175,164,255,146,43,231,0,194,217,52,255,3,223,12,0,138,54,178,254,85,235,207,0,232,207,34,0,49,52,50,255,166,113,89,255,10,45,216,255,62,173,28,0,111,165,246,0,118,115,91,255,128,84,60,0,167,144,203,0,87,13,243,0,22,30,228,1,177,113,146,255,129,170,230,254,252,153,129,255,145,225,43,0,70,231,5,255,122,105,126,254,86,246,148,255,110,37,154,254,209,3,91,0,68,145,62,0,228,16,165,255,55,221,249,254,178,210,91,0,83,146,226,254,69,146,186,0,93,210,104,254,16,25,173,0,231,186,38,0,189,122,140,255,251,13,112,255,105,110,93,0,251,72,170,0,192,23,223,255,24,3,202,1,225,93,228,0,153,147,199,254,109,170,22,0,248,101,246,255,178,124,12,255,178,254,102,254,55,4,65,0,125,214,180,0,183,96,147,0,45,117,23,254,132,191,249,0,143,176,203,254,136,183,54,255,146,234,177,0,146,101,86,255,44,123,143,1,33,209,152,0,192,90,41,254,83,15,125,255,213,172,82,0,215,169,144,0,16,13,34,0,32,209,100,255,84,18,249,1,197,17,236,255,217,186,230,0,49,160,176,255,111,118,97,255,237,104,235,0,79,59,92,254,69,249,11,255,35,172,74,1,19,118,68,0,222,124,165,255,180,66,35,255,86,174,246,0,43,74,111,255,126,144,86,255,228,234,91,0,242,213,24,254,69,44,235,255,220,180,35,0,8,248,7,255,102,47,92,255,240,205,102,255,113,230,171,1,31,185,201,255,194,246,70,255,122,17,187,0,134,70,199,255,149,3,150,255,117,63,103,0,65,104,123,255,212,54,19,1,6,141,88,0,83,134,243,255,136,53,103,0,169,27,180,0,177,49,24,0,111,54,167,0,195,61,215,255,31,1,108,1,60,42,70,0,185,3,162,255,194,149,40,255,246,127,38,254,190,119,38,255,61,119,8,1,96,161,219,255,42,203,221,1,177,242,164,255,245,159,10,0,116,196,0,0,5,93,205,254,128,127,179,0,125,237,246,255,149,162,217,255,87,37,20,254,140,238,192,0,9,9,193,0,97,1,226,0,29,38,10,0,0,136,63,255,229,72,210,254,38,134,92,255,78,218,208,1,104,36,84,255,12,5,193,255,242,175,61,255,191,169,46,1,179,147,147,255,113,190,139,254,125,172,31,0,3,75,252,254,215,36,15,0,193,27,24,1,255,69,149,255,110,129,118,0,203,93,249,0,138,137,64,254,38,70,6,0,153,116,222,0,161,74,123,0,193,99,79,255,118,59,94,255,61,12,43,1,146,177,157,0,46,147,191,0,16,255,38,0,11,51,31,1,60,58,98,255,111,194,77,1,154,91,244,0,140,40,144,1,173,10,251,0,203,209,50,254,108,130,78,0,228,180,90,0,174,7,250,0,31,174,60,0,41,171,30,0,116,99,82,255,118,193,139,255,187,173,198,254,218,111,56,0,185,123,216,0,249,158,52,0,52,180,93,255,201,9,91,255,56,45,166,254,132,155,203,255,58,232,110,0,52,211,89,255,253,0,162,1,9,87,183,0,145,136,44,1,94,122,245,0,85,188,171,1,147,92,198,0,0,8,104,0,30,95,174,0,221,230,52,1,247,247,235,255,137,174,53,255,35,21,204,255,71,227,214,1,232,82,194,0,11,48,227,255,170,73,184,255,198,251,252,254,44,112,34,0,131,101,131,255,72,168,187,0,132,135,125,255,138,104,97,255,238,184,168,255,243,104,84,255,135,216,226,255,139,144,237,0,188,137,150,1,80,56,140,255,86,169,167,255,194,78,25,255,220,17,180,255,17,13,193,0,117,137,212,255,141,224,151,0,49,244,175,0,193,99,175,255,19,99,154,1,255,65,62,255,156,210,55,255,242,244,3,255,250,14,149,0,158,88,217,255,157,207,134,254,251,232,28,0,46,156,251,255,171,56,184,255,239,51,234,0,142,138,131,255,25,254,243,1,10,201,194,0,63,97,75,0,210,239,162,0,192,200,31,1,117,214,243,0,24,71,222,254,54,40,232,255,76,183,111,254,144,14,87,255,214,79,136,255,216,196,212,0,132,27,140,254,131,5,253,0,124,108,19,255,28,215,75,0,76,222,55,254,233,182,63,0,68,171,191,254,52,111,222,255,10,105,77,255,80,170,235,0,143,24,88,255,45,231,121,0,148,129,224,1,61,246,84,0,253,46,219,255,239,76,33,0,49,148,18,254,230,37,69,0,67,134,22,254,142,155,94,0,31,157,211,254,213,42,30,255,4,228,247,254,252,176,13,255,39,0,31,254,241,244,255,255,170,45,10,254,253,222,249,0,222,114,132,0,255,47,6,255,180,163,179,1,84,94,151,255,89,209,82,254,229,52,169,255,213,236,0,1,214,56,228,255,135,119,151,255,112,201,193,0,83,160,53,254,6,151,66,0,18,162,17,0,233,97,91,0,131,5,78,1,181,120,53,255,117,95,63,255,237,117,185,0,191,126,136,255,144,119,233,0,183,57,97,1,47,201,187,255,167,165,119,1,45,100,126,0,21,98,6,254,145,150,95,255,120,54,152,0,209,98,104,0,143,111,30,254,184,148,249,0,235,216,46,0,248,202,148,255,57,95,22,0,242,225,163,0,233,247,232,255,71,171,19,255,103,244,49,255,84,103,93,255,68,121,244,1,82,224,13,0,41,79,43,255,249,206,167,255,215,52,21,254,192,32,22,255,247,111,60,0,101,74,38,255,22,91,84,254,29,28,13,255,198,231,215,254,244,154,200,0,223,137,237,0,211,132,14,0,95,64,206,255,17,62,247,255,233,131,121,1,93,23,77,0,205,204,52,254,81,189,136,0,180,219,138,1,143,18,94,0,204,43,140,254,188,175,219,0,111,98,143,255,151,63,162,255,211,50,71,254,19,146,53,0,146,45,83,254,178,82,238,255,16,133,84,255,226,198,93,255,201,97,20,255,120,118,35,255,114,50,231,255,162,229,156,255,211,26,12,0,114,39,115,255,206,212,134,0,197,217,160,255,116,129,94,254,199,215,219,255,75,223,249,1,253,116,181,255,232,215,104,255,228,130,246,255,185,117,86,0,14,5,8,0,239,29,61,1,237,87,133,255,125,146,137,254,204,168,223,0,46,168,245,0,154,105,22,0,220,212,161,255,107,69,24,255,137,218,181,255,241,84,198,255,130,122,211,255,141,8,153,255,190,177,118,0,96,89,178,0,255,16,48,254,122,96,105,255,117,54,232,255,34,126,105,255,204,67,166,0,232,52,138,255,211,147,12,0,25,54,7,0,44,15,215,254,51,236,45,0,190,68,129,1,106,147,225,0,28,93,45,254,236,141,15,255,17,61,161,0,220,115,192,0,236,145,24,254,111,168,169,0,224,58,63,255,127,164,188,0,82,234,75,1,224,158,134,0,209,68,110,1,217,166,217,0,70,225,166,1,187,193,143,255,16,7,88,255,10,205,140,0,117,192,156,1,17,56,38,0,27,124,108,1,171,215,55,255,95,253,212,0,155,135,168,255,246,178,153,254,154,68,74,0,232,61,96,254,105,132,59,0,33,76,199,1,189,176,130,255,9,104,25,254,75,198,102,255,233,1,112,0,108,220,20,255,114,230,70,0,140,194,133,255,57,158,164,254,146,6,80,255,169,196,97,1,85,183,130,0,70,158,222,1,59,237,234,255,96,25,26,255,232,175,97,255,11,121,248,254,88,35,194,0,219,180,252,254,74,8,227,0,195,227,73,1,184,110,161,255,49,233,164,1,128,53,47,0,82,14,121,255,193,190,58,0,48,174,117,255,132,23,32,0,40,10,134,1,22,51,25,255,240,11,176,255,110,57,146,0,117,143,239,1,157,101,118,255,54,84,76,0,205,184,18,255,47,4,72,255,78,112,85,255,193,50,66,1,93,16,52,255,8,105,134,0,12,109,72,255,58,156,251,0,144,35,204,0,44,160,117,254,50,107,194,0,1,68,165,255,111,110,162,0,158,83,40,254,76,214,234,0,58,216,205,255,171,96,147,255,40,227,114,1,176,227,241,0,70,249,183,1,136,84,139,255,60,122,247,254,143,9,117,255,177,174,137,254,73,247,143,0,236,185,126,255,62,25,247,255,45,64,56,255,161,244,6,0,34,57,56,1,105,202,83,0,128,147,208,0,6,103,10,255,74,138,65,255,97,80,100,255,214,174,33,255,50,134,74,255,110,151,130,254,111,84,172,0,84,199,75,254,248,59,112,255,8,216,178,1,9,183,95,0,238,27,8,254,170,205,220,0,195,229,135,0,98,76,237,255,226,91,26,1,82,219,39,255,225,190,199,1,217,200,121,255,81,179,8,255,140,65,206,0,178,207,87,254,250,252,46,255,104,89,110,1,253,189,158,255,144,214,158,255,160,245,54,255,53,183,92,1,21,200,194,255,146,33,113,1,209,1,255,0,235,106,43,255,167,52,232,0,157,229,221,0,51,30,25,0,250,221,27,1,65,147,87,255,79,123,196,0,65,196,223,255,76,44,17,1,85,241,68,0,202,183,249,255,65,212,212,255,9,33,154,1,71,59,80,0,175,194,59,255,141,72,9,0,100,160,244,0,230,208,56,0,59,25,75,254,80,194,194,0,18,3,200,254,160,159,115,0,132,143,247,1,111,93,57,255,58,237,11,1,134,222,135,255,122,163,108,1,123,43,190,255,251,189,206,254,80,182,72,255,208,246,224,1,17,60,9,0,161,207,38,0,141,109,91,0,216,15,211,255,136,78,110,0,98,163,104,255,21,80,121,255,173,178,183,1,127,143,4,0,104,60,82,254,214,16,13,255,96,238,33,1,158,148,230,255,127,129,62,255,51,255,210,255,62,141,236,254,157,55,224,255,114,39,244,0,192,188,250,255,228,76,53,0,98,84,81,255,173,203,61,254,147,50,55,255,204,235,191,0,52,197,244,0,88,43,211,254,27,191,119,0,188,231,154,0,66,81,161,0,92,193,160,1,250,227,120,0,123,55,226,0,184,17,72,0,133,168,10,254,22,135,156,255,41,25,103,255,48,202,58,0,186,149,81,255,188,134,239,0,235,181,189,254,217,139,188,255,74,48,82,0,46,218,229,0,189,253,251,0,50,229,12,255,211,141,191,1,128,244,25,255,169,231,122,254,86,47,189,255,132,183,23,255,37,178,150,255,51,137,253,0,200,78,31,0,22,105,50,0,130,60,0,0,132,163,91,254,23,231,187,0,192,79,239,0,157,102,164,255,192,82,20,1,24,181,103,255,240,9,234,0,1,123,164,255,133,233,0,255,202,242,242,0,60,186,245,0,241,16,199,255,224,116,158,254,191,125,91,255,224,86,207,0,121,37,231,255,227,9,198,255,15,153,239,255,121,232,217,254,75,112,82,0,95,12,57,254,51,214,105,255,148,220,97,1,199,98,36,0,156,209,12,254,10,212,52,0,217,180,55,254,212,170,232,255,216,20,84,255,157,250,135,0,157,99,127,254,1,206,41,0,149,36,70,1,54,196,201,255,87,116,0,254,235,171,150,0,27,163,234,0,202,135,180,0,208,95,0,254,123,156,93,0,183,62,75,0,137,235,182,0,204,225,255,255,214,139,210,255,2,115,8,255,29,12,111,0,52,156,1,0,253,21,251,255,37,165,31,254,12,130,211,0,106,18,53,254,42,99,154,0,14,217,61,254,216,11,92,255,200,197,112,254,147,38,199,0,36,252,120,254,107,169,77,0,1,123,159,255,207,75,102,0,163,175,196,0,44,1,240,0,120,186,176,254,13,98,76,255,237,124,241,255,232,146,188,255,200,96,224,0,204,31,41,0,208,200,13,0,21,225,96,255,175,156,196,0,247,208,126,0,62,184,244,254,2,171,81,0,85,115,158,0,54,64,45,255,19,138,114,0,135,71,205,0,227,47,147,1,218,231,66,0,253,209,28,0,244,15,173,255,6,15,118,254,16,150,208,255,185,22,50,255,86,112,207,255,75,113,215,1,63,146,43,255,4,225,19,254,227,23,62,255,14,255,214,254,45,8,205,255,87,197,151,254,210,82,215,255,245,248,247,255,128,248,70,0,225,247,87,0,90,120,70,0,213,245,92,0,13,133,226,0,47,181,5,1,92,163,105,255,6,30,133,254,232,178,61,255,230,149,24,255,18,49,158,0,228,100,61,254,116,243,251,255,77,75,92,1,81,219,147,255,76,163,254,254,141,213,246,0,232,37,152,254,97,44,100,0,201,37,50,1,212,244,57,0,174,171,183,255,249,74,112,0,166,156,30,0,222,221,97,255,243,93,73,254,251,101,100,255,216,217,93,255,254,138,187,255,142,190,52,255,59,203,177,255,200,94,52,0,115,114,158,255,165,152,104,1,126,99,226,255,118,157,244,1,107,200,16,0,193,90,229,0,121,6,88,0,156,32,93,254,125,241,211,255,14,237,157,255,165,154,21,255,184,224,22,255,250,24,152,255,113,77,31,0,247,171,23,255,237,177,204,255,52,137,145,255,194,182,114,0,224,234,149,0,10,111,103,1,201,129,4,0,238,142,78,0,52,6,40,255,110,213,165,254,60,207,253,0,62,215,69,0,96,97,0,255,49,45,202,0,120,121,22,255,235,139,48,1,198,45,34,255,182,50,27,1,131,210,91,255,46,54,128,0,175,123,105,255,198,141,78,254,67,244,239,255,245,54,103,254,78,38,242,255,2,92,249,254,251,174,87,255,139,63,144,0,24,108,27,255,34,102,18,1,34,22,152,0,66,229,118,254,50,143,99,0,144,169,149,1,118,30,152,0,178,8,121,1,8,159,18,0,90,101,230,255,129,29,119,0,68,36,11,1,232,183,55,0,23,255,96,255,161,41,193,255,63,139,222,0,15,179,243,0,255,100,15,255,82,53,135,0,137,57,149,1,99,240,170,255,22,230,228,254,49,180,82,255,61,82,43,0,110,245,217,0,199,125,61,0,46,253,52,0,141,197,219,0,211,159,193,0,55,121,105,254,183,20,129,0,169,119,170,255,203,178,139,255,135,40,182,255,172,13,202,255,65,178,148,0,8,207,43,0,122,53,127,1,74,161,48,0,227,214,128,254,86,11,243,255,100,86,7,1,245,68,134,255,61,43,21,1,152,84,94,255,190,60,250,254,239,118,232,255,214,136,37,1,113,76,107,255,93,104,100,1,144,206,23,255,110,150,154,1,228,103,185,0,218,49,50,254,135,77,139,255,185,1,78,0,0,161,148,255,97,29,233,255,207,148,149,255,160,168,0,0,91,128,171,255,6,28,19,254,11,111,247,0,39,187,150,255,138,232,149,0,117,62,68,255,63,216,188,255,235,234,32,254,29,57,160,255,25,12,241,1,169,60,191,0,32,131,141,255,237,159,123,255,94,197,94,254,116,254,3,255,92,179,97,254,121,97,92,255,170,112,14,0,21,149,248,0,248,227,3,0,80,96,109,0,75,192,74,1,12,90,226,255,161,106,68,1,208,114,127,255,114,42,255,254,74,26,74,255,247,179,150,254,121,140,60,0,147,70,200,255,214,40,161,255,161,188,201,255,141,65,135,255,242,115,252,0,62,47,202,0,180,149,255,254,130,55,237,0,165,17,186,255,10,169,194,0,156,109,218,255,112,140,123,255,104,128,223,254,177,142,108,255,121,37,219,255,128,77,18,255,111,108,23,1,91,192,75,0,174,245,22,255,4,236,62,255,43,64,153,1,227,173,254,0,237,122,132,1,127,89,186,255,142,82,128,254,252,84,174,0,90,179,177,1,243,214,87,255,103,60,162,255,208,130,14,255,11,130,139,0,206,129,219,255,94,217,157,255,239,230,230,255,116,115,159,254,164,107,95,0,51,218,2,1,216,125,198,255,140,202,128,254,11,95,68,255,55,9,93,254,174,153,6,255,204,172,96,0,69,160,110,0,213,38,49,254,27,80,213,0,118,125,114,0,70,70,67,255,15,142,73,255,131,122,185,255,243,20,50,254,130,237,40,0,210,159,140,1,197,151,65,255,84,153,66,0,195,126,90,0,16,238,236,1,118,187,102,255,3,24,133,255,187,69,230,0,56,197,92,1,213,69,94,255,80,138,229,1,206,7,230,0,222,111,230,1,91,233,119,255,9,89,7,1,2,98,1,0,148,74,133,255,51,246,180,255,228,177,112,1,58,189,108,255,194,203,237,254,21,209,195,0,147,10,35,1,86,157,226,0,31,163,139,254,56,7,75,255,62,90,116,0,181,60,169,0,138,162,212,254,81,167,31,0,205,90,112,255,33,112,227,0,83,151,117,1,177,224,73,255,174,144,217,255,230,204,79,255,22,77,232,255,114,78,234,0,224,57,126,254,9,49,141,0,242,147,165,1,104,182,140,255,167,132,12,1,123,68,127,0,225,87,39,1,251,108,8,0,198,193,143,1,121,135,207,255,172,22,70,0,50,68,116,255,101,175,40,255,248,105,233,0,166,203,7,0,110,197,218,0,215,254,26,254,168,226,253,0,31,143,96,0,11,103,41,0,183,129,203,254,100,247,74,255,213,126,132,0,210,147,44,0,199,234,27,1,148,47,181,0,155,91,158,1,54,105,175,255,2,78,145,254,102,154,95,0,128,207,127,254,52,124,236,255,130,84,71,0,221,243,211,0,152,170,207,0,222,106,199,0,183,84,94,254,92,200,56,255,138,182,115,1,142,96,146,0,133,136,228,0,97,18,150,0,55,251,66,0,140,102,4,0,202,103,151,0,30,19,248,255,51,184,207,0,202,198,89,0,55,197,225,254,169,95,249,255,66,65,68,255,188,234,126,0,166,223,100,1,112,239,244,0,144,23,194,0,58,39,182,0,244,44,24,254,175,68,179,255,152,118,154,1,176,162,130,0,217,114,204,254,173,126,78,255,33,222,30,255,36,2,91,255,2,143,243,0,9,235,215,0,3,171,151,1,24,215,245,255,168,47,164,254,241,146,207,0,69,129,180,0,68,243,113,0,144,53,72,254,251,45,14,0,23,110,168,0,68,68,79,255,110,70,95,254,174,91,144,255,33,206,95,255,137,41,7,255,19,187,153,254,35,255,112,255,9,145,185,254,50,157,37,0,11,112,49,1,102,8,190,255,234,243,169,1,60,85,23,0,74,39,189,0,116,49,239,0,173,213,210,0,46,161,108,255,159,150,37,0,196,120,185,255,34,98,6,255,153,195,62,255,97,230,71,255,102,61,76,0,26,212,236,255,164,97,16,0,198,59,146,0,163,23,196,0,56,24,61,0,181,98,193,0,251,147,229,255,98,189,24,255,46,54,206,255,234,82,246,0,183,103,38,1,109,62,204,0,10,240,224,0,146,22,117,255,142,154,120,0,69,212,35,0,208,99,118,1,121,255,3,255,72,6,194,0,117,17,197,255,125,15,23,0,154,79,153,0,214,94,197,255,185,55,147,255,62,254,78,254,127,82,153,0,110,102,63,255,108,82,161,255,105,187,212,1,80,138,39,0,60,255,93,255,72,12,186,0,210,251,31,1,190,167,144,255,228,44,19,254,128,67,232,0,214,249,107,254,136,145,86,255,132,46,176,0,189,187,227,255,208,22,140,0,217,211,116,0,50,81,186,254,139,250,31,0,30,64,198,1,135,155,100,0,160,206,23,254,187,162,211,255,16,188,63,0,254,208,49,0,85,84,191,0,241,192,242,255,153,126,145,1,234,162,162,255,230,97,216,1,64,135,126,0,190,148,223,1,52,0,43,255,28,39,189,1,64,136,238,0,175,196,185,0,98,226,213,255,127,159,244,1,226,175,60,0,160,233,142,1,180,243,207,255,69,152,89,1,31,101,21,0,144,25,164,254,139,191,209,0,91,25,121,0,32,147,5,0,39,186,123,255,63,115,230,255,93,167,198,255,143,213,220,255,179,156,19,255,25,66,122,0,214,160,217,255,2,45,62,255,106,79,146,254,51,137,99,255,87,100,231,255,175,145,232,255,101,184,1,255,174,9,125,0,82,37,161,1,36,114,141,255,48,222,142,255,245,186,154,0,5,174,221,254,63,114,155,255,135,55,160,1,80,31,135,0,126,250,179,1,236,218,45,0,20,28,145,1,16,147,73,0,249,189,132,1,17,189,192,255,223,142,198,255,72,20,15,255,250,53,237,254,15,11,18,0,27,211,113,254,213,107,56,255,174,147,146,255,96,126,48,0,23,193,109,1,37,162,94,0,199,157,249,254,24,128,187,255,205,49,178,254,93,164,42,255,43,119,235,1,88,183,237,255,218,210,1,255,107,254,42,0,230,10,99,255,162,0,226,0,219,237,91,0,129,178,203,0,208,50,95,254,206,208,95,255,247,191,89,254,110,234,79,255,165,61,243,0,20,122,112,255,246,246,185,254,103,4,123,0,233,99,230,1,219,91,252,255,199,222,22,255,179,245,233,255,211,241,234,0,111,250,192,255,85,84,136,0,101,58,50,255,131,173,156,254,119,45,51,255,118,233,16,254,242,90,214,0,94,159,219,1,3,3,234,255,98,76,92,254,80,54,230,0,5,228,231,254,53,24,223,255,113,56,118,1,20,132,1,255,171,210,236,0,56,241,158,255,186,115,19,255,8,229,174,0,48,44,0,1,114,114,166,255,6,73,226,255,205,89,244,0,137,227,75,1,248,173,56,0,74,120,246,254,119,3,11,255,81,120,198,255,136,122,98,255,146,241,221,1,109,194,78,255,223,241,70,1,214,200,169,255,97,190,47,255,47,103,174,255,99,92,72,254,118,233,180,255,193,35,233,254,26,229,32,255,222,252,198,0,204,43,71,255,199,84,172,0,134,102,190,0,111,238,97,254,230,40,230,0,227,205,64,254,200,12,225,0,166,25,222,0,113,69,51,255,143,159,24,0,167,184,74,0,29,224,116,254,158,208,233,0,193,116,126,255,212,11,133,255,22,58,140,1,204,36,51,255,232,30,43,0,235,70,181,255,64,56,146,254,169,18,84,255,226,1,13,255,200,50,176,255,52,213,245,254,168,209,97,0,191,71,55,0,34,78,156,0,232,144,58,1,185,74,189,0,186,142,149,254,64,69,127,255,161,203,147,255,176,151,191,0,136,231,203,254,163,182,137,0,161,126,251,254,233,32,66,0,68,207,66,0,30,28,37,0,93,114,96,1,254,92,247,255,44,171,69,0,202,119,11,255,188,118,50,1,255,83,136,255,71,82,26,0,70,227,2,0,32,235,121,1,181,41,154,0,71,134,229,254,202,255,36,0,41,152,5,0,154,63,73,255,34,182,124,0,121,221,150,255,26,204,213,1,41,172,87,0,90,157,146,255,109,130,20,0,71,107,200,255,243,102,189,0,1,195,145,254,46,88,117,0,8,206,227,0,191,110,253,255,109,128,20,254,134,85,51,255,137,177,112,1,216,34,22,255,131,16,208,255,121,149,170,0,114,19,23,1,166,80,31,255,113,240,122,0,232,179,250,0,68,110,180,254,210,170,119,0,223,108,164,255,207,79,233,255,27,229,226,254,209,98,81,255,79,68,7,0,131,185,100,0,170,29,162,255,17,162,107,255,57,21,11,1,100,200,181,255,127,65,166,1,165,134,204,0,104,167,168,0,1,164,79,0,146,135,59,1,70,50,128,255,102,119,13,254,227,6,135,0,162,142,179,255,160,100,222,0,27,224,219,1,158,93,195,255,234,141,137,0,16,24,125,255,238,206,47,255,97,17,98,255,116,110,12,255,96,115,77,0,91,227,232,255,248,254,79,255,92,229,6,254,88,198,139,0,206,75,129,0,250,77,206,255,141,244,123,1,138,69,220,0,32,151,6,1,131,167,22,255,237,68,167,254,199,189,150,0,163,171,138,255,51,188,6,255,95,29,137,254,148,226,179,0,181,107,208,255,134,31,82,255,151,101,45,255,129,202,225,0,224,72,147,0,48,138,151,255,195,64,206,254,237,218,158,0,106,29,137,254,253,189,233,255,103,15,17,255,194,97,255,0,178,45,169,254,198,225,155,0,39,48,117,255,135,106,115,0,97,38,181,0,150,47,65,255,83,130,229,254,246,38,129,0,92,239,154,254,91,99,127,0,161,111,33,255,238,217,242,255,131,185,195,255,213,191,158,255,41,150,218,0,132,169,131,0,89,84,252,1,171,70,128,255,163,248,203,254,1,50,180,255,124,76,85,1,251,111,80,0,99,66,239,255,154,237,182,255,221,126,133,254,74,204,99,255,65,147,119,255,99,56,167,255,79,248,149,255,116,155,228,255,237,43,14,254,69,137,11,255,22,250,241,1,91,122,143,255,205,249,243,0,212,26,60,255,48,182,176,1,48,23,191,255,203,121,152,254,45,74,213,255,62,90,18,254,245,163,230,255,185,106,116,255,83,35,159,0,12,33,2,255,80,34,62,0,16,87,174,255,173,101,85,0,202,36,81,254,160,69,204,255,64,225,187,0,58,206,94,0,86,144,47,0,229,86,245,0,63,145,190,1,37,5,39,0,109,251,26,0,137,147,234,0,162,121,145,255,144,116,206,255,197,232,185,255,183,190,140,255,73,12,254,255,139,20,242,255,170,90,239,255,97,66,187,255,245,181,135,254,222,136,52,0,245,5,51,254,203,47,78,0,152,101,216,0,73,23,125,0,254,96,33,1,235,210,73,255,43,209,88,1,7,129,109,0,122,104,228,254,170,242,203,0,242,204,135,255,202,28,233,255,65,6,127,0,159,144,71,0,100,140,95,0,78,150,13,0,251,107,118,1,182,58,125,255,1,38,108,255,141,189,209,255,8,155,125,1,113,163,91,255,121,79,190,255,134,239,108,255,76,47,248,0,163,228,239,0,17,111,10,0,88,149,75,255,215,235,239,0,167,159,24,255,47,151,108,255,107,209,188,0,233,231,99,254,28,202,148,255,174,35,138,255,110,24,68,255,2,69,181,0,107,102,82,0,102,237,7,0,92,36,237,255,221,162,83,1,55,202,6,255,135,234,135,255,24,250,222,0,65,94,168,254,245,248,210,255,167,108,201,254,255,161,111,0,205,8,254,0,136,13,116,0,100,176,132,255,43,215,126,255,177,133,130,255,158,79,148,0,67,224,37,1,12,206,21,255,62,34,110,1,237,104,175,255,80,132,111,255,142,174,72,0,84,229,180,254,105,179,140,0,64,248,15,255,233,138,16,0,245,67,123,254,218,121,212,255,63,95,218,1,213,133,137,255,143,182,82,255,48,28,11,0,244,114,141,1,209,175,76,255],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+20480);allocate([157,181,150,255,186,229,3,255,164,157,111,1,231,189,139,0,119,202,190,255,218,106,64,255,68,235,63,254,96,26,172,255,187,47,11,1,215,18,251,255,81,84,89,0,68,58,128,0,94,113,5,1,92,129,208,255,97,15,83,254,9,28,188,0,239,9,164,0,60,205,152,0,192,163,98,255,184,18,60,0,217,182,139,0,109,59,120,255,4,192,251,0,169,210,240,255,37,172,92,254,148,211,245,255,179,65,52,0,253,13,115,0,185,174,206,1,114,188,149,255,237,90,173,0,43,199,192,255,88,108,113,0,52,35,76,0,66,25,148,255,221,4,7,255,151,241,114,255,190,209,232,0,98,50,199,0,151,150,213,255,18,74,36,1,53,40,7,0,19,135,65,255,26,172,69,0,174,237,85,0,99,95,41,0,3,56,16,0,39,160,177,255,200,106,218,254,185,68,84,255,91,186,61,254,67,143,141,255,13,244,166,255,99,114,198,0,199,110,163,255,193,18,186,0,124,239,246,1,110,68,22,0,2,235,46,1,212,60,107,0,105,42,105,1,14,230,152,0,7,5,131,0,141,104,154,255,213,3,6,0,131,228,162,255,179,100,28,1,231,123,85,255,206,14,223,1,253,96,230,0,38,152,149,1,98,137,122,0,214,205,3,255,226,152,179,255,6,133,137,0,158,69,140,255,113,162,154,255,180,243,172,255,27,189,115,255,143,46,220,255,213,134,225,255,126,29,69,0,188,43,137,1,242,70,9,0,90,204,255,255,231,170,147,0,23,56,19,254,56,125,157,255,48,179,218,255,79,182,253,255,38,212,191,1,41,235,124,0,96,151,28,0,135,148,190,0,205,249,39,254,52,96,136,255,212,44,136,255,67,209,131,255,252,130,23,255,219,128,20,255,198,129,118,0,108,101,11,0,178,5,146,1,62,7,100,255,181,236,94,254,28,26,164,0,76,22,112,255,120,102,79,0,202,192,229,1,200,176,215,0,41,64,244,255,206,184,78,0,167,45,63,1,160,35,0,255,59,12,142,255,204,9,144,255,219,94,229,1,122,27,112,0,189,105,109,255,64,208,74,255,251,127,55,1,2,226,198,0,44,76,209,0,151,152,77,255,210,23,46,1,201,171,69,255,44,211,231,0,190,37,224,255,245,196,62,255,169,181,222,255,34,211,17,0,119,241,197,255,229,35,152,1,21,69,40,255,178,226,161,0,148,179,193,0,219,194,254,1,40,206,51,255,231,92,250,1,67,153,170,0,21,148,241,0,170,69,82,255,121,18,231,255,92,114,3,0,184,62,230,0,225,201,87,255,146,96,162,255,181,242,220,0,173,187,221,1,226,62,170,255,56,126,217,1,117,13,227,255,179,44,239,0,157,141,155,255,144,221,83,0,235,209,208,0,42,17,165,1,251,81,133,0,124,245,201,254,97,211,24,255,83,214,166,0,154,36,9,255,248,47,127,0,90,219,140,255,161,217,38,254,212,147,63,255,66,84,148,1,207,3,1,0,230,134,89,1,127,78,122,255,224,155,1,255,82,136,74,0,178,156,208,255,186,25,49,255,222,3,210,1,229,150,190,255,85,162,52,255,41,84,141,255,73,123,84,254,93,17,150,0,119,19,28,1,32,22,215,255,28,23,204,255,142,241,52,255,228,52,125,0,29,76,207,0,215,167,250,254,175,164,230,0,55,207,105,1,109,187,245,255,161,44,220,1,41,101,128,255,167,16,94,0,93,214,107,255,118,72,0,254,80,61,234,255,121,175,125,0,139,169,251,0,97,39,147,254,250,196,49,255,165,179,110,254,223,70,187,255,22,142,125,1,154,179,138,255,118,176,42,1,10,174,153,0,156,92,102,0,168,13,161,255,143,16,32,0,250,197,180,255,203,163,44,1,87,32,36,0,161,153,20,255,123,252,15,0,25,227,80,0,60,88,142,0,17,22,201,1,154,205,77,255,39,63,47,0,8,122,141,0,128,23,182,254,204,39,19,255,4,112,29,255,23,36,140,255,210,234,116,254,53,50,63,255,121,171,104,255,160,219,94,0,87,82,14,254,231,42,5,0,165,139,127,254,86,78,38,0,130,60,66,254,203,30,45,255,46,196,122,1,249,53,162,255,136,143,103,254,215,210,114,0,231,7,160,254,169,152,42,255,111,45,246,0,142,131,135,255,131,71,204,255,36,226,11,0,0,28,242,255,225,138,213,255,247,46,216,254,245,3,183,0,108,252,74,1,206,26,48,255,205,54,246,255,211,198,36,255,121,35,50,0,52,216,202,255,38,139,129,254,242,73,148,0,67,231,141,255,42,47,204,0,78,116,25,1,4,225,191,255,6,147,228,0,58,88,177,0,122,165,229,255,252,83,201,255,224,167,96,1,177,184,158,255,242,105,179,1,248,198,240,0,133,66,203,1,254,36,47,0,45,24,115,255,119,62,254,0,196,225,186,254,123,141,172,0,26,85,41,255,226,111,183,0,213,231,151,0,4,59,7,255,238,138,148,0,66,147,33,255,31,246,141,255,209,141,116,255,104,112,31,0,88,161,172,0,83,215,230,254,47,111,151,0,45,38,52,1,132,45,204,0,138,128,109,254,233,117,134,255,243,190,173,254,241,236,240,0,82,127,236,254,40,223,161,255,110,182,225,255,123,174,239,0,135,242,145,1,51,209,154,0,150,3,115,254,217,164,252,255,55,156,69,1,84,94,255,255,232,73,45,1,20,19,212,255,96,197,59,254,96,251,33,0,38,199,73,1,64,172,247,255,117,116,56,255,228,17,18,0,62,138,103,1,246,229,164,255,244,118,201,254,86,32,159,255,109,34,137,1,85,211,186,0,10,193,193,254,122,194,177,0,122,238,102,255,162,218,171,0,108,217,161,1,158,170,34,0,176,47,155,1,181,228,11,255,8,156,0,0,16,75,93,0,206,98,255,1,58,154,35,0,12,243,184,254,67,117,66,255,230,229,123,0,201,42,110,0,134,228,178,254,186,108,118,255,58,19,154,255,82,169,62,255,114,143,115,1,239,196,50,255,173,48,193,255,147,2,84,255,150,134,147,254,95,232,73,0,109,227,52,254,191,137,10,0,40,204,30,254,76,52,97,255,164,235,126,0,254,124,188,0,74,182,21,1,121,29,35,255,241,30,7,254,85,218,214,255,7,84,150,254,81,27,117,255,160,159,152,254,66,24,221,255,227,10,60,1,141,135,102,0,208,189,150,1,117,179,92,0,132,22,136,255,120,199,28,0,21,129,79,254,182,9,65,0,218,163,169,0,246,147,198,255,107,38,144,1,78,175,205,255,214,5,250,254,47,88,29,255,164,47,204,255,43,55,6,255,131,134,207,254,116,100,214,0,96,140,75,1,106,220,144,0,195,32,28,1,172,81,5,255,199,179,52,255,37,84,203,0,170,112,174,0,11,4,91,0,69,244,27,1,117,131,92,0,33,152,175,255,140,153,107,255,251,135,43,254,87,138,4,255,198,234,147,254,121,152,84,255,205,101,155,1,157,9,25,0,72,106,17,254,108,153,0,255,189,229,186,0,193,8,176,255,174,149,209,0,238,130,29,0,233,214,126,1,61,226,102,0,57,163,4,1,198,111,51,255,45,79,78,1,115,210,10,255,218,9,25,255,158,139,198,255,211,82,187,254,80,133,83,0,157,129,230,1,243,133,134,255,40,136,16,0,77,107,79,255,183,85,92,1,177,204,202,0,163,71,147,255,152,69,190,0,172,51,188,1,250,210,172,255,211,242,113,1,89,89,26,255,64,66,111,254,116,152,42,0,161,39,27,255,54,80,254,0,106,209,115,1,103,124,97,0,221,230,98,255,31,231,6,0,178,192,120,254,15,217,203,255,124,158,79,0,112,145,247,0,92,250,48,1,163,181,193,255,37,47,142,254,144,189,165,255,46,146,240,0,6,75,128,0,41,157,200,254,87,121,213,0,1,113,236,0,5,45,250,0,144,12,82,0,31,108,231,0,225,239,119,255,167,7,189,255,187,228,132,255,110,189,34,0,94,44,204,1,162,52,197,0,78,188,241,254,57,20,141,0,244,146,47,1,206,100,51,0,125,107,148,254,27,195,77,0,152,253,90,1,7,143,144,255,51,37,31,0,34,119,38,255,7,197,118,0,153,188,211,0,151,20,116,254,245,65,52,255,180,253,110,1,47,177,209,0,161,99,17,255,118,222,202,0,125,179,252,1,123,54,126,255,145,57,191,0,55,186,121,0,10,243,138,0,205,211,229,255,125,156,241,254,148,156,185,255,227,19,188,255,124,41,32,255,31,34,206,254,17,57,83,0,204,22,37,255,42,96,98,0,119,102,184,1,3,190,28,0,110,82,218,255,200,204,192,255,201,145,118,0,117,204,146,0,132,32,98,1,192,194,121,0,106,161,248,1,237,88,124,0,23,212,26,0,205,171,90,255,248,48,216,1,141,37,230,255,124,203,0,254,158,168,30,255,214,248,21,0,112,187,7,255,75,133,239,255,74,227,243,255,250,147,70,0,214,120,162,0,167,9,179,255,22,158,18,0,218,77,209,1,97,109,81,255,244,33,179,255,57,52,57,255,65,172,210,255,249,71,209,255,142,169,238,0,158,189,153,255,174,254,103,254,98,33,14,0,141,76,230,255,113,139,52,255,15,58,212,0,168,215,201,255,248,204,215,1,223,68,160,255,57,154,183,254,47,231,121,0,106,166,137,0,81,136,138,0,165,43,51,0,231,139,61,0,57,95,59,254,118,98,25,255,151,63,236,1,94,190,250,255,169,185,114,1,5,250,58,255,75,105,97,1,215,223,134,0,113,99,163,1,128,62,112,0,99,106,147,0,163,195,10,0,33,205,182,0,214,14,174,255,129,38,231,255,53,182,223,0,98,42,159,255,247,13,40,0,188,210,177,1,6,21,0,255,255,61,148,254,137,45,129,255,89,26,116,254,126,38,114,0,251,50,242,254,121,134,128,255,204,249,167,254,165,235,215,0,202,177,243,0,133,141,62,0,240,130,190,1,110,175,255,0,0,20,146,1,37,210,121,255,7,39,130,0,142,250,84,255,141,200,207,0,9,95,104,255,11,244,174,0,134,232,126,0,167,1,123,254,16,193,149,255,232,233,239,1,213,70,112,255,252,116,160,254,242,222,220,255,205,85,227,0,7,185,58,0,118,247,63,1,116,77,177,255,62,245,200,254,63,18,37,255,107,53,232,254,50,221,211,0,162,219,7,254,2,94,43,0,182,62,182,254,160,78,200,255,135,140,170,0,235,184,228,0,175,53,138,254,80,58,77,255,152,201,2,1,63,196,34,0,5,30,184,0,171,176,154,0,121,59,206,0,38,99,39,0,172,80,77,254,0,134,151,0,186,33,241,254,94,253,223,255,44,114,252,0,108,126,57,255,201,40,13,255,39,229,27,255,39,239,23,1,151,121,51,255,153,150,248,0,10,234,174,255,118,246,4,254,200,245,38,0,69,161,242,1,16,178,150,0,113,56,130,0,171,31,105,0,26,88,108,255,49,42,106,0,251,169,66,0,69,93,149,0,20,57,254,0,164,25,111,0,90,188,90,255,204,4,197,0,40,213,50,1,212,96,132,255,88,138,180,254,228,146,124,255,184,246,247,0,65,117,86,255,253,102,210,254,254,121,36,0,137,115,3,255,60,24,216,0,134,18,29,0,59,226,97,0,176,142,71,0,7,209,161,0,189,84,51,254,155,250,72,0,213,84,235,255,45,222,224,0,238,148,143,255,170,42,53,255,78,167,117,0,186,0,40,255,125,177,103,255,69,225,66,0,227,7,88,1,75,172,6,0,169,45,227,1,16,36,70,255,50,2,9,255,139,193,22,0,143,183,231,254,218,69,50,0,236,56,161,1,213,131,42,0,138,145,44,254,136,229,40,255,49,63,35,255,61,145,245,255,101,192,2,254,232,167,113,0,152,104,38,1,121,185,218,0,121,139,211,254,119,240,35,0,65,189,217,254,187,179,162,255,160,187,230,0,62,248,14,255,60,78,97,0,255,247,163,255,225,59,91,255,107,71,58,255,241,47,33,1,50,117,236,0,219,177,63,254,244,90,179,0,35,194,215,255,189,67,50,255,23,135,129,0,104,189,37,255,185,57,194,0,35,62,231,255,220,248,108,0,12,231,178,0,143,80,91,1,131,93,101,255,144,39,2,1,255,250,178,0,5,17,236,254,139,32,46,0,204,188,38,254,245,115,52,255,191,113,73,254,191,108,69,255,22,69,245,1,23,203,178,0,170,99,170,0,65,248,111,0,37,108,153,255,64,37,69,0,0,88,62,254,89,148,144,255,191,68,224,1,241,39,53,0,41,203,237,255,145,126,194,255,221,42,253,255,25,99,151,0,97,253,223,1,74,115,49,255,6,175,72,255,59,176,203,0,124,183,249,1,228,228,99,0,129,12,207,254,168,192,195,255,204,176,16,254,152,234,171,0,77,37,85,255,33,120,135,255,142,194,227,1,31,214,58,0,213,187,125,255,232,46,60,255,190,116,42,254,151,178,19,255,51,62,237,254,204,236,193,0,194,232,60,0,172,34,157,255,189,16,184,254,103,3,95,255,141,233,36,254,41,25,11,255,21,195,166,0,118,245,45,0,67,213,149,255,159,12,18,255,187,164,227,1,160,25,5,0,12,78,195,1,43,197,225,0,48,142,41,254,196,155,60,255,223,199,18,1,145,136,156,0,252,117,169,254,145,226,238,0,239,23,107,0,109,181,188,255,230,112,49,254,73,170,237,255,231,183,227,255,80,220,20,0,194,107,127,1,127,205,101,0,46,52,197,1,210,171,36,255,88,3,90,255,56,151,141,0,96,187,255,255,42,78,200,0,254,70,70,1,244,125,168,0,204,68,138,1,124,215,70,0,102,66,200,254,17,52,228,0,117,220,143,254,203,248,123,0,56,18,174,255,186,151,164,255,51,232,208,1,160,228,43,255,249,29,25,1,68,190,63,0,103,230,9,106,133,174,103,187,114,243,110,60,58,245,79,165,127,82,14,81,140,104,5,155,171,217,131,31,25,205,224,91,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,5,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,19,0,0,0,76,212,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,19,0,0,0,84,212,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,0,0,0,19,0,0,0,92,216,0,0,0,4,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+30720);allocate([1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5,0,0,0,0,224,1,0,0,18,0,0,0,19,0,0,0,0,0,0,0,248,1,0,0,20,0,0,0,21,0,0,0,18,0,0,0,23,0,0,0,18,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,24,0,0,0,21,0,0,0,22,0,0,0,18,0,0,0,25,0,0,0,19,0,0,0,0,0,0,0,0,2,0,0,22,0,0,0,23,0,0,0,19,0,0,0,26,0,0,0,19,0,0,0,19,0,0,0,23,0,0,0,24,0,0,0,27,0,0,0,25,0,0,0,26,0,0,0,20,0,0,0,28,0,0,0,21,0,0,0,8,0,0,0,0,0,0,0,8,2,0,0,24,0,0,0,25,0,0,0,248,255,255,255,248,255,255,255,8,2,0,0,26,0,0,0,27,0,0,0,8,0,0,0,0,0,0,0,32,2,0,0,28,0,0,0,29,0,0,0,248,255,255,255,248,255,255,255,32,2,0,0,30,0,0,0,31,0,0,0,4,0,0,0,0,0,0,0,56,2,0,0,32,0,0,0,33,0,0,0,252,255,255,255,252,255,255,255,56,2,0,0,34,0,0,0,35,0,0,0,4,0,0,0,0,0,0,0,80,2,0,0,36,0,0,0,37,0,0,0,252,255,255,255,252,255,255,255,80,2,0,0,38,0,0,0,39,0,0,0,0,0,0,0,104,2,0,0,40,0,0,0,41,0,0,0,27,0,0,0,0,0,0,0,120,2,0,0,42,0,0,0,43,0,0,0,28,0,0,0,18,0,0,0,29,0,0,0,30,0,0,0,19,0,0,0,0,0,0,0,136,2,0,0,20,0,0,0,44,0,0,0,20,0,0,0,23,0,0,0,18,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,24,0,0,0,29,0,0,0,30,0,0,0,22,0,0,0,25,0,0,0,19,0,0,0,0,0,0,0,152,2,0,0,22,0,0,0,45,0,0,0,21,0,0,0,26,0,0,0,19,0,0,0,19,0,0,0,23,0,0,0,24,0,0,0,27,0,0,0,31,0,0,0,32,0,0,0,23,0,0,0,28,0,0,0,21,0,0,0,0,0,0,0,168,2,0,0,20,0,0,0,46,0,0,0,22,0,0,0,23,0,0,0,18,0,0,0,18,0,0,0,33,0,0,0,20,0,0,0,24,0,0,0,21,0,0,0,22,0,0,0,18,0,0,0,31,0,0,0,24,0,0,0,0,0,0,0,184,2,0,0,22,0,0,0,47,0,0,0,23,0,0,0,26,0,0,0,19,0,0,0,19,0,0,0,34,0,0,0,24,0,0,0,27,0,0,0,25,0,0,0,26,0,0,0,20,0,0,0,32,0,0,0,25,0,0,0,0,0,0,0,200,2,0,0,48,0,0,0,49,0,0,0,50,0,0,0,18,0,0,0,20,0,0,0,33,0,0,0,0,0,0,0,232,2,0,0,51,0,0,0,52,0,0,0,50,0,0,0,19,0,0,0,21,0,0,0,34,0,0,0,0,0,0,0,248,2,0,0,53,0,0,0,54,0,0,0,50,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,56,3,0,0,55,0,0,0,56,0,0,0,50,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,0,0,0,0,112,3,0,0,57,0,0,0,58,0,0,0,50,0,0,0,20,0,0,0,21,0,0,0,40,0,0,0,22,0,0,0,41,0,0,0,18,0,0,0,19,0,0,0,23,0,0,0,0,0,0,0,176,3,0,0,59,0,0,0,60,0,0,0,50,0,0,0,24,0,0,0,25,0,0,0,42,0,0,0,26,0,0,0,43,0,0,0,20,0,0,0,21,0,0,0,27,0,0,0,0,0,0,0,232,3,0,0,61,0,0,0,62,0,0,0,50,0,0,0,35,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,18,0,0,0,248,255,255,255,232,3,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,0,0,0,0,32,4,0,0,63,0,0,0,64,0,0,0,50,0,0,0,43,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,19,0,0,0,248,255,255,255,32,4,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,80,4,0,0,65,0,0,0,66,0,0,0,50,0,0,0,18,0,0,0,0,0,0,0,120,4,0,0,67,0,0,0,68,0,0,0,50,0,0,0,19,0,0,0,0,0,0,0,152,4,0,0,69,0,0,0,70,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,53,0,0,0,28,0,0,0,29,0,0,0,0,0,0,0,192,4,0,0,71,0,0,0,72,0,0,0,50,0,0,0,54,0,0,0,55,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,56,0,0,0,34,0,0,0,35,0,0,0,0,0,0,0,224,4,0,0,73,0,0,0,74,0,0,0,50,0,0,0,57,0,0,0,58,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,59,0,0,0,40,0,0,0,41,0,0,0,0,0,0,0,0,5,0,0,75,0,0,0,76,0,0,0,50,0,0,0,60,0,0,0,61,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,62,0,0,0,46,0,0,0,47,0,0,0,0,0,0,0,32,5,0,0,77,0,0,0,78,0,0,0,50,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,72,5,0,0,79,0,0,0,80,0,0,0,50,0,0,0,22,0,0,0,23,0,0,0,0,0,0,0,112,5,0,0,81,0,0,0,82,0,0,0,50,0,0,0,18,0,0,0,54,0,0,0,0,0,0,0,152,5,0,0,83,0,0,0,84,0,0,0,50,0,0,0,19,0,0,0,55,0,0,0,0,0,0,0,192,5,0,0,85,0,0,0,86,0,0,0,50,0,0,0,35,0,0,0,20,0,0,0,48,0,0,0,0,0,0,0,232,5,0,0,87,0,0,0,88,0,0,0,50,0,0,0,36,0,0,0,21,0,0,0,49,0,0,0,0,0,0,0,8,6,0,0,89,0,0,0,90,0,0,0,50,0,0,0,20,0,0,0,21,0,0,0,28,0,0,0,63,0,0,0,64,0,0,0,29,0,0,0,65,0,0,0,0,0,0,0,64,6,0,0,89,0,0,0,91,0,0,0,50,0,0,0,20,0,0,0,21,0,0,0,28,0,0,0,63,0,0,0,64,0,0,0,29,0,0,0,65,0,0,0,0,0,0,0,112,6,0,0,92,0,0,0,93,0,0,0,50,0,0,0,22,0,0,0,23,0,0,0,30,0,0,0,66,0,0,0,67,0,0,0,31,0,0,0,68,0,0,0,0,0,0,0,176,6,0,0,94,0,0,0,95,0,0,0,50,0,0,0,0,0,0,0,192,6,0,0,96,0,0,0,97,0,0,0,50,0,0,0,26,0,0,0,37,0,0,0,27,0,0,0,38,0,0,0,28,0,0,0,18,0,0,0,39,0,0,0,32,0,0,0,0,0,0,0,8,7,0,0,98,0,0,0,99,0,0,0,50,0,0,0,69,0,0,0,70,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,0,0,0,0,24,7,0,0,100,0,0,0,101,0,0,0,50,0,0,0,71,0,0,0,72,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,216,2,0,0,89,0,0,0,102,0,0,0,50,0,0,0,0,0,0,0,232,6,0,0,89,0,0,0,103,0,0,0,50,0,0,0,40,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,29,0,0,0,41,0,0,0,30,0,0,0,42,0,0,0,31,0,0,0,22,0,0,0,43,0,0,0,33,0,0,0,0,0,0,0,80,6,0,0,89,0,0,0,104,0,0,0,50,0,0,0,24,0,0,0,25,0,0,0,34,0,0,0,73,0,0,0,74,0,0,0,35,0,0,0,75,0,0,0,0,0,0,0,144,6,0,0,89,0,0,0,105,0,0,0,50,0,0,0,26,0,0,0,27,0,0,0,36,0,0,0,76,0,0,0,77,0,0,0,37,0,0,0,78,0,0,0,0,0,0,0,24,6,0,0,89,0,0,0,106,0,0,0,50,0,0,0,20,0,0,0,21,0,0,0,28,0,0,0,63,0,0,0,64,0,0,0,29,0,0,0,65,0,0,0,0,0,0,0,56,7,0,0,107,0,0,0,108,0,0,0,27,0,0,0,18,0,0,0,0,0,0,0,96,7,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,44,0,0,0,22,0,0,0,18,0,0,0,22,0,0,0,0,0,0,0,112,7,0,0,109,0,0,0,113,0,0,0,111,0,0,0,112,0,0,0,44,0,0,0,23,0,0,0,19,0,0,0,23,0,0,0,0,0,0,0,152,7,0,0,114,0,0,0,115,0,0,0,79,0,0,0,0,0,0,0,168,7,0,0,116,0,0,0,117,0,0,0,80,0,0,0,0,0,0,0,184,7,0,0,118,0,0,0,119,0,0,0,27,0,0,0,0,0,0,0,200,7,0,0,116,0,0,0,120,0,0,0,80,0,0,0,0,0,0,0,216,7,0,0,121,0,0,0,122,0,0,0,81,0,0,0,0,0,0,0,232,7,0,0,109,0,0,0,123,0,0,0,111,0,0,0,112,0,0,0,44,0,0,0,24,0,0,0,20,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,3,32,2,32,2,32,2,32,2,32,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,1,96,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,4,192,4,192,4,192,4,192,4,192,4,192,4,192,8,213,8,213,8,213,8,213,8,213,8,213,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,4,192,4,192,4,192,4,192,4,192,4,192,8,214,8,214,8,214,8,214,8,214,8,214,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,4,192,4,192,4,192,4,192,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,99,117,114,118,101,50,53,53,49,57,120,115,97,108,115,97,50,48,112,111,108,121,49,51,48,53,0,98,108,97,107,101,50,98,0,83,45,62,98,117,102,108,101,110,32,60,61,32,66,76,65,75,69,50,66,95,66,76,79,67,75,66,89,84,69,83,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,47,98,108,97,107,101,50,47,114,101,102,47,98,108,97,107,101,50,98,45,114,101,102,46,99,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,95,98,108,97,107,101,50,98,95,95,102,105,110,97,108,0,111,117,116,108,101,110,32,60,61,32,85,73,78,84,56,95,77,65,88,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,47,98,108,97,107,101,50,47,114,101,102,47,103,101,110,101,114,105,99,104,97,115,104,95,98,108,97,107,101,50,98,46,99,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,95,98,108,97,107,101,50,98,0,107,101,121,108,101,110,32,60,61,32,85,73,78,84,56,95,77,65,88,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,95,98,108,97,107,101,50,98,95,115,97,108,116,95,112,101,114,115,111,110,97,108,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,95,98,108,97,107,101,50,98,95,105,110,105,116,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,95,98,108,97,107,101,50,98,95,105,110,105,116,95,115,97,108,116,95,112,101,114,115,111,110,97,108,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,95,98,108,97,107,101,50,98,95,102,105,110,97,108,0,115,104,97,53,49,50,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,111,108,121,49,51,48,53,0,36,97,114,103,111,110,50,105,0,36,118,61,0,36,109,61,0,44,116,61,0,44,112,61,0,44,100,97,116,97,61,0,36,97,114,103,111,110,50,105,36,118,61,0,36,97,114,103,111,110,50,105,36,0,97,114,103,111,110,50,105,0,46,47,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,0,36,55,36,0,99,117,114,118,101,50,53,53,49,57,0,120,115,97,108,115,97,50,48,112,111,108,121,49,51,48,53,0,115,105,112,104,97,115,104,50,52,0,101,100,50,53,53,49,57,0,237,211,245,92,26,99,18,88,214,156,247,162,222,249,222,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,120,115,97,108,115,97,50,48,0,106,115,0,123,32,114,101,116,117,114,110,32,77,111,100,117,108,101,46,103,101,116,82,97,110,100,111,109,86,97,108,117,101,40,41,59,32,125,0,123,32,105,102,32,40,77,111,100,117,108,101,46,103,101,116,82,97,110,100,111,109,86,97,108,117,101,32,61,61,61,32,117,110,100,101,102,105,110,101,100,41,32,123,32,116,114,121,32,123,32,118,97,114,32,119,105,110,100,111,119,95,32,61,32,34,111,98,106,101,99,116,34,32,61,61,61,32,116,121,112,101,111,102,32,119,105,110,100,111,119,32,63,32,119,105,110,100,111,119,32,58,32,115,101,108,102,44,32,99,114,121,112,116,111,95,32,61,32,116,121,112,101,111,102,32,119,105,110,100,111,119,95,46,99,114,121,112,116,111,32,33,61,61,32,34,117,110,100,101,102,105,110,101,100,34,32,63,32,119,105,110,100,111,119,95,46,99,114,121,112,116,111,32,58,32,119,105,110,100,111,119,95,46,109,115,67,114,121,112,116,111,44,32,114,97,110,100,111,109,86,97,108,117,101,115,83,116,97,110,100,97,114,100,32,61,32,102,117,110,99,116,105,111,110,40,41,32,123,32,118,97,114,32,98,117,102,32,61,32,110,101,119,32,85,105,110,116,51,50,65,114,114,97,121,40,49,41,59,32,99,114,121,112,116,111,95,46,103,101,116,82,97,110,100,111,109,86,97,108,117,101,115,40,98,117,102,41,59,32,114,101,116,117,114,110,32,98,117,102,91,48,93,32,62,62,62,32,48,59,32,125,59,32,114,97,110,100,111,109,86,97,108,117,101,115,83,116,97,110,100,97,114,100,40,41,59,32,77,111,100,117,108,101,46,103,101,116,82,97,110,100,111,109,86,97,108,117,101,32,61,32,114,97,110,100,111,109,86,97,108,117,101,115,83,116,97,110,100,97,114,100,59,32,125,32,99,97,116,99,104,32,40,101,41,32,123,32,116,114,121,32,123,32,118,97,114,32,99,114,121,112,116,111,32,61,32,114,101,113,117,105,114,101,40,39,99,114,121,112,116,111,39,41,44,32,114,97,110,100,111,109,86,97,108,117,101,78,111,100,101,74,83,32,61,32,102,117,110,99,116,105,111,110,40,41,32,123,32,118,97,114,32,98,117,102,32,61,32,99,114,121,112,116,111,46,114,97,110,100,111,109,66,121,116,101,115,40,52,41,59,32,114,101,116,117,114,110,32,40,98,117,102,91,48,93,32,60,60,32,50,52,32,124,32,98,117,102,91,49,93,32,60,60,32,49,54,32,124,32,98,117,102,91,50,93,32,60,60,32,56,32,124,32,98,117,102,91,51,93,41,32,62,62,62,32,48,59,32,125,59,32,114,97,110,100,111,109,86,97,108,117,101,78,111,100,101,74,83,40,41,59,32,77,111,100,117,108,101,46,103,101,116,82,97,110,100,111,109,86,97,108,117,101,32,61,32,114,97,110,100,111,109,86,97,108,117,101,78,111,100,101,74,83,59,32,125,32,99,97,116,99,104,32,40,101,41,32,123,32,116,104,114,111,119,32,39,78,111,32,115,101,99,117,114,101,32,114,97,110,100,111,109,32,110,117,109,98,101,114,32,103,101,110,101,114,97,116,111,114,32,102,111,117,110,100,39,59,32,125,32,125,32,125,32,125,0,98,117,102,95,108,101,110,32,60,61,32,83,73,90,69,95,77,65,88,0,114,97,110,100,111,109,98,121,116,101,115,47,114,97,110,100,111,109,98,121,116,101,115,46,99,0,114,97,110,100,111,109,98,121,116,101,115,0,49,46,48,46,49,49,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,3,4,5,6,7,8,9,255,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,4,7,3,6,5,0,17,0,10,0,17,17,17,0,0,0,0,5,0,0,0,0,0,0,9,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,15,10,17,17,17,3,10,7,0,1,19,9,11,11,0,0,9,6,11,0,0,11,0,6,17,0,0,0,17,17,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,10,10,17,17,17,0,10,0,0,2,0,9,11,0,0,0,9,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,4,13,0,0,0,0,9,14,0,0,0,0,0,14,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,15,0,0,0,0,9,16,0,0,0,0,0,16,0,0,16,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,10,0,0,0,0,9,11,0,0,0,0,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,45,43,32,32,32,48,88,48,120,0,84,33,34,25,13,1,2,3,17,75,28,12,16,4,11,29,18,30,39,104,110,111,112,113,98,32,5,6,15,19,20,21,26,8,22,7,40,36,23,24,9,10,14,27,31,37,35,131,130,125,38,42,43,60,61,62,63,67,71,74,77,88,89,90,91,92,93,94,95,96,97,99,100,101,102,103,105,106,107,108,114,115,116,121,122,123,124,0,73,108,108,101,103,97,108,32,98,121,116,101,32,115,101,113,117,101,110,99,101,0,68,111,109,97,105,110,32,101,114,114,111,114,0,82,101,115,117,108,116,32,110,111,116,32,114,101,112,114,101,115,101,110,116,97,98,108,101,0,78,111,116,32,97,32,116,116,121,0,80,101,114,109,105,115,115,105,111,110,32,100,101,110,105,101,100,0,79,112,101,114,97,116,105,111,110,32,110,111,116,32,112,101,114,109,105,116,116,101,100,0,78,111,32,115,117,99,104,32,102,105,108,101,32,111,114,32,100,105,114,101,99,116,111,114,121,0,78,111,32,115,117,99,104,32,112,114,111,99,101,115,115,0,70,105,108,101,32,101,120,105,115,116,115,0,86,97,108,117,101,32,116,111,111,32,108,97,114,103,101,32,102,111,114,32,100,97,116,97,32,116,121,112,101,0,78,111,32,115,112,97,99,101,32,108,101,102,116,32,111,110,32,100,101,118,105,99,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,115,111,117,114,99,101,32,98,117,115,121,0,73,110,116,101,114,114,117,112,116,101,100,32,115,121,115,116,101,109,32,99,97,108,108,0,82,101,115,111,117,114,99,101,32,116,101,109,112,111,114,97,114,105,108,121,32,117,110,97,118,97,105,108,97,98,108,101,0,73,110,118,97,108,105,100,32,115,101,101,107,0,67,114,111,115,115,45,100,101,118,105,99,101,32,108,105,110,107,0,82,101,97,100,45,111,110,108,121,32,102,105,108,101,32,115,121,115,116,101,109,0,68,105,114,101,99,116,111,114,121,32,110,111,116,32,101,109,112,116,121,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,112,101,101,114,0,79,112,101,114,97,116,105,111,110,32,116,105,109,101,100,32,111,117,116,0,67,111,110,110,101,99,116,105,111,110,32,114,101,102,117,115,101,100,0,72,111,115,116,32,105,115,32,100,111,119,110,0,72,111,115,116,32,105,115,32,117,110,114,101,97,99,104,97,98,108,101,0,65,100,100,114,101,115,115,32,105,110,32,117,115,101,0,66,114,111,107,101,110,32,112,105,112,101,0,73,47,79,32,101,114,114,111,114,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,32,111,114,32,97,100,100,114,101,115,115,0,66,108,111,99,107,32,100,101,118,105,99,101,32,114,101,113,117,105,114,101,100,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,0,78,111,116,32,97,32,100,105,114,101,99,116,111,114,121,0,73,115,32,97,32,100,105,114,101,99,116,111,114,121,0,84,101,120,116,32,102,105,108,101,32,98,117,115,121,0,69,120,101,99,32,102,111,114,109,97,116,32,101,114,114,111,114,0,73,110,118,97,108,105,100,32,97,114,103,117,109,101,110,116,0,65,114,103,117,109,101,110,116,32,108,105,115,116,32,116,111,111,32,108,111,110,103,0,83,121,109,98,111,108,105,99,32,108,105,110,107,32,108,111,111,112,0,70,105,108,101,110,97,109,101,32,116,111,111,32,108,111,110,103,0,84,111,111,32,109,97,110,121,32,111,112,101,110,32,102,105,108,101,115,32,105,110,32,115,121,115,116,101,109,0,78,111,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,115,32,97,118,97,105,108,97,98,108,101,0,66,97,100,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,0,78,111,32,99,104,105,108,100,32,112,114,111,99,101,115,115,0,66,97,100,32,97,100,100,114,101,115,115,0,70,105,108,101,32,116,111,111,32,108,97,114,103,101,0,84,111,111,32,109,97,110,121,32,108,105,110,107,115,0,78,111,32,108,111,99,107,115,32,97,118,97,105,108,97,98,108,101,0,82,101,115,111,117,114,99,101,32,100,101,97,100,108,111,99,107,32,119,111,117,108,100,32,111,99,99,117,114,0,83,116,97,116,101,32,110,111,116,32,114,101,99,111,118,101,114,97,98,108,101,0,80,114,101,118,105,111,117,115,32,111,119,110,101,114,32,100,105,101,100,0,79,112,101,114,97,116,105,111,110,32,99,97,110,99,101,108,101,100,0,70,117,110,99,116,105,111,110,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,78,111,32,109,101,115,115,97,103,101,32,111,102,32,100,101,115,105,114,101,100,32,116,121,112,101,0,73,100,101,110,116,105,102,105,101,114,32,114,101,109,111,118,101,100,0,68,101,118,105,99,101,32,110,111,116,32,97,32,115,116,114,101,97,109,0,78,111,32,100,97,116,97,32,97,118,97,105,108,97,98,108,101,0,68,101,118,105,99,101,32,116,105,109,101,111,117,116,0,79,117,116,32,111,102,32,115,116,114,101,97,109,115,32,114,101,115,111,117,114,99,101,115,0,76,105,110,107,32,104,97,115,32,98,101,101,110,32,115,101,118,101,114,101,100,0,80,114,111,116,111,99,111,108,32,101,114,114,111,114,0,66,97,100,32,109,101,115,115,97,103,101,0,70,105,108,101,32,100,101,115,99,114,105,112,116,111,114,32,105,110,32,98,97,100,32,115,116,97,116,101,0,78,111,116,32,97,32,115,111,99,107,101,116,0,68,101,115,116,105,110,97,116,105,111,110,32,97,100,100,114,101,115,115,32,114,101,113,117,105,114,101,100,0,77,101,115,115,97,103,101,32,116,111,111,32,108,97,114,103,101,0,80,114,111,116,111,99,111,108,32,119,114,111,110,103,32,116,121,112,101,32,102,111,114,32,115,111,99,107,101,116,0,80,114,111,116,111,99,111,108,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,80,114,111,116,111,99,111,108,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,83,111,99,107,101,116,32,116,121,112,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,111,116,32,115,117,112,112,111,114,116,101,100,0,80,114,111,116,111,99,111,108,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,65,100,100,114,101,115,115,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,112,114,111,116,111,99,111,108,0,65,100,100,114,101,115,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,78,101,116,119,111,114,107,32,105,115,32,100,111,119,110,0,78,101,116,119,111,114,107,32,117,110,114,101,97,99,104,97,98,108,101,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,110,101,116,119,111,114,107,0,67,111,110,110,101,99,116,105,111,110,32,97,98,111,114,116,101,100,0,78,111,32,98,117,102,102,101,114,32,115,112,97,99,101,32,97,118,97,105,108,97,98,108,101,0,83,111,99,107,101,116,32,105,115,32,99,111,110,110,101,99,116,101,100,0,83,111,99,107,101,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,67,97,110,110,111,116,32,115,101,110,100,32,97,102,116,101,114,32,115,111,99,107,101,116,32,115,104,117,116,100,111,119,110,0,79,112,101,114,97,116,105,111,110,32,97,108,114,101,97,100,121,32,105,110,32,112,114,111,103,114,101,115,115,0,79,112,101,114,97,116,105,111,110,32,105,110,32,112,114,111,103,114,101,115,115,0,83,116,97,108,101,32,102,105,108,101,32,104,97,110,100,108,101,0,82,101,109,111,116,101,32,73,47,79,32,101,114,114,111,114,0,81,117,111,116,97,32,101,120,99,101,101,100,101,100,0,78,111,32,109,101,100,105,117,109,32,102,111,117,110,100,0,87,114,111,110,103,32,109,101,100,105,117,109,32,116,121,112,101,0,78,111,32,101,114,114,111,114,32,105,110,102,111,114,109,97,116,105,111,110,0,0,40,110,117,108,108,41,0,45,48,88,43,48,88,32,48,88,45,48,120,43,48,120,32,48,120,0,105,110,102,0,73,78,70,0,78,65,78,0,105,110,102,105,110,105,116,121,0,110,97,110,0,80,79,83,73,88,0,46,0,78,83,116,51,95,95,50,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,56,105,111,115,95,98,97,115,101,69,0,78,83,116,51,95,95,50,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,78,83,116,51,95,95,50,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+36572);allocate([116,101,103,111,114,121,69,0,105,111,115,116,114,101,97,109,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,50,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,78,83,116,51,95,95,50,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,78,83,116,51,95,95,50,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,78,83,116,51,95,95,50,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,78,83,116,51,95,95,50,55,99,111,108,108,97,116,101,73,99,69,69,0,78,83,116,51,95,95,50,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,78,83,116,51,95,95,50,55,99,111,108,108,97,116,101,73,119,69,69,0,78,83,116,51,95,95,50,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,78,83,116,51,95,95,50,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,67,0,37,112,0,78,83,116,51,95,95,50,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,78,83,116,51,95,95,50,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,78,83,116,51,95,95,50,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,37,0,0,0,0,0,108,0,108,108,0,76,0,37,112,0,0,0,0,78,83,116,51,95,95,50,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,116,105,109,101,95,98,97,115,101,69,0,78,83,116,51,95,95,50,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,37,72,58,37,77,37,72,58,37,77,58,37,83,83,117,110,100,97,121,0,77,111,110,100,97,121,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,84,104,117,114,115,100,97,121,0,70,114,105,100,97,121,0,83,97,116,117,114,100,97,121,0,83,117,110,0,77,111,110,0,84,117,101,0,87,101,100,0,84,104,117,0,70,114,105,0,83,97,116,0,74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,77,97,114,99,104,0,65,112,114,105,108,0,77,97,121,0,74,117,110,101,0,74,117,108,121,0,65,117,103,117,115,116,0,83,101,112,116,101,109,98,101,114,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,68,101,99,101,109,98,101,114,0,74,97,110,0,70,101,98,0,77,97,114,0,65,112,114,0,74,117,110,0,74,117,108,0,65,117,103,0,83,101,112,0,79,99,116,0,78,111,118,0,68,101,99,0,65,77,0,80,77,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,37,73,58,37,77,58,37,83,32,37,112,0,37,109,47,37,100,47,37,121,0,37,72,58,37,77,58,37,83,0,78,83,116,51,95,95,50,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,48,95,95,116,105,109,101,95,112,117,116,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,48,49,50,51,52,53,54,55,56,57,0,37,76,102,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,48,49,50,51,52,53,54,55,56,57,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,37,46,48,76,102,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,78,83,116,51,95,95,50,56,109,101,115,115,97,103,101,115,73,99,69,69,0,78,83,116,51,95,95,50,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,78,83,116,51,95,95,50,56,109,101,115,115,97,103,101,115,73,119,69,69,0,78,83,116,51,95,95,50,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,78,83,116,51,95,95,50,53,99,116,121,112,101,73,99,69,69,0,78,83,116,51,95,95,50,49,48,99,116,121,112,101,95,98,97,115,101,69,0,78,83,116,51,95,95,50,53,99,116,121,112,101,73,119,69,69,0,78,83,116,51,95,95,50,56,110,117,109,112,117,110,99,116,73,99,69,69,0,116,114,117,101,0,102,97,108,115,101,0,78,83,116,51,95,95,50,56,110,117,109,112,117,110,99,116,73,119,69,69,0,118,101,99,116,111,114,0,78,83,116,51,95,95,50,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,98,97,115,105,99,95,115,116,114,105,110,103,0,78,83,116,51,95,95,50,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,78,83,116,51,95,95,50,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,78,83,116,51,95,95,50,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,58,32,0,99,97,110,110,111,116,32,122,101,114,111,32,111,117,116,32,116,104,114,101,97,100,32,118,97,108,117,101,32,102,111,114,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,40,41,0,99,97,110,110,111,116,32,99,114,101,97,116,101,32,112,116,104,114,101,97,100,32,107,101,121,32,102,111,114,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,40,41,0,112,116,104,114,101,97,100,95,111,110,99,101,32,102,97,105,108,117,114,101,32,105,110,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,95,102,97,115,116,40,41,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,83,116,57,116,121,112,101,95,105,110,102,111,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,83,116,57,101,120,99,101,112,116,105,111,110,0,117,110,99,97,117,103,104,116,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,101,120,99,101,112,116,105,111,110,32,111,102,32,116,121,112,101,32,37,115,58,32,37,115,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,101,120,99,101,112,116,105,111,110,32,111,102,32,116,121,112,101,32,37,115,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,102,111,114,101,105,103,110,32,101,120,99,101,112,116,105,111,110,0,116,101,114,109,105,110,97,116,105,110,103,0,116,101,114,109,105,110,97,116,101,95,104,97,110,100,108,101,114,32,117,110,101,120,112,101,99,116,101,100,108,121,32,114,101,116,117,114,110,101,100,0,116,101,114,109,105,110,97,116,101,95,104,97,110,100,108,101,114,32,117,110,101,120,112,101,99,116,101,100,108,121,32,116,104,114,101,119,32,97,110,32,101,120,99,101,112,116,105,111,110,0,83,116,57,98,97,100,95,97,108,108,111,99,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,83,116,56,98,97,100,95,99,97,115,116,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+46812);var tempDoublePtr=STATICTOP;STATICTOP+=16;function _atexit(func,arg){__ATEXIT__.unshift({func:func,arg:arg})}function ___cxa_atexit(){return _atexit.apply(null,arguments)}Module["_i64Subtract"]=_i64Subtract;function ___setErrNo(value){if(Module["___errno_location"])HEAP32[Module["___errno_location"]()>>2]=value;return value}var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};function _sysconf(name){switch(name){case 30:return PAGE_SIZE;case 85:return totalMemory/PAGE_SIZE;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 80:case 81:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:return 200809;case 79:return 0;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:{if(typeof navigator==="object")return navigator["hardwareConcurrency"]||1;return 1}}___setErrNo(ERRNO_CODES.EINVAL);return-1}function __ZSt18uncaught_exceptionv(){return!!__ZSt18uncaught_exceptionv.uncaught_exception}var EXCEPTIONS={last:0,caught:[],infos:{},deAdjust:(function(adjusted){if(!adjusted||EXCEPTIONS.infos[adjusted])return adjusted;for(var ptr in EXCEPTIONS.infos){var info=EXCEPTIONS.infos[ptr];if(info.adjusted===adjusted){return ptr}}return adjusted}),addRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount++}),decRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];assert(info.refcount>0);info.refcount--;if(info.refcount===0){if(info.destructor){Runtime.dynCall("vi",info.destructor,[ptr])}delete EXCEPTIONS.infos[ptr];___cxa_free_exception(ptr)}}),clearRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount=0})};function ___resumeException(ptr){if(!EXCEPTIONS.last){EXCEPTIONS.last=ptr}EXCEPTIONS.clearRef(EXCEPTIONS.deAdjust(ptr));throw ptr}function ___cxa_find_matching_catch(){var thrown=EXCEPTIONS.last;if(!thrown){return(asm["setTempRet0"](0),0)|0}var info=EXCEPTIONS.infos[thrown];var throwntype=info.type;if(!throwntype){return(asm["setTempRet0"](0),thrown)|0}var typeArray=Array.prototype.slice.call(arguments);var pointer=Module["___cxa_is_pointer_type"](throwntype);if(!___cxa_find_matching_catch.buffer)___cxa_find_matching_catch.buffer=_malloc(4);HEAP32[___cxa_find_matching_catch.buffer>>2]=thrown;thrown=___cxa_find_matching_catch.buffer;for(var i=0;i<typeArray.length;i++){if(typeArray[i]&&Module["___cxa_can_catch"](typeArray[i],throwntype,thrown)){thrown=HEAP32[thrown>>2];info.adjusted=thrown;return(asm["setTempRet0"](typeArray[i]),thrown)|0}}thrown=HEAP32[thrown>>2];return(asm["setTempRet0"](throwntype),thrown)|0}function ___cxa_throw(ptr,type,destructor){EXCEPTIONS.infos[ptr]={ptr:ptr,adjusted:ptr,type:type,destructor:destructor,refcount:0};EXCEPTIONS.last=ptr;if(!("uncaught_exception"in __ZSt18uncaught_exceptionv)){__ZSt18uncaught_exceptionv.uncaught_exception=1}else{__ZSt18uncaught_exceptionv.uncaught_exception++}throw ptr}Module["_memset"]=_memset;Module["_pthread_mutex_lock"]=_pthread_mutex_lock;function __isLeapYear(year){return year%4===0&&(year%100!==0||year%400===0)}function __arraySum(array,index){var sum=0;for(var i=0;i<=index;sum+=array[i++]);return sum}var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date,days){var newDate=new Date(date.getTime());while(days>0){var leap=__isLeapYear(newDate.getFullYear());var currentMonth=newDate.getMonth();var daysInCurrentMonth=(leap?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR)[currentMonth];if(days>daysInCurrentMonth-newDate.getDate()){days-=daysInCurrentMonth-newDate.getDate()+1;newDate.setDate(1);if(currentMonth<11){newDate.setMonth(currentMonth+1)}else{newDate.setMonth(0);newDate.setFullYear(newDate.getFullYear()+1)}}else{newDate.setDate(newDate.getDate()+days);return newDate}}return newDate}function _strftime(s,maxsize,format,tm){var tm_zone=HEAP32[tm+40>>2];var date={tm_sec:HEAP32[tm>>2],tm_min:HEAP32[tm+4>>2],tm_hour:HEAP32[tm+8>>2],tm_mday:HEAP32[tm+12>>2],tm_mon:HEAP32[tm+16>>2],tm_year:HEAP32[tm+20>>2],tm_wday:HEAP32[tm+24>>2],tm_yday:HEAP32[tm+28>>2],tm_isdst:HEAP32[tm+32>>2],tm_gmtoff:HEAP32[tm+36>>2],tm_zone:tm_zone?Pointer_stringify(tm_zone):""};var pattern=Pointer_stringify(format);var EXPANSION_RULES_1={"%c":"%a %b %d %H:%M:%S %Y","%D":"%m/%d/%y","%F":"%Y-%m-%d","%h":"%b","%r":"%I:%M:%S %p","%R":"%H:%M","%T":"%H:%M:%S","%x":"%m/%d/%y","%X":"%H:%M:%S"};for(var rule in EXPANSION_RULES_1){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_1[rule])}var WEEKDAYS=["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];var MONTHS=["January","February","March","April","May","June","July","August","September","October","November","December"];function leadingSomething(value,digits,character){var str=typeof value==="number"?value.toString():value||"";while(str.length<digits){str=character[0]+str}return str}function leadingNulls(value,digits){return leadingSomething(value,digits,"0")}function compareByDay(date1,date2){function sgn(value){return value<0?-1:value>0?1:0}var compare;if((compare=sgn(date1.getFullYear()-date2.getFullYear()))===0){if((compare=sgn(date1.getMonth()-date2.getMonth()))===0){compare=sgn(date1.getDate()-date2.getDate())}}return compare}function getFirstWeekStartDate(janFourth){switch(janFourth.getDay()){case 0:return new Date(janFourth.getFullYear()-1,11,29);case 1:return janFourth;case 2:return new Date(janFourth.getFullYear(),0,3);case 3:return new Date(janFourth.getFullYear(),0,2);case 4:return new Date(janFourth.getFullYear(),0,1);case 5:return new Date(janFourth.getFullYear()-1,11,31);case 6:return new Date(janFourth.getFullYear()-1,11,30)}}function getWeekBasedYear(date){var thisDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);var janFourthThisYear=new Date(thisDate.getFullYear(),0,4);var janFourthNextYear=new Date(thisDate.getFullYear()+1,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);if(compareByDay(firstWeekStartThisYear,thisDate)<=0){if(compareByDay(firstWeekStartNextYear,thisDate)<=0){return thisDate.getFullYear()+1}else{return thisDate.getFullYear()}}else{return thisDate.getFullYear()-1}}var EXPANSION_RULES_2={"%a":(function(date){return WEEKDAYS[date.tm_wday].substring(0,3)}),"%A":(function(date){return WEEKDAYS[date.tm_wday]}),"%b":(function(date){return MONTHS[date.tm_mon].substring(0,3)}),"%B":(function(date){return MONTHS[date.tm_mon]}),"%C":(function(date){var year=date.tm_year+1900;return leadingNulls(year/100|0,2)}),"%d":(function(date){return leadingNulls(date.tm_mday,2)}),"%e":(function(date){return leadingSomething(date.tm_mday,2," ")}),"%g":(function(date){return getWeekBasedYear(date).toString().substring(2)}),"%G":(function(date){return getWeekBasedYear(date)}),"%H":(function(date){return leadingNulls(date.tm_hour,2)}),"%I":(function(date){var twelveHour=date.tm_hour;if(twelveHour==0)twelveHour=12;else if(twelveHour>12)twelveHour-=12;return leadingNulls(twelveHour,2)}),"%j":(function(date){return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900)?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,date.tm_mon-1),3)}),"%m":(function(date){return leadingNulls(date.tm_mon+1,2)}),"%M":(function(date){return leadingNulls(date.tm_min,2)}),"%n":(function(){return"\n"}),"%p":(function(date){if(date.tm_hour>=0&&date.tm_hour<12){return"AM"}else{return"PM"}}),"%S":(function(date){return leadingNulls(date.tm_sec,2)}),"%t":(function(){return"\t"}),"%u":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()||7}),"%U":(function(date){var janFirst=new Date(date.tm_year+1900,0,1);var firstSunday=janFirst.getDay()===0?janFirst:__addDays(janFirst,7-janFirst.getDay());var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstSunday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstSundayUntilEndJanuary=31-firstSunday.getDate();var days=firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstSunday,janFirst)===0?"01":"00"}),"%V":(function(date){var janFourthThisYear=new Date(date.tm_year+1900,0,4);var janFourthNextYear=new Date(date.tm_year+1901,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);var endDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);if(compareByDay(endDate,firstWeekStartThisYear)<0){return"53"}if(compareByDay(firstWeekStartNextYear,endDate)<=0){return"01"}var daysDifference;if(firstWeekStartThisYear.getFullYear()<date.tm_year+1900){daysDifference=date.tm_yday+32-firstWeekStartThisYear.getDate()}else{daysDifference=date.tm_yday+1-firstWeekStartThisYear.getDate()}return leadingNulls(Math.ceil(daysDifference/7),2)}),"%w":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()}),"%W":(function(date){var janFirst=new Date(date.tm_year,0,1);var firstMonday=janFirst.getDay()===1?janFirst:__addDays(janFirst,janFirst.getDay()===0?1:7-janFirst.getDay()+1);var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstMonday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstMondayUntilEndJanuary=31-firstMonday.getDate();var days=firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstMonday,janFirst)===0?"01":"00"}),"%y":(function(date){return(date.tm_year+1900).toString().substring(2)}),"%Y":(function(date){return date.tm_year+1900}),"%z":(function(date){var off=date.tm_gmtoff;var ahead=off>=0;off=Math.abs(off)/60;off=off/60*100+off%60;return(ahead?"+":"-")+String("0000"+off).slice(-4)}),"%Z":(function(date){return date.tm_zone}),"%%":(function(){return"%"})};for(var rule in EXPANSION_RULES_2){if(pattern.indexOf(rule)>=0){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_2[rule](date))}}var bytes=intArrayFromString(pattern,false);if(bytes.length>maxsize){return 0}writeArrayToMemory(bytes,s);return bytes.length-1}function _strftime_l(s,maxsize,format,tm){return _strftime(s,maxsize,format,tm)}function _abort(){Module["abort"]()}function _free(){}Module["_free"]=_free;function ___cxa_free_exception(ptr){try{return _free(ptr)}catch(e){}}function ___cxa_end_catch(){if(___cxa_end_catch.rethrown){___cxa_end_catch.rethrown=false;return}asm["setThrew"](0);var ptr=EXCEPTIONS.caught.pop();if(ptr){EXCEPTIONS.decRef(EXCEPTIONS.deAdjust(ptr));EXCEPTIONS.last=0}}function _pthread_once(ptr,func){if(!_pthread_once.seen)_pthread_once.seen={};if(ptr in _pthread_once.seen)return;Runtime.dynCall("v",func);_pthread_once.seen[ptr]=1}function ___lock(){}function ___unlock(){}var PTHREAD_SPECIFIC={};function _pthread_getspecific(key){return PTHREAD_SPECIFIC[key]||0}var _llvm_fabs_f64=Math_abs;function ___assert_fail(condition,filename,line,func){ABORT=true;throw"Assertion failed: "+Pointer_stringify(condition)+", at: "+[filename?Pointer_stringify(filename):"unknown filename",line,func?Pointer_stringify(func):"unknown function"]+" at "+stackTrace()}var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key,destructor){if(key==0){return ERRNO_CODES.EINVAL}HEAP32[key>>2]=PTHREAD_SPECIFIC_NEXT_KEY;PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY]=0;PTHREAD_SPECIFIC_NEXT_KEY++;return 0}function _pthread_setspecific(key,value){if(!(key in PTHREAD_SPECIFIC)){return ERRNO_CODES.EINVAL}PTHREAD_SPECIFIC[key]=value;return 0}function _malloc(bytes){var ptr=Runtime.dynamicAlloc(bytes+8);return ptr+8&4294967288}Module["_malloc"]=_malloc;function ___cxa_allocate_exception(size){return _malloc(size)}var SYSCALLS={varargs:0,get:(function(varargs){SYSCALLS.varargs+=4;var ret=HEAP32[SYSCALLS.varargs-4>>2];return ret}),getStr:(function(){var ret=Pointer_stringify(SYSCALLS.get());return ret}),get64:(function(){var low=SYSCALLS.get(),high=SYSCALLS.get();if(low>=0)assert(high===0);else assert(high===-1);return low}),getZero:(function(){assert(SYSCALLS.get()===0)})};function ___syscall54(which,varargs){SYSCALLS.varargs=varargs;try{return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}Module["_bitshift64Ashr"]=_bitshift64Ashr;Module["_bitshift64Lshr"]=_bitshift64Lshr;function _pthread_cleanup_push(routine,arg){__ATEXIT__.push((function(){Runtime.dynCall("vi",routine,[arg])}));_pthread_cleanup_push.level=__ATEXIT__.length}Module["_pthread_cond_broadcast"]=_pthread_cond_broadcast;function _pthread_cleanup_pop(){assert(_pthread_cleanup_push.level==__ATEXIT__.length,"cannot pop if something else added meanwhile!");__ATEXIT__.pop();_pthread_cleanup_push.level=__ATEXIT__.length}Module["_i64Add"]=_i64Add;function ___cxa_find_matching_catch_2(){return ___cxa_find_matching_catch.apply(null,arguments)}function ___cxa_find_matching_catch_3(){return ___cxa_find_matching_catch.apply(null,arguments)}Module["_pthread_mutex_unlock"]=_pthread_mutex_unlock;Module["_bitshift64Shl"]=_bitshift64Shl;function _emscripten_memcpy_big(dest,src,num){HEAPU8.set(HEAPU8.subarray(src,src+num),dest);return dest}Module["_memcpy"]=_memcpy;function ___syscall6(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD();FS.close(stream);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var cttz_i8=allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0],"i8",ALLOC_STATIC);Module["_llvm_cttz_i32"]=_llvm_cttz_i32;Module["___udivmoddi4"]=___udivmoddi4;Module["___udivdi3"]=___udivdi3;Module["___muldsi3"]=___muldsi3;Module["___muldi3"]=___muldi3;function _sbrk(bytes){var self=_sbrk;if(!self.called){DYNAMICTOP=alignMemoryPage(DYNAMICTOP);self.called=true;assert(Runtime.dynamicAlloc);self.alloc=Runtime.dynamicAlloc;Runtime.dynamicAlloc=(function(){abort("cannot dynamically allocate, sbrk now has control")})}var ret=DYNAMICTOP;if(bytes!=0){var success=self.alloc(bytes);if(!success)return-1>>>0}return ret}Module["_memmove"]=_memmove;function ___cxa_begin_catch(ptr){__ZSt18uncaught_exceptionv.uncaught_exception--;EXCEPTIONS.caught.push(ptr);EXCEPTIONS.addRef(EXCEPTIONS.deAdjust(ptr));return ptr}function ___gxx_personality_v0(){}Module["___uremdi3"]=___uremdi3;function _pthread_cond_wait(){return 0}function ___cxa_rethrow(){___cxa_end_catch.rethrown=true;var ptr=EXCEPTIONS.caught.pop();EXCEPTIONS.last=ptr;throw ptr}Module["_pthread_self"]=_pthread_self;function ___syscall140(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),offset_high=SYSCALLS.get(),offset_low=SYSCALLS.get(),result=SYSCALLS.get(),whence=SYSCALLS.get();var offset=offset_low;assert(offset_high===0);FS.llseek(stream,offset,whence);HEAP32[result>>2]=stream.position;if(stream.getdents&&offset===0&&whence===0)stream.getdents=null;return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall146(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.get(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();var ret=0;if(!___syscall146.buffer){___syscall146.buffers=[null,[],[]];___syscall146.printChar=(function(stream,curr){var buffer=___syscall146.buffers[stream];assert(buffer);if(curr===0||curr===10){(stream===1?Module["print"]:Module["printErr"])(UTF8ArrayToString(buffer,0));buffer.length=0}else{buffer.push(curr)}})}for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];for(var j=0;j<len;j++){___syscall146.printChar(stream,HEAPU8[ptr+j])}ret+=len}return ret}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall145(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doReadv(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var ___dso_handle=STATICTOP;STATICTOP+=16;__ATEXIT__.push((function(){var fflush=Module["_fflush"];if(fflush)fflush(0);var printChar=___syscall146.printChar;if(!printChar)return;var buffers=___syscall146.buffers;if(buffers[1].length)printChar(1,10);if(buffers[2].length)printChar(2,10)}));STACK_BASE=STACKTOP=Runtime.alignMemory(STATICTOP);staticSealed=true;STACK_MAX=STACK_BASE+TOTAL_STACK;DYNAMIC_BASE=DYNAMICTOP=Runtime.alignMemory(STACK_MAX);function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7){return Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6,a7)}function invoke_viiiii(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_viiiii(index,a1,a2,a3,a4,a5){Runtime.functionPointers[index](a1,a2,a3,a4,a5)}function invoke_iiiiiid(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiiiiid(index,a1,a2,a3,a4,a5,a6){return Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6)}function invoke_vi(index,a1){try{Module["dynCall_vi"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_vi(index,a1){Runtime.functionPointers[index](a1)}function invoke_vii(index,a1,a2){try{Module["dynCall_vii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_vii(index,a1,a2){Runtime.functionPointers[index](a1,a2)}function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiiiiii(index,a1,a2,a3,a4,a5,a6){return Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6)}function invoke_ii(index,a1){try{return Module["dynCall_ii"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_ii(index,a1){return Runtime.functionPointers[index](a1)}function invoke_iiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{return Module["dynCall_iiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){return Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}function invoke_iiii(index,a1,a2,a3){try{return Module["dynCall_iiii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiii(index,a1,a2,a3){return Runtime.functionPointers[index](a1,a2,a3)}function invoke_viiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15){try{Module["dynCall_viiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_viiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15){Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15)}function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_viiiiii(index,a1,a2,a3,a4,a5,a6){Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6)}function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7){Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6,a7)}function invoke_viiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_viiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}function invoke_iii(index,a1,a2){try{return Module["dynCall_iii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iii(index,a1,a2){return Runtime.functionPointers[index](a1,a2)}function invoke_iiiiii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiiiii(index,a1,a2,a3,a4,a5){return Runtime.functionPointers[index](a1,a2,a3,a4,a5)}function invoke_i(index){try{return Module["dynCall_i"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_i(index){return Runtime.functionPointers[index]()}function invoke_iiiii(index,a1,a2,a3,a4){try{return Module["dynCall_iiiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiiii(index,a1,a2,a3,a4){return Runtime.functionPointers[index](a1,a2,a3,a4)}function invoke_viii(index,a1,a2,a3){try{Module["dynCall_viii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_viii(index,a1,a2,a3){Runtime.functionPointers[index](a1,a2,a3)}function invoke_v(index){try{Module["dynCall_v"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_v(index){Runtime.functionPointers[index]()}function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){return Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6,a7,a8)}function invoke_iiiiid(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiiiid(index,a1,a2,a3,a4,a5){return Runtime.functionPointers[index](a1,a2,a3,a4,a5)}function invoke_viiii(index,a1,a2,a3,a4){try{Module["dynCall_viiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_viiii(index,a1,a2,a3,a4){Runtime.functionPointers[index](a1,a2,a3,a4)}Module.asmGlobalArg={"Math":Math,"Int8Array":Int8Array,"Int16Array":Int16Array,"Int32Array":Int32Array,"Uint8Array":Uint8Array,"Uint16Array":Uint16Array,"Uint32Array":Uint32Array,"Float32Array":Float32Array,"Float64Array":Float64Array,"NaN":NaN,"Infinity":Infinity};Module.asmLibraryArg={"abort":abort,"assert":assert,"invoke_iiiiiiii":invoke_iiiiiiii,"jsCall_iiiiiiii":jsCall_iiiiiiii,"invoke_viiiii":invoke_viiiii,"jsCall_viiiii":jsCall_viiiii,"invoke_iiiiiid":invoke_iiiiiid,"jsCall_iiiiiid":jsCall_iiiiiid,"invoke_vi":invoke_vi,"jsCall_vi":jsCall_vi,"invoke_vii":invoke_vii,"jsCall_vii":jsCall_vii,"invoke_iiiiiii":invoke_iiiiiii,"jsCall_iiiiiii":jsCall_iiiiiii,"invoke_ii":invoke_ii,"jsCall_ii":jsCall_ii,"invoke_iiiiiiiiiiii":invoke_iiiiiiiiiiii,"jsCall_iiiiiiiiiiii":jsCall_iiiiiiiiiiii,"invoke_iiii":invoke_iiii,"jsCall_iiii":jsCall_iiii,"invoke_viiiiiiiiiiiiiii":invoke_viiiiiiiiiiiiiii,"jsCall_viiiiiiiiiiiiiii":jsCall_viiiiiiiiiiiiiii,"invoke_viiiiii":invoke_viiiiii,"jsCall_viiiiii":jsCall_viiiiii,"invoke_viiiiiii":invoke_viiiiiii,"jsCall_viiiiiii":jsCall_viiiiiii,"invoke_viiiiiiiiii":invoke_viiiiiiiiii,"jsCall_viiiiiiiiii":jsCall_viiiiiiiiii,"invoke_iii":invoke_iii,"jsCall_iii":jsCall_iii,"invoke_iiiiii":invoke_iiiiii,"jsCall_iiiiii":jsCall_iiiiii,"invoke_i":invoke_i,"jsCall_i":jsCall_i,"invoke_iiiii":invoke_iiiii,"jsCall_iiiii":jsCall_iiiii,"invoke_viii":invoke_viii,"jsCall_viii":jsCall_viii,"invoke_v":invoke_v,"jsCall_v":jsCall_v,"invoke_iiiiiiiii":invoke_iiiiiiiii,"jsCall_iiiiiiiii":jsCall_iiiiiiiii,"invoke_iiiiid":invoke_iiiiid,"jsCall_iiiiid":jsCall_iiiiid,"invoke_viiii":invoke_viiii,"jsCall_viiii":jsCall_viiii,"_pthread_cleanup_pop":_pthread_cleanup_pop,"_strftime":_strftime,"_pthread_cond_wait":_pthread_cond_wait,"___lock":___lock,"___resumeException":___resumeException,"_pthread_key_create":_pthread_key_create,"_abort":_abort,"_llvm_fabs_f64":_llvm_fabs_f64,"___gxx_personality_v0":___gxx_personality_v0,"___assert_fail":___assert_fail,"___cxa_free_exception":___cxa_free_exception,"___cxa_find_matching_catch_2":___cxa_find_matching_catch_2,"___cxa_find_matching_catch_3":___cxa_find_matching_catch_3,"_emscripten_asm_const_i":_emscripten_asm_const_i,"__addDays":__addDays,"_strftime_l":_strftime_l,"___setErrNo":___setErrNo,"_sbrk":_sbrk,"___cxa_allocate_exception":___cxa_allocate_exception,"_emscripten_memcpy_big":_emscripten_memcpy_big,"___cxa_end_catch":___cxa_end_catch,"_emscripten_asm_const_v":_emscripten_asm_const_v,"__ZSt18uncaught_exceptionv":__ZSt18uncaught_exceptionv,"_sysconf":_sysconf,"___cxa_begin_catch":___cxa_begin_catch,"_pthread_getspecific":_pthread_getspecific,"__arraySum":__arraySum,"_pthread_once":_pthread_once,"___syscall54":___syscall54,"___unlock":___unlock,"__isLeapYear":__isLeapYear,"_pthread_setspecific":_pthread_setspecific,"___cxa_atexit":___cxa_atexit,"___cxa_throw":___cxa_throw,"___cxa_rethrow":___cxa_rethrow,"___syscall6":___syscall6,"_pthread_cleanup_push":_pthread_cleanup_push,"_atexit":_atexit,"___syscall140":___syscall140,"___cxa_find_matching_catch":___cxa_find_matching_catch,"___syscall145":___syscall145,"___syscall146":___syscall146,"STACKTOP":STACKTOP,"STACK_MAX":STACK_MAX,"tempDoublePtr":tempDoublePtr,"ABORT":ABORT,"cttz_i8":cttz_i8,"___dso_handle":___dso_handle};// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer) {
"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.___dso_handle|0;var o=0;var p=0;var q=0;var r=0;var s=global.NaN,t=global.Infinity;var u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;var D=0;var E=global.Math.floor;var F=global.Math.abs;var G=global.Math.sqrt;var H=global.Math.pow;var I=global.Math.cos;var J=global.Math.sin;var K=global.Math.tan;var L=global.Math.acos;var M=global.Math.asin;var N=global.Math.atan;var O=global.Math.atan2;var P=global.Math.exp;var Q=global.Math.log;var R=global.Math.ceil;var S=global.Math.imul;var T=global.Math.min;var U=global.Math.clz32;var V=env.abort;var W=env.assert;var X=env.invoke_iiiiiiii;var Y=env.jsCall_iiiiiiii;var Z=env.invoke_viiiii;var _=env.jsCall_viiiii;var $=env.invoke_iiiiiid;var aa=env.jsCall_iiiiiid;var ba=env.invoke_vi;var ca=env.jsCall_vi;var da=env.invoke_vii;var ea=env.jsCall_vii;var fa=env.invoke_iiiiiii;var ga=env.jsCall_iiiiiii;var ha=env.invoke_ii;var ia=env.jsCall_ii;var ja=env.invoke_iiiiiiiiiiii;var ka=env.jsCall_iiiiiiiiiiii;var la=env.invoke_iiii;var ma=env.jsCall_iiii;var na=env.invoke_viiiiiiiiiiiiiii;var oa=env.jsCall_viiiiiiiiiiiiiii;var pa=env.invoke_viiiiii;var qa=env.jsCall_viiiiii;var ra=env.invoke_viiiiiii;var sa=env.jsCall_viiiiiii;var ta=env.invoke_viiiiiiiiii;var ua=env.jsCall_viiiiiiiiii;var va=env.invoke_iii;var wa=env.jsCall_iii;var xa=env.invoke_iiiiii;var ya=env.jsCall_iiiiii;var za=env.invoke_i;var Aa=env.jsCall_i;var Ba=env.invoke_iiiii;var Ca=env.jsCall_iiiii;var Da=env.invoke_viii;var Ea=env.jsCall_viii;var Fa=env.invoke_v;var Ga=env.jsCall_v;var Ha=env.invoke_iiiiiiiii;var Ia=env.jsCall_iiiiiiiii;var Ja=env.invoke_iiiiid;var Ka=env.jsCall_iiiiid;var La=env.invoke_viiii;var Ma=env.jsCall_viiii;var Na=env._pthread_cleanup_pop;var Oa=env._strftime;var Pa=env._pthread_cond_wait;var Qa=env.___lock;var Ra=env.___resumeException;var Sa=env._pthread_key_create;var Ta=env._abort;var Ua=env._llvm_fabs_f64;var Va=env.___gxx_personality_v0;var Wa=env.___assert_fail;var Xa=env.___cxa_free_exception;var Ya=env.___cxa_find_matching_catch_2;var Za=env.___cxa_find_matching_catch_3;var _a=env._emscripten_asm_const_i;var $a=env.__addDays;var ab=env._strftime_l;var bb=env.___setErrNo;var cb=env._sbrk;var db=env.___cxa_allocate_exception;var eb=env._emscripten_memcpy_big;var fb=env.___cxa_end_catch;var gb=env._emscripten_asm_const_v;var hb=env.__ZSt18uncaught_exceptionv;var ib=env._sysconf;var jb=env.___cxa_begin_catch;var kb=env._pthread_getspecific;var lb=env.__arraySum;var mb=env._pthread_once;var nb=env.___syscall54;var ob=env.___unlock;var pb=env.__isLeapYear;var qb=env._pthread_setspecific;var rb=env.___cxa_atexit;var sb=env.___cxa_throw;var tb=env.___cxa_rethrow;var ub=env.___syscall6;var vb=env._pthread_cleanup_push;var wb=env._atexit;var xb=env.___syscall140;var yb=env.___cxa_find_matching_catch;var zb=env.___syscall145;var Ab=env.___syscall146;var Bb=0;
// EMSCRIPTEN_START_FUNCS
function Yb(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;g=i;h=i=i+63&-64;i=i+720|0;e=0;do{k=b+(e<<3)|0;p=d[k+7>>0]|0;q=_n(d[k+6>>0]|0|0,0,8)|0;j=D;o=_n(d[k+5>>0]|0|0,0,16)|0;j=j|D;n=_n(d[k+4>>0]|0|0,0,24)|0;j=j|D|(d[k+3>>0]|0);m=_n(d[k+2>>0]|0|0,0,40)|0;j=j|D;l=_n(d[k+1>>0]|0|0,0,48)|0;j=j|D;k=_n(d[k>>0]|0|0,0,56)|0;f=h+80+(e<<3)|0;c[f>>2]=q|p|o|n|m|l|k;c[f+4>>2]=j|D;e=e+1|0}while((e|0)!=16);b=c[h+80>>2]|0;e=c[h+80+4>>2]|0;f=16;do{s=h+80+(f+-2<<3)|0;w=c[s>>2]|0;s=c[s+4>>2]|0;r=bo(w|0,s|0,19)|0;k=D;j=_n(w|0,s|0,45)|0;k=k|D;u=bo(w|0,s|0,61)|0;v=D;t=_n(w|0,s|0,3)|0;v=v|D;s=bo(w|0,s|0,6)|0;k=v^D^k;v=h+80+(f+-7<<3)|0;w=c[v>>2]|0;v=c[v+4>>2]|0;o=h+80+(f+-15<<3)|0;y=b;b=c[o>>2]|0;x=e;e=c[o+4>>2]|0;o=bo(b|0,e|0,1)|0;p=D;q=_n(b|0,e|0,63)|0;p=p|D;l=bo(b|0,e|0,8)|0;z=D;m=_n(b|0,e|0,56)|0;z=z|D;n=bo(b|0,e|0,7)|0;p=z^D^p;v=Jp(y|0,x|0,w|0,v|0)|0;k=Jp(v|0,D|0,(u|t)^s^(r|j)|0,k|0)|0;p=Jp(k|0,D|0,(l|m)^n^(o|q)|0,p|0)|0;q=h+80+(f<<3)|0;c[q>>2]=p;c[q+4>>2]=D;f=f+1|0}while((f|0)!=80);b=h+16|0;e=a;f=b+64|0;do{c[b>>2]=c[e>>2];b=b+4|0;e=e+4|0}while((b|0)<(f|0));G=h+16+56|0;x=c[G>>2]|0;E=c[G+4>>2]|0;w=h+16+32|0;I=c[w>>2]|0;H=c[w+4>>2]|0;b=bo(I|0,H|0,14)|0;z=D;F=_n(I|0,H|0,50)|0;z=z|D;l=bo(I|0,H|0,18)|0;A=D;L=_n(I|0,H|0,46)|0;A=z^(A|D);z=bo(I|0,H|0,41)|0;J=D;K=_n(I|0,H|0,23)|0;J=A^(J|D);A=h+16+40|0;M=c[A>>2]|0;f=c[A+4>>2]|0;k=h+16+48|0;p=c[k>>2]|0;j=c[k+4>>2]|0;r=c[h+80>>2]|0;y=c[h+80+4>>2]|0;E=Jp(x|0,E|0,-685199838,1116352408)|0;y=Jp(E|0,D|0,r|0,y|0)|0;J=Jp(y|0,D|0,(b|F)^(l|L)^(z|K)|0,J|0)|0;J=Jp(J|0,D|0,(p^M)&I^p|0,(j^f)&H^j|0)|0;K=D;z=c[h+16>>2]|0;L=c[h+16+4>>2]|0;l=bo(z|0,L|0,28)|0;F=D;b=_n(z|0,L|0,36)|0;F=F|D;y=bo(z|0,L|0,34)|0;r=D;E=_n(z|0,L|0,30)|0;r=F^(r|D);F=bo(z|0,L|0,39)|0;x=D;m=_n(z|0,L|0,25)|0;C=h+16+8|0;o=c[C>>2]|0;q=c[C+4>>2]|0;B=h+16+16|0;e=c[B>>2]|0;s=c[B+4>>2]|0;x=Jp((e|o)&z|e&o|0,(s|q)&L|s&q|0,(l|b)^(y|E)^(F|m)|0,r^(x|D)|0)|0;r=D;m=h+16+24|0;F=Jp(c[m>>2]|0,c[m+4>>2]|0,J|0,K|0)|0;E=D;c[m>>2]=F;c[m+4>>2]=E;K=Jp(x|0,r|0,J|0,K|0)|0;J=D;c[G>>2]=K;c[G+4>>2]=J;r=bo(F|0,E|0,14)|0;x=D;y=_n(F|0,E|0,50)|0;x=x|D;b=bo(F|0,E|0,18)|0;l=D;u=_n(F|0,E|0,46)|0;l=x^(l|D);x=bo(F|0,E|0,41)|0;t=D;v=_n(F|0,E|0,23)|0;t=l^(t|D);l=c[h+80+8>>2]|0;n=c[h+80+8+4>>2]|0;j=Jp(p|0,j|0,602891725,1899447441)|0;t=Jp(j|0,D|0,(r|y)^(b|u)^(x|v)|0,t|0)|0;n=Jp(t|0,D|0,l|0,n|0)|0;H=Jp(n|0,D|0,(M^I)&F^M|0,(f^H)&E^f|0)|0;I=D;n=bo(K|0,J|0,28)|0;l=D;t=_n(K|0,J|0,36)|0;l=l|D;v=bo(K|0,J|0,34)|0;x=D;u=_n(K|0,J|0,30)|0;x=l^(x|D);l=bo(K|0,J|0,39)|0;b=D;y=_n(K|0,J|0,25)|0;b=Jp((o|z)&K|o&z|0,(q|L)&J|q&L|0,(n|t)^(v|u)^(l|y)|0,x^(b|D)|0)|0;x=D;s=Jp(e|0,s|0,H|0,I|0)|0;e=D;c[B>>2]=s;c[B+4>>2]=e;I=Jp(b|0,x|0,H|0,I|0)|0;H=D;c[k>>2]=I;c[k+4>>2]=H;x=bo(s|0,e|0,14)|0;b=D;y=_n(s|0,e|0,50)|0;b=b|D;l=bo(s|0,e|0,18)|0;u=D;v=_n(s|0,e|0,46)|0;u=b^(u|D);b=bo(s|0,e|0,41)|0;t=D;n=_n(s|0,e|0,23)|0;t=u^(t|D);u=c[w>>2]|0;r=c[w+4>>2]|0;j=c[h+80+16>>2]|0;p=c[h+80+16+4>>2]|0;f=Jp(M|0,f|0,-330482897,-1245643825)|0;t=Jp(f|0,D|0,(x|y)^(l|v)^(b|n)|0,t|0)|0;p=Jp(t|0,D|0,j|0,p|0)|0;p=Jp(p|0,D|0,(u^F)&s^u|0,(r^E)&e^r|0)|0;j=D;t=bo(I|0,H|0,28)|0;n=D;b=_n(I|0,H|0,36)|0;n=n|D;v=bo(I|0,H|0,34)|0;l=D;y=_n(I|0,H|0,30)|0;l=n^(l|D);n=bo(I|0,H|0,39)|0;x=D;f=_n(I|0,H|0,25)|0;x=Jp((z|K)&I|z&K|0,(L|J)&H|L&J|0,(t|b)^(v|y)^(n|f)|0,l^(x|D)|0)|0;l=D;q=Jp(o|0,q|0,p|0,j|0)|0;o=D;c[C>>2]=q;c[C+4>>2]=o;j=Jp(x|0,l|0,p|0,j|0)|0;p=D;c[A>>2]=j;c[A+4>>2]=p;l=bo(q|0,o|0,14)|0;x=D;f=_n(q|0,o|0,50)|0;x=x|D;n=bo(q|0,o|0,18)|0;y=D;v=_n(q|0,o|0,46)|0;y=x^(y|D);x=bo(q|0,o|0,41)|0;b=D;t=_n(q|0,o|0,23)|0;b=y^(b|D);y=c[h+80+24>>2]|0;J=c[h+80+24+4>>2]|0;r=Jp(u|0,r|0,-2121671748,-373957723)|0;b=Jp(r|0,D|0,(l|f)^(n|v)^(x|t)|0,b|0)|0;J=Jp(b|0,D|0,y|0,J|0)|0;J=Jp(J|0,D|0,(F^s)&q^F|0,(E^e)&o^E|0)|0;y=D;b=bo(j|0,p|0,28)|0;t=D;x=_n(j|0,p|0,36)|0;t=t|D;v=bo(j|0,p|0,34)|0;n=D;f=_n(j|0,p|0,30)|0;n=t^(n|D);t=bo(j|0,p|0,39)|0;l=D;r=_n(j|0,p|0,25)|0;u=c[G>>2]|0;K=c[G+4>>2]|0;l=Jp((u|I)&j|u&I|0,(K|H)&p|K&H|0,(b|x)^(v|f)^(t|r)|0,n^(l|D)|0)|0;n=D;L=Jp(z|0,L|0,J|0,y|0)|0;z=D;c[h+16>>2]=L;c[h+16+4>>2]=z;y=Jp(l|0,n|0,J|0,y|0)|0;J=D;c[w>>2]=y;c[w+4>>2]=J;n=bo(L|0,z|0,14)|0;l=D;r=_n(L|0,z|0,50)|0;l=l|D;t=bo(L|0,z|0,18)|0;f=D;v=_n(L|0,z|0,46)|0;f=l^(f|D);l=bo(L|0,z|0,41)|0;x=D;b=_n(L|0,z|0,23)|0;x=f^(x|D);f=c[h+80+32>>2]|0;H=c[h+80+32+4>>2]|0;E=Jp(F|0,E|0,-213338824,961987163)|0;x=Jp(E|0,D|0,(n|r)^(t|v)^(l|b)|0,x|0)|0;H=Jp(x|0,D|0,f|0,H|0)|0;H=Jp(H|0,D|0,(s^q)&L^s|0,(e^o)&z^e|0)|0;f=D;x=bo(y|0,J|0,28)|0;b=D;l=_n(y|0,J|0,36)|0;b=b|D;v=bo(y|0,J|0,34)|0;t=D;r=_n(y|0,J|0,30)|0;t=b^(t|D);b=bo(y|0,J|0,39)|0;n=D;E=_n(y|0,J|0,25)|0;F=c[k>>2]|0;I=c[k+4>>2]|0;n=Jp((F|j)&y|F&j|0,(I|p)&J|I&p|0,(x|l)^(v|r)^(b|E)|0,t^(n|D)|0)|0;t=D;K=Jp(u|0,K|0,H|0,f|0)|0;u=D;c[G>>2]=K;c[G+4>>2]=u;f=Jp(n|0,t|0,H|0,f|0)|0;H=D;c[m>>2]=f;c[m+4>>2]=H;t=bo(K|0,u|0,14)|0;n=D;E=_n(K|0,u|0,50)|0;n=n|D;b=bo(K|0,u|0,18)|0;r=D;v=_n(K|0,u|0,46)|0;r=n^(r|D);n=bo(K|0,u|0,41)|0;l=D;x=_n(K|0,u|0,23)|0;l=r^(l|D);r=c[h+80+40>>2]|0;p=c[h+80+40+4>>2]|0;e=Jp(s|0,e|0,-1241133031,1508970993)|0;l=Jp(e|0,D|0,(t|E)^(b|v)^(n|x)|0,l|0)|0;p=Jp(l|0,D|0,r|0,p|0)|0;p=Jp(p|0,D|0,(q^L)&K^q|0,(o^z)&u^o|0)|0;r=D;l=bo(f|0,H|0,28)|0;x=D;n=_n(f|0,H|0,36)|0;x=x|D;v=bo(f|0,H|0,34)|0;b=D;E=_n(f|0,H|0,30)|0;b=x^(b|D);x=bo(f|0,H|0,39)|0;t=D;e=_n(f|0,H|0,25)|0;s=c[A>>2]|0;j=c[A+4>>2]|0;t=Jp((s|y)&f|s&y|0,(j|J)&H|j&J|0,(l|n)^(v|E)^(x|e)|0,b^(t|D)|0)|0;b=D;I=Jp(F|0,I|0,p|0,r|0)|0;F=D;c[k>>2]=I;c[k+4>>2]=F;r=Jp(t|0,b|0,p|0,r|0)|0;p=D;c[B>>2]=r;c[B+4>>2]=p;b=bo(I|0,F|0,14)|0;t=D;e=_n(I|0,F|0,50)|0;t=t|D;x=bo(I|0,F|0,18)|0;E=D;v=_n(I|0,F|0,46)|0;E=t^(E|D);t=bo(I|0,F|0,41)|0;n=D;l=_n(I|0,F|0,23)|0;n=E^(n|D);E=c[h+80+48>>2]|0;J=c[h+80+48+4>>2]|0;o=Jp(q|0,o|0,-1357295717,-1841331548)|0;n=Jp(o|0,D|0,(b|e)^(x|v)^(t|l)|0,n|0)|0;J=Jp(n|0,D|0,E|0,J|0)|0;J=Jp(J|0,D|0,(L^K)&I^L|0,(z^u)&F^z|0)|0;E=D;n=bo(r|0,p|0,28)|0;l=D;t=_n(r|0,p|0,36)|0;l=l|D;v=bo(r|0,p|0,34)|0;x=D;e=_n(r|0,p|0,30)|0;x=l^(x|D);l=bo(r|0,p|0,39)|0;b=D;o=_n(r|0,p|0,25)|0;q=c[w>>2]|0;y=c[w+4>>2]|0;b=Jp((q|f)&r|q&f|0,(y|H)&p|y&H|0,(n|t)^(v|e)^(l|o)|0,x^(b|D)|0)|0;x=D;j=Jp(s|0,j|0,J|0,E|0)|0;s=D;c[A>>2]=j;c[A+4>>2]=s;E=Jp(b|0,x|0,J|0,E|0)|0;J=D;c[C>>2]=E;c[C+4>>2]=J;x=bo(j|0,s|0,14)|0;b=D;o=_n(j|0,s|0,50)|0;b=b|D;l=bo(j|0,s|0,18)|0;e=D;v=_n(j|0,s|0,46)|0;e=b^(e|D);b=bo(j|0,s|0,41)|0;t=D;n=_n(j|0,s|0,23)|0;t=e^(t|D);e=c[h+80+56>>2]|0;H=c[h+80+56+4>>2]|0;z=Jp(L|0,z|0,-630357736,-1424204075)|0;t=Jp(z|0,D|0,(x|o)^(l|v)^(b|n)|0,t|0)|0;H=Jp(t|0,D|0,e|0,H|0)|0;H=Jp(H|0,D|0,(K^I)&j^K|0,(u^F)&s^u|0)|0;e=D;t=bo(E|0,J|0,28)|0;n=D;b=_n(E|0,J|0,36)|0;n=n|D;v=bo(E|0,J|0,34)|0;l=D;o=_n(E|0,J|0,30)|0;l=n^(l|D);n=bo(E|0,J|0,39)|0;x=D;z=_n(E|0,J|0,25)|0;L=c[m>>2]|0;f=c[m+4>>2]|0;x=Jp((L|r)&E|L&r|0,(f|p)&J|f&p|0,(t|b)^(v|o)^(n|z)|0,l^(x|D)|0)|0;l=D;y=Jp(q|0,y|0,H|0,e|0)|0;q=D;c[w>>2]=y;c[w+4>>2]=q;e=Jp(x|0,l|0,H|0,e|0)|0;H=D;c[h+16>>2]=e;c[h+16+4>>2]=H;l=bo(y|0,q|0,14)|0;x=D;z=_n(y|0,q|0,50)|0;x=x|D;n=bo(y|0,q|0,18)|0;o=D;v=_n(y|0,q|0,46)|0;o=x^(o|D);x=bo(y|0,q|0,41)|0;b=D;t=_n(y|0,q|0,23)|0;b=o^(b|D);o=c[h+80+64>>2]|0;p=c[h+80+64+4>>2]|0;u=Jp(K|0,u|0,-1560083902,-670586216)|0;b=Jp(u|0,D|0,(l|z)^(n|v)^(x|t)|0,b|0)|0;p=Jp(b|0,D|0,o|0,p|0)|0;p=Jp(p|0,D|0,(I^j)&y^I|0,(F^s)&q^F|0)|0;o=D;b=bo(e|0,H|0,28)|0;t=D;x=_n(e|0,H|0,36)|0;t=t|D;v=bo(e|0,H|0,34)|0;n=D;z=_n(e|0,H|0,30)|0;n=t^(n|D);t=bo(e|0,H|0,39)|0;l=D;u=_n(e|0,H|0,25)|0;K=c[B>>2]|0;r=c[B+4>>2]|0;l=Jp((K|E)&e|K&E|0,(r|J)&H|r&J|0,(b|x)^(v|z)^(t|u)|0,n^(l|D)|0)|0;n=D;f=Jp(L|0,f|0,p|0,o|0)|0;L=D;c[m>>2]=f;c[m+4>>2]=L;o=Jp(l|0,n|0,p|0,o|0)|0;p=D;c[G>>2]=o;c[G+4>>2]=p;n=bo(f|0,L|0,14)|0;l=D;u=_n(f|0,L|0,50)|0;l=l|D;t=bo(f|0,L|0,18)|0;z=D;v=_n(f|0,L|0,46)|0;z=l^(z|D);l=bo(f|0,L|0,41)|0;x=D;b=_n(f|0,L|0,23)|0;x=z^(x|D);z=c[h+80+72>>2]|0;J=c[h+80+72+4>>2]|0;F=Jp(I|0,F|0,1164996542,310598401)|0;x=Jp(F|0,D|0,(n|u)^(t|v)^(l|b)|0,x|0)|0;J=Jp(x|0,D|0,z|0,J|0)|0;J=Jp(J|0,D|0,(j^y)&f^j|0,(s^q)&L^s|0)|0;z=D;x=bo(o|0,p|0,28)|0;b=D;l=_n(o|0,p|0,36)|0;b=b|D;v=bo(o|0,p|0,34)|0;t=D;u=_n(o|0,p|0,30)|0;t=b^(t|D);b=bo(o|0,p|0,39)|0;n=D;F=_n(o|0,p|0,25)|0;I=c[C>>2]|0;E=c[C+4>>2]|0;n=Jp((I|e)&o|I&e|0,(E|H)&p|E&H|0,(x|l)^(v|u)^(b|F)|0,t^(n|D)|0)|0;t=D;r=Jp(K|0,r|0,J|0,z|0)|0;K=D;c[B>>2]=r;c[B+4>>2]=K;z=Jp(n|0,t|0,J|0,z|0)|0;J=D;c[k>>2]=z;c[k+4>>2]=J;t=bo(r|0,K|0,14)|0;n=D;F=_n(r|0,K|0,50)|0;n=n|D;b=bo(r|0,K|0,18)|0;u=D;v=_n(r|0,K|0,46)|0;u=n^(u|D);n=bo(r|0,K|0,41)|0;l=D;x=_n(r|0,K|0,23)|0;l=u^(l|D);u=c[h+80+80>>2]|0;H=c[h+80+80+4>>2]|0;s=Jp(j|0,s|0,1323610764,607225278)|0;l=Jp(s|0,D|0,(t|F)^(b|v)^(n|x)|0,l|0)|0;H=Jp(l|0,D|0,u|0,H|0)|0;H=Jp(H|0,D|0,(y^f)&r^y|0,(q^L)&K^q|0)|0;u=D;l=bo(z|0,J|0,28)|0;x=D;n=_n(z|0,J|0,36)|0;x=x|D;v=bo(z|0,J|0,34)|0;b=D;F=_n(z|0,J|0,30)|0;b=x^(b|D);x=bo(z|0,J|0,39)|0;t=D;s=_n(z|0,J|0,25)|0;j=c[h+16>>2]|0;e=c[h+16+4>>2]|0;t=Jp((j|o)&z|j&o|0,(e|p)&J|e&p|0,(l|n)^(v|F)^(x|s)|0,b^(t|D)|0)|0;b=D;E=Jp(I|0,E|0,H|0,u|0)|0;I=D;c[C>>2]=E;c[C+4>>2]=I;u=Jp(t|0,b|0,H|0,u|0)|0;H=D;c[A>>2]=u;c[A+4>>2]=H;b=bo(E|0,I|0,14)|0;t=D;s=_n(E|0,I|0,50)|0;t=t|D;x=bo(E|0,I|0,18)|0;F=D;v=_n(E|0,I|0,46)|0;F=t^(F|D);t=bo(E|0,I|0,41)|0;n=D;l=_n(E|0,I|0,23)|0;n=F^(n|D);F=c[h+80+88>>2]|0;p=c[h+80+88+4>>2]|0;q=Jp(y|0,q|0,-704662302,1426881987)|0;n=Jp(q|0,D|0,(b|s)^(x|v)^(t|l)|0,n|0)|0;p=Jp(n|0,D|0,F|0,p|0)|0;p=Jp(p|0,D|0,(f^r)&E^f|0,(L^K)&I^L|0)|0;F=D;n=bo(u|0,H|0,28)|0;l=D;t=_n(u|0,H|0,36)|0;l=l|D;v=bo(u|0,H|0,34)|0;x=D;s=_n(u|0,H|0,30)|0;x=l^(x|D);l=bo(u|0,H|0,39)|0;b=D;q=_n(u|0,H|0,25)|0;y=c[G>>2]|0;o=c[G+4>>2]|0;b=Jp((y|z)&u|y&z|0,(o|J)&H|o&J|0,(n|t)^(v|s)^(l|q)|0,x^(b|D)|0)|0;x=D;e=Jp(j|0,e|0,p|0,F|0)|0;j=D;c[h+16>>2]=e;c[h+16+4>>2]=j;F=Jp(b|0,x|0,p|0,F|0)|0;p=D;c[w>>2]=F;c[w+4>>2]=p;x=bo(e|0,j|0,14)|0;b=D;q=_n(e|0,j|0,50)|0;b=b|D;l=bo(e|0,j|0,18)|0;s=D;v=_n(e|0,j|0,46)|0;s=b^(s|D);b=bo(e|0,j|0,41)|0;t=D;n=_n(e|0,j|0,23)|0;t=s^(t|D);s=c[h+80+96>>2]|0;J=c[h+80+96+4>>2]|0;L=Jp(f|0,L|0,-226784913,1925078388)|0;t=Jp(L|0,D|0,(x|q)^(l|v)^(b|n)|0,t|0)|0;J=Jp(t|0,D|0,s|0,J|0)|0;J=Jp(J|0,D|0,(r^E)&e^r|0,(K^I)&j^K|0)|0;s=D;t=bo(F|0,p|0,28)|0;n=D;b=_n(F|0,p|0,36)|0;n=n|D;v=bo(F|0,p|0,34)|0;l=D;q=_n(F|0,p|0,30)|0;l=n^(l|D);n=bo(F|0,p|0,39)|0;x=D;L=_n(F|0,p|0,25)|0;f=c[k>>2]|0;z=c[k+4>>2]|0;x=Jp((f|u)&F|f&u|0,(z|H)&p|z&H|0,(t|b)^(v|q)^(n|L)|0,l^(x|D)|0)|0;l=D;o=Jp(y|0,o|0,J|0,s|0)|0;y=D;c[G>>2]=o;c[G+4>>2]=y;s=Jp(x|0,l|0,J|0,s|0)|0;J=D;c[m>>2]=s;c[m+4>>2]=J;l=bo(o|0,y|0,14)|0;x=D;L=_n(o|0,y|0,50)|0;x=x|D;n=bo(o|0,y|0,18)|0;q=D;v=_n(o|0,y|0,46)|0;q=x^(q|D);x=bo(o|0,y|0,41)|0;b=D;t=_n(o|0,y|0,23)|0;b=q^(b|D);q=c[h+80+104>>2]|0;H=c[h+80+104+4>>2]|0;K=Jp(r|0,K|0,991336113,-2132889090)|0;b=Jp(K|0,D|0,(l|L)^(n|v)^(x|t)|0,b|0)|0;H=Jp(b|0,D|0,q|0,H|0)|0;H=Jp(H|0,D|0,(E^e)&o^E|0,(I^j)&y^I|0)|0;q=D;b=bo(s|0,J|0,28)|0;t=D;x=_n(s|0,J|0,36)|0;t=t|D;v=bo(s|0,J|0,34)|0;n=D;L=_n(s|0,J|0,30)|0;n=t^(n|D);t=bo(s|0,J|0,39)|0;l=D;K=_n(s|0,J|0,25)|0;r=c[A>>2]|0;u=c[A+4>>2]|0;l=Jp((r|F)&s|r&F|0,(u|p)&J|u&p|0,(b|x)^(v|L)^(t|K)|0,n^(l|D)|0)|0;n=D;z=Jp(f|0,z|0,H|0,q|0)|0;f=D;c[k>>2]=z;c[k+4>>2]=f;q=Jp(l|0,n|0,H|0,q|0)|0;H=D;c[B>>2]=q;c[B+4>>2]=H;n=bo(z|0,f|0,14)|0;l=D;K=_n(z|0,f|0,50)|0;l=l|D;t=bo(z|0,f|0,18)|0;L=D;v=_n(z|0,f|0,46)|0;L=l^(L|D);l=bo(z|0,f|0,41)|0;x=D;b=_n(z|0,f|0,23)|0;x=L^(x|D);L=c[h+80+112>>2]|0;p=c[h+80+112+4>>2]|0;I=Jp(E|0,I|0,633803317,-1680079193)|0;x=Jp(I|0,D|0,(n|K)^(t|v)^(l|b)|0,x|0)|0;p=Jp(x|0,D|0,L|0,p|0)|0;p=Jp(p|0,D|0,(e^o)&z^e|0,(j^y)&f^j|0)|0;L=D;x=bo(q|0,H|0,28)|0;b=D;l=_n(q|0,H|0,36)|0;b=b|D;v=bo(q|0,H|0,34)|0;t=D;K=_n(q|0,H|0,30)|0;t=b^(t|D);b=bo(q|0,H|0,39)|0;n=D;I=_n(q|0,H|0,25)|0;E=c[w>>2]|0;F=c[w+4>>2]|0;n=Jp((E|s)&q|E&s|0,(F|J)&H|F&J|0,(x|l)^(v|K)^(b|I)|0,t^(n|D)|0)|0;t=D;u=Jp(r|0,u|0,p|0,L|0)|0;r=D;c[A>>2]=u;c[A+4>>2]=r;L=Jp(n|0,t|0,p|0,L|0)|0;p=D;c[C>>2]=L;c[C+4>>2]=p;t=bo(u|0,r|0,14)|0;n=D;I=_n(u|0,r|0,50)|0;n=n|D;b=bo(u|0,r|0,18)|0;K=D;v=_n(u|0,r|0,46)|0;K=n^(K|D);n=bo(u|0,r|0,41)|0;l=D;x=_n(u|0,r|0,23)|0;l=K^(l|D);K=c[h+80+120>>2]|0;J=c[h+80+120+4>>2]|0;j=Jp(e|0,j|0,-815192428,-1046744716)|0;l=Jp(j|0,D|0,(t|I)^(b|v)^(n|x)|0,l|0)|0;J=Jp(l|0,D|0,K|0,J|0)|0;J=Jp(J|0,D|0,(o^z)&u^o|0,(y^f)&r^y|0)|0;K=D;l=bo(L|0,p|0,28)|0;x=D;n=_n(L|0,p|0,36)|0;x=x|D;v=bo(L|0,p|0,34)|0;b=D;I=_n(L|0,p|0,30)|0;b=x^(b|D);x=bo(L|0,p|0,39)|0;t=D;j=_n(L|0,p|0,25)|0;e=c[m>>2]|0;s=c[m+4>>2]|0;t=Jp((e|q)&L|e&q|0,(s|H)&p|s&H|0,(l|n)^(v|I)^(x|j)|0,b^(t|D)|0)|0;b=D;F=Jp(E|0,F|0,J|0,K|0)|0;E=D;c[w>>2]=F;c[w+4>>2]=E;K=Jp(t|0,b|0,J|0,K|0)|0;J=D;c[h+16>>2]=K;c[h+16+4>>2]=J;b=bo(F|0,E|0,14)|0;t=D;j=_n(F|0,E|0,50)|0;t=t|D;x=bo(F|0,E|0,18)|0;I=D;v=_n(F|0,E|0,46)|0;I=t^(I|D);t=bo(F|0,E|0,41)|0;n=D;l=_n(F|0,E|0,23)|0;n=I^(n|D);I=c[h+80+128>>2]|0;H=c[h+80+128+4>>2]|0;y=Jp(o|0,y|0,-1628353838,-459576895)|0;n=Jp(y|0,D|0,(b|j)^(x|v)^(t|l)|0,n|0)|0;H=Jp(n|0,D|0,I|0,H|0)|0;H=Jp(H|0,D|0,(z^u)&F^z|0,(f^r)&E^f|0)|0;I=D;n=bo(K|0,J|0,28)|0;l=D;t=_n(K|0,J|0,36)|0;l=l|D;v=bo(K|0,J|0,34)|0;x=D;j=_n(K|0,J|0,30)|0;x=l^(x|D);l=bo(K|0,J|0,39)|0;b=D;y=_n(K|0,J|0,25)|0;o=c[B>>2]|0;q=c[B+4>>2]|0;b=Jp((o|L)&K|o&L|0,(q|p)&J|q&p|0,(n|t)^(v|j)^(l|y)|0,x^(b|D)|0)|0;x=D;s=Jp(e|0,s|0,H|0,I|0)|0;e=D;c[m>>2]=s;c[m+4>>2]=e;I=Jp(b|0,x|0,H|0,I|0)|0;H=D;c[G>>2]=I;c[G+4>>2]=H;x=bo(s|0,e|0,14)|0;b=D;y=_n(s|0,e|0,50)|0;b=b|D;l=bo(s|0,e|0,18)|0;j=D;v=_n(s|0,e|0,46)|0;j=b^(j|D);b=bo(s|0,e|0,41)|0;t=D;n=_n(s|0,e|0,23)|0;t=j^(t|D);j=c[h+80+136>>2]|0;p=c[h+80+136+4>>2]|0;f=Jp(z|0,f|0,944711139,-272742522)|0;t=Jp(f|0,D|0,(x|y)^(l|v)^(b|n)|0,t|0)|0;p=Jp(t|0,D|0,j|0,p|0)|0;p=Jp(p|0,D|0,(u^F)&s^u|0,(r^E)&e^r|0)|0;j=D;t=bo(I|0,H|0,28)|0;n=D;b=_n(I|0,H|0,36)|0;n=n|D;v=bo(I|0,H|0,34)|0;l=D;y=_n(I|0,H|0,30)|0;l=n^(l|D);n=bo(I|0,H|0,39)|0;x=D;f=_n(I|0,H|0,25)|0;z=c[C>>2]|0;L=c[C+4>>2]|0;x=Jp((z|K)&I|z&K|0,(L|J)&H|L&J|0,(t|b)^(v|y)^(n|f)|0,l^(x|D)|0)|0;l=D;q=Jp(o|0,q|0,p|0,j|0)|0;o=D;c[B>>2]=q;c[B+4>>2]=o;j=Jp(x|0,l|0,p|0,j|0)|0;p=D;c[k>>2]=j;c[k+4>>2]=p;l=bo(q|0,o|0,14)|0;x=D;f=_n(q|0,o|0,50)|0;x=x|D;n=bo(q|0,o|0,18)|0;y=D;v=_n(q|0,o|0,46)|0;y=x^(y|D);x=bo(q|0,o|0,41)|0;b=D;t=_n(q|0,o|0,23)|0;b=y^(b|D);y=c[h+80+144>>2]|0;J=c[h+80+144+4>>2]|0;r=Jp(u|0,r|0,-1953704523,264347078)|0;b=Jp(r|0,D|0,(l|f)^(n|v)^(x|t)|0,b|0)|0;J=Jp(b|0,D|0,y|0,J|0)|0;J=Jp(J|0,D|0,(F^s)&q^F|0,(E^e)&o^E|0)|0;y=D;b=bo(j|0,p|0,28)|0;t=D;x=_n(j|0,p|0,36)|0;t=t|D;v=bo(j|0,p|0,34)|0;n=D;f=_n(j|0,p|0,30)|0;n=t^(n|D);t=bo(j|0,p|0,39)|0;l=D;r=_n(j|0,p|0,25)|0;u=c[h+16>>2]|0;K=c[h+16+4>>2]|0;l=Jp((u|I)&j|u&I|0,(K|H)&p|K&H|0,(b|x)^(v|f)^(t|r)|0,n^(l|D)|0)|0;n=D;L=Jp(z|0,L|0,J|0,y|0)|0;z=D;c[C>>2]=L;c[C+4>>2]=z;y=Jp(l|0,n|0,J|0,y|0)|0;J=D;c[A>>2]=y;c[A+4>>2]=J;n=bo(L|0,z|0,14)|0;l=D;r=_n(L|0,z|0,50)|0;l=l|D;t=bo(L|0,z|0,18)|0;f=D;v=_n(L|0,z|0,46)|0;f=l^(f|D);l=bo(L|0,z|0,41)|0;x=D;b=_n(L|0,z|0,23)|0;x=f^(x|D);f=c[h+80+152>>2]|0;H=c[h+80+152+4>>2]|0;E=Jp(F|0,E|0,2007800933,604807628)|0;x=Jp(E|0,D|0,(n|r)^(t|v)^(l|b)|0,x|0)|0;H=Jp(x|0,D|0,f|0,H|0)|0;H=Jp(H|0,D|0,(s^q)&L^s|0,(e^o)&z^e|0)|0;f=D;x=bo(y|0,J|0,28)|0;b=D;l=_n(y|0,J|0,36)|0;b=b|D;v=bo(y|0,J|0,34)|0;t=D;r=_n(y|0,J|0,30)|0;t=b^(t|D);b=bo(y|0,J|0,39)|0;n=D;E=_n(y|0,J|0,25)|0;F=c[G>>2]|0;I=c[G+4>>2]|0;n=Jp((F|j)&y|F&j|0,(I|p)&J|I&p|0,(x|l)^(v|r)^(b|E)|0,t^(n|D)|0)|0;t=D;K=Jp(u|0,K|0,H|0,f|0)|0;u=D;c[h+16>>2]=K;c[h+16+4>>2]=u;f=Jp(n|0,t|0,H|0,f|0)|0;H=D;c[w>>2]=f;c[w+4>>2]=H;t=bo(K|0,u|0,14)|0;n=D;E=_n(K|0,u|0,50)|0;n=n|D;b=bo(K|0,u|0,18)|0;r=D;v=_n(K|0,u|0,46)|0;r=n^(r|D);n=bo(K|0,u|0,41)|0;l=D;x=_n(K|0,u|0,23)|0;l=r^(l|D);r=c[h+80+160>>2]|0;p=c[h+80+160+4>>2]|0;e=Jp(s|0,e|0,1495990901,770255983)|0;l=Jp(e|0,D|0,(t|E)^(b|v)^(n|x)|0,l|0)|0;p=Jp(l|0,D|0,r|0,p|0)|0;p=Jp(p|0,D|0,(q^L)&K^q|0,(o^z)&u^o|0)|0;r=D;l=bo(f|0,H|0,28)|0;x=D;n=_n(f|0,H|0,36)|0;x=x|D;v=bo(f|0,H|0,34)|0;b=D;E=_n(f|0,H|0,30)|0;b=x^(b|D);x=bo(f|0,H|0,39)|0;t=D;e=_n(f|0,H|0,25)|0;s=c[k>>2]|0;j=c[k+4>>2]|0;t=Jp((s|y)&f|s&y|0,(j|J)&H|j&J|0,(l|n)^(v|E)^(x|e)|0,b^(t|D)|0)|0;b=D;I=Jp(F|0,I|0,p|0,r|0)|0;F=D;c[G>>2]=I;c[G+4>>2]=F;r=Jp(t|0,b|0,p|0,r|0)|0;p=D;c[m>>2]=r;c[m+4>>2]=p;b=bo(I|0,F|0,14)|0;t=D;e=_n(I|0,F|0,50)|0;t=t|D;x=bo(I|0,F|0,18)|0;E=D;v=_n(I|0,F|0,46)|0;E=t^(E|D);t=bo(I|0,F|0,41)|0;n=D;l=_n(I|0,F|0,23)|0;n=E^(n|D);E=c[h+80+168>>2]|0;J=c[h+80+168+4>>2]|0;o=Jp(q|0,o|0,1856431235,1249150122)|0;n=Jp(o|0,D|0,(b|e)^(x|v)^(t|l)|0,n|0)|0;J=Jp(n|0,D|0,E|0,J|0)|0;J=Jp(J|0,D|0,(L^K)&I^L|0,(z^u)&F^z|0)|0;E=D;n=bo(r|0,p|0,28)|0;l=D;t=_n(r|0,p|0,36)|0;l=l|D;v=bo(r|0,p|0,34)|0;x=D;e=_n(r|0,p|0,30)|0;x=l^(x|D);l=bo(r|0,p|0,39)|0;b=D;o=_n(r|0,p|0,25)|0;q=c[A>>2]|0;y=c[A+4>>2]|0;b=Jp((q|f)&r|q&f|0,(y|H)&p|y&H|0,(n|t)^(v|e)^(l|o)|0,x^(b|D)|0)|0;x=D;j=Jp(s|0,j|0,J|0,E|0)|0;s=D;c[k>>2]=j;c[k+4>>2]=s;E=Jp(b|0,x|0,J|0,E|0)|0;J=D;c[B>>2]=E;c[B+4>>2]=J;x=bo(j|0,s|0,14)|0;b=D;o=_n(j|0,s|0,50)|0;b=b|D;l=bo(j|0,s|0,18)|0;e=D;v=_n(j|0,s|0,46)|0;e=b^(e|D);b=bo(j|0,s|0,41)|0;t=D;n=_n(j|0,s|0,23)|0;t=e^(t|D);e=c[h+80+176>>2]|0;H=c[h+80+176+4>>2]|0;z=Jp(L|0,z|0,-1119749164,1555081692)|0;t=Jp(z|0,D|0,(x|o)^(l|v)^(b|n)|0,t|0)|0;H=Jp(t|0,D|0,e|0,H|0)|0;H=Jp(H|0,D|0,(K^I)&j^K|0,(u^F)&s^u|0)|0;e=D;t=bo(E|0,J|0,28)|0;n=D;b=_n(E|0,J|0,36)|0;n=n|D;v=bo(E|0,J|0,34)|0;l=D;o=_n(E|0,J|0,30)|0;l=n^(l|D);n=bo(E|0,J|0,39)|0;x=D;z=_n(E|0,J|0,25)|0;L=c[w>>2]|0;f=c[w+4>>2]|0;x=Jp((L|r)&E|L&r|0,(f|p)&J|f&p|0,(t|b)^(v|o)^(n|z)|0,l^(x|D)|0)|0;l=D;y=Jp(q|0,y|0,H|0,e|0)|0;q=D;c[A>>2]=y;c[A+4>>2]=q;e=Jp(x|0,l|0,H|0,e|0)|0;H=D;c[C>>2]=e;c[C+4>>2]=H;l=bo(y|0,q|0,14)|0;x=D;z=_n(y|0,q|0,50)|0;x=x|D;n=bo(y|0,q|0,18)|0;o=D;v=_n(y|0,q|0,46)|0;o=x^(o|D);x=bo(y|0,q|0,41)|0;b=D;t=_n(y|0,q|0,23)|0;b=o^(b|D);o=c[h+80+184>>2]|0;p=c[h+80+184+4>>2]|0;u=Jp(K|0,u|0,-2096016459,1996064986)|0;b=Jp(u|0,D|0,(l|z)^(n|v)^(x|t)|0,b|0)|0;p=Jp(b|0,D|0,o|0,p|0)|0;p=Jp(p|0,D|0,(I^j)&y^I|0,(F^s)&q^F|0)|0;o=D;b=bo(e|0,H|0,28)|0;t=D;x=_n(e|0,H|0,36)|0;t=t|D;v=bo(e|0,H|0,34)|0;n=D;z=_n(e|0,H|0,30)|0;n=t^(n|D);t=bo(e|0,H|0,39)|0;l=D;u=_n(e|0,H|0,25)|0;K=c[m>>2]|0;r=c[m+4>>2]|0;l=Jp((K|E)&e|K&E|0,(r|J)&H|r&J|0,(b|x)^(v|z)^(t|u)|0,n^(l|D)|0)|0;n=D;f=Jp(L|0,f|0,p|0,o|0)|0;L=D;c[w>>2]=f;c[w+4>>2]=L;o=Jp(l|0,n|0,p|0,o|0)|0;p=D;c[h+16>>2]=o;c[h+16+4>>2]=p;n=bo(f|0,L|0,14)|0;l=D;u=_n(f|0,L|0,50)|0;l=l|D;t=bo(f|0,L|0,18)|0;z=D;v=_n(f|0,L|0,46)|0;z=l^(z|D);l=bo(f|0,L|0,41)|0;x=D;b=_n(f|0,L|0,23)|0;x=z^(x|D);z=c[h+80+192>>2]|0;J=c[h+80+192+4>>2]|0;F=Jp(I|0,F|0,-295247957,-1740746414)|0;x=Jp(F|0,D|0,(n|u)^(t|v)^(l|b)|0,x|0)|0;J=Jp(x|0,D|0,z|0,J|0)|0;J=Jp(J|0,D|0,(j^y)&f^j|0,(s^q)&L^s|0)|0;z=D;x=bo(o|0,p|0,28)|0;b=D;l=_n(o|0,p|0,36)|0;b=b|D;v=bo(o|0,p|0,34)|0;t=D;u=_n(o|0,p|0,30)|0;t=b^(t|D);b=bo(o|0,p|0,39)|0;n=D;F=_n(o|0,p|0,25)|0;I=c[B>>2]|0;E=c[B+4>>2]|0;n=Jp((I|e)&o|I&e|0,(E|H)&p|E&H|0,(x|l)^(v|u)^(b|F)|0,t^(n|D)|0)|0;t=D;r=Jp(K|0,r|0,J|0,z|0)|0;K=D;c[m>>2]=r;c[m+4>>2]=K;z=Jp(n|0,t|0,J|0,z|0)|0;J=D;c[G>>2]=z;c[G+4>>2]=J;t=bo(r|0,K|0,14)|0;n=D;F=_n(r|0,K|0,50)|0;n=n|D;b=bo(r|0,K|0,18)|0;u=D;v=_n(r|0,K|0,46)|0;u=n^(u|D);n=bo(r|0,K|0,41)|0;l=D;x=_n(r|0,K|0,23)|0;l=u^(l|D);u=c[h+80+200>>2]|0;H=c[h+80+200+4>>2]|0;s=Jp(j|0,s|0,766784016,-1473132947)|0;l=Jp(s|0,D|0,(t|F)^(b|v)^(n|x)|0,l|0)|0;H=Jp(l|0,D|0,u|0,H|0)|0;H=Jp(H|0,D|0,(y^f)&r^y|0,(q^L)&K^q|0)|0;u=D;l=bo(z|0,J|0,28)|0;x=D;n=_n(z|0,J|0,36)|0;x=x|D;v=bo(z|0,J|0,34)|0;b=D;F=_n(z|0,J|0,30)|0;b=x^(b|D);x=bo(z|0,J|0,39)|0;t=D;s=_n(z|0,J|0,25)|0;j=c[C>>2]|0;e=c[C+4>>2]|0;t=Jp((j|o)&z|j&o|0,(e|p)&J|e&p|0,(l|n)^(v|F)^(x|s)|0,b^(t|D)|0)|0;b=D;E=Jp(I|0,E|0,H|0,u|0)|0;I=D;c[B>>2]=E;c[B+4>>2]=I;u=Jp(t|0,b|0,H|0,u|0)|0;H=D;c[k>>2]=u;c[k+4>>2]=H;b=bo(E|0,I|0,14)|0;t=D;s=_n(E|0,I|0,50)|0;t=t|D;x=bo(E|0,I|0,18)|0;F=D;v=_n(E|0,I|0,46)|0;F=t^(F|D);t=bo(E|0,I|0,41)|0;n=D;l=_n(E|0,I|0,23)|0;n=F^(n|D);F=c[h+80+208>>2]|0;p=c[h+80+208+4>>2]|0;q=Jp(y|0,q|0,-1728372417,-1341970488)|0;n=Jp(q|0,D|0,(b|s)^(x|v)^(t|l)|0,n|0)|0;p=Jp(n|0,D|0,F|0,p|0)|0;p=Jp(p|0,D|0,(f^r)&E^f|0,(L^K)&I^L|0)|0;F=D;n=bo(u|0,H|0,28)|0;l=D;t=_n(u|0,H|0,36)|0;l=l|D;v=bo(u|0,H|0,34)|0;x=D;s=_n(u|0,H|0,30)|0;x=l^(x|D);l=bo(u|0,H|0,39)|0;b=D;q=_n(u|0,H|0,25)|0;y=c[h+16>>2]|0;o=c[h+16+4>>2]|0;b=Jp((y|z)&u|y&z|0,(o|J)&H|o&J|0,(n|t)^(v|s)^(l|q)|0,x^(b|D)|0)|0;x=D;e=Jp(j|0,e|0,p|0,F|0)|0;j=D;c[C>>2]=e;c[C+4>>2]=j;F=Jp(b|0,x|0,p|0,F|0)|0;p=D;c[A>>2]=F;c[A+4>>2]=p;x=bo(e|0,j|0,14)|0;b=D;q=_n(e|0,j|0,50)|0;b=b|D;l=bo(e|0,j|0,18)|0;s=D;v=_n(e|0,j|0,46)|0;s=b^(s|D);b=bo(e|0,j|0,41)|0;t=D;n=_n(e|0,j|0,23)|0;t=s^(t|D);s=c[h+80+216>>2]|0;J=c[h+80+216+4>>2]|0;L=Jp(f|0,L|0,-1091629340,-1084653625)|0;t=Jp(L|0,D|0,(x|q)^(l|v)^(b|n)|0,t|0)|0;J=Jp(t|0,D|0,s|0,J|0)|0;J=Jp(J|0,D|0,(r^E)&e^r|0,(K^I)&j^K|0)|0;s=D;t=bo(F|0,p|0,28)|0;n=D;b=_n(F|0,p|0,36)|0;n=n|D;v=bo(F|0,p|0,34)|0;l=D;q=_n(F|0,p|0,30)|0;l=n^(l|D);n=bo(F|0,p|0,39)|0;x=D;L=_n(F|0,p|0,25)|0;f=c[G>>2]|0;z=c[G+4>>2]|0;x=Jp((f|u)&F|f&u|0,(z|H)&p|z&H|0,(t|b)^(v|q)^(n|L)|0,l^(x|D)|0)|0;l=D;o=Jp(y|0,o|0,J|0,s|0)|0;y=D;c[h+16>>2]=o;c[h+16+4>>2]=y;s=Jp(x|0,l|0,J|0,s|0)|0;J=D;c[w>>2]=s;c[w+4>>2]=J;l=bo(o|0,y|0,14)|0;x=D;L=_n(o|0,y|0,50)|0;x=x|D;n=bo(o|0,y|0,18)|0;q=D;v=_n(o|0,y|0,46)|0;q=x^(q|D);x=bo(o|0,y|0,41)|0;b=D;t=_n(o|0,y|0,23)|0;b=q^(b|D);q=c[h+80+224>>2]|0;H=c[h+80+224+4>>2]|0;K=Jp(r|0,K|0,1034457026,-958395405)|0;b=Jp(K|0,D|0,(l|L)^(n|v)^(x|t)|0,b|0)|0;H=Jp(b|0,D|0,q|0,H|0)|0;H=Jp(H|0,D|0,(E^e)&o^E|0,(I^j)&y^I|0)|0;q=D;b=bo(s|0,J|0,28)|0;t=D;x=_n(s|0,J|0,36)|0;t=t|D;v=bo(s|0,J|0,34)|0;n=D;L=_n(s|0,J|0,30)|0;n=t^(n|D);t=bo(s|0,J|0,39)|0;l=D;K=_n(s|0,J|0,25)|0;r=c[k>>2]|0;u=c[k+4>>2]|0;l=Jp((r|F)&s|r&F|0,(u|p)&J|u&p|0,(b|x)^(v|L)^(t|K)|0,n^(l|D)|0)|0;n=D;z=Jp(f|0,z|0,H|0,q|0)|0;f=D;c[G>>2]=z;c[G+4>>2]=f;q=Jp(l|0,n|0,H|0,q|0)|0;H=D;c[m>>2]=q;c[m+4>>2]=H;n=bo(z|0,f|0,14)|0;l=D;K=_n(z|0,f|0,50)|0;l=l|D;t=bo(z|0,f|0,18)|0;L=D;v=_n(z|0,f|0,46)|0;L=l^(L|D);l=bo(z|0,f|0,41)|0;x=D;b=_n(z|0,f|0,23)|0;x=L^(x|D);L=c[h+80+232>>2]|0;p=c[h+80+232+4>>2]|0;I=Jp(E|0,I|0,-1828018395,-710438585)|0;x=Jp(I|0,D|0,(n|K)^(t|v)^(l|b)|0,x|0)|0;p=Jp(x|0,D|0,L|0,p|0)|0;p=Jp(p|0,D|0,(e^o)&z^e|0,(j^y)&f^j|0)|0;L=D;x=bo(q|0,H|0,28)|0;b=D;l=_n(q|0,H|0,36)|0;b=b|D;v=bo(q|0,H|0,34)|0;t=D;K=_n(q|0,H|0,30)|0;t=b^(t|D);b=bo(q|0,H|0,39)|0;n=D;I=_n(q|0,H|0,25)|0;E=c[A>>2]|0;F=c[A+4>>2]|0;n=Jp((E|s)&q|E&s|0,(F|J)&H|F&J|0,(x|l)^(v|K)^(b|I)|0,t^(n|D)|0)|0;t=D;u=Jp(r|0,u|0,p|0,L|0)|0;r=D;c[k>>2]=u;c[k+4>>2]=r;L=Jp(n|0,t|0,p|0,L|0)|0;p=D;c[B>>2]=L;c[B+4>>2]=p;t=bo(u|0,r|0,14)|0;n=D;I=_n(u|0,r|0,50)|0;n=n|D;b=bo(u|0,r|0,18)|0;K=D;v=_n(u|0,r|0,46)|0;K=n^(K|D);n=bo(u|0,r|0,41)|0;l=D;x=_n(u|0,r|0,23)|0;l=K^(l|D);K=c[h+80+240>>2]|0;J=c[h+80+240+4>>2]|0;j=Jp(e|0,j|0,-536640913,113926993)|0;l=Jp(j|0,D|0,(t|I)^(b|v)^(n|x)|0,l|0)|0;J=Jp(l|0,D|0,K|0,J|0)|0;J=Jp(J|0,D|0,(o^z)&u^o|0,(y^f)&r^y|0)|0;K=D;l=bo(L|0,p|0,28)|0;x=D;n=_n(L|0,p|0,36)|0;x=x|D;v=bo(L|0,p|0,34)|0;b=D;I=_n(L|0,p|0,30)|0;b=x^(b|D);x=bo(L|0,p|0,39)|0;t=D;j=_n(L|0,p|0,25)|0;e=c[w>>2]|0;s=c[w+4>>2]|0;t=Jp((e|q)&L|e&q|0,(s|H)&p|s&H|0,(l|n)^(v|I)^(x|j)|0,b^(t|D)|0)|0;b=D;F=Jp(E|0,F|0,J|0,K|0)|0;E=D;c[A>>2]=F;c[A+4>>2]=E;K=Jp(t|0,b|0,J|0,K|0)|0;J=D;c[C>>2]=K;c[C+4>>2]=J;b=bo(F|0,E|0,14)|0;t=D;j=_n(F|0,E|0,50)|0;t=t|D;x=bo(F|0,E|0,18)|0;I=D;v=_n(F|0,E|0,46)|0;I=t^(I|D);t=bo(F|0,E|0,41)|0;n=D;l=_n(F|0,E|0,23)|0;n=I^(n|D);I=c[h+80+248>>2]|0;H=c[h+80+248+4>>2]|0;y=Jp(o|0,y|0,168717936,338241895)|0;n=Jp(y|0,D|0,(b|j)^(x|v)^(t|l)|0,n|0)|0;H=Jp(n|0,D|0,I|0,H|0)|0;H=Jp(H|0,D|0,(z^u)&F^z|0,(f^r)&E^f|0)|0;I=D;n=bo(K|0,J|0,28)|0;l=D;t=_n(K|0,J|0,36)|0;l=l|D;v=bo(K|0,J|0,34)|0;x=D;j=_n(K|0,J|0,30)|0;x=l^(x|D);l=bo(K|0,J|0,39)|0;b=D;y=_n(K|0,J|0,25)|0;o=c[m>>2]|0;q=c[m+4>>2]|0;b=Jp((o|L)&K|o&L|0,(q|p)&J|q&p|0,(n|t)^(v|j)^(l|y)|0,x^(b|D)|0)|0;x=D;s=Jp(e|0,s|0,H|0,I|0)|0;e=D;c[w>>2]=s;c[w+4>>2]=e;I=Jp(b|0,x|0,H|0,I|0)|0;H=D;c[h+16>>2]=I;c[h+16+4>>2]=H;x=bo(s|0,e|0,14)|0;b=D;y=_n(s|0,e|0,50)|0;b=b|D;l=bo(s|0,e|0,18)|0;j=D;v=_n(s|0,e|0,46)|0;j=b^(j|D);b=bo(s|0,e|0,41)|0;t=D;n=_n(s|0,e|0,23)|0;t=j^(t|D);j=c[h+80+256>>2]|0;p=c[h+80+256+4>>2]|0;f=Jp(z|0,f|0,1188179964,666307205)|0;t=Jp(f|0,D|0,(x|y)^(l|v)^(b|n)|0,t|0)|0;p=Jp(t|0,D|0,j|0,p|0)|0;p=Jp(p|0,D|0,(u^F)&s^u|0,(r^E)&e^r|0)|0;j=D;t=bo(I|0,H|0,28)|0;n=D;b=_n(I|0,H|0,36)|0;n=n|D;v=bo(I|0,H|0,34)|0;l=D;y=_n(I|0,H|0,30)|0;l=n^(l|D);n=bo(I|0,H|0,39)|0;x=D;f=_n(I|0,H|0,25)|0;z=c[B>>2]|0;L=c[B+4>>2]|0;x=Jp((z|K)&I|z&K|0,(L|J)&H|L&J|0,(t|b)^(v|y)^(n|f)|0,l^(x|D)|0)|0;l=D;q=Jp(o|0,q|0,p|0,j|0)|0;o=D;c[m>>2]=q;c[m+4>>2]=o;j=Jp(x|0,l|0,p|0,j|0)|0;p=D;c[G>>2]=j;c[G+4>>2]=p;l=bo(q|0,o|0,14)|0;x=D;f=_n(q|0,o|0,50)|0;x=x|D;n=bo(q|0,o|0,18)|0;y=D;v=_n(q|0,o|0,46)|0;y=x^(y|D);x=bo(q|0,o|0,41)|0;b=D;t=_n(q|0,o|0,23)|0;b=y^(b|D);y=c[h+80+264>>2]|0;J=c[h+80+264+4>>2]|0;r=Jp(u|0,r|0,1546045734,773529912)|0;b=Jp(r|0,D|0,(l|f)^(n|v)^(x|t)|0,b|0)|0;J=Jp(b|0,D|0,y|0,J|0)|0;J=Jp(J|0,D|0,(F^s)&q^F|0,(E^e)&o^E|0)|0;y=D;b=bo(j|0,p|0,28)|0;t=D;x=_n(j|0,p|0,36)|0;t=t|D;v=bo(j|0,p|0,34)|0;n=D;f=_n(j|0,p|0,30)|0;n=t^(n|D);t=bo(j|0,p|0,39)|0;l=D;r=_n(j|0,p|0,25)|0;u=c[C>>2]|0;K=c[C+4>>2]|0;l=Jp((u|I)&j|u&I|0,(K|H)&p|K&H|0,(b|x)^(v|f)^(t|r)|0,n^(l|D)|0)|0;n=D;L=Jp(z|0,L|0,J|0,y|0)|0;z=D;c[B>>2]=L;c[B+4>>2]=z;y=Jp(l|0,n|0,J|0,y|0)|0;J=D;c[k>>2]=y;c[k+4>>2]=J;n=bo(L|0,z|0,14)|0;l=D;r=_n(L|0,z|0,50)|0;l=l|D;t=bo(L|0,z|0,18)|0;f=D;v=_n(L|0,z|0,46)|0;f=l^(f|D);l=bo(L|0,z|0,41)|0;x=D;b=_n(L|0,z|0,23)|0;x=f^(x|D);f=c[h+80+272>>2]|0;H=c[h+80+272+4>>2]|0;E=Jp(F|0,E|0,1522805485,1294757372)|0;x=Jp(E|0,D|0,(n|r)^(t|v)^(l|b)|0,x|0)|0;H=Jp(x|0,D|0,f|0,H|0)|0;H=Jp(H|0,D|0,(s^q)&L^s|0,(e^o)&z^e|0)|0;f=D;x=bo(y|0,J|0,28)|0;b=D;l=_n(y|0,J|0,36)|0;b=b|D;v=bo(y|0,J|0,34)|0;t=D;r=_n(y|0,J|0,30)|0;t=b^(t|D);b=bo(y|0,J|0,39)|0;n=D;E=_n(y|0,J|0,25)|0;F=c[h+16>>2]|0;I=c[h+16+4>>2]|0;n=Jp((F|j)&y|F&j|0,(I|p)&J|I&p|0,(x|l)^(v|r)^(b|E)|0,t^(n|D)|0)|0;t=D;K=Jp(u|0,K|0,H|0,f|0)|0;u=D;c[C>>2]=K;c[C+4>>2]=u;f=Jp(n|0,t|0,H|0,f|0)|0;H=D;c[A>>2]=f;c[A+4>>2]=H;t=bo(K|0,u|0,14)|0;n=D;E=_n(K|0,u|0,50)|0;n=n|D;b=bo(K|0,u|0,18)|0;r=D;v=_n(K|0,u|0,46)|0;r=n^(r|D);n=bo(K|0,u|0,41)|0;l=D;x=_n(K|0,u|0,23)|0;l=r^(l|D);r=c[h+80+280>>2]|0;p=c[h+80+280+4>>2]|0;e=Jp(s|0,e|0,-1651133473,1396182291)|0;l=Jp(e|0,D|0,(t|E)^(b|v)^(n|x)|0,l|0)|0;p=Jp(l|0,D|0,r|0,p|0)|0;p=Jp(p|0,D|0,(q^L)&K^q|0,(o^z)&u^o|0)|0;r=D;l=bo(f|0,H|0,28)|0;x=D;n=_n(f|0,H|0,36)|0;x=x|D;v=bo(f|0,H|0,34)|0;b=D;E=_n(f|0,H|0,30)|0;b=x^(b|D);x=bo(f|0,H|0,39)|0;t=D;e=_n(f|0,H|0,25)|0;s=c[G>>2]|0;j=c[G+4>>2]|0;t=Jp((s|y)&f|s&y|0,(j|J)&H|j&J|0,(l|n)^(v|E)^(x|e)|0,b^(t|D)|0)|0;b=D;I=Jp(F|0,I|0,p|0,r|0)|0;F=D;c[h+16>>2]=I;c[h+16+4>>2]=F;r=Jp(t|0,b|0,p|0,r|0)|0;p=D;c[w>>2]=r;c[w+4>>2]=p;b=bo(I|0,F|0,14)|0;t=D;e=_n(I|0,F|0,50)|0;t=t|D;x=bo(I|0,F|0,18)|0;E=D;v=_n(I|0,F|0,46)|0;E=t^(E|D);t=bo(I|0,F|0,41)|0;n=D;l=_n(I|0,F|0,23)|0;n=E^(n|D);E=c[h+80+288>>2]|0;J=c[h+80+288+4>>2]|0;o=Jp(q|0,o|0,-1951439906,1695183700)|0;n=Jp(o|0,D|0,(b|e)^(x|v)^(t|l)|0,n|0)|0;J=Jp(n|0,D|0,E|0,J|0)|0;J=Jp(J|0,D|0,(L^K)&I^L|0,(z^u)&F^z|0)|0;E=D;n=bo(r|0,p|0,28)|0;l=D;t=_n(r|0,p|0,36)|0;l=l|D;v=bo(r|0,p|0,34)|0;x=D;e=_n(r|0,p|0,30)|0;x=l^(x|D);l=bo(r|0,p|0,39)|0;b=D;o=_n(r|0,p|0,25)|0;q=c[k>>2]|0;y=c[k+4>>2]|0;b=Jp((q|f)&r|q&f|0,(y|H)&p|y&H|0,(n|t)^(v|e)^(l|o)|0,x^(b|D)|0)|0;x=D;j=Jp(s|0,j|0,J|0,E|0)|0;s=D;c[G>>2]=j;c[G+4>>2]=s;E=Jp(b|0,x|0,J|0,E|0)|0;J=D;c[m>>2]=E;c[m+4>>2]=J;x=bo(j|0,s|0,14)|0;b=D;o=_n(j|0,s|0,50)|0;b=b|D;l=bo(j|0,s|0,18)|0;e=D;v=_n(j|0,s|0,46)|0;e=b^(e|D);b=bo(j|0,s|0,41)|0;t=D;n=_n(j|0,s|0,23)|0;t=e^(t|D);e=c[h+80+296>>2]|0;H=c[h+80+296+4>>2]|0;z=Jp(L|0,z|0,1014477480,1986661051)|0;t=Jp(z|0,D|0,(x|o)^(l|v)^(b|n)|0,t|0)|0;H=Jp(t|0,D|0,e|0,H|0)|0;H=Jp(H|0,D|0,(K^I)&j^K|0,(u^F)&s^u|0)|0;e=D;t=bo(E|0,J|0,28)|0;n=D;b=_n(E|0,J|0,36)|0;n=n|D;v=bo(E|0,J|0,34)|0;l=D;o=_n(E|0,J|0,30)|0;l=n^(l|D);n=bo(E|0,J|0,39)|0;x=D;z=_n(E|0,J|0,25)|0;L=c[A>>2]|0;f=c[A+4>>2]|0;x=Jp((L|r)&E|L&r|0,(f|p)&J|f&p|0,(t|b)^(v|o)^(n|z)|0,l^(x|D)|0)|0;l=D;y=Jp(q|0,y|0,H|0,e|0)|0;q=D;c[k>>2]=y;c[k+4>>2]=q;e=Jp(x|0,l|0,H|0,e|0)|0;H=D;c[B>>2]=e;c[B+4>>2]=H;l=bo(y|0,q|0,14)|0;x=D;z=_n(y|0,q|0,50)|0;x=x|D;n=bo(y|0,q|0,18)|0;o=D;v=_n(y|0,q|0,46)|0;o=x^(o|D);x=bo(y|0,q|0,41)|0;b=D;t=_n(y|0,q|0,23)|0;b=o^(b|D);o=c[h+80+304>>2]|0;p=c[h+80+304+4>>2]|0;u=Jp(K|0,u|0,1206759142,-2117940946)|0;b=Jp(u|0,D|0,(l|z)^(n|v)^(x|t)|0,b|0)|0;p=Jp(b|0,D|0,o|0,p|0)|0;p=Jp(p|0,D|0,(I^j)&y^I|0,(F^s)&q^F|0)|0;o=D;b=bo(e|0,H|0,28)|0;t=D;x=_n(e|0,H|0,36)|0;t=t|D;v=bo(e|0,H|0,34)|0;n=D;z=_n(e|0,H|0,30)|0;n=t^(n|D);t=bo(e|0,H|0,39)|0;l=D;u=_n(e|0,H|0,25)|0;K=c[w>>2]|0;r=c[w+4>>2]|0;l=Jp((K|E)&e|K&E|0,(r|J)&H|r&J|0,(b|x)^(v|z)^(t|u)|0,n^(l|D)|0)|0;n=D;f=Jp(L|0,f|0,p|0,o|0)|0;L=D;c[A>>2]=f;c[A+4>>2]=L;o=Jp(l|0,n|0,p|0,o|0)|0;p=D;c[C>>2]=o;c[C+4>>2]=p;n=bo(f|0,L|0,14)|0;l=D;u=_n(f|0,L|0,50)|0;l=l|D;t=bo(f|0,L|0,18)|0;z=D;v=_n(f|0,L|0,46)|0;z=l^(z|D);l=bo(f|0,L|0,41)|0;x=D;b=_n(f|0,L|0,23)|0;x=z^(x|D);z=c[h+80+312>>2]|0;J=c[h+80+312+4>>2]|0;F=Jp(I|0,F|0,344077627,-1838011259)|0;x=Jp(F|0,D|0,(n|u)^(t|v)^(l|b)|0,x|0)|0;J=Jp(x|0,D|0,z|0,J|0)|0;J=Jp(J|0,D|0,(j^y)&f^j|0,(s^q)&L^s|0)|0;z=D;x=bo(o|0,p|0,28)|0;b=D;l=_n(o|0,p|0,36)|0;b=b|D;v=bo(o|0,p|0,34)|0;t=D;u=_n(o|0,p|0,30)|0;t=b^(t|D);b=bo(o|0,p|0,39)|0;n=D;F=_n(o|0,p|0,25)|0;I=c[m>>2]|0;E=c[m+4>>2]|0;n=Jp((I|e)&o|I&e|0,(E|H)&p|E&H|0,(x|l)^(v|u)^(b|F)|0,t^(n|D)|0)|0;t=D;r=Jp(K|0,r|0,J|0,z|0)|0;K=D;c[w>>2]=r;c[w+4>>2]=K;z=Jp(n|0,t|0,J|0,z|0)|0;J=D;c[h+16>>2]=z;c[h+16+4>>2]=J;t=bo(r|0,K|0,14)|0;n=D;F=_n(r|0,K|0,50)|0;n=n|D;b=bo(r|0,K|0,18)|0;u=D;v=_n(r|0,K|0,46)|0;u=n^(u|D);n=bo(r|0,K|0,41)|0;l=D;x=_n(r|0,K|0,23)|0;l=u^(l|D);u=c[h+80+320>>2]|0;H=c[h+80+320+4>>2]|0;s=Jp(j|0,s|0,1290863460,-1564481375)|0;l=Jp(s|0,D|0,(t|F)^(b|v)^(n|x)|0,l|0)|0;H=Jp(l|0,D|0,u|0,H|0)|0;H=Jp(H|0,D|0,(y^f)&r^y|0,(q^L)&K^q|0)|0;u=D;l=bo(z|0,J|0,28)|0;x=D;n=_n(z|0,J|0,36)|0;x=x|D;v=bo(z|0,J|0,34)|0;b=D;F=_n(z|0,J|0,30)|0;b=x^(b|D);x=bo(z|0,J|0,39)|0;t=D;s=_n(z|0,J|0,25)|0;j=c[B>>2]|0;e=c[B+4>>2]|0;t=Jp((j|o)&z|j&o|0,(e|p)&J|e&p|0,(l|n)^(v|F)^(x|s)|0,b^(t|D)|0)|0;b=D;E=Jp(I|0,E|0,H|0,u|0)|0;I=D;c[m>>2]=E;c[m+4>>2]=I;u=Jp(t|0,b|0,H|0,u|0)|0;H=D;c[G>>2]=u;c[G+4>>2]=H;b=bo(E|0,I|0,14)|0;t=D;s=_n(E|0,I|0,50)|0;t=t|D;x=bo(E|0,I|0,18)|0;F=D;v=_n(E|0,I|0,46)|0;F=t^(F|D);t=bo(E|0,I|0,41)|0;n=D;l=_n(E|0,I|0,23)|0;n=F^(n|D);F=c[h+80+328>>2]|0;p=c[h+80+328+4>>2]|0;q=Jp(y|0,q|0,-1136513023,-1474664885)|0;n=Jp(q|0,D|0,(b|s)^(x|v)^(t|l)|0,n|0)|0;p=Jp(n|0,D|0,F|0,p|0)|0;p=Jp(p|0,D|0,(f^r)&E^f|0,(L^K)&I^L|0)|0;F=D;n=bo(u|0,H|0,28)|0;l=D;t=_n(u|0,H|0,36)|0;l=l|D;v=bo(u|0,H|0,34)|0;x=D;s=_n(u|0,H|0,30)|0;x=l^(x|D);l=bo(u|0,H|0,39)|0;b=D;q=_n(u|0,H|0,25)|0;y=c[C>>2]|0;o=c[C+4>>2]|0;b=Jp((y|z)&u|y&z|0,(o|J)&H|o&J|0,(n|t)^(v|s)^(l|q)|0,x^(b|D)|0)|0;x=D;e=Jp(j|0,e|0,p|0,F|0)|0;j=D;c[B>>2]=e;c[B+4>>2]=j;F=Jp(b|0,x|0,p|0,F|0)|0;p=D;c[k>>2]=F;c[k+4>>2]=p;x=bo(e|0,j|0,14)|0;b=D;q=_n(e|0,j|0,50)|0;b=b|D;l=bo(e|0,j|0,18)|0;s=D;v=_n(e|0,j|0,46)|0;s=b^(s|D);b=bo(e|0,j|0,41)|0;t=D;n=_n(e|0,j|0,23)|0;t=s^(t|D);s=c[h+80+336>>2]|0;J=c[h+80+336+4>>2]|0;L=Jp(f|0,L|0,-789014639,-1035236496)|0;t=Jp(L|0,D|0,(x|q)^(l|v)^(b|n)|0,t|0)|0;J=Jp(t|0,D|0,s|0,J|0)|0;J=Jp(J|0,D|0,(r^E)&e^r|0,(K^I)&j^K|0)|0;s=D;t=bo(F|0,p|0,28)|0;n=D;b=_n(F|0,p|0,36)|0;n=n|D;v=bo(F|0,p|0,34)|0;l=D;q=_n(F|0,p|0,30)|0;l=n^(l|D);n=bo(F|0,p|0,39)|0;x=D;L=_n(F|0,p|0,25)|0;f=c[h+16>>2]|0;z=c[h+16+4>>2]|0;x=Jp((f|u)&F|f&u|0,(z|H)&p|z&H|0,(t|b)^(v|q)^(n|L)|0,l^(x|D)|0)|0;l=D;o=Jp(y|0,o|0,J|0,s|0)|0;y=D;c[C>>2]=o;c[C+4>>2]=y;s=Jp(x|0,l|0,J|0,s|0)|0;J=D;c[A>>2]=s;c[A+4>>2]=J;l=bo(o|0,y|0,14)|0;x=D;L=_n(o|0,y|0,50)|0;x=x|D;n=bo(o|0,y|0,18)|0;q=D;v=_n(o|0,y|0,46)|0;q=x^(q|D);x=bo(o|0,y|0,41)|0;b=D;t=_n(o|0,y|0,23)|0;b=q^(b|D);q=c[h+80+344>>2]|0;H=c[h+80+344+4>>2]|0;K=Jp(r|0,K|0,106217008,-949202525)|0;b=Jp(K|0,D|0,(l|L)^(n|v)^(x|t)|0,b|0)|0;H=Jp(b|0,D|0,q|0,H|0)|0;H=Jp(H|0,D|0,(E^e)&o^E|0,(I^j)&y^I|0)|0;q=D;b=bo(s|0,J|0,28)|0;t=D;x=_n(s|0,J|0,36)|0;t=t|D;v=bo(s|0,J|0,34)|0;n=D;L=_n(s|0,J|0,30)|0;n=t^(n|D);t=bo(s|0,J|0,39)|0;l=D;K=_n(s|0,J|0,25)|0;r=c[G>>2]|0;u=c[G+4>>2]|0;l=Jp((r|F)&s|r&F|0,(u|p)&J|u&p|0,(b|x)^(v|L)^(t|K)|0,n^(l|D)|0)|0;n=D;z=Jp(f|0,z|0,H|0,q|0)|0;f=D;c[h+16>>2]=z;c[h+16+4>>2]=f;q=Jp(l|0,n|0,H|0,q|0)|0;H=D;c[w>>2]=q;c[w+4>>2]=H;n=bo(z|0,f|0,14)|0;l=D;K=_n(z|0,f|0,50)|0;l=l|D;t=bo(z|0,f|0,18)|0;L=D;v=_n(z|0,f|0,46)|0;L=l^(L|D);l=bo(z|0,f|0,41)|0;x=D;b=_n(z|0,f|0,23)|0;x=L^(x|D);L=c[h+80+352>>2]|0;p=c[h+80+352+4>>2]|0;I=Jp(E|0,I|0,-688958952,-778901479)|0;x=Jp(I|0,D|0,(n|K)^(t|v)^(l|b)|0,x|0)|0;p=Jp(x|0,D|0,L|0,p|0)|0;p=Jp(p|0,D|0,(e^o)&z^e|0,(j^y)&f^j|0)|0;L=D;x=bo(q|0,H|0,28)|0;b=D;l=_n(q|0,H|0,36)|0;b=b|D;v=bo(q|0,H|0,34)|0;t=D;K=_n(q|0,H|0,30)|0;t=b^(t|D);b=bo(q|0,H|0,39)|0;n=D;I=_n(q|0,H|0,25)|0;E=c[k>>2]|0;F=c[k+4>>2]|0;n=Jp((E|s)&q|E&s|0,(F|J)&H|F&J|0,(x|l)^(v|K)^(b|I)|0,t^(n|D)|0)|0;t=D;u=Jp(r|0,u|0,p|0,L|0)|0;r=D;c[G>>2]=u;c[G+4>>2]=r;L=Jp(n|0,t|0,p|0,L|0)|0;p=D;c[m>>2]=L;c[m+4>>2]=p;t=bo(u|0,r|0,14)|0;n=D;I=_n(u|0,r|0,50)|0;n=n|D;b=bo(u|0,r|0,18)|0;K=D;v=_n(u|0,r|0,46)|0;K=n^(K|D);n=bo(u|0,r|0,41)|0;l=D;x=_n(u|0,r|0,23)|0;l=K^(l|D);K=c[h+80+360>>2]|0;J=c[h+80+360+4>>2]|0;j=Jp(e|0,j|0,1432725776,-694614492)|0;l=Jp(j|0,D|0,(t|I)^(b|v)^(n|x)|0,l|0)|0;J=Jp(l|0,D|0,K|0,J|0)|0;J=Jp(J|0,D|0,(o^z)&u^o|0,(y^f)&r^y|0)|0;K=D;l=bo(L|0,p|0,28)|0;x=D;n=_n(L|0,p|0,36)|0;x=x|D;v=bo(L|0,p|0,34)|0;b=D;I=_n(L|0,p|0,30)|0;b=x^(b|D);x=bo(L|0,p|0,39)|0;t=D;j=_n(L|0,p|0,25)|0;e=c[A>>2]|0;s=c[A+4>>2]|0;t=Jp((e|q)&L|e&q|0,(s|H)&p|s&H|0,(l|n)^(v|I)^(x|j)|0,b^(t|D)|0)|0;b=D;F=Jp(E|0,F|0,J|0,K|0)|0;E=D;c[k>>2]=F;c[k+4>>2]=E;K=Jp(t|0,b|0,J|0,K|0)|0;J=D;c[B>>2]=K;c[B+4>>2]=J;b=bo(F|0,E|0,14)|0;t=D;j=_n(F|0,E|0,50)|0;t=t|D;x=bo(F|0,E|0,18)|0;I=D;v=_n(F|0,E|0,46)|0;I=t^(I|D);t=bo(F|0,E|0,41)|0;n=D;l=_n(F|0,E|0,23)|0;n=I^(n|D);I=c[h+80+368>>2]|0;H=c[h+80+368+4>>2]|0;y=Jp(o|0,y|0,1467031594,-200395387)|0;n=Jp(y|0,D|0,(b|j)^(x|v)^(t|l)|0,n|0)|0;H=Jp(n|0,D|0,I|0,H|0)|0;H=Jp(H|0,D|0,(z^u)&F^z|0,(f^r)&E^f|0)|0;I=D;n=bo(K|0,J|0,28)|0;l=D;t=_n(K|0,J|0,36)|0;l=l|D;v=bo(K|0,J|0,34)|0;x=D;j=_n(K|0,J|0,30)|0;x=l^(x|D);l=bo(K|0,J|0,39)|0;b=D;y=_n(K|0,J|0,25)|0;o=c[w>>2]|0;q=c[w+4>>2]|0;b=Jp((o|L)&K|o&L|0,(q|p)&J|q&p|0,(n|t)^(v|j)^(l|y)|0,x^(b|D)|0)|0;x=D;s=Jp(e|0,s|0,H|0,I|0)|0;e=D;c[A>>2]=s;c[A+4>>2]=e;I=Jp(b|0,x|0,H|0,I|0)|0;H=D;c[C>>2]=I;c[C+4>>2]=H;x=bo(s|0,e|0,14)|0;b=D;y=_n(s|0,e|0,50)|0;b=b|D;l=bo(s|0,e|0,18)|0;j=D;v=_n(s|0,e|0,46)|0;j=b^(j|D);b=bo(s|0,e|0,41)|0;t=D;n=_n(s|0,e|0,23)|0;t=j^(t|D);j=c[h+80+376>>2]|0;p=c[h+80+376+4>>2]|0;f=Jp(z|0,f|0,851169720,275423344)|0;t=Jp(f|0,D|0,(x|y)^(l|v)^(b|n)|0,t|0)|0;p=Jp(t|0,D|0,j|0,p|0)|0;p=Jp(p|0,D|0,(u^F)&s^u|0,(r^E)&e^r|0)|0;j=D;t=bo(I|0,H|0,28)|0;n=D;b=_n(I|0,H|0,36)|0;n=n|D;v=bo(I|0,H|0,34)|0;l=D;y=_n(I|0,H|0,30)|0;l=n^(l|D);n=bo(I|0,H|0,39)|0;x=D;f=_n(I|0,H|0,25)|0;z=c[m>>2]|0;L=c[m+4>>2]|0;x=Jp((z|K)&I|z&K|0,(L|J)&H|L&J|0,(t|b)^(v|y)^(n|f)|0,l^(x|D)|0)|0;l=D;q=Jp(o|0,q|0,p|0,j|0)|0;o=D;c[w>>2]=q;c[w+4>>2]=o;j=Jp(x|0,l|0,p|0,j|0)|0;p=D;c[h+16>>2]=j;c[h+16+4>>2]=p;l=bo(q|0,o|0,14)|0;x=D;f=_n(q|0,o|0,50)|0;x=x|D;n=bo(q|0,o|0,18)|0;y=D;v=_n(q|0,o|0,46)|0;y=x^(y|D);x=bo(q|0,o|0,41)|0;b=D;t=_n(q|0,o|0,23)|0;b=y^(b|D);y=c[h+80+384>>2]|0;J=c[h+80+384+4>>2]|0;r=Jp(u|0,r|0,-1194143544,430227734)|0;b=Jp(r|0,D|0,(l|f)^(n|v)^(x|t)|0,b|0)|0;J=Jp(b|0,D|0,y|0,J|0)|0;J=Jp(J|0,D|0,(F^s)&q^F|0,(E^e)&o^E|0)|0;y=D;b=bo(j|0,p|0,28)|0;t=D;x=_n(j|0,p|0,36)|0;t=t|D;v=bo(j|0,p|0,34)|0;n=D;f=_n(j|0,p|0,30)|0;n=t^(n|D);t=bo(j|0,p|0,39)|0;l=D;r=_n(j|0,p|0,25)|0;u=c[B>>2]|0;K=c[B+4>>2]|0;l=Jp((u|I)&j|u&I|0,(K|H)&p|K&H|0,(b|x)^(v|f)^(t|r)|0,n^(l|D)|0)|0;n=D;L=Jp(z|0,L|0,J|0,y|0)|0;z=D;c[m>>2]=L;c[m+4>>2]=z;y=Jp(l|0,n|0,J|0,y|0)|0;J=D;c[G>>2]=y;c[G+4>>2]=J;n=bo(L|0,z|0,14)|0;l=D;r=_n(L|0,z|0,50)|0;l=l|D;t=bo(L|0,z|0,18)|0;f=D;v=_n(L|0,z|0,46)|0;f=l^(f|D);l=bo(L|0,z|0,41)|0;x=D;b=_n(L|0,z|0,23)|0;x=f^(x|D);f=c[h+80+392>>2]|0;H=c[h+80+392+4>>2]|0;E=Jp(F|0,E|0,1363258195,506948616)|0;x=Jp(E|0,D|0,(n|r)^(t|v)^(l|b)|0,x|0)|0;H=Jp(x|0,D|0,f|0,H|0)|0;H=Jp(H|0,D|0,(s^q)&L^s|0,(e^o)&z^e|0)|0;f=D;x=bo(y|0,J|0,28)|0;b=D;l=_n(y|0,J|0,36)|0;b=b|D;v=bo(y|0,J|0,34)|0;t=D;r=_n(y|0,J|0,30)|0;t=b^(t|D);b=bo(y|0,J|0,39)|0;n=D;E=_n(y|0,J|0,25)|0;F=c[C>>2]|0;I=c[C+4>>2]|0;n=Jp((F|j)&y|F&j|0,(I|p)&J|I&p|0,(x|l)^(v|r)^(b|E)|0,t^(n|D)|0)|0;t=D;K=Jp(u|0,K|0,H|0,f|0)|0;u=D;c[B>>2]=K;c[B+4>>2]=u;f=Jp(n|0,t|0,H|0,f|0)|0;H=D;c[k>>2]=f;c[k+4>>2]=H;t=bo(K|0,u|0,14)|0;n=D;E=_n(K|0,u|0,50)|0;n=n|D;b=bo(K|0,u|0,18)|0;r=D;v=_n(K|0,u|0,46)|0;r=n^(r|D);n=bo(K|0,u|0,41)|0;l=D;x=_n(K|0,u|0,23)|0;l=r^(l|D);r=c[h+80+400>>2]|0;p=c[h+80+400+4>>2]|0;e=Jp(s|0,e|0,-544281703,659060556)|0;l=Jp(e|0,D|0,(t|E)^(b|v)^(n|x)|0,l|0)|0;p=Jp(l|0,D|0,r|0,p|0)|0;p=Jp(p|0,D|0,(q^L)&K^q|0,(o^z)&u^o|0)|0;r=D;l=bo(f|0,H|0,28)|0;x=D;n=_n(f|0,H|0,36)|0;x=x|D;v=bo(f|0,H|0,34)|0;b=D;E=_n(f|0,H|0,30)|0;b=x^(b|D);x=bo(f|0,H|0,39)|0;t=D;e=_n(f|0,H|0,25)|0;s=c[h+16>>2]|0;j=c[h+16+4>>2]|0;t=Jp((s|y)&f|s&y|0,(j|J)&H|j&J|0,(l|n)^(v|E)^(x|e)|0,b^(t|D)|0)|0;b=D;I=Jp(F|0,I|0,p|0,r|0)|0;F=D;c[C>>2]=I;c[C+4>>2]=F;r=Jp(t|0,b|0,p|0,r|0)|0;p=D;c[A>>2]=r;c[A+4>>2]=p;b=bo(I|0,F|0,14)|0;t=D;e=_n(I|0,F|0,50)|0;t=t|D;x=bo(I|0,F|0,18)|0;E=D;v=_n(I|0,F|0,46)|0;E=t^(E|D);t=bo(I|0,F|0,41)|0;n=D;l=_n(I|0,F|0,23)|0;n=E^(n|D);E=c[h+80+408>>2]|0;J=c[h+80+408+4>>2]|0;o=Jp(q|0,o|0,-509917016,883997877)|0;n=Jp(o|0,D|0,(b|e)^(x|v)^(t|l)|0,n|0)|0;J=Jp(n|0,D|0,E|0,J|0)|0;J=Jp(J|0,D|0,(L^K)&I^L|0,(z^u)&F^z|0)|0;E=D;n=bo(r|0,p|0,28)|0;l=D;t=_n(r|0,p|0,36)|0;l=l|D;v=bo(r|0,p|0,34)|0;x=D;e=_n(r|0,p|0,30)|0;x=l^(x|D);l=bo(r|0,p|0,39)|0;b=D;o=_n(r|0,p|0,25)|0;q=c[G>>2]|0;y=c[G+4>>2]|0;b=Jp((q|f)&r|q&f|0,(y|H)&p|y&H|0,(n|t)^(v|e)^(l|o)|0,x^(b|D)|0)|0;x=D;j=Jp(s|0,j|0,J|0,E|0)|0;s=D;c[h+16>>2]=j;c[h+16+4>>2]=s;E=Jp(b|0,x|0,J|0,E|0)|0;J=D;c[w>>2]=E;c[w+4>>2]=J;x=bo(j|0,s|0,14)|0;b=D;o=_n(j|0,s|0,50)|0;b=b|D;l=bo(j|0,s|0,18)|0;e=D;v=_n(j|0,s|0,46)|0;e=b^(e|D);b=bo(j|0,s|0,41)|0;t=D;n=_n(j|0,s|0,23)|0;t=e^(t|D);e=c[h+80+416>>2]|0;H=c[h+80+416+4>>2]|0;z=Jp(L|0,z|0,-976659869,958139571)|0;t=Jp(z|0,D|0,(x|o)^(l|v)^(b|n)|0,t|0)|0;H=Jp(t|0,D|0,e|0,H|0)|0;H=Jp(H|0,D|0,(K^I)&j^K|0,(u^F)&s^u|0)|0;e=D;t=bo(E|0,J|0,28)|0;n=D;b=_n(E|0,J|0,36)|0;n=n|D;v=bo(E|0,J|0,34)|0;l=D;o=_n(E|0,J|0,30)|0;l=n^(l|D);n=bo(E|0,J|0,39)|0;x=D;z=_n(E|0,J|0,25)|0;L=c[k>>2]|0;f=c[k+4>>2]|0;x=Jp((L|r)&E|L&r|0,(f|p)&J|f&p|0,(t|b)^(v|o)^(n|z)|0,l^(x|D)|0)|0;l=D;y=Jp(q|0,y|0,H|0,e|0)|0;q=D;c[G>>2]=y;c[G+4>>2]=q;e=Jp(x|0,l|0,H|0,e|0)|0;H=D;c[m>>2]=e;c[m+4>>2]=H;l=bo(y|0,q|0,14)|0;x=D;z=_n(y|0,q|0,50)|0;x=x|D;n=bo(y|0,q|0,18)|0;o=D;v=_n(y|0,q|0,46)|0;o=x^(o|D);x=bo(y|0,q|0,41)|0;b=D;t=_n(y|0,q|0,23)|0;b=o^(b|D);o=c[h+80+424>>2]|0;p=c[h+80+424+4>>2]|0;u=Jp(K|0,u|0,-482243893,1322822218)|0;b=Jp(u|0,D|0,(l|z)^(n|v)^(x|t)|0,b|0)|0;p=Jp(b|0,D|0,o|0,p|0)|0;p=Jp(p|0,D|0,(I^j)&y^I|0,(F^s)&q^F|0)|0;o=D;b=bo(e|0,H|0,28)|0;t=D;x=_n(e|0,H|0,36)|0;t=t|D;v=bo(e|0,H|0,34)|0;n=D;z=_n(e|0,H|0,30)|0;n=t^(n|D);t=bo(e|0,H|0,39)|0;l=D;u=_n(e|0,H|0,25)|0;K=c[A>>2]|0;r=c[A+4>>2]|0;l=Jp((K|E)&e|K&E|0,(r|J)&H|r&J|0,(b|x)^(v|z)^(t|u)|0,n^(l|D)|0)|0;n=D;f=Jp(L|0,f|0,p|0,o|0)|0;L=D;c[k>>2]=f;c[k+4>>2]=L;o=Jp(l|0,n|0,p|0,o|0)|0;p=D;c[B>>2]=o;c[B+4>>2]=p;n=bo(f|0,L|0,14)|0;l=D;u=_n(f|0,L|0,50)|0;l=l|D;t=bo(f|0,L|0,18)|0;z=D;v=_n(f|0,L|0,46)|0;z=l^(z|D);l=bo(f|0,L|0,41)|0;x=D;b=_n(f|0,L|0,23)|0;x=z^(x|D);z=c[h+80+432>>2]|0;J=c[h+80+432+4>>2]|0;F=Jp(I|0,F|0,2003034995,1537002063)|0;x=Jp(F|0,D|0,(n|u)^(t|v)^(l|b)|0,x|0)|0;J=Jp(x|0,D|0,z|0,J|0)|0;J=Jp(J|0,D|0,(j^y)&f^j|0,(s^q)&L^s|0)|0;z=D;x=bo(o|0,p|0,28)|0;b=D;l=_n(o|0,p|0,36)|0;b=b|D;v=bo(o|0,p|0,34)|0;t=D;u=_n(o|0,p|0,30)|0;t=b^(t|D);b=bo(o|0,p|0,39)|0;n=D;F=_n(o|0,p|0,25)|0;I=c[w>>2]|0;E=c[w+4>>2]|0;n=Jp((I|e)&o|I&e|0,(E|H)&p|E&H|0,(x|l)^(v|u)^(b|F)|0,t^(n|D)|0)|0;t=D;r=Jp(K|0,r|0,J|0,z|0)|0;K=D;c[A>>2]=r;c[A+4>>2]=K;z=Jp(n|0,t|0,J|0,z|0)|0;J=D;c[C>>2]=z;c[C+4>>2]=J;t=bo(r|0,K|0,14)|0;n=D;F=_n(r|0,K|0,50)|0;n=n|D;b=bo(r|0,K|0,18)|0;u=D;v=_n(r|0,K|0,46)|0;u=n^(u|D);n=bo(r|0,K|0,41)|0;l=D;x=_n(r|0,K|0,23)|0;l=u^(l|D);u=c[h+80+440>>2]|0;H=c[h+80+440+4>>2]|0;s=Jp(j|0,s|0,-692930397,1747873779)|0;l=Jp(s|0,D|0,(t|F)^(b|v)^(n|x)|0,l|0)|0;H=Jp(l|0,D|0,u|0,H|0)|0;H=Jp(H|0,D|0,(y^f)&r^y|0,(q^L)&K^q|0)|0;u=D;l=bo(z|0,J|0,28)|0;x=D;n=_n(z|0,J|0,36)|0;x=x|D;v=bo(z|0,J|0,34)|0;b=D;F=_n(z|0,J|0,30)|0;b=x^(b|D);x=bo(z|0,J|0,39)|0;t=D;s=_n(z|0,J|0,25)|0;j=c[m>>2]|0;e=c[m+4>>2]|0;t=Jp((j|o)&z|j&o|0,(e|p)&J|e&p|0,(l|n)^(v|F)^(x|s)|0,b^(t|D)|0)|0;b=D;E=Jp(I|0,E|0,H|0,u|0)|0;I=D;c[w>>2]=E;c[w+4>>2]=I;u=Jp(t|0,b|0,H|0,u|0)|0;H=D;c[h+16>>2]=u;c[h+16+4>>2]=H;b=bo(E|0,I|0,14)|0;t=D;s=_n(E|0,I|0,50)|0;t=t|D;x=bo(E|0,I|0,18)|0;F=D;v=_n(E|0,I|0,46)|0;F=t^(F|D);t=bo(E|0,I|0,41)|0;n=D;l=_n(E|0,I|0,23)|0;n=F^(n|D);F=c[h+80+448>>2]|0;p=c[h+80+448+4>>2]|0;q=Jp(y|0,q|0,1575990012,1955562222)|0;n=Jp(q|0,D|0,(b|s)^(x|v)^(t|l)|0,n|0)|0;p=Jp(n|0,D|0,F|0,p|0)|0;p=Jp(p|0,D|0,(f^r)&E^f|0,(L^K)&I^L|0)|0;F=D;n=bo(u|0,H|0,28)|0;l=D;t=_n(u|0,H|0,36)|0;l=l|D;v=bo(u|0,H|0,34)|0;x=D;s=_n(u|0,H|0,30)|0;x=l^(x|D);l=bo(u|0,H|0,39)|0;b=D;q=_n(u|0,H|0,25)|0;y=c[B>>2]|0;o=c[B+4>>2]|0;b=Jp((y|z)&u|y&z|0,(o|J)&H|o&J|0,(n|t)^(v|s)^(l|q)|0,x^(b|D)|0)|0;x=D;e=Jp(j|0,e|0,p|0,F|0)|0;j=D;c[m>>2]=e;c[m+4>>2]=j;F=Jp(b|0,x|0,p|0,F|0)|0;p=D;c[G>>2]=F;c[G+4>>2]=p;x=bo(e|0,j|0,14)|0;b=D;q=_n(e|0,j|0,50)|0;b=b|D;l=bo(e|0,j|0,18)|0;s=D;v=_n(e|0,j|0,46)|0;s=b^(s|D);b=bo(e|0,j|0,41)|0;t=D;n=_n(e|0,j|0,23)|0;t=s^(t|D);s=c[h+80+456>>2]|0;J=c[h+80+456+4>>2]|0;L=Jp(f|0,L|0,1125592928,2024104815)|0;t=Jp(L|0,D|0,(x|q)^(l|v)^(b|n)|0,t|0)|0;J=Jp(t|0,D|0,s|0,J|0)|0;J=Jp(J|0,D|0,(r^E)&e^r|0,(K^I)&j^K|0)|0;s=D;t=bo(F|0,p|0,28)|0;n=D;b=_n(F|0,p|0,36)|0;n=n|D;v=bo(F|0,p|0,34)|0;l=D;q=_n(F|0,p|0,30)|0;l=n^(l|D);n=bo(F|0,p|0,39)|0;x=D;L=_n(F|0,p|0,25)|0;f=c[C>>2]|0;z=c[C+4>>2]|0;x=Jp((f|u)&F|f&u|0,(z|H)&p|z&H|0,(t|b)^(v|q)^(n|L)|0,l^(x|D)|0)|0;l=D;o=Jp(y|0,o|0,J|0,s|0)|0;y=D;c[B>>2]=o;c[B+4>>2]=y;s=Jp(x|0,l|0,J|0,s|0)|0;J=D;c[k>>2]=s;c[k+4>>2]=J;l=bo(o|0,y|0,14)|0;x=D;L=_n(o|0,y|0,50)|0;x=x|D;n=bo(o|0,y|0,18)|0;q=D;v=_n(o|0,y|0,46)|0;q=x^(q|D);x=bo(o|0,y|0,41)|0;b=D;t=_n(o|0,y|0,23)|0;b=q^(b|D);q=c[h+80+464>>2]|0;H=c[h+80+464+4>>2]|0;K=Jp(r|0,K|0,-1578062990,-2067236844)|0;b=Jp(K|0,D|0,(l|L)^(n|v)^(x|t)|0,b|0)|0;H=Jp(b|0,D|0,q|0,H|0)|0;H=Jp(H|0,D|0,(E^e)&o^E|0,(I^j)&y^I|0)|0;q=D;b=bo(s|0,J|0,28)|0;t=D;x=_n(s|0,J|0,36)|0;t=t|D;v=bo(s|0,J|0,34)|0;n=D;L=_n(s|0,J|0,30)|0;n=t^(n|D);t=bo(s|0,J|0,39)|0;l=D;K=_n(s|0,J|0,25)|0;r=c[h+16>>2]|0;u=c[h+16+4>>2]|0;l=Jp((r|F)&s|r&F|0,(u|p)&J|u&p|0,(b|x)^(v|L)^(t|K)|0,n^(l|D)|0)|0;n=D;z=Jp(f|0,z|0,H|0,q|0)|0;f=D;c[C>>2]=z;c[C+4>>2]=f;q=Jp(l|0,n|0,H|0,q|0)|0;H=D;c[A>>2]=q;c[A+4>>2]=H;n=bo(z|0,f|0,14)|0;l=D;K=_n(z|0,f|0,50)|0;l=l|D;t=bo(z|0,f|0,18)|0;L=D;v=_n(z|0,f|0,46)|0;L=l^(L|D);l=bo(z|0,f|0,41)|0;x=D;b=_n(z|0,f|0,23)|0;x=L^(x|D);L=c[h+80+472>>2]|0;p=c[h+80+472+4>>2]|0;I=Jp(E|0,I|0,442776044,-1933114872)|0;x=Jp(I|0,D|0,(n|K)^(t|v)^(l|b)|0,x|0)|0;p=Jp(x|0,D|0,L|0,p|0)|0;p=Jp(p|0,D|0,(e^o)&z^e|0,(j^y)&f^j|0)|0;L=D;x=bo(q|0,H|0,28)|0;b=D;l=_n(q|0,H|0,36)|0;b=b|D;v=bo(q|0,H|0,34)|0;t=D;K=_n(q|0,H|0,30)|0;t=b^(t|D);b=bo(q|0,H|0,39)|0;n=D;I=_n(q|0,H|0,25)|0;E=c[G>>2]|0;F=c[G+4>>2]|0;n=Jp((E|s)&q|E&s|0,(F|J)&H|F&J|0,(x|l)^(v|K)^(b|I)|0,t^(n|D)|0)|0;t=D;u=Jp(r|0,u|0,p|0,L|0)|0;r=D;c[h+16>>2]=u;c[h+16+4>>2]=r;L=Jp(n|0,t|0,p|0,L|0)|0;p=D;c[w>>2]=L;c[w+4>>2]=p;t=bo(u|0,r|0,14)|0;n=D;I=_n(u|0,r|0,50)|0;n=n|D;b=bo(u|0,r|0,18)|0;K=D;v=_n(u|0,r|0,46)|0;K=n^(K|D);n=bo(u|0,r|0,41)|0;l=D;x=_n(u|0,r|0,23)|0;l=K^(l|D);K=c[h+80+480>>2]|0;J=c[h+80+480+4>>2]|0;j=Jp(e|0,j|0,593698344,-1866530822)|0;l=Jp(j|0,D|0,(t|I)^(b|v)^(n|x)|0,l|0)|0;J=Jp(l|0,D|0,K|0,J|0)|0;J=Jp(J|0,D|0,(o^z)&u^o|0,(y^f)&r^y|0)|0;K=D;l=bo(L|0,p|0,28)|0;x=D;n=_n(L|0,p|0,36)|0;x=x|D;v=bo(L|0,p|0,34)|0;b=D;I=_n(L|0,p|0,30)|0;b=x^(b|D);x=bo(L|0,p|0,39)|0;t=D;j=_n(L|0,p|0,25)|0;e=c[k>>2]|0;s=c[k+4>>2]|0;t=Jp((e|q)&L|e&q|0,(s|H)&p|s&H|0,(l|n)^(v|I)^(x|j)|0,b^(t|D)|0)|0;b=D;F=Jp(E|0,F|0,J|0,K|0)|0;E=D;c[G>>2]=F;c[G+4>>2]=E;K=Jp(t|0,b|0,J|0,K|0)|0;J=D;c[m>>2]=K;c[m+4>>2]=J;b=bo(F|0,E|0,14)|0;t=D;j=_n(F|0,E|0,50)|0;t=t|D;x=bo(F|0,E|0,18)|0;I=D;v=_n(F|0,E|0,46)|0;I=t^(I|D);t=bo(F|0,E|0,41)|0;n=D;l=_n(F|0,E|0,23)|0;n=I^(n|D);I=c[h+80+488>>2]|0;H=c[h+80+488+4>>2]|0;y=Jp(o|0,y|0,-561857047,-1538233109)|0;n=Jp(y|0,D|0,(b|j)^(x|v)^(t|l)|0,n|0)|0;H=Jp(n|0,D|0,I|0,H|0)|0;H=Jp(H|0,D|0,(z^u)&F^z|0,(f^r)&E^f|0)|0;I=D;n=bo(K|0,J|0,28)|0;l=D;t=_n(K|0,J|0,36)|0;l=l|D;v=bo(K|0,J|0,34)|0;x=D;j=_n(K|0,J|0,30)|0;x=l^(x|D);l=bo(K|0,J|0,39)|0;b=D;y=_n(K|0,J|0,25)|0;o=c[A>>2]|0;q=c[A+4>>2]|0;b=Jp((o|L)&K|o&L|0,(q|p)&J|q&p|0,(n|t)^(v|j)^(l|y)|0,x^(b|D)|0)|0;x=D;s=Jp(e|0,s|0,H|0,I|0)|0;e=D;c[k>>2]=s;c[k+4>>2]=e;I=Jp(b|0,x|0,H|0,I|0)|0;H=D;c[B>>2]=I;c[B+4>>2]=H;x=bo(s|0,e|0,14)|0;b=D;y=_n(s|0,e|0,50)|0;b=b|D;l=bo(s|0,e|0,18)|0;j=D;v=_n(s|0,e|0,46)|0;j=b^(j|D);b=bo(s|0,e|0,41)|0;t=D;n=_n(s|0,e|0,23)|0;t=j^(t|D);j=c[h+80+496>>2]|0;p=c[h+80+496+4>>2]|0;f=Jp(z|0,f|0,-1295615723,-1090935817)|0;t=Jp(f|0,D|0,(x|y)^(l|v)^(b|n)|0,t|0)|0;p=Jp(t|0,D|0,j|0,p|0)|0;p=Jp(p|0,D|0,(u^F)&s^u|0,(r^E)&e^r|0)|0;j=D;t=bo(I|0,H|0,28)|0;n=D;b=_n(I|0,H|0,36)|0;n=n|D;v=bo(I|0,H|0,34)|0;l=D;y=_n(I|0,H|0,30)|0;l=n^(l|D);n=bo(I|0,H|0,39)|0;x=D;f=_n(I|0,H|0,25)|0;z=c[w>>2]|0;L=c[w+4>>2]|0;x=Jp((z|K)&I|z&K|0,(L|J)&H|L&J|0,(t|b)^(v|y)^(n|f)|0,l^(x|D)|0)|0;l=D;q=Jp(o|0,q|0,p|0,j|0)|0;o=D;c[A>>2]=q;c[A+4>>2]=o;j=Jp(x|0,l|0,p|0,j|0)|0;p=D;c[C>>2]=j;c[C+4>>2]=p;l=bo(q|0,o|0,14)|0;x=D;f=_n(q|0,o|0,50)|0;x=x|D;n=bo(q|0,o|0,18)|0;y=D;v=_n(q|0,o|0,46)|0;y=x^(y|D);x=bo(q|0,o|0,41)|0;b=D;t=_n(q|0,o|0,23)|0;b=y^(b|D);y=c[h+80+504>>2]|0;J=c[h+80+504+4>>2]|0;r=Jp(u|0,r|0,-479046869,-965641998)|0;b=Jp(r|0,D|0,(l|f)^(n|v)^(x|t)|0,b|0)|0;J=Jp(b|0,D|0,y|0,J|0)|0;J=Jp(J|0,D|0,(F^s)&q^F|0,(E^e)&o^E|0)|0;y=D;b=bo(j|0,p|0,28)|0;t=D;x=_n(j|0,p|0,36)|0;t=t|D;v=bo(j|0,p|0,34)|0;n=D;f=_n(j|0,p|0,30)|0;n=t^(n|D);t=bo(j|0,p|0,39)|0;l=D;r=_n(j|0,p|0,25)|0;u=c[m>>2]|0;K=c[m+4>>2]|0;l=Jp((u|I)&j|u&I|0,(K|H)&p|K&H|0,(b|x)^(v|f)^(t|r)|0,n^(l|D)|0)|0;n=D;L=Jp(z|0,L|0,J|0,y|0)|0;z=D;c[w>>2]=L;c[w+4>>2]=z;y=Jp(l|0,n|0,J|0,y|0)|0;J=D;c[h+16>>2]=y;c[h+16+4>>2]=J;n=bo(L|0,z|0,14)|0;l=D;r=_n(L|0,z|0,50)|0;l=l|D;t=bo(L|0,z|0,18)|0;f=D;v=_n(L|0,z|0,46)|0;f=l^(f|D);l=bo(L|0,z|0,41)|0;x=D;b=_n(L|0,z|0,23)|0;x=f^(x|D);f=c[h+80+512>>2]|0;H=c[h+80+512+4>>2]|0;E=Jp(F|0,E|0,-366583396,-903397682)|0;x=Jp(E|0,D|0,(n|r)^(t|v)^(l|b)|0,x|0)|0;H=Jp(x|0,D|0,f|0,H|0)|0;H=Jp(H|0,D|0,(s^q)&L^s|0,(e^o)&z^e|0)|0;f=D;x=bo(y|0,J|0,28)|0;b=D;l=_n(y|0,J|0,36)|0;b=b|D;v=bo(y|0,J|0,34)|0;t=D;r=_n(y|0,J|0,30)|0;t=b^(t|D);b=bo(y|0,J|0,39)|0;n=D;E=_n(y|0,J|0,25)|0;F=c[B>>2]|0;I=c[B+4>>2]|0;n=Jp((F|j)&y|F&j|0,(I|p)&J|I&p|0,(x|l)^(v|r)^(b|E)|0,t^(n|D)|0)|0;t=D;K=Jp(u|0,K|0,H|0,f|0)|0;u=D;c[m>>2]=K;c[m+4>>2]=u;f=Jp(n|0,t|0,H|0,f|0)|0;H=D;c[G>>2]=f;c[G+4>>2]=H;t=bo(K|0,u|0,14)|0;n=D;E=_n(K|0,u|0,50)|0;n=n|D;b=bo(K|0,u|0,18)|0;r=D;v=_n(K|0,u|0,46)|0;r=n^(r|D);n=bo(K|0,u|0,41)|0;l=D;x=_n(K|0,u|0,23)|0;l=r^(l|D);r=c[h+80+520>>2]|0;p=c[h+80+520+4>>2]|0;e=Jp(s|0,e|0,566280711,-779700025)|0;l=Jp(e|0,D|0,(t|E)^(b|v)^(n|x)|0,l|0)|0;p=Jp(l|0,D|0,r|0,p|0)|0;p=Jp(p|0,D|0,(q^L)&K^q|0,(o^z)&u^o|0)|0;r=D;l=bo(f|0,H|0,28)|0;x=D;n=_n(f|0,H|0,36)|0;x=x|D;v=bo(f|0,H|0,34)|0;b=D;E=_n(f|0,H|0,30)|0;b=x^(b|D);x=bo(f|0,H|0,39)|0;t=D;e=_n(f|0,H|0,25)|0;s=c[C>>2]|0;j=c[C+4>>2]|0;t=Jp((s|y)&f|s&y|0,(j|J)&H|j&J|0,(l|n)^(v|E)^(x|e)|0,b^(t|D)|0)|0;b=D;I=Jp(F|0,I|0,p|0,r|0)|0;F=D;c[B>>2]=I;c[B+4>>2]=F;r=Jp(t|0,b|0,p|0,r|0)|0;p=D;c[k>>2]=r;c[k+4>>2]=p;b=bo(I|0,F|0,14)|0;t=D;e=_n(I|0,F|0,50)|0;t=t|D;x=bo(I|0,F|0,18)|0;E=D;v=_n(I|0,F|0,46)|0;E=t^(E|D);t=bo(I|0,F|0,41)|0;n=D;l=_n(I|0,F|0,23)|0;n=E^(n|D);E=c[h+80+528>>2]|0;J=c[h+80+528+4>>2]|0;o=Jp(q|0,o|0,-840897762,-354779690)|0;n=Jp(o|0,D|0,(b|e)^(x|v)^(t|l)|0,n|0)|0;J=Jp(n|0,D|0,E|0,J|0)|0;J=Jp(J|0,D|0,(L^K)&I^L|0,(z^u)&F^z|0)|0;E=D;n=bo(r|0,p|0,28)|0;l=D;t=_n(r|0,p|0,36)|0;l=l|D;v=bo(r|0,p|0,34)|0;x=D;e=_n(r|0,p|0,30)|0;x=l^(x|D);l=bo(r|0,p|0,39)|0;b=D;o=_n(r|0,p|0,25)|0;q=c[h+16>>2]|0;y=c[h+16+4>>2]|0;b=Jp((q|f)&r|q&f|0,(y|H)&p|y&H|0,(n|t)^(v|e)^(l|o)|0,x^(b|D)|0)|0;x=D;j=Jp(s|0,j|0,J|0,E|0)|0;s=D;c[C>>2]=j;c[C+4>>2]=s;E=Jp(b|0,x|0,J|0,E|0)|0;J=D;c[A>>2]=E;c[A+4>>2]=J;x=bo(j|0,s|0,14)|0;b=D;o=_n(j|0,s|0,50)|0;b=b|D;l=bo(j|0,s|0,18)|0;e=D;v=_n(j|0,s|0,46)|0;e=b^(e|D);b=bo(j|0,s|0,41)|0;t=D;n=_n(j|0,s|0,23)|0;t=e^(t|D);e=c[h+80+536>>2]|0;H=c[h+80+536+4>>2]|0;z=Jp(L|0,z|0,-294727304,-176337025)|0;t=Jp(z|0,D|0,(x|o)^(l|v)^(b|n)|0,t|0)|0;H=Jp(t|0,D|0,e|0,H|0)|0;H=Jp(H|0,D|0,(K^I)&j^K|0,(u^F)&s^u|0)|0;e=D;t=bo(E|0,J|0,28)|0;n=D;b=_n(E|0,J|0,36)|0;n=n|D;v=bo(E|0,J|0,34)|0;l=D;o=_n(E|0,J|0,30)|0;l=n^(l|D);n=bo(E|0,J|0,39)|0;x=D;z=_n(E|0,J|0,25)|0;L=c[G>>2]|0;f=c[G+4>>2]|0;x=Jp((L|r)&E|L&r|0,(f|p)&J|f&p|0,(t|b)^(v|o)^(n|z)|0,l^(x|D)|0)|0;l=D;y=Jp(q|0,y|0,H|0,e|0)|0;q=D;c[h+16>>2]=y;c[h+16+4>>2]=q;e=Jp(x|0,l|0,H|0,e|0)|0;H=D;c[w>>2]=e;c[w+4>>2]=H;l=bo(y|0,q|0,14)|0;x=D;z=_n(y|0,q|0,50)|0;x=x|D;n=bo(y|0,q|0,18)|0;o=D;v=_n(y|0,q|0,46)|0;o=x^(o|D);x=bo(y|0,q|0,41)|0;b=D;t=_n(y|0,q|0,23)|0;b=o^(b|D);o=c[h+80+544>>2]|0;p=c[h+80+544+4>>2]|0;u=Jp(K|0,u|0,1914138554,116418474)|0;b=Jp(u|0,D|0,(l|z)^(n|v)^(x|t)|0,b|0)|0;p=Jp(b|0,D|0,o|0,p|0)|0;p=Jp(p|0,D|0,(I^j)&y^I|0,(F^s)&q^F|0)|0;o=D;b=bo(e|0,H|0,28)|0;t=D;x=_n(e|0,H|0,36)|0;t=t|D;v=bo(e|0,H|0,34)|0;n=D;z=_n(e|0,H|0,30)|0;n=t^(n|D);t=bo(e|0,H|0,39)|0;l=D;u=_n(e|0,H|0,25)|0;K=c[k>>2]|0;r=c[k+4>>2]|0;l=Jp((K|E)&e|K&E|0,(r|J)&H|r&J|0,(b|x)^(v|z)^(t|u)|0,n^(l|D)|0)|0;n=D;f=Jp(L|0,f|0,p|0,o|0)|0;L=D;c[G>>2]=f;c[G+4>>2]=L;o=Jp(l|0,n|0,p|0,o|0)|0;p=D;c[m>>2]=o;c[m+4>>2]=p;n=bo(f|0,L|0,14)|0;l=D;u=_n(f|0,L|0,50)|0;l=l|D;t=bo(f|0,L|0,18)|0;z=D;v=_n(f|0,L|0,46)|0;z=l^(z|D);l=bo(f|0,L|0,41)|0;x=D;b=_n(f|0,L|0,23)|0;x=z^(x|D);z=c[h+80+552>>2]|0;J=c[h+80+552+4>>2]|0;F=Jp(I|0,F|0,-1563912026,174292421)|0;x=Jp(F|0,D|0,(n|u)^(t|v)^(l|b)|0,x|0)|0;J=Jp(x|0,D|0,z|0,J|0)|0;J=Jp(J|0,D|0,(j^y)&f^j|0,(s^q)&L^s|0)|0;z=D;x=bo(o|0,p|0,28)|0;b=D;l=_n(o|0,p|0,36)|0;b=b|D;v=bo(o|0,p|0,34)|0;t=D;u=_n(o|0,p|0,30)|0;t=b^(t|D);b=bo(o|0,p|0,39)|0;n=D;F=_n(o|0,p|0,25)|0;I=c[A>>2]|0;E=c[A+4>>2]|0;n=Jp((I|e)&o|I&e|0,(E|H)&p|E&H|0,(x|l)^(v|u)^(b|F)|0,t^(n|D)|0)|0;t=D;r=Jp(K|0,r|0,J|0,z|0)|0;K=D;c[k>>2]=r;c[k+4>>2]=K;z=Jp(n|0,t|0,J|0,z|0)|0;J=D;c[B>>2]=z;c[B+4>>2]=J;t=bo(r|0,K|0,14)|0;n=D;F=_n(r|0,K|0,50)|0;n=n|D;b=bo(r|0,K|0,18)|0;u=D;v=_n(r|0,K|0,46)|0;u=n^(u|D);n=bo(r|0,K|0,41)|0;l=D;x=_n(r|0,K|0,23)|0;l=u^(l|D);u=c[h+80+560>>2]|0;H=c[h+80+560+4>>2]|0;s=Jp(j|0,s|0,-1090974290,289380356)|0;l=Jp(s|0,D|0,(t|F)^(b|v)^(n|x)|0,l|0)|0;H=Jp(l|0,D|0,u|0,H|0)|0;H=Jp(H|0,D|0,(y^f)&r^y|0,(q^L)&K^q|0)|0;u=D;l=bo(z|0,J|0,28)|0;x=D;n=_n(z|0,J|0,36)|0;x=x|D;v=bo(z|0,J|0,34)|0;b=D;F=_n(z|0,J|0,30)|0;b=x^(b|D);x=bo(z|0,J|0,39)|0;t=D;s=_n(z|0,J|0,25)|0;j=c[w>>2]|0;e=c[w+4>>2]|0;t=Jp((j|o)&z|j&o|0,(e|p)&J|e&p|0,(l|n)^(v|F)^(x|s)|0,b^(t|D)|0)|0;b=D;E=Jp(I|0,E|0,H|0,u|0)|0;I=D;c[A>>2]=E;c[A+4>>2]=I;u=Jp(t|0,b|0,H|0,u|0)|0;H=D;c[C>>2]=u;c[C+4>>2]=H;b=bo(E|0,I|0,14)|0;t=D;s=_n(E|0,I|0,50)|0;t=t|D;x=bo(E|0,I|0,18)|0;F=D;v=_n(E|0,I|0,46)|0;F=t^(F|D);t=bo(E|0,I|0,41)|0;n=D;l=_n(E|0,I|0,23)|0;n=F^(n|D);F=c[h+80+568>>2]|0;p=c[h+80+568+4>>2]|0;q=Jp(y|0,q|0,320620315,460393269)|0;n=Jp(q|0,D|0,(b|s)^(x|v)^(t|l)|0,n|0)|0;p=Jp(n|0,D|0,F|0,p|0)|0;p=Jp(p|0,D|0,(f^r)&E^f|0,(L^K)&I^L|0)|0;F=D;n=bo(u|0,H|0,28)|0;l=D;t=_n(u|0,H|0,36)|0;l=l|D;v=bo(u|0,H|0,34)|0;x=D;s=_n(u|0,H|0,30)|0;x=l^(x|D);l=bo(u|0,H|0,39)|0;b=D;q=_n(u|0,H|0,25)|0;y=c[m>>2]|0;o=c[m+4>>2]|0;b=Jp((y|z)&u|y&z|0,(o|J)&H|o&J|0,(n|t)^(v|s)^(l|q)|0,x^(b|D)|0)|0;x=D;e=Jp(j|0,e|0,p|0,F|0)|0;j=D;c[w>>2]=e;c[w+4>>2]=j;F=Jp(b|0,x|0,p|0,F|0)|0;p=D;c[h+16>>2]=F;c[h+16+4>>2]=p;x=bo(e|0,j|0,14)|0;b=D;q=_n(e|0,j|0,50)|0;b=b|D;l=bo(e|0,j|0,18)|0;s=D;v=_n(e|0,j|0,46)|0;s=b^(s|D);b=bo(e|0,j|0,41)|0;t=D;n=_n(e|0,j|0,23)|0;t=s^(t|D);s=c[h+80+576>>2]|0;J=c[h+80+576+4>>2]|0;L=Jp(f|0,L|0,587496836,685471733)|0;t=Jp(L|0,D|0,(x|q)^(l|v)^(b|n)|0,t|0)|0;J=Jp(t|0,D|0,s|0,J|0)|0;J=Jp(J|0,D|0,(r^E)&e^r|0,(K^I)&j^K|0)|0;s=D;t=bo(F|0,p|0,28)|0;n=D;b=_n(F|0,p|0,36)|0;n=n|D;v=bo(F|0,p|0,34)|0;l=D;q=_n(F|0,p|0,30)|0;l=n^(l|D);n=bo(F|0,p|0,39)|0;x=D;L=_n(F|0,p|0,25)|0;f=c[B>>2]|0;z=c[B+4>>2]|0;x=Jp((f|u)&F|f&u|0,(z|H)&p|z&H|0,(t|b)^(v|q)^(n|L)|0,l^(x|D)|0)|0;l=D;o=Jp(y|0,o|0,J|0,s|0)|0;y=D;c[m>>2]=o;c[m+4>>2]=y;s=Jp(x|0,l|0,J|0,s|0)|0;J=D;c[G>>2]=s;c[G+4>>2]=J;l=bo(o|0,y|0,14)|0;x=D;L=_n(o|0,y|0,50)|0;x=x|D;n=bo(o|0,y|0,18)|0;q=D;v=_n(o|0,y|0,46)|0;q=x^(q|D);x=bo(o|0,y|0,41)|0;b=D;t=_n(o|0,y|0,23)|0;b=q^(b|D);q=c[h+80+584>>2]|0;H=c[h+80+584+4>>2]|0;K=Jp(r|0,K|0,1086792851,852142971)|0;b=Jp(K|0,D|0,(l|L)^(n|v)^(x|t)|0,b|0)|0;H=Jp(b|0,D|0,q|0,H|0)|0;H=Jp(H|0,D|0,(E^e)&o^E|0,(I^j)&y^I|0)|0;q=D;b=bo(s|0,J|0,28)|0;t=D;x=_n(s|0,J|0,36)|0;t=t|D;v=bo(s|0,J|0,34)|0;n=D;L=_n(s|0,J|0,30)|0;n=t^(n|D);t=bo(s|0,J|0,39)|0;l=D;K=_n(s|0,J|0,25)|0;r=c[C>>2]|0;u=c[C+4>>2]|0;l=Jp((r|F)&s|r&F|0,(u|p)&J|u&p|0,(b|x)^(v|L)^(t|K)|0,n^(l|D)|0)|0;n=D;z=Jp(f|0,z|0,H|0,q|0)|0;f=D;c[B>>2]=z;c[B+4>>2]=f;q=Jp(l|0,n|0,H|0,q|0)|0;H=D;c[k>>2]=q;c[k+4>>2]=H;n=bo(z|0,f|0,14)|0;l=D;K=_n(z|0,f|0,50)|0;l=l|D;t=bo(z|0,f|0,18)|0;L=D;v=_n(z|0,f|0,46)|0;L=l^(L|D);l=bo(z|0,f|0,41)|0;x=D;b=_n(z|0,f|0,23)|0;x=L^(x|D);L=c[h+80+592>>2]|0;p=c[h+80+592+4>>2]|0;I=Jp(E|0,I|0,365543100,1017036298)|0;x=Jp(I|0,D|0,(n|K)^(t|v)^(l|b)|0,x|0)|0;p=Jp(x|0,D|0,L|0,p|0)|0;p=Jp(p|0,D|0,(e^o)&z^e|0,(j^y)&f^j|0)|0;L=D;x=bo(q|0,H|0,28)|0;b=D;l=_n(q|0,H|0,36)|0;b=b|D;v=bo(q|0,H|0,34)|0;t=D;K=_n(q|0,H|0,30)|0;t=b^(t|D);b=bo(q|0,H|0,39)|0;n=D;I=_n(q|0,H|0,25)|0;E=c[h+16>>2]|0;F=c[h+16+4>>2]|0;n=Jp((E|s)&q|E&s|0,(F|J)&H|F&J|0,(x|l)^(v|K)^(b|I)|0,t^(n|D)|0)|0;t=D;u=Jp(r|0,u|0,p|0,L|0)|0;r=D;c[C>>2]=u;c[C+4>>2]=r;L=Jp(n|0,t|0,p|0,L|0)|0;p=D;c[A>>2]=L;c[A+4>>2]=p;t=bo(u|0,r|0,14)|0;n=D;I=_n(u|0,r|0,50)|0;n=n|D;b=bo(u|0,r|0,18)|0;K=D;v=_n(u|0,r|0,46)|0;K=n^(K|D);n=bo(u|0,r|0,41)|0;l=D;x=_n(u|0,r|0,23)|0;l=K^(l|D);K=c[h+80+600>>2]|0;J=c[h+80+600+4>>2]|0;j=Jp(e|0,j|0,-1676669620,1126000580)|0;l=Jp(j|0,D|0,(t|I)^(b|v)^(n|x)|0,l|0)|0;J=Jp(l|0,D|0,K|0,J|0)|0;J=Jp(J|0,D|0,(o^z)&u^o|0,(y^f)&r^y|0)|0;K=D;l=bo(L|0,p|0,28)|0;x=D;n=_n(L|0,p|0,36)|0;x=x|D;v=bo(L|0,p|0,34)|0;b=D;I=_n(L|0,p|0,30)|0;b=x^(b|D);x=bo(L|0,p|0,39)|0;t=D;j=_n(L|0,p|0,25)|0;e=c[G>>2]|0;s=c[G+4>>2]|0;t=Jp((e|q)&L|e&q|0,(s|H)&p|s&H|0,(l|n)^(v|I)^(x|j)|0,b^(t|D)|0)|0;b=D;F=Jp(E|0,F|0,J|0,K|0)|0;E=D;c[h+16>>2]=F;c[h+16+4>>2]=E;K=Jp(t|0,b|0,J|0,K|0)|0;J=D;c[w>>2]=K;c[w+4>>2]=J;b=bo(F|0,E|0,14)|0;t=D;j=_n(F|0,E|0,50)|0;t=t|D;x=bo(F|0,E|0,18)|0;I=D;v=_n(F|0,E|0,46)|0;I=t^(I|D);t=bo(F|0,E|0,41)|0;n=D;l=_n(F|0,E|0,23)|0;n=I^(n|D);I=c[h+80+608>>2]|0;H=c[h+80+608+4>>2]|0;y=Jp(o|0,y|0,-885112138,1288033470)|0;n=Jp(y|0,D|0,(b|j)^(x|v)^(t|l)|0,n|0)|0;H=Jp(n|0,D|0,I|0,H|0)|0;H=Jp(H|0,D|0,(z^u)&F^z|0,(f^r)&E^f|0)|0;I=D;n=bo(K|0,J|0,28)|0;l=D;t=_n(K|0,J|0,36)|0;l=l|D;v=bo(K|0,J|0,34)|0;x=D;j=_n(K|0,J|0,30)|0;x=l^(x|D);l=bo(K|0,J|0,39)|0;b=D;y=_n(K|0,J|0,25)|0;o=c[k>>2]|0;q=c[k+4>>2]|0;b=Jp((o|L)&K|o&L|0,(q|p)&J|q&p|0,(n|t)^(v|j)^(l|y)|0,x^(b|D)|0)|0;x=D;s=Jp(e|0,s|0,H|0,I|0)|0;e=D;c[G>>2]=s;c[G+4>>2]=e;I=Jp(b|0,x|0,H|0,I|0)|0;H=D;c[m>>2]=I;c[m+4>>2]=H;x=bo(s|0,e|0,14)|0;b=D;G=_n(s|0,e|0,50)|0;b=b|D;y=bo(s|0,e|0,18)|0;l=D;j=_n(s|0,e|0,46)|0;l=b^(l|D);b=bo(s|0,e|0,41)|0;v=D;t=_n(s|0,e|0,23)|0;v=l^(v|D);l=c[h+80+616>>2]|0;n=c[h+80+616+4>>2]|0;f=Jp(z|0,f|0,-60457430,1501505948)|0;v=Jp(f|0,D|0,(x|G)^(y|j)^(b|t)|0,v|0)|0;n=Jp(v|0,D|0,l|0,n|0)|0;n=Jp(n|0,D|0,(u^F)&s^u|0,(r^E)&e^r|0)|0;l=D;v=bo(I|0,H|0,28)|0;t=D;b=_n(I|0,H|0,36)|0;t=t|D;j=bo(I|0,H|0,34)|0;y=D;G=_n(I|0,H|0,30)|0;y=t^(y|D);t=bo(I|0,H|0,39)|0;x=D;f=_n(I|0,H|0,25)|0;z=c[A>>2]|0;p=c[A+4>>2]|0;x=Jp((z|K)&I|z&K|0,(p|J)&H|p&J|0,(v|b)^(j|G)^(t|f)|0,y^(x|D)|0)|0;y=D;q=Jp(o|0,q|0,n|0,l|0)|0;o=D;c[k>>2]=q;c[k+4>>2]=o;l=Jp(x|0,y|0,n|0,l|0)|0;n=D;c[B>>2]=l;c[B+4>>2]=n;B=bo(q|0,o|0,14)|0;y=D;x=_n(q|0,o|0,50)|0;y=y|D;k=bo(q|0,o|0,18)|0;f=D;t=_n(q|0,o|0,46)|0;f=y^(f|D);y=bo(q|0,o|0,41)|0;G=D;j=_n(q|0,o|0,23)|0;G=f^(G|D);f=c[h+80+624>>2]|0;b=c[h+80+624+4>>2]|0;r=Jp(u|0,r|0,987167468,1607167915)|0;G=Jp(r|0,D|0,(B|x)^(k|t)^(y|j)|0,G|0)|0;b=Jp(G|0,D|0,f|0,b|0)|0;b=Jp(b|0,D|0,(F^s)&q^F|0,(E^e)&o^E|0)|0;f=D;G=bo(l|0,n|0,28)|0;j=D;y=_n(l|0,n|0,36)|0;j=j|D;t=bo(l|0,n|0,34)|0;k=D;x=_n(l|0,n|0,30)|0;k=j^(k|D);j=bo(l|0,n|0,39)|0;B=D;r=_n(l|0,n|0,25)|0;u=c[w>>2]|0;v=c[w+4>>2]|0;B=Jp((u|I)&l|u&I|0,(v|H)&n|v&H|0,(G|y)^(t|x)^(j|r)|0,k^(B|D)|0)|0;k=D;p=Jp(z|0,p|0,b|0,f|0)|0;z=D;c[A>>2]=p;c[A+4>>2]=z;f=Jp(B|0,k|0,b|0,f|0)|0;b=D;c[C>>2]=f;c[C+4>>2]=b;C=bo(p|0,z|0,14)|0;k=D;B=_n(p|0,z|0,50)|0;k=k|D;A=bo(p|0,z|0,18)|0;r=D;j=_n(p|0,z|0,46)|0;r=k^(r|D);k=bo(p|0,z|0,41)|0;x=D;t=_n(p|0,z|0,23)|0;x=r^(x|D);r=c[h+80+632>>2]|0;y=c[h+80+632+4>>2]|0;E=Jp(F|0,E|0,1246189591,1816402316)|0;x=Jp(E|0,D|0,(C|B)^(A|j)^(k|t)|0,x|0)|0;y=Jp(x|0,D|0,r|0,y|0)|0;e=Jp(y|0,D|0,(s^q)&p^s|0,(e^o)&z^e|0)|0;z=D;c[h+8>>2]=e;c[h+8+4>>2]=z;o=bo(f|0,b|0,28)|0;s=D;p=_n(f|0,b|0,36)|0;s=s|D;q=bo(f|0,b|0,34)|0;y=D;r=_n(f|0,b|0,30)|0;y=s^(y|D);s=bo(f|0,b|0,39)|0;x=D;t=_n(f|0,b|0,25)|0;k=c[m>>2]|0;m=c[m+4>>2]|0;x=Jp((k|l)&f|k&l|0,(m|n)&b|m&n|0,(o|p)^(q|r)^(s|t)|0,y^(x|D)|0)|0;y=D;c[h>>2]=x;c[h+4>>2]=y;v=Jp(u|0,v|0,e|0,z|0)|0;c[w>>2]=v;c[w+4>>2]=D;z=Jp(x|0,y|0,e|0,z|0)|0;e=D;c[h+16>>2]=z;c[h+16+4>>2]=e;e=Jp(c[a>>2]|0,c[a+4>>2]|0,z|0,e|0)|0;c[a>>2]=e;c[a+4>>2]=D;e=1;while(1){M=a+(e<<3)|0;b=Jp(c[M>>2]|0,c[M+4>>2]|0,f|0,b|0)|0;c[M>>2]=b;c[M+4>>2]=D;b=e+1|0;if((b|0)==8)break;e=b;f=c[h+16+(b<<3)>>2]|0;b=c[h+16+(b<<3)+4>>2]|0}bl(h+80|0,640);bl(h+16|0,64);bl(h+8|0,8);bl(h,8);i=g;return}function Zb(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;O=i;P=i=i+63&-64;i=i+128|0;o=d[b>>0]|d[b+1>>0]<<8|d[b+2>>0]<<16|d[b+3>>0]<<24;x=d[b+4>>0]|d[b+4+1>>0]<<8|d[b+4+2>>0]<<16|d[b+4+3>>0]<<24;L=d[b+8>>0]|d[b+8+1>>0]<<8|d[b+8+2>>0]<<16|d[b+8+3>>0]<<24;l=d[b+8+4>>0]|d[b+8+4+1>>0]<<8|d[b+8+4+2>>0]<<16|d[b+8+4+3>>0]<<24;m=d[b+16>>0]|d[b+16+1>>0]<<8|d[b+16+2>>0]<<16|d[b+16+3>>0]<<24;n=d[b+16+4>>0]|d[b+16+4+1>>0]<<8|d[b+16+4+2>>0]<<16|d[b+16+4+3>>0]<<24;p=d[b+24>>0]|d[b+24+1>>0]<<8|d[b+24+2>>0]<<16|d[b+24+3>>0]<<24;q=d[b+24+4>>0]|d[b+24+4+1>>0]<<8|d[b+24+4+2>>0]<<16|d[b+24+4+3>>0]<<24;r=d[b+32>>0]|d[b+32+1>>0]<<8|d[b+32+2>>0]<<16|d[b+32+3>>0]<<24;s=d[b+32+4>>0]|d[b+32+4+1>>0]<<8|d[b+32+4+2>>0]<<16|d[b+32+4+3>>0]<<24;t=d[b+40>>0]|d[b+40+1>>0]<<8|d[b+40+2>>0]<<16|d[b+40+3>>0]<<24;u=d[b+40+4>>0]|d[b+40+4+1>>0]<<8|d[b+40+4+2>>0]<<16|d[b+40+4+3>>0]<<24;v=d[b+48>>0]|d[b+48+1>>0]<<8|d[b+48+2>>0]<<16|d[b+48+3>>0]<<24;w=d[b+48+4>>0]|d[b+48+4+1>>0]<<8|d[b+48+4+2>>0]<<16|d[b+48+4+3>>0]<<24;y=d[b+56>>0]|d[b+56+1>>0]<<8|d[b+56+2>>0]<<16|d[b+56+3>>0]<<24;z=d[b+56+4>>0]|d[b+56+4+1>>0]<<8|d[b+56+4+2>>0]<<16|d[b+56+4+3>>0]<<24;A=d[b+64>>0]|d[b+64+1>>0]<<8|d[b+64+2>>0]<<16|d[b+64+3>>0]<<24;B=d[b+64+4>>0]|d[b+64+4+1>>0]<<8|d[b+64+4+2>>0]<<16|d[b+64+4+3>>0]<<24;C=d[b+72>>0]|d[b+72+1>>0]<<8|d[b+72+2>>0]<<16|d[b+72+3>>0]<<24;E=d[b+72+4>>0]|d[b+72+4+1>>0]<<8|d[b+72+4+2>>0]<<16|d[b+72+4+3>>0]<<24;F=d[b+80>>0]|d[b+80+1>>0]<<8|d[b+80+2>>0]<<16|d[b+80+3>>0]<<24;G=d[b+80+4>>0]|d[b+80+4+1>>0]<<8|d[b+80+4+2>>0]<<16|d[b+80+4+3>>0]<<24;H=d[b+88>>0]|d[b+88+1>>0]<<8|d[b+88+2>>0]<<16|d[b+88+3>>0]<<24;I=d[b+88+4>>0]|d[b+88+4+1>>0]<<8|d[b+88+4+2>>0]<<16|d[b+88+4+3>>0]<<24;J=d[b+96>>0]|d[b+96+1>>0]<<8|d[b+96+2>>0]<<16|d[b+96+3>>0]<<24;K=d[b+96+4>>0]|d[b+96+4+1>>0]<<8|d[b+96+4+2>>0]<<16|d[b+96+4+3>>0]<<24;M=d[b+104>>0]|d[b+104+1>>0]<<8|d[b+104+2>>0]<<16|d[b+104+3>>0]<<24;N=d[b+104+4>>0]|d[b+104+4+1>>0]<<8|d[b+104+4+2>>0]<<16|d[b+104+4+3>>0]<<24;h=d[b+112>>0]|d[b+112+1>>0]<<8|d[b+112+2>>0]<<16|d[b+112+3>>0]<<24;j=d[b+112+4>>0]|d[b+112+4+1>>0]<<8|d[b+112+4+2>>0]<<16|d[b+112+4+3>>0]<<24;k=d[b+120>>0]|d[b+120+1>>0]<<8|d[b+120+2>>0]<<16|d[b+120+3>>0]<<24;b=d[b+120+4>>0]|d[b+120+4+1>>0]<<8|d[b+120+4+2>>0]<<16|d[b+120+4+3>>0]<<24;e=P;f=a;g=e+64|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(g|0));c[P+80>>2]=-23791573;c[P+80+4>>2]=1013904242;c[P+88>>2]=1595750129;c[P+88+4>>2]=-1521486534;f=c[a+64>>2]^-1377402159;ha=c[a+64+4>>2]^1359893119;aa=c[a+72>>2]^725511199;W=c[a+72+4>>2]^-1694144372;e=c[a+80>>2]^-79577749;Y=c[a+80+4>>2]^528734635;ka=c[a+88>>2]^327033209;ga=c[a+88+4>>2]^1541459225;c[P+120>>2]=ka;c[P+120+4>>2]=ga;U=c[P+32>>2]|0;da=c[P+32+4>>2]|0;la=Jp(U|0,da|0,c[P>>2]|0,c[P+4>>2]|0)|0;la=Jp(la|0,D|0,o|0,x|0)|0;ja=D;Z=Jp(ha^ja|0,f^la|0,-205731576,1779033703)|0;ea=D;_=bo(U^Z|0,da^ea|0,24)|0;X=D;da=_n(U^Z|0,da^ea|0,40)|0;X=D|X;U=Jp(da|_|0,X|0,la|0,ja|0)|0;U=Jp(U|0,D|0,L|0,l|0)|0;Q=D;c[P>>2]=U;c[P+4>>2]=Q;$=bo(ha^ja^U|0,f^la^Q|0,16)|0;g=D;la=_n(ha^ja^U|0,f^la^Q|0,48)|0;g=D|g;c[P+96>>2]=la|$;c[P+96+4>>2]=g;ea=Jp(la|$|0,g|0,Z|0,ea|0)|0;Z=D;c[P+64>>2]=ea;c[P+64+4>>2]=Z;g=bo((da|_)^ea|0,X^Z|0,63)|0;$=D;Z=_n((da|_)^ea|0,X^Z|0,1)|0;c[P+32>>2]=Z|g;c[P+32+4>>2]=D|$;$=c[P+40>>2]|0;g=c[P+40+4>>2]|0;Z=Jp($|0,g|0,c[P+8>>2]|0,c[P+8+4>>2]|0)|0;Z=Jp(Z|0,D|0,m|0,n|0)|0;X=D;ea=Jp(W^X|0,aa^Z|0,-2067093701,-1150833019)|0;_=D;da=bo($^ea|0,g^_|0,24)|0;la=D;g=_n($^ea|0,g^_|0,40)|0;la=D|la;$=Jp(g|da|0,la|0,Z|0,X|0)|0;$=Jp($|0,D|0,p|0,q|0)|0;f=D;c[P+8>>2]=$;c[P+8+4>>2]=f;ja=bo(W^X^$|0,aa^Z^f|0,16)|0;ha=D;Z=_n(W^X^$|0,aa^Z^f|0,48)|0;ha=D|ha;c[P+104>>2]=Z|ja;c[P+104+4>>2]=ha;_=Jp(Z|ja|0,ha|0,ea|0,_|0)|0;ea=D;c[P+72>>2]=_;c[P+72+4>>2]=ea;ha=bo((g|da)^_|0,la^ea|0,63)|0;ja=D;ea=_n((g|da)^_|0,la^ea|0,1)|0;ja=D|ja;la=c[P+48>>2]|0;_=c[P+48+4>>2]|0;da=Jp(la|0,_|0,c[P+16>>2]|0,c[P+16+4>>2]|0)|0;da=Jp(da|0,D|0,r|0,s|0)|0;g=D;Z=Jp(Y^g|0,e^da|0,-23791573,1013904242)|0;aa=D;X=bo(la^Z|0,_^aa|0,24)|0;W=D;_=_n(la^Z|0,_^aa|0,40)|0;W=D|W;la=Jp(_|X|0,W|0,da|0,g|0)|0;la=Jp(la|0,D|0,t|0,u|0)|0;V=D;c[P+16>>2]=la;c[P+16+4>>2]=V;ia=bo(Y^g^la|0,e^da^V|0,16)|0;fa=D;da=_n(Y^g^la|0,e^da^V|0,48)|0;fa=D|fa;c[P+112>>2]=da|ia;c[P+112+4>>2]=fa;aa=Jp(da|ia|0,fa|0,Z|0,aa|0)|0;Z=D;fa=bo((_|X)^aa|0,W^Z|0,63)|0;ia=D;W=_n((_|X)^aa|0,W^Z|0,1)|0;ia=D|ia;X=c[P+56>>2]|0;_=c[P+56+4>>2]|0;da=Jp(X|0,_|0,c[P+24>>2]|0,c[P+24+4>>2]|0)|0;da=Jp(da|0,D|0,v|0,w|0)|0;e=D;g=Jp(ga^e|0,ka^da|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;Y=D;R=bo(X^g|0,_^Y|0,24)|0;ba=D;_=_n(X^g|0,_^Y|0,40)|0;ba=D|ba;X=Jp(_|R|0,ba|0,da|0,e|0)|0;X=Jp(X|0,D|0,y|0,z|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;ca=bo(ga^e^X|0,ka^da^S|0,16)|0;ma=D;da=_n(ga^e^X|0,ka^da^S|0,48)|0;ma=D|ma;Y=Jp(da|ca|0,ma|0,g|0,Y|0)|0;g=D;ka=bo((_|R)^Y|0,ba^g|0,63)|0;e=D;ba=_n((_|R)^Y|0,ba^g|0,1)|0;e=D|e;Q=Jp(ea|ha|0,ja|0,U|0,Q|0)|0;Q=Jp(Q|0,D|0,A|0,B|0)|0;U=D;Z=Jp(ma^U|0,(da|ca)^Q|0,aa|0,Z|0)|0;aa=D;R=bo((ea|ha)^Z|0,ja^aa|0,24)|0;_=D;ja=_n((ea|ha)^Z|0,ja^aa|0,40)|0;_=D|_;ha=Jp(ja|R|0,_|0,Q|0,U|0)|0;ha=Jp(ha|0,D|0,C|0,E|0)|0;ea=D;c[P>>2]=ha;c[P+4>>2]=ea;ga=bo(ma^U^ha|0,(da|ca)^Q^ea|0,16)|0;T=D;Q=_n(ma^U^ha|0,(da|ca)^Q^ea|0,48)|0;T=D|T;c[P+120>>2]=Q|ga;c[P+120+4>>2]=T;aa=Jp(Q|ga|0,T|0,Z|0,aa|0)|0;Z=D;c[P+80>>2]=aa;c[P+80+4>>2]=Z;T=bo((ja|R)^aa|0,_^Z|0,63)|0;ga=D;Z=_n((ja|R)^aa|0,_^Z|0,1)|0;c[P+40>>2]=Z|T;c[P+40+4>>2]=D|ga;f=Jp(W|fa|0,ia|0,$|0,f|0)|0;f=Jp(f|0,D|0,F|0,G|0)|0;$=D;ga=c[P+96>>2]^f;T=c[P+96+4>>2]^$;g=Jp(T|0,ga|0,Y|0,g|0)|0;Y=D;Z=bo((W|fa)^g|0,ia^Y|0,24)|0;_=D;ia=_n((W|fa)^g|0,ia^Y|0,40)|0;_=D|_;$=Jp(ia|Z|0,_|0,f|0,$|0)|0;$=Jp($|0,D|0,H|0,I|0)|0;f=D;c[P+8>>2]=$;c[P+8+4>>2]=f;fa=bo(T^$|0,ga^f|0,16)|0;W=D;ga=_n(T^$|0,ga^f|0,48)|0;W=D|W;Y=Jp(ga|fa|0,W|0,g|0,Y|0)|0;g=D;c[P+88>>2]=Y;c[P+88+4>>2]=g;T=bo((ia|Z)^Y|0,_^g|0,63)|0;aa=D;g=_n((ia|Z)^Y|0,_^g|0,1)|0;c[P+48>>2]=g|T;c[P+48+4>>2]=D|aa;V=Jp(ba|ka|0,e|0,la|0,V|0)|0;V=Jp(V|0,D|0,J|0,K|0)|0;la=D;aa=c[P+104>>2]^V;T=c[P+104+4>>2]^la;g=Jp(T|0,aa|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;_=D;Y=bo((ba|ka)^g|0,e^_|0,24)|0;Z=D;e=_n((ba|ka)^g|0,e^_|0,40)|0;Z=D|Z;la=Jp(e|Y|0,Z|0,V|0,la|0)|0;la=Jp(la|0,D|0,M|0,N|0)|0;V=D;c[P+16>>2]=la;c[P+16+4>>2]=V;ka=bo(T^la|0,aa^V|0,16)|0;ba=D;aa=_n(T^la|0,aa^V|0,48)|0;ba=D|ba;_=Jp(aa|ka|0,ba|0,g|0,_|0)|0;g=D;T=bo((e|Y)^_|0,Z^g|0,63)|0;ia=D;Z=_n((e|Y)^_|0,Z^g|0,1)|0;c[P+56>>2]=Z|T;c[P+56+4>>2]=D|ia;ia=c[P+32>>2]|0;T=c[P+32+4>>2]|0;S=Jp(ia|0,T|0,X|0,S|0)|0;S=Jp(S|0,D|0,h|0,j|0)|0;X=D;Z=c[P+112>>2]^S;Y=c[P+112+4>>2]^X;e=Jp(Y|0,Z|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;R=D;ja=bo(ia^e|0,T^R|0,24)|0;Q=D;T=_n(ia^e|0,T^R|0,40)|0;Q=D|Q;X=Jp(T|ja|0,Q|0,S|0,X|0)|0;X=Jp(X|0,D|0,k|0,b|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;ia=bo(Y^X|0,Z^S|0,16)|0;ca=D;Z=_n(Y^X|0,Z^S|0,48)|0;ca=D|ca;R=Jp(Z|ia|0,ca|0,e|0,R|0)|0;e=D;Y=bo((T|ja)^R|0,Q^e|0,63)|0;da=D;Q=_n((T|ja)^R|0,Q^e|0,1)|0;da=D|da;ea=Jp(Q|Y|0,da|0,ha|0,ea|0)|0;ea=Jp(ea|0,D|0,h|0,j|0)|0;ha=D;g=Jp(W^ha|0,(ga|fa)^ea|0,_|0,g|0)|0;_=D;ja=bo((Q|Y)^g|0,da^_|0,24)|0;T=D;da=_n((Q|Y)^g|0,da^_|0,40)|0;T=D|T;Y=Jp(da|ja|0,T|0,ea|0,ha|0)|0;Y=Jp(Y|0,D|0,F|0,G|0)|0;Q=D;c[P>>2]=Y;c[P+4>>2]=Q;U=bo(W^ha^Y|0,(ga|fa)^ea^Q|0,16)|0;ma=D;ea=_n(W^ha^Y|0,(ga|fa)^ea^Q|0,48)|0;ma=D|ma;c[P+96>>2]=ea|U;c[P+96+4>>2]=ma;_=Jp(ea|U|0,ma|0,g|0,_|0)|0;g=D;c[P+64>>2]=_;c[P+64+4>>2]=g;ma=bo((da|ja)^_|0,T^g|0,63)|0;U=D;g=_n((da|ja)^_|0,T^g|0,1)|0;c[P+32>>2]=g|ma;c[P+32+4>>2]=D|U;U=c[P+40>>2]|0;ma=c[P+40+4>>2]|0;f=Jp(U|0,ma|0,$|0,f|0)|0;f=Jp(f|0,D|0,r|0,s|0)|0;$=D;e=Jp(ba^$|0,(aa|ka)^f|0,R|0,e|0)|0;R=D;g=bo(U^e|0,ma^R|0,24)|0;T=D;ma=_n(U^e|0,ma^R|0,40)|0;T=D|T;U=Jp(ma|g|0,T|0,f|0,$|0)|0;U=Jp(U|0,D|0,A|0,B|0)|0;_=D;c[P+8>>2]=U;c[P+8+4>>2]=_;ja=bo(ba^$^U|0,(aa|ka)^f^_|0,16)|0;da=D;f=_n(ba^$^U|0,(aa|ka)^f^_|0,48)|0;da=D|da;c[P+104>>2]=f|ja;c[P+104+4>>2]=da;R=Jp(f|ja|0,da|0,e|0,R|0)|0;e=D;c[P+72>>2]=R;c[P+72+4>>2]=e;da=bo((ma|g)^R|0,T^e|0,63)|0;ja=D;e=_n((ma|g)^R|0,T^e|0,1)|0;ja=D|ja;T=c[P+48>>2]|0;R=c[P+48+4>>2]|0;V=Jp(T|0,R|0,la|0,V|0)|0;V=Jp(V|0,D|0,C|0,E|0)|0;la=D;g=Jp(ca^la|0,(Z|ia)^V|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;ma=D;f=bo(T^g|0,R^ma|0,24)|0;ka=D;R=_n(T^g|0,R^ma|0,40)|0;ka=D|ka;T=Jp(R|f|0,ka|0,V|0,la|0)|0;T=Jp(T|0,D|0,k|0,b|0)|0;aa=D;c[P+16>>2]=T;c[P+16+4>>2]=aa;$=bo(ca^la^T|0,(Z|ia)^V^aa|0,16)|0;ba=D;V=_n(ca^la^T|0,(Z|ia)^V^aa|0,48)|0;ba=D|ba;c[P+112>>2]=V|$;c[P+112+4>>2]=ba;ma=Jp(V|$|0,ba|0,g|0,ma|0)|0;g=D;ba=bo((R|f)^ma|0,ka^g|0,63)|0;$=D;ka=_n((R|f)^ma|0,ka^g|0,1)|0;$=D|$;f=c[P+56>>2]|0;R=c[P+56+4>>2]|0;S=Jp(f|0,R|0,X|0,S|0)|0;S=Jp(S|0,D|0,M|0,N|0)|0;X=D;V=c[P+120>>2]^S;ia=c[P+120+4>>2]^X;Z=Jp(ia|0,V|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;la=D;ca=bo(f^Z|0,R^la|0,24)|0;ea=D;R=_n(f^Z|0,R^la|0,40)|0;ea=D|ea;X=Jp(R|ca|0,ea|0,S|0,X|0)|0;X=Jp(X|0,D|0,v|0,w|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;f=bo(ia^X|0,V^S|0,16)|0;fa=D;V=_n(ia^X|0,V^S|0,48)|0;fa=D|fa;la=Jp(V|f|0,fa|0,Z|0,la|0)|0;Z=D;ia=bo((R|ca)^la|0,ea^Z|0,63)|0;ga=D;ea=_n((R|ca)^la|0,ea^Z|0,1)|0;ga=D|ga;Q=Jp(e|da|0,ja|0,Y|0,Q|0)|0;Q=Jp(Q|0,D|0,L|0,l|0)|0;Y=D;g=Jp(fa^Y|0,(V|f)^Q|0,ma|0,g|0)|0;ma=D;ca=bo((e|da)^g|0,ja^ma|0,24)|0;R=D;ja=_n((e|da)^g|0,ja^ma|0,40)|0;R=D|R;da=Jp(ja|ca|0,R|0,Q|0,Y|0)|0;da=Jp(da|0,D|0,J|0,K|0)|0;e=D;c[P>>2]=da;c[P+4>>2]=e;ha=bo(fa^Y^da|0,(V|f)^Q^e|0,16)|0;W=D;Q=_n(fa^Y^da|0,(V|f)^Q^e|0,48)|0;W=D|W;c[P+120>>2]=Q|ha;c[P+120+4>>2]=W;ma=Jp(Q|ha|0,W|0,g|0,ma|0)|0;g=D;c[P+80>>2]=ma;c[P+80+4>>2]=g;W=bo((ja|ca)^ma|0,R^g|0,63)|0;ha=D;g=_n((ja|ca)^ma|0,R^g|0,1)|0;c[P+40>>2]=g|W;c[P+40+4>>2]=D|ha;_=Jp(ka|ba|0,$|0,U|0,_|0)|0;_=Jp(_|0,D|0,o|0,x|0)|0;U=D;ha=c[P+96>>2]^_;W=c[P+96+4>>2]^U;Z=Jp(W|0,ha|0,la|0,Z|0)|0;la=D;g=bo((ka|ba)^Z|0,$^la|0,24)|0;R=D;$=_n((ka|ba)^Z|0,$^la|0,40)|0;R=D|R;U=Jp($|g|0,R|0,_|0,U|0)|0;U=Jp(U|0,D|0,m|0,n|0)|0;_=D;c[P+8>>2]=U;c[P+8+4>>2]=_;ba=bo(W^U|0,ha^_|0,16)|0;ka=D;ha=_n(W^U|0,ha^_|0,48)|0;ka=D|ka;la=Jp(ha|ba|0,ka|0,Z|0,la|0)|0;Z=D;c[P+88>>2]=la;c[P+88+4>>2]=Z;W=bo(($|g)^la|0,R^Z|0,63)|0;ma=D;Z=_n(($|g)^la|0,R^Z|0,1)|0;c[P+48>>2]=Z|W;c[P+48+4>>2]=D|ma;aa=Jp(ea|ia|0,ga|0,T|0,aa|0)|0;aa=Jp(aa|0,D|0,H|0,I|0)|0;T=D;ma=c[P+104>>2]^aa;W=c[P+104+4>>2]^T;Z=Jp(W|0,ma|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;R=D;la=bo((ea|ia)^Z|0,ga^R|0,24)|0;g=D;ga=_n((ea|ia)^Z|0,ga^R|0,40)|0;g=D|g;T=Jp(ga|la|0,g|0,aa|0,T|0)|0;T=Jp(T|0,D|0,y|0,z|0)|0;aa=D;c[P+16>>2]=T;c[P+16+4>>2]=aa;ia=bo(W^T|0,ma^aa|0,16)|0;ea=D;ma=_n(W^T|0,ma^aa|0,48)|0;ea=D|ea;R=Jp(ma|ia|0,ea|0,Z|0,R|0)|0;Z=D;W=bo((ga|la)^R|0,g^Z|0,63)|0;$=D;g=_n((ga|la)^R|0,g^Z|0,1)|0;c[P+56>>2]=g|W;c[P+56+4>>2]=D|$;$=c[P+32>>2]|0;W=c[P+32+4>>2]|0;S=Jp($|0,W|0,X|0,S|0)|0;S=Jp(S|0,D|0,t|0,u|0)|0;X=D;g=c[P+112>>2]^S;la=c[P+112+4>>2]^X;ga=Jp(la|0,g|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;ca=D;ja=bo($^ga|0,W^ca|0,24)|0;Q=D;W=_n($^ga|0,W^ca|0,40)|0;Q=D|Q;X=Jp(W|ja|0,Q|0,S|0,X|0)|0;X=Jp(X|0,D|0,p|0,q|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;$=bo(la^X|0,g^S|0,16)|0;f=D;g=_n(la^X|0,g^S|0,48)|0;f=D|f;ca=Jp(g|$|0,f|0,ga|0,ca|0)|0;ga=D;la=bo((W|ja)^ca|0,Q^ga|0,63)|0;V=D;Q=_n((W|ja)^ca|0,Q^ga|0,1)|0;V=D|V;e=Jp(Q|la|0,V|0,da|0,e|0)|0;e=Jp(e|0,D|0,H|0,I|0)|0;da=D;Z=Jp(ka^da|0,(ha|ba)^e|0,R|0,Z|0)|0;R=D;ja=bo((Q|la)^Z|0,V^R|0,24)|0;W=D;V=_n((Q|la)^Z|0,V^R|0,40)|0;W=D|W;la=Jp(V|ja|0,W|0,e|0,da|0)|0;la=Jp(la|0,D|0,A|0,B|0)|0;Q=D;c[P>>2]=la;c[P+4>>2]=Q;Y=bo(ka^da^la|0,(ha|ba)^e^Q|0,16)|0;fa=D;e=_n(ka^da^la|0,(ha|ba)^e^Q|0,48)|0;fa=D|fa;c[P+96>>2]=e|Y;c[P+96+4>>2]=fa;R=Jp(e|Y|0,fa|0,Z|0,R|0)|0;Z=D;c[P+64>>2]=R;c[P+64+4>>2]=Z;fa=bo((V|ja)^R|0,W^Z|0,63)|0;Y=D;Z=_n((V|ja)^R|0,W^Z|0,1)|0;c[P+32>>2]=Z|fa;c[P+32+4>>2]=D|Y;Y=c[P+40>>2]|0;fa=c[P+40+4>>2]|0;_=Jp(Y|0,fa|0,U|0,_|0)|0;_=Jp(_|0,D|0,J|0,K|0)|0;U=D;ga=Jp(ea^U|0,(ma|ia)^_|0,ca|0,ga|0)|0;ca=D;Z=bo(Y^ga|0,fa^ca|0,24)|0;W=D;fa=_n(Y^ga|0,fa^ca|0,40)|0;W=D|W;Y=Jp(fa|Z|0,W|0,_|0,U|0)|0;Y=Jp(Y|0,D|0,o|0,x|0)|0;R=D;c[P+8>>2]=Y;c[P+8+4>>2]=R;ja=bo(ea^U^Y|0,(ma|ia)^_^R|0,16)|0;V=D;_=_n(ea^U^Y|0,(ma|ia)^_^R|0,48)|0;V=D|V;c[P+104>>2]=_|ja;c[P+104+4>>2]=V;ca=Jp(_|ja|0,V|0,ga|0,ca|0)|0;ga=D;c[P+72>>2]=ca;c[P+72+4>>2]=ga;V=bo((fa|Z)^ca|0,W^ga|0,63)|0;ja=D;ga=_n((fa|Z)^ca|0,W^ga|0,1)|0;ja=D|ja;W=c[P+48>>2]|0;ca=c[P+48+4>>2]|0;aa=Jp(W|0,ca|0,T|0,aa|0)|0;aa=Jp(aa|0,D|0,t|0,u|0)|0;T=D;Z=Jp(f^T|0,(g|$)^aa|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;fa=D;_=bo(W^Z|0,ca^fa|0,24)|0;ia=D;ca=_n(W^Z|0,ca^fa|0,40)|0;ia=D|ia;W=Jp(ca|_|0,ia|0,aa|0,T|0)|0;W=Jp(W|0,D|0,m|0,n|0)|0;ma=D;c[P+16>>2]=W;c[P+16+4>>2]=ma;U=bo(f^T^W|0,(g|$)^aa^ma|0,16)|0;ea=D;aa=_n(f^T^W|0,(g|$)^aa^ma|0,48)|0;ea=D|ea;c[P+112>>2]=aa|U;c[P+112+4>>2]=ea;fa=Jp(aa|U|0,ea|0,Z|0,fa|0)|0;Z=D;ea=bo((ca|_)^fa|0,ia^Z|0,63)|0;U=D;ia=_n((ca|_)^fa|0,ia^Z|0,1)|0;U=D|U;_=c[P+56>>2]|0;ca=c[P+56+4>>2]|0;S=Jp(_|0,ca|0,X|0,S|0)|0;S=Jp(S|0,D|0,k|0,b|0)|0;X=D;aa=c[P+120>>2]^S;$=c[P+120+4>>2]^X;g=Jp($|0,aa|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;T=D;f=bo(_^g|0,ca^T|0,24)|0;e=D;ca=_n(_^g|0,ca^T|0,40)|0;e=D|e;X=Jp(ca|f|0,e|0,S|0,X|0)|0;X=Jp(X|0,D|0,M|0,N|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;_=bo($^X|0,aa^S|0,16)|0;ba=D;aa=_n($^X|0,aa^S|0,48)|0;ba=D|ba;T=Jp(aa|_|0,ba|0,g|0,T|0)|0;g=D;$=bo((ca|f)^T|0,e^g|0,63)|0;ha=D;e=_n((ca|f)^T|0,e^g|0,1)|0;ha=D|ha;Q=Jp(ga|V|0,ja|0,la|0,Q|0)|0;Q=Jp(Q|0,D|0,F|0,G|0)|0;la=D;Z=Jp(ba^la|0,(aa|_)^Q|0,fa|0,Z|0)|0;fa=D;f=bo((ga|V)^Z|0,ja^fa|0,24)|0;ca=D;ja=_n((ga|V)^Z|0,ja^fa|0,40)|0;ca=D|ca;V=Jp(ja|f|0,ca|0,Q|0,la|0)|0;V=Jp(V|0,D|0,h|0,j|0)|0;ga=D;c[P>>2]=V;c[P+4>>2]=ga;da=bo(ba^la^V|0,(aa|_)^Q^ga|0,16)|0;ka=D;Q=_n(ba^la^V|0,(aa|_)^Q^ga|0,48)|0;ka=D|ka;c[P+120>>2]=Q|da;c[P+120+4>>2]=ka;fa=Jp(Q|da|0,ka|0,Z|0,fa|0)|0;Z=D;c[P+80>>2]=fa;c[P+80+4>>2]=Z;ka=bo((ja|f)^fa|0,ca^Z|0,63)|0;da=D;Z=_n((ja|f)^fa|0,ca^Z|0,1)|0;c[P+40>>2]=Z|ka;c[P+40+4>>2]=D|da;R=Jp(ia|ea|0,U|0,Y|0,R|0)|0;R=Jp(R|0,D|0,p|0,q|0)|0;Y=D;da=c[P+96>>2]^R;ka=c[P+96+4>>2]^Y;g=Jp(ka|0,da|0,T|0,g|0)|0;T=D;Z=bo((ia|ea)^g|0,U^T|0,24)|0;ca=D;U=_n((ia|ea)^g|0,U^T|0,40)|0;ca=D|ca;Y=Jp(U|Z|0,ca|0,R|0,Y|0)|0;Y=Jp(Y|0,D|0,v|0,w|0)|0;R=D;c[P+8>>2]=Y;c[P+8+4>>2]=R;ea=bo(ka^Y|0,da^R|0,16)|0;ia=D;da=_n(ka^Y|0,da^R|0,48)|0;ia=D|ia;T=Jp(da|ea|0,ia|0,g|0,T|0)|0;g=D;c[P+88>>2]=T;c[P+88+4>>2]=g;ka=bo((U|Z)^T|0,ca^g|0,63)|0;fa=D;g=_n((U|Z)^T|0,ca^g|0,1)|0;c[P+48>>2]=g|ka;c[P+48+4>>2]=D|fa;ma=Jp(e|$|0,ha|0,W|0,ma|0)|0;ma=Jp(ma|0,D|0,y|0,z|0)|0;W=D;fa=c[P+104>>2]^ma;ka=c[P+104+4>>2]^W;g=Jp(ka|0,fa|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;ca=D;T=bo((e|$)^g|0,ha^ca|0,24)|0;Z=D;ha=_n((e|$)^g|0,ha^ca|0,40)|0;Z=D|Z;W=Jp(ha|T|0,Z|0,ma|0,W|0)|0;W=Jp(W|0,D|0,L|0,l|0)|0;ma=D;c[P+16>>2]=W;c[P+16+4>>2]=ma;$=bo(ka^W|0,fa^ma|0,16)|0;e=D;fa=_n(ka^W|0,fa^ma|0,48)|0;e=D|e;ca=Jp(fa|$|0,e|0,g|0,ca|0)|0;g=D;ka=bo((ha|T)^ca|0,Z^g|0,63)|0;U=D;Z=_n((ha|T)^ca|0,Z^g|0,1)|0;c[P+56>>2]=Z|ka;c[P+56+4>>2]=D|U;U=c[P+32>>2]|0;ka=c[P+32+4>>2]|0;S=Jp(U|0,ka|0,X|0,S|0)|0;S=Jp(S|0,D|0,C|0,E|0)|0;X=D;Z=c[P+112>>2]^S;T=c[P+112+4>>2]^X;ha=Jp(T|0,Z|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;f=D;ja=bo(U^ha|0,ka^f|0,24)|0;Q=D;ka=_n(U^ha|0,ka^f|0,40)|0;Q=D|Q;X=Jp(ka|ja|0,Q|0,S|0,X|0)|0;X=Jp(X|0,D|0,r|0,s|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;U=bo(T^X|0,Z^S|0,16)|0;_=D;Z=_n(T^X|0,Z^S|0,48)|0;_=D|_;f=Jp(Z|U|0,_|0,ha|0,f|0)|0;ha=D;T=bo((ka|ja)^f|0,Q^ha|0,63)|0;aa=D;Q=_n((ka|ja)^f|0,Q^ha|0,1)|0;aa=D|aa;ga=Jp(Q|T|0,aa|0,V|0,ga|0)|0;ga=Jp(ga|0,D|0,y|0,z|0)|0;V=D;g=Jp(ia^V|0,(da|ea)^ga|0,ca|0,g|0)|0;ca=D;ja=bo((Q|T)^g|0,aa^ca|0,24)|0;ka=D;aa=_n((Q|T)^g|0,aa^ca|0,40)|0;ka=D|ka;T=Jp(aa|ja|0,ka|0,ga|0,V|0)|0;T=Jp(T|0,D|0,C|0,E|0)|0;Q=D;c[P>>2]=T;c[P+4>>2]=Q;la=bo(ia^V^T|0,(da|ea)^ga^Q|0,16)|0;ba=D;ga=_n(ia^V^T|0,(da|ea)^ga^Q|0,48)|0;ba=D|ba;c[P+96>>2]=ga|la;c[P+96+4>>2]=ba;ca=Jp(ga|la|0,ba|0,g|0,ca|0)|0;g=D;c[P+64>>2]=ca;c[P+64+4>>2]=g;ba=bo((aa|ja)^ca|0,ka^g|0,63)|0;la=D;g=_n((aa|ja)^ca|0,ka^g|0,1)|0;c[P+32>>2]=g|ba;c[P+32+4>>2]=D|la;la=c[P+40>>2]|0;ba=c[P+40+4>>2]|0;R=Jp(la|0,ba|0,Y|0,R|0)|0;R=Jp(R|0,D|0,p|0,q|0)|0;Y=D;ha=Jp(e^Y|0,(fa|$)^R|0,f|0,ha|0)|0;f=D;g=bo(la^ha|0,ba^f|0,24)|0;ka=D;ba=_n(la^ha|0,ba^f|0,40)|0;ka=D|ka;la=Jp(ba|g|0,ka|0,R|0,Y|0)|0;la=Jp(la|0,D|0,L|0,l|0)|0;ca=D;c[P+8>>2]=la;c[P+8+4>>2]=ca;ja=bo(e^Y^la|0,(fa|$)^R^ca|0,16)|0;aa=D;R=_n(e^Y^la|0,(fa|$)^R^ca|0,48)|0;aa=D|aa;c[P+104>>2]=R|ja;c[P+104+4>>2]=aa;f=Jp(R|ja|0,aa|0,ha|0,f|0)|0;ha=D;c[P+72>>2]=f;c[P+72+4>>2]=ha;aa=bo((ba|g)^f|0,ka^ha|0,63)|0;ja=D;ha=_n((ba|g)^f|0,ka^ha|0,1)|0;ja=D|ja;ka=c[P+48>>2]|0;f=c[P+48+4>>2]|0;ma=Jp(ka|0,f|0,W|0,ma|0)|0;ma=Jp(ma|0,D|0,M|0,N|0)|0;W=D;g=Jp(_^W|0,(Z|U)^ma|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;ba=D;R=bo(ka^g|0,f^ba|0,24)|0;$=D;f=_n(ka^g|0,f^ba|0,40)|0;$=D|$;ka=Jp(f|R|0,$|0,ma|0,W|0)|0;ka=Jp(ka|0,D|0,J|0,K|0)|0;fa=D;c[P+16>>2]=ka;c[P+16+4>>2]=fa;Y=bo(_^W^ka|0,(Z|U)^ma^fa|0,16)|0;e=D;ma=_n(_^W^ka|0,(Z|U)^ma^fa|0,48)|0;e=D|e;c[P+112>>2]=ma|Y;c[P+112+4>>2]=e;ba=Jp(ma|Y|0,e|0,g|0,ba|0)|0;g=D;e=bo((f|R)^ba|0,$^g|0,63)|0;Y=D;$=_n((f|R)^ba|0,$^g|0,1)|0;Y=D|Y;R=c[P+56>>2]|0;f=c[P+56+4>>2]|0;S=Jp(R|0,f|0,X|0,S|0)|0;S=Jp(S|0,D|0,H|0,I|0)|0;X=D;ma=c[P+120>>2]^S;U=c[P+120+4>>2]^X;Z=Jp(U|0,ma|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;W=D;_=bo(R^Z|0,f^W|0,24)|0;ga=D;f=_n(R^Z|0,f^W|0,40)|0;ga=D|ga;X=Jp(f|_|0,ga|0,S|0,X|0)|0;X=Jp(X|0,D|0,h|0,j|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;R=bo(U^X|0,ma^S|0,16)|0;ea=D;ma=_n(U^X|0,ma^S|0,48)|0;ea=D|ea;W=Jp(ma|R|0,ea|0,Z|0,W|0)|0;Z=D;U=bo((f|_)^W|0,ga^Z|0,63)|0;da=D;ga=_n((f|_)^W|0,ga^Z|0,1)|0;da=D|da;Q=Jp(ha|aa|0,ja|0,T|0,Q|0)|0;Q=Jp(Q|0,D|0,m|0,n|0)|0;T=D;g=Jp(ea^T|0,(ma|R)^Q|0,ba|0,g|0)|0;ba=D;_=bo((ha|aa)^g|0,ja^ba|0,24)|0;f=D;ja=_n((ha|aa)^g|0,ja^ba|0,40)|0;f=D|f;aa=Jp(ja|_|0,f|0,Q|0,T|0)|0;aa=Jp(aa|0,D|0,v|0,w|0)|0;ha=D;c[P>>2]=aa;c[P+4>>2]=ha;V=bo(ea^T^aa|0,(ma|R)^Q^ha|0,16)|0;ia=D;Q=_n(ea^T^aa|0,(ma|R)^Q^ha|0,48)|0;ia=D|ia;c[P+120>>2]=Q|V;c[P+120+4>>2]=ia;ba=Jp(Q|V|0,ia|0,g|0,ba|0)|0;g=D;c[P+80>>2]=ba;c[P+80+4>>2]=g;ia=bo((ja|_)^ba|0,f^g|0,63)|0;V=D;g=_n((ja|_)^ba|0,f^g|0,1)|0;c[P+40>>2]=g|ia;c[P+40+4>>2]=D|V;ca=Jp($|e|0,Y|0,la|0,ca|0)|0;ca=Jp(ca|0,D|0,t|0,u|0)|0;la=D;V=c[P+96>>2]^ca;ia=c[P+96+4>>2]^la;Z=Jp(ia|0,V|0,W|0,Z|0)|0;W=D;g=bo(($|e)^Z|0,Y^W|0,24)|0;f=D;Y=_n(($|e)^Z|0,Y^W|0,40)|0;f=D|f;la=Jp(Y|g|0,f|0,ca|0,la|0)|0;la=Jp(la|0,D|0,F|0,G|0)|0;ca=D;c[P+8>>2]=la;c[P+8+4>>2]=ca;e=bo(ia^la|0,V^ca|0,16)|0;$=D;V=_n(ia^la|0,V^ca|0,48)|0;$=D|$;W=Jp(V|e|0,$|0,Z|0,W|0)|0;Z=D;c[P+88>>2]=W;c[P+88+4>>2]=Z;ia=bo((Y|g)^W|0,f^Z|0,63)|0;ba=D;Z=_n((Y|g)^W|0,f^Z|0,1)|0;c[P+48>>2]=Z|ia;c[P+48+4>>2]=D|ba;fa=Jp(ga|U|0,da|0,ka|0,fa|0)|0;fa=Jp(fa|0,D|0,r|0,s|0)|0;ka=D;ba=c[P+104>>2]^fa;ia=c[P+104+4>>2]^ka;Z=Jp(ia|0,ba|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;f=D;W=bo((ga|U)^Z|0,da^f|0,24)|0;g=D;da=_n((ga|U)^Z|0,da^f|0,40)|0;g=D|g;ka=Jp(da|W|0,g|0,fa|0,ka|0)|0;ka=Jp(ka|0,D|0,o|0,x|0)|0;fa=D;c[P+16>>2]=ka;c[P+16+4>>2]=fa;U=bo(ia^ka|0,ba^fa|0,16)|0;ga=D;ba=_n(ia^ka|0,ba^fa|0,48)|0;ga=D|ga;f=Jp(ba|U|0,ga|0,Z|0,f|0)|0;Z=D;ia=bo((da|W)^f|0,g^Z|0,63)|0;Y=D;g=_n((da|W)^f|0,g^Z|0,1)|0;c[P+56>>2]=g|ia;c[P+56+4>>2]=D|Y;Y=c[P+32>>2]|0;ia=c[P+32+4>>2]|0;S=Jp(Y|0,ia|0,X|0,S|0)|0;S=Jp(S|0,D|0,k|0,b|0)|0;X=D;g=c[P+112>>2]^S;W=c[P+112+4>>2]^X;da=Jp(W|0,g|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;_=D;ja=bo(Y^da|0,ia^_|0,24)|0;Q=D;ia=_n(Y^da|0,ia^_|0,40)|0;Q=D|Q;X=Jp(ia|ja|0,Q|0,S|0,X|0)|0;X=Jp(X|0,D|0,A|0,B|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;Y=bo(W^X|0,g^S|0,16)|0;R=D;g=_n(W^X|0,g^S|0,48)|0;R=D|R;_=Jp(g|Y|0,R|0,da|0,_|0)|0;da=D;W=bo((ia|ja)^_|0,Q^da|0,63)|0;ma=D;Q=_n((ia|ja)^_|0,Q^da|0,1)|0;ma=D|ma;ha=Jp(Q|W|0,ma|0,aa|0,ha|0)|0;ha=Jp(ha|0,D|0,C|0,E|0)|0;aa=D;Z=Jp($^aa|0,(V|e)^ha|0,f|0,Z|0)|0;f=D;ja=bo((Q|W)^Z|0,ma^f|0,24)|0;ia=D;ma=_n((Q|W)^Z|0,ma^f|0,40)|0;ia=D|ia;W=Jp(ma|ja|0,ia|0,ha|0,aa|0)|0;W=Jp(W|0,D|0,o|0,x|0)|0;Q=D;c[P>>2]=W;c[P+4>>2]=Q;T=bo($^aa^W|0,(V|e)^ha^Q|0,16)|0;ea=D;ha=_n($^aa^W|0,(V|e)^ha^Q|0,48)|0;ea=D|ea;c[P+96>>2]=ha|T;c[P+96+4>>2]=ea;f=Jp(ha|T|0,ea|0,Z|0,f|0)|0;Z=D;c[P+64>>2]=f;c[P+64+4>>2]=Z;ea=bo((ma|ja)^f|0,ia^Z|0,63)|0;T=D;Z=_n((ma|ja)^f|0,ia^Z|0,1)|0;c[P+32>>2]=Z|ea;c[P+32+4>>2]=D|T;T=c[P+40>>2]|0;ea=c[P+40+4>>2]|0;ca=Jp(T|0,ea|0,la|0,ca|0)|0;ca=Jp(ca|0,D|0,t|0,u|0)|0;la=D;da=Jp(ga^la|0,(ba|U)^ca|0,_|0,da|0)|0;_=D;Z=bo(T^da|0,ea^_|0,24)|0;ia=D;ea=_n(T^da|0,ea^_|0,40)|0;ia=D|ia;T=Jp(ea|Z|0,ia|0,ca|0,la|0)|0;T=Jp(T|0,D|0,y|0,z|0)|0;f=D;c[P+8>>2]=T;c[P+8+4>>2]=f;ja=bo(ga^la^T|0,(ba|U)^ca^f|0,16)|0;ma=D;ca=_n(ga^la^T|0,(ba|U)^ca^f|0,48)|0;ma=D|ma;c[P+104>>2]=ca|ja;c[P+104+4>>2]=ma;_=Jp(ca|ja|0,ma|0,da|0,_|0)|0;da=D;c[P+72>>2]=_;c[P+72+4>>2]=da;ma=bo((ea|Z)^_|0,ia^da|0,63)|0;ja=D;da=_n((ea|Z)^_|0,ia^da|0,1)|0;ja=D|ja;ia=c[P+48>>2]|0;_=c[P+48+4>>2]|0;fa=Jp(ia|0,_|0,ka|0,fa|0)|0;fa=Jp(fa|0,D|0,m|0,n|0)|0;ka=D;Z=Jp(R^ka|0,(g|Y)^fa|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;ea=D;ca=bo(ia^Z|0,_^ea|0,24)|0;U=D;_=_n(ia^Z|0,_^ea|0,40)|0;U=D|U;ia=Jp(_|ca|0,U|0,fa|0,ka|0)|0;ia=Jp(ia|0,D|0,r|0,s|0)|0;ba=D;c[P+16>>2]=ia;c[P+16+4>>2]=ba;la=bo(R^ka^ia|0,(g|Y)^fa^ba|0,16)|0;ga=D;fa=_n(R^ka^ia|0,(g|Y)^fa^ba|0,48)|0;ga=D|ga;c[P+112>>2]=fa|la;c[P+112+4>>2]=ga;ea=Jp(fa|la|0,ga|0,Z|0,ea|0)|0;Z=D;ga=bo((_|ca)^ea|0,U^Z|0,63)|0;la=D;U=_n((_|ca)^ea|0,U^Z|0,1)|0;la=D|la;ca=c[P+56>>2]|0;_=c[P+56+4>>2]|0;S=Jp(ca|0,_|0,X|0,S|0)|0;S=Jp(S|0,D|0,F|0,G|0)|0;X=D;fa=c[P+120>>2]^S;Y=c[P+120+4>>2]^X;g=Jp(Y|0,fa|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;ka=D;R=bo(ca^g|0,_^ka|0,24)|0;ha=D;_=_n(ca^g|0,_^ka|0,40)|0;ha=D|ha;X=Jp(_|R|0,ha|0,S|0,X|0)|0;X=Jp(X|0,D|0,k|0,b|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;ca=bo(Y^X|0,fa^S|0,16)|0;e=D;fa=_n(Y^X|0,fa^S|0,48)|0;e=D|e;ka=Jp(fa|ca|0,e|0,g|0,ka|0)|0;g=D;Y=bo((_|R)^ka|0,ha^g|0,63)|0;V=D;ha=_n((_|R)^ka|0,ha^g|0,1)|0;V=D|V;Q=Jp(da|ma|0,ja|0,W|0,Q|0)|0;Q=Jp(Q|0,D|0,h|0,j|0)|0;W=D;Z=Jp(e^W|0,(fa|ca)^Q|0,ea|0,Z|0)|0;ea=D;R=bo((da|ma)^Z|0,ja^ea|0,24)|0;_=D;ja=_n((da|ma)^Z|0,ja^ea|0,40)|0;_=D|_;ma=Jp(ja|R|0,_|0,Q|0,W|0)|0;ma=Jp(ma|0,D|0,L|0,l|0)|0;da=D;c[P>>2]=ma;c[P+4>>2]=da;aa=bo(e^W^ma|0,(fa|ca)^Q^da|0,16)|0;$=D;Q=_n(e^W^ma|0,(fa|ca)^Q^da|0,48)|0;$=D|$;c[P+120>>2]=Q|aa;c[P+120+4>>2]=$;ea=Jp(Q|aa|0,$|0,Z|0,ea|0)|0;Z=D;c[P+80>>2]=ea;c[P+80+4>>2]=Z;$=bo((ja|R)^ea|0,_^Z|0,63)|0;aa=D;Z=_n((ja|R)^ea|0,_^Z|0,1)|0;c[P+40>>2]=Z|$;c[P+40+4>>2]=D|aa;f=Jp(U|ga|0,la|0,T|0,f|0)|0;f=Jp(f|0,D|0,H|0,I|0)|0;T=D;aa=c[P+96>>2]^f;$=c[P+96+4>>2]^T;g=Jp($|0,aa|0,ka|0,g|0)|0;ka=D;Z=bo((U|ga)^g|0,la^ka|0,24)|0;_=D;la=_n((U|ga)^g|0,la^ka|0,40)|0;_=D|_;T=Jp(la|Z|0,_|0,f|0,T|0)|0;T=Jp(T|0,D|0,J|0,K|0)|0;f=D;c[P+8>>2]=T;c[P+8+4>>2]=f;ga=bo($^T|0,aa^f|0,16)|0;U=D;aa=_n($^T|0,aa^f|0,48)|0;U=D|U;ka=Jp(aa|ga|0,U|0,g|0,ka|0)|0;g=D;c[P+88>>2]=ka;c[P+88+4>>2]=g;$=bo((la|Z)^ka|0,_^g|0,63)|0;ea=D;g=_n((la|Z)^ka|0,_^g|0,1)|0;c[P+48>>2]=g|$;c[P+48+4>>2]=D|ea;ba=Jp(ha|Y|0,V|0,ia|0,ba|0)|0;ba=Jp(ba|0,D|0,v|0,w|0)|0;ia=D;ea=c[P+104>>2]^ba;$=c[P+104+4>>2]^ia;g=Jp($|0,ea|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;_=D;ka=bo((ha|Y)^g|0,V^_|0,24)|0;Z=D;V=_n((ha|Y)^g|0,V^_|0,40)|0;Z=D|Z;ia=Jp(V|ka|0,Z|0,ba|0,ia|0)|0;ia=Jp(ia|0,D|0,A|0,B|0)|0;ba=D;c[P+16>>2]=ia;c[P+16+4>>2]=ba;Y=bo($^ia|0,ea^ba|0,16)|0;ha=D;ea=_n($^ia|0,ea^ba|0,48)|0;ha=D|ha;_=Jp(ea|Y|0,ha|0,g|0,_|0)|0;g=D;$=bo((V|ka)^_|0,Z^g|0,63)|0;la=D;Z=_n((V|ka)^_|0,Z^g|0,1)|0;c[P+56>>2]=Z|$;c[P+56+4>>2]=D|la;la=c[P+32>>2]|0;$=c[P+32+4>>2]|0;S=Jp(la|0,$|0,X|0,S|0)|0;S=Jp(S|0,D|0,p|0,q|0)|0;X=D;Z=c[P+112>>2]^S;ka=c[P+112+4>>2]^X;V=Jp(ka|0,Z|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;R=D;ja=bo(la^V|0,$^R|0,24)|0;Q=D;$=_n(la^V|0,$^R|0,40)|0;Q=D|Q;X=Jp($|ja|0,Q|0,S|0,X|0)|0;X=Jp(X|0,D|0,M|0,N|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;la=bo(ka^X|0,Z^S|0,16)|0;ca=D;Z=_n(ka^X|0,Z^S|0,48)|0;ca=D|ca;R=Jp(Z|la|0,ca|0,V|0,R|0)|0;V=D;ka=bo(($|ja)^R|0,Q^V|0,63)|0;fa=D;Q=_n(($|ja)^R|0,Q^V|0,1)|0;fa=D|fa;da=Jp(Q|ka|0,fa|0,ma|0,da|0)|0;da=Jp(da|0,D|0,m|0,n|0)|0;ma=D;g=Jp(U^ma|0,(aa|ga)^da|0,_|0,g|0)|0;_=D;ja=bo((Q|ka)^g|0,fa^_|0,24)|0;$=D;fa=_n((Q|ka)^g|0,fa^_|0,40)|0;$=D|$;ka=Jp(fa|ja|0,$|0,da|0,ma|0)|0;ka=Jp(ka|0,D|0,J|0,K|0)|0;Q=D;c[P>>2]=ka;c[P+4>>2]=Q;W=bo(U^ma^ka|0,(aa|ga)^da^Q|0,16)|0;e=D;da=_n(U^ma^ka|0,(aa|ga)^da^Q|0,48)|0;e=D|e;c[P+96>>2]=da|W;c[P+96+4>>2]=e;_=Jp(da|W|0,e|0,g|0,_|0)|0;g=D;c[P+64>>2]=_;c[P+64+4>>2]=g;e=bo((fa|ja)^_|0,$^g|0,63)|0;W=D;g=_n((fa|ja)^_|0,$^g|0,1)|0;c[P+32>>2]=g|e;c[P+32+4>>2]=D|W;W=c[P+40>>2]|0;e=c[P+40+4>>2]|0;f=Jp(W|0,e|0,T|0,f|0)|0;f=Jp(f|0,D|0,v|0,w|0)|0;T=D;V=Jp(ha^T|0,(ea|Y)^f|0,R|0,V|0)|0;R=D;g=bo(W^V|0,e^R|0,24)|0;$=D;e=_n(W^V|0,e^R|0,40)|0;$=D|$;W=Jp(e|g|0,$|0,f|0,T|0)|0;W=Jp(W|0,D|0,F|0,G|0)|0;_=D;c[P+8>>2]=W;c[P+8+4>>2]=_;ja=bo(ha^T^W|0,(ea|Y)^f^_|0,16)|0;fa=D;f=_n(ha^T^W|0,(ea|Y)^f^_|0,48)|0;fa=D|fa;c[P+104>>2]=f|ja;c[P+104+4>>2]=fa;R=Jp(f|ja|0,fa|0,V|0,R|0)|0;V=D;c[P+72>>2]=R;c[P+72+4>>2]=V;fa=bo((e|g)^R|0,$^V|0,63)|0;ja=D;V=_n((e|g)^R|0,$^V|0,1)|0;ja=D|ja;$=c[P+48>>2]|0;R=c[P+48+4>>2]|0;ba=Jp($|0,R|0,ia|0,ba|0)|0;ba=Jp(ba|0,D|0,o|0,x|0)|0;ia=D;g=Jp(ca^ia|0,(Z|la)^ba|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;e=D;f=bo($^g|0,R^e|0,24)|0;Y=D;R=_n($^g|0,R^e|0,40)|0;Y=D|Y;$=Jp(R|f|0,Y|0,ba|0,ia|0)|0;$=Jp($|0,D|0,H|0,I|0)|0;ea=D;c[P+16>>2]=$;c[P+16+4>>2]=ea;T=bo(ca^ia^$|0,(Z|la)^ba^ea|0,16)|0;ha=D;ba=_n(ca^ia^$|0,(Z|la)^ba^ea|0,48)|0;ha=D|ha;c[P+112>>2]=ba|T;c[P+112+4>>2]=ha;e=Jp(ba|T|0,ha|0,g|0,e|0)|0;g=D;ha=bo((R|f)^e|0,Y^g|0,63)|0;T=D;Y=_n((R|f)^e|0,Y^g|0,1)|0;T=D|T;f=c[P+56>>2]|0;R=c[P+56+4>>2]|0;S=Jp(f|0,R|0,X|0,S|0)|0;S=Jp(S|0,D|0,A|0,B|0)|0;X=D;ba=c[P+120>>2]^S;la=c[P+120+4>>2]^X;Z=Jp(la|0,ba|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;ia=D;ca=bo(f^Z|0,R^ia|0,24)|0;da=D;R=_n(f^Z|0,R^ia|0,40)|0;da=D|da;X=Jp(R|ca|0,da|0,S|0,X|0)|0;X=Jp(X|0,D|0,p|0,q|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;f=bo(la^X|0,ba^S|0,16)|0;ga=D;ba=_n(la^X|0,ba^S|0,48)|0;ga=D|ga;ia=Jp(ba|f|0,ga|0,Z|0,ia|0)|0;Z=D;la=bo((R|ca)^ia|0,da^Z|0,63)|0;aa=D;da=_n((R|ca)^ia|0,da^Z|0,1)|0;aa=D|aa;Q=Jp(V|fa|0,ja|0,ka|0,Q|0)|0;Q=Jp(Q|0,D|0,r|0,s|0)|0;ka=D;g=Jp(ga^ka|0,(ba|f)^Q|0,e|0,g|0)|0;e=D;ca=bo((V|fa)^g|0,ja^e|0,24)|0;R=D;ja=_n((V|fa)^g|0,ja^e|0,40)|0;R=D|R;fa=Jp(ja|ca|0,R|0,Q|0,ka|0)|0;fa=Jp(fa|0,D|0,M|0,N|0)|0;V=D;c[P>>2]=fa;c[P+4>>2]=V;ma=bo(ga^ka^fa|0,(ba|f)^Q^V|0,16)|0;U=D;Q=_n(ga^ka^fa|0,(ba|f)^Q^V|0,48)|0;U=D|U;c[P+120>>2]=Q|ma;c[P+120+4>>2]=U;e=Jp(Q|ma|0,U|0,g|0,e|0)|0;g=D;c[P+80>>2]=e;c[P+80+4>>2]=g;U=bo((ja|ca)^e|0,R^g|0,63)|0;ma=D;g=_n((ja|ca)^e|0,R^g|0,1)|0;c[P+40>>2]=g|U;c[P+40+4>>2]=D|ma;_=Jp(Y|ha|0,T|0,W|0,_|0)|0;_=Jp(_|0,D|0,y|0,z|0)|0;W=D;ma=c[P+96>>2]^_;U=c[P+96+4>>2]^W;Z=Jp(U|0,ma|0,ia|0,Z|0)|0;ia=D;g=bo((Y|ha)^Z|0,T^ia|0,24)|0;R=D;T=_n((Y|ha)^Z|0,T^ia|0,40)|0;R=D|R;W=Jp(T|g|0,R|0,_|0,W|0)|0;W=Jp(W|0,D|0,t|0,u|0)|0;_=D;c[P+8>>2]=W;c[P+8+4>>2]=_;ha=bo(U^W|0,ma^_|0,16)|0;Y=D;ma=_n(U^W|0,ma^_|0,48)|0;Y=D|Y;ia=Jp(ma|ha|0,Y|0,Z|0,ia|0)|0;Z=D;c[P+88>>2]=ia;c[P+88+4>>2]=Z;U=bo((T|g)^ia|0,R^Z|0,63)|0;e=D;Z=_n((T|g)^ia|0,R^Z|0,1)|0;c[P+48>>2]=Z|U;c[P+48+4>>2]=D|e;ea=Jp(da|la|0,aa|0,$|0,ea|0)|0;ea=Jp(ea|0,D|0,k|0,b|0)|0;$=D;e=c[P+104>>2]^ea;U=c[P+104+4>>2]^$;Z=Jp(U|0,e|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;R=D;ia=bo((da|la)^Z|0,aa^R|0,24)|0;g=D;aa=_n((da|la)^Z|0,aa^R|0,40)|0;g=D|g;$=Jp(aa|ia|0,g|0,ea|0,$|0)|0;$=Jp($|0,D|0,h|0,j|0)|0;ea=D;c[P+16>>2]=$;c[P+16+4>>2]=ea;la=bo(U^$|0,e^ea|0,16)|0;da=D;e=_n(U^$|0,e^ea|0,48)|0;da=D|da;R=Jp(e|la|0,da|0,Z|0,R|0)|0;Z=D;U=bo((aa|ia)^R|0,g^Z|0,63)|0;T=D;g=_n((aa|ia)^R|0,g^Z|0,1)|0;c[P+56>>2]=g|U;c[P+56+4>>2]=D|T;T=c[P+32>>2]|0;U=c[P+32+4>>2]|0;S=Jp(T|0,U|0,X|0,S|0)|0;S=Jp(S|0,D|0,L|0,l|0)|0;X=D;g=c[P+112>>2]^S;ia=c[P+112+4>>2]^X;aa=Jp(ia|0,g|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;ca=D;ja=bo(T^aa|0,U^ca|0,24)|0;Q=D;U=_n(T^aa|0,U^ca|0,40)|0;Q=D|Q;X=Jp(U|ja|0,Q|0,S|0,X|0)|0;X=Jp(X|0,D|0,C|0,E|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;T=bo(ia^X|0,g^S|0,16)|0;f=D;g=_n(ia^X|0,g^S|0,48)|0;f=D|f;ca=Jp(g|T|0,f|0,aa|0,ca|0)|0;aa=D;ia=bo((U|ja)^ca|0,Q^aa|0,63)|0;ba=D;Q=_n((U|ja)^ca|0,Q^aa|0,1)|0;ba=D|ba;V=Jp(Q|ia|0,ba|0,fa|0,V|0)|0;V=Jp(V|0,D|0,J|0,K|0)|0;fa=D;Z=Jp(Y^fa|0,(ma|ha)^V|0,R|0,Z|0)|0;R=D;ja=bo((Q|ia)^Z|0,ba^R|0,24)|0;U=D;ba=_n((Q|ia)^Z|0,ba^R|0,40)|0;U=D|U;ia=Jp(ba|ja|0,U|0,V|0,fa|0)|0;ia=Jp(ia|0,D|0,t|0,u|0)|0;Q=D;c[P>>2]=ia;c[P+4>>2]=Q;ka=bo(Y^fa^ia|0,(ma|ha)^V^Q|0,16)|0;ga=D;V=_n(Y^fa^ia|0,(ma|ha)^V^Q|0,48)|0;ga=D|ga;c[P+96>>2]=V|ka;c[P+96+4>>2]=ga;R=Jp(V|ka|0,ga|0,Z|0,R|0)|0;Z=D;c[P+64>>2]=R;c[P+64+4>>2]=Z;ga=bo((ba|ja)^R|0,U^Z|0,63)|0;ka=D;Z=_n((ba|ja)^R|0,U^Z|0,1)|0;c[P+32>>2]=Z|ga;c[P+32+4>>2]=D|ka;ka=c[P+40>>2]|0;ga=c[P+40+4>>2]|0;_=Jp(ka|0,ga|0,W|0,_|0)|0;_=Jp(_|0,D|0,L|0,l|0)|0;W=D;aa=Jp(da^W|0,(e|la)^_|0,ca|0,aa|0)|0;ca=D;Z=bo(ka^aa|0,ga^ca|0,24)|0;U=D;ga=_n(ka^aa|0,ga^ca|0,40)|0;U=D|U;ka=Jp(ga|Z|0,U|0,_|0,W|0)|0;ka=Jp(ka|0,D|0,k|0,b|0)|0;R=D;c[P+8>>2]=ka;c[P+8+4>>2]=R;ja=bo(da^W^ka|0,(e|la)^_^R|0,16)|0;ba=D;_=_n(da^W^ka|0,(e|la)^_^R|0,48)|0;ba=D|ba;c[P+104>>2]=_|ja;c[P+104+4>>2]=ba;ca=Jp(_|ja|0,ba|0,aa|0,ca|0)|0;aa=D;c[P+72>>2]=ca;c[P+72+4>>2]=aa;ba=bo((ga|Z)^ca|0,U^aa|0,63)|0;ja=D;aa=_n((ga|Z)^ca|0,U^aa|0,1)|0;ja=D|ja;U=c[P+48>>2]|0;ca=c[P+48+4>>2]|0;ea=Jp(U|0,ca|0,$|0,ea|0)|0;ea=Jp(ea|0,D|0,h|0,j|0)|0;$=D;Z=Jp(f^$|0,(g|T)^ea|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;ga=D;_=bo(U^Z|0,ca^ga|0,24)|0;la=D;ca=_n(U^Z|0,ca^ga|0,40)|0;la=D|la;U=Jp(ca|_|0,la|0,ea|0,$|0)|0;U=Jp(U|0,D|0,M|0,N|0)|0;e=D;c[P+16>>2]=U;c[P+16+4>>2]=e;W=bo(f^$^U|0,(g|T)^ea^e|0,16)|0;da=D;ea=_n(f^$^U|0,(g|T)^ea^e|0,48)|0;da=D|da;c[P+112>>2]=ea|W;c[P+112+4>>2]=da;ga=Jp(ea|W|0,da|0,Z|0,ga|0)|0;Z=D;da=bo((ca|_)^ga|0,la^Z|0,63)|0;W=D;la=_n((ca|_)^ga|0,la^Z|0,1)|0;W=D|W;_=c[P+56>>2]|0;ca=c[P+56+4>>2]|0;S=Jp(_|0,ca|0,X|0,S|0)|0;S=Jp(S|0,D|0,r|0,s|0)|0;X=D;ea=c[P+120>>2]^S;T=c[P+120+4>>2]^X;g=Jp(T|0,ea|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;$=D;f=bo(_^g|0,ca^$|0,24)|0;V=D;ca=_n(_^g|0,ca^$|0,40)|0;V=D|V;X=Jp(ca|f|0,V|0,S|0,X|0)|0;X=Jp(X|0,D|0,F|0,G|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;_=bo(T^X|0,ea^S|0,16)|0;ha=D;ea=_n(T^X|0,ea^S|0,48)|0;ha=D|ha;$=Jp(ea|_|0,ha|0,g|0,$|0)|0;g=D;T=bo((ca|f)^$|0,V^g|0,63)|0;ma=D;V=_n((ca|f)^$|0,V^g|0,1)|0;ma=D|ma;Q=Jp(aa|ba|0,ja|0,ia|0,Q|0)|0;Q=Jp(Q|0,D|0,o|0,x|0)|0;ia=D;Z=Jp(ha^ia|0,(ea|_)^Q|0,ga|0,Z|0)|0;ga=D;f=bo((aa|ba)^Z|0,ja^ga|0,24)|0;ca=D;ja=_n((aa|ba)^Z|0,ja^ga|0,40)|0;ca=D|ca;ba=Jp(ja|f|0,ca|0,Q|0,ia|0)|0;ba=Jp(ba|0,D|0,y|0,z|0)|0;aa=D;c[P>>2]=ba;c[P+4>>2]=aa;fa=bo(ha^ia^ba|0,(ea|_)^Q^aa|0,16)|0;Y=D;Q=_n(ha^ia^ba|0,(ea|_)^Q^aa|0,48)|0;Y=D|Y;c[P+120>>2]=Q|fa;c[P+120+4>>2]=Y;ga=Jp(Q|fa|0,Y|0,Z|0,ga|0)|0;Z=D;c[P+80>>2]=ga;c[P+80+4>>2]=Z;Y=bo((ja|f)^ga|0,ca^Z|0,63)|0;fa=D;Z=_n((ja|f)^ga|0,ca^Z|0,1)|0;c[P+40>>2]=Z|Y;c[P+40+4>>2]=D|fa;R=Jp(la|da|0,W|0,ka|0,R|0)|0;R=Jp(R|0,D|0,v|0,w|0)|0;ka=D;fa=c[P+96>>2]^R;Y=c[P+96+4>>2]^ka;g=Jp(Y|0,fa|0,$|0,g|0)|0;$=D;Z=bo((la|da)^g|0,W^$|0,24)|0;ca=D;W=_n((la|da)^g|0,W^$|0,40)|0;ca=D|ca;ka=Jp(W|Z|0,ca|0,R|0,ka|0)|0;ka=Jp(ka|0,D|0,p|0,q|0)|0;R=D;c[P+8>>2]=ka;c[P+8+4>>2]=R;da=bo(Y^ka|0,fa^R|0,16)|0;la=D;fa=_n(Y^ka|0,fa^R|0,48)|0;la=D|la;$=Jp(fa|da|0,la|0,g|0,$|0)|0;g=D;c[P+88>>2]=$;c[P+88+4>>2]=g;Y=bo((W|Z)^$|0,ca^g|0,63)|0;ga=D;g=_n((W|Z)^$|0,ca^g|0,1)|0;c[P+48>>2]=g|Y;c[P+48+4>>2]=D|ga;e=Jp(V|T|0,ma|0,U|0,e|0)|0;e=Jp(e|0,D|0,C|0,E|0)|0;U=D;ga=c[P+104>>2]^e;Y=c[P+104+4>>2]^U;g=Jp(Y|0,ga|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;ca=D;$=bo((V|T)^g|0,ma^ca|0,24)|0;Z=D;ma=_n((V|T)^g|0,ma^ca|0,40)|0;Z=D|Z;U=Jp(ma|$|0,Z|0,e|0,U|0)|0;U=Jp(U|0,D|0,m|0,n|0)|0;e=D;c[P+16>>2]=U;c[P+16+4>>2]=e;T=bo(Y^U|0,ga^e|0,16)|0;V=D;ga=_n(Y^U|0,ga^e|0,48)|0;V=D|V;ca=Jp(ga|T|0,V|0,g|0,ca|0)|0;g=D;Y=bo((ma|$)^ca|0,Z^g|0,63)|0;W=D;Z=_n((ma|$)^ca|0,Z^g|0,1)|0;c[P+56>>2]=Z|Y;c[P+56+4>>2]=D|W;W=c[P+32>>2]|0;Y=c[P+32+4>>2]|0;S=Jp(W|0,Y|0,X|0,S|0)|0;S=Jp(S|0,D|0,A|0,B|0)|0;X=D;Z=c[P+112>>2]^S;$=c[P+112+4>>2]^X;ma=Jp($|0,Z|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;f=D;ja=bo(W^ma|0,Y^f|0,24)|0;Q=D;Y=_n(W^ma|0,Y^f|0,40)|0;Q=D|Q;X=Jp(Y|ja|0,Q|0,S|0,X|0)|0;X=Jp(X|0,D|0,H|0,I|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;W=bo($^X|0,Z^S|0,16)|0;_=D;Z=_n($^X|0,Z^S|0,48)|0;_=D|_;f=Jp(Z|W|0,_|0,ma|0,f|0)|0;ma=D;$=bo((Y|ja)^f|0,Q^ma|0,63)|0;ea=D;Q=_n((Y|ja)^f|0,Q^ma|0,1)|0;ea=D|ea;aa=Jp(Q|$|0,ea|0,ba|0,aa|0)|0;aa=Jp(aa|0,D|0,M|0,N|0)|0;ba=D;g=Jp(la^ba|0,(fa|da)^aa|0,ca|0,g|0)|0;ca=D;ja=bo((Q|$)^g|0,ea^ca|0,24)|0;Y=D;ea=_n((Q|$)^g|0,ea^ca|0,40)|0;Y=D|Y;$=Jp(ea|ja|0,Y|0,aa|0,ba|0)|0;$=Jp($|0,D|0,H|0,I|0)|0;Q=D;c[P>>2]=$;c[P+4>>2]=Q;ia=bo(la^ba^$|0,(fa|da)^aa^Q|0,16)|0;ha=D;aa=_n(la^ba^$|0,(fa|da)^aa^Q|0,48)|0;ha=D|ha;c[P+96>>2]=aa|ia;c[P+96+4>>2]=ha;ca=Jp(aa|ia|0,ha|0,g|0,ca|0)|0;g=D;c[P+64>>2]=ca;c[P+64+4>>2]=g;ha=bo((ea|ja)^ca|0,Y^g|0,63)|0;ia=D;g=_n((ea|ja)^ca|0,Y^g|0,1)|0;c[P+32>>2]=g|ha;c[P+32+4>>2]=D|ia;ia=c[P+40>>2]|0;ha=c[P+40+4>>2]|0;R=Jp(ia|0,ha|0,ka|0,R|0)|0;R=Jp(R|0,D|0,y|0,z|0)|0;ka=D;ma=Jp(V^ka|0,(ga|T)^R|0,f|0,ma|0)|0;f=D;g=bo(ia^ma|0,ha^f|0,24)|0;Y=D;ha=_n(ia^ma|0,ha^f|0,40)|0;Y=D|Y;ia=Jp(ha|g|0,Y|0,R|0,ka|0)|0;ia=Jp(ia|0,D|0,h|0,j|0)|0;ca=D;c[P+8>>2]=ia;c[P+8+4>>2]=ca;ja=bo(V^ka^ia|0,(ga|T)^R^ca|0,16)|0;ea=D;R=_n(V^ka^ia|0,(ga|T)^R^ca|0,48)|0;ea=D|ea;c[P+104>>2]=R|ja;c[P+104+4>>2]=ea;f=Jp(R|ja|0,ea|0,ma|0,f|0)|0;ma=D;c[P+72>>2]=f;c[P+72+4>>2]=ma;ea=bo((ha|g)^f|0,Y^ma|0,63)|0;ja=D;ma=_n((ha|g)^f|0,Y^ma|0,1)|0;ja=D|ja;Y=c[P+48>>2]|0;f=c[P+48+4>>2]|0;e=Jp(Y|0,f|0,U|0,e|0)|0;e=Jp(e|0,D|0,J|0,K|0)|0;U=D;g=Jp(_^U|0,(Z|W)^e|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;ha=D;R=bo(Y^g|0,f^ha|0,24)|0;T=D;f=_n(Y^g|0,f^ha|0,40)|0;T=D|T;Y=Jp(f|R|0,T|0,e|0,U|0)|0;Y=Jp(Y|0,D|0,L|0,l|0)|0;ga=D;c[P+16>>2]=Y;c[P+16+4>>2]=ga;ka=bo(_^U^Y|0,(Z|W)^e^ga|0,16)|0;V=D;e=_n(_^U^Y|0,(Z|W)^e^ga|0,48)|0;V=D|V;c[P+112>>2]=e|ka;c[P+112+4>>2]=V;ha=Jp(e|ka|0,V|0,g|0,ha|0)|0;g=D;V=bo((f|R)^ha|0,T^g|0,63)|0;ka=D;T=_n((f|R)^ha|0,T^g|0,1)|0;ka=D|ka;R=c[P+56>>2]|0;f=c[P+56+4>>2]|0;S=Jp(R|0,f|0,X|0,S|0)|0;S=Jp(S|0,D|0,p|0,q|0)|0;X=D;e=c[P+120>>2]^S;W=c[P+120+4>>2]^X;Z=Jp(W|0,e|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;U=D;_=bo(R^Z|0,f^U|0,24)|0;aa=D;f=_n(R^Z|0,f^U|0,40)|0;aa=D|aa;X=Jp(f|_|0,aa|0,S|0,X|0)|0;X=Jp(X|0,D|0,C|0,E|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;R=bo(W^X|0,e^S|0,16)|0;da=D;e=_n(W^X|0,e^S|0,48)|0;da=D|da;U=Jp(e|R|0,da|0,Z|0,U|0)|0;Z=D;W=bo((f|_)^U|0,aa^Z|0,63)|0;fa=D;aa=_n((f|_)^U|0,aa^Z|0,1)|0;fa=D|fa;Q=Jp(ma|ea|0,ja|0,$|0,Q|0)|0;Q=Jp(Q|0,D|0,t|0,u|0)|0;$=D;g=Jp(da^$|0,(e|R)^Q|0,ha|0,g|0)|0;ha=D;_=bo((ma|ea)^g|0,ja^ha|0,24)|0;f=D;ja=_n((ma|ea)^g|0,ja^ha|0,40)|0;f=D|f;ea=Jp(ja|_|0,f|0,Q|0,$|0)|0;ea=Jp(ea|0,D|0,o|0,x|0)|0;ma=D;c[P>>2]=ea;c[P+4>>2]=ma;ba=bo(da^$^ea|0,(e|R)^Q^ma|0,16)|0;la=D;Q=_n(da^$^ea|0,(e|R)^Q^ma|0,48)|0;la=D|la;c[P+120>>2]=Q|ba;c[P+120+4>>2]=la;ha=Jp(Q|ba|0,la|0,g|0,ha|0)|0;g=D;c[P+80>>2]=ha;c[P+80+4>>2]=g;la=bo((ja|_)^ha|0,f^g|0,63)|0;ba=D;g=_n((ja|_)^ha|0,f^g|0,1)|0;c[P+40>>2]=g|la;c[P+40+4>>2]=D|ba;ca=Jp(T|V|0,ka|0,ia|0,ca|0)|0;ca=Jp(ca|0,D|0,k|0,b|0)|0;ia=D;ba=c[P+96>>2]^ca;la=c[P+96+4>>2]^ia;Z=Jp(la|0,ba|0,U|0,Z|0)|0;U=D;g=bo((T|V)^Z|0,ka^U|0,24)|0;f=D;ka=_n((T|V)^Z|0,ka^U|0,40)|0;f=D|f;ia=Jp(ka|g|0,f|0,ca|0,ia|0)|0;ia=Jp(ia|0,D|0,r|0,s|0)|0;ca=D;c[P+8>>2]=ia;c[P+8+4>>2]=ca;V=bo(la^ia|0,ba^ca|0,16)|0;T=D;ba=_n(la^ia|0,ba^ca|0,48)|0;T=D|T;U=Jp(ba|V|0,T|0,Z|0,U|0)|0;Z=D;c[P+88>>2]=U;c[P+88+4>>2]=Z;la=bo((ka|g)^U|0,f^Z|0,63)|0;ha=D;Z=_n((ka|g)^U|0,f^Z|0,1)|0;c[P+48>>2]=Z|la;c[P+48+4>>2]=D|ha;ga=Jp(aa|W|0,fa|0,Y|0,ga|0)|0;ga=Jp(ga|0,D|0,A|0,B|0)|0;Y=D;ha=c[P+104>>2]^ga;la=c[P+104+4>>2]^Y;Z=Jp(la|0,ha|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;f=D;U=bo((aa|W)^Z|0,fa^f|0,24)|0;g=D;fa=_n((aa|W)^Z|0,fa^f|0,40)|0;g=D|g;Y=Jp(fa|U|0,g|0,ga|0,Y|0)|0;Y=Jp(Y|0,D|0,v|0,w|0)|0;ga=D;c[P+16>>2]=Y;c[P+16+4>>2]=ga;W=bo(la^Y|0,ha^ga|0,16)|0;aa=D;ha=_n(la^Y|0,ha^ga|0,48)|0;aa=D|aa;f=Jp(ha|W|0,aa|0,Z|0,f|0)|0;Z=D;la=bo((fa|U)^f|0,g^Z|0,63)|0;ka=D;g=_n((fa|U)^f|0,g^Z|0,1)|0;c[P+56>>2]=g|la;c[P+56+4>>2]=D|ka;ka=c[P+32>>2]|0;la=c[P+32+4>>2]|0;S=Jp(ka|0,la|0,X|0,S|0)|0;S=Jp(S|0,D|0,m|0,n|0)|0;X=D;g=c[P+112>>2]^S;U=c[P+112+4>>2]^X;fa=Jp(U|0,g|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;_=D;ja=bo(ka^fa|0,la^_|0,24)|0;Q=D;la=_n(ka^fa|0,la^_|0,40)|0;Q=D|Q;X=Jp(la|ja|0,Q|0,S|0,X|0)|0;X=Jp(X|0,D|0,F|0,G|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;ka=bo(U^X|0,g^S|0,16)|0;R=D;g=_n(U^X|0,g^S|0,48)|0;R=D|R;_=Jp(g|ka|0,R|0,fa|0,_|0)|0;fa=D;U=bo((la|ja)^_|0,Q^fa|0,63)|0;e=D;Q=_n((la|ja)^_|0,Q^fa|0,1)|0;e=D|e;ma=Jp(Q|U|0,e|0,ea|0,ma|0)|0;ma=Jp(ma|0,D|0,v|0,w|0)|0;ea=D;Z=Jp(T^ea|0,(ba|V)^ma|0,f|0,Z|0)|0;f=D;ja=bo((Q|U)^Z|0,e^f|0,24)|0;la=D;e=_n((Q|U)^Z|0,e^f|0,40)|0;la=D|la;U=Jp(e|ja|0,la|0,ma|0,ea|0)|0;U=Jp(U|0,D|0,k|0,b|0)|0;Q=D;c[P>>2]=U;c[P+4>>2]=Q;$=bo(T^ea^U|0,(ba|V)^ma^Q|0,16)|0;da=D;ma=_n(T^ea^U|0,(ba|V)^ma^Q|0,48)|0;da=D|da;c[P+96>>2]=ma|$;c[P+96+4>>2]=da;f=Jp(ma|$|0,da|0,Z|0,f|0)|0;Z=D;c[P+64>>2]=f;c[P+64+4>>2]=Z;da=bo((e|ja)^f|0,la^Z|0,63)|0;$=D;Z=_n((e|ja)^f|0,la^Z|0,1)|0;c[P+32>>2]=Z|da;c[P+32+4>>2]=D|$;$=c[P+40>>2]|0;da=c[P+40+4>>2]|0;ca=Jp($|0,da|0,ia|0,ca|0)|0;ca=Jp(ca|0,D|0,h|0,j|0)|0;ia=D;fa=Jp(aa^ia|0,(ha|W)^ca|0,_|0,fa|0)|0;_=D;Z=bo($^fa|0,da^_|0,24)|0;la=D;da=_n($^fa|0,da^_|0,40)|0;la=D|la;$=Jp(da|Z|0,la|0,ca|0,ia|0)|0;$=Jp($|0,D|0,C|0,E|0)|0;f=D;c[P+8>>2]=$;c[P+8+4>>2]=f;ja=bo(aa^ia^$|0,(ha|W)^ca^f|0,16)|0;e=D;ca=_n(aa^ia^$|0,(ha|W)^ca^f|0,48)|0;e=D|e;c[P+104>>2]=ca|ja;c[P+104+4>>2]=e;_=Jp(ca|ja|0,e|0,fa|0,_|0)|0;fa=D;c[P+72>>2]=_;c[P+72+4>>2]=fa;e=bo((da|Z)^_|0,la^fa|0,63)|0;ja=D;fa=_n((da|Z)^_|0,la^fa|0,1)|0;ja=D|ja;la=c[P+48>>2]|0;_=c[P+48+4>>2]|0;ga=Jp(la|0,_|0,Y|0,ga|0)|0;ga=Jp(ga|0,D|0,H|0,I|0)|0;Y=D;Z=Jp(R^Y|0,(g|ka)^ga|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;da=D;ca=bo(la^Z|0,_^da|0,24)|0;W=D;_=_n(la^Z|0,_^da|0,40)|0;W=D|W;la=Jp(_|ca|0,W|0,ga|0,Y|0)|0;la=Jp(la|0,D|0,p|0,q|0)|0;ha=D;c[P+16>>2]=la;c[P+16+4>>2]=ha;ia=bo(R^Y^la|0,(g|ka)^ga^ha|0,16)|0;aa=D;ga=_n(R^Y^la|0,(g|ka)^ga^ha|0,48)|0;aa=D|aa;c[P+112>>2]=ga|ia;c[P+112+4>>2]=aa;da=Jp(ga|ia|0,aa|0,Z|0,da|0)|0;Z=D;aa=bo((_|ca)^da|0,W^Z|0,63)|0;ia=D;W=_n((_|ca)^da|0,W^Z|0,1)|0;ia=D|ia;ca=c[P+56>>2]|0;_=c[P+56+4>>2]|0;S=Jp(ca|0,_|0,X|0,S|0)|0;S=Jp(S|0,D|0,o|0,x|0)|0;X=D;ga=c[P+120>>2]^S;ka=c[P+120+4>>2]^X;g=Jp(ka|0,ga|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;Y=D;R=bo(ca^g|0,_^Y|0,24)|0;ma=D;_=_n(ca^g|0,_^Y|0,40)|0;ma=D|ma;X=Jp(_|R|0,ma|0,S|0,X|0)|0;X=Jp(X|0,D|0,A|0,B|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;ca=bo(ka^X|0,ga^S|0,16)|0;V=D;ga=_n(ka^X|0,ga^S|0,48)|0;V=D|V;Y=Jp(ga|ca|0,V|0,g|0,Y|0)|0;g=D;ka=bo((_|R)^Y|0,ma^g|0,63)|0;ba=D;ma=_n((_|R)^Y|0,ma^g|0,1)|0;ba=D|ba;Q=Jp(fa|e|0,ja|0,U|0,Q|0)|0;Q=Jp(Q|0,D|0,J|0,K|0)|0;U=D;Z=Jp(V^U|0,(ga|ca)^Q|0,da|0,Z|0)|0;da=D;R=bo((fa|e)^Z|0,ja^da|0,24)|0;_=D;ja=_n((fa|e)^Z|0,ja^da|0,40)|0;_=D|_;e=Jp(ja|R|0,_|0,Q|0,U|0)|0;e=Jp(e|0,D|0,m|0,n|0)|0;fa=D;c[P>>2]=e;c[P+4>>2]=fa;ea=bo(V^U^e|0,(ga|ca)^Q^fa|0,16)|0;T=D;Q=_n(V^U^e|0,(ga|ca)^Q^fa|0,48)|0;T=D|T;c[P+120>>2]=Q|ea;c[P+120+4>>2]=T;da=Jp(Q|ea|0,T|0,Z|0,da|0)|0;Z=D;c[P+80>>2]=da;c[P+80+4>>2]=Z;T=bo((ja|R)^da|0,_^Z|0,63)|0;ea=D;Z=_n((ja|R)^da|0,_^Z|0,1)|0;c[P+40>>2]=Z|T;c[P+40+4>>2]=D|ea;f=Jp(W|aa|0,ia|0,$|0,f|0)|0;f=Jp(f|0,D|0,M|0,N|0)|0;$=D;ea=c[P+96>>2]^f;T=c[P+96+4>>2]^$;g=Jp(T|0,ea|0,Y|0,g|0)|0;Y=D;Z=bo((W|aa)^g|0,ia^Y|0,24)|0;_=D;ia=_n((W|aa)^g|0,ia^Y|0,40)|0;_=D|_;$=Jp(ia|Z|0,_|0,f|0,$|0)|0;$=Jp($|0,D|0,y|0,z|0)|0;f=D;c[P+8>>2]=$;c[P+8+4>>2]=f;aa=bo(T^$|0,ea^f|0,16)|0;W=D;ea=_n(T^$|0,ea^f|0,48)|0;W=D|W;Y=Jp(ea|aa|0,W|0,g|0,Y|0)|0;g=D;c[P+88>>2]=Y;c[P+88+4>>2]=g;T=bo((ia|Z)^Y|0,_^g|0,63)|0;da=D;g=_n((ia|Z)^Y|0,_^g|0,1)|0;c[P+48>>2]=g|T;c[P+48+4>>2]=D|da;ha=Jp(ma|ka|0,ba|0,la|0,ha|0)|0;ha=Jp(ha|0,D|0,L|0,l|0)|0;la=D;da=c[P+104>>2]^ha;T=c[P+104+4>>2]^la;g=Jp(T|0,da|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;_=D;Y=bo((ma|ka)^g|0,ba^_|0,24)|0;Z=D;ba=_n((ma|ka)^g|0,ba^_|0,40)|0;Z=D|Z;la=Jp(ba|Y|0,Z|0,ha|0,la|0)|0;la=Jp(la|0,D|0,r|0,s|0)|0;ha=D;c[P+16>>2]=la;c[P+16+4>>2]=ha;ka=bo(T^la|0,da^ha|0,16)|0;ma=D;da=_n(T^la|0,da^ha|0,48)|0;ma=D|ma;_=Jp(da|ka|0,ma|0,g|0,_|0)|0;g=D;T=bo((ba|Y)^_|0,Z^g|0,63)|0;ia=D;Z=_n((ba|Y)^_|0,Z^g|0,1)|0;c[P+56>>2]=Z|T;c[P+56+4>>2]=D|ia;ia=c[P+32>>2]|0;T=c[P+32+4>>2]|0;S=Jp(ia|0,T|0,X|0,S|0)|0;S=Jp(S|0,D|0,F|0,G|0)|0;X=D;Z=c[P+112>>2]^S;Y=c[P+112+4>>2]^X;ba=Jp(Y|0,Z|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;R=D;ja=bo(ia^ba|0,T^R|0,24)|0;Q=D;T=_n(ia^ba|0,T^R|0,40)|0;Q=D|Q;X=Jp(T|ja|0,Q|0,S|0,X|0)|0;X=Jp(X|0,D|0,t|0,u|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;ia=bo(Y^X|0,Z^S|0,16)|0;ca=D;Z=_n(Y^X|0,Z^S|0,48)|0;ca=D|ca;R=Jp(Z|ia|0,ca|0,ba|0,R|0)|0;ba=D;Y=bo((T|ja)^R|0,Q^ba|0,63)|0;ga=D;Q=_n((T|ja)^R|0,Q^ba|0,1)|0;ga=D|ga;fa=Jp(Q|Y|0,ga|0,e|0,fa|0)|0;fa=Jp(fa|0,D|0,F|0,G|0)|0;e=D;g=Jp(W^e|0,(ea|aa)^fa|0,_|0,g|0)|0;_=D;ja=bo((Q|Y)^g|0,ga^_|0,24)|0;T=D;ga=_n((Q|Y)^g|0,ga^_|0,40)|0;T=D|T;Y=Jp(ga|ja|0,T|0,fa|0,e|0)|0;Y=Jp(Y|0,D|0,m|0,n|0)|0;Q=D;c[P>>2]=Y;c[P+4>>2]=Q;U=bo(W^e^Y|0,(ea|aa)^fa^Q|0,16)|0;V=D;fa=_n(W^e^Y|0,(ea|aa)^fa^Q|0,48)|0;V=D|V;c[P+96>>2]=fa|U;c[P+96+4>>2]=V;_=Jp(fa|U|0,V|0,g|0,_|0)|0;g=D;c[P+64>>2]=_;c[P+64+4>>2]=g;V=bo((ga|ja)^_|0,T^g|0,63)|0;U=D;g=_n((ga|ja)^_|0,T^g|0,1)|0;c[P+32>>2]=g|V;c[P+32+4>>2]=D|U;U=c[P+40>>2]|0;V=c[P+40+4>>2]|0;f=Jp(U|0,V|0,$|0,f|0)|0;f=Jp(f|0,D|0,A|0,B|0)|0;$=D;ba=Jp(ma^$|0,(da|ka)^f|0,R|0,ba|0)|0;R=D;g=bo(U^ba|0,V^R|0,24)|0;T=D;V=_n(U^ba|0,V^R|0,40)|0;T=D|T;U=Jp(V|g|0,T|0,f|0,$|0)|0;U=Jp(U|0,D|0,r|0,s|0)|0;_=D;c[P+8>>2]=U;c[P+8+4>>2]=_;ja=bo(ma^$^U|0,(da|ka)^f^_|0,16)|0;ga=D;f=_n(ma^$^U|0,(da|ka)^f^_|0,48)|0;ga=D|ga;c[P+104>>2]=f|ja;c[P+104+4>>2]=ga;R=Jp(f|ja|0,ga|0,ba|0,R|0)|0;ba=D;c[P+72>>2]=R;c[P+72+4>>2]=ba;ga=bo((V|g)^R|0,T^ba|0,63)|0;ja=D;ba=_n((V|g)^R|0,T^ba|0,1)|0;ja=D|ja;T=c[P+48>>2]|0;R=c[P+48+4>>2]|0;ha=Jp(T|0,R|0,la|0,ha|0)|0;ha=Jp(ha|0,D|0,y|0,z|0)|0;la=D;g=Jp(ca^la|0,(Z|ia)^ha|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;V=D;f=bo(T^g|0,R^V|0,24)|0;ka=D;R=_n(T^g|0,R^V|0,40)|0;ka=D|ka;T=Jp(R|f|0,ka|0,ha|0,la|0)|0;T=Jp(T|0,D|0,v|0,w|0)|0;da=D;c[P+16>>2]=T;c[P+16+4>>2]=da;$=bo(ca^la^T|0,(Z|ia)^ha^da|0,16)|0;ma=D;ha=_n(ca^la^T|0,(Z|ia)^ha^da|0,48)|0;ma=D|ma;c[P+112>>2]=ha|$;c[P+112+4>>2]=ma;V=Jp(ha|$|0,ma|0,g|0,V|0)|0;g=D;ma=bo((R|f)^V|0,ka^g|0,63)|0;$=D;ka=_n((R|f)^V|0,ka^g|0,1)|0;$=D|$;f=c[P+56>>2]|0;R=c[P+56+4>>2]|0;S=Jp(f|0,R|0,X|0,S|0)|0;S=Jp(S|0,D|0,L|0,l|0)|0;X=D;ha=c[P+120>>2]^S;ia=c[P+120+4>>2]^X;Z=Jp(ia|0,ha|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;la=D;ca=bo(f^Z|0,R^la|0,24)|0;fa=D;R=_n(f^Z|0,R^la|0,40)|0;fa=D|fa;X=Jp(R|ca|0,fa|0,S|0,X|0)|0;X=Jp(X|0,D|0,t|0,u|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;f=bo(ia^X|0,ha^S|0,16)|0;aa=D;ha=_n(ia^X|0,ha^S|0,48)|0;aa=D|aa;la=Jp(ha|f|0,aa|0,Z|0,la|0)|0;Z=D;ia=bo((R|ca)^la|0,fa^Z|0,63)|0;ea=D;fa=_n((R|ca)^la|0,fa^Z|0,1)|0;ea=D|ea;Q=Jp(ba|ga|0,ja|0,Y|0,Q|0)|0;Q=Jp(Q|0,D|0,k|0,b|0)|0;Y=D;g=Jp(aa^Y|0,(ha|f)^Q|0,V|0,g|0)|0;V=D;ca=bo((ba|ga)^g|0,ja^V|0,24)|0;R=D;ja=_n((ba|ga)^g|0,ja^V|0,40)|0;R=D|R;ga=Jp(ja|ca|0,R|0,Q|0,Y|0)|0;ga=Jp(ga|0,D|0,H|0,I|0)|0;ba=D;c[P>>2]=ga;c[P+4>>2]=ba;e=bo(aa^Y^ga|0,(ha|f)^Q^ba|0,16)|0;W=D;Q=_n(aa^Y^ga|0,(ha|f)^Q^ba|0,48)|0;W=D|W;c[P+120>>2]=Q|e;c[P+120+4>>2]=W;V=Jp(Q|e|0,W|0,g|0,V|0)|0;g=D;c[P+80>>2]=V;c[P+80+4>>2]=g;W=bo((ja|ca)^V|0,R^g|0,63)|0;e=D;g=_n((ja|ca)^V|0,R^g|0,1)|0;c[P+40>>2]=g|W;c[P+40+4>>2]=D|e;_=Jp(ka|ma|0,$|0,U|0,_|0)|0;_=Jp(_|0,D|0,C|0,E|0)|0;U=D;e=c[P+96>>2]^_;W=c[P+96+4>>2]^U;Z=Jp(W|0,e|0,la|0,Z|0)|0;la=D;g=bo((ka|ma)^Z|0,$^la|0,24)|0;R=D;$=_n((ka|ma)^Z|0,$^la|0,40)|0;R=D|R;U=Jp($|g|0,R|0,_|0,U|0)|0;U=Jp(U|0,D|0,h|0,j|0)|0;_=D;c[P+8>>2]=U;c[P+8+4>>2]=_;ma=bo(W^U|0,e^_|0,16)|0;ka=D;e=_n(W^U|0,e^_|0,48)|0;ka=D|ka;la=Jp(e|ma|0,ka|0,Z|0,la|0)|0;Z=D;c[P+88>>2]=la;c[P+88+4>>2]=Z;W=bo(($|g)^la|0,R^Z|0,63)|0;V=D;Z=_n(($|g)^la|0,R^Z|0,1)|0;c[P+48>>2]=Z|W;c[P+48+4>>2]=D|V;da=Jp(fa|ia|0,ea|0,T|0,da|0)|0;da=Jp(da|0,D|0,p|0,q|0)|0;T=D;V=c[P+104>>2]^da;W=c[P+104+4>>2]^T;Z=Jp(W|0,V|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;R=D;la=bo((fa|ia)^Z|0,ea^R|0,24)|0;g=D;ea=_n((fa|ia)^Z|0,ea^R|0,40)|0;g=D|g;T=Jp(ea|la|0,g|0,da|0,T|0)|0;T=Jp(T|0,D|0,J|0,K|0)|0;da=D;c[P+16>>2]=T;c[P+16+4>>2]=da;ia=bo(W^T|0,V^da|0,16)|0;fa=D;V=_n(W^T|0,V^da|0,48)|0;fa=D|fa;R=Jp(V|ia|0,fa|0,Z|0,R|0)|0;Z=D;W=bo((ea|la)^R|0,g^Z|0,63)|0;$=D;g=_n((ea|la)^R|0,g^Z|0,1)|0;c[P+56>>2]=g|W;c[P+56+4>>2]=D|$;$=c[P+32>>2]|0;W=c[P+32+4>>2]|0;S=Jp($|0,W|0,X|0,S|0)|0;S=Jp(S|0,D|0,M|0,N|0)|0;X=D;g=c[P+112>>2]^S;la=c[P+112+4>>2]^X;ea=Jp(la|0,g|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;ca=D;ja=bo($^ea|0,W^ca|0,24)|0;Q=D;W=_n($^ea|0,W^ca|0,40)|0;Q=D|Q;X=Jp(W|ja|0,Q|0,S|0,X|0)|0;X=Jp(X|0,D|0,o|0,x|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;$=bo(la^X|0,g^S|0,16)|0;f=D;g=_n(la^X|0,g^S|0,48)|0;f=D|f;ca=Jp(g|$|0,f|0,ea|0,ca|0)|0;ea=D;la=bo((W|ja)^ca|0,Q^ea|0,63)|0;ha=D;Q=_n((W|ja)^ca|0,Q^ea|0,1)|0;ha=D|ha;ba=Jp(Q|la|0,ha|0,ga|0,ba|0)|0;ba=Jp(ba|0,D|0,o|0,x|0)|0;ga=D;Z=Jp(ka^ga|0,(e|ma)^ba|0,R|0,Z|0)|0;R=D;ja=bo((Q|la)^Z|0,ha^R|0,24)|0;W=D;ha=_n((Q|la)^Z|0,ha^R|0,40)|0;W=D|W;la=Jp(ha|ja|0,W|0,ba|0,ga|0)|0;la=Jp(la|0,D|0,L|0,l|0)|0;Q=D;c[P>>2]=la;c[P+4>>2]=Q;Y=bo(ka^ga^la|0,(e|ma)^ba^Q|0,16)|0;aa=D;ba=_n(ka^ga^la|0,(e|ma)^ba^Q|0,48)|0;aa=D|aa;c[P+96>>2]=ba|Y;c[P+96+4>>2]=aa;R=Jp(ba|Y|0,aa|0,Z|0,R|0)|0;Z=D;c[P+64>>2]=R;c[P+64+4>>2]=Z;aa=bo((ha|ja)^R|0,W^Z|0,63)|0;Y=D;Z=_n((ha|ja)^R|0,W^Z|0,1)|0;c[P+32>>2]=Z|aa;c[P+32+4>>2]=D|Y;Y=c[P+40>>2]|0;aa=c[P+40+4>>2]|0;_=Jp(Y|0,aa|0,U|0,_|0)|0;_=Jp(_|0,D|0,m|0,n|0)|0;U=D;ea=Jp(fa^U|0,(V|ia)^_|0,ca|0,ea|0)|0;ca=D;Z=bo(Y^ea|0,aa^ca|0,24)|0;W=D;aa=_n(Y^ea|0,aa^ca|0,40)|0;W=D|W;Y=Jp(aa|Z|0,W|0,_|0,U|0)|0;Y=Jp(Y|0,D|0,p|0,q|0)|0;R=D;c[P+8>>2]=Y;c[P+8+4>>2]=R;ja=bo(fa^U^Y|0,(V|ia)^_^R|0,16)|0;ha=D;_=_n(fa^U^Y|0,(V|ia)^_^R|0,48)|0;ha=D|ha;c[P+104>>2]=_|ja;c[P+104+4>>2]=ha;ca=Jp(_|ja|0,ha|0,ea|0,ca|0)|0;ea=D;c[P+72>>2]=ca;c[P+72+4>>2]=ea;ha=bo((aa|Z)^ca|0,W^ea|0,63)|0;ja=D;ea=_n((aa|Z)^ca|0,W^ea|0,1)|0;ja=D|ja;W=c[P+48>>2]|0;ca=c[P+48+4>>2]|0;da=Jp(W|0,ca|0,T|0,da|0)|0;da=Jp(da|0,D|0,r|0,s|0)|0;T=D;Z=Jp(f^T|0,(g|$)^da|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;aa=D;_=bo(W^Z|0,ca^aa|0,24)|0;ia=D;ca=_n(W^Z|0,ca^aa|0,40)|0;ia=D|ia;W=Jp(ca|_|0,ia|0,da|0,T|0)|0;W=Jp(W|0,D|0,t|0,u|0)|0;V=D;c[P+16>>2]=W;c[P+16+4>>2]=V;U=bo(f^T^W|0,(g|$)^da^V|0,16)|0;fa=D;da=_n(f^T^W|0,(g|$)^da^V|0,48)|0;fa=D|fa;c[P+112>>2]=da|U;c[P+112+4>>2]=fa;aa=Jp(da|U|0,fa|0,Z|0,aa|0)|0;Z=D;fa=bo((ca|_)^aa|0,ia^Z|0,63)|0;U=D;ia=_n((ca|_)^aa|0,ia^Z|0,1)|0;U=D|U;_=c[P+56>>2]|0;ca=c[P+56+4>>2]|0;S=Jp(_|0,ca|0,X|0,S|0)|0;S=Jp(S|0,D|0,v|0,w|0)|0;X=D;da=c[P+120>>2]^S;$=c[P+120+4>>2]^X;g=Jp($|0,da|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;T=D;f=bo(_^g|0,ca^T|0,24)|0;ba=D;ca=_n(_^g|0,ca^T|0,40)|0;ba=D|ba;X=Jp(ca|f|0,ba|0,S|0,X|0)|0;X=Jp(X|0,D|0,y|0,z|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;_=bo($^X|0,da^S|0,16)|0;ma=D;da=_n($^X|0,da^S|0,48)|0;ma=D|ma;T=Jp(da|_|0,ma|0,g|0,T|0)|0;g=D;$=bo((ca|f)^T|0,ba^g|0,63)|0;e=D;ba=_n((ca|f)^T|0,ba^g|0,1)|0;e=D|e;Q=Jp(ea|ha|0,ja|0,la|0,Q|0)|0;Q=Jp(Q|0,D|0,A|0,B|0)|0;la=D;Z=Jp(ma^la|0,(da|_)^Q|0,aa|0,Z|0)|0;aa=D;f=bo((ea|ha)^Z|0,ja^aa|0,24)|0;ca=D;ja=_n((ea|ha)^Z|0,ja^aa|0,40)|0;ca=D|ca;ha=Jp(ja|f|0,ca|0,Q|0,la|0)|0;ha=Jp(ha|0,D|0,C|0,E|0)|0;ea=D;c[P>>2]=ha;c[P+4>>2]=ea;ga=bo(ma^la^ha|0,(da|_)^Q^ea|0,16)|0;ka=D;Q=_n(ma^la^ha|0,(da|_)^Q^ea|0,48)|0;ka=D|ka;c[P+120>>2]=Q|ga;c[P+120+4>>2]=ka;aa=Jp(Q|ga|0,ka|0,Z|0,aa|0)|0;Z=D;c[P+80>>2]=aa;c[P+80+4>>2]=Z;ka=bo((ja|f)^aa|0,ca^Z|0,63)|0;ga=D;Z=_n((ja|f)^aa|0,ca^Z|0,1)|0;c[P+40>>2]=Z|ka;c[P+40+4>>2]=D|ga;R=Jp(ia|fa|0,U|0,Y|0,R|0)|0;R=Jp(R|0,D|0,F|0,G|0)|0;Y=D;ga=c[P+96>>2]^R;ka=c[P+96+4>>2]^Y;g=Jp(ka|0,ga|0,T|0,g|0)|0;T=D;Z=bo((ia|fa)^g|0,U^T|0,24)|0;ca=D;U=_n((ia|fa)^g|0,U^T|0,40)|0;ca=D|ca;Y=Jp(U|Z|0,ca|0,R|0,Y|0)|0;Y=Jp(Y|0,D|0,H|0,I|0)|0;R=D;c[P+8>>2]=Y;c[P+8+4>>2]=R;fa=bo(ka^Y|0,ga^R|0,16)|0;ia=D;ga=_n(ka^Y|0,ga^R|0,48)|0;ia=D|ia;T=Jp(ga|fa|0,ia|0,g|0,T|0)|0;g=D;c[P+88>>2]=T;c[P+88+4>>2]=g;ka=bo((U|Z)^T|0,ca^g|0,63)|0;aa=D;g=_n((U|Z)^T|0,ca^g|0,1)|0;c[P+48>>2]=g|ka;c[P+48+4>>2]=D|aa;V=Jp(ba|$|0,e|0,W|0,V|0)|0;V=Jp(V|0,D|0,J|0,K|0)|0;W=D;aa=c[P+104>>2]^V;ka=c[P+104+4>>2]^W;g=Jp(ka|0,aa|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;ca=D;T=bo((ba|$)^g|0,e^ca|0,24)|0;Z=D;e=_n((ba|$)^g|0,e^ca|0,40)|0;Z=D|Z;W=Jp(e|T|0,Z|0,V|0,W|0)|0;W=Jp(W|0,D|0,M|0,N|0)|0;V=D;c[P+16>>2]=W;c[P+16+4>>2]=V;$=bo(ka^W|0,aa^V|0,16)|0;ba=D;aa=_n(ka^W|0,aa^V|0,48)|0;ba=D|ba;ca=Jp(aa|$|0,ba|0,g|0,ca|0)|0;g=D;ka=bo((e|T)^ca|0,Z^g|0,63)|0;U=D;Z=_n((e|T)^ca|0,Z^g|0,1)|0;c[P+56>>2]=Z|ka;c[P+56+4>>2]=D|U;U=c[P+32>>2]|0;ka=c[P+32+4>>2]|0;S=Jp(U|0,ka|0,X|0,S|0)|0;S=Jp(S|0,D|0,h|0,j|0)|0;X=D;Z=c[P+112>>2]^S;T=c[P+112+4>>2]^X;e=Jp(T|0,Z|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;f=D;ja=bo(U^e|0,ka^f|0,24)|0;Q=D;ka=_n(U^e|0,ka^f|0,40)|0;Q=D|Q;X=Jp(ka|ja|0,Q|0,S|0,X|0)|0;X=Jp(X|0,D|0,k|0,b|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;U=bo(T^X|0,Z^S|0,16)|0;_=D;Z=_n(T^X|0,Z^S|0,48)|0;_=D|_;f=Jp(Z|U|0,_|0,e|0,f|0)|0;e=D;T=bo((ka|ja)^f|0,Q^e|0,63)|0;da=D;Q=_n((ka|ja)^f|0,Q^e|0,1)|0;da=D|da;ea=Jp(Q|T|0,da|0,ha|0,ea|0)|0;ea=Jp(ea|0,D|0,h|0,j|0)|0;ha=D;g=Jp(ia^ha|0,(ga|fa)^ea|0,ca|0,g|0)|0;h=D;ca=bo((Q|T)^g|0,da^h|0,24)|0;j=D;da=_n((Q|T)^g|0,da^h|0,40)|0;j=D|j;T=Jp(da|ca|0,j|0,ea|0,ha|0)|0;T=Jp(T|0,D|0,F|0,G|0)|0;Q=D;c[P>>2]=T;c[P+4>>2]=Q;G=bo(ia^ha^T|0,(ga|fa)^ea^Q|0,16)|0;F=D;ea=_n(ia^ha^T|0,(ga|fa)^ea^Q|0,48)|0;F=D|F;c[P+96>>2]=ea|G;c[P+96+4>>2]=F;F=Jp(ea|G|0,F|0,g|0,h|0)|0;h=D;c[P+64>>2]=F;c[P+64+4>>2]=h;G=bo((da|ca)^F|0,j^h|0,63)|0;g=D;h=_n((da|ca)^F|0,j^h|0,1)|0;c[P+32>>2]=h|G;c[P+32+4>>2]=D|g;g=c[P+40>>2]|0;G=c[P+40+4>>2]|0;R=Jp(g|0,G|0,Y|0,R|0)|0;R=Jp(R|0,D|0,r|0,s|0)|0;h=D;e=Jp(ba^h|0,(aa|$)^R|0,f|0,e|0)|0;f=D;F=bo(g^e|0,G^f|0,24)|0;Y=D;G=_n(g^e|0,G^f|0,40)|0;Y=D|Y;s=Jp(G|F|0,Y|0,R|0,h|0)|0;s=Jp(s|0,D|0,A|0,B|0)|0;r=D;c[P+8>>2]=s;c[P+8+4>>2]=r;g=bo(ba^h^s|0,(aa|$)^R^r|0,16)|0;B=D;R=_n(ba^h^s|0,(aa|$)^R^r|0,48)|0;B=D|B;c[P+104>>2]=R|g;c[P+104+4>>2]=B;B=Jp(R|g|0,B|0,e|0,f|0)|0;f=D;c[P+72>>2]=B;c[P+72+4>>2]=f;e=bo((G|F)^B|0,Y^f|0,63)|0;g=D;f=_n((G|F)^B|0,Y^f|0,1)|0;g=D|g;B=c[P+48>>2]|0;Y=c[P+48+4>>2]|0;F=Jp(B|0,Y|0,W|0,V|0)|0;F=Jp(F|0,D|0,C|0,E|0)|0;G=D;V=Jp(_^G|0,(Z|U)^F|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;W=D;R=bo(B^V|0,Y^W|0,24)|0;h=D;Y=_n(B^V|0,Y^W|0,40)|0;h=D|h;B=Jp(Y|R|0,h|0,F|0,G|0)|0;B=Jp(B|0,D|0,k|0,b|0)|0;C=D;c[P+16>>2]=B;c[P+16+4>>2]=C;k=bo(_^G^B|0,(Z|U)^F^C|0,16)|0;j=D;F=_n(_^G^B|0,(Z|U)^F^C|0,48)|0;j=D|j;c[P+112>>2]=F|k;c[P+112+4>>2]=j;W=Jp(F|k|0,j|0,V|0,W|0)|0;V=D;j=bo((Y|R)^W|0,h^V|0,63)|0;k=D;h=_n((Y|R)^W|0,h^V|0,1)|0;k=D|k;R=c[P+56>>2]|0;Y=c[P+56+4>>2]|0;F=Jp(R|0,Y|0,X|0,S|0)|0;F=Jp(F|0,D|0,M|0,N|0)|0;G=D;S=c[P+120>>2]^F;A=c[P+120+4>>2]^G;M=Jp(A|0,S|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;E=D;X=bo(R^M|0,Y^E|0,24)|0;N=D;Y=_n(R^M|0,Y^E|0,40)|0;N=D|N;G=Jp(Y|X|0,N|0,F|0,G|0)|0;G=Jp(G|0,D|0,v|0,w|0)|0;F=D;c[P+24>>2]=G;c[P+24+4>>2]=F;R=bo(A^G|0,S^F|0,16)|0;U=D;S=_n(A^G|0,S^F|0,48)|0;U=D|U;E=Jp(S|R|0,U|0,M|0,E|0)|0;M=D;A=bo((Y|X)^E|0,N^M|0,63)|0;b=D;w=_n((Y|X)^E|0,N^M|0,1)|0;b=D|b;Q=Jp(f|e|0,g|0,T|0,Q|0)|0;Q=Jp(Q|0,D|0,L|0,l|0)|0;T=D;v=Jp(U^T|0,(S|R)^Q|0,W|0,V|0)|0;N=D;l=bo((f|e)^v|0,g^N|0,24)|0;L=D;g=_n((f|e)^v|0,g^N|0,40)|0;L=D|L;e=Jp(g|l|0,L|0,Q|0,T|0)|0;e=Jp(e|0,D|0,J|0,K|0)|0;f=D;c[P>>2]=e;c[P+4>>2]=f;J=bo(U^T^e|0,(S|R)^Q^f|0,16)|0;K=D;Q=_n(U^T^e|0,(S|R)^Q^f|0,48)|0;K=D|K;c[P+120>>2]=Q|J;c[P+120+4>>2]=K;N=Jp(Q|J|0,K|0,v|0,N|0)|0;K=D;c[P+80>>2]=N;c[P+80+4>>2]=K;J=bo((g|l)^N|0,L^K|0,63)|0;v=D;K=_n((g|l)^N|0,L^K|0,1)|0;c[P+40>>2]=K|J;c[P+40+4>>2]=D|v;v=Jp(h|j|0,k|0,s|0,r|0)|0;v=Jp(v|0,D|0,o|0,x|0)|0;r=D;s=c[P+96>>2]^v;o=c[P+96+4>>2]^r;M=Jp(o|0,s|0,E|0,M|0)|0;E=D;J=bo((h|j)^M|0,k^E|0,24)|0;K=D;x=_n((h|j)^M|0,k^E|0,40)|0;K=D|K;r=Jp(x|J|0,K|0,v|0,r|0)|0;r=Jp(r|0,D|0,m|0,n|0)|0;v=D;c[P+8>>2]=r;c[P+8+4>>2]=v;L=bo(o^r|0,s^v|0,16)|0;N=D;v=_n(o^r|0,s^v|0,48)|0;N=D|N;c[P+96>>2]=v|L;c[P+96+4>>2]=N;E=Jp(v|L|0,N|0,M|0,E|0)|0;M=D;c[P+88>>2]=E;c[P+88+4>>2]=M;N=bo((x|J)^E|0,K^M|0,63)|0;L=D;M=_n((x|J)^E|0,K^M|0,1)|0;c[P+48>>2]=M|N;c[P+48+4>>2]=D|L;L=Jp(w|A|0,b|0,B|0,C|0)|0;L=Jp(L|0,D|0,H|0,I|0)|0;C=D;N=c[P+104>>2]^L;B=c[P+104+4>>2]^C;H=Jp(B|0,N|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;M=D;K=bo((w|A)^H|0,b^M|0,24)|0;E=D;J=_n((w|A)^H|0,b^M|0,40)|0;E=D|E;C=Jp(J|K|0,E|0,L|0,C|0)|0;C=Jp(C|0,D|0,y|0,z|0)|0;L=D;c[P+16>>2]=C;c[P+16+4>>2]=L;b=bo(B^C|0,N^L|0,16)|0;I=D;L=_n(B^C|0,N^L|0,48)|0;I=D|I;c[P+104>>2]=L|b;c[P+104+4>>2]=I;M=Jp(L|b|0,I|0,H|0,M|0)|0;H=D;c[P+64>>2]=M;c[P+64+4>>2]=H;I=bo((J|K)^M|0,E^H|0,63)|0;b=D;H=_n((J|K)^M|0,E^H|0,1)|0;c[P+56>>2]=H|I;c[P+56+4>>2]=D|b;b=c[P+32>>2]|0;I=c[P+32+4>>2]|0;H=Jp(b|0,I|0,G|0,F|0)|0;H=Jp(H|0,D|0,t|0,u|0)|0;F=D;G=c[P+112>>2]^H;E=c[P+112+4>>2]^F;M=Jp(E|0,G|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;K=D;J=bo(b^M|0,I^K|0,24)|0;L=D;I=_n(b^M|0,I^K|0,40)|0;L=D|L;F=Jp(I|J|0,L|0,H|0,F|0)|0;F=Jp(F|0,D|0,p|0,q|0)|0;H=D;c[P+24>>2]=F;c[P+24+4>>2]=H;b=bo(E^F|0,G^H|0,16)|0;N=D;H=_n(E^F|0,G^H|0,48)|0;N=D|N;c[P+112>>2]=H|b;c[P+112+4>>2]=N;K=Jp(H|b|0,N|0,M|0,K|0)|0;M=D;c[P+72>>2]=K;c[P+72+4>>2]=M;N=bo((I|J)^K|0,L^M|0,63)|0;b=D;M=_n((I|J)^K|0,L^M|0,1)|0;c[P+32>>2]=M|N;c[P+32+4>>2]=D|b;b=0;while(1){ma=a+(b<<3)|0;ka=P+(b+8<<3)|0;la=f^c[ma+4>>2]^c[ka+4>>2];c[ma>>2]=e^c[ma>>2]^c[ka>>2];c[ma+4>>2]=la;b=b+1|0;if((b|0)==8)break;e=c[P+(b<<3)>>2]|0;f=c[P+(b<<3)+4>>2]|0}i=O;return}function _b(b,c,e,f){b=b|0;c=c|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0;O=d[c>>0]|0;P=_n(d[c+1>>0]|0|0,0,8)|0;jb=D;j=d[c+2>>0]|0;db=_n(j|0,0,16)|0;Ma=_n(d[c+3>>0]|0|0,0,8)|0;qb=D;A=_n(d[c+4>>0]|0|0,0,16)|0;qb=qb|D;nb=d[c+5>>0]|0;z=_n(nb|0,0,24)|0;qb=bo(Ma|j|A|z|0,qb|D|0,5)|0;z=_n(d[c+6>>0]|0|0,0,8)|0;A=D;j=d[c+7>>0]|0;Ma=_n(j|0,0,16)|0;A=bo(z|nb|Ma|0,A|D|0,2)|0;Ma=_n(d[c+8>>0]|0|0,0,8)|0;nb=D;z=_n(d[c+9>>0]|0|0,0,16)|0;nb=nb|D;ca=d[c+10>>0]|0;lb=_n(ca|0,0,24)|0;nb=bo(Ma|j|z|lb|0,nb|D|0,7)|0;lb=_n(d[c+11>>0]|0|0,0,8)|0;z=D;j=_n(d[c+12>>0]|0|0,0,16)|0;z=z|D;Ma=d[c+13>>0]|0;ra=_n(Ma|0,0,24)|0;z=bo(lb|ca|j|ra|0,z|D|0,4)|0;ra=_n(d[c+14>>0]|0|0,0,8)|0;j=D;ca=d[c+15>>0]|0;lb=_n(ca|0,0,16)|0;j=bo(ra|Ma|lb|0,j|D|0,1)|0;lb=_n(d[c+16>>0]|0|0,0,8)|0;Ma=D;ra=_n(d[c+17>>0]|0|0,0,16)|0;Ma=Ma|D;Ca=d[c+18>>0]|0;I=_n(Ca|0,0,24)|0;Ma=bo(lb|ca|ra|I|0,Ma|D|0,6)|0;I=_n(d[c+19>>0]|0|0,0,8)|0;ra=D;ca=_n(d[c+20>>0]|0|0,0,16)|0;ra=bo(I|Ca|ca|0,ra|D|0,3)|0;ca=D;Ca=d[c+21>>0]|0;I=_n(d[c+22>>0]|0|0,0,8)|0;lb=D;eb=d[c+23>>0]|0;Ja=_n(eb|0,0,16)|0;ba=_n(d[c+24>>0]|0|0,0,8)|0;La=D;sc=_n(d[c+25>>0]|0|0,0,16)|0;La=La|D;o=d[c+26>>0]|0;rb=_n(o|0,0,24)|0;La=bo(ba|eb|sc|rb|0,La|D|0,5)|0;rb=_n(d[c+27>>0]|0|0,0,8)|0;sc=D;eb=d[c+28>>0]|0;ba=_n(eb|0,0,16)|0;sc=bo(rb|o|ba|0,sc|D|0,2)|0;ba=_n(d[c+29>>0]|0|0,0,8)|0;o=D;rb=_n(d[c+30>>0]|0|0,0,16)|0;o=o|D;Da=_n(d[c+31>>0]|0|0,0,24)|0;o=bo(ba|eb|rb|Da|0,o|D|0,7)|0;Da=D;rb=d[e>>0]|0;eb=_n(d[e+1>>0]|0|0,0,8)|0;ba=D;Ta=d[e+2>>0]|0;aa=_n(Ta|0,0,16)|0;m=_n(d[e+3>>0]|0|0,0,8)|0;Ya=D;q=_n(d[e+4>>0]|0|0,0,16)|0;Ya=Ya|D;p=d[e+5>>0]|0;ea=_n(p|0,0,24)|0;Ya=bo(m|Ta|q|ea|0,Ya|D|0,5)|0;ea=_n(d[e+6>>0]|0|0,0,8)|0;q=D;Ta=d[e+7>>0]|0;m=_n(Ta|0,0,16)|0;q=bo(ea|p|m|0,q|D|0,2)|0;m=_n(d[e+8>>0]|0|0,0,8)|0;p=D;ea=_n(d[e+9>>0]|0|0,0,16)|0;p=p|D;wc=d[e+10>>0]|0;wa=_n(wc|0,0,24)|0;p=bo(m|Ta|ea|wa|0,p|D|0,7)|0;wa=_n(d[e+11>>0]|0|0,0,8)|0;ea=D;Ta=_n(d[e+12>>0]|0|0,0,16)|0;ea=ea|D;m=d[e+13>>0]|0;zc=_n(m|0,0,24)|0;ea=bo(wa|wc|Ta|zc|0,ea|D|0,4)|0;zc=_n(d[e+14>>0]|0|0,0,8)|0;Ta=D;wc=d[e+15>>0]|0;wa=_n(wc|0,0,16)|0;Ta=bo(zc|m|wa|0,Ta|D|0,1)|0;wa=_n(d[e+16>>0]|0|0,0,8)|0;m=D;zc=_n(d[e+17>>0]|0|0,0,16)|0;m=m|D;ub=d[e+18>>0]|0;uc=_n(ub|0,0,24)|0;m=bo(wa|wc|zc|uc|0,m|D|0,6)|0;uc=_n(d[e+19>>0]|0|0,0,8)|0;zc=D;wc=_n(d[e+20>>0]|0|0,0,16)|0;zc=bo(uc|ub|wc|0,zc|D|0,3)|0;wc=D;ub=d[e+21>>0]|0;uc=_n(d[e+22>>0]|0|0,0,8)|0;wa=D;pc=d[e+23>>0]|0;na=_n(pc|0,0,16)|0;W=_n(d[e+24>>0]|0|0,0,8)|0;Ia=D;K=_n(d[e+25>>0]|0|0,0,16)|0;Ia=Ia|D;x=d[e+26>>0]|0;qc=_n(x|0,0,24)|0;Ia=bo(W|pc|K|qc|0,Ia|D|0,5)|0;qc=_n(d[e+27>>0]|0|0,0,8)|0;K=D;pc=d[e+28>>0]|0;W=_n(pc|0,0,16)|0;K=bo(qc|x|W|0,K|D|0,2)|0;W=_n(d[e+29>>0]|0|0,0,8)|0;x=D;qc=_n(d[e+30>>0]|0|0,0,16)|0;x=x|D;Ba=_n(d[e+31>>0]|0|0,0,24)|0;x=bo(W|pc|qc|Ba|0,x|D|0,7)|0;Ba=D;qc=d[f>>0]|0;pc=_n(d[f+1>>0]|0|0,0,8)|0;W=D;y=d[f+2>>0]|0;rc=_n(y|0,0,16)|0;Qa=_n(d[f+3>>0]|0|0,0,8)|0;xa=D;Fa=_n(d[f+4>>0]|0|0,0,16)|0;xa=xa|D;ib=d[f+5>>0]|0;za=_n(ib|0,0,24)|0;xa=bo(Qa|y|Fa|za|0,xa|D|0,5)|0;za=_n(d[f+6>>0]|0|0,0,8)|0;Fa=D;y=d[f+7>>0]|0;Qa=_n(y|0,0,16)|0;Fa=bo(za|ib|Qa|0,Fa|D|0,2)|0;Qa=_n(d[f+8>>0]|0|0,0,8)|0;ib=D;za=_n(d[f+9>>0]|0|0,0,16)|0;ib=ib|D;h=d[f+10>>0]|0;Y=_n(h|0,0,24)|0;ib=bo(Qa|y|za|Y|0,ib|D|0,7)|0;Y=_n(d[f+11>>0]|0|0,0,8)|0;za=D;y=_n(d[f+12>>0]|0|0,0,16)|0;za=za|D;Qa=d[f+13>>0]|0;B=_n(Qa|0,0,24)|0;za=bo(Y|h|y|B|0,za|D|0,4)|0;B=_n(d[f+14>>0]|0|0,0,8)|0;y=D;h=d[f+15>>0]|0;Y=_n(h|0,0,16)|0;y=bo(B|Qa|Y|0,y|D|0,1)|0;Y=_n(d[f+16>>0]|0|0,0,8)|0;Qa=D;B=_n(d[f+17>>0]|0|0,0,16)|0;Qa=Qa|D;sa=d[f+18>>0]|0;H=_n(sa|0,0,24)|0;Qa=bo(Y|h|B|H|0,Qa|D|0,6)|0;H=_n(d[f+19>>0]|0|0,0,8)|0;B=D;h=_n(d[f+20>>0]|0|0,0,16)|0;B=bo(H|sa|h|0,B|D|0,3)|0;h=D;sa=d[f+21>>0]|0;H=_n(d[f+22>>0]|0|0,0,8)|0;Y=D;ma=d[f+23>>0]|0;Z=_n(ma|0,0,16)|0;ua=_n(d[f+24>>0]|0|0,0,8)|0;G=D;N=_n(d[f+25>>0]|0|0,0,16)|0;G=G|D;c=d[f+26>>0]|0;Aa=_n(c|0,0,24)|0;G=bo(ua|ma|N|Aa|0,G|D|0,5)|0;Aa=_n(d[f+27>>0]|0|0,0,8)|0;N=D;ma=d[f+28>>0]|0;ua=_n(ma|0,0,16)|0;N=bo(Aa|c|ua|0,N|D|0,2)|0;ua=_n(d[f+29>>0]|0|0,0,8)|0;c=D;Aa=_n(d[f+30>>0]|0|0,0,16)|0;c=c|D;i=_n(d[f+31>>0]|0|0,0,24)|0;c=bo(ua|ma|Aa|i|0,c|D|0,7)|0;i=D;Aa=_m(eb|rb|aa&2031616|0,ba|0,P|O|db&2031616|0,jb|0)|0;Aa=Jp(pc|qc|rc&2031616|0,W|0,Aa|0,D|0)|0;W=D;rc=_m(Ya&2097151|0,0,P|O|db&2031616|0,jb|0)|0;qc=D;pc=_m(eb|rb|aa&2031616|0,ba|0,qb&2097151|0,0)|0;ma=D;ua=_m(q&2097151|0,0,P|O|db&2031616|0,jb|0)|0;Ea=D;va=_m(Ya&2097151|0,0,qb&2097151|0,0)|0;kc=D;ia=_m(eb|rb|aa&2031616|0,ba|0,A&2097151|0,0)|0;ia=Jp(va|0,kc|0,ia|0,D|0)|0;Ea=Jp(ia|0,D|0,ua|0,Ea|0)|0;Fa=Jp(Ea|0,D|0,Fa&2097151|0,0)|0;Ea=D;ua=_m(p&2097151|0,0,P|O|db&2031616|0,jb|0)|0;ia=D;kc=_m(q&2097151|0,0,qb&2097151|0,0)|0;va=D;oc=_m(Ya&2097151|0,0,A&2097151|0,0)|0;nc=D;mc=_m(eb|rb|aa&2031616|0,ba|0,nb&2097151|0,0)|0;lc=D;Ha=_m(ea&2097151|0,0,P|O|db&2031616|0,jb|0)|0;ya=D;bc=_m(p&2097151|0,0,qb&2097151|0,0)|0;u=D;dc=_m(q&2097151|0,0,A&2097151|0,0)|0;Ga=D;ec=_m(Ya&2097151|0,0,nb&2097151|0,0)|0;fc=D;cc=_m(eb|rb|aa&2031616|0,ba|0,z&2097151|0,0)|0;cc=Jp(ec|0,fc|0,cc|0,D|0)|0;Ga=Jp(cc|0,D|0,dc|0,Ga|0)|0;u=Jp(Ga|0,D|0,bc|0,u|0)|0;ya=Jp(u|0,D|0,Ha|0,ya|0)|0;za=Jp(ya|0,D|0,za&2097151|0,0)|0;ya=D;Ha=_m(Ta&2097151|0,0,P|O|db&2031616|0,jb|0)|0;u=D;bc=_m(ea&2097151|0,0,qb&2097151|0,0)|0;Ga=D;dc=_m(p&2097151|0,0,A&2097151|0,0)|0;cc=D;fc=_m(q&2097151|0,0,nb&2097151|0,0)|0;ec=D;jc=_m(Ya&2097151|0,0,z&2097151|0,0)|0;ic=D;hc=_m(eb|rb|aa&2031616|0,ba|0,j&2097151|0,0)|0;gc=D;X=_m(m&2097151|0,0,P|O|db&2031616|0,jb|0)|0;Ra=D;Qb=_m(Ta&2097151|0,0,qb&2097151|0,0)|0;da=D;Sb=_m(ea&2097151|0,0,A&2097151|0,0)|0;Pb=D;Ub=_m(p&2097151|0,0,nb&2097151|0,0)|0;Rb=D;Wb=_m(q&2097151|0,0,z&2097151|0,0)|0;Tb=D;Xb=_m(Ya&2097151|0,0,j&2097151|0,0)|0;Yb=D;Vb=_m(eb|rb|aa&2031616|0,ba|0,Ma&2097151|0,0)|0;Vb=Jp(Xb|0,Yb|0,Vb|0,D|0)|0;Tb=Jp(Vb|0,D|0,Wb|0,Tb|0)|0;Rb=Jp(Tb|0,D|0,Ub|0,Rb|0)|0;Pb=Jp(Rb|0,D|0,Sb|0,Pb|0)|0;da=Jp(Pb|0,D|0,Qb|0,da|0)|0;Ra=Jp(da|0,D|0,X|0,Ra|0)|0;Qa=Jp(Ra|0,D|0,Qa&2097151|0,0)|0;Ra=D;X=_m(zc|0,wc|0,P|O|db&2031616|0,jb|0)|0;da=D;Qb=_m(m&2097151|0,0,qb&2097151|0,0)|0;Pb=D;Sb=_m(Ta&2097151|0,0,A&2097151|0,0)|0;Rb=D;Ub=_m(ea&2097151|0,0,nb&2097151|0,0)|0;Tb=D;Wb=_m(p&2097151|0,0,z&2097151|0,0)|0;Vb=D;Yb=_m(q&2097151|0,0,j&2097151|0,0)|0;Xb=D;ac=_m(Ya&2097151|0,0,Ma&2097151|0,0)|0;$b=D;_b=_m(eb|rb|aa&2031616|0,ba|0,ra|0,ca|0)|0;Zb=D;ta=_m(uc|ub|na&2031616|0,wa|0,P|O|db&2031616|0,jb|0)|0;yb=D;zb=_m(zc|0,wc|0,qb&2097151|0,0)|0;Ab=D;Bb=_m(m&2097151|0,0,A&2097151|0,0)|0;Cb=D;Db=_m(Ta&2097151|0,0,nb&2097151|0,0)|0;Eb=D;Fb=_m(ea&2097151|0,0,z&2097151|0,0)|0;Gb=D;Hb=_m(p&2097151|0,0,j&2097151|0,0)|0;Ib=D;Jb=_m(q&2097151|0,0,Ma&2097151|0,0)|0;Kb=D;Mb=_m(Ya&2097151|0,0,ra|0,ca|0)|0;Nb=D;Ob=_m(eb|rb|aa&2031616|0,ba|0,I|Ca|Ja&2031616|0,lb|0)|0;Ob=Jp(Mb|0,Nb|0,Ob|0,D|0)|0;Kb=Jp(Ob|0,D|0,Jb|0,Kb|0)|0;Ib=Jp(Kb|0,D|0,Hb|0,Ib|0)|0;Gb=Jp(Ib|0,D|0,Fb|0,Gb|0)|0;Eb=Jp(Gb|0,D|0,Db|0,Eb|0)|0;Cb=Jp(Eb|0,D|0,Bb|0,Cb|0)|0;Ab=Jp(Cb|0,D|0,zb|0,Ab|0)|0;yb=Jp(Ab|0,D|0,ta|0,yb|0)|0;Y=Jp(yb|0,D|0,H|sa|Z&2031616|0,Y|0)|0;Z=D;sa=_m(Ia&2097151|0,0,P|O|db&2031616|0,jb|0)|0;H=D;yb=_m(uc|ub|na&2031616|0,wa|0,qb&2097151|0,0)|0;ta=D;Ab=_m(zc|0,wc|0,A&2097151|0,0)|0;zb=D;Cb=_m(m&2097151|0,0,nb&2097151|0,0)|0;Bb=D;Eb=_m(Ta&2097151|0,0,z&2097151|0,0)|0;Db=D;Gb=_m(ea&2097151|0,0,j&2097151|0,0)|0;Fb=D;Ib=_m(p&2097151|0,0,Ma&2097151|0,0)|0;Hb=D;Kb=_m(q&2097151|0,0,ra|0,ca|0)|0;Jb=D;Ob=_m(Ya&2097151|0,0,I|Ca|Ja&2031616|0,lb|0)|0;Nb=D;Mb=_m(eb|rb|aa&2031616|0,ba|0,La&2097151|0,0)|0;Lb=D;ab=_m(K&2097151|0,0,P|O|db&2031616|0,jb|0)|0;M=D;Q=_m(Ia&2097151|0,0,qb&2097151|0,0)|0;bb=D;ob=_m(uc|ub|na&2031616|0,wa|0,A&2097151|0,0)|0;R=D;J=_m(zc|0,wc|0,nb&2097151|0,0)|0;pb=D;Oa=_m(m&2097151|0,0,z&2097151|0,0)|0;C=D;gb=_m(Ta&2097151|0,0,j&2097151|0,0)|0;Pa=D;U=_m(ea&2097151|0,0,Ma&2097151|0,0)|0;hb=D;Wa=_m(p&2097151|0,0,ra|0,ca|0)|0;V=D;xb=_m(q&2097151|0,0,I|Ca|Ja&2031616|0,lb|0)|0;Xa=D;fa=_m(Ya&2097151|0,0,La&2097151|0,0)|0;w=D;wb=_m(eb|rb|aa&2031616|0,ba|0,sc&2097151|0,0)|0;wb=Jp(fa|0,w|0,wb|0,D|0)|0;Xa=Jp(wb|0,D|0,xb|0,Xa|0)|0;V=Jp(Xa|0,D|0,Wa|0,V|0)|0;hb=Jp(V|0,D|0,U|0,hb|0)|0;Pa=Jp(hb|0,D|0,gb|0,Pa|0)|0;C=Jp(Pa|0,D|0,Oa|0,C|0)|0;pb=Jp(C|0,D|0,J|0,pb|0)|0;R=Jp(pb|0,D|0,ob|0,R|0)|0;bb=Jp(R|0,D|0,Q|0,bb|0)|0;M=Jp(bb|0,D|0,ab|0,M|0)|0;N=Jp(M|0,D|0,N&2097151|0,0)|0;M=D;jb=_m(x|0,Ba|0,P|O|db&2031616|0,jb|0)|0;db=D;O=_m(K&2097151|0,0,qb&2097151|0,0)|0;P=D;ab=_m(Ia&2097151|0,0,A&2097151|0,0)|0;bb=D;Q=_m(uc|ub|na&2031616|0,wa|0,nb&2097151|0,0)|0;R=D;ob=_m(zc|0,wc|0,z&2097151|0,0)|0;pb=D;J=_m(m&2097151|0,0,j&2097151|0,0)|0;C=D;Oa=_m(Ta&2097151|0,0,Ma&2097151|0,0)|0;Pa=D;gb=_m(ea&2097151|0,0,ra|0,ca|0)|0;hb=D;U=_m(p&2097151|0,0,I|Ca|Ja&2031616|0,lb|0)|0;V=D;Wa=_m(q&2097151|0,0,La&2097151|0,0)|0;Xa=D;xb=_m(Ya&2097151|0,0,sc&2097151|0,0)|0;wb=D;ba=_m(eb|rb|aa&2031616|0,ba|0,o|0,Da|0)|0;aa=D;qb=_m(x|0,Ba|0,qb&2097151|0,0)|0;rb=D;eb=_m(K&2097151|0,0,A&2097151|0,0)|0;w=D;fa=_m(Ia&2097151|0,0,nb&2097151|0,0)|0;fb=D;ha=_m(uc|ub|na&2031616|0,wa|0,z&2097151|0,0)|0;$=D;sb=_m(zc|0,wc|0,j&2097151|0,0)|0;kb=D;la=_m(m&2097151|0,0,Ma&2097151|0,0)|0;tb=D;qa=_m(Ta&2097151|0,0,ra|0,ca|0)|0;ka=D;Na=_m(ea&2097151|0,0,I|Ca|Ja&2031616|0,lb|0)|0;pa=D;Za=_m(p&2097151|0,0,La&2097151|0,0)|0;ga=D;mb=_m(q&2097151|0,0,sc&2097151|0,0)|0;v=D;Ya=_m(Ya&2097151|0,0,o|0,Da|0)|0;Ya=Jp(mb|0,v|0,Ya|0,D|0)|0;ga=Jp(Ya|0,D|0,Za|0,ga|0)|0;pa=Jp(ga|0,D|0,Na|0,pa|0)|0;ka=Jp(pa|0,D|0,qa|0,ka|0)|0;tb=Jp(ka|0,D|0,la|0,tb|0)|0;kb=Jp(tb|0,D|0,sb|0,kb|0)|0;$=Jp(kb|0,D|0,ha|0,$|0)|0;fb=Jp($|0,D|0,fa|0,fb|0)|0;w=Jp(fb|0,D|0,eb|0,w|0)|0;rb=Jp(w|0,D|0,qb|0,rb|0)|0;qb=D;A=_m(x|0,Ba|0,A&2097151|0,0)|0;w=D;eb=_m(K&2097151|0,0,nb&2097151|0,0)|0;fb=D;fa=_m(Ia&2097151|0,0,z&2097151|0,0)|0;$=D;ha=_m(uc|ub|na&2031616|0,wa|0,j&2097151|0,0)|0;kb=D;sb=_m(zc|0,wc|0,Ma&2097151|0,0)|0;tb=D;la=_m(m&2097151|0,0,ra|0,ca|0)|0;ka=D;qa=_m(Ta&2097151|0,0,I|Ca|Ja&2031616|0,lb|0)|0;pa=D;Na=_m(ea&2097151|0,0,La&2097151|0,0)|0;ga=D;Za=_m(p&2097151|0,0,sc&2097151|0,0)|0;Ya=D;q=_m(q&2097151|0,0,o|0,Da|0)|0;v=D;nb=_m(x|0,Ba|0,nb&2097151|0,0)|0;mb=D;_a=_m(K&2097151|0,0,z&2097151|0,0)|0;r=D;E=_m(Ia&2097151|0,0,j&2097151|0,0)|0;$a=D;n=_m(uc|ub|na&2031616|0,wa|0,Ma&2097151|0,0)|0;t=D;_=_m(zc|0,wc|0,ra|0,ca|0)|0;g=D;ja=_m(m&2097151|0,0,I|Ca|Ja&2031616|0,lb|0)|0;s=D;oa=_m(Ta&2097151|0,0,La&2097151|0,0)|0;F=D;vb=_m(ea&2097151|0,0,sc&2097151|0,0)|0;l=D;p=_m(p&2097151|0,0,o|0,Da|0)|0;p=Jp(vb|0,l|0,p|0,D|0)|0;F=Jp(p|0,D|0,oa|0,F|0)|0;s=Jp(F|0,D|0,ja|0,s|0)|0;g=Jp(s|0,D|0,_|0,g|0)|0;t=Jp(g|0,D|0,n|0,t|0)|0;$a=Jp(t|0,D|0,E|0,$a|0)|0;r=Jp($a|0,D|0,_a|0,r|0)|0;mb=Jp(r|0,D|0,nb|0,mb|0)|0;nb=D;z=_m(x|0,Ba|0,z&2097151|0,0)|0;r=D;_a=_m(K&2097151|0,0,j&2097151|0,0)|0;$a=D;E=_m(Ia&2097151|0,0,Ma&2097151|0,0)|0;t=D;n=_m(uc|ub|na&2031616|0,wa|0,ra|0,ca|0)|0;g=D;_=_m(zc|0,wc|0,I|Ca|Ja&2031616|0,lb|0)|0;s=D;ja=_m(m&2097151|0,0,La&2097151|0,0)|0;F=D;oa=_m(Ta&2097151|0,0,sc&2097151|0,0)|0;p=D;ea=_m(ea&2097151|0,0,o|0,Da|0)|0;l=D;j=_m(x|0,Ba|0,j&2097151|0,0)|0;vb=D;e=_m(K&2097151|0,0,Ma&2097151|0,0)|0;L=D;T=_m(Ia&2097151|0,0,ra|0,ca|0)|0;Ka=D;Va=_m(uc|ub|na&2031616|0,wa|0,I|Ca|Ja&2031616|0,lb|0)|0;S=D;Sa=_m(zc|0,wc|0,La&2097151|0,0)|0;Ua=D;f=_m(m&2097151|0,0,sc&2097151|0,0)|0;k=D;Ta=_m(Ta&2097151|0,0,o|0,Da|0)|0;Ta=Jp(f|0,k|0,Ta|0,D|0)|0;Ua=Jp(Ta|0,D|0,Sa|0,Ua|0)|0;S=Jp(Ua|0,D|0,Va|0,S|0)|0;Ka=Jp(S|0,D|0,T|0,Ka|0)|0;L=Jp(Ka|0,D|0,e|0,L|0)|0;vb=Jp(L|0,D|0,j|0,vb|0)|0;j=D;Ma=_m(x|0,Ba|0,Ma&2097151|0,0)|0;L=D;e=_m(K&2097151|0,0,ra|0,ca|0)|0;Ka=D;T=_m(Ia&2097151|0,0,I|Ca|Ja&2031616|0,lb|0)|0;S=D;Va=_m(uc|ub|na&2031616|0,wa|0,La&2097151|0,0)|0;Ua=D;Sa=_m(zc|0,wc|0,sc&2097151|0,0)|0;Ta=D;m=_m(m&2097151|0,0,o|0,Da|0)|0;k=D;ca=_m(x|0,Ba|0,ra|0,ca|0)|0;f=D;ra=_m(K&2097151|0,0,I|Ca|Ja&2031616|0,lb|0)|0;cb=D;vc=_m(Ia&2097151|0,0,La&2097151|0,0)|0;tc=D;yc=_m(uc|ub|na&2031616|0,wa|0,sc&2097151|0,0)|0;xc=D;wc=_m(zc|0,wc|0,o|0,Da|0)|0;wc=Jp(yc|0,xc|0,wc|0,D|0)|0;tc=Jp(wc|0,D|0,vc|0,tc|0)|0;cb=Jp(tc|0,D|0,ra|0,cb|0)|0;f=Jp(cb|0,D|0,ca|0,f|0)|0;ca=D;lb=_m(x|0,Ba|0,I|Ca|Ja&2031616|0,lb|0)|0;Ja=D;Ca=_m(K&2097151|0,0,La&2097151|0,0)|0;I=D;cb=_m(Ia&2097151|0,0,sc&2097151|0,0)|0;ra=D;wa=_m(uc|ub|na&2031616|0,wa|0,o|0,Da|0)|0;na=D;La=_m(x|0,Ba|0,La&2097151|0,0)|0;ub=D;uc=_m(K&2097151|0,0,sc&2097151|0,0)|0;tc=D;Ia=_m(Ia&2097151|0,0,o|0,Da|0)|0;Ia=Jp(uc|0,tc|0,Ia|0,D|0)|0;ub=Jp(Ia|0,D|0,La|0,ub|0)|0;La=D;sc=_m(x|0,Ba|0,sc&2097151|0,0)|0;Ia=D;K=_m(K&2097151|0,0,o|0,Da|0)|0;K=Jp(sc|0,Ia|0,K|0,D|0)|0;Ia=D;Da=_m(x|0,Ba|0,o|0,Da|0)|0;o=D;Ba=Jp(Aa|0,W|0,1048576,0)|0;Ba=bo(Ba|0,D|0,21)|0;x=D;ma=Jp(rc|0,qc|0,pc|0,ma|0)|0;ma=Jp(ma|0,D|0,Ba|0,x|0)|0;xa=Jp(ma|0,D|0,xa&2097151|0,0)|0;ma=D;x=_n(Ba|0,x|0,21)|0;x=mo(Aa|0,W|0,x|0,D|0)|0;W=D;Aa=Jp(Fa|0,Ea|0,1048576,0)|0;Aa=bo(Aa|0,D|0,21)|0;Ba=D;lc=Jp(oc|0,nc|0,mc|0,lc|0)|0;va=Jp(lc|0,D|0,kc|0,va|0)|0;ia=Jp(va|0,D|0,ua|0,ia|0)|0;ib=Jp(ia|0,D|0,ib&2097151|0,0)|0;ib=Jp(ib|0,D|0,Aa|0,Ba|0)|0;ia=D;Ba=_n(Aa|0,Ba|0,21)|0;Aa=D;ua=Jp(za|0,ya|0,1048576,0)|0;ua=ln(ua|0,D|0,21)|0;va=D;gc=Jp(jc|0,ic|0,hc|0,gc|0)|0;ec=Jp(gc|0,D|0,fc|0,ec|0)|0;cc=Jp(ec|0,D|0,dc|0,cc|0)|0;Ga=Jp(cc|0,D|0,bc|0,Ga|0)|0;u=Jp(Ga|0,D|0,Ha|0,u|0)|0;y=Jp(u|0,D|0,y&2097151|0,0)|0;y=Jp(y|0,D|0,ua|0,va|0)|0;u=D;va=_n(ua|0,va|0,21)|0;ua=D;Ha=Jp(Qa|0,Ra|0,1048576,0)|0;Ha=ln(Ha|0,D|0,21)|0;Ga=D;Zb=Jp(ac|0,$b|0,_b|0,Zb|0)|0;Xb=Jp(Zb|0,D|0,Yb|0,Xb|0)|0;Vb=Jp(Xb|0,D|0,Wb|0,Vb|0)|0;Tb=Jp(Vb|0,D|0,Ub|0,Tb|0)|0;Rb=Jp(Tb|0,D|0,Sb|0,Rb|0)|0;Pb=Jp(Rb|0,D|0,Qb|0,Pb|0)|0;da=Jp(Pb|0,D|0,X|0,da|0)|0;h=Jp(da|0,D|0,B|0,h|0)|0;h=Jp(h|0,D|0,Ha|0,Ga|0)|0;B=D;Ga=_n(Ha|0,Ga|0,21)|0;Ha=D;da=Jp(Y|0,Z|0,1048576,0)|0;da=ln(da|0,D|0,21)|0;X=D;Lb=Jp(Ob|0,Nb|0,Mb|0,Lb|0)|0;Jb=Jp(Lb|0,D|0,Kb|0,Jb|0)|0;Hb=Jp(Jb|0,D|0,Ib|0,Hb|0)|0;Fb=Jp(Hb|0,D|0,Gb|0,Fb|0)|0;Db=Jp(Fb|0,D|0,Eb|0,Db|0)|0;Bb=Jp(Db|0,D|0,Cb|0,Bb|0)|0;zb=Jp(Bb|0,D|0,Ab|0,zb|0)|0;ta=Jp(zb|0,D|0,yb|0,ta|0)|0;H=Jp(ta|0,D|0,sa|0,H|0)|0;G=Jp(H|0,D|0,G&2097151|0,0)|0;G=Jp(G|0,D|0,da|0,X|0)|0;H=D;X=_n(da|0,X|0,21)|0;da=D;sa=Jp(N|0,M|0,1048576,0)|0;sa=ln(sa|0,D|0,21)|0;ta=D;aa=Jp(xb|0,wb|0,ba|0,aa|0)|0;Xa=Jp(aa|0,D|0,Wa|0,Xa|0)|0;V=Jp(Xa|0,D|0,U|0,V|0)|0;hb=Jp(V|0,D|0,gb|0,hb|0)|0;Pa=Jp(hb|0,D|0,Oa|0,Pa|0)|0;C=Jp(Pa|0,D|0,J|0,C|0)|0;pb=Jp(C|0,D|0,ob|0,pb|0)|0;R=Jp(pb|0,D|0,Q|0,R|0)|0;bb=Jp(R|0,D|0,ab|0,bb|0)|0;P=Jp(bb|0,D|0,O|0,P|0)|0;db=Jp(P|0,D|0,jb|0,db|0)|0;i=Jp(db|0,D|0,c|0,i|0)|0;i=Jp(i|0,D|0,sa|0,ta|0)|0;c=D;ta=_n(sa|0,ta|0,21)|0;sa=D;db=Jp(rb|0,qb|0,1048576,0)|0;db=ln(db|0,D|0,21)|0;jb=D;v=Jp(Za|0,Ya|0,q|0,v|0)|0;ga=Jp(v|0,D|0,Na|0,ga|0)|0;pa=Jp(ga|0,D|0,qa|0,pa|0)|0;ka=Jp(pa|0,D|0,la|0,ka|0)|0;tb=Jp(ka|0,D|0,sb|0,tb|0)|0;kb=Jp(tb|0,D|0,ha|0,kb|0)|0;$=Jp(kb|0,D|0,fa|0,$|0)|0;fb=Jp($|0,D|0,eb|0,fb|0)|0;w=Jp(fb|0,D|0,A|0,w|0)|0;w=Jp(w|0,D|0,db|0,jb|0)|0;A=D;jb=_n(db|0,jb|0,21)|0;db=D;fb=Jp(mb|0,nb|0,1048576,0)|0;fb=ln(fb|0,D|0,21)|0;eb=D;l=Jp(oa|0,p|0,ea|0,l|0)|0;F=Jp(l|0,D|0,ja|0,F|0)|0;s=Jp(F|0,D|0,_|0,s|0)|0;g=Jp(s|0,D|0,n|0,g|0)|0;t=Jp(g|0,D|0,E|0,t|0)|0;$a=Jp(t|0,D|0,_a|0,$a|0)|0;r=Jp($a|0,D|0,z|0,r|0)|0;r=Jp(r|0,D|0,fb|0,eb|0)|0;z=D;eb=_n(fb|0,eb|0,21)|0;fb=D;$a=Jp(vb|0,j|0,1048576,0)|0;$a=ln($a|0,D|0,21)|0;_a=D;k=Jp(Sa|0,Ta|0,m|0,k|0)|0;Ua=Jp(k|0,D|0,Va|0,Ua|0)|0;S=Jp(Ua|0,D|0,T|0,S|0)|0;Ka=Jp(S|0,D|0,e|0,Ka|0)|0;L=Jp(Ka|0,D|0,Ma|0,L|0)|0;L=Jp(L|0,D|0,$a|0,_a|0)|0;Ma=D;_a=_n($a|0,_a|0,21)|0;$a=D;Ka=Jp(f|0,ca|0,1048576,0)|0;Ka=ln(Ka|0,D|0,21)|0;e=D;na=Jp(cb|0,ra|0,wa|0,na|0)|0;I=Jp(na|0,D|0,Ca|0,I|0)|0;Ja=Jp(I|0,D|0,lb|0,Ja|0)|0;Ja=Jp(Ja|0,D|0,Ka|0,e|0)|0;lb=D;e=_n(Ka|0,e|0,21)|0;e=mo(f|0,ca|0,e|0,D|0)|0;ca=D;f=Jp(ub|0,La|0,1048576,0)|0;f=ln(f|0,D|0,21)|0;Ka=D;Ia=Jp(K|0,Ia|0,f|0,Ka|0)|0;K=D;Ka=_n(f|0,Ka|0,21)|0;Ka=mo(ub|0,La|0,Ka|0,D|0)|0;La=D;ub=Jp(Da|0,o|0,1048576,0)|0;ub=ln(ub|0,D|0,21)|0;f=D;I=_n(ub|0,f|0,21)|0;I=mo(Da|0,o|0,I|0,D|0)|0;o=D;Da=Jp(xa|0,ma|0,1048576,0)|0;Da=bo(Da|0,D|0,21)|0;Ca=D;na=_n(Da|0,Ca|0,21)|0;na=mo(xa|0,ma|0,na|0,D|0)|0;ma=D;xa=Jp(ib|0,ia|0,1048576,0)|0;xa=ln(xa|0,D|0,21)|0;wa=D;ra=_n(xa|0,wa|0,21)|0;ra=mo(ib|0,ia|0,ra|0,D|0)|0;ia=D;ib=Jp(y|0,u|0,1048576,0)|0;ib=ln(ib|0,D|0,21)|0;cb=D;S=_n(ib|0,cb|0,21)|0;T=D;Ua=Jp(h|0,B|0,1048576,0)|0;Ua=ln(Ua|0,D|0,21)|0;Va=D;k=_n(Ua|0,Va|0,21)|0;m=D;Ta=Jp(G|0,H|0,1048576,0)|0;Ta=ln(Ta|0,D|0,21)|0;Sa=D;t=_n(Ta|0,Sa|0,21)|0;E=D;g=Jp(i|0,c|0,1048576,0)|0;g=ln(g|0,D|0,21)|0;n=D;s=_n(g|0,n|0,21)|0;_=D;F=Jp(w|0,A|0,1048576,0)|0;F=ln(F|0,D|0,21)|0;ja=D;l=_n(F|0,ja|0,21)|0;ea=D;p=Jp(r|0,z|0,1048576,0)|0;p=ln(p|0,D|0,21)|0;oa=D;$=_n(p|0,oa|0,21)|0;fa=D;kb=Jp(L|0,Ma|0,1048576,0)|0;kb=ln(kb|0,D|0,21)|0;ha=D;ca=Jp(kb|0,ha|0,e|0,ca|0)|0;e=D;ha=_n(kb|0,ha|0,21)|0;ha=mo(L|0,Ma|0,ha|0,D|0)|0;Ma=D;L=Jp(Ja|0,lb|0,1048576,0)|0;L=ln(L|0,D|0,21)|0;kb=D;La=Jp(L|0,kb|0,Ka|0,La|0)|0;Ka=D;kb=_n(L|0,kb|0,21)|0;kb=mo(Ja|0,lb|0,kb|0,D|0)|0;lb=D;Ja=Jp(Ia|0,K|0,1048576,0)|0;Ja=ln(Ja|0,D|0,21)|0;L=D;o=Jp(Ja|0,L|0,I|0,o|0)|0;I=D;L=_n(Ja|0,L|0,21)|0;L=mo(Ia|0,K|0,L|0,D|0)|0;K=D;Ia=_m(ub|0,f|0,666643,0)|0;Ja=D;tb=_m(ub|0,f|0,470296,0)|0;sb=D;ka=_m(ub|0,f|0,654183,0)|0;la=D;pa=_m(ub|0,f|0,-997805,-1)|0;qa=D;ga=_m(ub|0,f|0,136657,0)|0;Na=D;f=_m(ub|0,f|0,-683901,-1)|0;f=Jp(vb|0,j|0,f|0,D|0)|0;$a=mo(f|0,D|0,_a|0,$a|0)|0;oa=Jp($a|0,D|0,p|0,oa|0)|0;p=D;$a=_m(o|0,I|0,666643,0)|0;_a=D;f=_m(o|0,I|0,470296,0)|0;j=D;vb=_m(o|0,I|0,654183,0)|0;ub=D;v=_m(o|0,I|0,-997805,-1)|0;q=D;Ya=_m(o|0,I|0,136657,0)|0;Za=D;I=_m(o|0,I|0,-683901,-1)|0;o=D;P=_m(L|0,K|0,666643,0)|0;O=D;bb=_m(L|0,K|0,470296,0)|0;ab=D;R=_m(L|0,K|0,654183,0)|0;Q=D;pb=_m(L|0,K|0,-997805,-1)|0;ob=D;C=_m(L|0,K|0,136657,0)|0;J=D;K=_m(L|0,K|0,-683901,-1)|0;L=D;qa=Jp(mb|0,nb|0,pa|0,qa|0)|0;Za=Jp(qa|0,D|0,Ya|0,Za|0)|0;L=Jp(Za|0,D|0,K|0,L|0)|0;fb=mo(L|0,D|0,eb|0,fb|0)|0;ja=Jp(fb|0,D|0,F|0,ja|0)|0;F=D;fb=_m(La|0,Ka|0,666643,0)|0;eb=D;L=_m(La|0,Ka|0,470296,0)|0;K=D;Za=_m(La|0,Ka|0,654183,0)|0;Ya=D;qa=_m(La|0,Ka|0,-997805,-1)|0;pa=D;nb=_m(La|0,Ka|0,136657,0)|0;mb=D;Ka=_m(La|0,Ka|0,-683901,-1)|0;La=D;Pa=_m(kb|0,lb|0,666643,0)|0;Oa=D;hb=_m(kb|0,lb|0,470296,0)|0;gb=D;V=_m(kb|0,lb|0,654183,0)|0;U=D;Xa=_m(kb|0,lb|0,-997805,-1)|0;Wa=D;aa=_m(kb|0,lb|0,136657,0)|0;ba=D;lb=_m(kb|0,lb|0,-683901,-1)|0;kb=D;sb=Jp(vb|0,ub|0,tb|0,sb|0)|0;qb=Jp(sb|0,D|0,rb|0,qb|0)|0;ob=Jp(qb|0,D|0,pb|0,ob|0)|0;mb=Jp(ob|0,D|0,nb|0,mb|0)|0;kb=Jp(mb|0,D|0,lb|0,kb|0)|0;db=mo(kb|0,D|0,jb|0,db|0)|0;n=Jp(db|0,D|0,g|0,n|0)|0;g=D;db=_m(ca|0,e|0,666643,0)|0;db=Jp(ib|0,cb|0,db|0,D|0)|0;Ra=Jp(db|0,D|0,Qa|0,Ra|0)|0;Ha=mo(Ra|0,D|0,Ga|0,Ha|0)|0;Ga=D;Ra=_m(ca|0,e|0,470296,0)|0;Qa=D;db=_m(ca|0,e|0,654183,0)|0;cb=D;eb=Jp(hb|0,gb|0,fb|0,eb|0)|0;cb=Jp(eb|0,D|0,db|0,cb|0)|0;Va=Jp(cb|0,D|0,Ua|0,Va|0)|0;Z=Jp(Va|0,D|0,Y|0,Z|0)|0;da=mo(Z|0,D|0,X|0,da|0)|0;X=D;Z=_m(ca|0,e|0,-997805,-1)|0;Y=D;Va=_m(ca|0,e|0,136657,0)|0;Ua=D;_a=Jp(bb|0,ab|0,$a|0,_a|0)|0;Ya=Jp(_a|0,D|0,Za|0,Ya|0)|0;Wa=Jp(Ya|0,D|0,Xa|0,Wa|0)|0;Ua=Jp(Wa|0,D|0,Va|0,Ua|0)|0;Sa=Jp(Ua|0,D|0,Ta|0,Sa|0)|0;M=Jp(Sa|0,D|0,N|0,M|0)|0;sa=mo(M|0,D|0,ta|0,sa|0)|0;ta=D;e=_m(ca|0,e|0,-683901,-1)|0;ca=D;M=Jp(Ha|0,Ga|0,1048576,0)|0;M=ln(M|0,D|0,21)|0;N=D;Oa=Jp(Ra|0,Qa|0,Pa|0,Oa|0)|0;B=Jp(Oa|0,D|0,h|0,B|0)|0;m=mo(B|0,D|0,k|0,m|0)|0;m=Jp(m|0,D|0,M|0,N|0)|0;k=D;N=_n(M|0,N|0,21)|0;M=D;B=Jp(da|0,X|0,1048576,0)|0;B=ln(B|0,D|0,21)|0;h=D;O=Jp(L|0,K|0,P|0,O|0)|0;U=Jp(O|0,D|0,V|0,U|0)|0;Y=Jp(U|0,D|0,Z|0,Y|0)|0;H=Jp(Y|0,D|0,G|0,H|0)|0;E=mo(H|0,D|0,t|0,E|0)|0;E=Jp(E|0,D|0,B|0,h|0)|0;t=D;h=_n(B|0,h|0,21)|0;B=D;H=Jp(sa|0,ta|0,1048576,0)|0;H=ln(H|0,D|0,21)|0;G=D;Ja=Jp(f|0,j|0,Ia|0,Ja|0)|0;Q=Jp(Ja|0,D|0,R|0,Q|0)|0;pa=Jp(Q|0,D|0,qa|0,pa|0)|0;ba=Jp(pa|0,D|0,aa|0,ba|0)|0;ca=Jp(ba|0,D|0,e|0,ca|0)|0;c=Jp(ca|0,D|0,i|0,c|0)|0;_=mo(c|0,D|0,s|0,_|0)|0;_=Jp(_|0,D|0,H|0,G|0)|0;s=D;G=_n(H|0,G|0,21)|0;H=D;c=Jp(n|0,g|0,1048576,0)|0;c=ln(c|0,D|0,21)|0;i=D;la=Jp(v|0,q|0,ka|0,la|0)|0;J=Jp(la|0,D|0,C|0,J|0)|0;La=Jp(J|0,D|0,Ka|0,La|0)|0;A=Jp(La|0,D|0,w|0,A|0)|0;ea=mo(A|0,D|0,l|0,ea|0)|0;ea=Jp(ea|0,D|0,c|0,i|0)|0;l=D;i=_n(c|0,i|0,21)|0;i=mo(n|0,g|0,i|0,D|0)|0;g=D;n=Jp(ja|0,F|0,1048576,0)|0;n=ln(n|0,D|0,21)|0;c=D;Na=Jp(I|0,o|0,ga|0,Na|0)|0;z=Jp(Na|0,D|0,r|0,z|0)|0;fa=mo(z|0,D|0,$|0,fa|0)|0;fa=Jp(fa|0,D|0,n|0,c|0)|0;$=D;c=_n(n|0,c|0,21)|0;c=mo(ja|0,F|0,c|0,D|0)|0;F=D;ja=Jp(oa|0,p|0,1048576,0)|0;ja=ln(ja|0,D|0,21)|0;n=D;Ma=Jp(ja|0,n|0,ha|0,Ma|0)|0;ha=D;n=_n(ja|0,n|0,21)|0;n=mo(oa|0,p|0,n|0,D|0)|0;p=D;oa=Jp(m|0,k|0,1048576,0)|0;oa=ln(oa|0,D|0,21)|0;ja=D;z=_n(oa|0,ja|0,21)|0;r=D;Na=Jp(E|0,t|0,1048576,0)|0;Na=ln(Na|0,D|0,21)|0;ga=D;o=_n(Na|0,ga|0,21)|0;I=D;A=Jp(_|0,s|0,1048576,0)|0;A=ln(A|0,D|0,21)|0;w=D;g=Jp(A|0,w|0,i|0,g|0)|0;i=D;w=_n(A|0,w|0,21)|0;w=mo(_|0,s|0,w|0,D|0)|0;s=D;_=Jp(ea|0,l|0,1048576,0)|0;_=ln(_|0,D|0,21)|0;A=D;F=Jp(_|0,A|0,c|0,F|0)|0;c=D;A=_n(_|0,A|0,21)|0;A=mo(ea|0,l|0,A|0,D|0)|0;l=D;ea=Jp(fa|0,$|0,1048576,0)|0;ea=ln(ea|0,D|0,21)|0;_=D;p=Jp(ea|0,_|0,n|0,p|0)|0;n=D;_=_n(ea|0,_|0,21)|0;_=mo(fa|0,$|0,_|0,D|0)|0;$=D;fa=_m(Ma|0,ha|0,666643,0)|0;ea=D;La=_m(Ma|0,ha|0,470296,0)|0;Ka=D;J=_m(Ma|0,ha|0,654183,0)|0;C=D;la=_m(Ma|0,ha|0,-997805,-1)|0;ka=D;q=_m(Ma|0,ha|0,136657,0)|0;v=D;ha=_m(Ma|0,ha|0,-683901,-1)|0;ha=Jp(Na|0,ga|0,ha|0,D|0)|0;ta=Jp(ha|0,D|0,sa|0,ta|0)|0;H=mo(ta|0,D|0,G|0,H|0)|0;G=D;ta=_m(p|0,n|0,666643,0)|0;sa=D;ha=_m(p|0,n|0,470296,0)|0;ga=D;Na=_m(p|0,n|0,654183,0)|0;Ma=D;ca=_m(p|0,n|0,-997805,-1)|0;e=D;ba=_m(p|0,n|0,136657,0)|0;aa=D;n=_m(p|0,n|0,-683901,-1)|0;p=D;pa=_m(_|0,$|0,666643,0)|0;pa=Jp(ra|0,ia|0,pa|0,D|0)|0;ia=D;ra=_m(_|0,$|0,470296,0)|0;qa=D;Q=_m(_|0,$|0,654183,0)|0;R=D;Ja=_m(_|0,$|0,-997805,-1)|0;Ia=D;j=_m(_|0,$|0,136657,0)|0;f=D;$=_m(_|0,$|0,-683901,-1)|0;_=D;ka=Jp(ba|0,aa|0,la|0,ka|0)|0;_=Jp(ka|0,D|0,$|0,_|0)|0;ja=Jp(_|0,D|0,oa|0,ja|0)|0;X=Jp(ja|0,D|0,da|0,X|0)|0;B=mo(X|0,D|0,h|0,B|0)|0;h=D;X=_m(F|0,c|0,666643,0)|0;da=D;ja=_m(F|0,c|0,470296,0)|0;ja=Jp(pa|0,ia|0,ja|0,D|0)|0;ia=D;pa=_m(F|0,c|0,654183,0)|0;oa=D;_=_m(F|0,c|0,-997805,-1)|0;$=D;ka=_m(F|0,c|0,136657,0)|0;la=D;c=_m(F|0,c|0,-683901,-1)|0;F=D;aa=_m(A|0,l|0,666643,0)|0;ba=D;Y=_m(A|0,l|0,470296,0)|0;Z=D;U=_m(A|0,l|0,654183,0)|0;V=D;O=_m(A|0,l|0,-997805,-1)|0;P=D;K=_m(A|0,l|0,136657,0)|0;L=D;l=_m(A|0,l|0,-683901,-1)|0;A=D;Ka=Jp(Na|0,Ma|0,La|0,Ka|0)|0;Ia=Jp(Ka|0,D|0,Ja|0,Ia|0)|0;Ga=Jp(Ia|0,D|0,Ha|0,Ga|0)|0;M=mo(Ga|0,D|0,N|0,M|0)|0;la=Jp(M|0,D|0,ka|0,la|0)|0;A=Jp(la|0,D|0,l|0,A|0)|0;l=D;la=_m(g|0,i|0,666643,0)|0;W=Jp(la|0,D|0,x|0,W|0)|0;x=D;la=_m(g|0,i|0,470296,0)|0;ka=D;M=_m(g|0,i|0,654183,0)|0;N=D;Ca=Jp(Fa|0,Ea|0,Da|0,Ca|0)|0;Aa=mo(Ca|0,D|0,Ba|0,Aa|0)|0;da=Jp(Aa|0,D|0,X|0,da|0)|0;N=Jp(da|0,D|0,M|0,N|0)|0;Z=Jp(N|0,D|0,Y|0,Z|0)|0;Y=D;N=_m(g|0,i|0,-997805,-1)|0;M=D;da=_m(g|0,i|0,136657,0)|0;X=D;wa=Jp(za|0,ya|0,xa|0,wa|0)|0;ua=mo(wa|0,D|0,va|0,ua|0)|0;sa=Jp(ua|0,D|0,ta|0,sa|0)|0;qa=Jp(sa|0,D|0,ra|0,qa|0)|0;oa=Jp(qa|0,D|0,pa|0,oa|0)|0;X=Jp(oa|0,D|0,da|0,X|0)|0;P=Jp(X|0,D|0,O|0,P|0)|0;O=D;i=_m(g|0,i|0,-683901,-1)|0;g=D;X=Jp(W|0,x|0,1048576,0)|0;X=ln(X|0,D|0,21)|0;da=D;ka=Jp(na|0,ma|0,la|0,ka|0)|0;ba=Jp(ka|0,D|0,aa|0,ba|0)|0;ba=Jp(ba|0,D|0,X|0,da|0)|0;aa=D;da=_n(X|0,da|0,21)|0;da=mo(W|0,x|0,da|0,D|0)|0;x=D;W=Jp(Z|0,Y|0,1048576,0)|0;W=ln(W|0,D|0,21)|0;X=D;M=Jp(ja|0,ia|0,N|0,M|0)|0;V=Jp(M|0,D|0,U|0,V|0)|0;V=Jp(V|0,D|0,W|0,X|0)|0;U=D;X=_n(W|0,X|0,21)|0;W=D;M=Jp(P|0,O|0,1048576,0)|0;M=ln(M|0,D|0,21)|0;N=D;ea=Jp(ha|0,ga|0,fa|0,ea|0)|0;u=Jp(ea|0,D|0,y|0,u|0)|0;R=Jp(u|0,D|0,Q|0,R|0)|0;T=mo(R|0,D|0,S|0,T|0)|0;$=Jp(T|0,D|0,_|0,$|0)|0;g=Jp($|0,D|0,i|0,g|0)|0;L=Jp(g|0,D|0,K|0,L|0)|0;L=Jp(L|0,D|0,M|0,N|0)|0;K=D;N=_n(M|0,N|0,21)|0;M=D;g=Jp(A|0,l|0,1048576,0)|0;g=ln(g|0,D|0,21)|0;i=D;C=Jp(ca|0,e|0,J|0,C|0)|0;f=Jp(C|0,D|0,j|0,f|0)|0;k=Jp(f|0,D|0,m|0,k|0)|0;r=mo(k|0,D|0,z|0,r|0)|0;F=Jp(r|0,D|0,c|0,F|0)|0;F=Jp(F|0,D|0,g|0,i|0)|0;c=D;i=_n(g|0,i|0,21)|0;i=mo(A|0,l|0,i|0,D|0)|0;l=D;A=Jp(B|0,h|0,1048576,0)|0;A=ln(A|0,D|0,21)|0;g=D;v=Jp(n|0,p|0,q|0,v|0)|0;t=Jp(v|0,D|0,E|0,t|0)|0;I=mo(t|0,D|0,o|0,I|0)|0;I=Jp(I|0,D|0,A|0,g|0)|0;o=D;g=_n(A|0,g|0,21)|0;g=mo(B|0,h|0,g|0,D|0)|0;h=D;B=Jp(H|0,G|0,1048576,0)|0;B=ln(B|0,D|0,21)|0;A=D;s=Jp(w|0,s|0,B|0,A|0)|0;w=D;A=_n(B|0,A|0,21)|0;B=D;t=Jp(ba|0,aa|0,1048576,0)|0;t=ln(t|0,D|0,21)|0;E=D;v=_n(t|0,E|0,21)|0;q=D;p=Jp(V|0,U|0,1048576,0)|0;p=ln(p|0,D|0,21)|0;n=D;r=_n(p|0,n|0,21)|0;z=D;k=Jp(L|0,K|0,1048576,0)|0;k=ln(k|0,D|0,21)|0;m=D;l=Jp(i|0,l|0,k|0,m|0)|0;i=D;m=_n(k|0,m|0,21)|0;k=D;f=Jp(F|0,c|0,1048576,0)|0;f=ln(f|0,D|0,21)|0;j=D;h=Jp(g|0,h|0,f|0,j|0)|0;g=D;j=_n(f|0,j|0,21)|0;j=mo(F|0,c|0,j|0,D|0)|0;c=D;F=Jp(I|0,o|0,1048576,0)|0;F=ln(F|0,D|0,21)|0;f=D;C=_n(F|0,f|0,21)|0;C=mo(I|0,o|0,C|0,D|0)|0;o=D;I=Jp(s|0,w|0,1048576,0)|0;I=ln(I|0,D|0,21)|0;J=D;e=_n(I|0,J|0,21)|0;e=mo(s|0,w|0,e|0,D|0)|0;w=D;s=_m(I|0,J|0,666643,0)|0;s=Jp(da|0,x|0,s|0,D|0)|0;x=D;da=_m(I|0,J|0,470296,0)|0;ca=D;$=_m(I|0,J|0,654183,0)|0;_=D;T=_m(I|0,J|0,-997805,-1)|0;S=D;R=_m(I|0,J|0,136657,0)|0;Q=D;J=_m(I|0,J|0,-683901,-1)|0;I=D;u=ln(s|0,x|0,21)|0;y=D;aa=Jp(da|0,ca|0,ba|0,aa|0)|0;q=mo(aa|0,D|0,v|0,q|0)|0;q=Jp(q|0,D|0,u|0,y|0)|0;v=D;y=_n(u|0,y|0,21)|0;y=mo(s|0,x|0,y|0,D|0)|0;x=D;s=ln(q|0,v|0,21)|0;u=D;Y=Jp($|0,_|0,Z|0,Y|0)|0;W=mo(Y|0,D|0,X|0,W|0)|0;E=Jp(W|0,D|0,t|0,E|0)|0;E=Jp(E|0,D|0,s|0,u|0)|0;t=D;u=_n(s|0,u|0,21)|0;u=mo(q|0,v|0,u|0,D|0)|0;v=D;q=ln(E|0,t|0,21)|0;s=D;S=Jp(V|0,U|0,T|0,S|0)|0;z=mo(S|0,D|0,r|0,z|0)|0;z=Jp(z|0,D|0,q|0,s|0)|0;r=D;s=_n(q|0,s|0,21)|0;s=mo(E|0,t|0,s|0,D|0)|0;t=D;E=ln(z|0,r|0,21)|0;q=D;O=Jp(R|0,Q|0,P|0,O|0)|0;M=mo(O|0,D|0,N|0,M|0)|0;n=Jp(M|0,D|0,p|0,n|0)|0;n=Jp(n|0,D|0,E|0,q|0)|0;p=D;q=_n(E|0,q|0,21)|0;q=mo(z|0,r|0,q|0,D|0)|0;r=D;z=ln(n|0,p|0,21)|0;E=D;I=Jp(L|0,K|0,J|0,I|0)|0;k=mo(I|0,D|0,m|0,k|0)|0;k=Jp(k|0,D|0,z|0,E|0)|0;m=D;E=_n(z|0,E|0,21)|0;E=mo(n|0,p|0,E|0,D|0)|0;p=D;n=ln(k|0,m|0,21)|0;z=D;i=Jp(l|0,i|0,n|0,z|0)|0;l=D;z=_n(n|0,z|0,21)|0;z=mo(k|0,m|0,z|0,D|0)|0;m=D;k=ln(i|0,l|0,21)|0;n=D;c=Jp(k|0,n|0,j|0,c|0)|0;j=D;n=_n(k|0,n|0,21)|0;n=mo(i|0,l|0,n|0,D|0)|0;l=D;i=ln(c|0,j|0,21)|0;k=D;g=Jp(h|0,g|0,i|0,k|0)|0;h=D;k=_n(i|0,k|0,21)|0;k=mo(c|0,j|0,k|0,D|0)|0;j=D;c=ln(g|0,h|0,21)|0;i=D;o=Jp(c|0,i|0,C|0,o|0)|0;C=D;i=_n(c|0,i|0,21)|0;i=mo(g|0,h|0,i|0,D|0)|0;h=D;g=ln(o|0,C|0,21)|0;c=D;f=Jp(H|0,G|0,F|0,f|0)|0;B=mo(f|0,D|0,A|0,B|0)|0;B=Jp(B|0,D|0,g|0,c|0)|0;A=D;c=_n(g|0,c|0,21)|0;c=mo(o|0,C|0,c|0,D|0)|0;C=D;o=ln(B|0,A|0,21)|0;g=D;w=Jp(o|0,g|0,e|0,w|0)|0;e=D;g=_n(o|0,g|0,21)|0;g=mo(B|0,A|0,g|0,D|0)|0;A=D;B=ln(w|0,e|0,21)|0;o=D;f=_n(B|0,o|0,21)|0;f=mo(w|0,e|0,f|0,D|0)|0;e=D;w=_m(B|0,o|0,666643,0)|0;x=Jp(w|0,D|0,y|0,x|0)|0;y=D;w=_m(B|0,o|0,470296,0)|0;w=Jp(u|0,v|0,w|0,D|0)|0;v=D;u=_m(B|0,o|0,654183,0)|0;u=Jp(s|0,t|0,u|0,D|0)|0;t=D;s=_m(B|0,o|0,-997805,-1)|0;s=Jp(q|0,r|0,s|0,D|0)|0;r=D;q=_m(B|0,o|0,136657,0)|0;q=Jp(E|0,p|0,q|0,D|0)|0;p=D;o=_m(B|0,o|0,-683901,-1)|0;o=Jp(z|0,m|0,o|0,D|0)|0;m=D;z=ln(x|0,y|0,21)|0;B=D;v=Jp(w|0,v|0,z|0,B|0)|0;w=D;B=_n(z|0,B|0,21)|0;B=mo(x|0,y|0,B|0,D|0)|0;y=D;x=ln(v|0,w|0,21)|0;z=D;t=Jp(u|0,t|0,x|0,z|0)|0;u=D;z=_n(x|0,z|0,21)|0;z=mo(v|0,w|0,z|0,D|0)|0;w=D;v=ln(t|0,u|0,21)|0;x=D;r=Jp(s|0,r|0,v|0,x|0)|0;s=D;x=_n(v|0,x|0,21)|0;x=mo(t|0,u|0,x|0,D|0)|0;u=D;t=ln(r|0,s|0,21)|0;v=D;p=Jp(q|0,p|0,t|0,v|0)|0;q=D;v=_n(t|0,v|0,21)|0;v=mo(r|0,s|0,v|0,D|0)|0;s=D;r=ln(p|0,q|0,21)|0;t=D;m=Jp(o|0,m|0,r|0,t|0)|0;o=D;t=_n(r|0,t|0,21)|0;t=mo(p|0,q|0,t|0,D|0)|0;q=D;p=ln(m|0,o|0,21)|0;r=D;l=Jp(p|0,r|0,n|0,l|0)|0;n=D;r=_n(p|0,r|0,21)|0;r=mo(m|0,o|0,r|0,D|0)|0;o=D;m=ln(l|0,n|0,21)|0;p=D;j=Jp(m|0,p|0,k|0,j|0)|0;k=D;p=_n(m|0,p|0,21)|0;p=mo(l|0,n|0,p|0,D|0)|0;n=D;l=ln(j|0,k|0,21)|0;m=D;h=Jp(l|0,m|0,i|0,h|0)|0;i=D;m=_n(l|0,m|0,21)|0;m=mo(j|0,k|0,m|0,D|0)|0;k=D;j=ln(h|0,i|0,21)|0;l=D;C=Jp(j|0,l|0,c|0,C|0)|0;c=D;l=_n(j|0,l|0,21)|0;l=mo(h|0,i|0,l|0,D|0)|0;i=D;h=ln(C|0,c|0,21)|0;j=D;A=Jp(h|0,j|0,g|0,A|0)|0;g=D;j=_n(h|0,j|0,21)|0;j=mo(C|0,c|0,j|0,D|0)|0;c=D;C=ln(A|0,g|0,21)|0;h=D;e=Jp(C|0,h|0,f|0,e|0)|0;f=D;h=_n(C|0,h|0,21)|0;h=mo(A|0,g|0,h|0,D|0)|0;g=D;a[b>>0]=B;A=bo(B|0,y|0,8)|0;a[b+1>>0]=A;y=bo(B|0,y|0,16)|0;B=D;A=_n(z|0,w|0,5)|0;a[b+2>>0]=A|y;y=bo(z|0,w|0,3)|0;a[b+3>>0]=y;y=bo(z|0,w|0,11)|0;a[b+4>>0]=y;w=bo(z|0,w|0,19)|0;z=D;y=_n(x|0,u|0,2)|0;a[b+5>>0]=y|w;w=bo(x|0,u|0,6)|0;a[b+6>>0]=w;u=bo(x|0,u|0,14)|0;x=D;w=_n(v|0,s|0,7)|0;a[b+7>>0]=w|u;u=bo(v|0,s|0,1)|0;a[b+8>>0]=u;u=bo(v|0,s|0,9)|0;a[b+9>>0]=u;s=bo(v|0,s|0,17)|0;v=D;u=_n(t|0,q|0,4)|0;a[b+10>>0]=u|s;s=bo(t|0,q|0,4)|0;a[b+11>>0]=s;s=bo(t|0,q|0,12)|0;a[b+12>>0]=s;q=bo(t|0,q|0,20)|0;t=D;s=_n(r|0,o|0,1)|0;a[b+13>>0]=s|q;q=bo(r|0,o|0,7)|0;a[b+14>>0]=q;o=bo(r|0,o|0,15)|0;r=D;q=_n(p|0,n|0,6)|0;a[b+15>>0]=q|o;o=bo(p|0,n|0,2)|0;a[b+16>>0]=o;o=bo(p|0,n|0,10)|0;a[b+17>>0]=o;n=bo(p|0,n|0,18)|0;p=D;o=_n(m|0,k|0,3)|0;a[b+18>>0]=o|n;n=bo(m|0,k|0,5)|0;a[b+19>>0]=n;k=bo(m|0,k|0,13)|0;a[b+20>>0]=k;a[b+21>>0]=l;k=bo(l|0,i|0,8)|0;a[b+22>>0]=k;i=bo(l|0,i|0,16)|0;l=D;k=_n(j|0,c|0,5)|0;a[b+23>>0]=k|i;i=bo(j|0,c|0,3)|0;a[b+24>>0]=i;i=bo(j|0,c|0,11)|0;a[b+25>>0]=i;c=bo(j|0,c|0,19)|0;j=D;i=_n(h|0,g|0,2)|0;a[b+26>>0]=i|c;c=bo(h|0,g|0,6)|0;a[b+27>>0]=c;g=bo(h|0,g|0,14)|0;h=D;c=_n(e|0,f|0,7)|0;a[b+28>>0]=g|c;c=bo(e|0,f|0,1)|0;a[b+29>>0]=c;c=bo(e|0,f|0,9)|0;a[b+30>>0]=c;f=bo(e|0,f|0,17)|0;a[b+31>>0]=f;return}function $b(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=i=i+63&-64;i=i+304|0;e=0;do{h=b+(e<<2)|0;c[g+40+(e<<2)>>2]=(d[h+2>>0]|0)<<8|(d[h+3>>0]|0)|(d[h+1>>0]|0)<<16|(d[h>>0]|0)<<24;e=e+1|0}while((e|0)!=16);b=c[g+40>>2]|0;e=16;do{h=c[g+40+(e+-2<<2)>>2]|0;j=b;b=c[g+40+(e+-15<<2)>>2]|0;c[g+40+(e<<2)>>2]=j+(c[g+40+(e+-7<<2)>>2]|0)+((h>>>19|h<<13)^h>>>10^(h>>>17|h<<15))+((b>>>18|b<<14)^b>>>3^(b>>>7|b<<25));e=e+1|0}while((e|0)!=64);c[g+8>>2]=c[a>>2];c[g+8+4>>2]=c[a+4>>2];c[g+8+8>>2]=c[a+8>>2];c[g+8+12>>2]=c[a+12>>2];c[g+8+16>>2]=c[a+16>>2];c[g+8+20>>2]=c[a+20>>2];c[g+8+24>>2]=c[a+24>>2];c[g+8+28>>2]=c[a+28>>2];x=g+8+28|0;k=g+8+16|0;p=c[k>>2]|0;v=g+8+20|0;n=c[v>>2]|0;j=g+8+24|0;y=c[j>>2]|0;e=(c[x>>2]|0)+1116352408+(c[g+40>>2]|0)+((p>>>6|p<<26)^(p>>>11|p<<21)^(p>>>25|p<<7))+((y^n)&p^y)|0;l=c[g+8>>2]|0;t=g+8+4|0;o=c[t>>2]|0;w=g+8+8|0;q=c[w>>2]|0;h=g+8+12|0;b=(c[h>>2]|0)+e|0;c[h>>2]=b;c[x>>2]=((q|o)&l|q&o)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+e;p=y+1899447441+((b>>>6|b<<26)^(b>>>11|b<<21)^(b>>>25|b<<7))+(c[g+40+4>>2]|0)+((n^p)&b^n)|0;c[w>>2]=q+p;y=((o|l)&((q|o)&l|q&o)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+e|o&l)+(((((q|o)&l|q&o)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+e|0)>>>2|((q|o)&l|q&o)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+e<<30)^((((q|o)&l|q&o)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+e|0)>>>13|((q|o)&l|q&o)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+e<<19)^((((q|o)&l|q&o)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+e|0)>>>22|((q|o)&l|q&o)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+e<<10))+p|0;c[j>>2]=y;r=c[k>>2]|0;n=n+-1245643825+(((q+p|0)>>>6|q+p<<26)^((q+p|0)>>>11|q+p<<21)^((q+p|0)>>>25|q+p<<7))+(c[g+40+8>>2]|0)+((r^b)&q+p^r)|0;c[t>>2]=o+n;e=((l|((q|o)&l|q&o)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+e)&y|l&((q|o)&l|q&o)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+e)+((y>>>2|y<<30)^(y>>>13|y<<19)^(y>>>22|y<<10))+n|0;c[v>>2]=e;r=r+-373957723+(((o+n|0)>>>6|o+n<<26)^((o+n|0)>>>11|o+n<<21)^((o+n|0)>>>25|o+n<<7))+(c[g+40+12>>2]|0)+((b^q+p)&o+n^b)|0;s=c[x>>2]|0;c[g+8>>2]=l+r;c[k>>2]=((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r;b=b+961987163+(((l+r|0)>>>6|l+r<<26)^((l+r|0)>>>11|l+r<<21)^((l+r|0)>>>25|l+r<<7))+(c[g+40+16>>2]|0)+((q+p^o+n)&l+r^q+p)|0;m=c[j>>2]|0;c[x>>2]=s+b;u=((m|e)&((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|m&e)+(((((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|0)>>>2|((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r<<30)^((((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|0)>>>13|((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r<<19)^((((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|0)>>>22|((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r<<10))+b|0;c[h>>2]=u;p=q+p+1508970993+(((s+b|0)>>>6|s+b<<26)^((s+b|0)>>>11|s+b<<21)^((s+b|0)>>>25|s+b<<7))+(c[g+40+20>>2]|0)+((o+n^l+r)&s+b^o+n)|0;q=c[v>>2]|0;c[j>>2]=m+p;e=((q|((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r)&u|q&((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+p|0;c[w>>2]=e;n=o+n+-1841331548+(((m+p|0)>>>6|m+p<<26)^((m+p|0)>>>11|m+p<<21)^((m+p|0)>>>25|m+p<<7))+(c[g+40+24>>2]|0)+((l+r^s+b)&m+p^l+r)|0;o=c[k>>2]|0;c[v>>2]=q+n;c[t>>2]=((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n;r=l+r+-1424204075+(((q+n|0)>>>6|q+n<<26)^((q+n|0)>>>11|q+n<<21)^((q+n|0)>>>25|q+n<<7))+(c[g+40+28>>2]|0)+((s+b^m+p)&q+n^s+b)|0;l=c[h>>2]|0;c[k>>2]=o+r;y=((l|e)&((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|l&e)+(((((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|0)>>>2|((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n<<30)^((((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|0)>>>13|((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n<<19)^((((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|0)>>>22|((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n<<10))+r|0;c[g+8>>2]=y;b=s+b+-670586216+(((o+r|0)>>>6|o+r<<26)^((o+r|0)>>>11|o+r<<21)^((o+r|0)>>>25|o+r<<7))+(c[g+40+32>>2]|0)+((m+p^q+n)&o+r^m+p)|0;s=c[w>>2]|0;c[h>>2]=l+b;e=((s|((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n)&y|s&((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n)+((y>>>2|y<<30)^(y>>>13|y<<19)^(y>>>22|y<<10))+b|0;c[x>>2]=e;p=m+p+310598401+(((l+b|0)>>>6|l+b<<26)^((l+b|0)>>>11|l+b<<21)^((l+b|0)>>>25|l+b<<7))+(c[g+40+36>>2]|0)+((q+n^o+r)&l+b^q+n)|0;m=c[t>>2]|0;c[w>>2]=s+p;c[j>>2]=((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p;n=q+n+607225278+(((s+p|0)>>>6|s+p<<26)^((s+p|0)>>>11|s+p<<21)^((s+p|0)>>>25|s+p<<7))+(c[g+40+40>>2]|0)+((o+r^l+b)&s+p^o+r)|0;q=c[g+8>>2]|0;c[t>>2]=m+n;u=((q|e)&((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|q&e)+(((((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|0)>>>2|((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p<<30)^((((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|0)>>>13|((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p<<19)^((((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|0)>>>22|((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p<<10))+n|0;c[v>>2]=u;r=o+r+1426881987+(((m+n|0)>>>6|m+n<<26)^((m+n|0)>>>11|m+n<<21)^((m+n|0)>>>25|m+n<<7))+(c[g+40+44>>2]|0)+((l+b^s+p)&m+n^l+b)|0;o=c[x>>2]|0;c[g+8>>2]=q+r;e=((o|((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p)&u|o&((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+r|0;c[k>>2]=e;b=l+b+1925078388+(((q+r|0)>>>6|q+r<<26)^((q+r|0)>>>11|q+r<<21)^((q+r|0)>>>25|q+r<<7))+(c[g+40+48>>2]|0)+((s+p^m+n)&q+r^s+p)|0;l=c[j>>2]|0;c[x>>2]=o+b;c[h>>2]=((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b;p=s+p+-2132889090+(((o+b|0)>>>6|o+b<<26)^((o+b|0)>>>11|o+b<<21)^((o+b|0)>>>25|o+b<<7))+(c[g+40+52>>2]|0)+((m+n^q+r)&o+b^m+n)|0;s=c[v>>2]|0;c[j>>2]=l+p;y=((s|e)&((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|s&e)+(((((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|0)>>>2|((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b<<30)^((((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|0)>>>13|((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b<<19)^((((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|0)>>>22|((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b<<10))+p|0;c[w>>2]=y;n=m+n+-1680079193+(((l+p|0)>>>6|l+p<<26)^((l+p|0)>>>11|l+p<<21)^((l+p|0)>>>25|l+p<<7))+(c[g+40+56>>2]|0)+((q+r^o+b)&l+p^q+r)|0;m=c[k>>2]|0;c[v>>2]=s+n;e=((m|((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b)&y|m&((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b)+((y>>>2|y<<30)^(y>>>13|y<<19)^(y>>>22|y<<10))+n|0;c[t>>2]=e;r=q+r+-1046744716+(((s+n|0)>>>6|s+n<<26)^((s+n|0)>>>11|s+n<<21)^((s+n|0)>>>25|s+n<<7))+(c[g+40+60>>2]|0)+((o+b^l+p)&s+n^o+b)|0;q=c[h>>2]|0;c[k>>2]=m+r;c[g+8>>2]=((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r;b=o+b+-459576895+(((m+r|0)>>>6|m+r<<26)^((m+r|0)>>>11|m+r<<21)^((m+r|0)>>>25|m+r<<7))+(c[g+40+64>>2]|0)+((l+p^s+n)&m+r^l+p)|0;o=c[w>>2]|0;c[h>>2]=q+b;u=((o|e)&((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|o&e)+(((((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|0)>>>2|((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r<<30)^((((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|0)>>>13|((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r<<19)^((((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|0)>>>22|((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r<<10))+b|0;c[x>>2]=u;p=l+p+-272742522+(((q+b|0)>>>6|q+b<<26)^((q+b|0)>>>11|q+b<<21)^((q+b|0)>>>25|q+b<<7))+(c[g+40+68>>2]|0)+((s+n^m+r)&q+b^s+n)|0;l=c[t>>2]|0;c[w>>2]=o+p;e=((l|((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r)&u|l&((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+p|0;c[j>>2]=e;n=s+n+264347078+(((o+p|0)>>>6|o+p<<26)^((o+p|0)>>>11|o+p<<21)^((o+p|0)>>>25|o+p<<7))+(c[g+40+72>>2]|0)+((m+r^q+b)&o+p^m+r)|0;s=c[g+8>>2]|0;c[t>>2]=l+n;c[v>>2]=((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n;r=m+r+604807628+(((l+n|0)>>>6|l+n<<26)^((l+n|0)>>>11|l+n<<21)^((l+n|0)>>>25|l+n<<7))+(c[g+40+76>>2]|0)+((q+b^o+p)&l+n^q+b)|0;m=c[x>>2]|0;c[g+8>>2]=s+r;y=((m|e)&((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|m&e)+(((((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|0)>>>2|((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n<<30)^((((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|0)>>>13|((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n<<19)^((((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|0)>>>22|((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n<<10))+r|0;c[k>>2]=y;b=q+b+770255983+(((s+r|0)>>>6|s+r<<26)^((s+r|0)>>>11|s+r<<21)^((s+r|0)>>>25|s+r<<7))+(c[g+40+80>>2]|0)+((o+p^l+n)&s+r^o+p)|0;q=c[j>>2]|0;c[x>>2]=m+b;e=((q|((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n)&y|q&((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n)+((y>>>2|y<<30)^(y>>>13|y<<19)^(y>>>22|y<<10))+b|0;c[h>>2]=e;p=o+p+1249150122+(((m+b|0)>>>6|m+b<<26)^((m+b|0)>>>11|m+b<<21)^((m+b|0)>>>25|m+b<<7))+(c[g+40+84>>2]|0)+((l+n^s+r)&m+b^l+n)|0;o=c[v>>2]|0;c[j>>2]=q+p;c[w>>2]=((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p;n=l+n+1555081692+(((q+p|0)>>>6|q+p<<26)^((q+p|0)>>>11|q+p<<21)^((q+p|0)>>>25|q+p<<7))+(c[g+40+88>>2]|0)+((s+r^m+b)&q+p^s+r)|0;l=c[k>>2]|0;c[v>>2]=o+n;u=((l|e)&((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|l&e)+(((((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|0)>>>2|((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p<<30)^((((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|0)>>>13|((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p<<19)^((((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|0)>>>22|((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p<<10))+n|0;c[t>>2]=u;r=s+r+1996064986+(((o+n|0)>>>6|o+n<<26)^((o+n|0)>>>11|o+n<<21)^((o+n|0)>>>25|o+n<<7))+(c[g+40+92>>2]|0)+((m+b^q+p)&o+n^m+b)|0;s=c[h>>2]|0;c[k>>2]=l+r;e=((s|((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p)&u|s&((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+r|0;c[g+8>>2]=e;b=m+b+-1740746414+(((l+r|0)>>>6|l+r<<26)^((l+r|0)>>>11|l+r<<21)^((l+r|0)>>>25|l+r<<7))+(c[g+40+96>>2]|0)+((q+p^o+n)&l+r^q+p)|0;m=c[w>>2]|0;c[h>>2]=s+b;c[x>>2]=((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b;p=q+p+-1473132947+(((s+b|0)>>>6|s+b<<26)^((s+b|0)>>>11|s+b<<21)^((s+b|0)>>>25|s+b<<7))+(c[g+40+100>>2]|0)+((o+n^l+r)&s+b^o+n)|0;q=c[t>>2]|0;c[w>>2]=m+p;y=((q|e)&((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|q&e)+(((((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|0)>>>2|((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b<<30)^((((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|0)>>>13|((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b<<19)^((((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|0)>>>22|((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b<<10))+p|0;c[j>>2]=y;n=o+n+-1341970488+(((m+p|0)>>>6|m+p<<26)^((m+p|0)>>>11|m+p<<21)^((m+p|0)>>>25|m+p<<7))+(c[g+40+104>>2]|0)+((l+r^s+b)&m+p^l+r)|0;o=c[g+8>>2]|0;c[t>>2]=q+n;e=((o|((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b)&y|o&((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b)+((y>>>2|y<<30)^(y>>>13|y<<19)^(y>>>22|y<<10))+n|0;c[v>>2]=e;r=l+r+-1084653625+(((q+n|0)>>>6|q+n<<26)^((q+n|0)>>>11|q+n<<21)^((q+n|0)>>>25|q+n<<7))+(c[g+40+108>>2]|0)+((s+b^m+p)&q+n^s+b)|0;l=c[x>>2]|0;c[g+8>>2]=o+r;c[k>>2]=((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r;b=s+b+-958395405+(((o+r|0)>>>6|o+r<<26)^((o+r|0)>>>11|o+r<<21)^((o+r|0)>>>25|o+r<<7))+(c[g+40+112>>2]|0)+((m+p^q+n)&o+r^m+p)|0;s=c[j>>2]|0;c[x>>2]=l+b;u=((s|e)&((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|s&e)+(((((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|0)>>>2|((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r<<30)^((((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|0)>>>13|((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r<<19)^((((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|0)>>>22|((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r<<10))+b|0;c[h>>2]=u;p=m+p+-710438585+(((l+b|0)>>>6|l+b<<26)^((l+b|0)>>>11|l+b<<21)^((l+b|0)>>>25|l+b<<7))+(c[g+40+116>>2]|0)+((q+n^o+r)&l+b^q+n)|0;m=c[v>>2]|0;c[j>>2]=s+p;e=((m|((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r)&u|m&((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+p|0;c[w>>2]=e;n=q+n+113926993+(((s+p|0)>>>6|s+p<<26)^((s+p|0)>>>11|s+p<<21)^((s+p|0)>>>25|s+p<<7))+(c[g+40+120>>2]|0)+((o+r^l+b)&s+p^o+r)|0;q=c[k>>2]|0;c[v>>2]=m+n;c[t>>2]=((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n;r=o+r+338241895+(((m+n|0)>>>6|m+n<<26)^((m+n|0)>>>11|m+n<<21)^((m+n|0)>>>25|m+n<<7))+(c[g+40+124>>2]|0)+((l+b^s+p)&m+n^l+b)|0;o=c[h>>2]|0;c[k>>2]=q+r;y=((o|e)&((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|o&e)+(((((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|0)>>>2|((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n<<30)^((((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|0)>>>13|((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n<<19)^((((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|0)>>>22|((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n<<10))+r|0;c[g+8>>2]=y;b=l+b+666307205+(((q+r|0)>>>6|q+r<<26)^((q+r|0)>>>11|q+r<<21)^((q+r|0)>>>25|q+r<<7))+(c[g+40+128>>2]|0)+((s+p^m+n)&q+r^s+p)|0;l=c[w>>2]|0;c[h>>2]=o+b;e=((l|((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n)&y|l&((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n)+((y>>>2|y<<30)^(y>>>13|y<<19)^(y>>>22|y<<10))+b|0;c[x>>2]=e;p=s+p+773529912+(((o+b|0)>>>6|o+b<<26)^((o+b|0)>>>11|o+b<<21)^((o+b|0)>>>25|o+b<<7))+(c[g+40+132>>2]|0)+((m+n^q+r)&o+b^m+n)|0;s=c[t>>2]|0;c[w>>2]=l+p;c[j>>2]=((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p;n=m+n+1294757372+(((l+p|0)>>>6|l+p<<26)^((l+p|0)>>>11|l+p<<21)^((l+p|0)>>>25|l+p<<7))+(c[g+40+136>>2]|0)+((q+r^o+b)&l+p^q+r)|0;m=c[g+8>>2]|0;c[t>>2]=s+n;u=((m|e)&((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|m&e)+(((((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|0)>>>2|((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p<<30)^((((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|0)>>>13|((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p<<19)^((((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|0)>>>22|((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p<<10))+n|0;c[v>>2]=u;r=q+r+1396182291+(((s+n|0)>>>6|s+n<<26)^((s+n|0)>>>11|s+n<<21)^((s+n|0)>>>25|s+n<<7))+(c[g+40+140>>2]|0)+((o+b^l+p)&s+n^o+b)|0;q=c[x>>2]|0;c[g+8>>2]=m+r;e=((q|((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p)&u|q&((s|y)&e|s&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+r|0;c[k>>2]=e;b=o+b+1695183700+(((m+r|0)>>>6|m+r<<26)^((m+r|0)>>>11|m+r<<21)^((m+r|0)>>>25|m+r<<7))+(c[g+40+144>>2]|0)+((l+p^s+n)&m+r^l+p)|0;o=c[j>>2]|0;c[x>>2]=q+b;c[h>>2]=((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b;p=l+p+1986661051+(((q+b|0)>>>6|q+b<<26)^((q+b|0)>>>11|q+b<<21)^((q+b|0)>>>25|q+b<<7))+(c[g+40+148>>2]|0)+((s+n^m+r)&q+b^s+n)|0;l=c[v>>2]|0;c[j>>2]=o+p;y=((l|e)&((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|l&e)+(((((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|0)>>>2|((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b<<30)^((((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|0)>>>13|((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b<<19)^((((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|0)>>>22|((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b<<10))+p|0;c[w>>2]=y;n=s+n+-2117940946+(((o+p|0)>>>6|o+p<<26)^((o+p|0)>>>11|o+p<<21)^((o+p|0)>>>25|o+p<<7))+(c[g+40+152>>2]|0)+((m+r^q+b)&o+p^m+r)|0;s=c[k>>2]|0;c[v>>2]=l+n;e=((s|((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b)&y|s&((o|u)&e|o&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b)+((y>>>2|y<<30)^(y>>>13|y<<19)^(y>>>22|y<<10))+n|0;c[t>>2]=e;r=m+r+-1838011259+(((l+n|0)>>>6|l+n<<26)^((l+n|0)>>>11|l+n<<21)^((l+n|0)>>>25|l+n<<7))+(c[g+40+156>>2]|0)+((q+b^o+p)&l+n^q+b)|0;m=c[h>>2]|0;c[k>>2]=s+r;c[g+8>>2]=((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r;b=q+b+-1564481375+(((s+r|0)>>>6|s+r<<26)^((s+r|0)>>>11|s+r<<21)^((s+r|0)>>>25|s+r<<7))+(c[g+40+160>>2]|0)+((o+p^l+n)&s+r^o+p)|0;q=c[w>>2]|0;c[h>>2]=m+b;u=((q|e)&((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|q&e)+(((((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|0)>>>2|((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r<<30)^((((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|0)>>>13|((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r<<19)^((((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|0)>>>22|((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r<<10))+b|0;c[x>>2]=u;p=o+p+-1474664885+(((m+b|0)>>>6|m+b<<26)^((m+b|0)>>>11|m+b<<21)^((m+b|0)>>>25|m+b<<7))+(c[g+40+164>>2]|0)+((l+n^s+r)&m+b^l+n)|0;o=c[t>>2]|0;c[w>>2]=q+p;e=((o|((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r)&u|o&((m|y)&e|m&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+p|0;c[j>>2]=e;n=l+n+-1035236496+(((q+p|0)>>>6|q+p<<26)^((q+p|0)>>>11|q+p<<21)^((q+p|0)>>>25|q+p<<7))+(c[g+40+168>>2]|0)+((s+r^m+b)&q+p^s+r)|0;l=c[g+8>>2]|0;c[t>>2]=o+n;c[v>>2]=((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n;r=s+r+-949202525+(((o+n|0)>>>6|o+n<<26)^((o+n|0)>>>11|o+n<<21)^((o+n|0)>>>25|o+n<<7))+(c[g+40+172>>2]|0)+((m+b^q+p)&o+n^m+b)|0;s=c[x>>2]|0;c[g+8>>2]=l+r;y=((s|e)&((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|s&e)+(((((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|0)>>>2|((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n<<30)^((((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|0)>>>13|((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n<<19)^((((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|0)>>>22|((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n<<10))+r|0;c[k>>2]=y;b=m+b+-778901479+(((l+r|0)>>>6|l+r<<26)^((l+r|0)>>>11|l+r<<21)^((l+r|0)>>>25|l+r<<7))+(c[g+40+176>>2]|0)+((q+p^o+n)&l+r^q+p)|0;m=c[j>>2]|0;c[x>>2]=s+b;e=((m|((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n)&y|m&((l|u)&e|l&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n)+((y>>>2|y<<30)^(y>>>13|y<<19)^(y>>>22|y<<10))+b|0;c[h>>2]=e;p=q+p+-694614492+(((s+b|0)>>>6|s+b<<26)^((s+b|0)>>>11|s+b<<21)^((s+b|0)>>>25|s+b<<7))+(c[g+40+180>>2]|0)+((o+n^l+r)&s+b^o+n)|0;q=c[v>>2]|0;c[j>>2]=m+p;c[w>>2]=((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p;n=o+n+-200395387+(((m+p|0)>>>6|m+p<<26)^((m+p|0)>>>11|m+p<<21)^((m+p|0)>>>25|m+p<<7))+(c[g+40+184>>2]|0)+((l+r^s+b)&m+p^l+r)|0;o=c[k>>2]|0;c[v>>2]=q+n;u=((o|e)&((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|o&e)+(((((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|0)>>>2|((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p<<30)^((((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|0)>>>13|((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p<<19)^((((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|0)>>>22|((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p<<10))+n|0;c[t>>2]=u;r=l+r+275423344+(((q+n|0)>>>6|q+n<<26)^((q+n|0)>>>11|q+n<<21)^((q+n|0)>>>25|q+n<<7))+(c[g+40+188>>2]|0)+((s+b^m+p)&q+n^s+b)|0;l=c[h>>2]|0;c[k>>2]=o+r;e=((l|((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p)&u|l&((q|y)&e|q&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+r|0;c[g+8>>2]=e;b=s+b+430227734+(((o+r|0)>>>6|o+r<<26)^((o+r|0)>>>11|o+r<<21)^((o+r|0)>>>25|o+r<<7))+(c[g+40+192>>2]|0)+((m+p^q+n)&o+r^m+p)|0;s=c[w>>2]|0;c[h>>2]=l+b;c[x>>2]=((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b;p=m+p+506948616+(((l+b|0)>>>6|l+b<<26)^((l+b|0)>>>11|l+b<<21)^((l+b|0)>>>25|l+b<<7))+(c[g+40+196>>2]|0)+((q+n^o+r)&l+b^q+n)|0;m=c[t>>2]|0;c[w>>2]=s+p;y=((m|e)&((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|m&e)+(((((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|0)>>>2|((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b<<30)^((((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|0)>>>13|((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b<<19)^((((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|0)>>>22|((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b<<10))+p|0;c[j>>2]=y;n=q+n+659060556+(((s+p|0)>>>6|s+p<<26)^((s+p|0)>>>11|s+p<<21)^((s+p|0)>>>25|s+p<<7))+(c[g+40+200>>2]|0)+((o+r^l+b)&s+p^o+r)|0;q=c[g+8>>2]|0;c[t>>2]=m+n;e=((q|((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b)&y|q&((s|u)&e|s&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b)+((y>>>2|y<<30)^(y>>>13|y<<19)^(y>>>22|y<<10))+n|0;c[v>>2]=e;r=o+r+883997877+(((m+n|0)>>>6|m+n<<26)^((m+n|0)>>>11|m+n<<21)^((m+n|0)>>>25|m+n<<7))+(c[g+40+204>>2]|0)+((l+b^s+p)&m+n^l+b)|0;o=c[x>>2]|0;c[g+8>>2]=q+r;c[k>>2]=((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r;b=l+b+958139571+(((q+r|0)>>>6|q+r<<26)^((q+r|0)>>>11|q+r<<21)^((q+r|0)>>>25|q+r<<7))+(c[g+40+208>>2]|0)+((s+p^m+n)&q+r^s+p)|0;l=c[j>>2]|0;c[x>>2]=o+b;u=((l|e)&((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|l&e)+(((((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|0)>>>2|((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r<<30)^((((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|0)>>>13|((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r<<19)^((((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r|0)>>>22|((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r<<10))+b|0;c[h>>2]=u;p=s+p+1322822218+(((o+b|0)>>>6|o+b<<26)^((o+b|0)>>>11|o+b<<21)^((o+b|0)>>>25|o+b<<7))+(c[g+40+212>>2]|0)+((m+n^q+r)&o+b^m+n)|0;s=c[v>>2]|0;c[j>>2]=l+p;e=((s|((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r)&u|s&((o|y)&e|o&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+r)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+p|0;c[w>>2]=e;n=m+n+1537002063+(((l+p|0)>>>6|l+p<<26)^((l+p|0)>>>11|l+p<<21)^((l+p|0)>>>25|l+p<<7))+(c[g+40+216>>2]|0)+((q+r^o+b)&l+p^q+r)|0;m=c[k>>2]|0;c[v>>2]=s+n;c[t>>2]=((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n;r=q+r+1747873779+(((s+n|0)>>>6|s+n<<26)^((s+n|0)>>>11|s+n<<21)^((s+n|0)>>>25|s+n<<7))+(c[g+40+220>>2]|0)+((o+b^l+p)&s+n^o+b)|0;q=c[h>>2]|0;c[k>>2]=m+r;y=((q|e)&((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|q&e)+(((((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|0)>>>2|((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n<<30)^((((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|0)>>>13|((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n<<19)^((((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n|0)>>>22|((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n<<10))+r|0;c[g+8>>2]=y;b=o+b+1955562222+(((m+r|0)>>>6|m+r<<26)^((m+r|0)>>>11|m+r<<21)^((m+r|0)>>>25|m+r<<7))+(c[g+40+224>>2]|0)+((l+p^s+n)&m+r^l+p)|0;o=c[w>>2]|0;c[h>>2]=q+b;e=((o|((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n)&y|o&((m|u)&e|m&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+n)+((y>>>2|y<<30)^(y>>>13|y<<19)^(y>>>22|y<<10))+b|0;c[x>>2]=e;p=l+p+2024104815+(((q+b|0)>>>6|q+b<<26)^((q+b|0)>>>11|q+b<<21)^((q+b|0)>>>25|q+b<<7))+(c[g+40+228>>2]|0)+((s+n^m+r)&q+b^s+n)|0;l=c[t>>2]|0;c[w>>2]=o+p;c[j>>2]=((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p;n=s+n+-2067236844+(((o+p|0)>>>6|o+p<<26)^((o+p|0)>>>11|o+p<<21)^((o+p|0)>>>25|o+p<<7))+(c[g+40+232>>2]|0)+((m+r^q+b)&o+p^m+r)|0;s=c[g+8>>2]|0;c[t>>2]=l+n;u=((s|e)&((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|s&e)+(((((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|0)>>>2|((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p<<30)^((((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|0)>>>13|((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p<<19)^((((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p|0)>>>22|((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p<<10))+n|0;c[v>>2]=u;r=m+r+-1933114872+(((l+n|0)>>>6|l+n<<26)^((l+n|0)>>>11|l+n<<21)^((l+n|0)>>>25|l+n<<7))+(c[g+40+236>>2]|0)+((q+b^o+p)&l+n^q+b)|0;m=c[x>>2]|0;c[g+8>>2]=s+r;e=((m|((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p)&u|m&((l|y)&e|l&y)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+p)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+r|0;c[k>>2]=e;b=q+b+-1866530822+(((s+r|0)>>>6|s+r<<26)^((s+r|0)>>>11|s+r<<21)^((s+r|0)>>>25|s+r<<7))+(c[g+40+240>>2]|0)+((o+p^l+n)&s+r^o+p)|0;q=c[j>>2]|0;c[x>>2]=m+b;c[h>>2]=((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b;p=o+p+-1538233109+(((m+b|0)>>>6|m+b<<26)^((m+b|0)>>>11|m+b<<21)^((m+b|0)>>>25|m+b<<7))+(c[g+40+244>>2]|0)+((l+n^s+r)&m+b^l+n)|0;o=c[v>>2]|0;c[j>>2]=q+p;j=((o|e)&((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|o&e)+(((((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|0)>>>2|((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b<<30)^((((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|0)>>>13|((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b<<19)^((((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|0)>>>22|((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b<<10))+p|0;c[w>>2]=j;n=l+n+-1090935817+(((q+p|0)>>>6|q+p<<26)^((q+p|0)>>>11|q+p<<21)^((q+p|0)>>>25|q+p<<7))+(c[g+40+248>>2]|0)+((s+r^m+b)&q+p^s+r)|0;l=c[k>>2]|0;c[v>>2]=o+n;e=((l|((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b)&j|l&((q|u)&e|q&u)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b)+((j>>>2|j<<30)^(j>>>13|j<<19)^(j>>>22|j<<10))+n|0;c[t>>2]=e;b=s+r+-965641998+(((o+n|0)>>>6|o+n<<26)^((o+n|0)>>>11|o+n<<21)^((o+n|0)>>>25|o+n<<7))+(c[g+40+252>>2]|0)+((m+b^q+p)&o+n^m+b)|0;c[g+4>>2]=b;h=c[h>>2]|0;c[g>>2]=((h|j)&e|h&j)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10));c[k>>2]=l+b;b=((h|j)&e|h&j)+((e>>>2|e<<30)^(e>>>13|e<<19)^(e>>>22|e<<10))+b|0;c[g+8>>2]=b;c[a>>2]=(c[a>>2]|0)+b;b=1;while(1){y=a+(b<<2)|0;c[y>>2]=(c[y>>2]|0)+e;b=b+1|0;if((b|0)==8)break;e=c[g+8+(b<<2)>>2]|0}bl(g+40|0,256);bl(g+8|0,32);bl(g+4|0,4);bl(g,4);i=f;return}function ac(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;r=i;q=i=i+63&-64;i=i+4096|0;if(b){o=ec(c[b+12>>2]<<3)|0;if(!o)e=-22;else{cu(q+3072|0);cu(q+2048|0);p=c[d>>2]|0;c[q+2048>>2]=p;c[q+2048+4>>2]=0;m=c[d+4>>2]|0;c[q+2048+8>>2]=m;c[q+2048+8+4>>2]=0;n=a[d+8>>0]|0;c[q+2048+16>>2]=n&255;c[q+2048+16+4>>2]=0;c[q+2048+24>>2]=c[b+8>>2];c[q+2048+24+4>>2]=0;c[q+2048+32>>2]=c[b+4>>2];c[q+2048+32+4>>2]=0;c[q+2048+40>>2]=c[b+28>>2];c[q+2048+40+4>>2]=0;e=c[b+12>>2]|0;if(!e)e=0;else{g=0;do{f=g&127;if(!f){e=Jp(c[q+2048+48>>2]|0,c[q+2048+48+4>>2]|0,1,0)|0;c[q+2048+48>>2]=e;c[q+2048+48+4>>2]=D;cu(q);cu(q+1024|0);bc(q+3072|0,q+2048|0,q);bc(q+3072|0,q,q+1024|0);e=c[b+12>>2]|0}k=c[q+1024+(f<<3)+4>>2]|0;l=o+(g<<3)|0;c[l>>2]=c[q+1024+(f<<3)>>2];c[l+4>>2]=k;g=g+1|0}while(g>>>0<e>>>0)}f=(p|0)==0&n<<24>>24==0?2:0;g=c[b+16>>2]|0;h=(S(g,m)|0)+f+(S(n&255,e)|0)|0;if(f>>>0<e>>>0){j=g;l=h;e=(((h>>>0)%(g>>>0)|0|0)==0?g+-1|0:-1)+h|0;while(1){k=((l>>>0)%(j>>>0)|0|0)==1?l+-1|0:e;s=o+(f<<3)|0;g=c[s>>2]|0;s=ym(c[s+4>>2]|0,0,c[b+20>>2]|0,0)|0;s=(p|0)==0&n<<24>>24==0?m:s;e=(p|0)==0&n<<24>>24==0?0:D;g=eg(b,p,n,f,g,(s|0)==(m|0)&(e|0)==0&1)|0;h=c[(c[b>>2]|0)+4>>2]|0;e=_m(j|0,0,s|0,e|0)|0;j=h+(l<<10)|0;if(!p){vt(q+3072|0,h+(e<<10)+(g<<10)|0);fl(q+3072|0,h+(k<<10)|0);vt(q+2048|0,q+3072|0);e=0;do{s=e<<4;C=c[q+3072+(s<<3)>>2]|0;J=c[q+3072+(s<<3)+4>>2]|0;x=c[q+3072+((s|4)<<3)>>2]|0;v=c[q+3072+((s|4)<<3)+4>>2]|0;h=Jp(x|0,v|0,C|0,J|0)|0;y=D;J=_n(C|0,J|0,1)|0;J=_m(J&-2|0,D&1|0,x|0,0)|0;J=Jp(h|0,y|0,J|0,D|0)|0;y=D;h=J^c[q+3072+((s|12)<<3)>>2];C=y^c[q+3072+((s|12)<<3)+4>>2];B=c[q+3072+((s|8)<<3)>>2]|0;E=c[q+3072+((s|8)<<3)+4>>2]|0;G=Jp(C|0,h|0,B|0,E|0)|0;t=D;E=_n(B|0,E|0,1)|0;E=_m(C|0,0,E&-2|0,D&1|0)|0;E=Jp(G|0,t|0,E|0,D|0)|0;t=D;G=bo(E^x|0,t^v|0,24)|0;B=D;v=_n(E^x|0,t^v|0,40)|0;B=D|B;x=Jp(v|G|0,B|0,J|0,y|0)|0;u=D;y=_n(J|0,y|0,1)|0;y=_m(G|0,0,y&-2|0,D&1|0)|0;y=Jp(x|0,u|0,y|0,D|0)|0;u=D;c[q+3072+(s<<3)>>2]=y;c[q+3072+(s<<3)+4>>2]=u;x=bo(y^C|0,u^h|0,16)|0;J=D;h=_n(y^C|0,u^h|0,48)|0;J=D|J;c[q+3072+((s|12)<<3)>>2]=h|x;c[q+3072+((s|12)<<3)+4>>2]=J;J=Jp(h|x|0,J|0,E|0,t|0)|0;h=D;t=_n(E|0,t|0,1)|0;t=_m(x|0,0,t&-2|0,D&1|0)|0;t=Jp(J|0,h|0,t|0,D|0)|0;h=D;c[q+3072+((s|8)<<3)>>2]=t;c[q+3072+((s|8)<<3)+4>>2]=h;J=bo(t^(v|G)|0,h^B|0,63)|0;x=D;B=_n(t^(v|G)|0,h^B|0,1)|0;c[q+3072+((s|4)<<3)>>2]=B|J;c[q+3072+((s|4)<<3)+4>>2]=D|x;x=c[q+3072+((s|1)<<3)>>2]|0;J=c[q+3072+((s|1)<<3)+4>>2]|0;B=c[q+3072+((s|5)<<3)>>2]|0;h=c[q+3072+((s|5)<<3)+4>>2]|0;G=Jp(B|0,h|0,x|0,J|0)|0;v=D;J=_n(x|0,J|0,1)|0;J=_m(J&-2|0,D&1|0,B|0,0)|0;J=Jp(G|0,v|0,J|0,D|0)|0;v=D;G=J^c[q+3072+((s|13)<<3)>>2];x=v^c[q+3072+((s|13)<<3)+4>>2];t=c[q+3072+((s|9)<<3)>>2]|0;E=c[q+3072+((s|9)<<3)+4>>2]|0;u=Jp(x|0,G|0,t|0,E|0)|0;C=D;E=_n(t|0,E|0,1)|0;E=_m(x|0,0,E&-2|0,D&1|0)|0;E=Jp(u|0,C|0,E|0,D|0)|0;C=D;u=bo(E^B|0,C^h|0,24)|0;t=D;h=_n(E^B|0,C^h|0,40)|0;t=D|t;B=Jp(h|u|0,t|0,J|0,v|0)|0;y=D;v=_n(J|0,v|0,1)|0;v=_m(u|0,0,v&-2|0,D&1|0)|0;v=Jp(B|0,y|0,v|0,D|0)|0;y=D;c[q+3072+((s|1)<<3)>>2]=v;c[q+3072+((s|1)<<3)+4>>2]=y;B=bo(v^x|0,y^G|0,16)|0;J=D;G=_n(v^x|0,y^G|0,48)|0;J=D|J;c[q+3072+((s|13)<<3)>>2]=G|B;c[q+3072+((s|13)<<3)+4>>2]=J;J=Jp(G|B|0,J|0,E|0,C|0)|0;G=D;C=_n(E|0,C|0,1)|0;C=_m(B|0,0,C&-2|0,D&1|0)|0;C=Jp(J|0,G|0,C|0,D|0)|0;G=D;c[q+3072+((s|9)<<3)>>2]=C;c[q+3072+((s|9)<<3)+4>>2]=G;J=bo(C^(h|u)|0,G^t|0,63)|0;B=D;t=_n(C^(h|u)|0,G^t|0,1)|0;c[q+3072+((s|5)<<3)>>2]=t|J;c[q+3072+((s|5)<<3)+4>>2]=D|B;B=c[q+3072+((s|2)<<3)>>2]|0;J=c[q+3072+((s|2)<<3)+4>>2]|0;t=c[q+3072+((s|6)<<3)>>2]|0;G=c[q+3072+((s|6)<<3)+4>>2]|0;u=Jp(t|0,G|0,B|0,J|0)|0;h=D;J=_n(B|0,J|0,1)|0;J=_m(J&-2|0,D&1|0,t|0,0)|0;J=Jp(u|0,h|0,J|0,D|0)|0;h=D;u=J^c[q+3072+((s|14)<<3)>>2];B=h^c[q+3072+((s|14)<<3)+4>>2];C=c[q+3072+((s|10)<<3)>>2]|0;E=c[q+3072+((s|10)<<3)+4>>2]|0;y=Jp(B|0,u|0,C|0,E|0)|0;x=D;E=_n(C|0,E|0,1)|0;E=_m(B|0,0,E&-2|0,D&1|0)|0;E=Jp(y|0,x|0,E|0,D|0)|0;x=D;y=bo(E^t|0,x^G|0,24)|0;C=D;G=_n(E^t|0,x^G|0,40)|0;C=D|C;t=Jp(G|y|0,C|0,J|0,h|0)|0;v=D;h=_n(J|0,h|0,1)|0;h=_m(y|0,0,h&-2|0,D&1|0)|0;h=Jp(t|0,v|0,h|0,D|0)|0;v=D;c[q+3072+((s|2)<<3)>>2]=h;c[q+3072+((s|2)<<3)+4>>2]=v;t=bo(h^B|0,v^u|0,16)|0;J=D;u=_n(h^B|0,v^u|0,48)|0;J=D|J;c[q+3072+((s|14)<<3)>>2]=u|t;c[q+3072+((s|14)<<3)+4>>2]=J;J=Jp(u|t|0,J|0,E|0,x|0)|0;u=D;x=_n(E|0,x|0,1)|0;x=_m(t|0,0,x&-2|0,D&1|0)|0;x=Jp(J|0,u|0,x|0,D|0)|0;u=D;J=bo(x^(G|y)|0,u^C|0,63)|0;t=D;C=_n(x^(G|y)|0,u^C|0,1)|0;c[q+3072+((s|6)<<3)>>2]=C|J;c[q+3072+((s|6)<<3)+4>>2]=D|t;t=c[q+3072+((s|3)<<3)>>2]|0;J=c[q+3072+((s|3)<<3)+4>>2]|0;C=c[q+3072+((s|7)<<3)>>2]|0;y=c[q+3072+((s|7)<<3)+4>>2]|0;G=Jp(C|0,y|0,t|0,J|0)|0;E=D;J=_n(t|0,J|0,1)|0;J=_m(J&-2|0,D&1|0,C|0,0)|0;J=Jp(G|0,E|0,J|0,D|0)|0;E=D;G=J^c[q+3072+((s|15)<<3)>>2];t=E^c[q+3072+((s|15)<<3)+4>>2];v=c[q+3072+((s|11)<<3)>>2]|0;B=c[q+3072+((s|11)<<3)+4>>2]|0;h=Jp(t|0,G|0,v|0,B|0)|0;w=D;B=_n(v|0,B|0,1)|0;B=_m(t|0,0,B&-2|0,D&1|0)|0;B=Jp(h|0,w|0,B|0,D|0)|0;w=D;h=bo(B^C|0,w^y|0,24)|0;v=D;y=_n(B^C|0,w^y|0,40)|0;v=D|v;C=Jp(y|h|0,v|0,J|0,E|0)|0;A=D;E=_n(J|0,E|0,1)|0;E=_m(h|0,0,E&-2|0,D&1|0)|0;E=Jp(C|0,A|0,E|0,D|0)|0;A=D;c[q+3072+((s|3)<<3)>>2]=E;c[q+3072+((s|3)<<3)+4>>2]=A;C=bo(E^t|0,A^G|0,16)|0;J=D;G=_n(E^t|0,A^G|0,48)|0;J=D|J;A=Jp(G|C|0,J|0,B|0,w|0)|0;t=D;w=_n(B|0,w|0,1)|0;w=_m(C|0,0,w&-2|0,D&1|0)|0;w=Jp(A|0,t|0,w|0,D|0)|0;t=D;A=bo(w^(y|h)|0,t^v|0,63)|0;B=D;v=_n(w^(y|h)|0,t^v|0,1)|0;B=D|B;c[q+3072+((s|7)<<3)>>2]=v|A;c[q+3072+((s|7)<<3)+4>>2]=B;h=c[q+3072+(s<<3)>>2]|0;y=c[q+3072+(s<<3)+4>>2]|0;E=c[q+3072+((s|5)<<3)>>2]|0;F=c[q+3072+((s|5)<<3)+4>>2]|0;z=Jp(E|0,F|0,h|0,y|0)|0;I=D;y=_n(h|0,y|0,1)|0;y=_m(y&-2|0,D&1|0,E|0,0)|0;y=Jp(z|0,I|0,y|0,D|0)|0;I=D;z=Jp(J^I|0,(G|C)^y|0,x|0,u|0)|0;h=D;u=_n(x|0,u|0,1)|0;u=_m(J^I|0,0,u&-2|0,D&1|0)|0;u=Jp(z|0,h|0,u|0,D|0)|0;h=D;z=bo(u^E|0,h^F|0,24)|0;x=D;F=_n(u^E|0,h^F|0,40)|0;x=D|x;E=Jp(F|z|0,x|0,y|0,I|0)|0;H=D;K=_n(y|0,I|0,1)|0;K=_m(z|0,0,K&-2|0,D&1|0)|0;K=Jp(E|0,H|0,K|0,D|0)|0;H=D;c[q+3072+(s<<3)>>2]=K;c[q+3072+(s<<3)+4>>2]=H;E=bo(K^(J^I)|0,H^((G|C)^y)|0,16)|0;g=D;y=_n(K^(J^I)|0,H^((G|C)^y)|0,48)|0;g=D|g;c[q+3072+((s|15)<<3)>>2]=y|E;c[q+3072+((s|15)<<3)+4>>2]=g;g=Jp(y|E|0,g|0,u|0,h|0)|0;y=D;h=_n(u|0,h|0,1)|0;h=_m(E|0,0,h&-2|0,D&1|0)|0;h=Jp(g|0,y|0,h|0,D|0)|0;y=D;c[q+3072+((s|10)<<3)>>2]=h;c[q+3072+((s|10)<<3)+4>>2]=y;g=bo(h^(F|z)|0,y^x|0,63)|0;E=D;x=_n(h^(F|z)|0,y^x|0,1)|0;c[q+3072+((s|5)<<3)>>2]=x|g;c[q+3072+((s|5)<<3)+4>>2]=D|E;E=c[q+3072+((s|1)<<3)>>2]|0;g=c[q+3072+((s|1)<<3)+4>>2]|0;x=c[q+3072+((s|6)<<3)>>2]|0;y=c[q+3072+((s|6)<<3)+4>>2]|0;z=Jp(x|0,y|0,E|0,g|0)|0;F=D;g=_n(E|0,g|0,1)|0;g=_m(g&-2|0,D&1|0,x|0,0)|0;g=Jp(z|0,F|0,g|0,D|0)|0;F=D;z=g^c[q+3072+((s|12)<<3)>>2];E=F^c[q+3072+((s|12)<<3)+4>>2];h=Jp(E|0,z|0,w|0,t|0)|0;u=D;t=_n(w|0,t|0,1)|0;t=_m(t&-2|0,D&1|0,E|0,0)|0;t=Jp(h|0,u|0,t|0,D|0)|0;u=D;h=bo(t^x|0,u^y|0,24)|0;w=D;y=_n(t^x|0,u^y|0,40)|0;w=D|w;x=Jp(y|h|0,w|0,g|0,F|0)|0;C=D;F=_n(g|0,F|0,1)|0;F=_m(h|0,0,F&-2|0,D&1|0)|0;F=Jp(x|0,C|0,F|0,D|0)|0;C=D;c[q+3072+((s|1)<<3)>>2]=F;c[q+3072+((s|1)<<3)+4>>2]=C;x=bo(F^E|0,C^z|0,16)|0;g=D;z=_n(F^E|0,C^z|0,48)|0;g=D|g;c[q+3072+((s|12)<<3)>>2]=z|x;c[q+3072+((s|12)<<3)+4>>2]=g;g=Jp(z|x|0,g|0,t|0,u|0)|0;z=D;u=_n(t|0,u|0,1)|0;u=_m(x|0,0,u&-2|0,D&1|0)|0;u=Jp(g|0,z|0,u|0,D|0)|0;z=D;c[q+3072+((s|11)<<3)>>2]=u;c[q+3072+((s|11)<<3)+4>>2]=z;g=bo(u^(y|h)|0,z^w|0,63)|0;x=D;w=_n(u^(y|h)|0,z^w|0,1)|0;c[q+3072+((s|6)<<3)>>2]=w|g;c[q+3072+((s|6)<<3)+4>>2]=D|x;x=c[q+3072+((s|2)<<3)>>2]|0;g=c[q+3072+((s|2)<<3)+4>>2]|0;w=Jp(v|A|0,B|0,x|0,g|0)|0;z=D;g=_n(x|0,g|0,1)|0;g=_m(g&-2|0,D&1|0,v|A|0,0)|0;g=Jp(w|0,z|0,g|0,D|0)|0;z=D;w=g^c[q+3072+((s|13)<<3)>>2];x=z^c[q+3072+((s|13)<<3)+4>>2];h=c[q+3072+((s|8)<<3)>>2]|0;y=c[q+3072+((s|8)<<3)+4>>2]|0;u=Jp(x|0,w|0,h|0,y|0)|0;t=D;y=_n(h|0,y|0,1)|0;y=_m(x|0,0,y&-2|0,D&1|0)|0;y=Jp(u|0,t|0,y|0,D|0)|0;t=D;u=bo(y^(v|A)|0,t^B|0,24)|0;h=D;B=_n(y^(v|A)|0,t^B|0,40)|0;h=D|h;A=Jp(B|u|0,h|0,g|0,z|0)|0;v=D;z=_n(g|0,z|0,1)|0;z=_m(u|0,0,z&-2|0,D&1|0)|0;z=Jp(A|0,v|0,z|0,D|0)|0;v=D;c[q+3072+((s|2)<<3)>>2]=z;c[q+3072+((s|2)<<3)+4>>2]=v;A=bo(z^x|0,v^w|0,16)|0;g=D;w=_n(z^x|0,v^w|0,48)|0;g=D|g;c[q+3072+((s|13)<<3)>>2]=w|A;c[q+3072+((s|13)<<3)+4>>2]=g;g=Jp(w|A|0,g|0,y|0,t|0)|0;w=D;t=_n(y|0,t|0,1)|0;t=_m(A|0,0,t&-2|0,D&1|0)|0;t=Jp(g|0,w|0,t|0,D|0)|0;w=D;c[q+3072+((s|8)<<3)>>2]=t;c[q+3072+((s|8)<<3)+4>>2]=w;g=bo(t^(B|u)|0,w^h|0,63)|0;A=D;h=_n(t^(B|u)|0,w^h|0,1)|0;c[q+3072+((s|7)<<3)>>2]=h|g;c[q+3072+((s|7)<<3)+4>>2]=D|A;A=c[q+3072+((s|3)<<3)>>2]|0;g=c[q+3072+((s|3)<<3)+4>>2]|0;h=c[q+3072+((s|4)<<3)>>2]|0;w=c[q+3072+((s|4)<<3)+4>>2]|0;u=Jp(h|0,w|0,A|0,g|0)|0;B=D;g=_n(A|0,g|0,1)|0;g=_m(g&-2|0,D&1|0,h|0,0)|0;g=Jp(u|0,B|0,g|0,D|0)|0;B=D;u=g^c[q+3072+((s|14)<<3)>>2];A=B^c[q+3072+((s|14)<<3)+4>>2];t=c[q+3072+((s|9)<<3)>>2]|0;y=c[q+3072+((s|9)<<3)+4>>2]|0;v=Jp(A|0,u|0,t|0,y|0)|0;x=D;y=_n(t|0,y|0,1)|0;y=_m(A|0,0,y&-2|0,D&1|0)|0;y=Jp(v|0,x|0,y|0,D|0)|0;x=D;v=bo(y^h|0,x^w|0,24)|0;t=D;w=_n(y^h|0,x^w|0,40)|0;t=D|t;h=Jp(w|v|0,t|0,g|0,B|0)|0;z=D;B=_n(g|0,B|0,1)|0;B=_m(v|0,0,B&-2|0,D&1|0)|0;B=Jp(h|0,z|0,B|0,D|0)|0;z=D;c[q+3072+((s|3)<<3)>>2]=B;c[q+3072+((s|3)<<3)+4>>2]=z;h=bo(B^A|0,z^u|0,16)|0;g=D;u=_n(B^A|0,z^u|0,48)|0;g=D|g;c[q+3072+((s|14)<<3)>>2]=u|h;c[q+3072+((s|14)<<3)+4>>2]=g;g=Jp(u|h|0,g|0,y|0,x|0)|0;u=D;x=_n(y|0,x|0,1)|0;x=_m(h|0,0,x&-2|0,D&1|0)|0;x=Jp(g|0,u|0,x|0,D|0)|0;u=D;c[q+3072+((s|9)<<3)>>2]=x;c[q+3072+((s|9)<<3)+4>>2]=u;g=bo(x^(w|v)|0,u^t|0,63)|0;h=D;t=_n(x^(w|v)|0,u^t|0,1)|0;c[q+3072+((s|4)<<3)>>2]=t|g;c[q+3072+((s|4)<<3)+4>>2]=D|h;e=e+1|0}while((e|0)!=8);e=0;do{K=e<<1;E=c[q+3072+(K<<3)>>2]|0;H=c[q+3072+(K<<3)+4>>2]|0;y=q+3072+(K+32<<3)|0;B=c[y>>2]|0;y=c[y+4>>2]|0;v=Jp(B|0,y|0,E|0,H|0)|0;h=D;H=_n(E|0,H|0,1)|0;H=_m(H&-2|0,D&1|0,B|0,0)|0;H=Jp(v|0,h|0,H|0,D|0)|0;h=D;v=q+3072+(K+96<<3)|0;E=H^c[v>>2];v=h^c[v+4>>2];u=q+3072+(K+64<<3)|0;z=c[u>>2]|0;u=c[u+4>>2]|0;I=Jp(v|0,E|0,z|0,u|0)|0;x=D;u=_n(z|0,u|0,1)|0;u=_m(v|0,0,u&-2|0,D&1|0)|0;u=Jp(I|0,x|0,u|0,D|0)|0;x=D;I=bo(u^B|0,x^y|0,24)|0;z=D;y=_n(u^B|0,x^y|0,40)|0;z=D|z;B=Jp(y|I|0,z|0,H|0,h|0)|0;F=D;h=_n(H|0,h|0,1)|0;h=_m(I|0,0,h&-2|0,D&1|0)|0;h=Jp(B|0,F|0,h|0,D|0)|0;F=D;c[q+3072+(K<<3)>>2]=h;c[q+3072+(K<<3)+4>>2]=F;B=bo(h^v|0,F^E|0,16)|0;H=D;E=_n(h^v|0,F^E|0,48)|0;H=D|H;F=q+3072+(K+96<<3)|0;c[F>>2]=E|B;c[F+4>>2]=H;H=Jp(E|B|0,H|0,u|0,x|0)|0;E=D;x=_n(u|0,x|0,1)|0;x=_m(B|0,0,x&-2|0,D&1|0)|0;x=Jp(H|0,E|0,x|0,D|0)|0;E=D;H=q+3072+(K+64<<3)|0;c[H>>2]=x;c[H+4>>2]=E;H=bo(x^(y|I)|0,E^z|0,63)|0;B=D;z=_n(x^(y|I)|0,E^z|0,1)|0;E=q+3072+(K+32<<3)|0;c[E>>2]=z|H;c[E+4>>2]=D|B;E=c[q+3072+((K|1)<<3)>>2]|0;B=c[q+3072+((K|1)<<3)+4>>2]|0;H=q+3072+(K+33<<3)|0;z=c[H>>2]|0;H=c[H+4>>2]|0;I=Jp(z|0,H|0,E|0,B|0)|0;y=D;B=_n(E|0,B|0,1)|0;B=_m(B&-2|0,D&1|0,z|0,0)|0;B=Jp(I|0,y|0,B|0,D|0)|0;y=D;I=q+3072+(K+97<<3)|0;E=B^c[I>>2];I=y^c[I+4>>2];x=q+3072+(K+65<<3)|0;u=c[x>>2]|0;x=c[x+4>>2]|0;F=Jp(I|0,E|0,u|0,x|0)|0;v=D;x=_n(u|0,x|0,1)|0;x=_m(I|0,0,x&-2|0,D&1|0)|0;x=Jp(F|0,v|0,x|0,D|0)|0;v=D;F=bo(x^z|0,v^H|0,24)|0;u=D;H=_n(x^z|0,v^H|0,40)|0;u=D|u;z=Jp(H|F|0,u|0,B|0,y|0)|0;h=D;y=_n(B|0,y|0,1)|0;y=_m(F|0,0,y&-2|0,D&1|0)|0;y=Jp(z|0,h|0,y|0,D|0)|0;h=D;c[q+3072+((K|1)<<3)>>2]=y;c[q+3072+((K|1)<<3)+4>>2]=h;z=bo(y^I|0,h^E|0,16)|0;B=D;E=_n(y^I|0,h^E|0,48)|0;B=D|B;h=q+3072+(K+97<<3)|0;c[h>>2]=E|z;c[h+4>>2]=B;B=Jp(E|z|0,B|0,x|0,v|0)|0;E=D;v=_n(x|0,v|0,1)|0;v=_m(z|0,0,v&-2|0,D&1|0)|0;v=Jp(B|0,E|0,v|0,D|0)|0;E=D;B=q+3072+(K+65<<3)|0;c[B>>2]=v;c[B+4>>2]=E;B=bo(v^(H|F)|0,E^u|0,63)|0;z=D;u=_n(v^(H|F)|0,E^u|0,1)|0;E=q+3072+(K+33<<3)|0;c[E>>2]=u|B;c[E+4>>2]=D|z;E=q+3072+(K+16<<3)|0;z=c[E>>2]|0;E=c[E+4>>2]|0;B=q+3072+(K+48<<3)|0;u=c[B>>2]|0;B=c[B+4>>2]|0;F=Jp(u|0,B|0,z|0,E|0)|0;H=D;E=_n(z|0,E|0,1)|0;E=_m(E&-2|0,D&1|0,u|0,0)|0;E=Jp(F|0,H|0,E|0,D|0)|0;H=D;F=q+3072+(K+112<<3)|0;z=E^c[F>>2];F=H^c[F+4>>2];v=q+3072+(K+80<<3)|0;x=c[v>>2]|0;v=c[v+4>>2]|0;h=Jp(F|0,z|0,x|0,v|0)|0;I=D;v=_n(x|0,v|0,1)|0;v=_m(F|0,0,v&-2|0,D&1|0)|0;v=Jp(h|0,I|0,v|0,D|0)|0;I=D;h=bo(v^u|0,I^B|0,24)|0;x=D;B=_n(v^u|0,I^B|0,40)|0;x=D|x;u=Jp(B|h|0,x|0,E|0,H|0)|0;y=D;H=_n(E|0,H|0,1)|0;H=_m(h|0,0,H&-2|0,D&1|0)|0;H=Jp(u|0,y|0,H|0,D|0)|0;y=D;u=q+3072+(K+16<<3)|0;c[u>>2]=H;c[u+4>>2]=y;u=bo(H^F|0,y^z|0,16)|0;E=D;z=_n(H^F|0,y^z|0,48)|0;E=D|E;y=q+3072+(K+112<<3)|0;c[y>>2]=z|u;c[y+4>>2]=E;E=Jp(z|u|0,E|0,v|0,I|0)|0;z=D;I=_n(v|0,I|0,1)|0;I=_m(u|0,0,I&-2|0,D&1|0)|0;I=Jp(E|0,z|0,I|0,D|0)|0;z=D;E=bo(I^(B|h)|0,z^x|0,63)|0;u=D;x=_n(I^(B|h)|0,z^x|0,1)|0;h=q+3072+(K+48<<3)|0;c[h>>2]=x|E;c[h+4>>2]=D|u;h=q+3072+(K+17<<3)|0;u=c[h>>2]|0;h=c[h+4>>2]|0;E=q+3072+(K+49<<3)|0;x=c[E>>2]|0;E=c[E+4>>2]|0;B=Jp(x|0,E|0,u|0,h|0)|0;v=D;h=_n(u|0,h|0,1)|0;h=_m(h&-2|0,D&1|0,x|0,0)|0;h=Jp(B|0,v|0,h|0,D|0)|0;v=D;B=q+3072+(K+113<<3)|0;u=h^c[B>>2];B=v^c[B+4>>2];y=q+3072+(K+81<<3)|0;F=c[y>>2]|0;y=c[y+4>>2]|0;H=Jp(B|0,u|0,F|0,y|0)|0;A=D;y=_n(F|0,y|0,1)|0;y=_m(B|0,0,y&-2|0,D&1|0)|0;y=Jp(H|0,A|0,y|0,D|0)|0;A=D;H=bo(y^x|0,A^E|0,24)|0;F=D;E=_n(y^x|0,A^E|0,40)|0;F=D|F;x=Jp(E|H|0,F|0,h|0,v|0)|0;G=D;v=_n(h|0,v|0,1)|0;v=_m(H|0,0,v&-2|0,D&1|0)|0;v=Jp(x|0,G|0,v|0,D|0)|0;G=D;x=q+3072+(K+17<<3)|0;c[x>>2]=v;c[x+4>>2]=G;x=bo(v^B|0,G^u|0,16)|0;h=D;u=_n(v^B|0,G^u|0,48)|0;h=D|h;G=Jp(u|x|0,h|0,y|0,A|0)|0;B=D;A=_n(y|0,A|0,1)|0;A=_m(x|0,0,A&-2|0,D&1|0)|0;A=Jp(G|0,B|0,A|0,D|0)|0;B=D;G=bo(A^(E|H)|0,B^F|0,63)|0;y=D;F=_n(A^(E|H)|0,B^F|0,1)|0;y=D|y;H=q+3072+(K+49<<3)|0;c[H>>2]=F|G;c[H+4>>2]=y;H=c[q+3072+(K<<3)>>2]|0;E=c[q+3072+(K<<3)+4>>2]|0;v=q+3072+(K+33<<3)|0;C=c[v>>2]|0;v=c[v+4>>2]|0;w=Jp(C|0,v|0,H|0,E|0)|0;s=D;E=_n(H|0,E|0,1)|0;E=_m(E&-2|0,D&1|0,C|0,0)|0;E=Jp(w|0,s|0,E|0,D|0)|0;s=D;w=Jp(h^s|0,(u|x)^E|0,I|0,z|0)|0;H=D;z=_n(I|0,z|0,1)|0;z=_m(h^s|0,0,z&-2|0,D&1|0)|0;z=Jp(w|0,H|0,z|0,D|0)|0;H=D;w=bo(z^C|0,H^v|0,24)|0;I=D;v=_n(z^C|0,H^v|0,40)|0;I=D|I;C=Jp(v|w|0,I|0,E|0,s|0)|0;t=D;g=_n(E|0,s|0,1)|0;g=_m(w|0,0,g&-2|0,D&1|0)|0;g=Jp(C|0,t|0,g|0,D|0)|0;t=D;c[q+3072+(K<<3)>>2]=g;c[q+3072+(K<<3)+4>>2]=t;C=bo(g^(h^s)|0,t^((u|x)^E)|0,16)|0;J=D;E=_n(g^(h^s)|0,t^((u|x)^E)|0,48)|0;J=D|J;x=q+3072+(K+113<<3)|0;c[x>>2]=E|C;c[x+4>>2]=J;J=Jp(E|C|0,J|0,z|0,H|0)|0;E=D;H=_n(z|0,H|0,1)|0;H=_m(C|0,0,H&-2|0,D&1|0)|0;H=Jp(J|0,E|0,H|0,D|0)|0;E=D;J=q+3072+(K+80<<3)|0;c[J>>2]=H;c[J+4>>2]=E;J=bo(H^(v|w)|0,E^I|0,63)|0;C=D;I=_n(H^(v|w)|0,E^I|0,1)|0;E=q+3072+(K+33<<3)|0;c[E>>2]=I|J;c[E+4>>2]=D|C;E=c[q+3072+((K|1)<<3)>>2]|0;C=c[q+3072+((K|1)<<3)+4>>2]|0;J=q+3072+(K+48<<3)|0;I=c[J>>2]|0;J=c[J+4>>2]|0;w=Jp(I|0,J|0,E|0,C|0)|0;v=D;C=_n(E|0,C|0,1)|0;C=_m(C&-2|0,D&1|0,I|0,0)|0;C=Jp(w|0,v|0,C|0,D|0)|0;v=D;w=q+3072+(K+96<<3)|0;E=C^c[w>>2];w=v^c[w+4>>2];H=Jp(w|0,E|0,A|0,B|0)|0;z=D;B=_n(A|0,B|0,1)|0;B=_m(B&-2|0,D&1|0,w|0,0)|0;B=Jp(H|0,z|0,B|0,D|0)|0;z=D;H=bo(B^I|0,z^J|0,24)|0;A=D;J=_n(B^I|0,z^J|0,40)|0;A=D|A;I=Jp(J|H|0,A|0,C|0,v|0)|0;x=D;v=_n(C|0,v|0,1)|0;v=_m(H|0,0,v&-2|0,D&1|0)|0;v=Jp(I|0,x|0,v|0,D|0)|0;x=D;c[q+3072+((K|1)<<3)>>2]=v;c[q+3072+((K|1)<<3)+4>>2]=x;I=bo(v^w|0,x^E|0,16)|0;C=D;E=_n(v^w|0,x^E|0,48)|0;C=D|C;x=q+3072+(K+96<<3)|0;c[x>>2]=E|I;c[x+4>>2]=C;C=Jp(E|I|0,C|0,B|0,z|0)|0;E=D;z=_n(B|0,z|0,1)|0;z=_m(I|0,0,z&-2|0,D&1|0)|0;z=Jp(C|0,E|0,z|0,D|0)|0;E=D;C=q+3072+(K+81<<3)|0;c[C>>2]=z;c[C+4>>2]=E;C=bo(z^(J|H)|0,E^A|0,63)|0;I=D;A=_n(z^(J|H)|0,E^A|0,1)|0;E=q+3072+(K+48<<3)|0;c[E>>2]=A|C;c[E+4>>2]=D|I;E=q+3072+(K+16<<3)|0;I=c[E>>2]|0;E=c[E+4>>2]|0;C=Jp(F|G|0,y|0,I|0,E|0)|0;A=D;E=_n(I|0,E|0,1)|0;E=_m(E&-2|0,D&1|0,F|G|0,0)|0;E=Jp(C|0,A|0,E|0,D|0)|0;A=D;C=q+3072+(K+97<<3)|0;I=E^c[C>>2];C=A^c[C+4>>2];H=q+3072+(K+64<<3)|0;J=c[H>>2]|0;H=c[H+4>>2]|0;z=Jp(C|0,I|0,J|0,H|0)|0;B=D;H=_n(J|0,H|0,1)|0;H=_m(C|0,0,H&-2|0,D&1|0)|0;H=Jp(z|0,B|0,H|0,D|0)|0;B=D;z=bo(H^(F|G)|0,B^y|0,24)|0;J=D;y=_n(H^(F|G)|0,B^y|0,40)|0;J=D|J;G=Jp(y|z|0,J|0,E|0,A|0)|0;F=D;A=_n(E|0,A|0,1)|0;A=_m(z|0,0,A&-2|0,D&1|0)|0;A=Jp(G|0,F|0,A|0,D|0)|0;F=D;G=q+3072+(K+16<<3)|0;c[G>>2]=A;c[G+4>>2]=F;G=bo(A^C|0,F^I|0,16)|0;E=D;I=_n(A^C|0,F^I|0,48)|0;E=D|E;F=q+3072+(K+97<<3)|0;c[F>>2]=I|G;c[F+4>>2]=E;E=Jp(I|G|0,E|0,H|0,B|0)|0;I=D;B=_n(H|0,B|0,1)|0;B=_m(G|0,0,B&-2|0,D&1|0)|0;B=Jp(E|0,I|0,B|0,D|0)|0;I=D;E=q+3072+(K+64<<3)|0;c[E>>2]=B;c[E+4>>2]=I;E=bo(B^(y|z)|0,I^J|0,63)|0;G=D;J=_n(B^(y|z)|0,I^J|0,1)|0;I=q+3072+(K+49<<3)|0;c[I>>2]=J|E;c[I+4>>2]=D|G;I=q+3072+(K+17<<3)|0;G=c[I>>2]|0;I=c[I+4>>2]|0;E=q+3072+(K+32<<3)|0;J=c[E>>2]|0;E=c[E+4>>2]|0;z=Jp(J|0,E|0,G|0,I|0)|0;y=D;I=_n(G|0,I|0,1)|0;I=_m(I&-2|0,D&1|0,J|0,0)|0;I=Jp(z|0,y|0,I|0,D|0)|0;y=D;z=q+3072+(K+112<<3)|0;G=I^c[z>>2];z=y^c[z+4>>2];B=q+3072+(K+65<<3)|0;H=c[B>>2]|0;B=c[B+4>>2]|0;F=Jp(z|0,G|0,H|0,B|0)|0;C=D;B=_n(H|0,B|0,1)|0;B=_m(z|0,0,B&-2|0,D&1|0)|0;B=Jp(F|0,C|0,B|0,D|0)|0;C=D;F=bo(B^J|0,C^E|0,24)|0;H=D;E=_n(B^J|0,C^E|0,40)|0;H=D|H;J=Jp(E|F|0,H|0,I|0,y|0)|0;A=D;y=_n(I|0,y|0,1)|0;y=_m(F|0,0,y&-2|0,D&1|0)|0;y=Jp(J|0,A|0,y|0,D|0)|0;A=D;J=q+3072+(K+17<<3)|0;c[J>>2]=y;c[J+4>>2]=A;J=bo(y^z|0,A^G|0,16)|0;I=D;G=_n(y^z|0,A^G|0,48)|0;I=D|I;A=q+3072+(K+112<<3)|0;c[A>>2]=G|J;c[A+4>>2]=I;I=Jp(G|J|0,I|0,B|0,C|0)|0;G=D;C=_n(B|0,C|0,1)|0;C=_m(J|0,0,C&-2|0,D&1|0)|0;C=Jp(I|0,G|0,C|0,D|0)|0;G=D;I=q+3072+(K+65<<3)|0;c[I>>2]=C;c[I+4>>2]=G;I=bo(C^(E|F)|0,G^H|0,63)|0;J=D;H=_n(C^(E|F)|0,G^H|0,1)|0;K=q+3072+(K+32<<3)|0;c[K>>2]=H|I;c[K+4>>2]=D|J;e=e+1|0}while((e|0)!=8);vt(j,q+2048|0);fl(j,q+3072|0)}else bc(h+(k<<10)|0,h+(e<<10)+(g<<10)|0,j);e=f+1|0;if(e>>>0>=(c[b+12>>2]|0)>>>0)break;j=c[b+16>>2]|0;l=l+1|0;f=e;e=k+1|0}c[d+12>>2]=f}nc(o);e=0}}else e=0;i=r;return e|0}function bc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=i=i+63&-64;i=i+2048|0;vt(f+1024|0,b);fl(f+1024|0,a);vt(f,f+1024|0);fl(f,d);a=0;do{b=a<<4;o=c[f+1024+(b<<3)>>2]|0;x=c[f+1024+(b<<3)+4>>2]|0;n=c[f+1024+((b|4)<<3)>>2]|0;l=c[f+1024+((b|4)<<3)+4>>2]|0;g=Jp(n|0,l|0,o|0,x|0)|0;v=D;x=_n(o|0,x|0,1)|0;x=_m(x&-2|0,D&1|0,n|0,0)|0;x=Jp(g|0,v|0,x|0,D|0)|0;v=D;g=x^c[f+1024+((b|12)<<3)>>2];o=v^c[f+1024+((b|12)<<3)+4>>2];r=c[f+1024+((b|8)<<3)>>2]|0;t=c[f+1024+((b|8)<<3)+4>>2]|0;s=Jp(o|0,g|0,r|0,t|0)|0;j=D;t=_n(r|0,t|0,1)|0;t=_m(t&-2|0,D&1|0,o|0,0)|0;t=Jp(s|0,j|0,t|0,D|0)|0;j=D;s=bo(t^n|0,j^l|0,24)|0;r=D;l=_n(t^n|0,j^l|0,40)|0;r=D|r;n=Jp(l|s|0,r|0,x|0,v|0)|0;k=D;v=_n(x|0,v|0,1)|0;v=_m(s|0,0,v&-2|0,D&1|0)|0;v=Jp(n|0,k|0,v|0,D|0)|0;k=D;c[f+1024+(b<<3)>>2]=v;c[f+1024+(b<<3)+4>>2]=k;n=bo(v^o|0,k^g|0,16)|0;x=D;g=_n(v^o|0,k^g|0,48)|0;x=D|x;c[f+1024+((b|12)<<3)>>2]=g|n;c[f+1024+((b|12)<<3)+4>>2]=x;x=Jp(g|n|0,x|0,t|0,j|0)|0;g=D;j=_n(t|0,j|0,1)|0;j=_m(n|0,0,j&-2|0,D&1|0)|0;j=Jp(x|0,g|0,j|0,D|0)|0;g=D;c[f+1024+((b|8)<<3)>>2]=j;c[f+1024+((b|8)<<3)+4>>2]=g;x=bo(j^(l|s)|0,g^r|0,63)|0;n=D;r=_n(j^(l|s)|0,g^r|0,1)|0;c[f+1024+((b|4)<<3)>>2]=r|x;c[f+1024+((b|4)<<3)+4>>2]=D|n;n=c[f+1024+((b|1)<<3)>>2]|0;x=c[f+1024+((b|1)<<3)+4>>2]|0;r=c[f+1024+((b|5)<<3)>>2]|0;g=c[f+1024+((b|5)<<3)+4>>2]|0;s=Jp(r|0,g|0,n|0,x|0)|0;l=D;x=_n(n|0,x|0,1)|0;x=_m(x&-2|0,D&1|0,r|0,0)|0;x=Jp(s|0,l|0,x|0,D|0)|0;l=D;s=x^c[f+1024+((b|13)<<3)>>2];n=l^c[f+1024+((b|13)<<3)+4>>2];j=c[f+1024+((b|9)<<3)>>2]|0;t=c[f+1024+((b|9)<<3)+4>>2]|0;k=Jp(n|0,s|0,j|0,t|0)|0;o=D;t=_n(j|0,t|0,1)|0;t=_m(t&-2|0,D&1|0,n|0,0)|0;t=Jp(k|0,o|0,t|0,D|0)|0;o=D;k=bo(t^r|0,o^g|0,24)|0;j=D;g=_n(t^r|0,o^g|0,40)|0;j=D|j;r=Jp(g|k|0,j|0,x|0,l|0)|0;v=D;l=_n(x|0,l|0,1)|0;l=_m(k|0,0,l&-2|0,D&1|0)|0;l=Jp(r|0,v|0,l|0,D|0)|0;v=D;c[f+1024+((b|1)<<3)>>2]=l;c[f+1024+((b|1)<<3)+4>>2]=v;r=bo(l^n|0,v^s|0,16)|0;x=D;s=_n(l^n|0,v^s|0,48)|0;x=D|x;c[f+1024+((b|13)<<3)>>2]=s|r;c[f+1024+((b|13)<<3)+4>>2]=x;x=Jp(s|r|0,x|0,t|0,o|0)|0;s=D;o=_n(t|0,o|0,1)|0;o=_m(r|0,0,o&-2|0,D&1|0)|0;o=Jp(x|0,s|0,o|0,D|0)|0;s=D;c[f+1024+((b|9)<<3)>>2]=o;c[f+1024+((b|9)<<3)+4>>2]=s;x=bo(o^(g|k)|0,s^j|0,63)|0;r=D;j=_n(o^(g|k)|0,s^j|0,1)|0;c[f+1024+((b|5)<<3)>>2]=j|x;c[f+1024+((b|5)<<3)+4>>2]=D|r;r=c[f+1024+((b|2)<<3)>>2]|0;x=c[f+1024+((b|2)<<3)+4>>2]|0;j=c[f+1024+((b|6)<<3)>>2]|0;s=c[f+1024+((b|6)<<3)+4>>2]|0;k=Jp(j|0,s|0,r|0,x|0)|0;g=D;x=_n(r|0,x|0,1)|0;x=_m(x&-2|0,D&1|0,j|0,0)|0;x=Jp(k|0,g|0,x|0,D|0)|0;g=D;k=x^c[f+1024+((b|14)<<3)>>2];r=g^c[f+1024+((b|14)<<3)+4>>2];o=c[f+1024+((b|10)<<3)>>2]|0;t=c[f+1024+((b|10)<<3)+4>>2]|0;v=Jp(r|0,k|0,o|0,t|0)|0;n=D;t=_n(o|0,t|0,1)|0;t=_m(t&-2|0,D&1|0,r|0,0)|0;t=Jp(v|0,n|0,t|0,D|0)|0;n=D;v=bo(t^j|0,n^s|0,24)|0;o=D;s=_n(t^j|0,n^s|0,40)|0;o=D|o;j=Jp(s|v|0,o|0,x|0,g|0)|0;l=D;g=_n(x|0,g|0,1)|0;g=_m(v|0,0,g&-2|0,D&1|0)|0;g=Jp(j|0,l|0,g|0,D|0)|0;l=D;c[f+1024+((b|2)<<3)>>2]=g;c[f+1024+((b|2)<<3)+4>>2]=l;j=bo(g^r|0,l^k|0,16)|0;x=D;k=_n(g^r|0,l^k|0,48)|0;x=D|x;c[f+1024+((b|14)<<3)>>2]=k|j;c[f+1024+((b|14)<<3)+4>>2]=x;x=Jp(k|j|0,x|0,t|0,n|0)|0;k=D;n=_n(t|0,n|0,1)|0;n=_m(j|0,0,n&-2|0,D&1|0)|0;n=Jp(x|0,k|0,n|0,D|0)|0;k=D;x=bo(n^(s|v)|0,k^o|0,63)|0;j=D;o=_n(n^(s|v)|0,k^o|0,1)|0;c[f+1024+((b|6)<<3)>>2]=o|x;c[f+1024+((b|6)<<3)+4>>2]=D|j;j=c[f+1024+((b|3)<<3)>>2]|0;x=c[f+1024+((b|3)<<3)+4>>2]|0;o=c[f+1024+((b|7)<<3)>>2]|0;v=c[f+1024+((b|7)<<3)+4>>2]|0;s=Jp(o|0,v|0,j|0,x|0)|0;t=D;x=_n(j|0,x|0,1)|0;x=_m(x&-2|0,D&1|0,o|0,0)|0;x=Jp(s|0,t|0,x|0,D|0)|0;t=D;s=x^c[f+1024+((b|15)<<3)>>2];j=t^c[f+1024+((b|15)<<3)+4>>2];l=c[f+1024+((b|11)<<3)>>2]|0;r=c[f+1024+((b|11)<<3)+4>>2]|0;g=Jp(j|0,s|0,l|0,r|0)|0;m=D;r=_n(l|0,r|0,1)|0;r=_m(r&-2|0,D&1|0,j|0,0)|0;r=Jp(g|0,m|0,r|0,D|0)|0;m=D;g=bo(r^o|0,m^v|0,24)|0;l=D;v=_n(r^o|0,m^v|0,40)|0;l=D|l;o=Jp(v|g|0,l|0,x|0,t|0)|0;q=D;t=_n(x|0,t|0,1)|0;t=_m(g|0,0,t&-2|0,D&1|0)|0;t=Jp(o|0,q|0,t|0,D|0)|0;q=D;c[f+1024+((b|3)<<3)>>2]=t;c[f+1024+((b|3)<<3)+4>>2]=q;o=bo(t^j|0,q^s|0,16)|0;x=D;s=_n(t^j|0,q^s|0,48)|0;x=D|x;q=Jp(s|o|0,x|0,r|0,m|0)|0;j=D;m=_n(r|0,m|0,1)|0;m=_m(o|0,0,m&-2|0,D&1|0)|0;m=Jp(q|0,j|0,m|0,D|0)|0;j=D;q=bo(m^(v|g)|0,j^l|0,63)|0;r=D;l=_n(m^(v|g)|0,j^l|0,1)|0;r=D|r;c[f+1024+((b|7)<<3)>>2]=l|q;c[f+1024+((b|7)<<3)+4>>2]=r;g=c[f+1024+(b<<3)>>2]|0;v=c[f+1024+(b<<3)+4>>2]|0;t=c[f+1024+((b|5)<<3)>>2]|0;u=c[f+1024+((b|5)<<3)+4>>2]|0;p=Jp(t|0,u|0,g|0,v|0)|0;y=D;v=_n(g|0,v|0,1)|0;v=_m(v&-2|0,D&1|0,t|0,0)|0;v=Jp(p|0,y|0,v|0,D|0)|0;y=D;p=Jp(y^x|0,v^(s|o)|0,n|0,k|0)|0;g=D;k=_n(n|0,k|0,1)|0;k=_m(k&-2|0,D&1|0,y^x|0,0)|0;k=Jp(p|0,g|0,k|0,D|0)|0;g=D;p=bo(k^t|0,g^u|0,24)|0;n=D;u=_n(k^t|0,g^u|0,40)|0;n=D|n;t=Jp(u|p|0,n|0,v|0,y|0)|0;w=D;z=_n(v|0,y|0,1)|0;z=_m(p|0,0,z&-2|0,D&1|0)|0;z=Jp(t|0,w|0,z|0,D|0)|0;w=D;c[f+1024+(b<<3)>>2]=z;c[f+1024+(b<<3)+4>>2]=w;t=bo(z^(y^x)|0,w^(v^(s|o))|0,16)|0;h=D;o=_n(z^(y^x)|0,w^(v^(s|o))|0,48)|0;h=D|h;c[f+1024+((b|15)<<3)>>2]=o|t;c[f+1024+((b|15)<<3)+4>>2]=h;h=Jp(o|t|0,h|0,k|0,g|0)|0;o=D;g=_n(k|0,g|0,1)|0;g=_m(t|0,0,g&-2|0,D&1|0)|0;g=Jp(h|0,o|0,g|0,D|0)|0;o=D;c[f+1024+((b|10)<<3)>>2]=g;c[f+1024+((b|10)<<3)+4>>2]=o;h=bo(g^(u|p)|0,o^n|0,63)|0;t=D;n=_n(g^(u|p)|0,o^n|0,1)|0;c[f+1024+((b|5)<<3)>>2]=n|h;c[f+1024+((b|5)<<3)+4>>2]=D|t;t=c[f+1024+((b|1)<<3)>>2]|0;h=c[f+1024+((b|1)<<3)+4>>2]|0;n=c[f+1024+((b|6)<<3)>>2]|0;o=c[f+1024+((b|6)<<3)+4>>2]|0;p=Jp(n|0,o|0,t|0,h|0)|0;u=D;h=_n(t|0,h|0,1)|0;h=_m(h&-2|0,D&1|0,n|0,0)|0;h=Jp(p|0,u|0,h|0,D|0)|0;u=D;p=h^c[f+1024+((b|12)<<3)>>2];t=u^c[f+1024+((b|12)<<3)+4>>2];g=Jp(t|0,p|0,m|0,j|0)|0;k=D;j=_n(m|0,j|0,1)|0;j=_m(j&-2|0,D&1|0,t|0,0)|0;j=Jp(g|0,k|0,j|0,D|0)|0;k=D;g=bo(j^n|0,k^o|0,24)|0;m=D;o=_n(j^n|0,k^o|0,40)|0;m=D|m;n=Jp(o|g|0,m|0,h|0,u|0)|0;s=D;u=_n(h|0,u|0,1)|0;u=_m(g|0,0,u&-2|0,D&1|0)|0;u=Jp(n|0,s|0,u|0,D|0)|0;s=D;c[f+1024+((b|1)<<3)>>2]=u;c[f+1024+((b|1)<<3)+4>>2]=s;n=bo(u^t|0,s^p|0,16)|0;h=D;p=_n(u^t|0,s^p|0,48)|0;h=D|h;c[f+1024+((b|12)<<3)>>2]=p|n;c[f+1024+((b|12)<<3)+4>>2]=h;h=Jp(p|n|0,h|0,j|0,k|0)|0;p=D;k=_n(j|0,k|0,1)|0;k=_m(n|0,0,k&-2|0,D&1|0)|0;k=Jp(h|0,p|0,k|0,D|0)|0;p=D;c[f+1024+((b|11)<<3)>>2]=k;c[f+1024+((b|11)<<3)+4>>2]=p;h=bo(k^(o|g)|0,p^m|0,63)|0;n=D;m=_n(k^(o|g)|0,p^m|0,1)|0;c[f+1024+((b|6)<<3)>>2]=m|h;c[f+1024+((b|6)<<3)+4>>2]=D|n;n=c[f+1024+((b|2)<<3)>>2]|0;h=c[f+1024+((b|2)<<3)+4>>2]|0;m=Jp(l|q|0,r|0,n|0,h|0)|0;p=D;h=_n(n|0,h|0,1)|0;h=_m(h&-2|0,D&1|0,l|q|0,0)|0;h=Jp(m|0,p|0,h|0,D|0)|0;p=D;m=h^c[f+1024+((b|13)<<3)>>2];n=p^c[f+1024+((b|13)<<3)+4>>2];g=c[f+1024+((b|8)<<3)>>2]|0;o=c[f+1024+((b|8)<<3)+4>>2]|0;k=Jp(n|0,m|0,g|0,o|0)|0;j=D;o=_n(g|0,o|0,1)|0;o=_m(o&-2|0,D&1|0,n|0,0)|0;o=Jp(k|0,j|0,o|0,D|0)|0;j=D;k=bo(o^(l|q)|0,j^r|0,24)|0;g=D;r=_n(o^(l|q)|0,j^r|0,40)|0;g=D|g;q=Jp(r|k|0,g|0,h|0,p|0)|0;l=D;p=_n(h|0,p|0,1)|0;p=_m(k|0,0,p&-2|0,D&1|0)|0;p=Jp(q|0,l|0,p|0,D|0)|0;l=D;c[f+1024+((b|2)<<3)>>2]=p;c[f+1024+((b|2)<<3)+4>>2]=l;q=bo(p^n|0,l^m|0,16)|0;h=D;m=_n(p^n|0,l^m|0,48)|0;h=D|h;c[f+1024+((b|13)<<3)>>2]=m|q;c[f+1024+((b|13)<<3)+4>>2]=h;h=Jp(m|q|0,h|0,o|0,j|0)|0;m=D;j=_n(o|0,j|0,1)|0;j=_m(q|0,0,j&-2|0,D&1|0)|0;j=Jp(h|0,m|0,j|0,D|0)|0;m=D;c[f+1024+((b|8)<<3)>>2]=j;c[f+1024+((b|8)<<3)+4>>2]=m;h=bo(j^(r|k)|0,m^g|0,63)|0;q=D;g=_n(j^(r|k)|0,m^g|0,1)|0;c[f+1024+((b|7)<<3)>>2]=g|h;c[f+1024+((b|7)<<3)+4>>2]=D|q;q=c[f+1024+((b|3)<<3)>>2]|0;h=c[f+1024+((b|3)<<3)+4>>2]|0;g=c[f+1024+((b|4)<<3)>>2]|0;m=c[f+1024+((b|4)<<3)+4>>2]|0;k=Jp(g|0,m|0,q|0,h|0)|0;r=D;h=_n(q|0,h|0,1)|0;h=_m(h&-2|0,D&1|0,g|0,0)|0;h=Jp(k|0,r|0,h|0,D|0)|0;r=D;k=h^c[f+1024+((b|14)<<3)>>2];q=r^c[f+1024+((b|14)<<3)+4>>2];j=c[f+1024+((b|9)<<3)>>2]|0;o=c[f+1024+((b|9)<<3)+4>>2]|0;l=Jp(q|0,k|0,j|0,o|0)|0;n=D;o=_n(j|0,o|0,1)|0;o=_m(o&-2|0,D&1|0,q|0,0)|0;o=Jp(l|0,n|0,o|0,D|0)|0;n=D;l=bo(o^g|0,n^m|0,24)|0;j=D;m=_n(o^g|0,n^m|0,40)|0;j=D|j;g=Jp(m|l|0,j|0,h|0,r|0)|0;p=D;r=_n(h|0,r|0,1)|0;r=_m(l|0,0,r&-2|0,D&1|0)|0;r=Jp(g|0,p|0,r|0,D|0)|0;p=D;c[f+1024+((b|3)<<3)>>2]=r;c[f+1024+((b|3)<<3)+4>>2]=p;g=bo(r^q|0,p^k|0,16)|0;h=D;k=_n(r^q|0,p^k|0,48)|0;h=D|h;c[f+1024+((b|14)<<3)>>2]=k|g;c[f+1024+((b|14)<<3)+4>>2]=h;h=Jp(k|g|0,h|0,o|0,n|0)|0;k=D;n=_n(o|0,n|0,1)|0;n=_m(g|0,0,n&-2|0,D&1|0)|0;n=Jp(h|0,k|0,n|0,D|0)|0;k=D;c[f+1024+((b|9)<<3)>>2]=n;c[f+1024+((b|9)<<3)+4>>2]=k;h=bo(n^(m|l)|0,k^j|0,63)|0;g=D;j=_n(n^(m|l)|0,k^j|0,1)|0;c[f+1024+((b|4)<<3)>>2]=j|h;c[f+1024+((b|4)<<3)+4>>2]=D|g;a=a+1|0}while((a|0)!=8);a=0;do{z=a<<1;k=c[f+1024+(z<<3)>>2]|0;w=c[f+1024+(z<<3)+4>>2]|0;o=f+1024+(z+32<<3)|0;r=c[o>>2]|0;o=c[o+4>>2]|0;l=Jp(r|0,o|0,k|0,w|0)|0;h=D;w=_n(k|0,w|0,1)|0;w=_m(w&-2|0,D&1|0,r|0,0)|0;w=Jp(l|0,h|0,w|0,D|0)|0;h=D;l=f+1024+(z+96<<3)|0;k=w^c[l>>2];l=h^c[l+4>>2];n=f+1024+(z+64<<3)|0;p=c[n>>2]|0;n=c[n+4>>2]|0;x=Jp(l|0,k|0,p|0,n|0)|0;t=D;n=_n(p|0,n|0,1)|0;n=_m(n&-2|0,D&1|0,l|0,0)|0;n=Jp(x|0,t|0,n|0,D|0)|0;t=D;x=bo(n^r|0,t^o|0,24)|0;p=D;o=_n(n^r|0,t^o|0,40)|0;p=D|p;r=Jp(o|x|0,p|0,w|0,h|0)|0;u=D;h=_n(w|0,h|0,1)|0;h=_m(x|0,0,h&-2|0,D&1|0)|0;h=Jp(r|0,u|0,h|0,D|0)|0;u=D;c[f+1024+(z<<3)>>2]=h;c[f+1024+(z<<3)+4>>2]=u;r=bo(h^l|0,u^k|0,16)|0;w=D;k=_n(h^l|0,u^k|0,48)|0;w=D|w;u=f+1024+(z+96<<3)|0;c[u>>2]=k|r;c[u+4>>2]=w;w=Jp(k|r|0,w|0,n|0,t|0)|0;k=D;t=_n(n|0,t|0,1)|0;t=_m(r|0,0,t&-2|0,D&1|0)|0;t=Jp(w|0,k|0,t|0,D|0)|0;k=D;w=f+1024+(z+64<<3)|0;c[w>>2]=t;c[w+4>>2]=k;w=bo(t^(o|x)|0,k^p|0,63)|0;r=D;p=_n(t^(o|x)|0,k^p|0,1)|0;k=f+1024+(z+32<<3)|0;c[k>>2]=p|w;c[k+4>>2]=D|r;k=c[f+1024+((z|1)<<3)>>2]|0;r=c[f+1024+((z|1)<<3)+4>>2]|0;w=f+1024+(z+33<<3)|0;p=c[w>>2]|0;w=c[w+4>>2]|0;x=Jp(p|0,w|0,k|0,r|0)|0;o=D;r=_n(k|0,r|0,1)|0;r=_m(r&-2|0,D&1|0,p|0,0)|0;r=Jp(x|0,o|0,r|0,D|0)|0;o=D;x=f+1024+(z+97<<3)|0;k=r^c[x>>2];x=o^c[x+4>>2];t=f+1024+(z+65<<3)|0;n=c[t>>2]|0;t=c[t+4>>2]|0;u=Jp(x|0,k|0,n|0,t|0)|0;l=D;t=_n(n|0,t|0,1)|0;t=_m(t&-2|0,D&1|0,x|0,0)|0;t=Jp(u|0,l|0,t|0,D|0)|0;l=D;u=bo(t^p|0,l^w|0,24)|0;n=D;w=_n(t^p|0,l^w|0,40)|0;n=D|n;p=Jp(w|u|0,n|0,r|0,o|0)|0;h=D;o=_n(r|0,o|0,1)|0;o=_m(u|0,0,o&-2|0,D&1|0)|0;o=Jp(p|0,h|0,o|0,D|0)|0;h=D;c[f+1024+((z|1)<<3)>>2]=o;c[f+1024+((z|1)<<3)+4>>2]=h;p=bo(o^x|0,h^k|0,16)|0;r=D;k=_n(o^x|0,h^k|0,48)|0;r=D|r;h=f+1024+(z+97<<3)|0;c[h>>2]=k|p;c[h+4>>2]=r;r=Jp(k|p|0,r|0,t|0,l|0)|0;k=D;l=_n(t|0,l|0,1)|0;l=_m(p|0,0,l&-2|0,D&1|0)|0;l=Jp(r|0,k|0,l|0,D|0)|0;k=D;r=f+1024+(z+65<<3)|0;c[r>>2]=l;c[r+4>>2]=k;r=bo(l^(w|u)|0,k^n|0,63)|0;p=D;n=_n(l^(w|u)|0,k^n|0,1)|0;k=f+1024+(z+33<<3)|0;c[k>>2]=n|r;c[k+4>>2]=D|p;k=f+1024+(z+16<<3)|0;p=c[k>>2]|0;k=c[k+4>>2]|0;r=f+1024+(z+48<<3)|0;n=c[r>>2]|0;r=c[r+4>>2]|0;u=Jp(n|0,r|0,p|0,k|0)|0;w=D;k=_n(p|0,k|0,1)|0;k=_m(k&-2|0,D&1|0,n|0,0)|0;k=Jp(u|0,w|0,k|0,D|0)|0;w=D;u=f+1024+(z+112<<3)|0;p=k^c[u>>2];u=w^c[u+4>>2];l=f+1024+(z+80<<3)|0;t=c[l>>2]|0;l=c[l+4>>2]|0;h=Jp(u|0,p|0,t|0,l|0)|0;x=D;l=_n(t|0,l|0,1)|0;l=_m(l&-2|0,D&1|0,u|0,0)|0;l=Jp(h|0,x|0,l|0,D|0)|0;x=D;h=bo(l^n|0,x^r|0,24)|0;t=D;r=_n(l^n|0,x^r|0,40)|0;t=D|t;n=Jp(r|h|0,t|0,k|0,w|0)|0;o=D;w=_n(k|0,w|0,1)|0;w=_m(h|0,0,w&-2|0,D&1|0)|0;w=Jp(n|0,o|0,w|0,D|0)|0;o=D;n=f+1024+(z+16<<3)|0;c[n>>2]=w;c[n+4>>2]=o;n=bo(w^u|0,o^p|0,16)|0;k=D;p=_n(w^u|0,o^p|0,48)|0;k=D|k;o=f+1024+(z+112<<3)|0;c[o>>2]=p|n;c[o+4>>2]=k;k=Jp(p|n|0,k|0,l|0,x|0)|0;p=D;x=_n(l|0,x|0,1)|0;x=_m(n|0,0,x&-2|0,D&1|0)|0;x=Jp(k|0,p|0,x|0,D|0)|0;p=D;k=bo(x^(r|h)|0,p^t|0,63)|0;n=D;t=_n(x^(r|h)|0,p^t|0,1)|0;h=f+1024+(z+48<<3)|0;c[h>>2]=t|k;c[h+4>>2]=D|n;h=f+1024+(z+17<<3)|0;n=c[h>>2]|0;h=c[h+4>>2]|0;k=f+1024+(z+49<<3)|0;t=c[k>>2]|0;k=c[k+4>>2]|0;r=Jp(t|0,k|0,n|0,h|0)|0;l=D;h=_n(n|0,h|0,1)|0;h=_m(h&-2|0,D&1|0,t|0,0)|0;h=Jp(r|0,l|0,h|0,D|0)|0;l=D;r=f+1024+(z+113<<3)|0;n=h^c[r>>2];r=l^c[r+4>>2];o=f+1024+(z+81<<3)|0;u=c[o>>2]|0;o=c[o+4>>2]|0;w=Jp(r|0,n|0,u|0,o|0)|0;q=D;o=_n(u|0,o|0,1)|0;o=_m(o&-2|0,D&1|0,r|0,0)|0;o=Jp(w|0,q|0,o|0,D|0)|0;q=D;w=bo(o^t|0,q^k|0,24)|0;u=D;k=_n(o^t|0,q^k|0,40)|0;u=D|u;t=Jp(k|w|0,u|0,h|0,l|0)|0;v=D;l=_n(h|0,l|0,1)|0;l=_m(w|0,0,l&-2|0,D&1|0)|0;l=Jp(t|0,v|0,l|0,D|0)|0;v=D;t=f+1024+(z+17<<3)|0;c[t>>2]=l;c[t+4>>2]=v;t=bo(l^r|0,v^n|0,16)|0;h=D;n=_n(l^r|0,v^n|0,48)|0;h=D|h;v=Jp(n|t|0,h|0,o|0,q|0)|0;r=D;q=_n(o|0,q|0,1)|0;q=_m(t|0,0,q&-2|0,D&1|0)|0;q=Jp(v|0,r|0,q|0,D|0)|0;r=D;v=bo(q^(k|w)|0,r^u|0,63)|0;o=D;u=_n(q^(k|w)|0,r^u|0,1)|0;o=D|o;w=f+1024+(z+49<<3)|0;c[w>>2]=u|v;c[w+4>>2]=o;w=c[f+1024+(z<<3)>>2]|0;k=c[f+1024+(z<<3)+4>>2]|0;l=f+1024+(z+33<<3)|0;s=c[l>>2]|0;l=c[l+4>>2]|0;m=Jp(s|0,l|0,w|0,k|0)|0;g=D;k=_n(w|0,k|0,1)|0;k=_m(k&-2|0,D&1|0,s|0,0)|0;k=Jp(m|0,g|0,k|0,D|0)|0;g=D;m=Jp(g^h|0,k^(n|t)|0,x|0,p|0)|0;w=D;p=_n(x|0,p|0,1)|0;p=_m(p&-2|0,D&1|0,g^h|0,0)|0;p=Jp(m|0,w|0,p|0,D|0)|0;w=D;m=bo(p^s|0,w^l|0,24)|0;x=D;l=_n(p^s|0,w^l|0,40)|0;x=D|x;s=Jp(l|m|0,x|0,k|0,g|0)|0;j=D;b=_n(k|0,g|0,1)|0;b=_m(m|0,0,b&-2|0,D&1|0)|0;b=Jp(s|0,j|0,b|0,D|0)|0;j=D;c[f+1024+(z<<3)>>2]=b;c[f+1024+(z<<3)+4>>2]=j;s=bo(b^(g^h)|0,j^(k^(n|t))|0,16)|0;y=D;t=_n(b^(g^h)|0,j^(k^(n|t))|0,48)|0;y=D|y;n=f+1024+(z+113<<3)|0;c[n>>2]=t|s;c[n+4>>2]=y;y=Jp(t|s|0,y|0,p|0,w|0)|0;t=D;w=_n(p|0,w|0,1)|0;w=_m(s|0,0,w&-2|0,D&1|0)|0;w=Jp(y|0,t|0,w|0,D|0)|0;t=D;y=f+1024+(z+80<<3)|0;c[y>>2]=w;c[y+4>>2]=t;y=bo(w^(l|m)|0,t^x|0,63)|0;s=D;x=_n(w^(l|m)|0,t^x|0,1)|0;t=f+1024+(z+33<<3)|0;c[t>>2]=x|y;c[t+4>>2]=D|s;t=c[f+1024+((z|1)<<3)>>2]|0;s=c[f+1024+((z|1)<<3)+4>>2]|0;y=f+1024+(z+48<<3)|0;x=c[y>>2]|0;y=c[y+4>>2]|0;m=Jp(x|0,y|0,t|0,s|0)|0;l=D;s=_n(t|0,s|0,1)|0;s=_m(s&-2|0,D&1|0,x|0,0)|0;s=Jp(m|0,l|0,s|0,D|0)|0;l=D;m=f+1024+(z+96<<3)|0;t=s^c[m>>2];m=l^c[m+4>>2];w=Jp(m|0,t|0,q|0,r|0)|0;p=D;r=_n(q|0,r|0,1)|0;r=_m(r&-2|0,D&1|0,m|0,0)|0;r=Jp(w|0,p|0,r|0,D|0)|0;p=D;w=bo(r^x|0,p^y|0,24)|0;q=D;y=_n(r^x|0,p^y|0,40)|0;q=D|q;x=Jp(y|w|0,q|0,s|0,l|0)|0;n=D;l=_n(s|0,l|0,1)|0;l=_m(w|0,0,l&-2|0,D&1|0)|0;l=Jp(x|0,n|0,l|0,D|0)|0;n=D;c[f+1024+((z|1)<<3)>>2]=l;c[f+1024+((z|1)<<3)+4>>2]=n;x=bo(l^m|0,n^t|0,16)|0;s=D;t=_n(l^m|0,n^t|0,48)|0;s=D|s;n=f+1024+(z+96<<3)|0;c[n>>2]=t|x;c[n+4>>2]=s;s=Jp(t|x|0,s|0,r|0,p|0)|0;t=D;p=_n(r|0,p|0,1)|0;p=_m(x|0,0,p&-2|0,D&1|0)|0;p=Jp(s|0,t|0,p|0,D|0)|0;t=D;s=f+1024+(z+81<<3)|0;c[s>>2]=p;c[s+4>>2]=t;s=bo(p^(y|w)|0,t^q|0,63)|0;x=D;q=_n(p^(y|w)|0,t^q|0,1)|0;t=f+1024+(z+48<<3)|0;c[t>>2]=q|s;c[t+4>>2]=D|x;t=f+1024+(z+16<<3)|0;x=c[t>>2]|0;t=c[t+4>>2]|0;s=Jp(u|v|0,o|0,x|0,t|0)|0;q=D;t=_n(x|0,t|0,1)|0;t=_m(t&-2|0,D&1|0,u|v|0,0)|0;t=Jp(s|0,q|0,t|0,D|0)|0;q=D;s=f+1024+(z+97<<3)|0;x=t^c[s>>2];s=q^c[s+4>>2];w=f+1024+(z+64<<3)|0;y=c[w>>2]|0;w=c[w+4>>2]|0;p=Jp(s|0,x|0,y|0,w|0)|0;r=D;w=_n(y|0,w|0,1)|0;w=_m(w&-2|0,D&1|0,s|0,0)|0;w=Jp(p|0,r|0,w|0,D|0)|0;r=D;p=bo(w^(u|v)|0,r^o|0,24)|0;y=D;o=_n(w^(u|v)|0,r^o|0,40)|0;y=D|y;v=Jp(o|p|0,y|0,t|0,q|0)|0;u=D;q=_n(t|0,q|0,1)|0;q=_m(p|0,0,q&-2|0,D&1|0)|0;q=Jp(v|0,u|0,q|0,D|0)|0;u=D;v=f+1024+(z+16<<3)|0;c[v>>2]=q;c[v+4>>2]=u;v=bo(q^s|0,u^x|0,16)|0;t=D;x=_n(q^s|0,u^x|0,48)|0;t=D|t;u=f+1024+(z+97<<3)|0;c[u>>2]=x|v;c[u+4>>2]=t;t=Jp(x|v|0,t|0,w|0,r|0)|0;x=D;r=_n(w|0,r|0,1)|0;r=_m(v|0,0,r&-2|0,D&1|0)|0;r=Jp(t|0,x|0,r|0,D|0)|0;x=D;t=f+1024+(z+64<<3)|0;c[t>>2]=r;c[t+4>>2]=x;t=bo(r^(o|p)|0,x^y|0,63)|0;v=D;y=_n(r^(o|p)|0,x^y|0,1)|0;x=f+1024+(z+49<<3)|0;c[x>>2]=y|t;c[x+4>>2]=D|v;x=f+1024+(z+17<<3)|0;v=c[x>>2]|0;x=c[x+4>>2]|0;t=f+1024+(z+32<<3)|0;y=c[t>>2]|0;t=c[t+4>>2]|0;p=Jp(y|0,t|0,v|0,x|0)|0;o=D;x=_n(v|0,x|0,1)|0;x=_m(x&-2|0,D&1|0,y|0,0)|0;x=Jp(p|0,o|0,x|0,D|0)|0;o=D;p=f+1024+(z+112<<3)|0;v=x^c[p>>2];p=o^c[p+4>>2];r=f+1024+(z+65<<3)|0;w=c[r>>2]|0;r=c[r+4>>2]|0;u=Jp(p|0,v|0,w|0,r|0)|0;s=D;r=_n(w|0,r|0,1)|0;r=_m(r&-2|0,D&1|0,p|0,0)|0;r=Jp(u|0,s|0,r|0,D|0)|0;s=D;u=bo(r^y|0,s^t|0,24)|0;w=D;t=_n(r^y|0,s^t|0,40)|0;w=D|w;y=Jp(t|u|0,w|0,x|0,o|0)|0;q=D;o=_n(x|0,o|0,1)|0;o=_m(u|0,0,o&-2|0,D&1|0)|0;o=Jp(y|0,q|0,o|0,D|0)|0;q=D;y=f+1024+(z+17<<3)|0;c[y>>2]=o;c[y+4>>2]=q;y=bo(o^p|0,q^v|0,16)|0;x=D;v=_n(o^p|0,q^v|0,48)|0;x=D|x;q=f+1024+(z+112<<3)|0;c[q>>2]=v|y;c[q+4>>2]=x;x=Jp(v|y|0,x|0,r|0,s|0)|0;v=D;s=_n(r|0,s|0,1)|0;s=_m(y|0,0,s&-2|0,D&1|0)|0;s=Jp(x|0,v|0,s|0,D|0)|0;v=D;x=f+1024+(z+65<<3)|0;c[x>>2]=s;c[x+4>>2]=v;x=bo(s^(t|u)|0,v^w|0,63)|0;y=D;w=_n(s^(t|u)|0,v^w|0,1)|0;z=f+1024+(z+32<<3)|0;c[z>>2]=w|x;c[z+4>>2]=D|y;a=a+1|0}while((a|0)!=8);vt(d,f);fl(d,f+1024|0);i=e;return}function cc(b,e,f,g,h,j,k,l,m,n,p){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=i;D=i=i+63&-64;i=i+512|0;c[D+96>>2]=p;c[D+88>>2]=D+104;c[D+88+4>>2]=140;c[D+80>>2]=D+104;c[D+76>>2]=D+104+400;c[D+56>>2]=0;c[D+56+4>>2]=0;c[D+56+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[D+56+(p<<2)>>2]=0;p=p+1|0}c[D+44>>2]=0;c[D+44+4>>2]=0;c[D+44+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[D+44+(p<<2)>>2]=0;p=p+1|0}c[D+32>>2]=0;c[D+32+4>>2]=0;c[D+32+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[D+32+(p<<2)>>2]=0;p=p+1|0}c[D+20>>2]=0;c[D+20+4>>2]=0;c[D+20+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[D+20+(p<<2)>>2]=0;p=p+1|0}c[D+8>>2]=0;c[D+8+4>>2]=0;c[D+8+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[D+8+(p<<2)>>2]=0;p=p+1|0}o=0;ta(19,f|0,g|0,D+504|0,D+72|0,D+68|0,D+56|0,D+44|0,D+32|0,D+20|0,D+4|0);B=o;o=0;a:do if(B&1)p=Ya()|0;else{c[n>>2]=c[m>>2];x=D+32+8+3|0;y=D+20+8+3|0;z=D+44+8+3|0;v=D+104|0;w=0;B=0;b:while(1){if(w>>>0>=4){A=257;break}p=c[b>>2]|0;do if(p){f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=39;break b}}else p=c[f>>2]|0;if((p|0)==-1){c[b>>2]=0;f=1;break}else{f=(c[b>>2]|0)==0;break}}else f=1;while(0);if(e){p=c[e+12>>2]|0;if((p|0)==(c[e+16>>2]|0)){o=0;p=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;u=o;o=0;if(u&1){A=39;break}}else p=c[p>>2]|0;if((p|0)!=-1){if(!f){A=257;break}}else A=31}else A=31;if((A|0)==31){A=0;if(f){e=0;A=257;break}else e=0}c:do switch(a[D+504+w>>0]|0){case 1:{if((w|0)!=3){p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;A=o;o=0;if(A&1){A=39;break b}}else p=c[f>>2]|0;o=0;p=la(c[(c[l>>2]|0)+12>>2]|0,l|0,8192,p|0)|0;A=o;o=0;if(A&1){A=39;break b}if(!p){A=57;break b}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+40>>2]|0,p|0)|0;A=o;o=0;if(A&1){A=39;break b}}else{c[p+12>>2]=f+4;p=c[f>>2]|0}o=0;da(62,D+8|0,p|0);A=o;o=0;if(A&1){A=39;break b}else{q=e;g=e;A=59}}else{p=v;f=B}break}case 0:{if((w|0)==3){p=v;f=B}else{q=e;g=e;A=59}break}case 3:{f=a[x>>0]|0;p=f<<24>>24<0?c[D+32+4>>2]|0:f&255;g=a[y>>0]|0;q=g<<24>>24<0?c[D+20+4>>2]|0:g&255;if((p|0)==(0-q|0)){p=v;f=B}else{if(!p){p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=39;break b}g=a[y>>0]|0}else p=c[f>>2]|0;if((p|0)!=(c[(g<<24>>24<0?c[D+20>>2]|0:D+20|0)>>2]|0)){p=v;f=B;break c}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;ha(c[(c[p>>2]|0)+40>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=39;break b}f=a[y>>0]|0}else{c[p+12>>2]=f+4;f=g}a[k>>0]=1;p=v;f=(f<<24>>24<0?c[D+20+4>>2]|0:f&255)>>>0>1?D+20|0:B;break c}r=c[b>>2]|0;s=c[r+12>>2]|0;g=c[r+16>>2]|0;if(!q){if((s|0)==(g|0)){o=0;p=ha(c[(c[r>>2]|0)+36>>2]|0,r|0)|0;u=o;o=0;if(u&1){A=39;break b}g=a[x>>0]|0}else{p=c[s>>2]|0;g=f}if((p|0)!=(c[(g<<24>>24<0?c[D+32>>2]|0:D+32|0)>>2]|0)){a[k>>0]=1;p=v;f=B;break c}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;ha(c[(c[p>>2]|0)+40>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=39;break b}f=a[x>>0]|0}else{c[p+12>>2]=f+4;f=g}p=v;f=(f<<24>>24<0?c[D+32+4>>2]|0:f&255)>>>0>1?D+32|0:B;break c}if((s|0)==(g|0)){o=0;p=ha(c[(c[r>>2]|0)+36>>2]|0,r|0)|0;u=o;o=0;if(u&1){A=39;break b}g=c[b>>2]|0;f=a[x>>0]|0;r=g;s=c[g+12>>2]|0;g=c[g+16>>2]|0}else p=c[s>>2]|0;q=r+12|0;g=(s|0)==(g|0);if((p|0)==(c[(f<<24>>24<0?c[D+32>>2]|0:D+32|0)>>2]|0)){if(g){o=0;ha(c[(c[r>>2]|0)+40>>2]|0,r|0)|0;u=o;o=0;if(u&1){A=39;break b}f=a[x>>0]|0}else c[q>>2]=s+4;p=v;f=(f<<24>>24<0?c[D+32+4>>2]|0:f&255)>>>0>1?D+32|0:B;break c}if(g){o=0;p=ha(c[(c[r>>2]|0)+36>>2]|0,r|0)|0;u=o;o=0;if(u&1){A=39;break b}}else p=c[s>>2]|0;g=a[y>>0]|0;if((p|0)!=(c[(g<<24>>24<0?c[D+20>>2]|0:D+20|0)>>2]|0)){A=125;break b}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;ha(c[(c[p>>2]|0)+40>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=39;break b}f=a[y>>0]|0}else{c[p+12>>2]=f+4;f=g}a[k>>0]=1;p=v;f=(f<<24>>24<0?c[D+20+4>>2]|0:f&255)>>>0>1?D+20|0:B}break}case 2:{if(!(w>>>0<2|(B|0)!=0)?!((h&512|0)!=0|(w|0)==2&(a[D+504+3>>0]|0)!=0):0){p=v;f=0;break c}p=a[z>>0]|0;f=c[D+44>>2]|0;q=p<<24>>24<0?f:D+44|0;d:do if((w|0)!=0?(d[D+504+(w+-1)>>0]|0)<2:0){g=f;u=q;while(1){t=p<<24>>24<0;f=u;if((f|0)==((t?g:D+44|0)+((t?c[D+44+4>>2]|0:p&255)<<2)|0)){f=g;break}o=0;p=la(c[(c[l>>2]|0)+12>>2]|0,l|0,8192,c[f>>2]|0)|0;t=o;o=0;if(t&1){A=36;break b}if(!p){A=133;break}p=a[z>>0]|0;g=c[D+44>>2]|0;u=f+4|0}if((A|0)==133){A=0;p=a[z>>0]|0;f=c[D+44>>2]|0}g=p<<24>>24<0?f:D+44|0;t=u-g>>2;q=a[D+8+8+3>>0]|0;r=q<<24>>24<0?c[D+8+4>>2]|0:q&255;if(t>>>0>r>>>0){s=e;r=e}else{s=(q<<24>>24<0?c[D+8>>2]|0:D+8|0)+(r<<2)|0;r=g;q=s+(0-t<<2)|0;while(1){if((q|0)==(s|0)){s=e;r=e;g=u;break d}if((c[q>>2]|0)!=(c[r>>2]|0)){s=e;r=e;break d}r=r+4|0;q=q+4|0}}}else{s=e;r=e;g=q}while(0);while(1){u=p<<24>>24<0;p=(u?f:D+44|0)+((u?c[D+44+4>>2]|0:p&255)<<2)|0;if((g|0)==(p|0))break;p=c[b>>2]|0;do if(p){f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=35;break b}}else p=c[f>>2]|0;if((p|0)==-1){c[b>>2]=0;f=1;break}else{f=(c[b>>2]|0)==0;break}}else f=1;while(0);if(r){p=c[r+12>>2]|0;if((p|0)==(c[r+16>>2]|0)){o=0;p=ha(c[(c[r>>2]|0)+36>>2]|0,r|0)|0;u=o;o=0;if(u&1){A=35;break b}}else p=c[p>>2]|0;if((p|0)!=-1)if(f^(s|0)==0){q=s;r=s}else{p=g;break}else{p=0;e=0;A=153}}else{p=s;A=153}if((A|0)==153){A=0;if(f){p=g;break}else{q=p;r=0}}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=35;break b}}else p=c[f>>2]|0;if((p|0)!=(c[g>>2]|0)){p=g;break}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;ha(c[(c[p>>2]|0)+40>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=35;break b}}else c[p+12>>2]=f+4;s=q;p=a[z>>0]|0;f=c[D+44>>2]|0;g=g+4|0}if(h&512|0?(u=a[z>>0]|0,(p|0)!=((u<<24>>24<0?c[D+44>>2]|0:D+44|0)+((u<<24>>24<0?c[D+44+4>>2]|0:u&255)<<2)|0)):0){A=165;break b}else{p=v;f=B}break}case 4:{u=c[D+68>>2]|0;s=e;q=e;p=v;r=0;while(1){f=c[b>>2]|0;do if(f){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){o=0;f=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=38;break b}}else f=c[g>>2]|0;if((f|0)==-1){c[b>>2]=0;g=1;break}else{g=(c[b>>2]|0)==0;break}}else g=1;while(0);if(q){f=c[q+12>>2]|0;if((f|0)==(c[q+16>>2]|0)){o=0;f=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=38;break b}}else f=c[f>>2]|0;if((f|0)!=-1)if(g^(s|0)==0){f=s;t=s}else break;else{f=0;e=0;A=178}}else{f=s;A=178}if((A|0)==178){A=0;if(g){s=f;break}else t=0}g=c[b>>2]|0;q=c[g+12>>2]|0;if((q|0)==(c[g+16>>2]|0)){o=0;g=ha(c[(c[g>>2]|0)+36>>2]|0,g|0)|0;v=o;o=0;if(v&1){A=38;break b}}else g=c[q>>2]|0;o=0;q=la(c[(c[l>>2]|0)+12>>2]|0,l|0,2048,g|0)|0;v=o;o=0;if(v&1){A=38;break b}if(q){q=c[n>>2]|0;if((q|0)==(c[D+96>>2]|0)){o=0;Da(24,m|0,n|0,D+96|0);v=o;o=0;if(v&1){A=38;break b}q=c[n>>2]|0}c[n>>2]=q+4;c[q>>2]=g;r=r+1|0}else{v=a[D+56+11>>0]|0;if(!((g|0)==(u|0)&(r|0?((v<<24>>24<0?c[D+56+4>>2]|0:v&255)|0)!=0:0))){s=f;break}if((p|0)==(c[D+76>>2]|0)){o=0;Da(22,D+88|0,D+80|0,D+76|0);v=o;o=0;if(v&1){A=38;break b}p=c[D+80>>2]|0}v=p+4|0;c[D+80>>2]=v;c[p>>2]=r;p=v;r=0}g=c[b>>2]|0;q=c[g+12>>2]|0;if((q|0)==(c[g+16>>2]|0)){o=0;ha(c[(c[g>>2]|0)+40>>2]|0,g|0)|0;v=o;o=0;if(v&1){A=38;break b}else{s=f;q=t;continue}}else{c[g+12>>2]=q+4;s=f;q=t;continue}}if(r|0?(c[D+88>>2]|0)!=(p|0):0){if((p|0)==(c[D+76>>2]|0)){o=0;Da(22,D+88|0,D+80|0,D+76|0);v=o;o=0;if(v&1){A=39;break b}p=c[D+80>>2]|0}v=p+4|0;c[D+80>>2]=v;c[p>>2]=r;p=v}q=c[D+4>>2]|0;e:do if((q|0)>0){f=c[b>>2]|0;do if(f){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){o=0;f=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=39;break b}}else f=c[g>>2]|0;if((f|0)==-1){c[b>>2]=0;g=1;break}else{g=(c[b>>2]|0)==0;break}}else g=1;while(0);if(s){f=c[s+12>>2]|0;if((f|0)==(c[s+16>>2]|0)){o=0;f=ha(c[(c[s>>2]|0)+36>>2]|0,s|0)|0;v=o;o=0;if(v&1){A=39;break b}}else f=c[f>>2]|0;if((f|0)!=-1)if(g)r=s;else{A=221;break b}else{e=0;A=215}}else A=215;if((A|0)==215){A=0;if(g){A=221;break b}else r=0}f=c[b>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){o=0;f=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=39;break b}}else f=c[g>>2]|0;if((f|0)!=(c[D+72>>2]|0)){A=221;break b}f=c[b>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){o=0;ha(c[(c[f>>2]|0)+40>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=39;break b}else s=r}else{c[f+12>>2]=g+4;s=r}while(1){if((q|0)<=0)break e;f=c[b>>2]|0;do if(f){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){o=0;f=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=37;break b}}else f=c[g>>2]|0;if((f|0)==-1){c[b>>2]=0;g=1;break}else{g=(c[b>>2]|0)==0;break}}else g=1;while(0);do if(r){f=c[r+12>>2]|0;if((f|0)==(c[r+16>>2]|0)){o=0;f=ha(c[(c[r>>2]|0)+36>>2]|0,r|0)|0;v=o;o=0;if(v&1){A=37;break b}}else f=c[f>>2]|0;if((f|0)==-1){f=0;e=0;A=238;break}if(g^(s|0)==0){t=s;r=s}else{A=245;break b}}else{f=s;A=238}while(0);if((A|0)==238){A=0;if(g){A=245;break b}else{t=f;r=0}}f=c[b>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){o=0;f=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=37;break b}}else f=c[g>>2]|0;o=0;f=la(c[(c[l>>2]|0)+12>>2]|0,l|0,2048,f|0)|0;v=o;o=0;if(v&1){A=37;break b}if(!f){A=245;break b}if((c[n>>2]|0)==(c[D+96>>2]|0)?(o=0,Da(24,m|0,n|0,D+96|0),v=o,o=0,v&1):0){A=37;break b}f=c[b>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){o=0;f=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=37;break b}}else f=c[g>>2]|0;g=c[n>>2]|0;c[n>>2]=g+4;c[g>>2]=f;q=q+-1|0;c[D+4>>2]=q;f=c[b>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){o=0;ha(c[(c[f>>2]|0)+40>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=37;break b}else{s=t;continue}}else{c[f+12>>2]=g+4;s=t;continue}}}while(0);if((c[n>>2]|0)==(c[m>>2]|0)){A=255;break b}else f=B;break}default:{p=v;f=B}}while(0);f:do if((A|0)==59)while(1){A=0;p=c[b>>2]|0;do if(p){f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=34;break b}}else p=c[f>>2]|0;if((p|0)==-1){c[b>>2]=0;f=1;break}else{f=(c[b>>2]|0)==0;break}}else f=1;while(0);if(g){p=c[g+12>>2]|0;if((p|0)==(c[g+16>>2]|0)){o=0;p=ha(c[(c[g>>2]|0)+36>>2]|0,g|0)|0;u=o;o=0;if(u&1){A=34;break b}}else p=c[p>>2]|0;if((p|0)!=-1)if(f^(q|0)==0){r=q;g=q}else{p=v;f=B;break f}else{p=0;e=0;A=71}}else{p=q;A=71}if((A|0)==71){A=0;if(f){p=v;f=B;break f}else{r=p;g=0}}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=34;break b}}else p=c[f>>2]|0;o=0;p=la(c[(c[l>>2]|0)+12>>2]|0,l|0,8192,p|0)|0;u=o;o=0;if(u&1){A=34;break b}if(!p){p=v;f=B;break f}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+40>>2]|0,p|0)|0;A=o;o=0;if(A&1){A=34;break b}}else{c[p+12>>2]=f+4;p=c[f>>2]|0}o=0;da(62,D+8|0,p|0);A=o;o=0;if(A&1){A=34;break b}else{q=r;A=59}}while(0);v=p;w=w+1|0;B=f}g:switch(A|0){case 34:{p=Ya()|0;break a}case 35:{p=Ya()|0;break a}case 36:{p=Ya()|0;break a}case 37:{p=Ya()|0;break a}case 38:{p=Ya()|0;break a}case 39:{p=Ya()|0;break a}case 57:{c[j>>2]=c[j>>2]|4;p=0;break}case 125:{c[j>>2]=c[j>>2]|4;p=0;break}case 165:{c[j>>2]=c[j>>2]|4;p=0;break}case 221:{c[j>>2]=c[j>>2]|4;p=0;break}case 245:{c[j>>2]=c[j>>2]|4;p=0;break}case 255:{c[j>>2]=c[j>>2]|4;p=0;break}case 257:{h:do if(B|0){q=B+8+3|0;r=B+4|0;g=1;i:while(1){p=a[q>>0]|0;if(p<<24>>24<0)p=c[r>>2]|0;else p=p&255;if(g>>>0>=p>>>0)break h;p=c[b>>2]|0;do if(p){f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;n=o;o=0;if(n&1){A=33;break i}}else p=c[f>>2]|0;if((p|0)==-1){c[b>>2]=0;f=1;break}else{f=(c[b>>2]|0)==0;break}}else f=1;while(0);if(e){p=c[e+12>>2]|0;if((p|0)==(c[e+16>>2]|0)){o=0;p=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;n=o;o=0;if(n&1){A=33;break}}else p=c[p>>2]|0;if((p|0)!=-1){if(!f){A=283;break}}else A=275}else A=275;if((A|0)==275){A=0;if(f){A=283;break}else e=0}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;n=o;o=0;if(n&1){A=33;break}}else p=c[f>>2]|0;if((a[q>>0]|0)<0)f=c[B>>2]|0;else f=B;if((p|0)!=(c[f+(g<<2)>>2]|0)){A=283;break}g=g+1|0;p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;ha(c[(c[p>>2]|0)+40>>2]|0,p|0)|0;n=o;o=0;if(n&1){A=33;break}else continue}else{c[p+12>>2]=f+4;continue}}if((A|0)==33){p=Ya()|0;break a}else if((A|0)==283){c[j>>2]=c[j>>2]|4;p=0;break g}}while(0);e=c[D+88>>2]|0;if((e|0)!=(v|0)){c[D>>2]=0;If(D+56|0,e,v,D);if(!(c[D>>2]|0)){p=1;break}else{c[j>>2]=c[j>>2]|4;p=0;break}}else p=1;break}}dq(D+8|0);dq(D+20|0);dq(D+32|0);dq(D+44|0);rq(D+56|0);e=c[D+88>>2]|0;c[D+88>>2]=0;if(e|0?(o=0,ba(c[D+88+4>>2]|0,e|0),D=o,o=0,D&1):0){D=Za(0)|0;lt(D)}i=C;return p|0}while(0);dq(D+8|0);dq(D+20|0);dq(D+32|0);dq(D+44|0);rq(D+56|0);e=c[D+88>>2]|0;c[D+88>>2]=0;if(e|0?(o=0,ba(c[D+88+4>>2]|0,e|0),D=o,o=0,D&1):0){D=Za(0)|0;lt(D)}Ra(p|0);return 0}
function Xc(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;s=i;u=i=i+63&-64;i=i+976|0;c[u+872>>2]=u+876;h[u>>3]=j;b=rm(u+876|0,100,48739,u)|0;a:do if(b>>>0>99){l=zq()|0;o=0;h[u+8>>3]=j;l=Ba(23,u+872|0,l|0,48739,u+8|0)|0;v=o;o=0;do if(!(v&1)){b=c[u+872>>2]|0;if((b|0)==0?(o=0,Fa(20),v=o,o=0,v&1):0){k=0;b=0;break}k=ec(l<<2)|0;if(k|0){m=b;r=k;v=b;w=8;break a}o=0;Fa(20);v=o;o=0;if(!(v&1)){m=b;r=0;v=b;w=8;break a}}else{k=0;b=0}while(0);l=Ya()|0}else{m=u+876|0;r=u+472|0;k=0;v=0;l=b;w=8}while(0);if((w|0)==8){b=Wm(f)|0;o=0;q=va(32,b|0,52364)|0;p=o;o=0;if(!(p&1)?(o=0,Ba(c[(c[q>>2]|0)+48>>2]|0,q|0,m|0,m+l|0,r|0)|0,p=o,o=0,!(p&1)):0){if(!l)p=0;else p=(a[m>>0]|0)==45;c[u+452>>2]=0;c[u+452+4>>2]=0;c[u+452+8>>2]=0;m=0;while(1){if((m|0)==3)break;c[u+452+(m<<2)>>2]=0;m=m+1|0}c[u+440>>2]=0;c[u+440+4>>2]=0;c[u+440+8>>2]=0;m=0;while(1){if((m|0)==3)break;c[u+440+(m<<2)>>2]=0;m=m+1|0}c[u+428>>2]=0;c[u+428+4>>2]=0;c[u+428+8>>2]=0;m=0;while(1){if((m|0)==3)break;c[u+428+(m<<2)>>2]=0;m=m+1|0}o=0;ta(21,e|0,p|0,b|0,u|0,u+468|0,u+464|0,u+452|0,u+440|0,u+428|0,u+424|0);n=o;o=0;if(!(n&1)){n=c[u+424>>2]|0;if((l|0)>(n|0)){e=a[u+428+8+3>>0]|0;m=a[u+440+8+3>>0]|0;m=(e<<24>>24<0?c[u+428+4>>2]|0:e&255)+(l-n<<1|1)+(m<<24>>24<0?c[u+440+4>>2]|0:m&255)|0}else{e=a[u+428+8+3>>0]|0;m=a[u+440+8+3>>0]|0;m=(e<<24>>24<0?c[u+428+4>>2]|0:e&255)+2+(m<<24>>24<0?c[u+440+4>>2]|0:m&255)|0}m=m+n|0;if(m>>>0>100){m=ec(m<<2)|0;if(!m){o=0;Fa(20);e=o;o=0;if(!(e&1)){e=m;m=0;w=32}}else{e=m;w=32}}else{e=0;m=u+24|0;w=32}if((w|0)==32){o=0;na(19,m|0,u+20|0,u+16|0,c[f+4>>2]|0,r|0,r+(l<<2)|0,q|0,p|0,u|0,c[u+468>>2]|0,c[u+464>>2]|0,u+452|0,u+440|0,u+428|0,n|0);w=o;o=0;if(!(w&1)?(o=0,t=fa(57,c[d>>2]|0,m|0,c[u+20>>2]|0,c[u+16>>2]|0,f|0,g|0)|0,w=o,o=0,!(w&1)):0){if(e)nc(e);dq(u+428|0);dq(u+440|0);rq(u+452|0);en(b);if(k|0)nc(k);if(v|0)nc(v);i=s;return t|0}else m=e}l=Ya()|0;if(m)nc(m)}else l=Ya()|0;dq(u+428|0);dq(u+440|0);rq(u+452|0)}else l=Ya()|0;en(b);b=v}if(k|0)nc(k);if(b|0)nc(b);Ra(l|0);return 0}function Yc(b,d){b=b|0;d=d|0;var e=0,f=0;c[b+4>>2]=d+-1;c[b>>2]=40592;o=0;da(64,b+8|0,28);e=o;o=0;if(e&1)d=Ya()|0;else{c[b+144>>2]=0;c[b+144+4>>2]=0;c[b+144+8>>2]=0;o=0;Da(26,b+144|0,47235,1);e=o;o=0;if(e&1)d=Ya()|0;else{e=c[b+8>>2]|0;d=c[b+12>>2]|0;while(1){if((d|0)==(e|0))break;f=d+-4|0;c[b+12>>2]=f;d=f}c[12557]=0;c[12556]=38256;o=0;ba(145,b|0);f=o;o=0;do if((((((((((((((!(f&1)?(c[12559]=0,c[12558]=38288,o=0,ba(146,b|0),f=o,o=0,!(f&1)):0)?(c[12561]=0,c[12560]=40612,a[50252]=0,c[12562]=41512,o=0,ba(147,b|0),f=o,o=0,!(f&1)):0)?(c[12565]=0,c[12564]=40808,o=0,ba(148,b|0),f=o,o=0,!(f&1)):0)?(c[12567]=0,c[12566]=40876,o=0,ba(149,b|0),f=o,o=0,!(f&1)):0)?(ip(50272,1),o=0,ba(150,b|0),f=o,o=0,!(f&1)):0)?(c[12573]=0,c[12572]=40924,o=0,ba(151,b|0),f=o,o=0,!(f&1)):0)?(c[12575]=0,c[12574]=40972,o=0,ba(152,b|0),f=o,o=0,!(f&1)):0)?(Ek(50304,1),o=0,ba(153,b|0),f=o,o=0,!(f&1)):0)?(Bk(50328,1),o=0,ba(154,b|0),f=o,o=0,!(f&1)):0)?(c[12591]=0,c[12590]=38320,o=0,ba(155,b|0),f=o,o=0,!(f&1)):0)?(c[12593]=0,c[12592]=38384,o=0,ba(156,b|0),f=o,o=0,!(f&1)):0)?(c[12595]=0,c[12594]=38448,o=0,ba(157,b|0),f=o,o=0,!(f&1)):0)?(c[12597]=0,c[12596]=38500,o=0,ba(158,b|0),f=o,o=0,!(f&1)):0)?(c[12599]=0,c[12598]=40048,o=0,ba(159,b|0),f=o,o=0,!(f&1)):0){c[12601]=0;c[12600]=40104;o=0;ba(160,b|0);f=o;o=0;if(f&1)break;c[12603]=0;c[12602]=40160;o=0;ba(161,b|0);f=o;o=0;if(f&1)break;c[12605]=0;c[12604]=40216;o=0;ba(162,b|0);f=o;o=0;if(f&1)break;c[12607]=0;c[12606]=40272;o=0;ba(163,b|0);f=o;o=0;if(f&1)break;c[12609]=0;c[12608]=40300;o=0;ba(164,b|0);f=o;o=0;if(f&1)break;c[12611]=0;c[12610]=40328;o=0;ba(165,b|0);f=o;o=0;if(f&1)break;c[12613]=0;c[12612]=40356;o=0;ba(166,b|0);f=o;o=0;if(f&1)break;c[12615]=0;c[12614]=38552;c[12616]=38600;o=0;ba(167,b|0);f=o;o=0;if(f&1)break;c[12619]=0;c[12618]=38636;c[12620]=38684;o=0;ba(168,b|0);f=o;o=0;if(f&1)break;c[12623]=0;c[12622]=40788;c[12624]=zq()|0;c[12622]=4e4;o=0;ba(169,b|0);f=o;o=0;if(f&1)break;c[12627]=0;c[12626]=40788;c[12628]=zq()|0;c[12626]=40024;o=0;ba(170,b|0);f=o;o=0;if(f&1)break;c[12631]=0;c[12630]=40384;o=0;ba(171,b|0);f=o;o=0;if(f&1)break;c[12633]=0;c[12632]=40416;o=0;ba(172,b|0);f=o;o=0;if(f&1)break;return}while(0);d=Ya()|0;rq(b+144|0)}mj(b+8|0)}Ra(d|0)}function Zc(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;r=i;p=i=i+63&-64;i=i+240|0;Vc(a+40|0,b);c[a+80>>2]=1;e=a+84|0;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));lc(p+160|0,a+40|0);ic(p+120|0,p+160|0,2040);o=c[a+80>>2]|0;n=c[a+84>>2]|0;m=c[a+88>>2]|0;l=c[a+92>>2]|0;k=c[a+96>>2]|0;j=c[a+100>>2]|0;h=c[a+104>>2]|0;g=c[a+108>>2]|0;f=c[a+112>>2]|0;e=c[a+116>>2]|0;B=(c[p+160>>2]|0)-o|0;A=(c[p+160+4>>2]|0)-n|0;z=(c[p+160+8>>2]|0)-m|0;y=(c[p+160+12>>2]|0)-l|0;x=(c[p+160+16>>2]|0)-k|0;w=(c[p+160+20>>2]|0)-j|0;v=(c[p+160+24>>2]|0)-h|0;u=(c[p+160+28>>2]|0)-g|0;t=(c[p+160+32>>2]|0)-f|0;s=(c[p+160+36>>2]|0)-e|0;c[p+160>>2]=B;c[p+160+4>>2]=A;c[p+160+8>>2]=z;c[p+160+12>>2]=y;c[p+160+16>>2]=x;c[p+160+20>>2]=w;c[p+160+24>>2]=v;c[p+160+28>>2]=u;c[p+160+32>>2]=t;c[p+160+36>>2]=s;n=n+(c[p+120+4>>2]|0)|0;m=m+(c[p+120+8>>2]|0)|0;l=l+(c[p+120+12>>2]|0)|0;k=k+(c[p+120+16>>2]|0)|0;j=j+(c[p+120+20>>2]|0)|0;h=h+(c[p+120+24>>2]|0)|0;g=g+(c[p+120+28>>2]|0)|0;f=f+(c[p+120+32>>2]|0)|0;e=e+(c[p+120+36>>2]|0)|0;c[p+120>>2]=o+(c[p+120>>2]|0);c[p+120+4>>2]=n;c[p+120+8>>2]=m;c[p+120+12>>2]=l;c[p+120+16>>2]=k;c[p+120+20>>2]=j;c[p+120+24>>2]=h;c[p+120+28>>2]=g;c[p+120+32>>2]=f;c[p+120+36>>2]=e;lc(p+80|0,p+120|0);ic(p+80|0,p+80|0,p+120|0);lc(a,p+80|0);ic(a,a,p+120|0);ic(a,a,p+160|0);xd(a,a);ic(a,a,p+80|0);ic(a,a,p+160|0);lc(p+40|0,a);ic(p+40|0,p+40|0,p+120|0);e=c[p+40>>2]|0;f=c[p+40+4>>2]|0;g=c[p+40+8>>2]|0;h=c[p+40+12>>2]|0;j=c[p+40+16>>2]|0;k=c[p+40+20>>2]|0;l=c[p+40+24>>2]|0;m=c[p+40+28>>2]|0;n=c[p+40+32>>2]|0;o=c[p+40+36>>2]|0;c[p>>2]=e-B;c[p+4>>2]=f-A;c[p+8>>2]=g-z;c[p+12>>2]=h-y;c[p+16>>2]=j-x;c[p+20>>2]=k-w;c[p+24>>2]=l-v;c[p+28>>2]=m-u;c[p+32>>2]=n-t;c[p+36>>2]=o-s;Rd(p+200|0,p);if(wm(p+200|0,54292)|0){t=(c[p+160+4>>2]|0)+f|0;u=(c[p+160+8>>2]|0)+g|0;v=(c[p+160+12>>2]|0)+h|0;w=(c[p+160+16>>2]|0)+j|0;x=(c[p+160+20>>2]|0)+k|0;y=(c[p+160+24>>2]|0)+l|0;z=(c[p+160+28>>2]|0)+m|0;A=(c[p+160+32>>2]|0)+n|0;B=(c[p+160+36>>2]|0)+o|0;c[p>>2]=(c[p+160>>2]|0)+e;c[p+4>>2]=t;c[p+8>>2]=u;c[p+12>>2]=v;c[p+16>>2]=w;c[p+20>>2]=x;c[p+24>>2]=y;c[p+28>>2]=z;c[p+32>>2]=A;c[p+36>>2]=B;Rd(p+200|0,p);if(!(wm(p+200|0,54292)|0)){ic(a,a,2080);q=4}else e=-1}else q=4;if((q|0)==4){Rd(p+200|0,a);if(((d[p+200>>0]|0)&1|0)==((d[b+31>>0]|0)>>>7|0))eh(a,a);ic(a+120|0,a,a+40|0);e=0}i=r;return e|0}function _c(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;s=i;u=i=i+63&-64;i=i+384|0;c[u+64>>2]=u+272;h[u>>3]=j;b=rm(u+272|0,100,48739,u)|0;a:do if(b>>>0>99){l=zq()|0;o=0;h[u+8>>3]=j;l=Ba(23,u+64|0,l|0,48739,u+8|0)|0;v=o;o=0;do if(!(v&1)){b=c[u+64>>2]|0;if((b|0)==0?(o=0,Fa(20),v=o,o=0,v&1):0){k=0;b=0;break}k=ec(l)|0;if(k|0){m=b;r=k;v=b;w=8;break a}o=0;Fa(20);v=o;o=0;if(!(v&1)){m=b;r=0;v=b;w=8;break a}}else{k=0;b=0}while(0);l=Ya()|0}else{m=u+272|0;r=u+172|0;k=0;v=0;l=b;w=8}while(0);if((w|0)==8){b=Wm(f)|0;o=0;q=va(32,b|0,52332)|0;p=o;o=0;if(!(p&1)?(o=0,Ba(c[(c[q>>2]|0)+32>>2]|0,q|0,m|0,m+l|0,r|0)|0,p=o,o=0,!(p&1)):0){if(!l)p=0;else p=(a[m>>0]|0)==45;c[u+52>>2]=0;c[u+52+4>>2]=0;c[u+52+8>>2]=0;m=0;while(1){if((m|0)==3)break;c[u+52+(m<<2)>>2]=0;m=m+1|0}c[u+40>>2]=0;c[u+40+4>>2]=0;c[u+40+8>>2]=0;m=0;while(1){if((m|0)==3)break;c[u+40+(m<<2)>>2]=0;m=m+1|0}c[u+28>>2]=0;c[u+28+4>>2]=0;c[u+28+8>>2]=0;m=0;while(1){if((m|0)==3)break;c[u+28+(m<<2)>>2]=0;m=m+1|0}o=0;ta(20,e|0,p|0,b|0,u|0,u+169|0,u+168|0,u+52|0,u+40|0,u+28|0,u+24|0);n=o;o=0;if(!(n&1)){n=c[u+24>>2]|0;if((l|0)>(n|0)){e=a[u+28+11>>0]|0;m=a[u+40+11>>0]|0;m=(e<<24>>24<0?c[u+28+4>>2]|0:e&255)+(l-n<<1|1)+(m<<24>>24<0?c[u+40+4>>2]|0:m&255)|0}else{e=a[u+28+11>>0]|0;m=a[u+40+11>>0]|0;m=(e<<24>>24<0?c[u+28+4>>2]|0:e&255)+2+(m<<24>>24<0?c[u+40+4>>2]|0:m&255)|0}m=m+n|0;if(m>>>0>100){m=ec(m)|0;if(!m){o=0;Fa(20);e=o;o=0;if(!(e&1)){e=m;m=0;w=32}}else{e=m;w=32}}else{e=0;m=u+68|0;w=32}if((w|0)==32){o=0;na(18,m|0,u+20|0,u+16|0,c[f+4>>2]|0,r|0,r+l|0,q|0,p|0,u|0,a[u+169>>0]|0,a[u+168>>0]|0,u+52|0,u+40|0,u+28|0,n|0);w=o;o=0;if(!(w&1)?(o=0,t=fa(56,c[d>>2]|0,m|0,c[u+20>>2]|0,c[u+16>>2]|0,f|0,g|0)|0,w=o,o=0,!(w&1)):0){if(e)nc(e);rq(u+28|0);rq(u+40|0);rq(u+52|0);en(b);if(k|0)nc(k);if(v|0)nc(v);i=s;return t|0}else m=e}l=Ya()|0;if(m)nc(m)}else l=Ya()|0;rq(u+28|0);rq(u+40|0);rq(u+52|0)}else l=Ya()|0;en(b);b=v}if(k|0)nc(k);if(b|0)nc(b);Ra(l|0);return 0}function $c(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;s=a[b+80>>0]|0?0:16777216;t=c[b+4>>2]|0;u=c[b+8>>2]|0;p=c[b+12>>2]|0;q=c[b+16>>2]|0;l=c[b+20>>2]|0;k=c[b+24>>2]|0;j=c[b+28>>2]|0;i=c[b+32>>2]|0;h=c[b+36>>2]|0;if(g>>>0>0|(g|0)==0&f>>>0>15){r=c[b>>2]|0;while(1){z=((d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24)&67108863)+l|0;A=e+3|0;A=((d[A>>0]|d[A+1>>0]<<8|d[A+2>>0]<<16|d[A+3>>0]<<24)>>>2&67108863)+k|0;y=e+6|0;y=((d[y>>0]|d[y+1>>0]<<8|d[y+2>>0]<<16|d[y+3>>0]<<24)>>>4&67108863)+j|0;x=e+9|0;x=((d[x>>0]|d[x+1>>0]<<8|d[x+2>>0]<<16|d[x+3>>0]<<24)>>>6)+i|0;l=e+12|0;l=((d[l>>0]|d[l+1>>0]<<8|d[l+2>>0]<<16|d[l+3>>0]<<24)>>>8|s)+h|0;h=_m(z|0,0,r|0,0)|0;m=D;j=_m(A|0,0,q*5|0,0)|0;m=Jp(j|0,D|0,h|0,m|0)|0;h=D;j=_m(y|0,0,p*5|0,0)|0;j=Jp(m|0,h|0,j|0,D|0)|0;h=D;m=_m(x|0,0,u*5|0,0)|0;m=Jp(j|0,h|0,m|0,D|0)|0;h=D;j=_m(l|0,0,t*5|0,0)|0;j=Jp(m|0,h|0,j|0,D|0)|0;h=D;m=_m(z|0,0,t|0,0)|0;n=D;w=_m(A|0,0,r|0,0)|0;n=Jp(w|0,D|0,m|0,n|0)|0;m=D;w=_m(y|0,0,q*5|0,0)|0;w=Jp(n|0,m|0,w|0,D|0)|0;m=D;n=_m(x|0,0,p*5|0,0)|0;n=Jp(w|0,m|0,n|0,D|0)|0;m=D;w=_m(l|0,0,u*5|0,0)|0;w=Jp(n|0,m|0,w|0,D|0)|0;m=D;n=_m(z|0,0,u|0,0)|0;o=D;v=_m(A|0,0,t|0,0)|0;o=Jp(v|0,D|0,n|0,o|0)|0;n=D;v=_m(y|0,0,r|0,0)|0;v=Jp(o|0,n|0,v|0,D|0)|0;n=D;o=_m(x|0,0,q*5|0,0)|0;o=Jp(v|0,n|0,o|0,D|0)|0;n=D;v=_m(l|0,0,p*5|0,0)|0;v=Jp(o|0,n|0,v|0,D|0)|0;n=D;o=_m(z|0,0,p|0,0)|0;i=D;k=_m(A|0,0,u|0,0)|0;i=Jp(k|0,D|0,o|0,i|0)|0;o=D;k=_m(y|0,0,t|0,0)|0;k=Jp(i|0,o|0,k|0,D|0)|0;o=D;i=_m(x|0,0,r|0,0)|0;i=Jp(k|0,o|0,i|0,D|0)|0;o=D;k=_m(l|0,0,q*5|0,0)|0;k=Jp(i|0,o|0,k|0,D|0)|0;o=D;i=_m(z|0,0,q|0,0)|0;z=D;A=_m(A|0,0,p|0,0)|0;z=Jp(A|0,D|0,i|0,z|0)|0;i=D;y=_m(y|0,0,u|0,0)|0;y=Jp(z|0,i|0,y|0,D|0)|0;i=D;x=_m(x|0,0,t|0,0)|0;x=Jp(y|0,i|0,x|0,D|0)|0;i=D;l=_m(l|0,0,r|0,0)|0;l=Jp(x|0,i|0,l|0,D|0)|0;i=D;h=bo(j|0,h|0,26)|0;h=Jp(w|0,m|0,h|0,0)|0;m=bo(h|0,D|0,26)|0;m=Jp(v|0,n|0,m|0,0)|0;n=bo(m|0,D|0,26)|0;n=Jp(k|0,o|0,n|0,0)|0;o=bo(n|0,D|0,26)|0;o=Jp(l|0,i|0,o|0,0)|0;i=bo(o|0,D|0,26)|0;f=Jp(f|0,g|0,-16,-1)|0;g=D;if(!(g>>>0>0|(g|0)==0&f>>>0>15)){e=(i*5|0)+j&67108863;k=(((i*5|0)+(j&67108863)|0)>>>26)+(h&67108863)|0;j=m&67108863;i=n&67108863;h=o&67108863;break}else{e=e+16|0;l=(i*5|0)+j&67108863;k=(((i*5|0)+(j&67108863)|0)>>>26)+(h&67108863)|0;j=m&67108863;i=n&67108863;h=o&67108863}}}else e=l;c[b+20>>2]=e;c[b+24>>2]=k;c[b+28>>2]=j;c[b+32>>2]=i;c[b+36>>2]=h;return}function ad(b,c,e,f){b=b|0;c=c|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;if(!f){g=1634760805;h=2036477234;i=1797285236;f=857760878}else{g=d[f>>0]|d[f+1>>0]<<8|d[f+2>>0]<<16|d[f+3>>0]<<24;h=d[f+8>>0]|d[f+8+1>>0]<<8|d[f+8+2>>0]<<16|d[f+8+3>>0]<<24;i=d[f+12>>0]|d[f+12+1>>0]<<8|d[f+12+2>>0]<<16|d[f+12+3>>0]<<24;f=d[f+4>>0]|d[f+4+1>>0]<<8|d[f+4+2>>0]<<16|d[f+4+3>>0]<<24}u=20;t=d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24;p=d[e+16>>0]|d[e+16+1>>0]<<8|d[e+16+2>>0]<<16|d[e+16+3>>0]<<24;q=d[e+20>>0]|d[e+20+1>>0]<<8|d[e+20+2>>0]<<16|d[e+20+3>>0]<<24;r=d[e+24>>0]|d[e+24+1>>0]<<8|d[e+24+2>>0]<<16|d[e+24+3>>0]<<24;s=d[e+28>>0]|d[e+28+1>>0]<<8|d[e+28+2>>0]<<16|d[e+28+3>>0]<<24;n=d[e+4>>0]|d[e+4+1>>0]<<8|d[e+4+2>>0]<<16|d[e+4+3>>0]<<24;o=d[e+8>>0]|d[e+8+1>>0]<<8|d[e+8+2>>0]<<16|d[e+8+3>>0]<<24;m=d[e+12>>0]|d[e+12+1>>0]<<8|d[e+12+2>>0]<<16|d[e+12+3>>0]<<24;e=f;j=d[c>>0]|d[c+1>>0]<<8|d[c+2>>0]<<16|d[c+3>>0]<<24;k=d[c+4>>0]|d[c+4+1>>0]<<8|d[c+4+2>>0]<<16|d[c+4+3>>0]<<24;l=d[c+8>>0]|d[c+8+1>>0]<<8|d[c+8+2>>0]<<16|d[c+8+3>>0]<<24;f=d[c+12>>0]|d[c+12+1>>0]<<8|d[c+12+2>>0]<<16|d[c+12+3>>0]<<24;while(1){D=q+g|0;D=(D>>>25|D<<7)^m;A=D+g|0;A=(A>>>23|A<<9)^l;x=((A+D|0)>>>19|A+D<<13)^q;G=((x+A|0)>>>14|x+A<<18)^g;z=e+t|0;z=f^(z>>>25|z<<7);w=z+e|0;w=r^(w>>>23|w<<9);J=((w+z|0)>>>19|w+z<<13)^t;C=((J+w|0)>>>14|J+w<<18)^e;v=h+j|0;v=s^(v>>>25|v<<7);I=v+h|0;I=(I>>>23|I<<9)^n;F=((I+v|0)>>>19|I+v<<13)^j;y=((F+I|0)>>>14|F+I<<18)^h;H=i+p|0;H=(H>>>25|H<<7)^o;E=H+i|0;E=(E>>>23|E<<9)^k;B=((E+H|0)>>>19|E+H<<13)^p;c=((B+E|0)>>>14|B+E<<18)^i;t=((G+H|0)>>>25|G+H<<7)^J;J=t+G|0;n=(J>>>23|J<<9)^I;I=n+t|0;o=(I>>>19|I<<13)^H;H=o+n|0;g=(H>>>14|H<<18)^G;j=((C+D|0)>>>25|C+D<<7)^F;F=j+C|0;k=(F>>>23|F<<9)^E;E=k+j|0;m=(E>>>19|E<<13)^D;D=m+k|0;e=(D>>>14|D<<18)^C;p=((y+z|0)>>>25|y+z<<7)^B;B=p+y|0;l=(B>>>23|B<<9)^A;A=l+p|0;f=(A>>>19|A<<13)^z;z=f+l|0;h=(z>>>14|z<<18)^y;q=((c+v|0)>>>25|c+v<<7)^x;x=q+c|0;r=(x>>>23|x<<9)^w;w=r+q|0;s=(w>>>19|w<<13)^v;v=s+r|0;i=(v>>>14|v<<18)^c;if((u|0)<=2)break;else u=u+-2|0}a[b>>0]=g;a[b+1>>0]=g>>8;a[b+2>>0]=g>>16;a[b+3>>0]=g>>24;a[b+4>>0]=e;a[b+4+1>>0]=e>>8;a[b+4+2>>0]=e>>16;a[b+4+3>>0]=e>>24;a[b+8>>0]=h;a[b+8+1>>0]=h>>8;a[b+8+2>>0]=h>>16;a[b+8+3>>0]=h>>24;a[b+12>>0]=i;a[b+12+1>>0]=i>>8;a[b+12+2>>0]=i>>16;a[b+12+3>>0]=i>>24;a[b+16>>0]=j;a[b+16+1>>0]=j>>8;a[b+16+2>>0]=j>>16;a[b+16+3>>0]=j>>24;a[b+20>>0]=k;a[b+20+1>>0]=k>>8;a[b+20+2>>0]=k>>16;a[b+20+3>>0]=k>>24;a[b+24>>0]=l;a[b+24+1>>0]=l>>8;a[b+24+2>>0]=l>>16;a[b+24+3>>0]=l>>24;a[b+28>>0]=f;a[b+28+1>>0]=f>>8;a[b+28+2>>0]=f>>16;a[b+28+3>>0]=f>>24;return 0}function bd(d,e,f,g,h,i,j,k,l,m,n,o,p,q,r){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c[f>>2]=d;x=0;while(1){if((x|0)==4)break;a:do switch(a[l+x>>0]|0){case 0:{c[e>>2]=c[f>>2];break}case 1:{c[e>>2]=c[f>>2];v=Pb[c[(c[j>>2]|0)+28>>2]&63](j,32)|0;w=c[f>>2]|0;c[f>>2]=w+1;a[w>>0]=v;break}case 3:{s=a[q+11>>0]|0;if((s<<24>>24<0?c[q+4>>2]|0:s&255)|0){v=a[(s<<24>>24<0?c[q>>2]|0:q)>>0]|0;w=c[f>>2]|0;c[f>>2]=w+1;a[w>>0]=v}break}case 2:{s=a[p+11>>0]|0;w=s<<24>>24<0?c[p+4>>2]|0:s&255;if(!((g&512|0)==0|(w|0)==0)){u=s<<24>>24<0?c[p>>2]|0:p;v=c[f>>2]|0;s=v;t=u;while(1){if((t|0)==(u+w|0))break;a[s>>0]=a[t>>0]|0;s=s+1|0;t=t+1|0}c[f>>2]=v+w}break}case 4:{t=c[f>>2]|0;h=k?h+1|0:h;u=h;while(1){if(u>>>0>=i>>>0)break;s=a[u>>0]|0;if(s<<24>>24<=-1)break;if(!(b[(c[j+8>>2]|0)+(s<<24>>24<<1)>>1]&2048))break;u=u+1|0}if((r|0)>0){v=r;while(1){s=(v|0)>0;if(!(u>>>0>h>>>0&s))break;w=u+-1|0;y=a[w>>0]|0;s=c[f>>2]|0;c[f>>2]=s+1;a[s>>0]=y;u=w;v=v+-1|0}if(s)w=Pb[c[(c[j>>2]|0)+28>>2]&63](j,48)|0;else w=0;while(1){s=c[f>>2]|0;c[f>>2]=s+1;if((v|0)<=0)break;a[s>>0]=w;v=v+-1|0}a[s>>0]=m}b:do if((u|0)==(h|0)){w=Pb[c[(c[j>>2]|0)+28>>2]&63](j,48)|0;y=c[f>>2]|0;c[f>>2]=y+1;a[y>>0]=w}else{s=a[o+11>>0]|0;if(!((s<<24>>24<0?c[o+4>>2]|0:s&255)|0)){s=-1;v=0;w=0}else{s=a[(s<<24>>24<0?c[o>>2]|0:o)>>0]|0;v=0;w=0}while(1){if((u|0)==(h|0))break b;if((w|0)==(s|0)){s=c[f>>2]|0;c[f>>2]=s+1;a[s>>0]=n;v=v+1|0;s=a[o+11>>0]|0;if(v>>>0<(s<<24>>24<0?c[o+4>>2]|0:s&255)>>>0){s=a[(s<<24>>24<0?c[o>>2]|0:o)+v>>0]|0;s=s<<24>>24==127?-1:s<<24>>24;w=0}else{s=w;w=0}}y=u+-1|0;A=a[y>>0]|0;z=c[f>>2]|0;c[f>>2]=z+1;a[z>>0]=A;u=y;w=w+1|0}}while(0);s=c[f>>2]|0;if((t|0)!=(s|0))while(1){s=s+-1|0;if(t>>>0>=s>>>0)break a;A=a[t>>0]|0;a[t>>0]=a[s>>0]|0;a[s>>0]=A;t=t+1|0}break}default:{}}while(0);x=x+1|0}h=a[q+11>>0]|0;v=h<<24>>24<0?c[q+4>>2]|0:h&255;if(v>>>0>1){t=h<<24>>24<0?c[q>>2]|0:q;u=c[f>>2]|0;s=u;h=t;while(1){h=h+1|0;if((h|0)==(t+v|0))break;a[s>>0]=a[h>>0]|0;s=s+1|0}c[f>>2]=u+(v+-1)}switch(g&176|0){case 32:{c[e>>2]=c[f>>2];break}case 16:break;default:c[e>>2]=d}return}function cd(b,d,e,f,g,h,i,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c[e>>2]=b;z=0;while(1){if((z|0)==4)break;a:do switch(a[k+z>>0]|0){case 0:{c[d>>2]=c[e>>2];break}case 1:{c[d>>2]=c[e>>2];x=Pb[c[(c[i>>2]|0)+44>>2]&63](i,32)|0;y=c[e>>2]|0;c[e>>2]=y+4;c[y>>2]=x;break}case 3:{r=a[p+8+3>>0]|0;if((r<<24>>24<0?c[p+4>>2]|0:r&255)|0){x=c[(r<<24>>24<0?c[p>>2]|0:p)>>2]|0;y=c[e>>2]|0;c[e>>2]=y+4;c[y>>2]=x}break}case 2:{r=a[o+8+3>>0]|0;v=r<<24>>24<0?c[o+4>>2]|0:r&255;if(!((f&512|0)==0|(v|0)==0)){s=r<<24>>24<0?c[o>>2]|0:o;t=c[e>>2]|0;r=t;u=s;while(1){if((u|0)==(s+(v<<2)|0))break;c[r>>2]=c[u>>2];r=r+4|0;u=u+4|0}c[e>>2]=t+(v<<2)}break}case 4:{s=c[e>>2]|0;g=j?g+4|0:g;r=g;while(1){if(r>>>0>=h>>>0)break;if(!(Kb[c[(c[i>>2]|0)+12>>2]&63](i,2048,c[r>>2]|0)|0))break;r=r+4|0}if((q|0)>0){u=q;while(1){t=(u|0)>0;if(!(r>>>0>g>>>0&t))break;y=r+-4|0;w=c[y>>2]|0;x=c[e>>2]|0;c[e>>2]=x+4;c[x>>2]=w;r=y;u=u+-1|0}if(t)w=Pb[c[(c[i>>2]|0)+44>>2]&63](i,48)|0;else w=0;v=c[e>>2]|0;while(1){t=v+4|0;if((u|0)<=0)break;c[v>>2]=w;v=t;u=u+-1|0}c[e>>2]=t;c[v>>2]=l}if((r|0)==(g|0)){y=Pb[c[(c[i>>2]|0)+44>>2]&63](i,48)|0;r=c[e>>2]|0;c[e>>2]=r+4;c[r>>2]=y;r=r+4|0}else{x=a[n+11>>0]|0;y=x<<24>>24<0?c[n+4>>2]|0:x&255;if(!y){w=-1;t=0;v=0}else{w=a[(x<<24>>24<0?c[n>>2]|0:n)>>0]|0;t=0;v=0}while(1){if((r|0)==(g|0))break;u=c[e>>2]|0;if((v|0)==(w|0)){c[e>>2]=u+4;c[u>>2]=m;t=t+1|0;if(t>>>0<y>>>0){w=a[(x<<24>>24<0?c[n>>2]|0:n)+t>>0]|0;u=u+4|0;w=w<<24>>24==127?-1:w<<24>>24;v=0}else{u=u+4|0;w=v;v=0}}A=r+-4|0;B=c[A>>2]|0;c[e>>2]=u+4;c[u>>2]=B;r=A;v=v+1|0}r=c[e>>2]|0}if((s|0)!=(r|0))while(1){r=r+-4|0;if(s>>>0>=r>>>0)break a;B=c[s>>2]|0;c[s>>2]=c[r>>2];c[r>>2]=B;s=s+4|0}break}default:{}}while(0);z=z+1|0}g=a[p+8+3>>0]|0;u=g<<24>>24<0?c[p+4>>2]|0:g&255;if(u>>>0>1){r=g<<24>>24<0?c[p>>2]|0:p;s=c[e>>2]|0;g=s;t=r+4|0;while(1){if((t|0)==(r+(u<<2)|0))break;c[g>>2]=c[t>>2];g=g+4|0;t=t+4|0}c[e>>2]=s+((r+(u<<2)-(r+4)|0)>>>2<<2)}switch(f&176|0){case 32:{c[d>>2]=c[e>>2];break}case 16:break;default:c[d>>2]=b}return}function dd(b,e,f,g,h,i,j,k,l,m,n){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;v=_m(l|0,0,k|0,0)|0;u=D;do if(u>>>0>0|(u|0)==0&v>>>0>1073741823){c[(Sq()|0)>>2]=27;o=-1}else{if(j>>>0>0|(j|0)==0&i>>>0>4294967295){c[(Sq()|0)>>2]=27;o=-1;break}u=Jp(i|0,j|0,-1,-1)|0;if(j>>>0<0|(j|0)==0&i>>>0<2|((u&i|0)!=0|(D&j|0)!=0)){c[(Sq()|0)>>2]=22;o=-1;break}if((k|0)==0|(l|0)==0){c[(Sq()|0)>>2]=22;o=-1;break}if(!(k>>>0>16777215?1:(33554431/(l>>>0)|0)>>>0<k>>>0)?!(0<j>>>0|(0==(j|0)?(33554431/(k>>>0)|0)>>>0<i>>>0:0)):0){v=S(k<<7,l)|0;p=_m(k<<7|0,0,i|0,j|0)|0;if((p+v|0)>>>0<p>>>0){c[(Sq()|0)>>2]=12;o=-1;break}o=p+v+(k<<8|64)|0;if(o>>>0<(k<<8|64)>>>0){c[(Sq()|0)>>2]=12;o=-1;break}if((c[b+8>>2]|0)>>>0<o>>>0?(up(b),(Qj(b,o)|0)==0):0){o=-1;break}t=c[b+4>>2]|0;s=t+v+p|0;Fg(e,f,g,h,t,v);h=s+(k<<5<<2)|0;r=0;do{q=t+(S(k<<7,r)|0)|0;if(k<<5|0){o=0;do{g=q+(o<<2)|0;c[s+(o<<2)>>2]=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;o=o+1|0}while((o|0)!=(k<<5|0))}if(!((i|0)==0&(j|0)==0)){p=0;g=0;do{if(!(k<<5&1073741792))Rf(s,h,s+(k<<6<<2)|0,k);else{o=_m(p|0,g|0,k<<5|0,0)|0;b=0;do{c[t+v+(o<<2)+(b<<2)>>2]=c[s+(b<<2)>>2];b=b+1|0}while((b|0)!=(k<<5&1073741792|0));Rf(s,h,s+(k<<6<<2)|0,k);o=_m(p|1|0,g|0,k<<5|0,0)|0;b=0;do{c[t+v+(o<<2)+(b<<2)>>2]=c[h+(b<<2)>>2];b=b+1|0}while((b|0)!=(k<<5&1073741792|0))}Rf(h,s,s+(k<<6<<2)|0,k);p=Jp(p|0,g|0,2,0)|0;g=D}while(g>>>0<j>>>0|(g|0)==(j|0)&p>>>0<i>>>0);p=0;g=0;do{if(!(k<<5&1073741792))Rf(s,h,s+(k<<6<<2)|0,k);else{o=_m(c[s+((k<<7)+-64)>>2]&u|0,0,k<<5|0,0)|0;b=0;do{w=s+(b<<2)|0;c[w>>2]=c[w>>2]^c[t+v+(o<<2)+(b<<2)>>2];b=b+1|0}while((b|0)!=(k<<5&1073741792|0));Rf(s,h,s+(k<<6<<2)|0,k);o=_m(c[h+((k<<7)+-64)>>2]&u|0,0,k<<5|0,0)|0;b=0;do{w=h+(b<<2)|0;c[w>>2]=c[w>>2]^c[t+v+(o<<2)+(b<<2)>>2];b=b+1|0}while((b|0)!=(k<<5&1073741792|0))}Rf(h,s,s+(k<<6<<2)|0,k);p=Jp(p|0,g|0,2,0)|0;g=D}while(g>>>0<j>>>0|(g|0)==(j|0)&p>>>0<i>>>0)}if(k<<5|0){o=0;do{w=q+(o<<2)|0;g=c[s+(o<<2)>>2]|0;a[w>>0]=g;a[w+1>>0]=g>>8;a[w+2>>0]=g>>16;a[w+3>>0]=g>>24;o=o+1|0}while((o|0)!=(k<<5|0))}r=r+1|0}while((r|0)!=(l|0));Fg(e,f,t,v,m,n);o=0;break}c[(Sq()|0)>>2]=12;o=-1}while(0);return o|0}function ed(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0;n=i;r=i=i+63&-64;i=i+576|0;c[r+56>>2]=r+64;c[r+56+4>>2]=140;p=Wm(g)|0;o=0;b=va(32,p|0,52364)|0;m=o;o=0;a:do if(!(m&1)?(a[r+564>>0]=0,o=0,k=ja(19,d|0,c[e>>2]|0,f|0,p|0,c[g+4>>2]|0,h|0,r+564|0,b|0,r+56|0,r+48|0,r+64+400|0)|0,m=o,o=0,!(m&1)):0){b:do if(k){o=0;Ba(c[(c[b>>2]|0)+48>>2]|0,b|0,48633,48643,r+8|0)|0;m=o;o=0;if(m&1){q=8;break a}f=c[r+48>>2]|0;g=c[r+56>>2]|0;if((f-g|0)>392){k=ec((f-g>>2)+2|0)|0;if(!k){o=0;Fa(20);m=o;o=0;if(!(m&1)){m=k;b=0;q=11}}else{m=k;b=k;q=11}}else{m=0;b=r+464|0;q=11}do if((q|0)==11){if(a[r+564>>0]|0){a[b>>0]=45;b=b+1|0}l=b;while(1){if(g>>>0>=f>>>0)break;k=c[g>>2]|0;b=r+8|0;while(1){if((b|0)==(r+8+40|0)){b=r+8+40|0;break}if((c[b>>2]|0)==(k|0))break;b=b+4|0}a[l>>0]=a[48633+(b-(r+8)>>2)>>0]|0;f=c[r+48>>2]|0;l=l+1|0;g=g+4|0}a[l>>0]=0;c[r>>2]=j;if((Xm(r+464|0,48518,r)|0)!=1?(o=0,ba(141,48522),j=o,o=0,j&1):0){k=m;break}if(m|0)nc(m);break b}while(0);b=Ya()|0;if(!k){k=b;f=r+56|0;break a}nc(k);k=b;f=r+56|0;break a}while(0);b=c[d>>2]|0;do if(b){k=c[b+12>>2]|0;if((k|0)==(c[b+16>>2]|0)){o=0;b=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;j=o;o=0;if(j&1){q=8;break a}}else b=c[k>>2]|0;if((b|0)==-1){c[d>>2]=0;f=1;break}else{f=(c[d>>2]|0)==0;break}}else f=1;while(0);b=c[e>>2]|0;do if(b){k=c[b+12>>2]|0;if((k|0)==(c[b+16>>2]|0)){o=0;b=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;j=o;o=0;if(j&1){q=8;break a}}else b=c[k>>2]|0;if((b|0)!=-1)if(f)break;else{q=40;break}else{c[e>>2]=0;q=38;break}}else q=38;while(0);if((q|0)==38?f:0)q=40;if((q|0)==40)c[h>>2]=c[h>>2]|2;k=c[d>>2]|0;en(p);b=c[r+56>>2]|0;c[r+56>>2]=0;if(b|0?(o=0,ba(c[r+56+4>>2]|0,b|0),r=o,o=0,r&1):0){r=Za(0)|0;lt(r)}i=n;return k|0}else q=8;while(0);if((q|0)==8){k=Ya()|0;f=r+56|0}en(p);b=c[f>>2]|0;c[f>>2]=0;if(b|0?(o=0,ba(c[r+56+4>>2]|0,b|0),r=o,o=0,r&1):0){r=Za(0)|0;lt(r)}Ra(k|0);return 0}function fd(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0;n=i;r=i=i+63&-64;i=i+240|0;c[r+8>>2]=r+128;c[r+8+4>>2]=140;p=Wm(g)|0;o=0;b=va(32,p|0,52332)|0;m=o;o=0;a:do if(!(m&1)?(a[r+126>>0]=0,o=0,k=ja(18,d|0,c[e>>2]|0,f|0,p|0,c[g+4>>2]|0,h|0,r+126|0,b|0,r+8|0,r+4|0,r+128+100|0)|0,m=o,o=0,!(m&1)):0){b:do if(k){o=0;Ba(c[(c[b>>2]|0)+32>>2]|0,b|0,48507,48517,r+116|0)|0;m=o;o=0;if(m&1){q=8;break a}f=c[r+4>>2]|0;g=c[r+8>>2]|0;if((f-g|0)>98){k=ec(f-g+2|0)|0;if(!k){o=0;Fa(20);m=o;o=0;if(!(m&1)){m=k;b=0;q=11}}else{m=k;b=k;q=11}}else{m=0;b=r+16|0;q=11}do if((q|0)==11){if(a[r+126>>0]|0){a[b>>0]=45;b=b+1|0}l=b;while(1){if(g>>>0>=f>>>0)break;k=a[g>>0]|0;b=r+116|0;while(1){if((b|0)==(r+116+10|0)){b=r+116+10|0;break}if((a[b>>0]|0)==k<<24>>24)break;b=b+1|0}a[l>>0]=a[48507+(b-(r+116))>>0]|0;f=c[r+4>>2]|0;l=l+1|0;g=g+1|0}a[l>>0]=0;c[r>>2]=j;if((Xm(r+16|0,48518,r)|0)!=1?(o=0,ba(141,48522),j=o,o=0,j&1):0){k=m;break}if(m|0)nc(m);break b}while(0);b=Ya()|0;if(!k){k=b;f=r+8|0;break a}nc(k);k=b;f=r+8|0;break a}while(0);b=c[d>>2]|0;do if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)){o=0;b=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;j=o;o=0;if(j&1){q=8;break a}if((b|0)==-1){c[d>>2]=0;b=0;break}else{b=c[d>>2]|0;break}}}else b=0;while(0);k=(b|0)==0;b=c[e>>2]|0;do if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)){o=0;b=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;j=o;o=0;if(j&1){q=8;break a}if((b|0)==-1){c[e>>2]=0;q=37;break}}if(!k)q=38}else q=37;while(0);if((q|0)==37?k:0)q=38;if((q|0)==38)c[h>>2]=c[h>>2]|2;k=c[d>>2]|0;en(p);b=c[r+8>>2]|0;c[r+8>>2]=0;if(b|0?(o=0,ba(c[r+8+4>>2]|0,b|0),r=o,o=0,r&1):0){r=Za(0)|0;lt(r)}i=n;return k|0}else q=8;while(0);if((q|0)==8){k=Ya()|0;f=r+8|0}en(p);b=c[f>>2]|0;c[f>>2]=0;if(b|0?(o=0,ba(c[r+8+4>>2]|0,b|0),r=o,o=0,r&1):0){r=Za(0)|0;lt(r)}Ra(k|0);return 0}function gd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=c[a>>2]|0;do if(g){h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=Ib[c[(c[g>>2]|0)+36>>2]&127](g)|0;else g=c[h>>2]|0;if((g|0)==-1){c[a>>2]=0;h=1;break}else{h=(c[a>>2]|0)==0;break}}else h=1;while(0);if(b){g=c[b+12>>2]|0;if((g|0)==(c[b+16>>2]|0))g=Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0;else g=c[g>>2]|0;if((g|0)!=-1)if(h){i=b;n=16}else n=15;else n=13}else n=13;if((n|0)==13)if(h)n=15;else{i=0;n=16}a:do if((n|0)==15){c[d>>2]=c[d>>2]|6;g=0}else if((n|0)==16){g=c[a>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=Ib[c[(c[g>>2]|0)+36>>2]&127](g)|0;else g=c[h>>2]|0;if(!(Kb[c[(c[e>>2]|0)+12>>2]&63](e,2048,g)|0)){c[d>>2]=c[d>>2]|4;g=0;break}g=(Kb[c[(c[e>>2]|0)+52>>2]&63](e,g,0)|0)<<24>>24;h=c[a>>2]|0;b=c[h+12>>2]|0;if((b|0)==(c[h+16>>2]|0)){Ib[c[(c[h>>2]|0)+40>>2]&127](h)|0;l=f;j=i;f=i}else{c[h+12>>2]=b+4;l=f;j=i;f=i}while(1){g=g+-48|0;m=l+-1|0;h=c[a>>2]|0;do if(h){b=c[h+12>>2]|0;if((b|0)==(c[h+16>>2]|0))h=Ib[c[(c[h>>2]|0)+36>>2]&127](h)|0;else h=c[b>>2]|0;if((h|0)==-1){c[a>>2]=0;i=1;break}else{i=(c[a>>2]|0)==0;break}}else i=1;while(0);if(!f){k=j;f=0;h=1}else{h=c[f+12>>2]|0;if((h|0)==(c[f+16>>2]|0))h=Ib[c[(c[f>>2]|0)+36>>2]&127](f)|0;else h=c[h>>2]|0;h=(h|0)==-1;k=h?0:j;f=h?0:j;h=h|(j|0)==0}b=c[a>>2]|0;if(!((l|0)>1&(i^h)))break;h=c[b+12>>2]|0;if((h|0)==(c[b+16>>2]|0))h=Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0;else h=c[h>>2]|0;if(!(Kb[c[(c[e>>2]|0)+12>>2]&63](e,2048,h)|0))break a;g=((Kb[c[(c[e>>2]|0)+52>>2]&63](e,h,0)|0)<<24>>24)+(g*10|0)|0;h=c[a>>2]|0;b=c[h+12>>2]|0;if((b|0)==(c[h+16>>2]|0)){Ib[c[(c[h>>2]|0)+40>>2]&127](h)|0;l=m;j=k;continue}else{c[h+12>>2]=b+4;l=m;j=k;continue}}do if(b){h=c[b+12>>2]|0;if((h|0)==(c[b+16>>2]|0))h=Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0;else h=c[h>>2]|0;if((h|0)==-1){c[a>>2]=0;b=1;break}else{b=(c[a>>2]|0)==0;break}}else b=1;while(0);if(k){h=c[k+12>>2]|0;if((h|0)==(c[k+16>>2]|0))h=Ib[c[(c[k>>2]|0)+36>>2]&127](k)|0;else h=c[h>>2]|0;if((h|0)!=-1){if(b)break}else n=56}else n=56;if((n|0)==56?!b:0)break;c[d>>2]=c[d>>2]|2}while(0);return g|0}function hd(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;p=i;m=i=i+63&-64;i=i+32|0;do if(f>>>0>=12){h=e;j=42680;k=h+12|0;do{a[h>>0]=a[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(k|0));h=bf(g)|0;if(!h){a[m+12+9>>0]=57;a[m+12+8>>0]=49;b[m>>1]=d[m+12+8>>0]|d[m+12+8+1>>0]<<8;a[m+2>>0]=0;l=Kh(m)|0;if((f+-11|0)>>>0<=l>>>0){h=-31;break}bi(e+11|0,m|0,l+1|0)|0;e=e+11+l|0;if((f+-11-l|0)>>>0>=4){a[e>>0]=36;a[e+1>>0]=109;a[e+2>>0]=61;a[e+3>>0]=0;h=c[g+44>>2]|0;k=10;while(1){j=k+-1|0;a[m+12+j>>0]=(h>>>0)%10|0|48;if(h>>>0>9&(j|0)!=0){h=(h>>>0)/10|0;k=j}else break}h=11-k|0;bi(m|0,m+12+j|0,h|0)|0;a[m+h>>0]=0;h=Kh(m)|0;if((f+-11-l+-3|0)>>>0<=h>>>0){h=-31;break}bi(e+3|0,m|0,h+1|0)|0;e=e+3+h|0;f=f+-11-l+-3-h|0;if(f>>>0>=4){a[e>>0]=44;a[e+1>>0]=116;a[e+2>>0]=61;a[e+3>>0]=0;h=c[g+40>>2]|0;k=10;while(1){j=k+-1|0;a[m+12+j>>0]=(h>>>0)%10|0|48;if(h>>>0>9&(j|0)!=0){h=(h>>>0)/10|0;k=j}else break}l=11-k|0;bi(m|0,m+12+j|0,l|0)|0;a[m+l>>0]=0;l=Kh(m)|0;if((f+-3|0)>>>0<=l>>>0){h=-31;break}bi(e+3|0,m|0,l+1|0)|0;e=e+3+l|0;if((f+-3-l|0)>>>0>=4){a[e>>0]=44;a[e+1>>0]=112;a[e+2>>0]=61;a[e+3>>0]=0;h=c[g+48>>2]|0;k=10;while(1){j=k+-1|0;a[m+12+j>>0]=(h>>>0)%10|0|48;if(h>>>0>9&(j|0)!=0){h=(h>>>0)/10|0;k=j}else break}h=11-k|0;bi(m|0,m+12+j|0,h|0)|0;a[m+h>>0]=0;h=Kh(m)|0;if((f+-3-l+-3|0)>>>0<=h>>>0){h=-31;break}bi(e+3|0,m|0,h+1|0)|0;j=e+3+h|0;h=f+-3-l+-3-h|0;if(c[g+36>>2]|0){if(h>>>0<7){h=-31;break}a[j>>0]=a[42673]|0;a[j+1>>0]=a[42674]|0;a[j+2>>0]=a[42675]|0;a[j+3>>0]=a[42676]|0;a[j+4>>0]=a[42677]|0;a[j+5>>0]=a[42678]|0;a[j+6>>0]=a[42679]|0;k=jg(j+6|0,h+-6|0,c[g+32>>2]|0,c[g+36>>2]|0)|0;if((k|0)==-1){h=-31;break}else{j=j+6+k|0;h=h+-6-((k|0)==-1?0:k)|0}}if(c[g+20>>2]|0)if(h>>>0>=2?(a[j>>0]=36,a[j+1>>0]=0,n=j+1|0,o=h+-1|0,m=jg(n,o,c[g+16>>2]|0,c[g+20>>2]|0)|0,o=o-((m|0)==-1?0:m)|0,n=(m|0)==-1?n:n+m|0,(m|0)!=-1):0)if(c[g+4>>2]|0)if(o>>>0<2)h=-31;else{a[n>>0]=36;a[n+1>>0]=0;g=(jg(n+1|0,o+-1|0,c[g>>2]|0,c[g+4>>2]|0)|0)!=-1;i=p;return (g?0:-31)|0}else h=0;else h=-31;else h=0}else h=-31}else h=-31}else h=-31}}else h=-31;while(0);i=p;return h|0}function id(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+464|0;b=Wm(f)|0;o=0;q=va(32,b|0,52364)|0;p=o;o=0;do if(p&1)u=22;else{j=a[h+8+3>>0]|0;if(!((j<<24>>24<0?c[h+4>>2]|0:j&255)|0))p=0;else{j=c[(j<<24>>24<0?c[h>>2]|0:h)>>2]|0;o=0;k=va(c[(c[q>>2]|0)+44>>2]|0,q|0,45)|0;p=o;o=0;if(p&1){u=22;break}p=(j|0)==(k|0)}c[t+436>>2]=0;c[t+436+4>>2]=0;c[t+436+8>>2]=0;j=0;while(1){if((j|0)==3)break;c[t+436+(j<<2)>>2]=0;j=j+1|0}c[t+424>>2]=0;c[t+424+4>>2]=0;c[t+424+8>>2]=0;j=0;while(1){if((j|0)==3)break;c[t+424+(j<<2)>>2]=0;j=j+1|0}c[t+412>>2]=0;c[t+412+4>>2]=0;c[t+412+8>>2]=0;j=0;while(1){if((j|0)==3)break;c[t+412+(j<<2)>>2]=0;j=j+1|0}o=0;ta(21,e|0,p|0,b|0,t+456|0,t+452|0,t+448|0,t+436|0,t+424|0,t+412|0,t+408|0);n=o;o=0;if(!(n&1)){e=a[h+8+3>>0]|0;m=c[h+4>>2]|0;j=e<<24>>24<0?m:e&255;n=c[t+408>>2]|0;if((j|0)>(n|0)){k=a[t+412+8+3>>0]|0;l=a[t+424+8+3>>0]|0;j=(k<<24>>24<0?c[t+412+4>>2]|0:k&255)+(j-n<<1|1)+(l<<24>>24<0?c[t+424+4>>2]|0:l&255)|0}else{l=a[t+412+8+3>>0]|0;j=a[t+424+8+3>>0]|0;j=(l<<24>>24<0?c[t+412+4>>2]|0:l&255)+2+(j<<24>>24<0?c[t+424+4>>2]|0:j&255)|0}j=j+n|0;if(j>>>0>100){k=ec(j<<2)|0;if(!k){o=0;Fa(20);m=o;o=0;if(!(m&1)){m=c[h+4>>2]|0;e=a[h+8+3>>0]|0;l=k;j=0;u=26}}else{l=k;j=k;u=26}}else{l=0;j=t+8|0;u=26}if((u|0)==26){k=e<<24>>24<0;h=k?c[h>>2]|0:h;o=0;na(19,j|0,t+4|0,t|0,c[f+4>>2]|0,h|0,h+((k?m:e&255)<<2)|0,q|0,p|0,t+456|0,c[t+452>>2]|0,c[t+448>>2]|0,t+436|0,t+424|0,t+412|0,n|0);h=o;o=0;if(!(h&1)?(o=0,s=fa(57,c[d>>2]|0,j|0,c[t+4>>2]|0,c[t>>2]|0,f|0,g|0)|0,d=o,o=0,!(d&1)):0){if(l)nc(l);dq(t+412|0);dq(t+424|0);rq(t+436|0);en(b);i=r;return s|0}else k=l}j=Ya()|0;if(k)nc(k)}else j=Ya()|0;dq(t+412|0);dq(t+424|0);rq(t+436|0)}while(0);if((u|0)==22)j=Ya()|0;en(b);Ra(j|0);return 0}function jd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+160|0;b=Wm(f)|0;o=0;q=va(32,b|0,52332)|0;p=o;o=0;do if(p&1)u=22;else{j=a[h+11>>0]|0;if(!((j<<24>>24<0?c[h+4>>2]|0:j&255)|0))p=0;else{j=a[(j<<24>>24<0?c[h>>2]|0:h)>>0]|0;o=0;k=va(c[(c[q>>2]|0)+28>>2]|0,q|0,45)|0;p=o;o=0;if(p&1){u=22;break}p=j<<24>>24==k<<24>>24}c[t+36>>2]=0;c[t+36+4>>2]=0;c[t+36+8>>2]=0;j=0;while(1){if((j|0)==3)break;c[t+36+(j<<2)>>2]=0;j=j+1|0}c[t+24>>2]=0;c[t+24+4>>2]=0;c[t+24+8>>2]=0;j=0;while(1){if((j|0)==3)break;c[t+24+(j<<2)>>2]=0;j=j+1|0}c[t+12>>2]=0;c[t+12+4>>2]=0;c[t+12+8>>2]=0;j=0;while(1){if((j|0)==3)break;c[t+12+(j<<2)>>2]=0;j=j+1|0}o=0;ta(20,e|0,p|0,b|0,t+152|0,t+149|0,t+148|0,t+36|0,t+24|0,t+12|0,t+8|0);n=o;o=0;if(!(n&1)){l=a[h+11>>0]|0;e=c[h+4>>2]|0;j=l<<24>>24<0?e:l&255;n=c[t+8>>2]|0;if((j|0)>(n|0)){k=a[t+12+11>>0]|0;m=a[t+24+11>>0]|0;j=(k<<24>>24<0?c[t+12+4>>2]|0:k&255)+(j-n<<1|1)+(m<<24>>24<0?c[t+24+4>>2]|0:m&255)|0}else{m=a[t+12+11>>0]|0;j=a[t+24+11>>0]|0;j=(m<<24>>24<0?c[t+12+4>>2]|0:m&255)+2+(j<<24>>24<0?c[t+24+4>>2]|0:j&255)|0}j=j+n|0;if(j>>>0>100){k=ec(j)|0;if(!k){o=0;Fa(20);m=o;o=0;if(!(m&1)){m=a[h+11>>0]|0;e=c[h+4>>2]|0;l=k;j=0;u=26}}else{m=l;l=k;j=k;u=26}}else{m=l;l=0;j=t+48|0;u=26}if((u|0)==26){k=m<<24>>24<0;h=k?c[h>>2]|0:h;o=0;na(18,j|0,t+4|0,t|0,c[f+4>>2]|0,h|0,h+(k?e:m&255)|0,q|0,p|0,t+152|0,a[t+149>>0]|0,a[t+148>>0]|0,t+36|0,t+24|0,t+12|0,n|0);h=o;o=0;if(!(h&1)?(o=0,s=fa(56,c[d>>2]|0,j|0,c[t+4>>2]|0,c[t>>2]|0,f|0,g|0)|0,d=o,o=0,!(d&1)):0){if(l)nc(l);rq(t+12|0);rq(t+24|0);rq(t+36|0);en(b);i=r;return s|0}else k=l}j=Ya()|0;if(k)nc(k)}else j=Ya()|0;rq(t+12|0);rq(t+24|0);rq(t+36|0)}while(0);if((u|0)==22)j=Ya()|0;en(b);Ra(j|0);return 0}function kd(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=c[e>>2]|0;if((g|0)!=0?(i=c[g>>2]|0,(i|0)!=0):0)if(!b){g=f;j=h;k=15}else{c[g>>2]=0;l=b;g=f;j=i;k=35}else if(!b){g=f;k=7}else{i=b;g=f;k=6}a:while(1)if((k|0)==6){if(!g){k=25;break}else j=i;while(1){i=a[h>>0]|0;b:do if(((i&255)+-1|0)>>>0<127?g>>>0>4&(h&3|0)==0:0){i=j;do{j=c[h>>2]|0;if((j+-16843009|j)&-2139062144|0){b=i;i=j&255;break b}c[i>>2]=j&255;c[i+4>>2]=d[h+1>>0];c[i+8>>2]=d[h+2>>0];k=h;h=h+4|0;l=i;i=i+16|0;c[l+12>>2]=d[k+3>>0];g=g+-4|0}while(g>>>0>4);b=i;i=a[h>>0]|0}else b=j;while(0);j=i&255;if((j+-1|0)>>>0>=127)break;h=h+1|0;c[b>>2]=j;g=g+-1|0;if(!g){k=25;break a}else j=b+4|0}if((j+-194|0)>>>0>50){k=47;break}l=b;j=c[33872+(j+-194<<2)>>2]|0;h=h+1|0;k=35;continue}else if((k|0)==7){i=a[h>>0]|0;if(((i&255)+-1|0)>>>0<127?(h&3|0)==0:0){i=c[h>>2]|0;if(!((i+-16843009|i)&-2139062144)){do{h=h+4|0;g=g+-4|0;i=c[h>>2]|0}while(((i+-16843009|i)&-2139062144|0)==0);i=i&255}else i=i&255}j=i&255;if((j+-1|0)>>>0<127){g=g+-1|0;h=h+1|0;k=7;continue}if((j+-194|0)>>>0>50){k=47;break}i=c[33872+(j+-194<<2)>>2]|0;j=h+1|0;k=15;continue}else if((k|0)==15){l=(d[j>>0]|0)>>>3;if((l+-16|l+(i>>26))>>>0>7){k=16;break}h=j+1|0;if(i&33554432){if((a[h>>0]&-64)<<24>>24!=-128){k=19;break}h=j+2|0;if(i&524288){if((a[h>>0]&-64)<<24>>24!=-128){k=22;break}h=j+3|0}}g=g+-1|0;k=7;continue}else if((k|0)==35){i=d[h>>0]|0;if(((i>>>3)+-16|(i>>>3)+(j>>26))>>>0>7){k=36;break}b=h+1|0;k=i+-128|j<<6;if((k|0)<0){j=d[b>>0]|0;if((j&192|0)!=128){k=39;break}i=h+2|0;if((j+-128|k<<6|0)<0){i=d[i>>0]|0;if((i&192|0)!=128){k=42;break}j=i+-128|(j+-128|k<<6)<<6;h=h+3|0}else{j=j+-128|k<<6;h=i}}else{j=k;h=b}c[l>>2]=j;i=l+4|0;g=g+-1|0;k=6;continue}if((k|0)==16){h=j+-1|0;k=45}else if((k|0)==19){h=j+-1|0;k=45}else if((k|0)==22){h=j+-1|0;k=45}else if((k|0)==25)c[e>>2]=h;else if((k|0)==36){b=l;i=j;h=h+-1|0;k=45}else if((k|0)==39){g=l;f=h+-1|0;k=51}else if((k|0)==42){g=l;f=h+-1|0;k=51}if((k|0)==45)if(!i){i=a[h>>0]|0;k=47}else{g=b;f=h;k=51}if((k|0)==47)if(!(i<<24>>24)){if(b|0){c[b>>2]=0;c[e>>2]=0}f=f-g|0}else{g=b;f=h;k=51}if((k|0)==51){c[(Sq()|0)>>2]=84;if(!g)f=-1;else{c[e>>2]=f;f=-1}}return f|0}function ld(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;s=i;t=i=i+63&-64;i=i+16|0;q=wq(c[j>>2]|0,52332)|0;m=wq(c[j>>2]|0,52344)|0;Gb[c[(c[m>>2]|0)+20>>2]&127](t,m);p=a[t+11>>0]|0;a:do if(!((p<<24>>24<0?c[t+4>>2]|0:p&255)|0)){o=0;Ba(c[(c[q>>2]|0)+32>>2]|0,q|0,b|0,e|0,f|0)|0;r=o;o=0;if(r&1)r=5;else{c[h>>2]=f+(e-b);k=b;j=f+(e-b)|0;r=30}}else{c[h>>2]=f;j=a[b>>0]|0;switch(j<<24>>24){case 43:case 45:{o=0;j=va(c[(c[q>>2]|0)+28>>2]|0,q|0,j|0)|0;p=o;o=0;if(p&1){r=5;break a}l=c[h>>2]|0;c[h>>2]=l+1;a[l>>0]=j;l=b+1|0;break}default:l=b}b:do if((e-l|0)>1?(a[l>>0]|0)==48:0){j=l+1|0;switch(a[j>>0]|0){case 88:case 120:break;default:break b}o=0;k=va(c[(c[q>>2]|0)+28>>2]|0,q|0,48)|0;p=o;o=0;if(p&1){r=5;break a}p=c[h>>2]|0;c[h>>2]=p+1;a[p>>0]=k;o=0;j=va(c[(c[q>>2]|0)+28>>2]|0,q|0,a[j>>0]|0)|0;p=o;o=0;if(p&1){r=5;break a}p=c[h>>2]|0;c[h>>2]=p+1;a[p>>0]=j;l=l+2|0}while(0);c:do if((l|0)!=(e|0)){j=e;k=l;while(1){j=j+-1|0;if(k>>>0>=j>>>0)break c;p=a[k>>0]|0;a[k>>0]=a[j>>0]|0;a[j>>0]=p;k=k+1|0}}while(0);o=0;n=ha(c[(c[m>>2]|0)+16>>2]|0,m|0)|0;p=o;o=0;if(!(p&1)){j=0;k=0;p=l;while(1){if(p>>>0>=e>>>0)break;m=a[((a[t+11>>0]|0)<0?c[t>>2]|0:t)+k>>0]|0;if(m<<24>>24!=0&(j|0)==(m<<24>>24|0)){j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=n;j=a[t+11>>0]|0;m=0;k=(k>>>0<((j<<24>>24<0?c[t+4>>2]|0:j&255)+-1|0)>>>0&1)+k|0}else m=j;o=0;j=va(c[(c[q>>2]|0)+28>>2]|0,q|0,a[p>>0]|0)|0;u=o;o=0;if(u&1){r=4;break}u=c[h>>2]|0;c[h>>2]=u+1;a[u>>0]=j;j=m+1|0;p=p+1|0}if((r|0)==4){j=Ya()|0;break}j=f+(l-b)|0;k=c[h>>2]|0;if((j|0)==(k|0)){k=b;r=30}else{while(1){k=k+-1|0;if(j>>>0>=k>>>0)break;u=a[j>>0]|0;a[j>>0]=a[k>>0]|0;a[k>>0]=u;j=j+1|0}k=b;j=c[h>>2]|0;r=30}}else r=5}while(0);if((r|0)==5)j=Ya()|0;else if((r|0)==30){c[g>>2]=(d|0)==(e|0)?j:f+(d-k)|0;rq(t);i=s;return}rq(t);Ra(j|0)}function md(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;s=i;t=i=i+63&-64;i=i+16|0;q=wq(c[j>>2]|0,52364)|0;m=wq(c[j>>2]|0,52372)|0;Gb[c[(c[m>>2]|0)+20>>2]&127](t,m);p=a[t+11>>0]|0;a:do if(!((p<<24>>24<0?c[t+4>>2]|0:p&255)|0)){o=0;Ba(c[(c[q>>2]|0)+48>>2]|0,q|0,b|0,e|0,f|0)|0;r=o;o=0;if(r&1)r=5;else{c[h>>2]=f+(e-b<<2);k=b;j=f+(e-b<<2)|0;r=29}}else{c[h>>2]=f;j=a[b>>0]|0;switch(j<<24>>24){case 43:case 45:{o=0;j=va(c[(c[q>>2]|0)+44>>2]|0,q|0,j|0)|0;p=o;o=0;if(p&1){r=5;break a}l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=j;l=b+1|0;break}default:l=b}b:do if((e-l|0)>1?(a[l>>0]|0)==48:0){j=l+1|0;switch(a[j>>0]|0){case 88:case 120:break;default:break b}o=0;k=va(c[(c[q>>2]|0)+44>>2]|0,q|0,48)|0;p=o;o=0;if(p&1){r=5;break a}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=k;o=0;j=va(c[(c[q>>2]|0)+44>>2]|0,q|0,a[j>>0]|0)|0;p=o;o=0;if(p&1){r=5;break a}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=j;l=l+2|0}while(0);c:do if((l|0)!=(e|0)){j=e;k=l;while(1){j=j+-1|0;if(k>>>0>=j>>>0)break c;p=a[k>>0]|0;a[k>>0]=a[j>>0]|0;a[j>>0]=p;k=k+1|0}}while(0);o=0;n=ha(c[(c[m>>2]|0)+16>>2]|0,m|0)|0;p=o;o=0;if(!(p&1)){k=0;m=0;p=l;while(1){if(p>>>0>=e>>>0)break;j=a[t+11>>0]|0;u=a[(j<<24>>24<0?c[t>>2]|0:t)+m>>0]|0;if(u<<24>>24!=0&(k|0)==(u<<24>>24|0)){k=c[h>>2]|0;c[h>>2]=k+4;c[k>>2]=n;k=0;m=(m>>>0<((j<<24>>24<0?c[t+4>>2]|0:j&255)+-1|0)>>>0&1)+m|0}o=0;j=va(c[(c[q>>2]|0)+44>>2]|0,q|0,a[p>>0]|0)|0;u=o;o=0;if(u&1){r=4;break}u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=j;k=k+1|0;p=p+1|0}if((r|0)==4){j=Ya()|0;break}j=f+(l-b<<2)|0;l=c[h>>2]|0;if((j|0)==(l|0)){k=b;r=29}else{k=l;while(1){k=k+-4|0;if(j>>>0>=k>>>0){k=b;j=l;r=29;break a}u=c[j>>2]|0;c[j>>2]=c[k>>2];c[k>>2]=u;j=j+4|0}}}else r=5}while(0);if((r|0)==5)j=Ya()|0;else if((r|0)==29){c[g>>2]=(d|0)==(e|0)?j:f+(d-k<<2)|0;rq(t);i=s;return}rq(t);Ra(j|0)}function nd(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=c[a>>2]|0;do if(i){if((c[i+12>>2]|0)==(c[i+16>>2]|0))if((Ib[c[(c[i>>2]|0)+36>>2]&127](i)|0)==-1){c[a>>2]=0;i=0;break}else{i=c[a>>2]|0;break}}else i=0;while(0);i=(i|0)==0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(Ib[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){o=10;break}if(i){k=e;o=12}else o=11}else o=10;while(0);if((o|0)==10)if(i)o=11;else{k=0;o=12}a:do if((o|0)==11){c[f>>2]=c[f>>2]|6;i=0}else if((o|0)==12){i=c[a>>2]|0;e=c[i+12>>2]|0;if((e|0)==(c[i+16>>2]|0))i=Ib[c[(c[i>>2]|0)+36>>2]&127](i)|0;else i=d[e>>0]|0;e=i&255;if(e<<24>>24>-1?b[(c[g+8>>2]|0)+(i<<24>>24<<1)>>1]&2048:0){i=(Kb[c[(c[g>>2]|0)+36>>2]&63](g,e,0)|0)<<24>>24;e=c[a>>2]|0;j=c[e+12>>2]|0;if((j|0)==(c[e+16>>2]|0)){Ib[c[(c[e>>2]|0)+40>>2]&127](e)|0;l=k}else{c[e+12>>2]=j+1;l=k}while(1){i=i+-48|0;m=h+-1|0;e=c[a>>2]|0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0))if((Ib[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[a>>2]=0;e=0;break}else{e=c[a>>2]|0;break}}else e=0;while(0);j=(e|0)==0;if(k)if((c[k+12>>2]|0)==(c[k+16>>2]|0)){k=(Ib[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;n=k?0:l;k=k?0:l}else n=l;else{n=l;k=0}e=c[a>>2]|0;if(!((h|0)>1&(j^(k|0)==0)))break;j=c[e+12>>2]|0;if((j|0)==(c[e+16>>2]|0))e=Ib[c[(c[e>>2]|0)+36>>2]&127](e)|0;else e=d[j>>0]|0;j=e&255;if(j<<24>>24<=-1)break a;if(!(b[(c[g+8>>2]|0)+(e<<24>>24<<1)>>1]&2048))break a;i=((Kb[c[(c[g>>2]|0)+36>>2]&63](g,j,0)|0)<<24>>24)+(i*10|0)|0;e=c[a>>2]|0;j=c[e+12>>2]|0;if((j|0)==(c[e+16>>2]|0)){Ib[c[(c[e>>2]|0)+40>>2]&127](e)|0;h=m;l=n;continue}else{c[e+12>>2]=j+1;h=m;l=n;continue}}do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0))if((Ib[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[a>>2]=0;e=0;break}else{e=c[a>>2]|0;break}}else e=0;while(0);e=(e|0)==0;do if(n){if((c[n+12>>2]|0)==(c[n+16>>2]|0)?(Ib[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1:0){o=47;break}if(e)break a}else o=47;while(0);if((o|0)==47?!e:0)break;c[f>>2]=c[f>>2]|2;break}c[f>>2]=c[f>>2]|4;i=0}while(0);return i|0}function od(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!b)if(!e){if(f|0){c[f>>2]=(a>>>0)%(d>>>0);c[f+4>>2]=0}e=0;f=(a>>>0)/(d>>>0)>>>0;return (D=e,f)|0}else{if(!f){e=0;f=0;return (D=e,f)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;e=0;f=0;return (D=e,f)|0}do if(d){if(e|0){h=(U(e|0)|0)-(U(b|0)|0)|0;if(h>>>0<=31){n=h+1|0;i=a>>>((h+1|0)>>>0)&h-31>>31|b<<31-h;m=b>>>((h+1|0)>>>0)&h-31>>31;g=0;h=a<<31-h;break}if(!f){e=0;f=0;return (D=e,f)|0}c[f>>2]=a|0;c[f+4>>2]=b|b&0;e=0;f=0;return (D=e,f)|0}if(d-1&d|0){h=(U(d|0)|0)+33-(U(b|0)|0)|0;n=h;i=32-h-1>>31&b>>>((h-32|0)>>>0)|(b<<32-h|a>>>(h>>>0))&h-32>>31;m=h-32>>31&b>>>(h>>>0);g=a<<64-h&32-h>>31;h=(b<<64-h|a>>>((h-32|0)>>>0))&32-h>>31|a<<32-h&h-33>>31;break}if(f|0){c[f>>2]=d-1&a;c[f+4>>2]=0}if((d|0)==1){e=b|b&0;f=a|0|0;return (D=e,f)|0}else{f=ol(d|0)|0;e=b>>>(f>>>0)|0;f=b<<32-f|a>>>(f>>>0)|0;return (D=e,f)|0}}else{if(!e){if(f|0){c[f>>2]=(b>>>0)%(d>>>0);c[f+4>>2]=0}e=0;f=(b>>>0)/(d>>>0)>>>0;return (D=e,f)|0}if(!a){if(f|0){c[f>>2]=0;c[f+4>>2]=(b>>>0)%(e>>>0)}d=0;f=(b>>>0)/(e>>>0)>>>0;return (D=d,f)|0}if(!(e-1&e)){if(f|0){c[f>>2]=a|0;c[f+4>>2]=e-1&b|b&0}d=0;f=b>>>((ol(e|0)|0)>>>0);return (D=d,f)|0}h=(U(e|0)|0)-(U(b|0)|0)|0;if(h>>>0<=30){n=h+1|0;i=b<<31-h|a>>>((h+1|0)>>>0);m=b>>>((h+1|0)>>>0);g=0;h=a<<31-h;break}if(!f){e=0;f=0;return (D=e,f)|0}c[f>>2]=a|0;c[f+4>>2]=b|b&0;e=0;f=0;return (D=e,f)|0}while(0);if(!n){j=h;b=m;a=0;h=0}else{k=Jp(d|0|0,e|e&0|0,-1,-1)|0;l=D;j=h;b=m;a=n;h=0;do{p=j;j=g>>>31|j<<1;g=h|g<<1;p=i<<1|p>>>31|0;o=i>>>31|b<<1|0;mo(k|0,l|0,p|0,o|0)|0;n=D;m=n>>31|((n|0)<0?-1:0)<<1;h=m&1;i=mo(p|0,o|0,m&(d|0)|0,(((n|0)<0?-1:0)>>31|((n|0)<0?-1:0)<<1)&(e|e&0)|0)|0;b=D;a=a-1|0}while((a|0)!=0);a=0}if(f|0){c[f>>2]=i;c[f+4>>2]=b}o=(g|0)>>>31|j<<1|(0<<1|g>>>31)&0|a;p=(g<<1|0>>>31)&-2|h;return (D=o,p)|0}function pd(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0;q=i;r=i=i+63&-64;i=i+432|0;c[r+8>>2]=r+16;c[r+8+4>>2]=140;p=Wm(g)|0;o=0;l=va(32,p|0,52364)|0;b=o;o=0;a:do if(!(b&1)?(a[r+416>>0]=0,m=c[e>>2]|0,o=0,k=ja(19,d|0,m|0,f|0,p|0,c[g+4>>2]|0,h|0,r+416|0,l|0,r+8|0,r|0,r+16+400|0)|0,g=o,o=0,!(g&1)):0){if(k){if((a[j+8+3>>0]|0)<0){c[c[j>>2]>>2]=0;c[j+4>>2]=0}else{c[j>>2]=0;a[j+8+3>>0]=0}if(a[r+416>>0]|0){o=0;b=va(c[(c[l>>2]|0)+44>>2]|0,l|0,45)|0;g=o;o=0;if(g&1)break;o=0;da(62,j|0,b|0);g=o;o=0;if(g&1)break}o=0;b=va(c[(c[l>>2]|0)+44>>2]|0,l|0,48)|0;g=o;o=0;if(g&1)break;k=c[r>>2]|0;l=c[r+8>>2]|0;while(1){if(l>>>0>=(k+-4|0)>>>0)break;if((c[l>>2]|0)!=(b|0))break;l=l+4|0}o=0;Da(25,j|0,l|0,k|0);j=o;o=0;if(j&1)break}b=c[d>>2]|0;do if(b){k=c[b+12>>2]|0;if((k|0)==(c[b+16>>2]|0)){o=0;b=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;j=o;o=0;if(j&1)break a}else b=c[k>>2]|0;if((b|0)==-1){c[d>>2]=0;k=1;break}else{k=(c[d>>2]|0)==0;break}}else k=1;while(0);do if(m){b=c[m+12>>2]|0;if((b|0)==(c[m+16>>2]|0)){o=0;b=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;m=o;o=0;if(m&1)break a}else b=c[b>>2]|0;if((b|0)!=-1)if(k)break;else{n=31;break}else{c[e>>2]=0;n=29;break}}else n=29;while(0);if((n|0)==29?k:0)n=31;if((n|0)==31)c[h>>2]=c[h>>2]|2;k=c[d>>2]|0;en(p);b=c[r+8>>2]|0;c[r+8>>2]=0;if(b|0?(o=0,ba(c[r+8+4>>2]|0,b|0),r=o,o=0,r&1):0){r=Za(0)|0;lt(r)}i=q;return k|0}while(0);k=Ya()|0;en(p);b=c[r+8>>2]|0;c[r+8>>2]=0;if(b|0?(o=0,ba(c[r+8+4>>2]|0,b|0),r=o,o=0,r&1):0){r=Za(0)|0;lt(r)}Ra(k|0);return 0}function qd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=i=i+63&-64;i=i+2400|0;Wf(h+2136|0,d);Wf(h+1880|0,f);Bg(h+480|0,e);Ce(h+1760|0,e);rh(h+320|0,h+1760|0);Rk(h,h+320|0);Ag(h+320|0,h,h+480|0);Rk(h+160|0,h+320|0);Bg(h+480+160|0,h+160|0);Ag(h+320|0,h,h+480+160|0);Rk(h+160|0,h+320|0);Bg(h+480+320|0,h+160|0);Ag(h+320|0,h,h+480+320|0);Rk(h+160|0,h+320|0);Bg(h+480+480|0,h+160|0);Ag(h+320|0,h,h+480+480|0);Rk(h+160|0,h+320|0);Bg(h+480+640|0,h+160|0);Ag(h+320|0,h,h+480+640|0);Rk(h+160|0,h+320|0);Bg(h+480+800|0,h+160|0);Ag(h+320|0,h,h+480+800|0);Rk(h+160|0,h+320|0);Bg(h+480+960|0,h+160|0);Ag(h+320|0,h,h+480+960|0);Rk(h+160|0,h+320|0);Bg(h+480+1120|0,h+160|0);e=b;d=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(d|0));c[b+40>>2]=1;e=b+44|0;d=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(d|0));c[b+80>>2]=1;e=b+84|0;d=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(d|0));d=255;while(1){if(a[h+2136+d>>0]|0){e=d;break}if(a[h+1880+d>>0]|0){e=d;break}e=d+-1|0;if((d|0)>0)d=e;else break}if((e|0)>-1)while(1){rh(h+320|0,b);d=a[h+2136+e>>0]|0;if(d<<24>>24<=0){if(d<<24>>24<0){Rk(h+160|0,h+320|0);zg(h+320|0,h+160|0,h+480+(((d<<24>>24|0)/-2|0)*160|0)|0)}}else{Rk(h+160|0,h+320|0);Ag(h+320|0,h+160|0,h+480+(((d<<24>>24|0)/2|0)*160|0)|0)}d=a[h+1880+e>>0]|0;if(d<<24>>24<=0){if(d<<24>>24<0){Rk(h+160|0,h+320|0);Kg(h+320|0,h+160|0,2160+(((d<<24>>24|0)/-2|0)*120|0)|0)}}else{Rk(h+160|0,h+320|0);Lg(h+320|0,h+160|0,2160+(((d<<24>>24|0)/2|0)*120|0)|0)}jm(b,h+320|0);if((e|0)>0)e=e+-1|0;else break}i=g;return}function rd(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0;q=i;r=i=i+63&-64;i=i+128|0;c[r+8>>2]=r+20;c[r+8+4>>2]=140;p=Wm(g)|0;o=0;l=va(32,p|0,52332)|0;b=o;o=0;a:do if(!(b&1)?(a[r+16>>0]=0,m=c[e>>2]|0,o=0,k=ja(18,d|0,m|0,f|0,p|0,c[g+4>>2]|0,h|0,r+16|0,l|0,r+8|0,r|0,r+20+100|0)|0,g=o,o=0,!(g&1)):0){if(k){if((a[j+11>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0}else{a[j>>0]=0;a[j+11>>0]=0}if(a[r+16>>0]|0){o=0;b=va(c[(c[l>>2]|0)+28>>2]|0,l|0,45)|0;g=o;o=0;if(g&1)break;o=0;da(61,j|0,b|0);g=o;o=0;if(g&1)break}o=0;b=va(c[(c[l>>2]|0)+28>>2]|0,l|0,48)|0;g=o;o=0;if(g&1)break;k=c[r>>2]|0;l=c[r+8>>2]|0;while(1){if(l>>>0>=(k+-1|0)>>>0)break;if((a[l>>0]|0)!=b<<24>>24)break;l=l+1|0}o=0;Da(23,j|0,l|0,k|0);j=o;o=0;if(j&1)break}b=c[d>>2]|0;do if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)){o=0;b=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;j=o;o=0;if(j&1)break a;if((b|0)==-1){c[d>>2]=0;b=0;break}else{b=c[d>>2]|0;break}}}else b=0;while(0);k=(b|0)==0;do if(m){if((c[m+12>>2]|0)==(c[m+16>>2]|0)){o=0;b=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;m=o;o=0;if(m&1)break a;if((b|0)==-1){c[e>>2]=0;n=28;break}}if(!k)n=29}else n=28;while(0);if((n|0)==28?k:0)n=29;if((n|0)==29)c[h>>2]=c[h>>2]|2;k=c[d>>2]|0;en(p);b=c[r+8>>2]|0;c[r+8>>2]=0;if(b|0?(o=0,ba(c[r+8+4>>2]|0,b|0),r=o,o=0,r&1):0){r=Za(0)|0;lt(r)}i=q;return k|0}while(0);k=Ya()|0;en(p);b=c[r+8>>2]|0;c[r+8>>2]=0;if(b|0?(o=0,ba(c[r+8+4>>2]|0,b|0),r=o,o=0,r&1):0){r=Za(0)|0;lt(r)}Ra(k|0);return 0}function sd(a,b){a=+a;b=+b;var d=0,e=0,f=0,g=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0;h[k>>3]=a;d=c[k>>2]|0;o=c[k+4>>2]|0;h[k>>3]=b;m=c[k>>2]|0;n=c[k+4>>2]|0;j=bo(d|0,o|0,52)|0;l=bo(m|0,n|0,52)|0;g=_n(m|0,n|0,1)|0;i=D;a:do if(!((g|0)==0&(i|0)==0)?(q=+F(+b),h[k>>3]=q,f=c[k+4>>2]|0,!(f>>>0>2146435072|(f|0)==2146435072&(c[k>>2]|0)>>>0>0|(j&2047|0)==2047)):0){e=_n(d|0,o|0,1)|0;f=D;if(!(f>>>0>i>>>0|(f|0)==(i|0)&e>>>0>g>>>0))return +((e|0)==(g|0)&(f|0)==(i|0)?a*0.0:a);if(!(j&2047)){e=_n(d|0,o|0,12)|0;f=D;if((f|0)>-1|(f|0)==-1&e>>>0>4294967295){g=e;e=0;do{e=e+-1|0;g=_n(g|0,f|0,1)|0;f=D}while((f|0)>-1|(f|0)==-1&g>>>0>4294967295)}else e=0;d=_n(d|0,o|0,1-e|0)|0;f=D}else{f=o&1048575|1048576;e=j&2047}if(!(l&2047)){g=_n(m|0,n|0,12)|0;i=D;if((i|0)>-1|(i|0)==-1&g>>>0>4294967295){j=0;do{j=j+-1|0;g=_n(g|0,i|0,1)|0;i=D}while((i|0)>-1|(i|0)==-1&g>>>0>4294967295)}else j=0;m=_n(m|0,n|0,1-j|0)|0;n=D}else{n=n&1048575|1048576;j=l&2047}i=mo(d|0,f|0,m|0,n|0)|0;g=D;b:do if((e|0)>(j|0)){l=(g|0)>-1|(g|0)==-1&i>>>0>4294967295;while(1){if(l)if((d|0)==(m|0)&(f|0)==(n|0))break;else{d=i;f=g}d=_n(d|0,f|0,1)|0;f=D;e=e+-1|0;i=mo(d|0,f|0,m|0,n|0)|0;g=D;if((e|0)>(j|0))l=(g|0)>-1|(g|0)==-1&i>>>0>4294967295;else{j=(g|0)>-1|(g|0)==-1&i>>>0>4294967295;break b}}b=a*0.0;break a}else j=(g|0)>-1|(g|0)==-1&i>>>0>4294967295;while(0);if(j)if((d|0)==(m|0)&(f|0)==(n|0)){b=a*0.0;break}else{f=g;d=i}if(f>>>0<1048576|(f|0)==1048576&d>>>0<0)do{d=_n(d|0,f|0,1)|0;f=D;e=e+-1|0}while(f>>>0<1048576|(f|0)==1048576&d>>>0<0);if((e|0)>0){n=Jp(d|0,f|0,0,-1048576)|0;d=D;e=_n(e|0,0,52)|0;d=d|D;e=n|e}else{e=bo(d|0,f|0,1-e|0)|0;d=D}c[k>>2]=e;c[k+4>>2]=d|o&-2147483648;b=+h[k>>3]}else p=3;while(0);if((p|0)==3)b=a*b/(a*b);return +b}function td(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=i=i+63&-64;i=i+160|0;lc(d+120|0,b);lc(d+80|0,d+120|0);lc(d+80|0,d+80|0);ic(d+80|0,b,d+80|0);ic(d+120|0,d+120|0,d+80|0);lc(d+40|0,d+120|0);ic(d+80|0,d+80|0,d+40|0);lc(d+40|0,d+80|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);ic(d+80|0,d+40|0,d+80|0);lc(d+40|0,d+80|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);ic(d+40|0,d+40|0,d+80|0);lc(d,d+40|0);b=1;do{lc(d,d);b=b+1|0}while((b|0)!=20);ic(d+40|0,d,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);lc(d+40|0,d+40|0);ic(d+80|0,d+40|0,d+80|0);lc(d+40|0,d+80|0);b=1;do{lc(d+40|0,d+40|0);b=b+1|0}while((b|0)!=50);ic(d+40|0,d+40|0,d+80|0);lc(d,d+40|0);b=1;do{lc(d,d);b=b+1|0}while((b|0)!=100);ic(d+40|0,d,d+40|0);lc(d+40|0,d+40|0);b=1;do{lc(d+40|0,d+40|0);b=b+1|0}while((b|0)!=50);ic(d+80|0,d+40|0,d+80|0);lc(d+80|0,d+80|0);lc(d+80|0,d+80|0);lc(d+80|0,d+80|0);lc(d+80|0,d+80|0);lc(d+80|0,d+80|0);ic(a,d+80|0,d+120|0);i=c;return}function ud(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;a:do if((b|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)==(e|0)?(c[d+28>>2]|0)!=1:0)c[d+28>>2]=f}else{if((b|0)!=(c[d>>2]|0)){i=c[b+12>>2]|0;gj(b+16|0,d,e,f,g);if((i|0)<=1)break;h=c[b+8>>2]|0;if((h&2|0)==0?(c[d+36>>2]|0)!=1:0){if(!(h&1)){h=b+24|0;while(1){if(a[d+54>>0]|0)break a;if((c[d+36>>2]|0)==1)break a;gj(h,d,e,f,g);h=h+8|0;if(h>>>0>=(b+16+(i<<3)|0)>>>0)break a}}h=b+24|0;while(1){if(a[d+54>>0]|0)break a;if((c[d+36>>2]|0)==1?(c[d+24>>2]|0)==1:0)break a;gj(h,d,e,f,g);h=h+8|0;if(h>>>0>=(b+16+(i<<3)|0)>>>0)break a}}h=b+24|0;while(1){if(a[d+54>>0]|0)break a;gj(h,d,e,f,g);h=h+8|0;if(h>>>0>=(b+16+(i<<3)|0)>>>0)break a}}if((c[d+16>>2]|0)!=(e|0)?(c[d+20>>2]|0)!=(e|0):0){c[d+32>>2]=f;if((c[d+44>>2]|0)==4)break;f=b+16+(c[b+12>>2]<<3)|0;k=0;h=0;j=b+16|0;b:while(1){if(j>>>0>=f>>>0){i=20;break}a[d+52>>0]=0;a[d+53>>0]=0;Wi(j,d,e,e,1,g);if(a[d+54>>0]|0){i=20;break}do if(a[d+53>>0]|0){if(!(a[d+52>>0]|0))if(!(c[b+8>>2]&1)){h=1;i=20;break b}else{i=k;h=1;break}if((c[d+24>>2]|0)==1){i=25;break b}if(!(c[b+8>>2]&2)){i=25;break b}else{i=1;h=1}}else i=k;while(0);k=i;j=j+8|0}do if((i|0)==20){if((!k?(c[d+20>>2]=e,c[d+40>>2]=(c[d+40>>2]|0)+1,(c[d+36>>2]|0)==1):0)?(c[d+24>>2]|0)==2:0){a[d+54>>0]=1;if(h){i=25;break}else{h=4;break}}if(h)i=25;else h=4}while(0);if((i|0)==25)h=3;c[d+44>>2]=h;break}if((f|0)==1)c[d+32>>2]=1}while(0);return}function vd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;k=i=i+63&-64;i=i+224|0;c[k+16>>2]=0;c[k+16+4>>2]=0;c[k+16+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[k+16+(e<<2)>>2]=0;e=e+1|0}c[k+8+4>>2]=0;c[k+8>>2]=40448;d=a[h+8+3>>0]|0;g=d<<24>>24<0?c[h>>2]|0:h;d=g+((d<<24>>24<0?c[h+4>>2]|0:d&255)<<2)|0;e=0;a:while(1){if(!((e|0)!=2&g>>>0<d>>>0)){g=16;break}c[k+176>>2]=g;o=0;f=Ha(c[(c[k+8>>2]|0)+12>>2]|0,k+8|0,k+184|0,g|0,d|0,k+176|0,k+192|0,k+192+32|0,k+180|0)|0;h=o;o=0;if(h&1){g=14;break}if((f|0)==2?1:(c[k+176>>2]|0)==(g|0)){g=8;break}else e=k+192|0;while(1){if(e>>>0>=(c[k+180>>2]|0)>>>0)break;o=0;da(61,k+16|0,a[e>>0]|0);h=o;o=0;if(h&1){g=13;break a}e=e+1|0}g=c[k+176>>2]|0;e=f}if((g|0)==8){o=0;ba(141,48258);o=0;e=Ya()|0;g=15}else if((g|0)==13){e=Ya()|0;g=15}else if((g|0)==14){e=Ya()|0;g=15}else if((g|0)==16){e=(a[k+16+11>>0]|0)<0?c[k+16>>2]|0:k+16|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;g=0;while(1){if((g|0)==3)break;c[b+(g<<2)>>2]=0;g=g+1|0}g=nv(e)|0;c[k+4>>2]=0;c[k>>2]=40496;d=g+(Kh(g)|0)|0;e=0;b:while(1){if(!((e|0)!=2&g>>>0<d>>>0)){g=28;break}c[k+28>>2]=g;o=0;f=Ha(c[(c[k>>2]|0)+16>>2]|0,k|0,k+168|0,g|0,((d-g|0)>32?g+32|0:d)|0,k+28|0,k+40|0,k+40+128|0,k+32|0)|0;h=o;o=0;if(h&1){g=30;break}if((f|0)==2?1:(c[k+28>>2]|0)==(g|0)){g=23;break}else e=k+40|0;while(1){if(e>>>0>=(c[k+32>>2]|0)>>>0)break;o=0;da(62,b|0,c[e>>2]|0);h=o;o=0;if(h&1){g=29;break b}e=e+4|0}g=c[k+28>>2]|0;e=f}if((g|0)==23){o=0;ba(141,48258);o=0;e=Ya()|0}else if((g|0)==28){rq(k+16|0);i=j;return}else if((g|0)==29)e=Ya()|0;else if((g|0)==30)e=Ya()|0;dq(b)}rq(k+16|0);Ra(e|0)}function wd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;u=i;v=i=i+63&-64;i=i+64|0;b=v;d=a;e=b+64|0;do{c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0}while((b|0)<(e|0));b=c[v+44>>2]|0;e=c[v+60>>2]|0;f=c[v+12>>2]|0;g=c[v+28>>2]|0;h=c[v+48>>2]|0;j=c[v>>2]|0;k=c[v+16>>2]|0;l=c[v+32>>2]|0;d=c[v+4>>2]|0;m=c[v+20>>2]|0;n=c[v+36>>2]|0;o=c[v+52>>2]|0;p=c[v+24>>2]|0;q=c[v+40>>2]|0;r=c[v+56>>2]|0;s=c[v+8>>2]|0;t=0;do{F=h+j|0;F=(F<<7|F>>>25)^k;C=F+j|0;C=(C<<9|C>>>23)^l;z=(C+F<<13|(C+F|0)>>>19)^h;I=(z+C<<18|(z+C|0)>>>14)^j;B=d+m|0;B=(B<<7|B>>>25)^n;y=B+m|0;y=(y<<9|y>>>23)^o;L=(y+B<<13|(y+B|0)>>>19)^d;E=(L+y<<18|(L+y|0)>>>14)^m;x=p+q|0;x=(x<<7|x>>>25)^r;K=x+q|0;K=(K<<9|K>>>23)^s;H=(K+x<<13|(K+x|0)>>>19)^p;A=(H+K<<18|(H+K|0)>>>14)^q;J=b+e|0;J=(J<<7|J>>>25)^f;G=J+e|0;G=(G<<9|G>>>23)^g;D=(G+J<<13|(G+J|0)>>>19)^b;w=(D+G<<18|(D+G|0)>>>14)^e;d=(J+I<<7|(J+I|0)>>>25)^L;L=d+I|0;s=(L<<9|L>>>23)^K;K=s+d|0;f=(K<<13|K>>>19)^J;J=f+s|0;j=(J<<18|J>>>14)^I;p=(F+E<<7|(F+E|0)>>>25)^H;H=p+E|0;g=(H<<9|H>>>23)^G;G=g+p|0;k=(G<<13|G>>>19)^F;F=k+g|0;m=(F<<18|F>>>14)^E;b=(B+A<<7|(B+A|0)>>>25)^D;D=b+A|0;l=(D<<9|D>>>23)^C;C=l+b|0;n=(C<<13|C>>>19)^B;B=n+l|0;q=(B<<18|B>>>14)^A;h=(x+w<<7|(x+w|0)>>>25)^z;z=h+w|0;o=(z<<9|z>>>23)^y;y=o+h|0;r=(y<<13|y>>>19)^x;x=r+o|0;e=(x<<18|x>>>14)^w;t=t+2|0}while(t>>>0<8);c[v>>2]=j;c[v+48>>2]=h;c[v+16>>2]=k;c[v+32>>2]=l;c[v+20>>2]=m;c[v+4>>2]=d;c[v+36>>2]=n;c[v+52>>2]=o;c[v+40>>2]=q;c[v+24>>2]=p;c[v+56>>2]=r;c[v+8>>2]=s;c[v+60>>2]=e;c[v+44>>2]=b;c[v+12>>2]=f;c[v+28>>2]=g;c[a>>2]=(c[a>>2]|0)+j;b=1;while(1){L=a+(b<<2)|0;c[L>>2]=(c[L>>2]|0)+d;b=b+1|0;if((b|0)==16)break;d=c[v+(b<<2)>>2]|0}i=u;return}function xd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=i;e=i=i+63&-64;i=i+128|0;lc(e+80|0,b);lc(e+40|0,e+80|0);lc(e+40|0,e+40|0);ic(e+40|0,b,e+40|0);ic(e+80|0,e+80|0,e+40|0);lc(e+80|0,e+80|0);ic(e+80|0,e+40|0,e+80|0);lc(e+40|0,e+80|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);ic(e+80|0,e+40|0,e+80|0);lc(e+40|0,e+80|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);ic(e+40|0,e+40|0,e+80|0);lc(e,e+40|0);c=1;do{lc(e,e);c=c+1|0}while((c|0)!=20);ic(e+40|0,e,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);lc(e+40|0,e+40|0);ic(e+80|0,e+40|0,e+80|0);lc(e+40|0,e+80|0);c=1;do{lc(e+40|0,e+40|0);c=c+1|0}while((c|0)!=50);ic(e+40|0,e+40|0,e+80|0);lc(e,e+40|0);c=1;do{lc(e,e);c=c+1|0}while((c|0)!=100);ic(e+40|0,e,e+40|0);lc(e+40|0,e+40|0);c=1;do{lc(e+40|0,e+40|0);c=c+1|0}while((c|0)!=50);ic(e+80|0,e+40|0,e+80|0);lc(e+80|0,e+80|0);lc(e+80|0,e+80|0);ic(a,e+80|0,b);i=d;return}function yd(e,f,g,h,i,j,k,l){e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;c[g>>2]=e;c[j>>2]=h;if(((((l&4|0)!=0?(m=c[g>>2]|0,(f-m|0)>2):0)?(a[m>>0]|0)==-17:0)?(a[m+1>>0]|0)==-69:0)?(a[m+2>>0]|0)==-65:0){c[g>>2]=m+3;n=f}else n=f;a:while(1){h=c[g>>2]|0;if(h>>>0>=f>>>0){m=0;break}o=c[j>>2]|0;if(o>>>0>=i>>>0){m=1;break}p=a[h>>0]|0;if((p&255)>>>0>k>>>0){m=2;break}do if(p<<24>>24>-1){b[o>>1]=p&255;c[g>>2]=h+1}else{if((p&255)<194){m=2;break a}if((p&255)<224){if((n-h|0)<2){m=1;break a}m=d[h+1>>0]|0;if((m&192|0)!=128){m=2;break a}if((m&63|(p&255)<<6&1984)>>>0>k>>>0){m=2;break a}b[o>>1]=m&63|(p&255)<<6&1984;c[g>>2]=h+2;break}if((p&255)<240){if((n-h|0)<3){m=1;break a}m=a[h+1>>0]|0;e=a[h+2>>0]|0;switch(p&255|0){case 224:{if((m&-32)<<24>>24!=-96){m=2;break a}break}case 237:{if((m&-32)<<24>>24!=-128){m=2;break a}break}default:if((m&-64)<<24>>24!=-128){m=2;break a}}if((e&192|0)!=128){m=2;break a}if((((m&255)<<6&4032|(p&255)<<12|e&63)&65535)>>>0>k>>>0){m=2;break a}b[o>>1]=(m&255)<<6&4032|(p&255)<<12|e&63;c[g>>2]=h+3;break}if((p&255)>=245){m=2;break a}if((n-h|0)<4){m=1;break a}e=a[h+1>>0]|0;l=a[h+2>>0]|0;m=a[h+3>>0]|0;switch(p&255|0){case 240:{if((e+112&255)>=48){m=2;break a}break}case 244:{if((e&-16)<<24>>24!=-128){m=2;break a}break}default:if((e&-64)<<24>>24!=-128){m=2;break a}}if((l&192|0)!=128){m=2;break a}if((m&192|0)!=128){m=2;break a}if((i-o|0)<4){m=1;break a}if(((e&255)<<12&258048|(p&7)<<18|(l&255)<<6&4032|m&63)>>>0>k>>>0){m=2;break a}b[o>>1]=(e&255)<<2&60|(l&255)>>>4&3|(((e&255)>>>4&3|(p&7)<<2)<<6)+16320|55296;c[j>>2]=o+2;b[o+2>>1]=m&63|(l&255)<<6&960|56320;c[g>>2]=(c[g>>2]|0)+4}while(0);c[j>>2]=(c[j>>2]|0)+2}return m|0}function zd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0;q=i;p=i=i+63&-64;i=i+336|0;c[p>>2]=37;c[p+4>>2]=0;g=Of(p+1|0,47456,c[d+4>>2]|0)|0;c[p+296>>2]=p+300;a=zq()|0;if(g){c[p+8>>2]=c[d+8>>2];h[p+8+8>>3]=f;a=ek(p+300|0,30,a,p,p+8|0)|0}else{h[p+24>>3]=f;a=ek(p+300|0,30,a,p,p+24|0)|0}do if((a|0)>29){a=zq()|0;if(g){o=0;c[p+32>>2]=c[d+8>>2];h[p+32+8>>3]=f;a=Ba(23,p+296|0,a|0,p|0,p+32|0)|0;n=o;o=0;if(!(n&1))r=9}else{o=0;h[p+48>>3]=f;a=Ba(23,p+296|0,a|0,p|0,p+48|0)|0;n=o;o=0;if(!(n&1))r=9}if((r|0)==9){g=c[p+296>>2]|0;if(g|0){j=g;k=g;n=g;r=11;break}o=0;Fa(20);n=o;o=0;if(!(n&1)){j=0;k=g;n=g;r=11;break}}a=Ya()|0}else{j=p+300|0;k=p+300|0;n=0;r=11}while(0);if((r|0)==11){l=k+a|0;m=Ch(k,l,c[d+4>>2]|0)|0;do if((k|0)==(p+300|0)){a=p+300|0;k=p+68|0;g=0;r=16}else{g=ec(a<<3)|0;if(!g){o=0;Fa(20);r=o;o=0;if(r&1){g=0;r=14;break}else a=j}else a=k;k=g;r=16}while(0);do if((r|0)==16){j=Wm(d)|0;c[p+56>>2]=j;o=0;ra(21,a|0,m|0,l|0,k|0,p+64|0,p+60|0,p+56|0);m=o;o=0;if(m&1){a=Ya()|0;en(j);break}en(j);o=0;a=fa(57,c[b>>2]|0,k|0,c[p+64>>2]|0,c[p+60>>2]|0,d|0,e|0)|0;r=o;o=0;if(r&1)r=14;else{c[b>>2]=a;if(g|0)nc(g);if(n|0)nc(n);i=q;return a|0}}while(0);if((r|0)==14)a=Ya()|0;if(g|0)nc(g);if(n)nc(n)}Ra(a|0);return 0}function Ad(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0;q=i;p=i=i+63&-64;i=i+336|0;c[p>>2]=37;c[p+4>>2]=0;g=Of(p+1|0,56413,c[d+4>>2]|0)|0;c[p+296>>2]=p+300;a=zq()|0;if(g){c[p+8>>2]=c[d+8>>2];h[p+8+8>>3]=f;a=ek(p+300|0,30,a,p,p+8|0)|0}else{h[p+24>>3]=f;a=ek(p+300|0,30,a,p,p+24|0)|0}do if((a|0)>29){a=zq()|0;if(g){o=0;c[p+32>>2]=c[d+8>>2];h[p+32+8>>3]=f;a=Ba(23,p+296|0,a|0,p|0,p+32|0)|0;n=o;o=0;if(!(n&1))r=9}else{o=0;h[p+48>>3]=f;a=Ba(23,p+296|0,a|0,p|0,p+48|0)|0;n=o;o=0;if(!(n&1))r=9}if((r|0)==9){g=c[p+296>>2]|0;if(g|0){j=g;k=g;n=g;r=11;break}o=0;Fa(20);n=o;o=0;if(!(n&1)){j=0;k=g;n=g;r=11;break}}a=Ya()|0}else{j=p+300|0;k=p+300|0;n=0;r=11}while(0);if((r|0)==11){l=k+a|0;m=Ch(k,l,c[d+4>>2]|0)|0;do if((k|0)==(p+300|0)){a=p+300|0;k=p+68|0;g=0;r=16}else{g=ec(a<<3)|0;if(!g){o=0;Fa(20);r=o;o=0;if(r&1){g=0;r=14;break}else a=j}else a=k;k=g;r=16}while(0);do if((r|0)==16){j=Wm(d)|0;c[p+56>>2]=j;o=0;ra(21,a|0,m|0,l|0,k|0,p+64|0,p+60|0,p+56|0);m=o;o=0;if(m&1){a=Ya()|0;en(j);break}en(j);o=0;a=fa(57,c[b>>2]|0,k|0,c[p+64>>2]|0,c[p+60>>2]|0,d|0,e|0)|0;r=o;o=0;if(r&1)r=14;else{c[b>>2]=a;if(g|0)nc(g);if(n|0)nc(n);i=q;return a|0}}while(0);if((r|0)==14)a=Ya()|0;if(g|0)nc(g);if(n)nc(n)}Ra(a|0);return 0}function Bd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0;q=i;p=i=i+63&-64;i=i+160|0;c[p>>2]=37;c[p+4>>2]=0;g=Of(p+1|0,47456,c[d+4>>2]|0)|0;c[p+68>>2]=p+130;a=zq()|0;if(g){c[p+8>>2]=c[d+8>>2];h[p+8+8>>3]=f;a=ek(p+130|0,30,a,p,p+8|0)|0}else{h[p+24>>3]=f;a=ek(p+130|0,30,a,p,p+24|0)|0}do if((a|0)>29){a=zq()|0;if(g){o=0;c[p+32>>2]=c[d+8>>2];h[p+32+8>>3]=f;a=Ba(23,p+68|0,a|0,p|0,p+32|0)|0;n=o;o=0;if(!(n&1))r=9}else{o=0;h[p+48>>3]=f;a=Ba(23,p+68|0,a|0,p|0,p+48|0)|0;n=o;o=0;if(!(n&1))r=9}if((r|0)==9){g=c[p+68>>2]|0;if(g|0){j=g;k=g;n=g;r=11;break}o=0;Fa(20);n=o;o=0;if(!(n&1)){j=0;k=g;n=g;r=11;break}}a=Ya()|0}else{j=p+130|0;k=p+130|0;n=0;r=11}while(0);if((r|0)==11){l=k+a|0;m=Ch(k,l,c[d+4>>2]|0)|0;do if((k|0)==(p+130|0)){a=p+130|0;k=p+72|0;g=0;r=16}else{g=ec(a<<1)|0;if(!g){o=0;Fa(20);r=o;o=0;if(r&1){g=0;r=14;break}else a=j}else a=k;k=g;r=16}while(0);do if((r|0)==16){j=Wm(d)|0;c[p+56>>2]=j;o=0;ra(19,a|0,m|0,l|0,k|0,p+64|0,p+60|0,p+56|0);m=o;o=0;if(m&1){a=Ya()|0;en(j);break}en(j);o=0;a=fa(56,c[b>>2]|0,k|0,c[p+64>>2]|0,c[p+60>>2]|0,d|0,e|0)|0;r=o;o=0;if(r&1)r=14;else{c[b>>2]=a;if(g|0)nc(g);if(n|0)nc(n);i=q;return a|0}}while(0);if((r|0)==14)a=Ya()|0;if(g|0)nc(g);if(n)nc(n)}Ra(a|0);return 0}function Cd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0;q=i;p=i=i+63&-64;i=i+160|0;c[p>>2]=37;c[p+4>>2]=0;g=Of(p+1|0,56413,c[d+4>>2]|0)|0;c[p+68>>2]=p+130;a=zq()|0;if(g){c[p+8>>2]=c[d+8>>2];h[p+8+8>>3]=f;a=ek(p+130|0,30,a,p,p+8|0)|0}else{h[p+24>>3]=f;a=ek(p+130|0,30,a,p,p+24|0)|0}do if((a|0)>29){a=zq()|0;if(g){o=0;c[p+32>>2]=c[d+8>>2];h[p+32+8>>3]=f;a=Ba(23,p+68|0,a|0,p|0,p+32|0)|0;n=o;o=0;if(!(n&1))r=9}else{o=0;h[p+48>>3]=f;a=Ba(23,p+68|0,a|0,p|0,p+48|0)|0;n=o;o=0;if(!(n&1))r=9}if((r|0)==9){g=c[p+68>>2]|0;if(g|0){j=g;k=g;n=g;r=11;break}o=0;Fa(20);n=o;o=0;if(!(n&1)){j=0;k=g;n=g;r=11;break}}a=Ya()|0}else{j=p+130|0;k=p+130|0;n=0;r=11}while(0);if((r|0)==11){l=k+a|0;m=Ch(k,l,c[d+4>>2]|0)|0;do if((k|0)==(p+130|0)){a=p+130|0;k=p+72|0;g=0;r=16}else{g=ec(a<<1)|0;if(!g){o=0;Fa(20);r=o;o=0;if(r&1){g=0;r=14;break}else a=j}else a=k;k=g;r=16}while(0);do if((r|0)==16){j=Wm(d)|0;c[p+56>>2]=j;o=0;ra(19,a|0,m|0,l|0,k|0,p+64|0,p+60|0,p+56|0);m=o;o=0;if(m&1){a=Ya()|0;en(j);break}en(j);o=0;a=fa(56,c[b>>2]|0,k|0,c[p+64>>2]|0,c[p+60>>2]|0,d|0,e|0)|0;r=o;o=0;if(r&1)r=14;else{c[b>>2]=a;if(g|0)nc(g);if(n|0)nc(n);i=q;return a|0}}while(0);if((r|0)==14)a=Ya()|0;if(g|0)nc(g);if(n)nc(n)}Ra(a|0);return 0}function Dd(d,f,g,h,i,j,k,l){d=d|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0;c[g>>2]=d;c[j>>2]=h;if(l&2)if((i-h|0)<3)d=1;else{c[j>>2]=h+1;a[h>>0]=-17;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=-69;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=-65;m=4}else m=4;a:do if((m|0)==4){d=c[g>>2]|0;while(1){if(d>>>0>=f>>>0){d=0;break a}h=b[d>>1]|0;if((h&65535)>>>0>k>>>0){d=2;break a}do if((h&65535)<128){d=c[j>>2]|0;if((i-d|0)<1){d=1;break a}c[j>>2]=d+1;a[d>>0]=h}else{if((h&65535)<2048){d=c[j>>2]|0;if((i-d|0)<2){d=1;break a}c[j>>2]=d+1;a[d>>0]=(h&65535)>>>6|192;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=h&63|128;break}if((h&65535)<55296){d=c[j>>2]|0;if((i-d|0)<3){d=1;break a}c[j>>2]=d+1;a[d>>0]=(h&65535)>>>12|224;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=(h&65535)>>>6&63|128;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=h&63|128;break}if((h&65535)>=56320){if((h&65535)<57344){d=2;break a}d=c[j>>2]|0;if((i-d|0)<3){d=1;break a}c[j>>2]=d+1;a[d>>0]=(h&65535)>>>12|224;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=(h&65535)>>>6&63|128;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=h&63|128;break}if((f-d|0)<4){d=1;break a}d=d+2|0;l=e[d>>1]|0;if((l&64512|0)!=56320){d=2;break a}if((i-(c[j>>2]|0)|0)<4){d=1;break a}if((((h&960)<<10)+65536|(h&65535)<<10&64512|l&1023)>>>0>k>>>0){d=2;break a}c[g>>2]=d;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=(((h&960)>>>6)+1|0)>>>2|240;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=(h&65535)>>>2&15|((h&960)>>>6)+1<<4&48|128;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=(h&65535)<<4&48|l>>>6&15|128;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=l&63|128}while(0);d=(c[g>>2]|0)+2|0;c[g>>2]=d}}while(0);return d|0}function Ed(b,e,f,g,h,i,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;c[f>>2]=b;c[i>>2]=g;if(((((k&4|0)!=0?(l=c[f>>2]|0,(e-l|0)>2):0)?(a[l>>0]|0)==-17:0)?(a[l+1>>0]|0)==-69:0)?(a[l+2>>0]|0)==-65:0){c[f>>2]=l+3;g=e}else g=e;a:while(1){m=c[f>>2]|0;if(m>>>0>=e>>>0){l=0;break}n=c[i>>2]|0;if(n>>>0>=h>>>0){l=1;break}o=a[m>>0]|0;do if(o<<24>>24>-1){if((o&255)>>>0>j>>>0){l=2;break a}c[n>>2]=o&255;c[f>>2]=m+1}else{if((o&255)<194){l=2;break a}if((o&255)<224){if((g-m|0)<2){l=1;break a}l=d[m+1>>0]|0;if((l&192|0)!=128){l=2;break a}if((l&63|(o&255)<<6&1984)>>>0>j>>>0){l=2;break a}c[n>>2]=l&63|(o&255)<<6&1984;c[f>>2]=m+2;break}if((o&255)<240){if((g-m|0)<3){l=1;break a}l=a[m+1>>0]|0;b=a[m+2>>0]|0;switch(o&255|0){case 224:{if((l&-32)<<24>>24!=-96){l=2;break a}break}case 237:{if((l&-32)<<24>>24!=-128){l=2;break a}break}default:if((l&-64)<<24>>24!=-128){l=2;break a}}if((b&192|0)!=128){l=2;break a}if(((l&255)<<6&4032|(o&255)<<12&61440|b&63)>>>0>j>>>0){l=2;break a}c[n>>2]=(l&255)<<6&4032|(o&255)<<12&61440|b&63;c[f>>2]=m+3;break}if((o&255)>=245){l=2;break a}if((g-m|0)<4){l=1;break a}l=a[m+1>>0]|0;b=a[m+2>>0]|0;k=a[m+3>>0]|0;switch(o&255|0){case 240:{if((l+112&255)>=48){l=2;break a}break}case 244:{if((l&-16)<<24>>24!=-128){l=2;break a}break}default:if((l&-64)<<24>>24!=-128){l=2;break a}}if((b&192|0)!=128){l=2;break a}if((k&192|0)!=128){l=2;break a}if(((l&255)<<12&258048|(o&255)<<18&1835008|(b&255)<<6&4032|k&63)>>>0>j>>>0){l=2;break a}c[n>>2]=(l&255)<<12&258048|(o&255)<<18&1835008|(b&255)<<6&4032|k&63;c[f>>2]=m+4}while(0);c[i>>2]=(c[i>>2]|0)+4}return l|0}function Fd(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;if((((g&4|0)!=0?(c-b|0)>2:0)?(a[b>>0]|0)==-17:0)?(a[b+1>>0]|0)==-69:0){g=(a[b+2>>0]|0)==-65?b+3|0:b;h=0}else{g=b;h=0}a:while(1){if(!(h>>>0<e>>>0&g>>>0<c>>>0)){h=40;break}m=a[g>>0]|0;if((m&255)>>>0>f>>>0){h=40;break}do if(m<<24>>24>-1)g=g+1|0;else{if((m&255)<194){h=40;break a}if((m&255)<224){if((c-g|0)<2){h=40;break a}i=d[g+1>>0]|0;if((i&192|0)!=128){h=40;break a}if((i&63|(m&255)<<6&1984)>>>0>f>>>0){h=40;break a}else{g=g+2|0;break}}if((m&255)<240){k=g;if((c-k|0)<3){h=40;break a}i=a[g+1>>0]|0;j=a[g+2>>0]|0;switch(m&255|0){case 224:{if((i&-32)<<24>>24!=-96){h=19;break a}break}case 237:{if((i&-32)<<24>>24!=-128){h=21;break a}break}default:if((i&-64)<<24>>24!=-128){h=23;break a}}if((j&192|0)!=128){h=40;break a}if(((i&255)<<6&4032|(m&255)<<12&61440|j&63)>>>0>f>>>0){h=40;break a}else{g=g+3|0;break}}if((m&255)>=245){h=40;break a}l=g;if((e-h|0)>>>0<2|(c-l|0)<4){h=40;break a}i=a[g+1>>0]|0;j=a[g+2>>0]|0;k=a[g+3>>0]|0;switch(m&255|0){case 240:{if((i+112&255)>=48){h=30;break a}break}case 244:{if((i&-16)<<24>>24!=-128){h=32;break a}break}default:if((i&-64)<<24>>24!=-128){h=34;break a}}if((j&192|0)!=128){h=40;break a}if((k&192|0)!=128){h=40;break a}if(((i&255)<<12&258048|(m&255)<<18&1835008|(j&255)<<6&4032|k&63)>>>0>f>>>0){h=40;break a}g=g+4|0;h=h+1|0}while(0);h=h+1|0}if((h|0)==19)g=k-b|0;else if((h|0)==21)g=k-b|0;else if((h|0)==23)g=k-b|0;else if((h|0)==30)g=l-b|0;else if((h|0)==32)g=l-b|0;else if((h|0)==34)g=l-b|0;else if((h|0)==40)g=g-b|0;return g|0}function Gd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;k=i;l=i=i+63&-64;i=i+48|0;a:do if(!(c[f+4>>2]&1)){c[l+8>>2]=-1;j=c[(c[b>>2]|0)+16>>2]|0;c[l+4>>2]=c[d>>2];c[l>>2]=c[e>>2];c[l+12>>2]=c[l+4>>2];c[l+16>>2]=c[l>>2];b=Hb[j&63](b,l+12|0,l+16|0,f,g,l+8|0)|0;c[d>>2]=b;switch(c[l+8>>2]|0){case 0:{a[h>>0]=0;break}case 1:{a[h>>0]=1;break}default:{a[h>>0]=1;c[g>>2]=4}}}else{b=Wm(f)|0;o=0;j=va(32,b|0,52364)|0;m=o;o=0;do if(!(m&1)){en(b);b=Wm(f)|0;o=0;f=va(32,b|0,52372)|0;m=o;o=0;if(m&1){m=Ya()|0;en(b);b=m;break}en(b);o=0;da(c[(c[f>>2]|0)+24>>2]|0,l+16|0,f|0);m=o;o=0;if(!(m&1)){o=0;da(c[(c[f>>2]|0)+28>>2]|0,l+16+12|0,f|0);m=o;o=0;if(!(m&1)){o=0;b=X(25,d|0,c[e>>2]|0,l+16|0,l+16+24|0,j|0,g|0,1)|0;m=o;o=0;if(m&1){b=Ya()|0;dq(l+16+12|0);dq(l+16|0);break}else{a[h>>0]=(b|0)==(l+16|0)&1;b=c[d>>2]|0;dq(l+16+12|0);dq(l+16|0);break a}}else f=l+16+12|0}else f=l+16|0;b=Ya()|0;j=D;if((l+16|0)!=(f|0))do{f=f+-12|0;dq(f)}while((f|0)!=(l+16|0))}else{m=Ya()|0;en(b);b=m}while(0);Ra(b|0)}while(0);i=k;return b|0}function Hd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;k=i;l=i=i+63&-64;i=i+48|0;a:do if(!(c[f+4>>2]&1)){c[l+8>>2]=-1;j=c[(c[b>>2]|0)+16>>2]|0;c[l+4>>2]=c[d>>2];c[l>>2]=c[e>>2];c[l+12>>2]=c[l+4>>2];c[l+16>>2]=c[l>>2];b=Hb[j&63](b,l+12|0,l+16|0,f,g,l+8|0)|0;c[d>>2]=b;switch(c[l+8>>2]|0){case 0:{a[h>>0]=0;break}case 1:{a[h>>0]=1;break}default:{a[h>>0]=1;c[g>>2]=4}}}else{b=Wm(f)|0;o=0;j=va(32,b|0,52332)|0;m=o;o=0;do if(!(m&1)){en(b);b=Wm(f)|0;o=0;f=va(32,b|0,52344)|0;m=o;o=0;if(m&1){m=Ya()|0;en(b);b=m;break}en(b);o=0;da(c[(c[f>>2]|0)+24>>2]|0,l+16|0,f|0);m=o;o=0;if(!(m&1)){o=0;da(c[(c[f>>2]|0)+28>>2]|0,l+16+12|0,f|0);m=o;o=0;if(!(m&1)){o=0;b=X(24,d|0,c[e>>2]|0,l+16|0,l+16+24|0,j|0,g|0,1)|0;m=o;o=0;if(m&1){b=Ya()|0;rq(l+16+12|0);rq(l+16|0);break}else{a[h>>0]=(b|0)==(l+16|0)&1;b=c[d>>2]|0;rq(l+16+12|0);rq(l+16|0);break a}}else f=l+16+12|0}else f=l+16|0;b=Ya()|0;j=D;if((l+16|0)!=(f|0))do{f=f+-12|0;rq(f)}while((f|0)!=(l+16|0))}else{m=Ya()|0;en(b);b=m}while(0);Ra(b|0)}while(0);i=k;return b|0}function Id(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;if((((g&4|0)!=0?(c-b|0)>2:0)?(a[b>>0]|0)==-17:0)?(a[b+1>>0]|0)==-69:0){g=(a[b+2>>0]|0)==-65?b+3|0:b;m=0}else{g=b;m=0}a:while(1){if(!(m>>>0<e>>>0&g>>>0<c>>>0)){h=40;break}l=a[g>>0]|0;do if(l<<24>>24<=-1){if((l&255)<194){h=40;break a}if((l&255)<224){if((c-g|0)<2){h=40;break a}h=d[g+1>>0]|0;if((h&192|0)!=128){h=40;break a}if((h&63|(l&255)<<6&1984)>>>0>f>>>0){h=40;break a}g=g+2|0;break}if((l&255)<240){j=g;if((c-j|0)<3){h=40;break a}h=a[g+1>>0]|0;i=a[g+2>>0]|0;switch(l&255|0){case 224:{if((h&-32)<<24>>24!=-96){h=20;break a}break}case 237:{if((h&-32)<<24>>24!=-128){h=22;break a}break}default:if((h&-64)<<24>>24!=-128){h=24;break a}}if((i&192|0)!=128){h=40;break a}if(((h&255)<<6&4032|(l&255)<<12&61440|i&63)>>>0>f>>>0){h=40;break a}else{g=g+3|0;break}}if((l&255)>=245){h=40;break a}k=g;if((c-k|0)<4){h=40;break a}h=a[g+1>>0]|0;i=a[g+2>>0]|0;j=a[g+3>>0]|0;switch(l&255|0){case 240:{if((h+112&255)>=48){h=31;break a}break}case 244:{if((h&-16)<<24>>24!=-128){h=33;break a}break}default:if((h&-64)<<24>>24!=-128){h=35;break a}}if((i&192|0)!=128){h=40;break a}if((j&192|0)!=128){h=40;break a}if(((h&255)<<12&258048|(l&255)<<18&1835008|(i&255)<<6&4032|j&63)>>>0>f>>>0){h=40;break a}else g=g+4|0}else{if((l&255)>>>0>f>>>0){h=40;break a}g=g+1|0}while(0);m=m+1|0}if((h|0)==20)g=j-b|0;else if((h|0)==22)g=j-b|0;else if((h|0)==24)g=j-b|0;else if((h|0)==31)g=k-b|0;else if((h|0)==33)g=k-b|0;else if((h|0)==35)g=k-b|0;else if((h|0)==40)g=g-b|0;return g|0}function Jd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;h=i=i+63&-64;i=i+128|0;e=bo(d<<24>>24|0,((d<<24>>24|0)<0)<<31>>31|0,63)|0;c[a>>2]=1;f=a+4|0;j=f+36|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(j|0));c[a+40>>2]=1;f=a+44|0;j=f+76|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(j|0));o=(d<<24>>24)-((d<<24>>24&0-e)<<1)&255;tm(a,3120+(b*960|0)|0,((o^1)+-1|0)>>>31&255);tm(a,3120+(b*960|0)+120|0,((o^2)+-1|0)>>>31&255);tm(a,3120+(b*960|0)+240|0,((o^3)+-1|0)>>>31&255);tm(a,3120+(b*960|0)+360|0,((o^4)+-1|0)>>>31&255);tm(a,3120+(b*960|0)+480|0,((o^5)+-1|0)>>>31&255);tm(a,3120+(b*960|0)+600|0,((o^6)+-1|0)>>>31&255);tm(a,3120+(b*960|0)+720|0,((o^7)+-1|0)>>>31&255);tm(a,3120+(b*960|0)+840|0,((o^8)+-1|0)>>>31&255);o=c[a+44>>2]|0;n=c[a+48>>2]|0;m=c[a+52>>2]|0;l=c[a+56>>2]|0;k=c[a+60>>2]|0;d=c[a+64>>2]|0;b=c[a+68>>2]|0;f=c[a+72>>2]|0;j=c[a+76>>2]|0;c[h>>2]=c[a+40>>2];c[h+4>>2]=o;c[h+8>>2]=n;c[h+12>>2]=m;c[h+16>>2]=l;c[h+20>>2]=k;c[h+24>>2]=d;c[h+28>>2]=b;c[h+32>>2]=f;c[h+36>>2]=j;j=c[a+4>>2]|0;f=c[a+8>>2]|0;b=c[a+12>>2]|0;d=c[a+16>>2]|0;k=c[a+20>>2]|0;l=c[a+24>>2]|0;m=c[a+28>>2]|0;n=c[a+32>>2]|0;o=c[a+36>>2]|0;c[h+40>>2]=c[a>>2];c[h+44>>2]=j;c[h+48>>2]=f;c[h+52>>2]=b;c[h+56>>2]=d;c[h+60>>2]=k;c[h+64>>2]=l;c[h+68>>2]=m;c[h+72>>2]=n;c[h+76>>2]=o;o=0-(c[a+84>>2]|0)|0;n=0-(c[a+88>>2]|0)|0;m=0-(c[a+92>>2]|0)|0;l=0-(c[a+96>>2]|0)|0;k=0-(c[a+100>>2]|0)|0;d=0-(c[a+104>>2]|0)|0;b=0-(c[a+108>>2]|0)|0;f=0-(c[a+112>>2]|0)|0;j=0-(c[a+116>>2]|0)|0;c[h+80>>2]=0-(c[a+80>>2]|0);c[h+84>>2]=o;c[h+88>>2]=n;c[h+92>>2]=m;c[h+96>>2]=l;c[h+100>>2]=k;c[h+104>>2]=d;c[h+108>>2]=b;c[h+112>>2]=f;c[h+116>>2]=j;tm(a,h,e&255);i=g;return}function Kd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=c[a>>2]|0;do if(f){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=Ib[c[(c[f>>2]|0)+36>>2]&127](f)|0;else f=c[g>>2]|0;if((f|0)==-1){c[a>>2]=0;g=1;break}else{g=(c[a>>2]|0)==0;break}}else g=1;while(0);if(b){f=c[b+12>>2]|0;if((f|0)==(c[b+16>>2]|0))f=Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0;else f=c[f>>2]|0;if((f|0)!=-1)if(g){h=b;i=16}else i=15;else i=13}else i=13;if((i|0)==13)if(g)i=15;else{h=0;i=16}do if((i|0)==15)c[d>>2]=c[d>>2]|6;else if((i|0)==16){f=c[a>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=Ib[c[(c[f>>2]|0)+36>>2]&127](f)|0;else f=c[g>>2]|0;if((Kb[c[(c[e>>2]|0)+52>>2]&63](e,f,0)|0)<<24>>24!=37){c[d>>2]=c[d>>2]|4;break}f=c[a>>2]|0;g=c[f+12>>2]|0;b=c[f+16>>2]|0;if((g|0)==(b|0)){Ib[c[(c[f>>2]|0)+40>>2]&127](f)|0;f=c[a>>2]|0;if(!f)g=1;else{g=c[f+12>>2]|0;b=c[f+16>>2]|0;i=25}}else{c[f+12>>2]=g+4;g=g+4|0;i=25}do if((i|0)==25){if((g|0)==(b|0))f=Ib[c[(c[f>>2]|0)+36>>2]&127](f)|0;else f=c[g>>2]|0;if((f|0)==-1){c[a>>2]=0;g=1;break}else{g=(c[a>>2]|0)==0;break}}while(0);if(h){f=c[h+12>>2]|0;if((f|0)==(c[h+16>>2]|0))f=Ib[c[(c[h>>2]|0)+36>>2]&127](h)|0;else f=c[f>>2]|0;if((f|0)!=-1){if(g)break}else i=36}else i=36;if((i|0)==36?!g:0)break;c[d>>2]=c[d>>2]|2}while(0);return}function Ld(b,e,f,g,h,i,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0;a:do if(b<<24>>24==i<<24>>24)if(a[e>>0]|0){a[e>>0]=0;f=c[h>>2]|0;c[h>>2]=f+1;a[f>>0]=46;f=a[k+11>>0]|0;if(((f<<24>>24<0?c[k+4>>2]|0:f&255)|0)!=0?(p=c[m>>2]|0,(p-l|0)<160):0){l=c[n>>2]|0;c[m>>2]=p+4;c[p>>2]=l;p=0}else p=0}else p=-1;else{if(b<<24>>24==j<<24>>24?(j=a[k+11>>0]|0,(j<<24>>24<0?c[k+4>>2]|0:j&255)|0):0){if(!(a[e>>0]|0)){p=-1;break}p=c[m>>2]|0;if((p-l|0)>=160){p=0;break}l=c[n>>2]|0;c[m>>2]=p+4;c[p>>2]=l;c[n>>2]=0;p=0;break}p=o;while(1){if((p|0)==(o+32|0)){p=o+32|0;break}if((a[p>>0]|0)==b<<24>>24)break;p=p+1|0}p=p-o|0;if((p|0)>31)p=-1;else{i=a[47202+p>>0]|0;switch(p|0){case 24:case 25:{p=c[h>>2]|0;if((p|0)!=(g|0)?(d[p+-1>>0]&95|0)!=(d[f>>0]&127|0):0){p=-1;break a}c[h>>2]=p+1;a[p>>0]=i;p=0;break a}case 23:case 22:{a[f>>0]=80;p=c[h>>2]|0;c[h>>2]=p+1;a[p>>0]=i;p=0;break a}default:{if((((i&95|0)==(a[f>>0]|0)?(a[f>>0]=i&95|128,a[e>>0]|0):0)?(a[e>>0]=0,f=a[k+11>>0]|0,(f<<24>>24<0?c[k+4>>2]|0:f&255)|0):0)?(q=c[m>>2]|0,(q-l|0)<160):0){l=c[n>>2]|0;c[m>>2]=q+4;c[q>>2]=l}m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=i;if((p|0)>21){p=0;break a}c[n>>2]=(c[n>>2]|0)+1;p=0;break a}}}}while(0);return p|0}function Md(b){b=b|0;var d=0;if((a[50160]|0)==0?sr(50160)|0:0){if((a[50168]|0)==0?sr(50168)|0:0){b=53388;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+(d<<2)>>2]=0;d=d+1|0}b=b+12|0}while((b|0)!=53676);rb(137,0,n|0)|0}On(53388,39244);On(53400,39276);On(53412,39312);On(53424,39336);On(53436,39360);On(53448,39376);On(53460,39396);On(53472,39416);On(53484,39444);On(53496,39484);On(53508,39516);On(53520,39552);On(53532,39588);On(53544,39604);On(53556,39620);On(53568,39636);On(53580,39360);On(53592,39652);On(53604,39668);On(53616,39684);On(53628,39700);On(53640,39716);On(53652,39732);On(53664,39748);c[13419]=53388}return c[13419]|0}function Nd(b){b=b|0;var d=0;if((a[50080]|0)==0?sr(50080)|0:0){if((a[50088]|0)==0?sr(50088)|0:0){b=52576;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+(d<<2)>>2]=0;d=d+1|0}b=b+12|0}while((b|0)!=52864);rb(133,0,n|0)|0}Pn(52576,47809);Pn(52588,47817);Pn(52600,47826);Pn(52612,47832);Pn(52624,47838);Pn(52636,47842);Pn(52648,47847);Pn(52660,47852);Pn(52672,47859);Pn(52684,47869);Pn(52696,47877);Pn(52708,47886);Pn(52720,47895);Pn(52732,47899);Pn(52744,47903);Pn(52756,47907);Pn(52768,47838);Pn(52780,47911);Pn(52792,47915);Pn(52804,47919);Pn(52816,47923);Pn(52828,47927);Pn(52840,47931);Pn(52852,47935);c[13216]=52576}return c[13216]|0}function Od(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;q=i;p=i=i+63&-64;i=i+16|0;l=e;while(1){if((l|0)==(f|0)){l=f;break}if(!(a[l>>0]|0))break;l=l+1|0}c[k>>2]=h;c[g>>2]=e;while(1){if((h|0)==(j|0)|(e|0)==(f|0)){h=33;break}o=c[d+4>>2]|0;c[p>>2]=c[d>>2];c[p+4>>2]=o;o=l;m=aq(c[b+8>>2]|0)|0;n=re(h,g,o-e|0,j-h>>2,d)|0;if(m|0)aq(m)|0;if((n|0)==-1){l=h;h=10;break}h=(c[k>>2]|0)+(n<<2)|0;c[k>>2]=h;if((h|0)==(j|0)){h=30;break}e=c[g>>2]|0;if((l|0)==(f|0))l=f;else{l=aq(c[b+8>>2]|0)|0;e=Pe(h,e,1,d)|0;if(l|0)aq(l)|0;if(e|0){e=2;h=29;break}c[k>>2]=(c[k>>2]|0)+4;e=(c[g>>2]|0)+1|0;c[g>>2]=e;l=e;while(1){if((l|0)==(f|0)){l=f;break}if(!(a[l>>0]|0))break;l=l+1|0}h=c[k>>2]|0}}do if((h|0)==10){a:while(1){c[k>>2]=l;if((e|0)==(c[g>>2]|0)){h=19;break}h=aq(c[b+8>>2]|0)|0;l=Pe(l,e,o-e|0,p)|0;if(h|0)aq(h)|0;switch(l|0){case -1:{h=15;break a}case -2:{h=16;break a}case 0:{e=e+1|0;break}default:e=e+l|0}l=(c[k>>2]|0)+4|0;h=10}if((h|0)==15){c[g>>2]=e;e=2;h=29;break}else if((h|0)==16){c[g>>2]=e;e=1;h=29;break}else if((h|0)==19){c[g>>2]=e;e=(e|0)!=(f|0)&1;h=29;break}}else if((h|0)==30){e=c[g>>2]|0;h=33}while(0);if((h|0)!=29)if((h|0)==33)e=(e|0)!=(f|0)&1;i=q;return e|0}function Pd(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=c[a>>2]|0;do if(g){if((c[g+12>>2]|0)==(c[g+16>>2]|0))if((Ib[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1){c[a>>2]=0;g=0;break}else{g=c[a>>2]|0;break}}else g=0;while(0);g=(g|0)==0;do if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){i=10;break}if(g){h=b;i=12}else i=11}else i=10;while(0);if((i|0)==10)if(g)i=11;else{h=0;i=12}a:do if((i|0)==11)c[e>>2]=c[e>>2]|6;else if((i|0)==12){g=c[a>>2]|0;b=c[g+12>>2]|0;if((b|0)==(c[g+16>>2]|0))g=Ib[c[(c[g>>2]|0)+36>>2]&127](g)|0;else g=d[b>>0]|0;if((Kb[c[(c[f>>2]|0)+36>>2]&63](f,g&255,0)|0)<<24>>24!=37){c[e>>2]=c[e>>2]|4;break}g=c[a>>2]|0;b=c[g+12>>2]|0;f=c[g+16>>2]|0;if((b|0)==(f|0)){Ib[c[(c[g>>2]|0)+40>>2]&127](g)|0;g=c[a>>2]|0;if(!g)g=0;else{b=c[g+12>>2]|0;f=c[g+16>>2]|0;i=21}}else{c[g+12>>2]=b+1;b=b+1|0;i=21}do if((i|0)==21)if((b|0)==(f|0))if((Ib[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1){c[a>>2]=0;g=0;break}else{g=c[a>>2]|0;break}while(0);g=(g|0)==0;do if(h){if((c[h+12>>2]|0)==(c[h+16>>2]|0)?(Ib[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1:0){i=29;break}if(g)break a}else i=29;while(0);if((i|0)==29?!g:0)break;c[e>>2]=c[e>>2]|2}while(0);return}function Qd(b,e,f,g,h,i,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0;a:do if((b|0)==(i|0))if(a[e>>0]|0){a[e>>0]=0;f=c[h>>2]|0;c[h>>2]=f+1;a[f>>0]=46;f=a[k+11>>0]|0;if(((f<<24>>24<0?c[k+4>>2]|0:f&255)|0)!=0?(p=c[m>>2]|0,(p-l|0)<160):0){l=c[n>>2]|0;c[m>>2]=p+4;c[p>>2]=l;p=0}else p=0}else p=-1;else{if((b|0)==(j|0)?(j=a[k+11>>0]|0,(j<<24>>24<0?c[k+4>>2]|0:j&255)|0):0){if(!(a[e>>0]|0)){p=-1;break}p=c[m>>2]|0;if((p-l|0)>=160){p=0;break}l=c[n>>2]|0;c[m>>2]=p+4;c[p>>2]=l;c[n>>2]=0;p=0;break}p=o;while(1){if((p|0)==(o+128|0)){p=o+128|0;break}if((c[p>>2]|0)==(b|0))break;p=p+4|0}p=p-o|0;if((p|0)<=124){i=a[47202+(p>>2)>>0]|0;switch(p>>2|0){case 24:case 25:{p=c[h>>2]|0;if((p|0)!=(g|0)?(d[p+-1>>0]&95|0)!=(d[f>>0]&127|0):0){p=-1;break a}c[h>>2]=p+1;a[p>>0]=i;p=0;break a}case 23:case 22:{a[f>>0]=80;break}default:if((((i&95|0)==(a[f>>0]|0)?(a[f>>0]=i&95|128,a[e>>0]|0):0)?(a[e>>0]=0,f=a[k+11>>0]|0,(f<<24>>24<0?c[k+4>>2]|0:f&255)|0):0)?(q=c[m>>2]|0,(q-l|0)<160):0){l=c[n>>2]|0;c[m>>2]=q+4;c[q>>2]=l}}m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=i;if((p|0)>84)p=0;else{c[n>>2]=(c[n>>2]|0)+1;p=0}}else p=-1}while(0);return p|0}function Rd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;m=c[d>>2]|0;h=c[d+4>>2]|0;i=c[d+8>>2]|0;j=c[d+12>>2]|0;p=c[d+16>>2]|0;f=c[d+20>>2]|0;g=c[d+24>>2]|0;n=c[d+28>>2]|0;e=c[d+32>>2]|0;d=c[d+36>>2]|0;o=((((((((((((((d*19|0)+16777216|0)>>>25)+m>>26)+h>>25)+i>>26)+j>>25)+p>>26)+f>>25)+g>>26)+n>>25)+e>>26)+d>>25)*19|0)+m>>26;m=((((((((((((((d*19|0)+16777216|0)>>>25)+m>>26)+h>>25)+i>>26)+j>>25)+p>>26)+f>>25)+g>>26)+n>>25)+e>>26)+d>>25)*19|0)+m-(o<<26)|0;l=o+h-(o+h>>25<<25)|0;k=(o+h>>25)+i-((o+h>>25)+i>>26<<26)|0;q=((o+h>>25)+i>>26)+j>>25;j=((o+h>>25)+i>>26)+j-(q<<25)|0;i=q+p-(q+p>>26<<26)|0;h=(q+p>>26)+f-((q+p>>26)+f>>25<<25)|0;o=((q+p>>26)+f>>25)+g>>26;g=((q+p>>26)+f>>25)+g-(o<<26)|0;f=o+n-(o+n>>25<<25)|0;d=((o+n>>25)+e>>26)+d|0;e=(o+n>>25)+e-((o+n>>25)+e>>26<<26)|0;a[b>>0]=m;a[b+1>>0]=m>>>8;a[b+2>>0]=m>>>16;a[b+3>>0]=l<<2|m>>>24;a[b+4>>0]=l>>>6;a[b+5>>0]=l>>>14;a[b+6>>0]=k<<3|l>>>22;a[b+7>>0]=k>>>5;a[b+8>>0]=k>>>13;a[b+9>>0]=j<<5|k>>>21;a[b+10>>0]=j>>>3;a[b+11>>0]=j>>>11;a[b+12>>0]=i<<6|j>>>19;a[b+13>>0]=i>>>2;a[b+14>>0]=i>>>10;a[b+15>>0]=i>>>18;a[b+16>>0]=h;a[b+17>>0]=h>>>8;a[b+18>>0]=h>>>16;a[b+19>>0]=g<<1|h>>>24;a[b+20>>0]=g>>>7;a[b+21>>0]=g>>>15;a[b+22>>0]=f<<3|g>>>23;a[b+23>>0]=f>>>5;a[b+24>>0]=f>>>13;a[b+25>>0]=e<<4|f>>>21;a[b+26>>0]=e>>>4;a[b+27>>0]=e>>>12;a[b+28>>0]=e>>>20|(d&33554431)<<6;a[b+29>>0]=d>>>2;a[b+30>>0]=d>>>10;a[b+31>>0]=(d&33554431)>>>18;return}function Sd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;while(1){f=c[a>>2]|0;do if(f){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=Ib[c[(c[f>>2]|0)+36>>2]&127](f)|0;else f=c[g>>2]|0;if((f|0)==-1){c[a>>2]=0;g=1;break}else{g=(c[a>>2]|0)==0;break}}else g=1;while(0);if(b){f=c[b+12>>2]|0;if((f|0)==(c[b+16>>2]|0))f=Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0;else f=c[f>>2]|0;if((f|0)!=-1){if(!g){g=b;break}}else h=14}else h=14;if((h|0)==14){h=0;if(g){g=0;break}else b=0}f=c[a>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=Ib[c[(c[f>>2]|0)+36>>2]&127](f)|0;else f=c[g>>2]|0;if(!(Kb[c[(c[e>>2]|0)+12>>2]&63](e,8192,f)|0)){g=b;break}f=c[a>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){Ib[c[(c[f>>2]|0)+40>>2]&127](f)|0;continue}else{c[f+12>>2]=g+4;continue}}b=c[a>>2]|0;do if(b){f=c[b+12>>2]|0;if((f|0)==(c[b+16>>2]|0))b=Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0;else b=c[f>>2]|0;if((b|0)==-1){c[a>>2]=0;f=1;break}else{f=(c[a>>2]|0)==0;break}}else f=1;while(0);if(g){b=c[g+12>>2]|0;if((b|0)==(c[g+16>>2]|0))b=Ib[c[(c[g>>2]|0)+36>>2]&127](g)|0;else b=c[b>>2]|0;if((b|0)!=-1){if(!f)h=37}else h=35}else h=35;if((h|0)==35?f:0)h=37;if((h|0)==37)c[d>>2]=c[d>>2]|2;return}function Td(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;q=i;p=i=i+63&-64;i=i+16|0;f=c[b+36>>2]|0;n=c[b+20>>2]|0;o=c[b+4>>2]|0;c[b+36>>2]=0;c[b+20>>2]=0;c[b+4>>2]=0;r=(ai(d,42648,8)|0)==0;d=r?d+8|0:d;a:do if((r?(ai(d,42657,3)|0)==0:0)?(g=Dh(d+3|0,p)|0,(g|0)!=0):0)if((c[p>>2]|0)==19)if((((((ai(g,42661,3)|0)==0?(h=Dh(g+3|0,p)|0,j=c[p>>2]|0,(h|0)!=0):0)?(c[b+44>>2]=j,(ai(h,42665,3)|0)==0):0)?(k=Dh(h+3|0,p)|0,l=(k|0)==0?j:c[p>>2]|0,(k|0)!=0):0)?(c[b+40>>2]=l,(ai(k,42669,3)|0)==0):0)?(e=Dh(k+3|0,p)|0,m=(e|0)==0?l:c[p>>2]|0,(e|0)!=0):0){c[b+48>>2]=m;c[b+52>>2]=m;do if(!(ai(e,42673,6)|0)){c[p>>2]=f;e=Bf(c[b+32>>2]|0,p,e+6|0)|0;if(!e){e=-32;break a}else{c[b+36>>2]=c[p>>2];break}}while(0);d=a[e>>0]|0;if(d<<24>>24)if(d<<24>>24==36){c[p>>2]=n;e=Bf(c[b+16>>2]|0,p,e+1|0)|0;if(!e){e=-32;break}c[b+20>>2]=c[p>>2];d=a[e>>0]|0;if(d<<24>>24)if(d<<24>>24==36){c[p>>2]=o;d=Bf(c[b>>2]|0,p,e+1|0)|0;if(!d){e=-32;break}c[b+4>>2]=c[p>>2];e=bf(b)|0;if(!e)e=(a[d>>0]|0)==0?0:-32}else e=-32;else e=0}else e=-32;else e=0}else e=-32;else e=-26;else e=-32;while(0);i=q;return e|0}function Ud(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;j=i;h=i=i+63&-64;i=i+16|0;a:do if(!(c[e+4>>2]&1)){k=c[(c[b>>2]|0)+24>>2]|0;c[h>>2]=c[d>>2];c[h+4>>2]=c[h>>2];f=Qb[k&63](b,h+4|0,e,f,g&1)|0}else{f=Wm(e)|0;o=0;e=va(32,f|0,52344)|0;k=o;o=0;do if(!(k&1)){en(f);f=c[e>>2]|0;if(g)Gb[c[f+24>>2]&127](h+4|0,e);else Gb[c[f+28>>2]&127](h+4|0,e);k=a[h+4+11>>0]|0;g=c[h+4>>2]|0;f=k;e=g;g=k<<24>>24<0?g:h+4|0;b:while(1){k=f<<24>>24<0;if((g|0)==((k?e:h+4|0)+(k?c[h+4+4>>2]|0:f&255)|0)){e=9;break}f=a[g>>0]|0;e=c[d>>2]|0;do if(e|0){b=c[e+24>>2]|0;if((b|0)!=(c[e+28>>2]|0)){c[e+24>>2]=b+1;a[b>>0]=f;break}o=0;f=va(c[(c[e>>2]|0)+52>>2]|0,e|0,f&255|0)|0;k=o;o=0;if(k&1){e=18;break b}if((f|0)==-1)c[d>>2]=0}while(0);f=a[h+4+11>>0]|0;e=c[h+4>>2]|0;g=g+1|0}if((e|0)==9){f=c[d>>2]|0;rq(h+4|0);break a}else if((e|0)==18){f=Ya()|0;rq(h+4|0);break}}else{k=Ya()|0;en(f);f=k}while(0);Ra(f|0)}while(0);i=j;return f|0}function Vd(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;s=i;t=i=i+63&-64;i=i+112|0;if(!((f|0)==0&(g|0)==0)){n=t+16|0;m=n+32|0;do{a[n>>0]=a[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(m|0));n=d[h+4>>0]|d[h+4+1>>0]<<8|d[h+4+2>>0]<<16|d[h+4+3>>0]<<24;c[t>>2]=d[h>>0]|d[h+1>>0]<<8|d[h+2>>0]<<16|d[h+3>>0]<<24;c[t+4>>2]=n;a[t+8>>0]=j;n=bo(j|0,k|0,8)|0;a[t+9>>0]=n;n=bo(j|0,k|0,16)|0;a[t+10>>0]=n;n=bo(j|0,k|0,24)|0;a[t+11>>0]=n;a[t+12>>0]=k;n=bo(j|0,k|0,40)|0;a[t+13>>0]=n;n=bo(j|0,k|0,48)|0;a[t+14>>0]=n;n=bo(j|0,k|0,56)|0;a[t+15>>0]=n;if(g>>>0>0|(g|0)==0&f>>>0>63){do{yc(t+48|0,t,t+16|0,0)|0;l=0;do{a[b+l>>0]=a[t+48+l>>0]^a[e+l>>0];l=l+1|0}while((l|0)!=64);m=8;l=1;while(1){n=t+m|0;l=(d[n>>0]|0)+l|0;a[n>>0]=l;m=m+1|0;if((m|0)==16)break;else l=l>>>8}f=Jp(f|0,g|0,-64,-1)|0;g=D;b=b+64|0;e=e+64|0}while(g>>>0>0|(g|0)==0&f>>>0>63);if(!((f|0)==0&(g|0)==0)){p=b;q=f;r=e;o=8}}else{p=b;q=f;r=e;o=8}if((o|0)==8?(yc(t+48|0,t,t+16|0,0)|0,q|0):0){l=0;do{a[p+l>>0]=a[t+48+l>>0]^a[r+l>>0];l=l+1|0}while((l|0)!=(q|0))}bl(t+48|0,64);bl(t+16|0,32)}i=s;return 0}function Wd(a,e,f,g){a=a|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;a:while(1){h=c[a>>2]|0;do if(h){if((c[h+12>>2]|0)==(c[h+16>>2]|0))if((Ib[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[a>>2]=0;h=0;break}else{h=c[a>>2]|0;break}}else h=0;while(0);h=(h|0)==0;do if(e){if((c[e+12>>2]|0)!=(c[e+16>>2]|0))if(h)break;else{h=e;break a}if((Ib[c[(c[e>>2]|0)+36>>2]&127](e)|0)!=-1){if(!h){h=e;break a}}else j=11}else j=11;while(0);if((j|0)==11){j=0;if(h){h=0;break}else e=0}h=c[a>>2]|0;i=c[h+12>>2]|0;if((i|0)==(c[h+16>>2]|0))h=Ib[c[(c[h>>2]|0)+36>>2]&127](h)|0;else h=d[i>>0]|0;if((h&255)<<24>>24<=-1){h=e;break}if(!(b[(c[g+8>>2]|0)+(h<<24>>24<<1)>>1]&8192)){h=e;break}h=c[a>>2]|0;i=c[h+12>>2]|0;if((i|0)==(c[h+16>>2]|0)){Ib[c[(c[h>>2]|0)+40>>2]&127](h)|0;continue}else{c[h+12>>2]=i+1;continue}}e=c[a>>2]|0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0))if((Ib[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[a>>2]=0;e=0;break}else{e=c[a>>2]|0;break}}else e=0;while(0);e=(e|0)==0;do if(h){if((c[h+12>>2]|0)==(c[h+16>>2]|0)?(Ib[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1:0){j=30;break}if(!e)j=31}else j=30;while(0);if((j|0)==30?e:0)j=31;if((j|0)==31)c[f>>2]=c[f>>2]|2;return}function Xd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;j=i;h=i=i+63&-64;i=i+16|0;a:do if(!(c[e+4>>2]&1)){k=c[(c[b>>2]|0)+24>>2]|0;c[h>>2]=c[d>>2];c[h+4>>2]=c[h>>2];f=Qb[k&63](b,h+4|0,e,f,g&1)|0}else{f=Wm(e)|0;o=0;e=va(32,f|0,52372)|0;k=o;o=0;do if(!(k&1)){en(f);f=c[e>>2]|0;if(g)Gb[c[f+24>>2]&127](h+4|0,e);else Gb[c[f+28>>2]&127](h+4|0,e);k=a[h+4+8+3>>0]|0;g=c[h+4>>2]|0;f=k;e=g;g=k<<24>>24<0?g:h+4|0;while(1){k=f<<24>>24<0;if((g|0)==((k?e:h+4|0)+((k?c[h+4+4>>2]|0:f&255)<<2)|0)){e=9;break}f=c[g>>2]|0;e=c[d>>2]|0;if(e|0){b=c[e+24>>2]|0;if((b|0)==(c[e+28>>2]|0)){o=0;f=va(c[(c[e>>2]|0)+52>>2]|0,e|0,f|0)|0;k=o;o=0;if(k&1){e=18;break}}else{c[e+24>>2]=b+4;c[b>>2]=f}if((f|0)==-1)c[d>>2]=0}f=a[h+4+8+3>>0]|0;e=c[h+4>>2]|0;g=g+4|0}if((e|0)==9){f=c[d>>2]|0;dq(h+4|0);break a}else if((e|0)==18){f=Ya()|0;dq(h+4|0);break}}else{k=Ya()|0;en(f);f=k}while(0);Ra(f|0)}while(0);i=j;return f|0}function Yd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;o=c[b+72>>2]|0;m=c[b+72+4>>2]|0;k=bo(o|0,m|0,3)|0;l=_n(e|0,f|0,3)|0;n=D;i=bo(e|0,f|0,61)|0;j=D;m=Jp(o|0,m|0,l|0,n|0)|0;o=D;c[b+72>>2]=m;c[b+72+4>>2]=o;g=c[b+64>>2]|0;h=c[b+64+4>>2]|0;if(o>>>0<n>>>0|(o|0)==(n|0)&m>>>0<l>>>0){g=Jp(g|0,h|0,1,0)|0;h=D;c[b+64>>2]=g;c[b+64+4>>2]=h}j=Jp(g|0,h|0,i|0,j|0)|0;c[b+64>>2]=j;c[b+64+4>>2]=D;j=mo(128,0,k&127|0,0)|0;g=D;if(g>>>0>f>>>0|(g|0)==(f|0)&j>>>0>e>>>0){if(!((e|0)==0&(f|0)==0)){g=0;h=0;do{n=a[d+g>>0]|0;o=Jp(g|0,h|0,k&127|0,0)|0;a[b+80+o>>0]=n;g=Jp(g|0,h|0,1,0)|0;h=D}while(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0)}}else{if(!((j|0)==0&(g|0)==0)){h=0;i=0;do{n=a[d+h>>0]|0;o=Jp(h|0,i|0,k&127|0,0)|0;a[b+80+o>>0]=n;h=Jp(h|0,i|0,1,0)|0;i=D}while(i>>>0<g>>>0|(i|0)==(g|0)&h>>>0<j>>>0)}Yb(b,b+80|0);g=mo(e|0,f|0,j|0,g|0)|0;h=D;if(h>>>0>0|(h|0)==0&g>>>0>127){i=d+j|0;do{Yb(b,i);i=i+128|0;g=Jp(g|0,h|0,-128,-1)|0;h=D}while(h>>>0>0|(h|0)==0&g>>>0>127);j=i}else j=d+j|0;g=g&127;if(!((g|0)==0&0==0)){h=0;i=0;do{a[b+80+h>>0]=a[j+h>>0]|0;h=Jp(h|0,i|0,1,0)|0;i=D}while(i>>>0<0|(i|0)==0&h>>>0<g>>>0)}}return 0}function Zd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0;a:do if(b>>>0<=20)do switch(b|0){case 9:{e=(c[d>>2]|0)+(4-1)&~(4-1);b=c[e>>2]|0;c[d>>2]=e+4;c[a>>2]=b;break a}case 10:{b=(c[d>>2]|0)+(4-1)&~(4-1);e=c[b>>2]|0;c[d>>2]=b+4;c[a>>2]=e;c[a+4>>2]=((e|0)<0)<<31>>31;break a}case 11:{b=(c[d>>2]|0)+(4-1)&~(4-1);e=c[b>>2]|0;c[d>>2]=b+4;c[a>>2]=e;c[a+4>>2]=0;break a}case 12:{f=(c[d>>2]|0)+(8-1)&~(8-1);b=c[f>>2]|0;e=c[f+4>>2]|0;c[d>>2]=f+8;c[a>>2]=b;c[a+4>>2]=e;break a}case 13:{e=(c[d>>2]|0)+(4-1)&~(4-1);f=c[e>>2]|0;c[d>>2]=e+4;c[a>>2]=(f&65535)<<16>>16;c[a+4>>2]=(((f&65535)<<16>>16|0)<0)<<31>>31;break a}case 14:{e=(c[d>>2]|0)+(4-1)&~(4-1);f=c[e>>2]|0;c[d>>2]=e+4;c[a>>2]=f&65535;c[a+4>>2]=0;break a}case 15:{e=(c[d>>2]|0)+(4-1)&~(4-1);f=c[e>>2]|0;c[d>>2]=e+4;c[a>>2]=(f&255)<<24>>24;c[a+4>>2]=(((f&255)<<24>>24|0)<0)<<31>>31;break a}case 16:{e=(c[d>>2]|0)+(4-1)&~(4-1);f=c[e>>2]|0;c[d>>2]=e+4;c[a>>2]=f&255;c[a+4>>2]=0;break a}case 17:{f=(c[d>>2]|0)+(8-1)&~(8-1);g=+h[f>>3];c[d>>2]=f+8;h[a>>3]=g;break a}case 18:{f=(c[d>>2]|0)+(8-1)&~(8-1);g=+h[f>>3];c[d>>2]=f+8;h[a>>3]=g;break a}default:break a}while(0);while(0);return}function _d(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;o=i;n=i=i+63&-64;i=i+16|0;d=e;while(1){if((d|0)==(f|0)){d=f;break}if(!(c[d>>2]|0))break;d=d+4|0}c[k>>2]=h;c[g>>2]=e;a:while(1){if((h|0)==(j|0)|(e|0)==(f|0)){p=33;break}l=aq(c[b+8>>2]|0)|0;m=Ne(h,g,d-e>>2,j-h|0)|0;if(l|0)aq(l)|0;switch(m|0){case -1:{p=10;break a}case 0:{e=1;break a}default:{}}h=(c[k>>2]|0)+m|0;c[k>>2]=h;if((h|0)==(j|0)){p=32;break}if((d|0)==(f|0)){e=c[g>>2]|0;d=f;continue}e=aq(c[b+8>>2]|0)|0;h=Wg(n,0)|0;if(e|0)aq(e)|0;if((h|0)==-1){e=2;p=31;break}if(h>>>0>(j-(c[k>>2]|0)|0)>>>0){e=1;p=31;break}else e=n;while(1){if(!h)break;l=a[e>>0]|0;m=c[k>>2]|0;c[k>>2]=m+1;a[m>>0]=l;h=h+-1|0;e=e+1|0}e=(c[g>>2]|0)+4|0;c[g>>2]=e;h=e;while(1){if((h|0)==(f|0)){d=f;break}if(!(c[h>>2]|0)){d=h;break}h=h+4|0}h=c[k>>2]|0}if((p|0)==10){c[k>>2]=h;while(1){if((e|0)==(c[g>>2]|0))break;f=c[e>>2]|0;d=aq(c[b+8>>2]|0)|0;h=Wg(h,f)|0;if(d|0)aq(d)|0;if((h|0)==-1)break;h=(c[k>>2]|0)+h|0;c[k>>2]=h;e=e+4|0}c[g>>2]=e;e=2}else if((p|0)!=31)if((p|0)==32){e=c[g>>2]|0;p=33}if((p|0)==33)e=(e|0)!=(f|0)&1;i=o;return e|0}function $d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=c[b+56>>2]|0;g=c[b+56+4>>2]|0;if(!((f|0)==0&(g|0)==0)){a[b+64+f>>0]=1;e=Jp(f|0,g|0,1,0)|0;h=D;if(h>>>0<0|(h|0)==0&e>>>0<16){h=mo(14,0,f|0,g|0)|0;Yi(b+64+e|0,0,h+1|0)|0}a[b+80>>0]=1;$c(b,b+64|0,16,0)}g=c[b+24>>2]|0;h=(c[b+28>>2]|0)+(g>>>26)|0;k=(h>>>26)+(c[b+32>>2]|0)|0;i=(k>>>26)+(c[b+36>>2]|0)|0;e=((i>>>26)*5|0)+(c[b+20>>2]|0)|0;l=((((e&67108863)+5|0)>>>26)+((e>>>26)+(g&67108863))|0)>>>26;j=(i|-67108864)+((((l+(h&67108863)|0)>>>26)+(k&67108863)|0)>>>26)|0;g=(((e&67108863)+5|0)>>>26)+((e>>>26)+(g&67108863))&67108863&(j>>>31)+-1|j>>31&(e>>>26)+(g&67108863);k=((l+(h&67108863)|0)>>>26)+k&67108863&(j>>>31)+-1|j>>31&(k&67108863);e=Jp(e+5&67108863&(j>>>31)+-1|j>>31&(e&67108863)|g<<26|0,0,c[b+40>>2]|0,0)|0;f=D;g=Jp(g>>>6|(l+h&67108863&(j>>>31)+-1|j>>31&(h&67108863))<<20|0,0,c[b+44>>2]|0,0)|0;f=Jp(g|0,D|0,f|0,0)|0;g=D;h=Jp((l+h&67108863&(j>>>31)+-1|j>>31&(h&67108863))>>>12|k<<14|0,0,c[b+48>>2]|0,0)|0;g=Jp(h|0,D|0,g|0,0)|0;h=D;i=Jp(k>>>18|((j>>>31)+-1&j|j>>31&i)<<8|0,0,c[b+52>>2]|0,0)|0;h=Jp(i|0,D|0,h|0,0)|0;a[d>>0]=e;a[d+1>>0]=e>>8;a[d+2>>0]=e>>16;a[d+3>>0]=e>>24;a[d+4>>0]=f;a[d+4+1>>0]=f>>8;a[d+4+2>>0]=f>>16;a[d+4+3>>0]=f>>24;a[d+8>>0]=g;a[d+8+1>>0]=g>>8;a[d+8+2>>0]=g>>16;a[d+8+3>>0]=g>>24;a[d+12>>0]=h;a[d+12+1>>0]=h>>8;a[d+12+2>>0]=h>>16;a[d+12+3>>0]=h>>24;bl(b,88);return}function ae(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=c[a+4>>2]|0;if(e>>>0<(c[a+100>>2]|0)>>>0){c[a+4>>2]=e+1;e=d[e>>0]|0}else e=ug(a)|0;switch(e|0){case 43:case 45:{f=(e|0)==45&1;e=c[a+4>>2]|0;if(e>>>0<(c[a+100>>2]|0)>>>0){c[a+4>>2]=e+1;e=d[e>>0]|0}else e=ug(a)|0;if((b|0)!=0&(e+-48|0)>>>0>9?(c[a+100>>2]|0)!=0:0)c[a+4>>2]=(c[a+4>>2]|0)+-1;break}default:f=0}if((e+-48|0)>>>0>9)if(!(c[a+100>>2]|0)){f=-2147483648;e=0}else{c[a+4>>2]=(c[a+4>>2]|0)+-1;f=-2147483648;e=0}else{h=0;do{h=e+-48+(h*10|0)|0;e=c[a+4>>2]|0;if(e>>>0<(c[a+100>>2]|0)>>>0){c[a+4>>2]=e+1;e=d[e>>0]|0}else e=ug(a)|0;b=(e+-48|0)>>>0<10}while(b&(h|0)<214748364);g=((h|0)<0)<<31>>31;if(b){b=h;do{g=_m(b|0,g|0,10,0)|0;b=D;e=Jp(e|0,((e|0)<0)<<31>>31|0,-48,-1)|0;b=Jp(e|0,D|0,g|0,b|0)|0;g=D;e=c[a+4>>2]|0;if(e>>>0<(c[a+100>>2]|0)>>>0){c[a+4>>2]=e+1;e=d[e>>0]|0}else e=ug(a)|0}while((e+-48|0)>>>0<10&((g|0)<21474836|(g|0)==21474836&b>>>0<2061584302))}else b=h;if((e+-48|0)>>>0<10)do{e=c[a+4>>2]|0;if(e>>>0<(c[a+100>>2]|0)>>>0){c[a+4>>2]=e+1;e=d[e>>0]|0}else e=ug(a)|0}while((e+-48|0)>>>0<10);if(c[a+100>>2]|0)c[a+4>>2]=(c[a+4>>2]|0)+-1;a=(f|0)!=0;e=mo(0,0,b|0,g|0)|0;f=a?D:g;e=a?e:b}D=f;return e|0}function be(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0;c[e>>2]=b;c[h>>2]=f;if(j&2)if((g-f|0)<3)b=1;else{c[h>>2]=f+1;a[f>>0]=-17;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=-69;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=-65;k=4}else k=4;a:do if((k|0)==4){b=c[e>>2]|0;while(1){if(b>>>0>=d>>>0){b=0;break a}j=c[b>>2]|0;if(j>>>0>i>>>0|(j&-2048|0)==55296){b=2;break a}do if(j>>>0>=128){if(j>>>0<2048){b=c[h>>2]|0;if((g-b|0)<2){b=1;break a}c[h>>2]=b+1;a[b>>0]=j>>>6|192;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=j&63|128;break}b=c[h>>2]|0;if(j>>>0<65536){if((g-b|0)<3){b=1;break a}c[h>>2]=b+1;a[b>>0]=j>>>12|224;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=j>>>6&63|128;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=j&63|128;break}else{if((g-b|0)<4){b=1;break a}c[h>>2]=b+1;a[b>>0]=j>>>18|240;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=j>>>12&63|128;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=j>>>6&63|128;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=j&63|128;break}}else{b=c[h>>2]|0;if((g-b|0)<1){b=1;break a}c[h>>2]=b+1;a[b>>0]=j}while(0);b=(c[e>>2]|0)+4|0;c[e>>2]=b}}while(0);return b|0}function ce(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;m=i;k=i=i+63&-64;i=i+32|0;if(a[b+52>>0]|0){f=c[b+48>>2]|0;if(e){c[b+48>>2]=-1;a[b+52>>0]=0}}else{f=c[b+44>>2]|0;f=(f|0)>1?f:1;h=0;while(1){if((h|0)>=(f|0)){l=8;break}g=cj(c[b+32>>2]|0)|0;if((g|0)==-1){f=-1;break}a[k+16+h>>0]=g;h=h+1|0}if((l|0)==8){do if(!(a[b+53>>0]|0)){a:while(1){n=c[b+40>>2]|0;g=c[n>>2]|0;h=c[n+4>>2]|0;o=c[b+36>>2]|0;j=k+16+f|0;switch(Vb[c[(c[o>>2]|0)+16>>2]&31](o,n,k+16|0,j,k+4|0,k+8|0,k+8+1|0,k)|0){case 3:{l=15;break a}case 2:{l=17;break a}case 1:break;default:break a}o=c[b+40>>2]|0;c[o>>2]=g;c[o+4>>2]=h;if((f|0)==8){l=17;break}g=cj(c[b+32>>2]|0)|0;if((g|0)==-1){l=17;break}a[j>>0]=g;f=f+1|0}if((l|0)==15)a[k+8>>0]=a[k+16>>0]|0;else if((l|0)==17){f=-1;break}l=18}else{a[k+8>>0]=a[k+16>>0]|0;l=18}while(0);b:do if((l|0)==18){if(e){f=a[k+8>>0]|0;c[b+48>>2]=f&255}else{while(1){if((f|0)<=0)break;f=f+-1|0;if((Dj(d[k+16+f>>0]|0,c[b+32>>2]|0)|0)==-1){f=-1;break b}}f=a[k+8>>0]|0}f=f&255}while(0)}}i=m;return f|0}function de(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;l=i;j=i=i+63&-64;i=i+32|0;if(a[b+52>>0]|0){e=c[b+48>>2]|0;if(d){c[b+48>>2]=-1;a[b+52>>0]=0}}else{e=c[b+44>>2]|0;e=(e|0)>1?e:1;g=0;while(1){if((g|0)>=(e|0)){k=8;break}f=cj(c[b+32>>2]|0)|0;if((f|0)==-1){e=-1;break}a[j+16+g>>0]=f;g=g+1|0}if((k|0)==8){do if(!(a[b+53>>0]|0)){a:while(1){m=c[b+40>>2]|0;f=c[m>>2]|0;g=c[m+4>>2]|0;n=c[b+36>>2]|0;h=j+16+e|0;switch(Vb[c[(c[n>>2]|0)+16>>2]&31](n,m,j+16|0,h,j+4|0,j+8|0,j+8+4|0,j)|0){case 3:{k=15;break a}case 2:{k=17;break a}case 1:break;default:break a}n=c[b+40>>2]|0;c[n>>2]=f;c[n+4>>2]=g;if((e|0)==8){k=17;break}f=cj(c[b+32>>2]|0)|0;if((f|0)==-1){k=17;break}a[h>>0]=f;e=e+1|0}if((k|0)==15)c[j+8>>2]=a[j+16>>0];else if((k|0)==17){e=-1;break}k=18}else{c[j+8>>2]=a[j+16>>0];k=18}while(0);b:do if((k|0)==18){if(d){e=c[j+8>>2]|0;c[b+48>>2]=e;break}while(1){if((e|0)<=0)break;e=e+-1|0;if((Dj(a[j+16+e>>0]|0,c[b+32>>2]|0)|0)==-1){e=-1;break b}}e=c[j+8>>2]|0}while(0)}}i=l;return e|0}function ee(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;k=i;j=i=i+63&-64;i=i+16|0;a:do if(!b){f=c[d>>2]|0;b=c[f>>2]|0;if(!b)e=0;else{e=0;do{if(b>>>0>127){b=Wg(j,b)|0;if((b|0)==-1){e=-1;break a}}else b=1;e=b+e|0;f=f+4|0;b=c[f>>2]|0}while((b|0)!=0)}}else{b:do if(e>>>0>3){f=e;g=c[d>>2]|0;while(1){h=c[g>>2]|0;if((h+-1|0)>>>0>126){if(!h)break;h=Wg(b,h)|0;if((h|0)==-1){e=-1;break a}b=b+h|0;f=f-h|0}else{a[b>>0]=h;b=b+1|0;f=f+-1|0;g=c[d>>2]|0}g=g+4|0;c[d>>2]=g;if(f>>>0<=3)break b}a[b>>0]=0;c[d>>2]=0;e=e-f|0;break a}else f=e;while(0);if(f){g=c[d>>2]|0;while(1){h=c[g>>2]|0;if((h+-1|0)>>>0>126){if(!h){g=19;break}h=Wg(j,h)|0;if((h|0)==-1){e=-1;break a}if(f>>>0<h>>>0){g=22;break}Wg(b,c[g>>2]|0)|0;b=b+h|0;f=f-h|0}else{a[b>>0]=h;b=b+1|0;f=f+-1|0;g=c[d>>2]|0}g=g+4|0;c[d>>2]=g;if(!f)break a}if((g|0)==19){a[b>>0]=0;c[d>>2]=0;e=e-f|0;break}else if((g|0)==22){e=e-f|0;break}}}while(0);i=k;return e|0}function fe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;f=a[b+8+3>>0]|0;if(f<<24>>24<0){i=c[b+4>>2]|0;d=(c[b+8>>2]&2147483647)+-1|0}else{i=f&255;d=1}if(i>>>0<2)h=1;else h=(i+4&-4)+-1|0;a:do if((h|0)!=(d|0)){do if((h|0)==1){e=c[b>>2]|0;if(f<<24>>24<0){d=b;f=0;g=21}else{nr(b,e,(f&255)+1|0);$u(e);g=24}}else{e=h+1|0;do if(h>>>0>d>>>0)if(e>>>0>1073741823){b=db(4)|0;eu(b);sb(b|0,1944,114)}else{d=Rj(e<<2)|0;break}else{if(e>>>0<=1073741823){o=0;d=ha(85,e<<2|0)|0;g=o;o=0;if(!(g&1))break}else{b=db(4)|0;eu(b);o=0;Da(27,b|0,1944,114);o=0}b=Za(0)|0;jb(b|0)|0;fb();break a}while(0);if(f<<24>>24<0){f=1;e=c[b>>2]|0;g=21;break}else{nr(d,b,(f&255)+1|0);f=b+4|0;g=23;break}}while(0);if((g|0)==21){nr(d,e,(c[b+4>>2]|0)+1|0);$u(e);if(f){e=h+1|0;f=b+4|0;g=23}else g=24}if((g|0)==23){c[b+8>>2]=e|-2147483648;c[f>>2]=i;c[b>>2]=d;break}else if((g|0)==24){a[b+8+3>>0]=i;break}}while(0);return}function ge(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;g=i;h=i=i+63&-64;i=i+592|0;f=0;do{k=a[e+f>>0]|0;j=f<<1;a[h+520+j>>0]=k&15;a[h+520+(j|1)>>0]=(k&255)>>>4;f=f+1|0}while((f|0)!=32);e=0;f=0;do{k=h+520+f|0;j=(d[k>>0]|0)+e|0;e=(j<<24)+134217728>>28;a[k>>0]=j-(e<<4);f=f+1|0}while((f|0)!=63);a[h+520+63>>0]=(d[h+520+63>>0]|0)+e;e=b;f=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));c[b+40>>2]=1;e=b+44|0;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));c[b+80>>2]=1;e=b+84|0;f=e+76|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));e=1;do{Jd(h,(e|0)/2|0,a[h+520+e>>0]|0);Lg(h+240|0,b,h);Rk(b,h+240|0);e=e+2|0}while((e|0)<64);Ce(h+400|0,b);rh(h+240|0,h+400|0);jm(h+120|0,h+240|0);rh(h+240|0,h+120|0);jm(h+120|0,h+240|0);rh(h+240|0,h+120|0);jm(h+120|0,h+240|0);rh(h+240|0,h+120|0);Rk(b,h+240|0);e=0;do{Jd(h,(e|0)/2|0,a[h+520+e>>0]|0);Lg(h+240|0,b,h);Rk(b,h+240|0);e=e+2|0}while((e|0)<64);i=g;return}function he(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;m=i;n=i=i+63&-64;i=i+192|0;if((e+-1&255)>63)Ta();if((f|0)!=0&g<<24>>24!=0?(g&255)<=64:0){a[n+128>>0]=e;a[n+128+1>>0]=g;a[n+128+2>>0]=1;a[n+128+3>>0]=1;k=n+128+4|0;l=k+28|0;do{a[k>>0]=0;k=k+1|0}while((k|0)<(l|0));if(!h){k=n+128+32|0;l=k+16|0;do{a[k>>0]=0;k=k+1|0}while((k|0)<(l|0))}else{k=n+128+32|0;e=h;l=k+16|0;do{a[k>>0]=a[e>>0]|0;k=k+1|0;e=e+1|0}while((k|0)<(l|0))}if(!j){k=n+128+48|0;l=k+16|0;do{a[k>>0]=0;k=k+1|0}while((k|0)<(l|0))}else{k=n+128+48|0;e=j;l=k+16|0;do{a[k>>0]=a[e>>0]|0;k=k+1|0;e=e+1|0}while((k|0)<(l|0))}Yi(b+64|0,0,293)|0;k=b;e=400;l=k+64|0;do{c[k>>2]=c[e>>2];k=k+4|0;e=e+4|0}while((k|0)<(l|0));e=0;do{k=n+128+(e<<3)|0;j=b+(e<<3)|0;l=c[j+4>>2]^(d[k+4>>0]|d[k+4+1>>0]<<8|d[k+4+2>>0]<<16|d[k+4+3>>0]<<24);c[j>>2]=c[j>>2]^(d[k>>0]|d[k+1>>0]<<8|d[k+2>>0]<<16|d[k+3>>0]<<24);c[j+4>>2]=l;e=e+1|0}while((e|0)!=8);Yi(n+(g&255)|0,0,(g<<24>>24<0?0:128-(g&255)|0)|0)|0;bi(n|0,f|0,g&255|0)|0;af(b,n,128,0);bl(n,128);i=m;return}Ta()}function ie(){var a=0;Jh();c[12821]=37788;c[12823]=37808;c[12822]=0;ak(51292,51964);c[12841]=0;c[12842]=-1;Hh();c[12843]=37828;c[12845]=37848;c[12844]=0;ak(51380,52028);c[12863]=0;c[12864]=-1;Hg(52092,34300,52140);c[12865]=37868;c[12866]=37888;ak(51464,52092);c[12884]=0;c[12885]=-1;Gg(52148,34300,52196);c[12886]=37908;c[12887]=37928;ak(51548,52148);c[12905]=0;c[12906]=-1;Hg(52204,34076,52252);c[12907]=37868;c[12908]=37888;ak(51632,52204);c[12926]=0;c[12927]=-1;a=c[51628+(c[(c[12907]|0)+-12>>2]|0)+24>>2]|0;c[12949]=37868;c[12950]=37888;ak(51800,a);c[12968]=0;c[12969]=-1;Gg(52260,34076,52308);c[12928]=37908;c[12929]=37928;ak(51716,52260);c[12947]=0;c[12948]=-1;a=c[51712+(c[(c[12928]|0)+-12>>2]|0)+24>>2]|0;c[12970]=37908;c[12971]=37928;ak(51884,a);c[12989]=0;c[12990]=-1;c[51284+(c[(c[12821]|0)+-12>>2]|0)+72>>2]=51460;c[51372+(c[(c[12843]|0)+-12>>2]|0)+72>>2]=51544;a=51628+(c[(c[12907]|0)+-12>>2]|0)+4|0;c[a>>2]=c[a>>2]|8192;a=51712+(c[(c[12928]|0)+-12>>2]|0)+4|0;c[a>>2]=c[a>>2]|8192;c[51628+(c[(c[12907]|0)+-12>>2]|0)+72>>2]=51460;c[51712+(c[(c[12928]|0)+-12>>2]|0)+72>>2]=51544;return}function je(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=i=i+63&-64;i=i+368|0;if(!((a|0)==0|(b|0)==0)){ri(f,0,0,64)|0;c[f+360>>2]=c[b+48>>2];cq(f,f+360|0,4,0)|0;c[f+360>>2]=c[b+4>>2];cq(f,f+360|0,4,0)|0;c[f+360>>2]=c[b+44>>2];cq(f,f+360|0,4,0)|0;c[f+360>>2]=c[b+40>>2];cq(f,f+360|0,4,0)|0;c[f+360>>2]=19;cq(f,f+360|0,4,0)|0;c[f+360>>2]=d;cq(f,f+360|0,4,0)|0;c[f+360>>2]=c[b+12>>2];cq(f,f+360|0,4,0)|0;d=c[b+8>>2]|0;if(d|0?(cq(f,d,c[b+12>>2]|0,0)|0,c[b+56>>2]&1|0):0){bl(c[b+8>>2]|0,c[b+12>>2]|0);c[b+12>>2]=0}c[f+360>>2]=c[b+20>>2];cq(f,f+360|0,4,0)|0;d=c[b+16>>2]|0;if(d|0)cq(f,d,c[b+20>>2]|0,0)|0;c[f+360>>2]=c[b+28>>2];cq(f,f+360|0,4,0)|0;d=c[b+24>>2]|0;if(d|0?(cq(f,d,c[b+28>>2]|0,0)|0,c[b+56>>2]&2|0):0){bl(c[b+24>>2]|0,c[b+28>>2]|0);c[b+28>>2]=0}c[f+360>>2]=c[b+36>>2];cq(f,f+360|0,4,0)|0;d=c[b+32>>2]|0;if(d|0)cq(f,d,c[b+36>>2]|0,0)|0;dn(f,a,64)|0}i=e;return}function ke(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=c[b+56>>2]|0;g=c[b+56+4>>2]|0;if(!((h|0)==0&(g|0)==0)){j=mo(16,0,h|0,g|0)|0;l=D;k=l>>>0>f>>>0|(l|0)==(f|0)&j>>>0>e>>>0?e:j;l=l>>>0>f>>>0|(l|0)==(f|0)&j>>>0>e>>>0?f:l;if(!((k|0)==0&(l|0)==0)){j=0;i=0;do{n=a[d+j>>0]|0;h=Jp(h|0,g|0,j|0,i|0)|0;a[b+64+h>>0]=n;j=Jp(j|0,i|0,1,0)|0;i=D;h=c[b+56>>2]|0;g=c[b+56+4>>2]|0}while(i>>>0<l>>>0|(i|0)==(l|0)&j>>>0<k>>>0)}n=Jp(h|0,g|0,k|0,l|0)|0;j=D;c[b+56>>2]=n;c[b+56+4>>2]=j;if(!(j>>>0<0|(j|0)==0&n>>>0<16)){e=mo(e|0,f|0,k|0,l|0)|0;f=D;$c(b,b+64|0,16,0);c[b+56>>2]=0;c[b+56+4>>2]=0;d=d+k|0;m=6}}else m=6;if((m|0)==6){if(f>>>0>0|(f|0)==0&e>>>0>15){h=e&-16;$c(b,d,h,f);e=mo(e|0,f|0,h|0,f|0)|0;h=d+h|0;f=D}else h=d;if(!((e|0)==0&(f|0)==0)){d=0;g=0;do{m=a[h+d>>0]|0;n=Jp(c[b+56>>2]|0,c[b+56+4>>2]|0,d|0,g|0)|0;a[b+64+n>>0]=m;d=Jp(d|0,g|0,1,0)|0;g=D}while(g>>>0<f>>>0|(g|0)==(f|0)&d>>>0<e>>>0);n=Jp(c[b+56>>2]|0,c[b+56+4>>2]|0,e|0,f|0)|0;c[b+56>>2]=n;c[b+56+4>>2]=D}}return}function le(b,d,e,f,g,h,i,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;o=c[f>>2]|0;do if((o|0)==(e|0)){m=(a[l+24>>0]|0)==b<<24>>24;if(!m?(a[l+25>>0]|0)!=b<<24>>24:0){n=5;break}c[f>>2]=e+1;a[e>>0]=m?43:45;c[g>>2]=0;m=0}else n=5;while(0);a:do if((n|0)==5){n=a[i+11>>0]|0;if(b<<24>>24==h<<24>>24?((n<<24>>24<0?c[i+4>>2]|0:n&255)|0)!=0:0){m=c[k>>2]|0;if((m-j|0)>=160){m=0;break}d=c[g>>2]|0;c[k>>2]=m+4;c[m>>2]=d;c[g>>2]=0;m=0;break}m=l;while(1){if((m|0)==(l+26|0)){m=l+26|0;break}if((a[m>>0]|0)==b<<24>>24)break;m=m+1|0}m=m-l|0;if((m|0)>23)m=-1;else{switch(d|0){case 10:case 8:{if((m|0)>=(d|0)){m=-1;break a}break}case 16:{if((m|0)>=22){if((o|0)==(e|0)){m=-1;break a}if((o-e|0)>=3){m=-1;break a}if((a[o+-1>>0]|0)!=48){m=-1;break a}c[g>>2]=0;m=a[47202+m>>0]|0;c[f>>2]=o+1;a[o>>0]=m;m=0;break a}break}default:{}}m=a[47202+m>>0]|0;c[f>>2]=o+1;a[o>>0]=m;c[g>>2]=(c[g>>2]|0)+1;m=0}}while(0);return m|0}function me(b,d,e,f,g,h,i,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;o=c[f>>2]|0;do if((o|0)==(e|0)){m=(c[l+96>>2]|0)==(b|0);if(!m?(c[l+100>>2]|0)!=(b|0):0){n=5;break}c[f>>2]=e+1;a[e>>0]=m?43:45;c[g>>2]=0;m=0}else n=5;while(0);a:do if((n|0)==5){n=a[i+11>>0]|0;if((b|0)==(h|0)?((n<<24>>24<0?c[i+4>>2]|0:n&255)|0)!=0:0){m=c[k>>2]|0;if((m-j|0)>=160){m=0;break}d=c[g>>2]|0;c[k>>2]=m+4;c[m>>2]=d;c[g>>2]=0;m=0;break}m=l;while(1){if((m|0)==(l+104|0)){m=l+104|0;break}if((c[m>>2]|0)==(b|0))break;m=m+4|0}m=m-l|0;if((m|0)>92)m=-1;else{switch(d|0){case 10:case 8:{if((m>>2|0)>=(d|0)){m=-1;break a}break}case 16:{if((m|0)>=88){if((o|0)==(e|0)){m=-1;break a}if((o-e|0)>=3){m=-1;break a}if((a[o+-1>>0]|0)!=48){m=-1;break a}c[g>>2]=0;m=a[47202+(m>>2)>>0]|0;c[f>>2]=o+1;a[o>>0]=m;m=0;break a}break}default:{}}m=a[47202+(m>>2)>>0]|0;c[f>>2]=o+1;a[o>>0]=m;c[g>>2]=(c[g>>2]|0)+1;m=0}}while(0);return m|0}function ne(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;k=i;l=i=i+63&-64;i=i+496|0;c[l+360>>2]=d;if(d>>>0<65){if((ri(l,0,0,d)|0)>=0){cq(l,l+360|0,4,0)|0;cq(l,e,f,0)|0;dn(l,b,d)|0}}else a:do if((ri(l,0,0,64)|0)>=0?(cq(l,l+360|0,4,0)|0,cq(l,e,f,0)|0,(dn(l,l+432|0,64)|0)>=0):0){g=b;h=l+432|0;j=g+32|0;do{a[g>>0]=a[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));g=l+368|0;h=l+432|0;j=g+64|0;do{a[g>>0]=a[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));if((d+-32|0)>>>0>64){f=b+32|0;e=d+-32|0;do{if((Ii(l+432|0,64,l+368|0,64,0,0,0)|0)<0)break a;g=f;h=l+432|0;j=g+32|0;do{a[g>>0]=a[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));e=e+-32|0;f=f+32|0;g=l+368|0;h=l+432|0;j=g+64|0;do{a[g>>0]=a[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0))}while(e>>>0>64)}else{f=b+32|0;e=d+-32|0}if((Ii(l+432|0,e,l+368|0,64,0,0,0)|0)>=0)bi(f|0,l+432|0,e|0)|0}while(0);bl(l,357);i=k;return}function oe(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;a:do if(!((e|0)==0&(f|0)==0)){j=c[b+32>>2]|0;g=c[b+32+4>>2]|0;i=bo(j|0,g|0,3)|0;h=_n(e|0,f|0,3)|0;h=Jp(j|0,g|0,h|0,D|0)|0;c[b+32>>2]=h;c[b+32+4>>2]=D;if(0>f>>>0|0==(f|0)&(64-(i&63)|0)>>>0>e>>>0){g=0;h=0;while(1){k=a[d+g>>0]|0;j=Jp(g|0,h|0,i&63|0,0)|0;a[b+40+j>>0]=k;g=Jp(g|0,h|0,1,0)|0;h=D;if(!(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0))break a}}if(64-(i&63)|0){g=0;h=0;do{j=a[d+g>>0]|0;k=Jp(g|0,h|0,i&63|0,0)|0;a[b+40+k>>0]=j;g=Jp(g|0,h|0,1,0)|0;h=D}while(h>>>0<0|(h|0)==0&g>>>0<(64-(i&63)|0)>>>0)}$b(b,b+40|0);g=mo(e|0,f|0,64-(i&63)|0,0)|0;h=D;if(h>>>0>0|(h|0)==0&g>>>0>63){e=d+(64-(i&63))|0;do{$b(b,e);e=e+64|0;g=Jp(g|0,h|0,-64,-1)|0;h=D}while(h>>>0>0|(h|0)==0&g>>>0>63);f=e}else f=d+(64-(i&63))|0;g=g&63;if(!((g|0)==0&0==0)){h=0;e=0;do{a[b+40+h>>0]=a[f+h>>0]|0;h=Jp(h|0,e|0,1,0)|0;e=D}while(e>>>0<0|(e|0)==0&h>>>0<g>>>0)}}while(0);return 0}function pe(a,b,e,f,g,h,j){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=i=i+63&-64;i=i+64|0;if(!((e|0)==0&(f|0)==0)){c[l>>2]=1634760805;c[l+4>>2]=857760878;c[l+8>>2]=2036477234;c[l+12>>2]=1797285236;c[l+16>>2]=d[j>>0]|d[j+1>>0]<<8|d[j+2>>0]<<16|d[j+3>>0]<<24;c[l+20>>2]=d[j+4>>0]|d[j+4+1>>0]<<8|d[j+4+2>>0]<<16|d[j+4+3>>0]<<24;c[l+24>>2]=d[j+8>>0]|d[j+8+1>>0]<<8|d[j+8+2>>0]<<16|d[j+8+3>>0]<<24;c[l+28>>2]=d[j+12>>0]|d[j+12+1>>0]<<8|d[j+12+2>>0]<<16|d[j+12+3>>0]<<24;c[l+32>>2]=d[j+16>>0]|d[j+16+1>>0]<<8|d[j+16+2>>0]<<16|d[j+16+3>>0]<<24;c[l+36>>2]=d[j+20>>0]|d[j+20+1>>0]<<8|d[j+20+2>>0]<<16|d[j+20+3>>0]<<24;c[l+40>>2]=d[j+24>>0]|d[j+24+1>>0]<<8|d[j+24+2>>0]<<16|d[j+24+3>>0]<<24;c[l+44>>2]=d[j+28>>0]|d[j+28+1>>0]<<8|d[j+28+2>>0]<<16|d[j+28+3>>0]<<24;c[l+48>>2]=h;c[l+52>>2]=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;c[l+56>>2]=d[g+4>>0]|d[g+4+1>>0]<<8|d[g+4+2>>0]<<16|d[g+4+3>>0]<<24;c[l+60>>2]=d[g+8>>0]|d[g+8+1>>0]<<8|d[g+8+2>>0]<<16|d[g+8+3>>0]<<24;pc(l,b,a,e,f);bl(l,64)}i=k;return 0}function qe(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+64|0;if(!((b|0)==0&(e|0)==0)){c[j>>2]=1634760805;c[j+4>>2]=857760878;c[j+8>>2]=2036477234;c[j+12>>2]=1797285236;c[j+16>>2]=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;c[j+20>>2]=d[g+4>>0]|d[g+4+1>>0]<<8|d[g+4+2>>0]<<16|d[g+4+3>>0]<<24;c[j+24>>2]=d[g+8>>0]|d[g+8+1>>0]<<8|d[g+8+2>>0]<<16|d[g+8+3>>0]<<24;c[j+28>>2]=d[g+12>>0]|d[g+12+1>>0]<<8|d[g+12+2>>0]<<16|d[g+12+3>>0]<<24;c[j+32>>2]=d[g+16>>0]|d[g+16+1>>0]<<8|d[g+16+2>>0]<<16|d[g+16+3>>0]<<24;c[j+36>>2]=d[g+20>>0]|d[g+20+1>>0]<<8|d[g+20+2>>0]<<16|d[g+20+3>>0]<<24;c[j+40>>2]=d[g+24>>0]|d[g+24+1>>0]<<8|d[g+24+2>>0]<<16|d[g+24+3>>0]<<24;c[j+44>>2]=d[g+28>>0]|d[g+28+1>>0]<<8|d[g+28+2>>0]<<16|d[g+28+3>>0]<<24;c[j+48>>2]=0;c[j+52>>2]=d[f>>0]|d[f+1>>0]<<8|d[f+2>>0]<<16|d[f+3>>0]<<24;c[j+56>>2]=d[f+4>>0]|d[f+4+1>>0]<<8|d[f+4+2>>0]<<16|d[f+4+3>>0]<<24;c[j+60>>2]=d[f+8>>0]|d[f+8+1>>0]<<8|d[f+8+2>>0]<<16|d[f+8+3>>0]<<24;Yi(a|0,0,b|0)|0;pc(j,a,a,b,e);bl(j,64)}i=h;return 0}function re(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;p=i;o=i=i+63&-64;i=i+1040|0;k=c[b>>2]|0;c[o>>2]=k;e=a|0?e:256;h=a|0?a:o+8|0;a:do if((e|0)!=0&(k|0)!=0){l=d;m=e;d=k;e=0;n=h;while(1){g=l>>>2;h=g>>>0>=m>>>0;if(!(l>>>0>131|h)){g=l;j=m;m=k;h=n;break a}d=h?m:g;g=l-d|0;d=kd(n,o,d,f)|0;if((d|0)==-1)break;h=(n|0)==(o+8|0);l=h?0:d;j=m-l|0;h=h?n:n+(d<<2)|0;e=d+e|0;k=c[o>>2]|0;if((m|0)!=(l|0)&(k|0)!=0){l=g;m=j;d=k;n=h}else{m=k;d=k;break a}}d=c[o>>2]|0;j=0;m=d;e=-1;h=n}else{g=d;j=e;m=k;d=k;e=0}while(0);b:do if((m|0)!=0?(j|0)!=0&(g|0)!=0:0){l=g;k=m;while(1){g=Pe(h,k,l,f)|0;if((g+2|0)>>>0<3)break;k=k+g|0;c[o>>2]=k;j=j+-1|0;e=e+1|0;d=k;if(!((j|0)!=0&(l|0)!=(g|0)))break b;else{l=l-g|0;h=h+4|0}}switch(g|0){case -1:{e=-1;break b}case 0:{c[o>>2]=0;d=0;break b}default:{c[f>>2]=0;break b}}}while(0);if(a|0)c[b>>2]=d;i=p;return e|0}function se(b,c,d,e,f,g,h){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;l=i;m=i=i+63&-64;i=i+352|0;ad(m+256|0,g,h,0)|0;if(b>>>0>=d>>>0?0<f>>>0|0==(f|0)&(b-d|0)>>>0<e>>>0:0)j=5;else if(d>>>0>=b>>>0?0<f>>>0|0==(f|0)&(d-b|0)>>>0<e>>>0:0)j=5;else k=d;if((j|0)==5){Lk(b|0,d|0,e|0)|0;k=b}h=m+288|0;d=h+32|0;do{a[h>>0]=0;h=h+1|0}while((h|0)<(d|0));h=f>>>0>0|(f|0)==0&e>>>0>32?32:e;d=f>>>0>0|(f|0)==0&e>>>0>32?0:f;if(!((h|0)==0&(d|0)==0)){j=Jp((f>>>0<0|(f|0)==0&e>>>0<32?e:32)|0,(f>>>0<0|(f|0)==0&e>>>0<32?f:0)|0,-1,0)|0;bi(m+288+32|0,k|0,j+1|0)|0}j=Jp(h|0,d|0,32,0)|0;io(m+288|0,m+288|0,j,D,g+16|0,m+256|0)|0;Zr(m,m+288|0)|0;if(!((h|0)==0&(d|0)==0)){j=Jp((f>>>0<0|(f|0)==0&e>>>0<32?e:32)|0,(f>>>0<0|(f|0)==0&e>>>0<32?f:0)|0,-1,0)|0;bi(b|0,m+288+32|0,j+1|0)|0}bl(m+288|0,64);if(f>>>0>0|(f|0)==0&e>>>0>32){j=mo(e|0,f|0,h|0,d|0)|0;Vd(b+h|0,k+h|0,j,D,g+16|0,1,0,m+256|0)|0}bl(m+256|0,32);Gp(m,b,e,f)|0;Rr(m,c)|0;bl(m,256);i=l;return 0}function te(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;m=i=i+63&-64;i=i+592|0;k=0;l=32;g=1;while(1){l=l+-1|0;h=a[b+32+l>>0]|0;j=a[42825+l>>0]|0;g=g&255;k=((h&255)-(j&255)|0)>>>8&g|k&255;if(!l)break;else g=(((j^h)&255)+65535|0)>>>8&g}a:do if(k){h=0;do{g=0;j=0;do{g=a[16+(h<<5)+j>>0]^a[b+j>>0]|g;j=j+1|0}while((j|0)!=32);h=h+1|0;if(!(g<<24>>24)){g=-1;break a}}while(h>>>0<12);if(!(Zc(m+328|0,f)|0)){g=0;h=0;do{g=a[f+h>>0]|g;h=h+1|0}while((h|0)!=32);if(g<<24>>24){Gl(m)|0;Yd(m,b,32,0)|0;Yd(m,f,32,0)|0;Yd(m,c,d,e)|0;Yh(m,m+520|0)|0;fc(m+520|0);qd(m+208|0,m+520|0,m+328|0,b+32|0);ei(m+488|0,m+208|0);g=wm(m+488|0,b)|0;g=((m+488|0)==(b|0)?-1:g)|(Li(b,m+488|0,32)|0)}else g=-1}else g=-1}else g=-1;while(0);i=n;return g|0}function ue(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;l=i;k=i=i+63&-64;i=i+48|0;h=c[a+28>>2]|0;c[k+32>>2]=h;h=(c[a+20>>2]|0)-h|0;c[k+32+4>>2]=h;c[k+32+8>>2]=b;c[k+32+12>>2]=d;j=k+32|0;f=2;b=h+d|0;while(1){if(!(c[12680]|0)){c[k+16>>2]=c[a+60>>2];c[k+16+4>>2]=j;c[k+16+8>>2]=f;g=rr(Ab(146,k+16|0)|0)|0}else{vb(124,a|0);c[k>>2]=c[a+60>>2];c[k+4>>2]=j;c[k+8>>2]=f;g=rr(Ab(146,k|0)|0)|0;Na(0)}if((b|0)==(g|0)){b=6;break}if((g|0)<0){b=8;break}b=b-g|0;e=c[j+4>>2]|0;if(g>>>0<=e>>>0)if((f|0)==2){c[a+28>>2]=(c[a+28>>2]|0)+g;h=e;e=j;f=2}else{h=e;e=j}else{h=c[a+44>>2]|0;c[a+28>>2]=h;c[a+20>>2]=h;h=c[j+12>>2]|0;g=g-e|0;e=j+8|0;f=f+-1|0}c[e>>2]=(c[e>>2]|0)+g;c[e+4>>2]=h-g;j=e}if((b|0)==6){k=c[a+44>>2]|0;c[a+16>>2]=k+(c[a+48>>2]|0);c[a+28>>2]=k;c[a+20>>2]=k}else if((b|0)==8){c[a+16>>2]=0;c[a+28>>2]=0;c[a+20>>2]=0;c[a>>2]=c[a>>2]|32;if((f|0)==2)d=0;else d=d-(c[j+4>>2]|0)|0}i=l;return d|0}function ve(a,b,e,f,g,h,j,k){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;m=i=i+63&-64;i=i+64|0;if(!((e|0)==0&(f|0)==0)){c[m>>2]=1634760805;c[m+4>>2]=857760878;c[m+8>>2]=2036477234;c[m+12>>2]=1797285236;c[m+16>>2]=d[k>>0]|d[k+1>>0]<<8|d[k+2>>0]<<16|d[k+3>>0]<<24;c[m+20>>2]=d[k+4>>0]|d[k+4+1>>0]<<8|d[k+4+2>>0]<<16|d[k+4+3>>0]<<24;c[m+24>>2]=d[k+8>>0]|d[k+8+1>>0]<<8|d[k+8+2>>0]<<16|d[k+8+3>>0]<<24;c[m+28>>2]=d[k+12>>0]|d[k+12+1>>0]<<8|d[k+12+2>>0]<<16|d[k+12+3>>0]<<24;c[m+32>>2]=d[k+16>>0]|d[k+16+1>>0]<<8|d[k+16+2>>0]<<16|d[k+16+3>>0]<<24;c[m+36>>2]=d[k+20>>0]|d[k+20+1>>0]<<8|d[k+20+2>>0]<<16|d[k+20+3>>0]<<24;c[m+40>>2]=d[k+24>>0]|d[k+24+1>>0]<<8|d[k+24+2>>0]<<16|d[k+24+3>>0]<<24;c[m+44>>2]=d[k+28>>0]|d[k+28+1>>0]<<8|d[k+28+2>>0]<<16|d[k+28+3>>0]<<24;c[m+48>>2]=h;c[m+52>>2]=j;c[m+56>>2]=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;c[m+60>>2]=d[g+4>>0]|d[g+4+1>>0]<<8|d[g+4+2>>0]<<16|d[g+4+3>>0]<<24;pc(m,b,a,e,f);bl(m,64)}i=l;return 0}function we(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;k=i;l=i=i+63&-64;i=i+1024|0;if(c[e+20>>2]|0){j=0;do{a[b+64>>0]=0;a[b+64+1>>0]=0;a[b+64+2>>0]=0;a[b+64+3>>0]=0;a[b+68>>0]=j;a[b+68+1>>0]=j>>8;a[b+68+2>>0]=j>>16;a[b+68+3>>0]=j>>24;ne(l,1024,b,72);g=S(c[e+16>>2]|0,j)|0;f=c[(c[e>>2]|0)+4>>2]|0;h=0;do{o=l+(h<<3)|0;n=d[o+4>>0]|d[o+4+1>>0]<<8|d[o+4+2>>0]<<16|d[o+4+3>>0]<<24;m=f+(g<<10)+(h<<3)|0;c[m>>2]=d[o>>0]|d[o+1>>0]<<8|d[o+2>>0]<<16|d[o+3>>0]<<24;c[m+4>>2]=n;h=h+1|0}while((h|0)!=128);a[b+64>>0]=1;a[b+64+1>>0]=0;a[b+64+2>>0]=0;a[b+64+3>>0]=0;ne(l,1024,b,72);f=(S(c[e+16>>2]|0,j)|0)+1|0;g=c[(c[e>>2]|0)+4>>2]|0;h=0;do{m=l+(h<<3)|0;n=d[m+4>>0]|d[m+4+1>>0]<<8|d[m+4+2>>0]<<16|d[m+4+3>>0]<<24;o=g+(f<<10)+(h<<3)|0;c[o>>2]=d[m>>0]|d[m+1>>0]<<8|d[m+2>>0]<<16|d[m+3>>0]<<24;c[o+4>>2]=n;h=h+1|0}while((h|0)!=128);j=j+1|0}while(j>>>0<(c[e+20>>2]|0)>>>0)}bl(l,1024);i=k;return}function xe(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;f=i;d=i=i+63&-64;i=i+16|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[d+(e<<2)>>2]=0;e=e+1|0}g=a[h+11>>0]|0;e=g<<24>>24<0?c[h>>2]|0:h;g=e+(g<<24>>24<0?c[h+4>>2]|0:g&255)|0;while(1){if(e>>>0>=g>>>0){g=9;break}o=0;da(61,d|0,a[e>>0]|0);h=o;o=0;if(h&1){g=8;break}e=e+1|0}do if((g|0)==8)e=Ya()|0;else if((g|0)==9){e=(a[d+11>>0]|0)<0?c[d>>2]|0:d;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;g=0;while(1){if((g|0)==3)break;c[b+(g<<2)>>2]=0;g=g+1|0}e=nv(e)|0;g=e+(Kh(e)|0)|0;while(1){if(e>>>0>=g>>>0){g=17;break}o=0;da(61,b|0,a[e>>0]|0);h=o;o=0;if(h&1){g=16;break}e=e+1|0}if((g|0)==16){e=Ya()|0;rq(b);break}else if((g|0)==17){rq(d);i=f;return}}while(0);rq(d);Ra(e|0)}function ye(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+64|0;if(!((b|0)==0&(e|0)==0)){c[j>>2]=1634760805;c[j+4>>2]=857760878;c[j+8>>2]=2036477234;c[j+12>>2]=1797285236;c[j+16>>2]=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;c[j+20>>2]=d[g+4>>0]|d[g+4+1>>0]<<8|d[g+4+2>>0]<<16|d[g+4+3>>0]<<24;c[j+24>>2]=d[g+8>>0]|d[g+8+1>>0]<<8|d[g+8+2>>0]<<16|d[g+8+3>>0]<<24;c[j+28>>2]=d[g+12>>0]|d[g+12+1>>0]<<8|d[g+12+2>>0]<<16|d[g+12+3>>0]<<24;c[j+32>>2]=d[g+16>>0]|d[g+16+1>>0]<<8|d[g+16+2>>0]<<16|d[g+16+3>>0]<<24;c[j+36>>2]=d[g+20>>0]|d[g+20+1>>0]<<8|d[g+20+2>>0]<<16|d[g+20+3>>0]<<24;c[j+40>>2]=d[g+24>>0]|d[g+24+1>>0]<<8|d[g+24+2>>0]<<16|d[g+24+3>>0]<<24;c[j+44>>2]=d[g+28>>0]|d[g+28+1>>0]<<8|d[g+28+2>>0]<<16|d[g+28+3>>0]<<24;c[j+48>>2]=0;c[j+52>>2]=0;c[j+56>>2]=d[f>>0]|d[f+1>>0]<<8|d[f+2>>0]<<16|d[f+3>>0]<<24;c[j+60>>2]=d[f+4>>0]|d[f+4+1>>0]<<8|d[f+4+2>>0]<<16|d[f+4+3>>0]<<24;Yi(a|0,0,b|0)|0;pc(j,a,a,b,e);bl(j,64)}i=h;return 0}function ze(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;if(e<<24>>24?(e&255)<=64:0){if((c[b+80>>2]|0)==0?(c[b+80+4>>2]|0)==0:0){f=c[b+352>>2]|0;do if(f>>>0>128){f=c[b+64>>2]|0;i=c[b+64+4>>2]|0;j=Jp(f|0,i|0,128,0)|0;c[b+64>>2]=j;c[b+64+4>>2]=D;f=Jp((i>>>0>4294967295|(i|0)==-1&f>>>0>4294967167)&1|0,0,c[b+72>>2]|0,c[b+72+4>>2]|0)|0;c[b+72>>2]=f;c[b+72+4>>2]=D;Zb(b,b+96|0);f=(c[b+352>>2]|0)+-128|0;c[b+352>>2]=f;if(f>>>0<129){bi(b+96|0,b+224|0,f|0)|0;g=b+72|0;h=c[b+352>>2]|0;break}else Wa(42059,42091,343,42135)}else{g=b+72|0;h=f}while(0);j=Jp(c[b+64>>2]|0,c[b+64+4>>2]|0,h|0,0)|0;f=D;c[b+64>>2]=j;c[b+64+4>>2]=f;i=g;i=Jp((f>>>0<0|(f|0)==0&j>>>0<h>>>0)&1|0,0,c[i>>2]|0,c[i+4>>2]|0)|0;j=g;c[j>>2]=i;c[j+4>>2]=D;if(a[b+356>>0]|0){c[b+88>>2]=-1;c[b+88+4>>2]=-1}c[b+80>>2]=-1;c[b+80+4>>2]=-1;Yi(b+96+h|0,0,256-h|0)|0;Zb(b,b+96|0);bi(d|0,b|0,e&255|0)|0;f=0}else f=-1;return f|0}Ta();return 0}function Ae(b){b=b|0;var d=0;if((a[50144]|0)==0?sr(50144)|0:0){if((a[50152]|0)==0?sr(50152)|0:0){b=53216;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+(d<<2)>>2]=0;d=d+1|0}b=b+12|0}while((b|0)!=53384);rb(136,0,n|0)|0}On(53216,38904);On(53228,38932);On(53240,38960);On(53252,38992);On(53264,39032);On(53276,39068);On(53288,39096);On(53300,39132);On(53312,39148);On(53324,39164);On(53336,39180);On(53348,39196);On(53360,39212);On(53372,39228);c[13346]=53216}return c[13346]|0}function Be(b){b=b|0;var d=0;if((a[50064]|0)==0?sr(50064)|0:0){if((a[50072]|0)==0?sr(50072)|0:0){b=52404;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+(d<<2)>>2]=0;d=d+1|0}b=b+12|0}while((b|0)!=52572);rb(132,0,n|0)|0}Pn(52404,47724);Pn(52416,47731);Pn(52428,47738);Pn(52440,47746);Pn(52452,47756);Pn(52464,47765);Pn(52476,47772);Pn(52488,47781);Pn(52500,47785);Pn(52512,47789);Pn(52524,47793);Pn(52536,47797);Pn(52548,47801);Pn(52560,47805);c[13143]=52404}return c[13143]|0}function Ce(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;l=c[b+4>>2]|0;k=c[b+8>>2]|0;j=c[b+12>>2]|0;i=c[b+16>>2]|0;h=c[b+20>>2]|0;g=c[b+24>>2]|0;f=c[b+28>>2]|0;e=c[b+32>>2]|0;d=c[b+36>>2]|0;c[a>>2]=c[b>>2];c[a+4>>2]=l;c[a+8>>2]=k;c[a+12>>2]=j;c[a+16>>2]=i;c[a+20>>2]=h;c[a+24>>2]=g;c[a+28>>2]=f;c[a+32>>2]=e;c[a+36>>2]=d;d=c[b+44>>2]|0;e=c[b+48>>2]|0;f=c[b+52>>2]|0;g=c[b+56>>2]|0;h=c[b+60>>2]|0;i=c[b+64>>2]|0;j=c[b+68>>2]|0;k=c[b+72>>2]|0;l=c[b+76>>2]|0;c[a+40>>2]=c[b+40>>2];c[a+44>>2]=d;c[a+48>>2]=e;c[a+52>>2]=f;c[a+56>>2]=g;c[a+60>>2]=h;c[a+64>>2]=i;c[a+68>>2]=j;c[a+72>>2]=k;c[a+76>>2]=l;l=c[b+84>>2]|0;k=c[b+88>>2]|0;j=c[b+92>>2]|0;i=c[b+96>>2]|0;h=c[b+100>>2]|0;g=c[b+104>>2]|0;f=c[b+108>>2]|0;e=c[b+112>>2]|0;d=c[b+116>>2]|0;c[a+80>>2]=c[b+80>>2];c[a+84>>2]=l;c[a+88>>2]=k;c[a+92>>2]=j;c[a+96>>2]=i;c[a+100>>2]=h;c[a+104>>2]=g;c[a+108>>2]=f;c[a+112>>2]=e;c[a+116>>2]=d;return}function De(a){a=a|0;dq(53956);dq(53944);dq(53932);dq(53920);dq(53908);dq(53896);dq(53884);dq(53872);dq(53860);dq(53848);dq(53836);dq(53824);dq(53812);dq(53800);dq(53788);dq(53776);dq(53764);dq(53752);dq(53740);dq(53728);dq(53716);dq(53704);dq(53692);dq(53680);return}function Ee(a){a=a|0;dq(53664);dq(53652);dq(53640);dq(53628);dq(53616);dq(53604);dq(53592);dq(53580);dq(53568);dq(53556);dq(53544);dq(53532);dq(53520);dq(53508);dq(53496);dq(53484);dq(53472);dq(53460);dq(53448);dq(53436);dq(53424);dq(53412);dq(53400);dq(53388);return}function Fe(a){a=a|0;rq(52852);rq(52840);rq(52828);rq(52816);rq(52804);rq(52792);rq(52780);rq(52768);rq(52756);rq(52744);rq(52732);rq(52720);rq(52708);rq(52696);rq(52684);rq(52672);rq(52660);rq(52648);rq(52636);rq(52624);rq(52612);rq(52600);rq(52588);rq(52576);return}function Ge(a){a=a|0;rq(53144);rq(53132);rq(53120);rq(53108);rq(53096);rq(53084);rq(53072);rq(53060);rq(53048);rq(53036);rq(53024);rq(53012);rq(53e3);rq(52988);rq(52976);rq(52964);rq(52952);rq(52940);rq(52928);rq(52916);rq(52904);rq(52892);rq(52880);rq(52868);return}function He(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;k=i=i+63&-64;i=i+96|0;c[k>>2]=(d[h>>0]|d[h+1>>0]<<8|d[h+2>>0]<<16|d[h+3>>0]<<24)&67108863;c[k+4>>2]=(d[h+3>>0]|d[h+3+1>>0]<<8|d[h+3+2>>0]<<16|d[h+3+3>>0]<<24)>>>2&67108611;c[k+8>>2]=(d[h+6>>0]|d[h+6+1>>0]<<8|d[h+6+2>>0]<<16|d[h+6+3>>0]<<24)>>>4&67092735;c[k+12>>2]=(d[h+9>>0]|d[h+9+1>>0]<<8|d[h+9+2>>0]<<16|d[h+9+3>>0]<<24)>>>6&66076671;c[k+16>>2]=(d[h+12>>0]|d[h+12+1>>0]<<8|d[h+12+2>>0]<<16|d[h+12+3>>0]<<24)>>>8&1048575;c[k+20>>2]=0;c[k+20+4>>2]=0;c[k+20+8>>2]=0;c[k+20+12>>2]=0;c[k+20+16>>2]=0;c[k+40>>2]=d[h+16>>0]|d[h+16+1>>0]<<8|d[h+16+2>>0]<<16|d[h+16+3>>0]<<24;c[k+44>>2]=d[h+20>>0]|d[h+20+1>>0]<<8|d[h+20+2>>0]<<16|d[h+20+3>>0]<<24;c[k+48>>2]=d[h+24>>0]|d[h+24+1>>0]<<8|d[h+24+2>>0]<<16|d[h+24+3>>0]<<24;c[k+52>>2]=d[h+28>>0]|d[h+28+1>>0]<<8|d[h+28+2>>0]<<16|d[h+28+3>>0]<<24;c[k+56>>2]=0;c[k+56+4>>2]=0;a[k+80>>0]=0;ke(k,e,f,g);$d(k,b);i=j;return 0}function Ie(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=c[a>>2]|0;v=c[a+4>>2]|0;t=c[a+8>>2]|0;r=c[a+12>>2]|0;p=c[a+16>>2]|0;n=c[a+20>>2]|0;l=c[a+24>>2]|0;j=c[a+28>>2]|0;h=c[a+32>>2]|0;f=c[a+36>>2]|0;w=c[b>>2]|0;u=c[b+4>>2]|0;s=c[b+8>>2]|0;q=c[b+12>>2]|0;o=c[b+16>>2]|0;m=c[b+20>>2]|0;k=c[b+24>>2]|0;i=c[b+28>>2]|0;g=c[b+32>>2]|0;e=c[b+36>>2]|0;c[a>>2]=(w^x)&0-d^x;c[a+4>>2]=(u^v)&0-d^v;c[a+8>>2]=(s^t)&0-d^t;c[a+12>>2]=(q^r)&0-d^r;c[a+16>>2]=(o^p)&0-d^p;c[a+20>>2]=(m^n)&0-d^n;c[a+24>>2]=(k^l)&0-d^l;c[a+28>>2]=(i^j)&0-d^j;c[a+32>>2]=(g^h)&0-d^h;c[a+36>>2]=(e^f)&0-d^f;c[b>>2]=(w^x)&0-d^w;c[b+4>>2]=(u^v)&0-d^u;c[b+8>>2]=(s^t)&0-d^s;c[b+12>>2]=(q^r)&0-d^q;c[b+16>>2]=(o^p)&0-d^o;c[b+20>>2]=(m^n)&0-d^m;c[b+24>>2]=(k^l)&0-d^k;c[b+28>>2]=(i^j)&0-d^i;c[b+32>>2]=(g^h)&0-d^g;c[b+36>>2]=(e^f)&0-d^e;return}function Je(b){b=b|0;var d=0,e=0,f=0,g=0;f=i;e=i=i+63&-64;i=i+16|0;a:do if(c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0){o=0;da(58,e|0,b|0);d=o;o=0;b:do if(d&1)d=Za(0)|0;else{do if(a[e>>0]|0){d=c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0;o=0;d=ha(c[(c[d>>2]|0)+24>>2]|0,d|0)|0;g=o;o=0;if(!(g&1)){if((d|0)!=-1)break;g=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;o=0;da(57,g|0,c[g+16>>2]|1|0);g=o;o=0;if(!(g&1))break}d=Za(0)|0;Yf(e);break b}while(0);Yf(e);break a}while(0);jb(d|0)|0;o=0;ba(127,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);g=o;o=0;if(!(g&1)){fb();break}d=Ya()|0;o=0;Fa(19);g=o;o=0;if(g&1){g=Za(0)|0;lt(g)}else Ra(d|0)}while(0);i=f;return}function Ke(b){b=b|0;var d=0,e=0,f=0,g=0;f=i;e=i=i+63&-64;i=i+16|0;a:do if(c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0){o=0;da(56,e|0,b|0);d=o;o=0;b:do if(d&1)d=Za(0)|0;else{do if(a[e>>0]|0){d=c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0;o=0;d=ha(c[(c[d>>2]|0)+24>>2]|0,d|0)|0;g=o;o=0;if(!(g&1)){if((d|0)!=-1)break;g=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;o=0;da(57,g|0,c[g+16>>2]|1|0);g=o;o=0;if(!(g&1))break}d=Za(0)|0;Yf(e);break b}while(0);Yf(e);break a}while(0);jb(d|0)|0;o=0;ba(127,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);g=o;o=0;if(!(g&1)){fb();break}d=Ya()|0;o=0;Fa(19);g=o;o=0;if(g&1){g=Za(0)|0;lt(g)}else Ra(d|0)}while(0);i=f;return}function Le(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;k=i;j=i=i+63&-64;i=i+96|0;ad(j,f,g,0)|0;Me(j+32|0,32,0,f+16|0,j)|0;if(!(Do(c,b,d,e,j+32|0)|0))if(!a)g=0;else{if(b>>>0>=a>>>0?0<e>>>0|0==(e|0)&(b-a|0)>>>0<d>>>0:0)h=8;else if(a>>>0>=b>>>0?0<e>>>0|0==(e|0)&(a-b|0)>>>0<d>>>0:0)h=8;if((h|0)==8){Lk(a|0,b|0,d|0)|0;b=a}g=e>>>0>0|(e|0)==0&d>>>0>32?32:d;c=e>>>0>0|(e|0)==0&d>>>0>32?0:e;if((g|0)==0&(c|0)==0)io(j+32|0,j+32|0,32,0,f+16|0,j)|0;else{h=Jp((e>>>0<0|(e|0)==0&d>>>0<32?d:32)|0,(e>>>0<0|(e|0)==0&d>>>0<32?e:0)|0,-1,0)|0;bi(j+32+32|0,b|0,h+1|0)|0;l=Jp(g|0,c|0,32,0)|0;io(j+32|0,j+32|0,l,D,f+16|0,j)|0;bi(a|0,j+32+32|0,h+1|0)|0}if(e>>>0>0|(e|0)==0&d>>>0>32){l=mo(d|0,e|0,g|0,c|0)|0;Vd(a+g|0,b+g|0,l,D,f+16|0,1,0,j)|0}bl(j,32);g=0}else{bl(j,32);g=-1}i=k;return g|0}function Me(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;o=i;p=i=i+63&-64;i=i+112|0;if(!((e|0)==0&(f|0)==0)){k=p+16|0;j=k+32|0;do{a[k>>0]=a[h>>0]|0;k=k+1|0;h=h+1|0}while((k|0)<(j|0));k=d[g+4>>0]|d[g+4+1>>0]<<8|d[g+4+2>>0]<<16|d[g+4+3>>0]<<24;c[p>>2]=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;c[p+4>>2]=k;c[p+8>>2]=0;c[p+8+4>>2]=0;if(f>>>0>0|(f|0)==0&e>>>0>63){do{yc(b,p,p+16|0,0)|0;j=8;h=1;while(1){k=p+j|0;h=(d[k>>0]|0)+h|0;a[k>>0]=h;j=j+1|0;if((j|0)==16)break;else h=h>>>8}e=Jp(e|0,f|0,-64,-1)|0;f=D;b=b+64|0}while(f>>>0>0|(f|0)==0&e>>>0>63);if(!((e|0)==0&(f|0)==0)){m=b;n=e;l=7}}else{m=b;n=e;l=7}if((l|0)==7?(yc(p+48|0,p,p+16|0,0)|0,n|0):0){h=0;do{a[m+h>>0]=a[p+48+h>>0]|0;h=h+1|0}while((h|0)!=(n|0))}bl(p+48|0,64);bl(p+16|0,32)}i=o;return 0}function Ne(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;m=i=i+63&-64;i=i+272|0;j=c[b>>2]|0;c[m>>2]=j;e=a|0?e:256;g=a|0?a:m+8|0;a:do if((e|0)!=0&(j|0)!=0){k=d;l=e;d=j;e=0;while(1){f=k>>>0>=l>>>0;if(!(f|k>>>0>32)){f=k;h=l;l=j;break a}d=f?l:k;f=k-d|0;d=ee(g,m,d)|0;if((d|0)==-1)break;j=(g|0)==(m+8|0);k=j?0:d;h=l-k|0;g=j?g:g+d|0;e=d+e|0;j=c[m>>2]|0;if((l|0)!=(k|0)&(j|0)!=0){k=f;l=h;d=j}else{l=j;d=j;break a}}d=c[m>>2]|0;h=0;l=d;e=-1}else{f=d;h=e;l=j;d=j;e=0}while(0);b:do if((l|0)!=0?(h|0)!=0&(f|0)!=0:0){k=f;j=l;while(1){f=Wg(g,c[j>>2]|0)|0;if((f+1|0)>>>0<2)break;j=j+4|0;c[m>>2]=j;k=k+-1|0;e=e+1|0;d=j;if(!((h|0)!=(f|0)&(k|0)!=0))break b;else{h=h-f|0;g=g+f|0}}if(!f){c[m>>2]=0;d=0}else e=-1}while(0);if(a|0)c[b>>2]=d;i=n;return e|0}function Oe(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;k=i;l=i=i+63&-64;i=i+64|0;if((e+-1&255)>63)Ta();a[l>>0]=e;a[l+1>>0]=0;a[l+2>>0]=1;a[l+3>>0]=1;h=l+4|0;j=h+28|0;do{a[h>>0]=0;h=h+1|0}while((h|0)<(j|0));if(!f){h=l+32|0;j=h+16|0;do{a[h>>0]=0;h=h+1|0}while((h|0)<(j|0))}else{h=l+32|0;e=f;j=h+16|0;do{a[h>>0]=a[e>>0]|0;h=h+1|0;e=e+1|0}while((h|0)<(j|0))}if(!g){h=l+48|0;j=h+16|0;do{a[h>>0]=0;h=h+1|0}while((h|0)<(j|0))}else{h=l+48|0;e=g;j=h+16|0;do{a[h>>0]=a[e>>0]|0;h=h+1|0;e=e+1|0}while((h|0)<(j|0))}Yi(b+64|0,0,293)|0;h=b;e=400;j=h+64|0;do{c[h>>2]=c[e>>2];h=h+4|0;e=e+4|0}while((h|0)<(j|0));e=0;do{h=l+(e<<3)|0;g=b+(e<<3)|0;j=c[g+4>>2]^(d[h+4>>0]|d[h+4+1>>0]<<8|d[h+4+2>>0]<<16|d[h+4+3>>0]<<24);c[g>>2]=c[g>>2]^(d[h>>0]|d[h+1>>0]<<8|d[h+2>>0]<<16|d[h+3>>0]<<24);c[g+4>>2]=j;e=e+1|0}while((e|0)!=8);i=k;return}function Pe(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;l=i;g=i=i+63&-64;i=i+16|0;j=(f|0)==0?50768:f;f=c[j>>2]|0;a:do if(!d)if(!f)f=0;else k=15;else{h=(b|0)==0?g:b;if(!e)f=-2;else{if(!f){f=a[d>>0]|0;if(f<<24>>24>-1){c[h>>2]=f&255;f=f<<24>>24!=0&1;break}if(((f&255)+-194|0)>>>0>50){k=15;break}f=c[33872+((f&255)+-194<<2)>>2]|0;if(e+-1|0){g=e+-1|0;d=d+1|0;k=9}}else{g=e;k=9}b:do if((k|0)==9){b=a[d>>0]|0;if((((b&255)>>>3)+-16|((b&255)>>>3)+(f>>26))>>>0>7){k=15;break a}while(1){d=d+1|0;f=(b&255)+-128|f<<6;g=g+-1|0;if((f|0)>=0)break;if(!g)break b;b=a[d>>0]|0;if((b&-64)<<24>>24!=-128){k=15;break a}}c[j>>2]=0;c[h>>2]=f;f=e-g|0;break a}while(0);c[j>>2]=f;f=-2}}while(0);if((k|0)==15){c[j>>2]=0;c[(Sq()|0)>>2]=84;f=-1}i=l;return f|0}function Qe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=a[b+11>>0]|0;if(h<<24>>24<0){k=c[b+4>>2]|0;d=(c[b+8>>2]&2147483647)+-1|0}else{k=h&255;d=10}if(k>>>0<11)l=10;else l=(k+16&-16)+-1|0;a:do if((l|0)!=(d|0)){do if((l|0)==10){e=c[b>>2]|0;if(h<<24>>24<0){d=b;f=0;j=16}else{d=b;f=0;g=1;j=17}}else{e=l+1|0;if(l>>>0<=d>>>0){o=0;d=ha(85,e|0)|0;j=o;o=0;if(j&1){b=Za(0)|0;jb(b|0)|0;fb();break a}}else d=Rj(e)|0;if(h<<24>>24<0){f=1;e=c[b>>2]|0;j=16;break}else{f=1;e=b;g=0;j=17;break}}while(0);if((j|0)==16){i=c[b+4>>2]|0;h=e;g=1}else if((j|0)==17){i=h&255;h=e}e=i+1|0;if(e|0)bi(d|0,h|0,e|0)|0;if(g)$u(h);if(f){c[b+8>>2]=l+1|-2147483648;c[b+4>>2]=k;c[b>>2]=d;break}else{a[b+11>>0]=k;break}}while(0);return}function Re(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;l=i;k=i=i+63&-64;i=i+16|0;a:do if(!b)b=0;else{j=c[g+12>>2]|0;j=(j|0)>(f-d>>2|0)?j-(f-d>>2)|0:0;if((e-d|0)>0?(Kb[c[(c[b>>2]|0)+48>>2]&63](b,d,e-d>>2)|0)!=(e-d>>2|0):0){b=0;break}do if((j|0)>0){c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;xh(k,j,h);o=0;h=la(c[(c[b>>2]|0)+48>>2]|0,b|0,((a[k+8+3>>0]|0)<0?c[k>>2]|0:k)|0,j|0)|0;d=o;o=0;if(!(d&1)){dq(k);if((h|0)==(j|0))break;else{b=0;break a}}else{l=Ya()|0;dq(k);Ra(l|0)}}while(0);if((f-e|0)>0?(Kb[c[(c[b>>2]|0)+48>>2]&63](b,e,f-e>>2)|0)!=(f-e>>2|0):0){b=0;break}c[g+12>>2]=0}while(0);i=l;return b|0}function Se(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;do if((b|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)==(e|0)?(c[d+28>>2]|0)!=1:0)c[d+28>>2]=f}else{if((b|0)!=(c[d>>2]|0)){b=c[b+8>>2]|0;Db[c[(c[b>>2]|0)+24>>2]&31](b,d,e,f,g);break}if((c[d+16>>2]|0)!=(e|0)?(c[d+20>>2]|0)!=(e|0):0){c[d+32>>2]=f;if((c[d+44>>2]|0)==4)break;a[d+52>>0]=0;a[d+53>>0]=0;b=c[b+8>>2]|0;Mb[c[(c[b>>2]|0)+20>>2]&31](b,d,e,e,1,g);if(a[d+53>>0]|0)if(!(a[d+52>>0]|0)){f=1;b=13}else b=17;else{f=0;b=13}do if((b|0)==13){c[d+20>>2]=e;c[d+40>>2]=(c[d+40>>2]|0)+1;if((c[d+36>>2]|0)==1?(c[d+24>>2]|0)==2:0){a[d+54>>0]=1;if(f){b=17;break}else{f=4;break}}if(f)b=17;else f=4}while(0);if((b|0)==17)f=3;c[d+44>>2]=f;break}if((f|0)==1)c[d+32>>2]=1}while(0);return}function Te(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;l=i;k=i=i+63&-64;i=i+16|0;a:do if(!b)b=0;else{j=c[g+12>>2]|0;j=(j|0)>(f-d|0)?j-(f-d)|0:0;if((e-d|0)>0?(Kb[c[(c[b>>2]|0)+48>>2]&63](b,d,e-d|0)|0)!=(e-d|0):0){b=0;break}do if((j|0)>0){c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;oi(k,j,h);o=0;h=la(c[(c[b>>2]|0)+48>>2]|0,b|0,((a[k+11>>0]|0)<0?c[k>>2]|0:k)|0,j|0)|0;d=o;o=0;if(!(d&1)){rq(k);if((h|0)==(j|0))break;else{b=0;break a}}else{l=Ya()|0;rq(k);Ra(l|0)}}while(0);if((f-e|0)>0?(Kb[c[(c[b>>2]|0)+48>>2]&63](b,e,f-e|0)|0)!=(f-e|0):0){b=0;break}c[g+12>>2]=0}while(0);i=l;return b|0}function Ue(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;k=i;l=i=i+63&-64;i=i+176|0;a[l+168>>0]=a[47458]|0;a[l+168+1>>0]=a[47459]|0;a[l+168+2>>0]=a[47460]|0;a[l+168+3>>0]=a[47461]|0;a[l+168+4>>0]=a[47462]|0;a[l+168+5>>0]=a[47463]|0;b=zq()|0;c[l>>2]=g;b=ek(l+148|0,20,b,l+168|0,l)|0;g=Ch(l+148|0,l+148+b|0,c[e+4>>2]|0)|0;h=Wm(e)|0;o=0;j=va(32,h|0,52364)|0;m=o;o=0;if(m&1){m=Ya()|0;en(h);Ra(m|0)}else{en(h);Sb[c[(c[j>>2]|0)+48>>2]&31](j,l+148|0,l+148+b|0,l)|0;m=Re(c[d>>2]|0,l,(g|0)==(l+148+b|0)?l+(b<<2)|0:l+(g-(l+148)<<2)|0,l+(b<<2)|0,e,f)|0;i=k;return m|0}return 0}function Ve(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;j=i=i+63&-64;i=i+128|0;a[j+118>>0]=a[47445]|0;a[j+118+1>>0]=a[47446]|0;a[j+118+2>>0]=a[47447]|0;a[j+118+3>>0]=a[47448]|0;a[j+118+4>>0]=a[47449]|0;a[j+118+5>>0]=a[47450]|0;Ug(j+118+1|0,47451,1,c[e+4>>2]|0);k=zq()|0;c[j>>2]=g;g=j+104+(ek(j+104|0,13,k,j+118|0,j)|0)|0;k=Ch(j+104|0,g,c[e+4>>2]|0)|0;b=Wm(e)|0;c[j+96>>2]=b;o=0;ra(20,j+104|0,k|0,g|0,j|0,j+100|0,j+92|0,j+96|0);g=o;o=0;if(g&1){k=Ya()|0;en(b);Ra(k|0)}else{en(b);k=Re(c[d>>2]|0,j,c[j+100>>2]|0,c[j+92>>2]|0,e,f)|0;i=h;return k|0}return 0}function We(b,e){b=b|0;e=e|0;c[b>>2]=(d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24)&67108863;c[b+4>>2]=(d[e+3>>0]|d[e+3+1>>0]<<8|d[e+3+2>>0]<<16|d[e+3+3>>0]<<24)>>>2&67108611;c[b+8>>2]=(d[e+6>>0]|d[e+6+1>>0]<<8|d[e+6+2>>0]<<16|d[e+6+3>>0]<<24)>>>4&67092735;c[b+12>>2]=(d[e+9>>0]|d[e+9+1>>0]<<8|d[e+9+2>>0]<<16|d[e+9+3>>0]<<24)>>>6&66076671;c[b+16>>2]=(d[e+12>>0]|d[e+12+1>>0]<<8|d[e+12+2>>0]<<16|d[e+12+3>>0]<<24)>>>8&1048575;c[b+20>>2]=0;c[b+20+4>>2]=0;c[b+20+8>>2]=0;c[b+20+12>>2]=0;c[b+20+16>>2]=0;c[b+40>>2]=d[e+16>>0]|d[e+16+1>>0]<<8|d[e+16+2>>0]<<16|d[e+16+3>>0]<<24;c[b+44>>2]=d[e+20>>0]|d[e+20+1>>0]<<8|d[e+20+2>>0]<<16|d[e+20+3>>0]<<24;c[b+48>>2]=d[e+24>>0]|d[e+24+1>>0]<<8|d[e+24+2>>0]<<16|d[e+24+3>>0]<<24;c[b+52>>2]=d[e+28>>0]|d[e+28+1>>0]<<8|d[e+28+2>>0]<<16|d[e+28+3>>0]<<24;c[b+56>>2]=0;c[b+56+4>>2]=0;a[b+80>>0]=0;return 0}function Xe(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;j=i=i+63&-64;i=i+128|0;a[j+108>>0]=a[47445]|0;a[j+108+1>>0]=a[47446]|0;a[j+108+2>>0]=a[47447]|0;a[j+108+3>>0]=a[47448]|0;a[j+108+4>>0]=a[47449]|0;a[j+108+5>>0]=a[47450]|0;Ug(j+108+1|0,47451,0,c[e+4>>2]|0);k=zq()|0;c[j>>2]=g;g=j+96+(ek(j+96|0,12,k,j+108|0,j)|0)|0;k=Ch(j+96|0,g,c[e+4>>2]|0)|0;b=Wm(e)|0;c[j+88>>2]=b;o=0;ra(20,j+96|0,k|0,g|0,j|0,j+92|0,j+84|0,j+88|0);g=o;o=0;if(g&1){k=Ya()|0;en(b);Ra(k|0)}else{en(b);k=Re(c[d>>2]|0,j,c[j+92>>2]|0,c[j+84>>2]|0,e,f)|0;i=h;return k|0}return 0}function Ye(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;j=i=i+63&-64;i=i+64|0;a[j+48>>0]=a[47445]|0;a[j+48+1>>0]=a[47446]|0;a[j+48+2>>0]=a[47447]|0;a[j+48+3>>0]=a[47448]|0;a[j+48+4>>0]=a[47449]|0;a[j+48+5>>0]=a[47450]|0;Ug(j+48+1|0,47451,0,c[e+4>>2]|0);k=zq()|0;c[j>>2]=g;g=j+36+(ek(j+36|0,12,k,j+48|0,j)|0)|0;k=Ch(j+36|0,g,c[e+4>>2]|0)|0;b=Wm(e)|0;c[j+28>>2]=b;o=0;ra(18,j+36|0,k|0,g|0,j|0,j+32|0,j+24|0,j+28|0);g=o;o=0;if(g&1){k=Ya()|0;en(b);Ra(k|0)}else{en(b);k=Te(c[d>>2]|0,j,c[j+32>>2]|0,c[j+24>>2]|0,e,f)|0;i=h;return k|0}return 0}function Ze(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;j=i=i+63&-64;i=i+64|0;a[j+50>>0]=a[47445]|0;a[j+50+1>>0]=a[47446]|0;a[j+50+2>>0]=a[47447]|0;a[j+50+3>>0]=a[47448]|0;a[j+50+4>>0]=a[47449]|0;a[j+50+5>>0]=a[47450]|0;Ug(j+50+1|0,47451,1,c[e+4>>2]|0);k=zq()|0;c[j>>2]=g;g=j+36+(ek(j+36|0,13,k,j+50|0,j)|0)|0;k=Ch(j+36|0,g,c[e+4>>2]|0)|0;b=Wm(e)|0;c[j+28>>2]=b;o=0;ra(18,j+36|0,k|0,g|0,j|0,j+32|0,j+24|0,j+28|0);g=o;o=0;if(g&1){k=Ya()|0;en(b);Ra(k|0)}else{en(b);k=Te(c[d>>2]|0,j,c[j+32>>2]|0,c[j+24>>2]|0,e,f)|0;i=h;return k|0}return 0}function _e(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;k=i;l=i=i+63&-64;i=i+80|0;a[l+60>>0]=a[47458]|0;a[l+60+1>>0]=a[47459]|0;a[l+60+2>>0]=a[47460]|0;a[l+60+3>>0]=a[47461]|0;a[l+60+4>>0]=a[47462]|0;a[l+60+5>>0]=a[47463]|0;b=zq()|0;c[l>>2]=g;b=ek(l+40|0,20,b,l+60|0,l)|0;g=Ch(l+40|0,l+40+b|0,c[e+4>>2]|0)|0;h=Wm(e)|0;o=0;j=va(32,h|0,52332)|0;m=o;o=0;if(m&1){m=Ya()|0;en(h);Ra(m|0)}else{en(h);Sb[c[(c[j>>2]|0)+32>>2]&31](j,l+40|0,l+40+b|0,l)|0;m=Te(c[d>>2]|0,l,(g|0)==(l+40+b|0)?l+b|0:l+(g-(l+40))|0,l+b|0,e,f)|0;i=k;return m|0}return 0}function $e(){var a=0,b=0,d=0,e=0;d=i=i+63&-64;i=i+32|0;o=0;a=za(19)|0;e=o;o=0;if(e&1){e=Za(0)|0;lt(e)}if((a|0?(b=c[a>>2]|0,b|0):0)?((c[b+48>>2]&-256|0)==1126902528?(c[b+48+4>>2]|0)==1129074247:0):0){o=0;Fa(c[b+12>>2]|0);e=o;o=0;if(!(e&1)){o=0;da(68,49814,d|0);o=0}a=Za(0)|0;jb(a|0)|0;o=0;da(68,49854,d+8|0);o=0;a=Za(0)|0;o=0;Fa(19);e=o;o=0;if(e&1){e=Za(0)|0;lt(e)}else lt(a)}e=c[10258]|0;c[10258]=e+0;o=0;Fa(e|0);e=o;o=0;if(!(e&1)){o=0;da(68,49814,d+16|0);o=0}a=Za(0)|0;jb(a|0)|0;o=0;da(68,49854,d+24|0);o=0;a=Za(0)|0;o=0;Fa(19);e=o;o=0;if(e&1){e=Za(0)|0;lt(e)}else lt(a)}function af(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;a:do if(!((e|0)==0&(f|0)==0)){g=c[b+352>>2]|0;j=e;while(1){i=256-g|0;e=b+96+g|0;if(!(f>>>0>0|(f|0)==0&j>>>0>i>>>0))break;bi(e|0,d|0,i|0)|0;c[b+352>>2]=(c[b+352>>2]|0)+i;e=c[b+64>>2]|0;g=c[b+64+4>>2]|0;h=Jp(e|0,g|0,128,0)|0;c[b+64>>2]=h;c[b+64+4>>2]=D;e=Jp((g>>>0>4294967295|(g|0)==-1&e>>>0>4294967167)&1|0,0,c[b+72>>2]|0,c[b+72+4>>2]|0)|0;c[b+72>>2]=e;c[b+72+4>>2]=D;Zb(b,b+96|0);e=b+96|0;g=b+224|0;h=e+128|0;do{a[e>>0]=a[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));g=(c[b+352>>2]|0)+-128|0;c[b+352>>2]=g;e=mo(j|0,f|0,i|0,0)|0;if((j|0)==(i|0)&(f|0)==0)break a;else{d=d+i|0;f=D;j=e}}bi(e|0,d|0,j|0)|0;j=Jp(c[b+352>>2]|0,0,j|0,f|0)|0;c[b+352>>2]=j}while(0);return}function bf(a){a=a|0;var b=0,d=0;do if(a)if(c[a>>2]|0)if((c[a+4>>2]|0)>>>0>=16){if((c[a+8>>2]|0)==0?c[a+12>>2]|0:0){b=-18;break}b=c[a+20>>2]|0;if(!(c[a+16>>2]|0)){if(b|0){b=-19;break}}else if(b>>>0<8){b=-6;break}if((c[a+24>>2]|0)==0?c[a+28>>2]|0:0){b=-20;break}if((c[a+32>>2]|0)==0?c[a+36>>2]|0:0){b=-21;break}b=c[a+44>>2]|0;if(b>>>0>=8)if(b>>>0<=2097152){d=c[a+48>>2]|0;if(b>>>0>=d<<3>>>0)if((c[a+40>>2]|0)>>>0>=3)if(d)if(d>>>0<=16777215){b=c[a+52>>2]|0;if(!b)b=-28;else b=b>>>0>16777215?-29:0}else b=-17;else b=-16;else b=-12;else b=-14}else b=-15;else b=-14}else b=-2;else b=-1;else b=-25;while(0);return b|0}function cf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;j=i;h=i=i+63&-64;i=i+32|0;do if((d|0)!=-1){c[h+8>>2]=d;if(a[b+44>>0]|0)if((gn(h+8|0,4,1,c[b+32>>2]|0)|0)==1){g=14;break}else{e=-1;break}c[h+4>>2]=h+16;f=h+8|0;while(1){e=c[b+36>>2]|0;e=Vb[c[(c[e>>2]|0)+12>>2]&31](e,c[b+40>>2]|0,f,h+8+4|0,h,h+16|0,h+16+8|0,h+4|0)|0;if((c[h>>2]|0)==(f|0)){g=13;break}if((e|0)==3){g=7;break}if((e|1|0)!=1){g=13;break}g=(c[h+4>>2]|0)-(h+16)|0;if((gn(h+16|0,1,g,c[b+32>>2]|0)|0)!=(g|0)){g=13;break}if((e|0)==1)f=c[h>>2]|0;else{g=12;break}}if((g|0)==7)if((gn(f,1,1,c[b+32>>2]|0)|0)==1)g=12;else g=13;if((g|0)==12){g=14;break}else if((g|0)==13){e=-1;break}}else g=14;while(0);if((g|0)==14)e=(d|0)==-1?0:d;i=j;return e|0}function df(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;j=i;h=i=i+63&-64;i=i+32|0;do if((d|0)!=-1){a[h+8>>0]=d;if(a[b+44>>0]|0)if((gn(h+8|0,1,1,c[b+32>>2]|0)|0)==1){g=14;break}else{e=-1;break}c[h+4>>2]=h+16;f=h+8|0;while(1){e=c[b+36>>2]|0;e=Vb[c[(c[e>>2]|0)+12>>2]&31](e,c[b+40>>2]|0,f,h+8+1|0,h,h+16|0,h+16+8|0,h+4|0)|0;if((c[h>>2]|0)==(f|0)){g=13;break}if((e|0)==3){g=7;break}if((e|1|0)!=1){g=13;break}g=(c[h+4>>2]|0)-(h+16)|0;if((gn(h+16|0,1,g,c[b+32>>2]|0)|0)!=(g|0)){g=13;break}if((e|0)==1)f=c[h>>2]|0;else{g=12;break}}if((g|0)==7)if((gn(f,1,1,c[b+32>>2]|0)|0)==1)g=12;else g=13;if((g|0)==12){g=14;break}else if((g|0)==13){e=-1;break}}else g=14;while(0);if((g|0)==14)e=(d|0)==-1?0:d;i=j;return e|0}function ef(a,b){a=a|0;b=b|0;var d=0;Uu(54172)|0;while(1){if((c[a>>2]|0)!=1)break;Pa(54200,54172)|0}do if(!(c[a>>2]|0)){c[a>>2]=1;o=0;ha(82,54172)|0;d=o;o=0;if((((!(d&1)?(o=0,ba(173,b|0),d=o,o=0,!(d&1)):0)?(o=0,ha(83,54172)|0,d=o,o=0,!(d&1)):0)?(c[a>>2]=-1,o=0,ha(82,54172)|0,d=o,o=0,!(d&1)):0)?(o=0,ha(84,54200)|0,d=o,o=0,!(d&1)):0)break;d=Za(0)|0;jb(d|0)|0;o=0;ha(83,54172)|0;d=o;o=0;if((!(d&1)?(c[a>>2]=0,o=0,ha(82,54172)|0,d=o,o=0,!(d&1)):0)?(o=0,ha(84,54200)|0,d=o,o=0,!(d&1)):0){o=0;Fa(21);o=0}b=Ya()|0;o=0;Fa(19);d=o;o=0;if(d&1){d=Za(0)|0;lt(d)}else Ra(b|0)}else Uu(54172)|0;while(0);return}function ff(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0;n=i;i=i+352|0;qq(n+280|0,64,0,l,m)|0;Zr(n,n+280|0)|0;bl(n+280|0,64);Gp(n,h,j,k)|0;b=mo(0,0,j|0,k|0)|0;Gp(n,54260,b&15,0)|0;Gp(n,d,e,f)|0;b=mo(0,0,e|0,f|0)|0;Gp(n,54260,b&15,0)|0;c[n+256>>2]=j;c[n+256+4>>2]=k;Gp(n,n+256|0,8,0)|0;c[n+256>>2]=e;c[n+256+4>>2]=f;Gp(n,n+256|0,8,0)|0;Rr(n,n+264|0)|0;bl(n,256);b=xm(n+264|0,g)|0;bl(n+264|0,16);do if(a)if(!b){Ln(a,d,e,f,l,1,m)|0;b=0;break}else{Yi(a|0,0,e|0)|0;b=-1;break}while(0);i=n;return b|0}function gf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;g=i;f=i=i+63&-64;i=i+32|0;e=(a[b+52>>0]|0)!=0;a:do if((d|0)==-1)if(e)d=-1;else{d=c[b+48>>2]|0;a[b+52>>0]=(d|0)!=-1&1}else{do if(e){c[f+4>>2]=c[b+48>>2];e=c[b+36>>2]|0;switch(Vb[c[(c[e>>2]|0)+12>>2]&31](e,c[b+40>>2]|0,f+4|0,f+4+4|0,f,f+16|0,f+16+8|0,f+8|0)|0){case 1:case 2:{d=-1;break a}case 3:{a[f+16>>0]=c[b+48>>2];c[f+8>>2]=f+16+1;break}default:{}}while(1){e=c[f+8>>2]|0;if(e>>>0<=(f+16|0)>>>0){f=13;break}c[f+8>>2]=e+-1;if((Dj(a[e+-1>>0]|0,c[b+32>>2]|0)|0)==-1){f=12;break}}if((f|0)==12){d=-1;break a}else if((f|0)==13){e=b+48|0;break}}else e=b+48|0;while(0);c[e>>2]=d;a[b+52>>0]=1}while(0);i=g;return d|0}function hf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;l=i;k=i=i+63&-64;i=i+64|0;e=k;f=e+60|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));e=Kh(a)|0;c[k+36>>2]=e;c[k+20>>2]=e;c[k+4>>2]=e;f=ec(e)|0;c[k+32>>2]=f;g=ec(e)|0;c[k+16>>2]=g;h=ec(e)|0;c[k>>2]=h;do if((h|0)==0|(g|0)==0|(f|0)==0){nc(f);nc(g);nc(h);e=-22}else{j=ec(e)|0;if(!j){nc(f);nc(g);nc(h);e=-22;break}e=Td(k,a)|0;if(e|0){nc(c[k+32>>2]|0);nc(c[k+16>>2]|0);nc(c[k>>2]|0);nc(j);break}d=Hf(c[k+40>>2]|0,c[k+44>>2]|0,c[k+52>>2]|0,b,d,c[k+16>>2]|0,c[k+20>>2]|0,j,c[k+4>>2]|0,0,0)|0;nc(c[k+32>>2]|0);nc(c[k+16>>2]|0);if((d|0)==0?(Li(j,c[k>>2]|0,c[k+4>>2]|0)|0)==0:0)e=0;else e=-35;nc(j);nc(c[k>>2]|0)}while(0);i=l;return e|0}function jf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;g=i;f=i=i+63&-64;i=i+32|0;e=(a[b+52>>0]|0)!=0;a:do if((d|0)==-1)if(e)d=-1;else{d=c[b+48>>2]|0;a[b+52>>0]=(d|0)!=-1&1}else{do if(e){a[f+8>>0]=c[b+48>>2];e=c[b+36>>2]|0;switch(Vb[c[(c[e>>2]|0)+12>>2]&31](e,c[b+40>>2]|0,f+8|0,f+8+1|0,f,f+16|0,f+16+8|0,f+4|0)|0){case 1:case 2:{d=-1;break a}case 3:{a[f+16>>0]=c[b+48>>2];c[f+4>>2]=f+16+1;break}default:{}}while(1){e=c[f+4>>2]|0;if(e>>>0<=(f+16|0)>>>0){f=13;break}c[f+4>>2]=e+-1;if((Dj(a[e+-1>>0]|0,c[b+32>>2]|0)|0)==-1){f=12;break}}if((f|0)==12){d=-1;break a}else if((f|0)==13){e=b+48|0;break}}else e=b+48|0;while(0);c[e>>2]=d;a[b+52>>0]=1}while(0);i=g;return d|0}function kf(b,e,f,g,h,i,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;a:do if(!g){n=0;l=0;m=0;k=0}else{n=0;q=0;l=0;k=0;while(1){p=k<<24>>24==0;while(1){o=d[f+l>>0]|0;m=(((o&223)+201&255)+65526^((o&223)+201&255)+65520)>>>8;if((m|((o^48)+65526|0)>>>8)&255|0)break;if(!((h|0)!=0&p)){m=0;break a}if(!(or(h,o)|0)){m=0;k=0;break a}l=l+1|0;if(l>>>0>=g>>>0){m=0;k=0;break a}}m=m&(o&223)+201|((o^48)+65526|0)>>>8&(o^48);if(n>>>0>=e>>>0)break;if(p)m=m<<4&255;else{a[b+n>>0]=m|q&255;n=n+1|0;m=q}k=(k&255^255)&255;l=l+1|0;if(l>>>0<g>>>0)q=m;else{m=0;break a}}c[(Sq()|0)>>2]=34;m=-1}while(0);if(j|0)c[j>>2]=f+(((k<<24>>24!=0)<<31>>31)+l);if(i|0)c[i>>2]=n;return m|0}function lf(d,e,f,g,h,i){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;if((d|0)==(c[e+8>>2]|0))Ng(e,f,g,h);else{l=b[e+52>>1]|0;j=c[d+12>>2]|0;a[e+52>>0]=0;a[e+53>>0]=0;Wi(d+16|0,e,f,g,h,i);a:do if((j|0)>1){m=d+24|0;do{if(a[e+54>>0]|0)break a;k=b[e+52>>1]|0;if(!((k&255)<<24>>24)){if((k&65535)>=256?(c[d+8>>2]&1|0)==0:0)break a}else{if((c[e+24>>2]|0)==1)break a;if(!(c[d+8>>2]&2))break a}a[e+52>>0]=0;a[e+53>>0]=0;Wi(m,e,f,g,h,i);m=m+8|0}while(m>>>0<(d+16+(j<<3)|0)>>>0)}while(0);a[e+52>>0]=l;a[e+53>>0]=(l&65535)>>>8}return}function mf(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;k=i;l=i=i+63&-64;i=i+192|0;if((e+-1&255)>63)Ta();if((f|0)!=0&g<<24>>24!=0?(g&255)<=64:0){a[l+128>>0]=e;a[l+128+1>>0]=g;a[l+128+2>>0]=1;a[l+128+3>>0]=1;e=l+128+4|0;j=e+60|0;do{a[e>>0]=0;e=e+1|0}while((e|0)<(j|0));Yi(b+64|0,0,293)|0;e=b;h=400;j=e+64|0;do{c[e>>2]=c[h>>2];e=e+4|0;h=h+4|0}while((e|0)<(j|0));e=0;do{m=l+128+(e<<3)|0;j=b+(e<<3)|0;h=c[j+4>>2]^(d[m+4>>0]|d[m+4+1>>0]<<8|d[m+4+2>>0]<<16|d[m+4+3>>0]<<24);c[j>>2]=c[j>>2]^(d[m>>0]|d[m+1>>0]<<8|d[m+2>>0]<<16|d[m+3>>0]<<24);c[j+4>>2]=h;e=e+1|0}while((e|0)!=8);Yi(l+(g&255)|0,0,(g<<24>>24<0?0:128-(g&255)|0)|0)|0;bi(l|0,f|0,g&255|0)|0;af(b,l,128,0);bl(l,128);i=k;return}Ta()}function nf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;j=i;h=i=i+63&-64;i=i+16|0;f=c[d>>2]|0;do if(f|0){g=a[e+11>>0]|0;if(g<<24>>24<0)g=c[e+4>>2]|0;else g=g&255;if(g){Yo(e);f=c[d>>2]|0}d=c[d+4>>2]|0;Tb[c[(c[d>>2]|0)+24>>2]&31](h,d,f);d=a[h+11>>0]|0;o=0;Da(28,e|0,(d<<24>>24<0?c[h>>2]|0:h)|0,(d<<24>>24<0?c[h+4>>2]|0:d&255)|0);d=o;o=0;if(d&1){j=Ya()|0;rq(h);Ra(j|0)}else{rq(h);break}}while(0);c[b>>2]=c[e>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];f=0;while(1){if((f|0)==3)break;c[e+(f<<2)>>2]=0;f=f+1|0}i=j;return}function of(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;i=b>>>0<0|(b|0)==0&a>>>0<32768?32768:a;h=b>>>0<0|(b|0)==0&a>>>0<32768?0:b;c[g>>2]=8;a:do if(h>>>0<0|(h|0)==0&i>>>0<d>>>5>>>0){c[f>>2]=1;a=bs(i|0,h|0,c[g>>2]<<2|0,0)|0;c[e>>2]=1;a=bo(a|0,D|0,1)|0;b=D;h=1;do{g=_n(1,0,h|0)|0;f=D;h=h+1|0;if(f>>>0>b>>>0|(f|0)==(b|0)&g>>>0>a>>>0)break a;c[e>>2]=h}while(h>>>0<63)}else{c[e>>2]=1;b=1;while(1){j=_n(1,0,b|0)|0;k=D;a=b+1|0;if(k>>>0>0|(k|0)==0&j>>>0>d>>>11>>>0){a=b;break}c[e>>2]=a;if(a>>>0<63)b=a;else break}e=bo(i|0,h|0,2)|0;e=bo(e|0,D|0,a|0)|0;j=D;k=j>>>0>0|(j|0)==0&e>>>0>1073741823?1073741823:e;c[f>>2]=(k>>>0)/((c[g>>2]|0)>>>0)|0}while(0);return}function pf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+224|0;c[j>>2]=37;c[j+4>>2]=0;Ug(j+1|0,47453,0,c[d+4>>2]|0);a=zq()|0;c[j+8>>2]=f;c[j+8+4>>2]=g;g=j+192+(ek(j+192|0,23,a,j,j+8|0)|0)|0;f=Ch(j+192|0,g,c[d+4>>2]|0)|0;a=Wm(d)|0;c[j+184>>2]=a;o=0;ra(20,j+192|0,f|0,g|0,j+8|0,j+188|0,j+180|0,j+184|0);g=o;o=0;if(g&1){b=Ya()|0;en(a);Ra(b|0)}else{en(a);b=Re(c[b>>2]|0,j+8|0,c[j+188>>2]|0,c[j+180>>2]|0,d,e)|0;i=h;return b|0}return 0}function qf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+224|0;c[j>>2]=37;c[j+4>>2]=0;Ug(j+1|0,47453,1,c[d+4>>2]|0);a=zq()|0;c[j+8>>2]=f;c[j+8+4>>2]=g;g=j+192+(ek(j+192|0,23,a,j,j+8|0)|0)|0;f=Ch(j+192|0,g,c[d+4>>2]|0)|0;a=Wm(d)|0;c[j+184>>2]=a;o=0;ra(20,j+192|0,f|0,g|0,j+8|0,j+188|0,j+180|0,j+184|0);g=o;o=0;if(g&1){b=Ya()|0;en(a);Ra(b|0)}else{en(a);b=Re(c[b>>2]|0,j+8|0,c[j+188>>2]|0,c[j+180>>2]|0,d,e)|0;i=h;return b|0}return 0}function rf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;m=i;l=i=i+63&-64;i=i+2048|0;if((a|0)!=0&(b|0)!=0){g=(c[b>>2]|0)+4|0;h=c[b+16>>2]|0;bi(l|0,(c[g>>2]|0)+(h<<10)+-1024|0,1024)|0;d=c[b+20>>2]|0;if(d>>>0>1){k=1;do{e=h+-1+(S(h,k)|0)|0;f=c[g>>2]|0;j=0;do{p=f+(e<<10)+(j<<3)|0;n=l+(j<<3)|0;o=c[n+4>>2]^c[p+4>>2];c[n>>2]=c[n>>2]^c[p>>2];c[n+4>>2]=o;j=j+1|0}while((j|0)!=128);k=k+1|0}while((k|0)!=(d|0))}bi(l+1024|0,l|0,1024)|0;ne(c[a>>2]|0,c[a+4>>2]|0,l+1024|0,1024);bl(l,1024);bl(l+1024|0,1024);e=c[b>>2]|0;if(e|0?(c[a+56>>2]&1|0)!=0:0){bl(c[e+4>>2]|0,c[b+8>>2]<<10);e=c[b>>2]|0}d=c[e>>2]|0;if(d|0)nc(d);nc(e)}i=m;return}function sf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+96|0;c[j>>2]=37;c[j+4>>2]=0;Ug(j+1|0,47453,0,c[d+4>>2]|0);a=zq()|0;c[j+8>>2]=f;c[j+8+4>>2]=g;g=j+64+(ek(j+64|0,23,a,j,j+8|0)|0)|0;f=Ch(j+64|0,g,c[d+4>>2]|0)|0;a=Wm(d)|0;c[j+56>>2]=a;o=0;ra(18,j+64|0,f|0,g|0,j+8|0,j+60|0,j+52|0,j+56|0);g=o;o=0;if(g&1){b=Ya()|0;en(a);Ra(b|0)}else{en(a);b=Te(c[b>>2]|0,j+8|0,c[j+60>>2]|0,c[j+52>>2]|0,d,e)|0;i=h;return b|0}return 0}function tf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+96|0;c[j>>2]=37;c[j+4>>2]=0;Ug(j+1|0,47453,1,c[d+4>>2]|0);a=zq()|0;c[j+8>>2]=f;c[j+8+4>>2]=g;g=j+64+(ek(j+64|0,23,a,j,j+8|0)|0)|0;f=Ch(j+64|0,g,c[d+4>>2]|0)|0;a=Wm(d)|0;c[j+56>>2]=a;o=0;ra(18,j+64|0,f|0,g|0,j+8|0,j+60|0,j+52|0,j+56|0);g=o;o=0;if(g&1){b=Ya()|0;en(a);Ra(b|0)}else{en(a);b=Te(c[b>>2]|0,j+8|0,c[j+60>>2]|0,c[j+52>>2]|0,d,e)|0;i=h;return b|0}return 0}function uf(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;k=i;g=i=i+63&-64;i=i+16|0;a:do if(!e)b=0;else{do if(f|0){j=(b|0)==0?g:b;b=a[e>>0]|0;if(b<<24>>24>-1){c[j>>2]=b&255;b=b<<24>>24!=0&1;break a}if(((b&255)+-194|0)>>>0<=50){h=c[33872+((b&255)+-194<<2)>>2]|0;if(f>>>0<4?h&-2147483648>>>((f*6|0)+-6|0)|0:0)break;b=d[e+1>>0]|0;if(((b>>>3)+-16|(b>>>3)+(h>>26))>>>0<=7){if((b+-128|h<<6|0)>=0){c[j>>2]=b+-128|h<<6;b=2;break a}g=d[e+2>>0]|0;if((g&192|0)==128){g=g+-128|(b+-128|h<<6)<<6;if((g|0)>=0){c[j>>2]=g;b=3;break a}b=d[e+3>>0]|0;if((b&192|0)==128){c[j>>2]=b+-128|g<<6;b=4;break a}}}}}while(0);c[(Sq()|0)>>2]=84;b=-1}while(0);i=k;return b|0}function vf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a:do if((e|0)!=0&(b&3|0)!=0){f=e;while(1){if((a[b>>0]|0)==(d&255)<<24>>24)break a;b=b+1|0;e=f+-1|0;if((e|0)!=0&(b&3|0)!=0)f=e;else{f=e;e=(e|0)!=0;g=5;break}}}else{f=e;e=(e|0)!=0;g=5}while(0);b:do if((g|0)==5)if(e){if((a[b>>0]|0)!=(d&255)<<24>>24){e=S(d&255,16843009)|0;c:do if(f>>>0>3)while(1){h=c[b>>2]^e;if((h&-2139062144^-2139062144)&h+-16843009|0)break;b=b+4|0;f=f+-4|0;if(f>>>0<=3){g=11;break c}}else g=11;while(0);if((g|0)==11)if(!f){f=0;break}while(1){if((a[b>>0]|0)==(d&255)<<24>>24)break b;b=b+1|0;f=f+-1|0;if(!f){f=0;break}}}}else f=0;while(0);return (f|0?b:0)|0}function wf(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;k=i;j=i=i+63&-64;i=i+64|0;h=c[d>>2]|0;g=d+(c[h+-8>>2]|0)|0;h=c[h+-4>>2]|0;c[j>>2]=e;c[j+4>>2]=d;c[j+8>>2]=1920;d=j+12|0;f=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(f|0));b[j+12+40>>1]=0;a[j+12+42>>0]=0;a:do if((h|0)==(e|0)){c[j+48>>2]=1;Mb[c[(c[e>>2]|0)+20>>2]&31](e,j,g,g,1,0);d=(c[j+24>>2]|0)==1?g:0}else{Db[c[(c[h>>2]|0)+24>>2]&31](h,j,g,1,0);switch(c[j+36>>2]|0){case 0:{d=((c[j+40>>2]|0)==1?(c[j+28>>2]|0)==1:0)&(c[j+32>>2]|0)==1?c[j+20>>2]|0:0;break a}case 1:break;default:{d=0;break a}}if((c[j+24>>2]|0)!=1?!(((c[j+40>>2]|0)==0?(c[j+28>>2]|0)==1:0)&(c[j+32>>2]|0)==1):0){d=0;break}d=c[j+16>>2]|0}while(0);i=k;return d|0}function xf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;h=i;i=i+192|0;if(d>>>0>128){Gl(b)|0;Yd(b,c,d,0)|0;Yh(b,h)|0;d=64;g=h}else g=c;Gl(b)|0;c=h+64|0;e=c+128|0;do{a[c>>0]=54;c=c+1|0}while((c|0)<(e|0));f=(d|0)==0;if(!f?(a[h+64>>0]=a[g>>0]^54,(d|0)!=1):0){c=1;do{e=h+64+c|0;a[e>>0]=a[e>>0]^a[g+c>>0];c=c+1|0}while((c|0)!=(d|0))}Yd(b,h+64|0,128,0)|0;Gl(b+208|0)|0;c=h+64|0;e=c+128|0;do{a[c>>0]=92;c=c+1|0}while((c|0)<(e|0));if(!f?(a[h+64>>0]=a[g>>0]^92,(d|0)!=1):0){c=1;do{f=h+64+c|0;a[f>>0]=a[f>>0]^a[g+c>>0];c=c+1|0}while((c|0)!=(d|0))}Yd(b+208|0,h+64|0,128,0)|0;bl(h+64|0,128);bl(h,64);i=h;return 0}function yf(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;if(((((((((b>>>0<=63?(i=_m(d|0,0,c|0,0)|0,j=D,!(j>>>0>0|(j|0)==0&i>>>0>1073741823)):0)?(a[f>>0]=36,a[f+1>>0]=55,a[f+2>>0]=36,a[f+3>>0]=a[42710+b>>0]|0,a[f+4>>0]=a[42710+(c&63)>>0]|0,a[f+5>>0]=a[42710+(c>>>6&63)>>0]|0,a[f+6>>0]=a[42710+(c>>>12&63)>>0]|0,a[f+7>>0]=a[42710+(c>>>18&63)>>0]|0,a[f+8>>0]=a[42710+(c>>>24&63)>>0]|0,(f+9|0)!=0):0)?(f+58|0)!=(f+9|0):0)?(g=f+58-(f+9)|0,a[f+9>>0]=a[42710+(d&63)>>0]|0,(g|0)!=1):0)?(a[f+10>>0]=a[42710+(d>>>6&63)>>0]|0,(g|0)!=2):0)?(a[f+11>>0]=a[42710+(d>>>12&63)>>0]|0,(g|0)!=3):0)?(a[f+12>>0]=a[42710+(d>>>18&63)>>0]|0,(g|0)!=4):0)?(a[f+13>>0]=a[42710+(d>>>24&63)>>0]|0,(f+14|0)!=0):0)?(h=Zg(f+14|0,f+58-(f+14)|0,e)|0,(h|0)!=0&h>>>0<(f+58|0)>>>0):0)a[h>>0]=0;else f=0;return f|0}function zf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;h=i;i=i+96|0;if(d>>>0>64){fk(b)|0;oe(b,c,d,0)|0;Uf(b,h)|0;d=32;g=h}else g=c;fk(b)|0;c=h+32|0;e=c+64|0;do{a[c>>0]=54;c=c+1|0}while((c|0)<(e|0));f=(d|0)==0;if(!f?(a[h+32>>0]=a[g>>0]^54,(d|0)!=1):0){c=1;do{e=h+32+c|0;a[e>>0]=a[e>>0]^a[g+c>>0];c=c+1|0}while((c|0)!=(d|0))}oe(b,h+32|0,64,0)|0;fk(b+104|0)|0;c=h+32|0;e=c+64|0;do{a[c>>0]=92;c=c+1|0}while((c|0)<(e|0));if(!f?(a[h+32>>0]=a[g>>0]^92,(d|0)!=1):0){c=1;do{f=h+32+c|0;a[f>>0]=a[f>>0]^a[g+c>>0];c=c+1|0}while((c|0)!=(d|0))}oe(b+104|0,h+32|0,64,0)|0;bl(h+32|0,64);bl(h,32);i=h;return 0}function Af(a){a=a|0;var b=0,d=0,e=0,f=0;if(a>>>0>=4294967168){c[(Sq()|0)>>2]=12;f=0;return f|0}f=a>>>0<11?16:a+11&-8;e=ec(f+76|0)|0;if(!e){f=0;return f|0}do if(e&63){d=((e+63&-64)+-8-(e+-8)|0)>>>0>15?(e+63&-64)+-8|0:(e+63&-64)+56|0;a=d-(e+-8)|0;b=c[e+-4>>2]|0;if(!(b&3)){c[d>>2]=(c[e+-8>>2]|0)+a;c[d+4>>2]=(b&-8)-a;break}else{c[d+4>>2]=(b&-8)-a|c[d+4>>2]&1|2;c[d+((b&-8)-a)+4>>2]=c[d+((b&-8)-a)+4>>2]|1;c[e+-4>>2]=a|c[e+-4>>2]&1|2;c[d+4>>2]=c[d+4>>2]|1;oc(e+-8|0,a);break}}else d=e+-8|0;while(0);a=d+4|0;b=c[a>>2]|0;if(b&3|0?(b&-8)>>>0>(f+16|0)>>>0:0){e=d+f|0;c[a>>2]=f|b&1|2;c[e+4>>2]=(b&-8)-f|3;c[e+((b&-8)-f)+4>>2]=c[e+((b&-8)-f)+4>>2]|1;oc(e,(b&-8)-f|0)}f=d+8|0;return f|0}function Bf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;g=0;f=0;i=0;a:while(1){h=f;while(1){f=a[e>>0]|0;f=((0-((0-(f^47)|0)>>>8&63^63|(0-(f^43)|0)>>>8&62^62|((f+65439|0)>>>8^255)&f+185&((122-f|0)>>>8&255^255)|((f+-65|0)>>>8^255)&f+-65&((90-f|0)>>>8&255^255)|((f+65488|0)>>>8^255)&f+4&((57-f|0)>>>8&255^255))|0)>>>8&255^255)&(0-(f^65)|0)>>>8|((0-(f^47)|0)>>>8&63^63|(0-(f^43)|0)>>>8&62^62|((f+65439|0)>>>8^255)&f+185&((122-f|0)>>>8&255^255)|((f+-65|0)>>>8^255)&f+-65&((90-f|0)>>>8&255^255)|((f+65488|0)>>>8^255)&f+4&((57-f|0)>>>8&255^255));if((f|0)==255){j=7;break a}e=e+1|0;g=f+(g<<6)|0;f=h+6|0;if(f>>>0>7)break;else h=f}f=h+-2|0;if(i>>>0>=(c[d>>2]|0)>>>0){e=0;break}a[b>>0]=g>>>f;b=b+1|0;i=i+1|0}if((j|0)==7)if(h>>>0<=4?((1<<h)+-1&g|0)==0:0)c[d>>2]=i;else e=0;return e|0}function Cf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=i=i+63&-64;i=i+32|0;c[g>>2]=b;c[g+4>>2]=d;c[g+8>>2]=0;c[g+8+4>>2]=0;c[g+8+8>>2]=0;ni(g+8|0,e,Kh(e)|0);o=0;Da(29,g+20|0,g|0,g+8|0);e=o;o=0;do if(!(e&1)){o=0;da(67,a|0,g+20|0);e=o;o=0;if(e&1){b=Ya()|0;rq(g+20|0);break}else{rq(g+20|0);rq(g+8|0);c[a>>2]=41020;e=c[g+4>>2]|0;c[a+8>>2]=c[g>>2];c[a+8+4>>2]=e;i=f;return}}else b=Ya()|0;while(0);rq(g+8|0);Ra(b|0)}function Df(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;j=i;h=i=i+63&-64;i=i+224|0;f=h+80|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));c[h+120>>2]=c[e>>2];if((hc(0,d,h+120|0,h,h+80|0)|0)<0)e=-1;else{g=c[b>>2]|0;if((a[b+74>>0]|0)<1)c[b>>2]=g&-33;if(!(c[b+48>>2]|0)){f=c[b+44>>2]|0;c[b+44>>2]=h+136;c[b+28>>2]=h+136;c[b+20>>2]=h+136;c[b+48>>2]=80;c[b+16>>2]=h+136+80;e=hc(b,d,h+120|0,h,h+80|0)|0;if(f){Kb[c[b+36>>2]&63](b,0,0)|0;e=(c[b+20>>2]|0)==0?-1:e;c[b+44>>2]=f;c[b+48>>2]=0;c[b+16>>2]=0;c[b+28>>2]=0;c[b+20>>2]=0}}else e=hc(b,d,h+120|0,h,h+80|0)|0;h=c[b>>2]|0;c[b>>2]=h|g&32;e=(h&32|0)==0?e:-1}i=j;return e|0}function Ef(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=c[a>>2]|0;u=c[a+4>>2]|0;s=c[a+8>>2]|0;q=c[a+12>>2]|0;o=c[a+16>>2]|0;m=c[a+20>>2]|0;k=c[a+24>>2]|0;i=c[a+28>>2]|0;g=c[a+32>>2]|0;e=c[a+36>>2]|0;v=(c[b+4>>2]^u)&0-d;t=(c[b+8>>2]^s)&0-d;r=(c[b+12>>2]^q)&0-d;p=(c[b+16>>2]^o)&0-d;n=(c[b+20>>2]^m)&0-d;l=(c[b+24>>2]^k)&0-d;j=(c[b+28>>2]^i)&0-d;h=(c[b+32>>2]^g)&0-d;f=(c[b+36>>2]^e)&0-d;c[a>>2]=(c[b>>2]^w)&0-d^w;c[a+4>>2]=v^u;c[a+8>>2]=t^s;c[a+12>>2]=r^q;c[a+16>>2]=p^o;c[a+20>>2]=n^m;c[a+24>>2]=l^k;c[a+28>>2]=j^i;c[a+32>>2]=h^g;c[a+36>>2]=f^e;return}function Ff(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;j=i;g=i=i+63&-64;i=i+48|0;c[g+32>>2]=d;h=c[b+48>>2]|0;c[g+32+4>>2]=e-((h|0)!=0&1);c[g+32+8>>2]=c[b+44>>2];c[g+32+12>>2]=h;if(!(c[12680]|0)){c[g+16>>2]=c[b+60>>2];c[g+16+4>>2]=g+32;c[g+16+8>>2]=2;f=rr(zb(145,g+16|0)|0)|0}else{vb(125,b|0);c[g>>2]=c[b+60>>2];c[g+4>>2]=g+32;c[g+8>>2]=2;f=rr(zb(145,g|0)|0)|0;Na(0)}if((f|0)>=1){g=c[g+32+4>>2]|0;if(f>>>0>g>>>0){h=c[b+44>>2]|0;c[b+4>>2]=h;c[b+8>>2]=h+(f-g);if(!(c[b+48>>2]|0))f=e;else{c[b+4>>2]=h+1;a[d+(e+-1)>>0]=a[h>>0]|0;f=e}}}else{c[b>>2]=c[b>>2]|f&48^16;c[b+8>>2]=0;c[b+4>>2]=0}i=j;return f|0}function Gf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;h=i;g=i=i+63&-64;i=i+32|0;e=c[a+8>>2]|0;d=c[a+4>>2]|0;if(e-d>>2>>>0<b>>>0){f=c[a>>2]|0;if(((d-f>>2)+b|0)>>>0>1073741823)mk();if(e-f>>2>>>0<536870911)e=e-f>>1>>>0<((d-f>>2)+b|0)>>>0?(d-f>>2)+b|0:e-f>>1;else e=1073741823;vi(g,e,d-f>>2,a+16|0);f=c[g+8>>2]|0;Yi(f|0,0,b<<2|0)|0;c[g+8>>2]=f+(b<<2);hh(a,g);Oi(g)}else do{c[d>>2]=0;d=(c[a+4>>2]|0)+4|0;c[a+4>>2]=d;b=b+-1|0}while((b|0)!=0);i=h;return}function Hf(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;p=i;o=i=i+63&-64;i=i+64|0;n=ec(k)|0;do if(!n)b=-22;else{c[o>>2]=n;c[o+4>>2]=k;c[o+8>>2]=e;c[o+12>>2]=f;c[o+16>>2]=g;c[o+20>>2]=h;c[o+24>>2]=0;c[o+24+4>>2]=0;c[o+24+8>>2]=0;c[o+24+12>>2]=0;c[o+40>>2]=a;c[o+44>>2]=b;c[o+48>>2]=d;c[o+52>>2]=d;c[o+56>>2]=4;b=_g(o)|0;if(b|0){bl(n,k);nc(n);break}if(j|0)bi(j|0,n|0,k|0)|0;if((l|0)!=0&(m|0)!=0?hd(l,m,o)|0:0){bl(n,k);bl(l,m);nc(n);b=-31;break}bl(n,k);nc(n);b=0}while(0);i=p;return b|0}function If(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;i=a[b+11>>0]|0;g=c[b+4>>2]|0;do if((i<<24>>24<0?g:i&255)|0){if((d|0)!=(e|0)){g=e;h=d;while(1){g=g+-4|0;if(h>>>0>=g>>>0)break;k=c[h>>2]|0;c[h>>2]=c[g>>2];c[g>>2]=k;h=h+4|0}g=c[b+4>>2]|0}k=i<<24>>24<0?c[b>>2]|0:b;h=k+(i<<24>>24<0?g:i&255)|0;i=k;while(1){g=a[i>>0]|0;if(d>>>0>=(e+-4|0)>>>0)break;if(!(g<<24>>24<1|g<<24>>24==127)?(g<<24>>24|0)!=(c[d>>2]|0):0){j=10;break}i=(h-i|0)>1?i+1|0:i;d=d+4|0}if((j|0)==10){c[f>>2]=4;break}if(!(g<<24>>24<1|g<<24>>24==127)?((c[e+-4>>2]|0)+-1|0)>>>0>=g<<24>>24>>>0:0)c[f>>2]=4}while(0);return}function Jf(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;q=i;p=i=i+63&-64;i=i+48|0;if((((((a[g>>0]|0)==36?(a[g+1>>0]|0)==55:0)?(a[g+2>>0]|0)==36:0)?(k=vf(42710,d[g+3>>0]|0,65)|0,(k|0)!=0):0)?(l=_n(1,0,k-42710|0)|0,m=D,j=_k(p+4|0,g+4|0)|0,(j|0)!=0):0)?(n=_k(p,j)|0,(n|0)!=0):0){j=dt(n,36)|0;if(!j)k=Kh(n)|0;else k=j-n|0;j=k+(n-g)|0;if((!((j+45|0)>>>0>102|(j+45|0)>>>0<k>>>0)?(dd(b,e,f,n,k,l,m,c[p+4>>2]|0,c[p>>2]|0,p+8|0,32)|0)==0:0)?(bi(h|0,g|0,j|0)|0,a[h+j>>0]=36,o=Zg(h+j+1|0,h+102-(h+j+1)|0,p+8|0)|0,bl(p+8|0,32),(o|0)!=0&o>>>0<(h+102|0)>>>0):0)a[o>>0]=0;else h=0}else h=0;i=q;return h|0}function Kf(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=i=i+63&-64;i=i+560|0;ji(l+496|0,j,32,0)|0;a[l+496>>0]=(d[l+496>>0]|0)&248;a[l+496+31>>0]=(d[l+496+31>>0]|0)&63|64;Gl(l)|0;Yd(l,l+496+32|0,32,0)|0;Yd(l,f,g,h)|0;Yh(l,l+432|0)|0;Lk(b+32|0,j+32|0,32)|0;fc(l+432|0);ge(l+208|0,l+432|0);ei(b,l+208|0);Gl(l)|0;Yd(l,b,64,0)|0;Yd(l,f,g,h)|0;Yh(l,l+368|0)|0;fc(l+368|0);_b(b+32|0,l+368|0,l+496|0,l+432|0);bl(l+496|0,64);if(e|0){c[e>>2]=64;c[e+4>>2]=0}i=k;return 0}function Lf(a,b,d,e,f,g,h,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;l=i;i=i+336|0;qq(l+264|0,64,0,m,n)|0;Zr(l,l+264|0)|0;bl(l+264|0,64);Gp(l,h,j,k)|0;h=mo(0,0,j|0,k|0)|0;Gp(l,54260,h&15,0)|0;Ln(a,e,f,g,m,1,n)|0;Gp(l,a,f,g)|0;m=mo(0,0,f|0,g|0)|0;Gp(l,54260,m&15,0)|0;c[l+256>>2]=j;c[l+256+4>>2]=k;Gp(l,l+256|0,8,0)|0;c[l+256>>2]=f;c[l+256+4>>2]=g;Gp(l,l+256|0,8,0)|0;Rr(l,b)|0;bl(l,256);if(d|0){c[d>>2]=16;c[d+4>>2]=0}i=l;return 0}function Mf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;k=i;j=i=i+63&-64;i=i+32|0;a:do if(((b|0)!=0?(d=c[b+20>>2]|0,(d|0)!=0):0)?(c[b+4>>2]|0)!=0:0){h=0;while(1){g=0;do{if(!d)d=0;else{e=g&255;f=0;do{c[j>>2]=h;c[j+4>>2]=f;a[j+8>>0]=e;c[j+12>>2]=0;c[j+16>>2]=c[j>>2];c[j+16+4>>2]=c[j+4>>2];c[j+16+8>>2]=c[j+8>>2];c[j+16+12>>2]=c[j+12>>2];d=ac(b,j+16|0)|0;f=f+1|0;if(d|0)break a;d=c[b+20>>2]|0}while(f>>>0<d>>>0)}g=g+1|0}while(g>>>0<4);h=h+1|0;if(h>>>0>=(c[b+4>>2]|0)>>>0){d=0;break}}}else d=0;while(0);i=k;return d|0}function Nf(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0;n=i;i=i+352|0;Qq(n+280|0,64,0,l,m)|0;Zr(n,n+280|0)|0;bl(n+280|0,64);Gp(n,h,j,k)|0;c[n+256>>2]=j;c[n+256+4>>2]=k;Gp(n,n+256|0,8,0)|0;Gp(n,d,e,f)|0;c[n+256>>2]=e;c[n+256+4>>2]=f;Gp(n,n+256|0,8,0)|0;Rr(n,n+264|0)|0;bl(n,256);b=xm(n+264|0,g)|0;bl(n+264|0,16);do if(a)if(!b){jn(a,d,e,f,l,1,0,m)|0;b=0;break}else{Yi(a|0,0,e|0)|0;b=-1;break}while(0);i=n;return b|0}function Of(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;if(d&2048){a[b>>0]=43;b=b+1|0}if(d&1024){a[b>>0]=35;b=b+1|0}if((d&260|0)==260)f=0;else{a[b>>0]=46;a[b+1>>0]=42;b=b+2|0;f=1}while(1){e=a[c>>0]|0;if(!(e<<24>>24))break;a[b>>0]=e;c=c+1|0;b=b+1|0}a:do switch(d&260|0){case 4:if(!(d>>>14&1)){a[b>>0]=102;break a}else{a[b>>0]=70;break a}case 256:if(!(d>>>14&1)){a[b>>0]=101;break a}else{a[b>>0]=69;break a}default:if((d&260|0)==260)if(d>>>14&1|0){a[b>>0]=65;break a}else{a[b>>0]=97;break a}else if(d>>>14&1|0){a[b>>0]=71;break a}else{a[b>>0]=103;break a}}while(0);return f|0}function Pf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;b=Wm(b)|0;o=0;g=va(32,b|0,52364)|0;k=o;o=0;if(((((!(k&1)?(o=0,Ba(c[(c[g>>2]|0)+48>>2]|0,g|0,47202,47234,d|0)|0,k=o,o=0,!(k&1)):0)?(o=0,j=va(32,b|0,52372)|0,k=o,o=0,!(k&1)):0)?(o=0,h=ha(c[(c[j>>2]|0)+12>>2]|0,j|0)|0,k=o,o=0,!(k&1)):0)?(c[e>>2]=h,o=0,i=ha(c[(c[j>>2]|0)+16>>2]|0,j|0)|0,k=o,o=0,!(k&1)):0)?(c[f>>2]=i,o=0,da(c[(c[j>>2]|0)+20>>2]|0,a|0,j|0),k=o,o=0,!(k&1)):0){en(b);return}k=Ya()|0;en(b);Ra(k|0)}function Qf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;d=Wm(d)|0;o=0;h=va(32,d|0,52332)|0;l=o;o=0;if(((((!(l&1)?(o=0,Ba(c[(c[h>>2]|0)+32>>2]|0,h|0,47202,47234,e|0)|0,l=o,o=0,!(l&1)):0)?(o=0,k=va(32,d|0,52344)|0,l=o,o=0,!(l&1)):0)?(o=0,i=ha(c[(c[k>>2]|0)+12>>2]|0,k|0)|0,l=o,o=0,!(l&1)):0)?(a[f>>0]=i,o=0,j=ha(c[(c[k>>2]|0)+16>>2]|0,k|0)|0,l=o,o=0,!(l&1)):0)?(a[g>>0]=j,o=0,da(c[(c[k>>2]|0)+20>>2]|0,b|0,k|0),l=o,o=0,!(l&1)):0){en(d);return}l=Ya()|0;en(d);Ra(l|0)}function Rf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=0;do{c[d+(f<<2)>>2]=c[a+((e<<5)+-16<<2)+(f<<2)>>2];f=f+1|0}while((f|0)!=16);if(e<<1|0){i=0;do{g=i<<4;f=0;do{h=d+(f<<2)|0;c[h>>2]=c[h>>2]^c[a+(g<<2)+(f<<2)>>2];f=f+1|0}while((f|0)!=16);wd(d);h=i<<3;f=0;do{c[b+(h<<2)+(f<<2)>>2]=c[d+(f<<2)>>2];f=f+1|0}while((f|0)!=16);f=0;do{j=d+(f<<2)|0;c[j>>2]=c[j>>2]^c[a+((g|16)<<2)+(f<<2)>>2];f=f+1|0}while((f|0)!=16);wd(d);f=0;do{c[b+(h+(e<<4)<<2)+(f<<2)>>2]=c[d+(f<<2)>>2];f=f+1|0}while((f|0)!=16);i=i+2|0}while(i>>>0<e<<1>>>0)}return}function Sf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=a[b+8+3>>0]|0;if(f<<24>>24<0){g=(c[b+8>>2]&2147483647)+-1|0;j=c[b+4>>2]|0}else{g=1;j=f&255}do if(e-d>>2|0){if((g-j|0)>>>0<e-d>>2>>>0){$f(b,g,j+(e-d>>2)-g|0,j,j,0);f=a[b+8+3>>0]|0}i=f<<24>>24<0;if(i)g=c[b>>2]|0;else g=b;f=d;h=g+(j<<2)|0;while(1){if((f|0)==(e|0))break;c[h>>2]=c[f>>2];f=f+4|0;h=h+4|0}c[g+(j+((e-d|0)>>>2)<<2)>>2]=0;f=j+(e-d>>2)|0;if(i){c[b+4>>2]=f;break}else{a[b+8+3>>0]=f;break}}while(0);return}function Tf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=a[b+11>>0]|0;if(f<<24>>24<0){g=(c[b+8>>2]&2147483647)+-1|0;j=c[b+4>>2]|0}else{g=10;j=f&255}do if((e|0)!=(d|0)){if((g-j|0)>>>0<(e-d|0)>>>0){bh(b,g,j+(e-d)-g|0,j,j);f=a[b+11>>0]|0}if(f<<24>>24<0)g=c[b>>2]|0;else g=b;i=e+(j-d)|0;f=d;h=g+j|0;while(1){if((f|0)==(e|0))break;a[h>>0]=a[f>>0]|0;f=f+1|0;h=h+1|0}a[g+i>>0]=0;f=j+(e-d)|0;if((a[b+11>>0]|0)<0){c[b+4>>2]=f;break}else{a[b+11>>0]=f;break}}while(0);return}function Uf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;f=i;e=i=i+63&-64;i=i+16|0;h=c[b+32>>2]|0;g=c[b+32+4>>2]|0;a[e+7>>0]=h;j=bo(h|0,g|0,8)|0;a[e+6>>0]=j;j=bo(h|0,g|0,16)|0;a[e+5>>0]=j;j=bo(h|0,g|0,24)|0;a[e+4>>0]=j;a[e+3>>0]=g;j=bo(h|0,g|0,40)|0;a[e+2>>0]=j;j=bo(h|0,g|0,48)|0;a[e+1>>0]=j;j=bo(h|0,g|0,56)|0;a[e>>0]=j;g=bo(h|0,g|0,3)|0;oe(b,42447,((g&63)>>>0<56?56:120)-(g&63)|0,0)|0;oe(b,e,8,0)|0;e=0;do{j=d+(e<<2)|0;h=c[b+(e<<2)>>2]|0;a[j+3>>0]=h;a[j+2>>0]=h>>>8;a[j+1>>0]=h>>>16;a[j>>0]=h>>>24;e=e+1|0}while((e|0)!=8);bl(b,104);i=f;return 0}function Vf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;k=i;j=i=i+63&-64;i=i+16|0;if((a|0)==(b|0)){c[d>>2]=4;a=0}else{g=Sq()|0;h=c[g>>2]|0;c[g>>2]=0;zq()|0;a=Os(a,j,e)|0;e=D;f=c[g>>2]|0;if(!f)c[g>>2]=h;a:do if((c[j>>2]|0)==(b|0)){do if((f|0)==34){c[d>>2]=4;if((e|0)>0|(e|0)==0&a>>>0>0){a=2147483647;break a}}else{if((e|0)<-1|(e|0)==-1&a>>>0<2147483648){c[d>>2]=4;break}if((e|0)>0|(e|0)==0&a>>>0>2147483647){c[d>>2]=4;a=2147483647;break a}else break a}while(0);a=-2147483648}else{c[d>>2]=4;a=0}while(0)}i=k;return a|0}function Wf(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0;e=0;do{a[b+e>>0]=(d[c+(e>>3)>>0]|0)>>>(e&7)&1;e=e+1|0}while((e|0)!=256);i=0;do{g=b+i|0;a:do if(a[g>>0]|0){h=1;do{e=h+i|0;if((e|0)>=256)break a;c=a[b+e>>0]|0;b:do if(c<<24>>24){f=a[g>>0]|0;c=c<<24>>24<<h;if((f+c|0)<16){a[g>>0]=f+c;a[b+e>>0]=0;break}if((f-c|0)<=-16)break a;a[g>>0]=f-c;while(1){c=b+e|0;if(!(a[c>>0]|0))break;a[c>>0]=0;e=e+1|0;if((e|0)>=256)break b}a[c>>0]=1}while(0);h=h+1|0}while((h|0)<7)}while(0);i=i+1|0}while((i|0)!=256);return}function Xf(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;if((1073741806-d|0)>>>0<e>>>0)lk();if((a[b+8+3>>0]|0)<0)k=c[b>>2]|0;else k=b;if(d>>>0<536870887){e=(e+d|0)>>>0<d<<1>>>0?d<<1:e+d|0;if(e>>>0>=2)if((e+4&-4)>>>0>1073741823){b=db(4)|0;eu(b);sb(b|0,1944,114)}else e=e+4&-4;else e=2}else e=1073741807;j=Rj(e<<2)|0;if(h|0)nr(j,i,h);if((f|0)!=(g|0))nr(j+(h<<2)|0,k+(g<<2)|0,f-g|0);if((d|0)!=1)$u(k);c[b>>2]=j;c[b+8>>2]=e|-2147483648;c[b+4>>2]=f-g+h;c[j+(f-g+h<<2)>>2]=0;return}function Yf(a){a=a|0;var b=0,d=0;b=c[a+4>>2]|0;b=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;do if(((c[b+24>>2]|0?(c[b+16>>2]|0)==0:0)?c[b+4>>2]&8192|0:0)?!(hb()|0):0){b=c[a+4>>2]|0;b=c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0;o=0;b=ha(c[(c[b>>2]|0)+24>>2]|0,b|0)|0;d=o;o=0;if(!(d&1)){if((b|0)!=-1)break;d=c[a+4>>2]|0;d=d+(c[(c[d>>2]|0)+-12>>2]|0)|0;o=0;da(57,d|0,c[d+16>>2]|1|0);d=o;o=0;if(!(d&1))break}d=Za(0)|0;jb(d|0)|0;o=0;Fa(19);d=o;o=0;if(d&1){d=Za(0)|0;lt(d)}}while(0);return}function Zf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=c[e+16>>2]|0;if(!f)if(!(Vj(e)|0)){f=c[e+16>>2]|0;g=5}else f=0;else g=5;a:do if((g|0)==5){h=c[e+20>>2]|0;if((f-h|0)>>>0<d>>>0){f=Kb[c[e+36>>2]&63](e,b,d)|0;break}b:do if((a[e+75>>0]|0)>-1){f=d;while(1){if(!f){g=h;f=0;break b}g=f+-1|0;if((a[b+g>>0]|0)==10)break;else f=g}if((Kb[c[e+36>>2]&63](e,b,f)|0)>>>0<f>>>0)break a;d=d-f|0;b=b+f|0;g=c[e+20>>2]|0}else{g=h;f=0}while(0);bi(g|0,b|0,d|0)|0;c[e+20>>2]=(c[e+20>>2]|0)+d;f=f+d|0}while(0);return f|0}function _f(){var a=0,b=0,d=0,e=0;e=i=i+63&-64;i=i+48|0;a=Tl()|0;if(a|0?(d=c[a>>2]|0,d|0):0){b=c[d+48>>2]|0;a=c[d+48+4>>2]|0;if(!((b&-256|0)==1126902528&(a|0)==1129074247)){c[e+24>>2]=49669;no(49764,e+24|0)}if((b|0)==1126902529&(a|0)==1129074247)a=c[d+44>>2]|0;else a=d+80|0;c[e+36>>2]=a;d=c[d>>2]|0;a=c[d+4>>2]|0;if(Rg(1880,d,e+36|0)|0){d=c[e+36>>2]|0;d=Ib[c[(c[d>>2]|0)+8>>2]&127](d)|0;c[e>>2]=49669;c[e+4>>2]=a;c[e+8>>2]=d;no(49678,e)}else{c[e+16>>2]=49669;c[e+16+4>>2]=a;no(49723,e+16|0)}}no(49802,e+32|0)}function $f(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;if((1073741807-d|0)>>>0<e>>>0)lk();if((a[b+8+3>>0]|0)<0)j=c[b>>2]|0;else j=b;if(d>>>0<536870887){e=(e+d|0)>>>0<d<<1>>>0?d<<1:e+d|0;if(e>>>0>=2)if((e+4&-4)>>>0>1073741823){b=db(4)|0;eu(b);sb(b|0,1944,114)}else e=e+4&-4;else e=2}else e=1073741807;i=Rj(e<<2)|0;if(g|0)nr(i,j,g);if((f-h|0)!=(g|0))nr(i+(g<<2)|0,j+(g<<2)+(h<<2)|0,f-h-g|0);if((d|0)!=1)$u(j);c[b>>2]=i;c[b+8>>2]=e|-2147483648;return}function ag(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;n=i;l=i=i+63&-64;i=i+128|0;k=b;m=k+102|0;do{a[k>>0]=0;k=k+1|0}while((k|0)<(m|0));do if(!(f>>>0>0|(f|0)==0&e>>>0>4294967295)){of(g,h,j,l+8|0,l+4|0,l);fn(l+88|0,32);if(!(yf(c[l+8>>2]|0,c[l>>2]|0,c[l+4>>2]|0,l+88|0,l+24|0)|0)){c[(Sq()|0)>>2]=22;e=-1;break}ks(l+12|0);m=(Jf(l+12|0,d,e,l+24|0,b)|0)==0;up(l+12|0);if(m){c[(Sq()|0)>>2]=22;e=-1}else e=0}else{c[(Sq()|0)>>2]=27;e=-1}while(0);i=n;return e|0}function bg(a){a=a|0;dq(53372);dq(53360);dq(53348);dq(53336);dq(53324);dq(53312);dq(53300);dq(53288);dq(53276);dq(53264);dq(53252);dq(53240);dq(53228);dq(53216);return}function cg(a){a=a|0;rq(52560);rq(52548);rq(52536);rq(52524);rq(52512);rq(52500);rq(52488);rq(52476);rq(52464);rq(52452);rq(52440);rq(52428);rq(52416);rq(52404);return}function dg(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;h=i;j=i=i+63&-64;i=i+64|0;if((e+-1&255)>63)Ta();a[j>>0]=e;a[j+1>>0]=0;a[j+2>>0]=1;a[j+3>>0]=1;e=j+4|0;g=e+60|0;do{a[e>>0]=0;e=e+1|0}while((e|0)<(g|0));Yi(b+64|0,0,293)|0;e=b;f=400;g=e+64|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(g|0));e=0;do{k=j+(e<<3)|0;g=b+(e<<3)|0;f=c[g+4>>2]^(d[k+4>>0]|d[k+4+1>>0]<<8|d[k+4+2>>0]<<16|d[k+4+3>>0]<<24);c[g>>2]=c[g>>2]^(d[k>>0]|d[k+1>>0]<<8|d[k+2>>0]<<16|d[k+3>>0]<<24);c[g+4>>2]=f;e=e+1|0}while((e|0)!=8);i=h;return}function eg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;do if(!b){if(!(d<<24>>24)){h=e+-1|0;break}h=S(c[a+12>>2]|0,d&255)|0;if(!g){h=(((e|0)==0)<<31>>31)+h|0;break}else{h=e+-1+h|0;break}}else{h=(c[a+16>>2]|0)-(c[a+12>>2]|0)|0;if(!g){h=(((e|0)==0)<<31>>31)+h|0;break}else{h=e+-1+h|0;break}}while(0);_m(f|0,0,f|0,0)|0;_m(h|0,0,D|0,0)|0;g=mo(h+-1|0,0,D|0,0)|0;if((b|0)==0|d<<24>>24==3){h=0;e=0}else{h=S(c[a+12>>2]|0,(d&255)+1|0)|0;e=0}d=Jp(g|0,D|0,h|0,e|0)|0;a=ym(d|0,D|0,c[a+16>>2]|0,0)|0;return a|0}function fg(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;j=Ib[c[(c[b+8>>2]|0)+8>>2]&127](b+8|0)|0;b=a[j+8+3>>0]|0;if(b<<24>>24<0)i=c[j+4>>2]|0;else i=b&255;b=a[j+20+3>>0]|0;if(b<<24>>24<0)b=c[j+16>>2]|0;else b=b&255;do if((i|0)!=(0-b|0)){b=xc(e,f,j,j+24|0,h,g,0)|0;i=c[d>>2]|0;if((b|0)==(j|0)&(i|0)==12){c[d>>2]=0;break}if((i|0)<12&(b-j|0)==12)c[d>>2]=i+12}else c[g>>2]=c[g>>2]|4;while(0);return}function gg(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;j=Ib[c[(c[b+8>>2]|0)+8>>2]&127](b+8|0)|0;b=a[j+11>>0]|0;if(b<<24>>24<0)i=c[j+4>>2]|0;else i=b&255;b=a[j+12+11>>0]|0;if(b<<24>>24<0)b=c[j+16>>2]|0;else b=b&255;do if((i|0)!=(0-b|0)){b=zc(e,f,j,j+24|0,h,g,0)|0;i=c[d>>2]|0;if((b|0)==(j|0)&(i|0)==12){c[d>>2]=0;break}if((i|0)<12&(b-j|0)==12)c[d>>2]=i+12}else c[g>>2]=c[g>>2]|4;while(0);return}function hg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;m=(c[b+4>>2]|0)-(c[d+4>>2]|0)|0;l=(c[b+8>>2]|0)-(c[d+8>>2]|0)|0;k=(c[b+12>>2]|0)-(c[d+12>>2]|0)|0;j=(c[b+16>>2]|0)-(c[d+16>>2]|0)|0;i=(c[b+20>>2]|0)-(c[d+20>>2]|0)|0;h=(c[b+24>>2]|0)-(c[d+24>>2]|0)|0;g=(c[b+28>>2]|0)-(c[d+28>>2]|0)|0;f=(c[b+32>>2]|0)-(c[d+32>>2]|0)|0;e=(c[b+36>>2]|0)-(c[d+36>>2]|0)|0;c[a>>2]=(c[b>>2]|0)-(c[d>>2]|0);c[a+4>>2]=m;c[a+8>>2]=l;c[a+12>>2]=k;c[a+16>>2]=j;c[a+20>>2]=i;c[a+24>>2]=h;c[a+28>>2]=g;c[a+32>>2]=f;c[a+36>>2]=e;return}function ig(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;m=(c[d+4>>2]|0)+(c[b+4>>2]|0)|0;l=(c[d+8>>2]|0)+(c[b+8>>2]|0)|0;k=(c[d+12>>2]|0)+(c[b+12>>2]|0)|0;j=(c[d+16>>2]|0)+(c[b+16>>2]|0)|0;i=(c[d+20>>2]|0)+(c[b+20>>2]|0)|0;h=(c[d+24>>2]|0)+(c[b+24>>2]|0)|0;g=(c[d+28>>2]|0)+(c[b+28>>2]|0)|0;f=(c[d+32>>2]|0)+(c[b+32>>2]|0)|0;e=(c[d+36>>2]|0)+(c[b+36>>2]|0)|0;c[a>>2]=(c[d>>2]|0)+(c[b>>2]|0);c[a+4>>2]=m;c[a+8>>2]=l;c[a+12>>2]=k;c[a+16>>2]=j;c[a+20>>2]=i;c[a+24>>2]=h;c[a+28>>2]=g;c[a+32>>2]=f;c[a+36>>2]=e;return}function jg(b,c,e,f){b=b|0;c=c|0;e=e|0;f=f|0;var g=0,h=0,i=0;switch((f>>>0)%3|0|0){case 2:{g=((f>>>0)/3|0)<<2|1;h=3;break}case 1:{g=((f>>>0)/3|0)<<2;h=3;break}default:g=((f>>>0)/3|0)<<2}if((h|0)==3)g=g+2|0;if(g>>>0<c>>>0){if(f){i=0;c=0;do{f=f+-1|0;h=e;e=e+1|0;i=d[h>>0]|0|i<<8;c=c+8|0;if(c>>>0>5)while(1){c=c+-6|0;h=b+1|0;a[b>>0]=Vl(i>>>c&63)|0;if(c>>>0>5)b=h;else{b=h;break}}}while((f|0)!=0);if(c){a[b>>0]=Vl(i<<6-c&63)|0;b=b+1|0}}a[b>>0]=0}else g=-1;return g|0}function kg(b,d){b=b|0;d=d|0;var e=0,f=0;a:do if(!(d&255))b=b+(Kh(b)|0)|0;else{if(b&3)do{f=a[b>>0]|0;if(f<<24>>24==0?1:f<<24>>24==(d&255)<<24>>24)break a;b=b+1|0}while((b&3|0)!=0);f=S(d&255,16843009)|0;e=c[b>>2]|0;b:do if(!((e&-2139062144^-2139062144)&e+-16843009))do{e=e^f;if((e&-2139062144^-2139062144)&e+-16843009|0)break b;b=b+4|0;e=c[b>>2]|0}while(!((e&-2139062144^-2139062144)&e+-16843009|0));while(0);while(1){f=a[b>>0]|0;if(f<<24>>24==0?1:f<<24>>24==(d&255)<<24>>24)break;else b=b+1|0}}while(0);return b|0}function lg(a,b,d,e,f,g,h,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;l=i;i=i+336|0;Qq(l+264|0,64,0,m,n)|0;Zr(l,l+264|0)|0;bl(l+264|0,64);Gp(l,h,j,k)|0;c[l+256>>2]=j;c[l+256+4>>2]=k;Gp(l,l+256|0,8,0)|0;jn(a,e,f,g,m,1,0,n)|0;Gp(l,a,f,g)|0;c[l+256>>2]=f;c[l+256+4>>2]=g;Gp(l,l+256|0,8,0)|0;Rr(l,b)|0;bl(l,256);if(d|0){c[d>>2]=16;c[d+4>>2]=0}i=l;return 0}function mg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=i;f=i=i+63&-64;i=i+80|0;a:do if((a|0)==0|(b|0)==0)d=-25;else{e=c[a+8>>2]|0;do if((e|0?((e<<10>>>0)/(e>>>0)|0|0)==1024:0)?(d=ec(12)|0,c[a>>2]=d,d|0):0){d=Nn(f,e<<10)|0;c[(Sq()|0)>>2]=d;if(d|0){c[f>>2]=0;break}d=c[f>>2]|0;if(d|0){c[c[a>>2]>>2]=d;c[(c[a>>2]|0)+4>>2]=d;c[(c[a>>2]|0)+8>>2]=e<<10;je(f+8|0,b,c[a+28>>2]|0);bl(f+8+64|0,8);we(f+8|0,a);bl(f+8|0,72);d=0;break a}}while(0);d=-22}while(0);i=g;return d|0}function ng(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;b=Wm(b)|0;o=0;f=va(32,b|0,52364)|0;i=o;o=0;if((((!(i&1)?(o=0,Ba(c[(c[f>>2]|0)+48>>2]|0,f|0,47202,47228,d|0)|0,i=o,o=0,!(i&1)):0)?(o=0,h=va(32,b|0,52372)|0,i=o,o=0,!(i&1)):0)?(o=0,g=ha(c[(c[h>>2]|0)+16>>2]|0,h|0)|0,i=o,o=0,!(i&1)):0)?(c[e>>2]=g,o=0,da(c[(c[h>>2]|0)+20>>2]|0,a|0,h|0),i=o,o=0,!(i&1)):0){en(b);return}i=Ya()|0;en(b);Ra(i|0)}function og(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;d=Wm(d)|0;o=0;g=va(32,d|0,52332)|0;j=o;o=0;if((((!(j&1)?(o=0,Ba(c[(c[g>>2]|0)+32>>2]|0,g|0,47202,47228,e|0)|0,j=o,o=0,!(j&1)):0)?(o=0,i=va(32,d|0,52344)|0,j=o,o=0,!(j&1)):0)?(o=0,h=ha(c[(c[i>>2]|0)+16>>2]|0,i|0)|0,j=o,o=0,!(j&1)):0)?(a[f>>0]=h,o=0,da(c[(c[i>>2]|0)+20>>2]|0,b|0,i|0),j=o,o=0,!(j&1)):0){en(d);return}j=Ya()|0;en(d);Ra(j|0)}function pg(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;if((-18-d|0)>>>0<e>>>0)lk();if((a[b+11>>0]|0)<0)l=c[b>>2]|0;else l=b;if(d>>>0<2147483623){e=(e+d|0)>>>0<d<<1>>>0?d<<1:e+d|0;e=e>>>0<11?11:e+16&-16}else e=-17;k=Rj(e)|0;if(g|0)bi(k|0,l|0,g|0)|0;if(i|0)bi(k+g|0,j|0,i|0)|0;if((f-h|0)!=(g|0))bi(k+g+i|0,l+g+h|0,f-h-g|0)|0;if((d|0)!=10)$u(l);c[b>>2]=k;c[b+8>>2]=e|-2147483648;c[b+4>>2]=f-h+i;a[k+(f-h+i)>>0]=0;return}function qg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=(c[a+4>>2]|0)!=140;h=c[a>>2]|0;f=(c[d>>2]|0)-h|0;f=f>>>0<2147483647?f<<1:-1;f=(f|0)==0?4:f;g=(c[b>>2]|0)-h>>2;h=$h(e?h:0,f)|0;if(!h)zr();do if(!e){e=c[a>>2]|0;c[a>>2]=h;if(e){o=0;ba(c[a+4>>2]|0,e|0);h=o;o=0;if(h&1){h=Za(0)|0;lt(h)}else{i=c[a>>2]|0;break}}else i=h}else{c[a>>2]=h;i=h}while(0);c[a+4>>2]=143;c[b>>2]=i+(g<<2);c[d>>2]=(c[a>>2]|0)+(f>>>2<<2);return}function rg(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0;k=i;e=i=i+63&-64;i=i+112|0;c[e>>2]=e+4+100;yi(b+8|0,e+4|0,e,g,h,j);b=c[e>>2]|0;g=e+4|0;e=c[d>>2]|0;while(1){if((g|0)==(b|0))break;h=a[g>>0]|0;do if(e){j=e+24|0;f=c[j>>2]|0;if((f|0)==(c[e+28>>2]|0)){d=(Pb[c[(c[e>>2]|0)+52>>2]&63](e,h&255)|0)==-1;e=d?0:e;break}else{c[j>>2]=f+1;a[f>>0]=h;break}}else e=0;while(0);g=g+1|0}i=k;return e|0}function sg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=(c[a+4>>2]|0)!=140;h=c[a>>2]|0;f=(c[d>>2]|0)-h|0;f=f>>>0<2147483647?f<<1:-1;f=(f|0)==0?1:f;g=(c[b>>2]|0)-h|0;h=$h(e?h:0,f)|0;if(!h)zr();do if(!e){e=c[a>>2]|0;c[a>>2]=h;if(e){o=0;ba(c[a+4>>2]|0,e|0);h=o;o=0;if(h&1){h=Za(0)|0;lt(h)}else{i=c[a>>2]|0;break}}else i=h}else{c[a>>2]=h;i=h}while(0);c[a+4>>2]=143;c[b>>2]=i+g;c[d>>2]=(c[a>>2]|0)+f;return}function tg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;l=i;k=i=i+63&-64;i=i+16|0;do if((b|0)==(d|0)){c[e>>2]=4;b=0}else{if((a[b>>0]|0)==45){c[e>>2]=4;b=0;break}h=Sq()|0;j=c[h>>2]|0;c[h>>2]=0;zq()|0;b=Ds(b,k,f)|0;f=D;g=c[h>>2]|0;if(!g)c[h>>2]=j;do if((c[k>>2]|0)==(d|0))if(f>>>0>0|(f|0)==0&b>>>0>65535|(g|0)==34){c[e>>2]=4;b=-1;break}else{b=b&65535;break}else{c[e>>2]=4;b=0}while(0)}while(0);i=l;return b|0}function ug(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0;i=c[b+104>>2]|0;if((i|0)!=0?(c[b+108>>2]|0)>=(i|0):0)j=4;else{e=Dk(b)|0;if((e|0)>=0){i=c[b+104>>2]|0;f=c[b+8>>2]|0;if((i|0)!=0?(g=c[b+4>>2]|0,h=i-(c[b+108>>2]|0)|0,(f-g|0)>=(h|0)):0){c[b+100>>2]=g+(h+-1);g=b+4|0}else{g=b+4|0;h=f;j=9}if((j|0)==9){c[b+100>>2]=f;f=h}if(!f)f=c[g>>2]|0;else{i=c[g>>2]|0;c[b+108>>2]=f+1-i+(c[b+108>>2]|0);f=i}f=f+-1|0;if((d[f>>0]|0|0)!=(e|0))a[f>>0]=e}else j=4}if((j|0)==4){c[b+100>>2]=0;e=-1}return e|0}function vg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;m=i;l=i=i+63&-64;i=i+128|0;g=l;h=34416;j=g+112|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(j|0));if((d+-1|0)>>>0>2147483646)if(!d){b=l+112|0;d=1;k=4}else{c[(Sq()|0)>>2]=75;d=-1}else k=4;if((k|0)==4){k=-2-b|0;k=d>>>0>k>>>0?k:d;c[l+48>>2]=k;c[l+20>>2]=b;c[l+44>>2]=b;d=b+k|0;c[l+16>>2]=d;c[l+28>>2]=d;d=Df(l,e,f)|0;if(k){k=c[l+20>>2]|0;a[k+(((k|0)==(c[l+16>>2]|0))<<31>>31)>>0]=0}}i=m;return d|0}function wg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;l=i;k=i=i+63&-64;i=i+16|0;do if((b|0)==(d|0)){c[e>>2]=4;b=0}else{if((a[b>>0]|0)==45){c[e>>2]=4;b=0;break}h=Sq()|0;j=c[h>>2]|0;c[h>>2]=0;zq()|0;b=Ds(b,k,f)|0;f=D;g=c[h>>2]|0;if(!g)c[h>>2]=j;do if((c[k>>2]|0)==(d|0))if(f>>>0>0|(f|0)==0&b>>>0>4294967295|(g|0)==34){c[e>>2]=4;b=-1;break}else break;else{c[e>>2]=4;b=0}while(0)}while(0);i=l;return b|0}function xg(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;j=i;d=i=i+63&-64;i=i+416|0;c[d>>2]=d+8+400;qh(a+8|0,d+8|0,d,f,g,h);a=c[d>>2]|0;f=d+8|0;d=c[b>>2]|0;while(1){if((f|0)==(a|0))break;e=c[f>>2]|0;if(!d)d=0;else{h=d+24|0;g=c[h>>2]|0;if((g|0)==(c[d+28>>2]|0))e=Pb[c[(c[d>>2]|0)+52>>2]&63](d,e)|0;else{c[h>>2]=g+4;c[g>>2]=e}d=(e|0)==-1?0:d}f=f+4|0}i=j;return d|0}function yg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=e-d>>2;if(f>>>0>1073741807)lk();do if(f>>>0>=2)if((f+4&-4)>>>0>1073741823){e=db(4)|0;eu(e);sb(e|0,1944,114)}else{g=Rj((f+4&-4)<<2)|0;c[b>>2]=g;c[b+8>>2]=f+4&-4|-2147483648;c[b+4>>2]=f;b=g;break}else a[b+8+3>>0]=f;while(0);f=d;g=b;while(1){if((f|0)==(e|0))break;c[g>>2]=c[f>>2];f=f+4|0;g=g+4|0}c[b+((e-d|0)>>>2<<2)>>2]=0;return}function zg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=i=i+63&-64;i=i+48|0;ig(a,b+40|0,b);hg(a+40|0,b+40|0,b);ic(a+80|0,a,c+40|0);ic(a+40|0,a+40|0,c);ic(a+120|0,c+120|0,b+120|0);ic(a,b+80|0,c+80|0);ig(e,a,a);hg(a,a+80|0,a+40|0);ig(a+40|0,a+80|0,a+40|0);hg(a+80|0,e,a+120|0);ig(a+120|0,e,a+120|0);i=d;return}function Ag(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=i=i+63&-64;i=i+48|0;ig(a,b+40|0,b);hg(a+40|0,b+40|0,b);ic(a+80|0,a,c);ic(a+40|0,a+40|0,c+40|0);ic(a+120|0,c+120|0,b+120|0);ic(a,b+80|0,c+80|0);ig(e,a,a);hg(a,a+80|0,a+40|0);ig(a+40|0,a+80|0,a+40|0);ig(a+80|0,e,a+120|0);hg(a+120|0,e,a+120|0);i=d;return}function Bg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;ig(a,b+40|0,b);hg(a+40|0,b+40|0,b);l=c[b+84>>2]|0;k=c[b+88>>2]|0;j=c[b+92>>2]|0;i=c[b+96>>2]|0;h=c[b+100>>2]|0;g=c[b+104>>2]|0;f=c[b+108>>2]|0;e=c[b+112>>2]|0;d=c[b+116>>2]|0;c[a+80>>2]=c[b+80>>2];c[a+84>>2]=l;c[a+88>>2]=k;c[a+92>>2]=j;c[a+96>>2]=i;c[a+100>>2]=h;c[a+104>>2]=g;c[a+108>>2]=f;c[a+112>>2]=e;c[a+116>>2]=d;ic(a+120|0,b+120|0,2120);return}function Cg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;l=i;k=i=i+63&-64;i=i+16|0;do if((b|0)==(d|0)){c[e>>2]=4;f=0;b=0}else{if((a[b>>0]|0)==45){c[e>>2]=4;f=0;b=0;break}h=Sq()|0;j=c[h>>2]|0;c[h>>2]=0;zq()|0;b=Ds(b,k,f)|0;f=D;g=c[h>>2]|0;if(!g)c[h>>2]=j;if((c[k>>2]|0)==(d|0)){if((g|0)==34){c[e>>2]=4;b=-1;f=-1}}else{c[e>>2]=4;b=0;f=0}}while(0);D=f;i=l;return b|0}function Dg(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;g=i;h=i=i+63&-64;i=i+320|0;f=h+280|0;e=f+32|0;do{a[f>>0]=a[c>>0]|0;f=f+1|0;c=c+1|0}while((f|0)<(e|0));a[h+280>>0]=(d[h+280>>0]|0)&248;a[h+280+31>>0]=(d[h+280+31>>0]|0)&63|64;ge(h+40|0,h+280|0);ig(h+240|0,h+40+80|0,h+40+40|0);hg(h+200|0,h+40+80|0,h+40+40|0);td(h+200|0,h+200|0);ic(h,h+240|0,h+200|0);Rd(b,h);i=g;return 0}function Eg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;k=i;j=i=i+63&-64;i=i+16|0;if((a|0)==(b|0)){c[d>>2]=4;e=0;a=0}else{g=Sq()|0;h=c[g>>2]|0;c[g>>2]=0;zq()|0;f=Os(a,j,e)|0;e=D;a=c[g>>2]|0;if(!a)c[g>>2]=h;if((c[j>>2]|0)==(b|0))if((a|0)==34){c[d>>2]=4;a=(e|0)>0|(e|0)==0&f>>>0>0?-1:0;e=(e|0)>0|(e|0)==0&f>>>0>0?2147483647:-2147483648}else a=f;else{c[d>>2]=4;a=0;e=0}}D=e;i=k;return a|0}function Fg(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+464|0;zf(j+208|0,b,c)|0;Mq(j+208|0,d,e,0)|0;if(g|0){b=0;c=0;do{c=c+1|0;a[j+448+3>>0]=c;a[j+448+2>>0]=c>>>8;a[j+448+1>>0]=c>>>16;a[j+448>>0]=c>>>24;bi(j|0,j+208|0,208)|0;Mq(j,j+448|0,4,0)|0;Ll(j,j+416|0)|0;e=g-b|0;bi(f+b|0,j+416|0,(e>>>0>32?32:e)|0)|0;b=c<<5}while(b>>>0<g>>>0)}bl(j+208|0,208);i=h;return}function Gg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=i=i+63&-64;i=i+16|0;Nl(b);c[b>>2]=38192;c[b+32>>2]=d;xr(g+4|0,c[b+4>>2]|0);d=c[g+4>>2]|0;c[g>>2]=d;o=0;d=va(32,d|0,54132)|0;h=o;o=0;if(h&1){h=Ya()|0;ts(g);tr(b);Ra(h|0)}else{ts(g);c[b+36>>2]=d;c[b+40>>2]=e;a[b+44>>0]=(Ib[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;i=f;return}}function Hg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=i=i+63&-64;i=i+16|0;Ol(b);c[b>>2]=38128;c[b+32>>2]=d;xr(g+4|0,c[b+4>>2]|0);d=c[g+4>>2]|0;c[g>>2]=d;o=0;d=va(32,d|0,54124)|0;h=o;o=0;if(h&1){h=Ya()|0;ts(g);ur(b);Ra(h|0)}else{ts(g);c[b+36>>2]=d;c[b+40>>2]=e;a[b+44>>0]=(Ib[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;i=f;return}}function Ig(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;h=i;j=i=i+63&-64;i=i+256|0;do if((d|0)>(e|0)&(f&73728|0)==0){Yi(j|0,b|0,((d-e|0)>>>0>256?256:d-e|0)|0)|0;f=c[a>>2]|0;if((d-e|0)>>>0>255){g=d-e|0;b=f;f=(f&32|0)==0;do{if(f){Zf(j,256,a)|0;b=c[a>>2]|0}g=g+-256|0;f=(b&32|0)==0}while(g>>>0>255);if(f)b=d-e&255;else break}else if(!(f&32))b=d-e|0;else break;Zf(j,b,a)|0}while(0);i=h;return}function Jg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;d=i=i+63&-64;i=i+16|0;c[g>>2]=e;b=aq(c[b+8>>2]|0)|0;e=Wg(d,0)|0;if(b|0)aq(b)|0;a:do switch(e|0){case 0:case -1:{d=2;break}default:if((e+-1|0)>>>0>(f-(c[g>>2]|0)|0)>>>0)d=1;else{b=e+-1|0;while(1){if(!b){d=0;break a}e=a[d>>0]|0;f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=e;b=b+-1|0;d=d+1|0}}}while(0);i=h;return d|0}function Kg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=i=i+63&-64;i=i+48|0;ig(a,b+40|0,b);hg(a+40|0,b+40|0,b);ic(a+80|0,a,c+40|0);ic(a+40|0,a+40|0,c);ic(a+120|0,c+80|0,b+120|0);ig(e,b+80|0,b+80|0);hg(a,a+80|0,a+40|0);ig(a+40|0,a+80|0,a+40|0);hg(a+80|0,e,a+120|0);ig(a+120|0,e,a+120|0);i=d;return}function Lg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=i=i+63&-64;i=i+48|0;ig(a,b+40|0,b);hg(a+40|0,b+40|0,b);ic(a+80|0,a,c);ic(a+40|0,a+40|0,c+40|0);ic(a+120|0,c+80|0,b+120|0);ig(e,b+80|0,b+80|0);hg(a,a+80|0,a+40|0);ig(a+40|0,a+80|0,a+40|0);ig(a+80|0,e,a+120|0);hg(a+120|0,e,a+120|0);i=d;return}function Mg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=a[b+8+3>>0]|0;if(f<<24>>24<0)g=(c[b+8>>2]&2147483647)+-1|0;else g=1;do if(g>>>0>=e>>>0){if(f<<24>>24<0)f=c[b>>2]|0;else f=b;cr(f,d,e);c[f+(e<<2)>>2]=0;if((a[b+8+3>>0]|0)<0){c[b+4>>2]=e;break}else{a[b+8+3>>0]=e;break}}else{if(f<<24>>24<0)f=c[b+4>>2]|0;else f=f&255;Xf(b,g,e-g|0,f,f,e,d)}while(0);return}function Ng(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;a[b+53>>0]=1;do if((c[b+4>>2]|0)==(e|0)){a[b+52>>0]=1;e=c[b+16>>2]|0;if(!e){c[b+16>>2]=d;c[b+24>>2]=f;c[b+36>>2]=1;if(!((f|0)==1?(c[b+48>>2]|0)==1:0))break;a[b+54>>0]=1;break}if((e|0)!=(d|0)){c[b+36>>2]=(c[b+36>>2]|0)+1;a[b+54>>0]=1;break}e=c[b+24>>2]|0;if((e|0)==2){c[b+24>>2]=f;e=f}if((e|0)==1?(c[b+48>>2]|0)==1:0)a[b+54>>0]=1}while(0);return}function Og(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=a[b+11>>0]|0;if(f<<24>>24<0)g=(c[b+8>>2]&2147483647)+-1|0;else g=10;do if(g>>>0>=e>>>0){if(f<<24>>24<0)f=c[b>>2]|0;else f=b;if(e|0)Lk(f|0,d|0,e|0)|0;a[f+e>>0]=0;if((a[b+11>>0]|0)<0){c[b+4>>2]=e;break}else{a[b+11>>0]=e;break}}else{if(f<<24>>24<0)f=c[b+4>>2]|0;else f=f&255;pg(b,g,e-g|0,f,0,f,e,d)}while(0);return}function Pg(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;n=i;l=i=i+63&-64;i=i+16|0;k=b;m=k+128|0;do{a[k>>0]=0;k=k+1|0}while((k|0)<(m|0));do if(!((h|f)>>>0>0|(h|f|0)==0&(g|e)>>>0>4294967295|j>>>0>2147484671))if(h>>>0<0|(h|0)==0&g>>>0<3|j>>>0<8192){c[(Sq()|0)>>2]=22;e=-1;break}else{fn(l,16);e=((Jo(g,j>>>10,d,e,l,b)|0)!=0)<<31>>31;break}else{c[(Sq()|0)>>2]=27;e=-1}while(0);i=n;return e|0}function Qg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a:do if((b|0)!=(c[d+8>>2]|0)){g=c[b+12>>2]|0;Aj(b+16|0,d,e,f);if((g|0)>1){h=b+24|0;do{Aj(h,d,e,f);if(a[d+54>>0]|0)break a;h=h+8|0}while(h>>>0<(b+16+(g<<3)|0)>>>0)}}else wi(d,e,f);while(0);return}function Rg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;h=i;g=i=i+63&-64;i=i+64|0;if((a|0)!=(b|0))if((b|0)!=0?(f=wf(b,1888)|0,(f|0)!=0):0){b=g;e=b+56|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(e|0));c[g>>2]=f;c[g+8>>2]=a;c[g+12>>2]=-1;c[g+48>>2]=1;Xb[c[(c[f>>2]|0)+28>>2]&31](f,g,c[d>>2]|0,1);if((c[g+24>>2]|0)==1){c[d>>2]=c[g+16>>2];b=1}else b=0}else b=0;else b=1;i=h;return b|0}function Sg(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=i=i+63&-64;i=i+368|0;if((b|0)==0&((e|0)!=0|(f|0)!=0))Ta();if(!a)Ta();if((d+-1&255)>63)Ta();if(!((c|0)!=0|g<<24>>24==0))Ta();if((g&255)>64)Ta();if(!(g<<24>>24))Oe(l,d,h,j);else he(l,d,c,g,h,j);af(l,b,e,f);ze(l,a,d)|0;i=k;return}function Tg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;do if((b|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)==(e|0)?(c[d+28>>2]|0)!=1:0)c[d+28>>2]=f}else if((b|0)==(c[d>>2]|0)){if((c[d+16>>2]|0)!=(e|0)?(c[d+20>>2]|0)!=(e|0):0){c[d+32>>2]=f;c[d+20>>2]=e;c[d+40>>2]=(c[d+40>>2]|0)+1;if((c[d+36>>2]|0)==1?(c[d+24>>2]|0)==2:0)a[d+54>>0]=1;c[d+44>>2]=4;break}if((f|0)==1)c[d+32>>2]=1}while(0);return}function Ug(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0;if(e&2048){a[b>>0]=43;b=b+1|0}if(!(e&512))f=c;else{a[b>>0]=35;f=c;b=b+1|0}while(1){c=a[f>>0]|0;if(!(c<<24>>24))break;a[b>>0]=c;f=f+1|0;b=b+1|0}a:do switch(e&74|0){case 64:{a[b>>0]=111;break}case 8:if(!(e&16384)){a[b>>0]=120;break a}else{a[b>>0]=88;break a}default:if(d){a[b>>0]=100;break a}else{a[b>>0]=117;break a}}while(0);return}function Vg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;if(e>>>3|0){f=0;do{g=b+(f<<3)|0;h=d+(f<<3)|0;i=c[h>>2]|0;h=c[h+4>>2]|0;a[g+7>>0]=i;j=bo(i|0,h|0,8)|0;a[g+6>>0]=j;j=bo(i|0,h|0,16)|0;a[g+5>>0]=j;j=bo(i|0,h|0,24)|0;a[g+4>>0]=j;a[g+3>>0]=h;j=bo(i|0,h|0,40)|0;a[g+2>>0]=j;j=bo(i|0,h|0,48)|0;a[g+1>>0]=j;h=bo(i|0,h|0,56)|0;a[g>>0]=h;f=f+1|0}while((f|0)!=(e>>>3|0))}return}function Wg(b,d){b=b|0;d=d|0;do if(b){if(d>>>0<128){a[b>>0]=d;b=1;break}if(d>>>0<2048){a[b>>0]=d>>>6|192;a[b+1>>0]=d&63|128;b=2;break}if(d>>>0<55296|(d&-8192|0)==57344){a[b>>0]=d>>>12|224;a[b+1>>0]=d>>>6&63|128;a[b+2>>0]=d&63|128;b=3;break}if((d+-65536|0)>>>0<1048576){a[b>>0]=d>>>18|240;a[b+1>>0]=d>>>12&63|128;a[b+2>>0]=d>>>6&63|128;a[b+3>>0]=d&63|128;b=4;break}else{c[(Sq()|0)>>2]=84;b=-1;break}}else b=1;while(0);return b|0}function Xg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=a[b+11>>0]|0;if(f<<24>>24<0){g=(c[b+8>>2]&2147483647)+-1|0;h=c[b+4>>2]|0}else{g=10;h=f&255}if((g-h|0)>>>0>=e>>>0){if(e|0){if(f<<24>>24<0)g=c[b>>2]|0;else g=b;bi(g+h|0,d|0,e|0)|0;f=h+e|0;if((a[b+11>>0]|0)<0)c[b+4>>2]=f;else a[b+11>>0]=f;a[g+f>>0]=0}}else pg(b,g,e-g+h|0,h,h,0,e,d);return}function Yg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=a[b+8+3>>0]|0;if(e<<24>>24<0){f=(c[b+8>>2]&2147483647)+-1|0;g=c[b+4>>2]|0}else{f=1;g=e&255}if((g|0)==(f|0)){$f(b,f,1,f,f,0);if((a[b+8+3>>0]|0)<0)e=8;else e=7}else if(e<<24>>24<0)e=8;else e=7;if((e|0)==7)a[b+8+3>>0]=g+1;else if((e|0)==8){f=c[b>>2]|0;c[b+4>>2]=g+1;b=f}g=b+(g<<2)|0;c[g>>2]=d;c[g+4>>2]=0;return}function Zg(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=0;a:while(1){if(f>>>0<32){k=0;g=0}else break;do{j=f;f=f+1|0;g=(d[e+j>>0]|0)<<k|g;k=k+8|0}while(f>>>0<32&k>>>0<24);h=c;i=b;j=0;while(1){if(!h){b=0;break a}l=i;i=i+1|0;a[l>>0]=a[42710+(g&63)>>0]|0;j=j+6|0;if(j>>>0>=k>>>0)break;else{g=g>>>6;h=h+-1|0}}l=(i|0)==0;c=(l?0:b-i|0)+c|0;if(l){b=0;break}else b=i}return b|0}function _g(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;e=i;d=i=i+63&-64;i=i+48|0;b=bf(a)|0;if(!b){f=c[a+44>>2]|0;b=c[a+48>>2]|0;f=((f>>>0<b<<3>>>0?b<<3:f)>>>0)/(b<<2>>>0)|0;g=S(f,b<<2)|0;c[d>>2]=0;c[d+4>>2]=c[a+40>>2];c[d+8>>2]=g;c[d+12>>2]=f;c[d+16>>2]=f<<2;c[d+20>>2]=b;c[d+24>>2]=c[a+52>>2];c[d+28>>2]=1;b=mg(d,a)|0;if(!b){b=Mf(d)|0;if(!b){rf(a,d);b=0}}}i=e;return b|0}function $g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;hs(b);e=c[a+8>>2]|0;do if((c[a+12>>2]|0)-e>>2>>>0>d>>>0)f=a+8|0;else{o=0;da(66,a+8|0,d+1|0);f=o;o=0;if(!(f&1)){f=a+8|0;e=c[a+8>>2]|0;break}e=Ya()|0;if(b|0)en(b);Ra(e|0)}while(0);a=c[e+(d<<2)>>2]|0;if(a){en(a);e=c[f>>2]|0}c[e+(d<<2)>>2]=b;return}function ah(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=a[b+11>>0]|0;if(e<<24>>24<0){f=(c[b+8>>2]&2147483647)+-1|0;g=c[b+4>>2]|0}else{f=10;g=e&255}if((g|0)==(f|0)){bh(b,f,1,f,f);if((a[b+11>>0]|0)<0)e=8;else e=7}else if(e<<24>>24<0)e=8;else e=7;if((e|0)==7)a[b+11>>0]=g+1;else if((e|0)==8){f=c[b>>2]|0;c[b+4>>2]=g+1;b=f}g=b+g|0;a[g>>0]=d;a[g+1>>0]=0;return}function bh(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;if((-17-d|0)>>>0<e>>>0)lk();if((a[b+11>>0]|0)<0)i=c[b>>2]|0;else i=b;if(d>>>0<2147483623){e=(e+d|0)>>>0<d<<1>>>0?d<<1:e+d|0;e=e>>>0<11?11:e+16&-16}else e=-17;h=Rj(e)|0;if(g|0)bi(h|0,i|0,g|0)|0;if((f|0)!=(g|0))bi(h+g|0,i+g|0,f-g|0)|0;if((d|0)!=10)$u(i);c[b>>2]=h;c[b+8>>2]=e|-2147483648;return}function ch(b){b=b|0;var d=0;if((a[50176]|0)==0?sr(50176)|0:0){if((a[50184]|0)==0?sr(50184)|0:0){b=53680;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+(d<<2)>>2]=0;d=d+1|0}b=b+12|0}while((b|0)!=53968);rb(138,0,n|0)|0}On(53680,39764);On(53692,39776);c[13492]=53680}return c[13492]|0}function dh(b){b=b|0;var d=0;if((a[50096]|0)==0?sr(50096)|0:0){if((a[50104]|0)==0?sr(50104)|0:0){b=52868;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+(d<<2)>>2]=0;d=d+1|0}b=b+12|0}while((b|0)!=53156);rb(134,0,n|0)|0}Pn(52868,47939);Pn(52880,47942);c[13289]=52868}return c[13289]|0}function eh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;l=0-(c[b+4>>2]|0)|0;k=0-(c[b+8>>2]|0)|0;j=0-(c[b+12>>2]|0)|0;i=0-(c[b+16>>2]|0)|0;h=0-(c[b+20>>2]|0)|0;g=0-(c[b+24>>2]|0)|0;f=0-(c[b+28>>2]|0)|0;e=0-(c[b+32>>2]|0)|0;d=0-(c[b+36>>2]|0)|0;c[a>>2]=0-(c[b>>2]|0);c[a+4>>2]=l;c[a+8>>2]=k;c[a+12>>2]=j;c[a+16>>2]=i;c[a+20>>2]=h;c[a+24>>2]=g;c[a+28>>2]=f;c[a+32>>2]=e;c[a+36>>2]=d;return}function fh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if(d|0){e=a[b+11>>0]|0;if(e<<24>>24<0){f=(c[b+8>>2]&2147483647)+-1|0;g=c[b+4>>2]|0}else{f=10;g=e&255}if((f-g|0)>>>0<d>>>0){bh(b,f,d-f+g|0,g,g);e=a[b+11>>0]|0}if(e<<24>>24<0)f=c[b>>2]|0;else f=b;Yi(f+g|0,0,d|0)|0;e=g+d|0;if((a[b+11>>0]|0)<0)c[b+4>>2]=e;else a[b+11>>0]=e;a[f+e>>0]=0}return}function gh(a,b,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;do if((l|0)==1){if((g|d|j)>>>0>0|(g|d|j|0)==0&(f|b|i)>>>0>4294967295|k>>>0>2147484671){c[(Sq()|0)>>2]=27;b=-1;break}if(d>>>0<0|(d|0)==0&b>>>0<16|(j>>>0<0|(j|0)==0&i>>>0<3)|k>>>0<8192){c[(Sq()|0)>>2]=22;b=-1;break}else{b=((ko(i,k>>>10,e,f,h,a,b)|0)!=0)<<31>>31;break}}else b=-1;while(0);return b|0}function hh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=c[a>>2]|0;f=(c[a+4>>2]|0)-e|0;d=(c[b+4>>2]|0)+(0-(f>>2)<<2)|0;c[b+4>>2]=d;if((f|0)>0){bi(d|0,e|0,f|0)|0;e=b+4|0;d=c[b+4>>2]|0}else e=b+4|0;f=c[a>>2]|0;c[a>>2]=d;c[e>>2]=f;f=c[a+4>>2]|0;c[a+4>>2]=c[b+8>>2];c[b+8>>2]=f;f=c[a+8>>2]|0;c[a+8>>2]=c[b+12>>2];c[b+12>>2]=f;c[b>>2]=c[e>>2];return}function ih(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0;j=i;h=i=i+63&-64;i=i+16|0;a[h>>0]=e;f=c[b+16>>2]|0;if(!f)if(!(Vj(b)|0)){f=c[b+16>>2]|0;g=4}else f=-1;else g=4;do if((g|0)==4){g=c[b+20>>2]|0;if(g>>>0<f>>>0?(e&255|0)!=(a[b+75>>0]|0):0){c[b+20>>2]=g+1;a[g>>0]=e;f=e&255;break}if((Kb[c[b+36>>2]&63](b,h,1)|0)==1)f=d[h>>0]|0;else f=-1}while(0);i=j;return f|0}function jh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;f=i;d=i=i+63&-64;i=i+16|0;a:while(1){b=c[a+36>>2]|0;b=Qb[c[(c[b>>2]|0)+20>>2]&63](b,c[a+40>>2]|0,d+8|0,d+8+8|0,d)|0;g=(c[d>>2]|0)-(d+8)|0;if((gn(d+8|0,1,g,c[a+32>>2]|0)|0)!=(g|0)){b=-1;break}switch(b|0){case 1:break;case 2:{b=-1;break a}default:{e=4;break a}}}if((e|0)==4)b=((Ki(c[a+32>>2]|0)|0)!=0)<<31>>31;i=f;return b|0}function kh(a,b,d,e,f,g,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0;n=i;m=i=i+63&-64;i=i+16|0;Yi(a|0,0,b|0)|0;if((g|d)>>>0>0|(g|d|0)==0&(f|b)>>>0>4294967295){c[(Sq()|0)>>2]=27;b=-1}else{of(j,k,l,m+8|0,m+4|0,m);l=_n(1,0,c[m+8>>2]|0)|0;b=pj(e,f,h,32,l,D,c[m>>2]|0,c[m+4>>2]|0,a,b)|0}i=n;return b|0}function lh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;e=Wm(e)|0;o=0;h=va(32,e|0,52364)|0;i=o;o=0;if(i&1){i=Ya()|0;en(e);Ra(i|0)}else{en(e);fi(a,g+16|0,b,c[d>>2]|0,f,h);return c[b>>2]|0}return 0}function mh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;e=Wm(e)|0;o=0;h=va(32,e|0,52364)|0;i=o;o=0;if(i&1){i=Ya()|0;en(e);Ra(i|0)}else{en(e);ki(a,g+24|0,b,c[d>>2]|0,f,h);return c[b>>2]|0}return 0}function nh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;e=Wm(e)|0;o=0;h=va(32,e|0,52332)|0;i=o;o=0;if(i&1){i=Ya()|0;en(e);Ra(i|0)}else{en(e);gi(a,g+16|0,b,c[d>>2]|0,f,h);return c[b>>2]|0}return 0}function oh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;e=Wm(e)|0;o=0;h=va(32,e|0,52332)|0;i=o;o=0;if(i&1){i=Ya()|0;en(e);Ra(i|0)}else{en(e);li(a,g+24|0,b,c[d>>2]|0,f,h);return c[b>>2]|0}return 0}function ph(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+368|0;if((b|0)==0&((e|0)!=0|(f|0)!=0))Ta();if(!a)Ta();if((d+-1&255)>63)Ta();if(!((c|0)!=0|g<<24>>24==0))Ta();if((g&255)>64)Ta();if(!(g<<24>>24))dg(j,d);else mf(j,d,c,g);af(j,b,e,f);ze(j,a,d)|0;i=h;return}function qh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+128|0;c[j+12>>2]=j+16+100;yi(a,j+16|0,j+12|0,e,f,g);c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=j+16;g=(c[d>>2]|0)-b>>2;f=aq(c[a>>2]|0)|0;g=kd(b,j+8|0,g,j)|0;if(f|0)aq(f)|0;if((g|0)==-1)ll(48258);else{c[d>>2]=b+(g<<2);i=h;return}}function rh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=i=i+63&-64;i=i+48|0;lc(a,b);lc(a+80|0,b+40|0);kc(a+120|0,b+80|0);ig(a+40|0,b,b+40|0);lc(d,a+40|0);ig(a+40|0,a+80|0,a);hg(a+80|0,a+80|0,a);hg(a,d,a+40|0);hg(a+120|0,a+120|0,a+80|0);i=c;return}function sh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+16|0;Lk(a+64|0,d|0,e|0)|0;Kf(a,j,a+64|0,e,f,g)|0;if((c[j>>2]|0)==64&(c[j+4>>2]|0)==0)if(b|0){e=Jp(e|0,f|0,64,0)|0;c[b>>2]=e;c[b+4>>2]=D;e=0}else e=0;else{if(b|0){c[b>>2]=0;c[b+4>>2]=0}e=Jp(e|0,f|0,64,0)|0;Yi(a|0,0,e|0)|0;e=-1}i=h;return e|0}function th(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;e=Wm(e)|0;o=0;a=va(32,e|0,52364)|0;h=o;o=0;if(h&1){h=Ya()|0;en(e);Ra(h|0)}else{en(e);Mi(g+20|0,b,c[d>>2]|0,f,a);return c[b>>2]|0}return 0}function uh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;e=Wm(e)|0;o=0;a=va(32,e|0,52332)|0;h=o;o=0;if(h&1){h=Ya()|0;en(e);Ra(h|0)}else{en(e);Ni(g+20|0,b,c[d>>2]|0,f,a);return c[b>>2]|0}return 0}function vh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if(e>>>0>1073741807)lk();do if(e>>>0>=2)if((e+4&-4)>>>0>1073741823){e=db(4)|0;eu(e);sb(e|0,1944,114)}else{f=Rj((e+4&-4)<<2)|0;c[b>>2]=f;c[b+8>>2]=e+4&-4|-2147483648;c[b+4>>2]=e;b=f;break}else a[b+8+3>>0]=e;while(0);nr(b,d,e);c[b+(e<<2)>>2]=0;return}function wh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;if((e-d|0)>>>0>4294967279)lk();if((e-d|0)>>>0<11)a[b+11>>0]=e-d;else{g=Rj(e-d+16&-16)|0;c[b>>2]=g;c[b+8>>2]=e-d+16&-16|-2147483648;c[b+4>>2]=e-d;b=g}f=d;g=b;while(1){if((f|0)==(e|0))break;a[g>>0]=a[f>>0]|0;f=f+1|0;g=g+1|0}a[b+(e-d)>>0]=0;return}function xh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if(d>>>0>1073741807)lk();do if(d>>>0>=2)if((d+4&-4)>>>0>1073741823){d=db(4)|0;eu(d);sb(d|0,1944,114)}else{f=Rj((d+4&-4)<<2)|0;c[b>>2]=f;c[b+8>>2]=d+4&-4|-2147483648;c[b+4>>2]=d;b=f;break}else a[b+8+3>>0]=d;while(0);mr(b,d,e);c[b+(d<<2)>>2]=0;return}function yh(a,b){a=+a;b=b|0;var d=0;if((b|0)>1023)if((b+-1023|0)>1023){b=(b+-2046|0)>1023?1023:b+-2046|0;a=a*8988465674311579538646525.0e283*8988465674311579538646525.0e283}else{b=b+-1023|0;a=a*8988465674311579538646525.0e283}else if((b|0)<-1022)if((b+1022|0)<-1022){b=(b+2044|0)<-1022?-1022:b+2044|0;a=a*2.2250738585072014e-308*2.2250738585072014e-308}else{b=b+1022|0;a=a*2.2250738585072014e-308}d=_n(b+1023|0,0,52)|0;b=D;c[k>>2]=d;c[k+4>>2]=b;return +(a*+h[k>>3])}function zh(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,i=0;h=0;while(1){if((h|0)>=(e|0))break;f=c[a+24>>2]|0;g=c[a+28>>2]|0;if(f>>>0>=g>>>0){if((Pb[c[(c[a>>2]|0)+52>>2]&63](a,d[b>>0]|0)|0)==-1)break;b=b+1|0;h=h+1|0;continue}i=e-h|0;g=(i|0)<(g-f|0)?i:g-f|0;if(g){bi(f|0,b|0,g|0)|0;f=c[a+24>>2]|0}c[a+24>>2]=f+g;b=b+g|0;h=g+h|0}return h|0}function Ah(a,b){a=a|0;b=b|0;var c=0,d=0;d=i;c=i=i+63&-64;i=i+240|0;if(!(Zc(c+80|0,b)|0)){fo(c);hg(c,c,c+80+40|0);td(c,c);fo(c+40|0);ig(c+40|0,c+40|0,c+80+40|0);ic(c+40|0,c+40|0,c);Rd(a,c+40|0);a=0}else a=-1;i=d;return a|0}function Bh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;g=0;while(1){if((g|0)>=(d|0))break;e=c[a+24>>2]|0;f=c[a+28>>2]|0;if(e>>>0<f>>>0){h=d-g|0;f=(h|0)<(f-e>>2|0)?h:f-e>>2;nr(e,b,f);c[a+24>>2]=(c[a+24>>2]|0)+(f<<2);b=b+(f<<2)|0;g=f+g|0;continue}if((Pb[c[(c[a>>2]|0)+52>>2]&63](a,c[b>>2]|0)|0)==-1)break;b=b+4|0;g=g+1|0}return g|0}function Ch(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;a:do switch(d&176|0){case 16:{d=a[b>>0]|0;switch(d<<24>>24){case 43:case 45:{b=b+1|0;break a}default:{}}if((c-b|0)>1&d<<24>>24==48){switch(a[b+1>>0]|0){case 88:case 120:break;default:{e=7;break a}}b=b+2|0}else e=7;break}case 32:{b=c;break}default:e=7}while(0);return b|0}function Dh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=a[b>>0]|0;a:do if((i+-48&255)<=9){h=b;f=i;g=0;while(1){f=(f<<24>>24)+-48|0;if(g>>>0>429496729){e=0;break a}e=g*10|0;if(f>>>0>~e>>>0){e=0;break a}g=f+e|0;e=h+1|0;f=a[e>>0]|0;if((f+-48&255)>9)break;else h=e}if((e|0)!=(b|0)?(h|0)==(b|0)|i<<24>>24!=48:0)c[d>>2]=g;else e=0}else e=0;while(0);return e|0}function Eh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;e=Jp(e|0,f|0,-64,-1)|0;f=D;do if(f>>>0>0|(f|0)==0&e>>>0>4294967231)h=7;else{if(te(d,d+64|0,e,f,g)|0){Yi(a|0,0,e|0)|0;h=7;break}if(b|0){c[b>>2]=e;c[b+4>>2]=f}Lk(a|0,d+64|0,e|0)|0;e=0}while(0);if((h|0)==7)if(!b)e=-1;else{c[b>>2]=0;c[b+4>>2]=0;e=-1}return e|0}function Fh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;l=c[b+4>>2]|0;k=c[b+8>>2]|0;j=c[b+12>>2]|0;i=c[b+16>>2]|0;h=c[b+20>>2]|0;g=c[b+24>>2]|0;f=c[b+28>>2]|0;e=c[b+32>>2]|0;d=c[b+36>>2]|0;c[a>>2]=c[b>>2];c[a+4>>2]=l;c[a+8>>2]=k;c[a+12>>2]=j;c[a+16>>2]=i;c[a+20>>2]=h;c[a+24>>2]=g;c[a+28>>2]=f;c[a+32>>2]=e;c[a+36>>2]=d;return}function Gh(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;j=i;h=i=i+63&-64;i=i+32|0;if(!(e>>>0<0|(e|0)==0&d>>>0<32)?(Zk(h,32,0,f,g)|0,k=Jp(d|0,e|0,-32,-1)|0,(Do(c+16|0,c+32|0,k,D,h)|0)==0):0){eo(b,c,d,e,f,g)|0;d=b+32|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(d|0));b=0}else b=-1;i=j;return b|0}function Hh(){var b=0,d=0,e=0;b=i;d=i=i+63&-64;i=i+16|0;Nl(52028);c[13007]=38064;c[13015]=34188;c[13017]=52084;c[13019]=-1;a[52080]=0;xr(d,c[13008]|0);o=0;da(21,52028,d|0);e=o;o=0;if(e&1){e=Ya()|0;ts(d);tr(52028);Ra(e|0)}else{ts(d);i=b;return}}function Ih(b,d){b=b|0;d=d|0;var e=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;a[b+128>>0]=0;if(d|0){o=0;da(65,b|0,d|0);e=o;o=0;if(e&1){e=Ya()|0;mj(b);Ra(e|0)}e=c[b+4>>2]|0;do{c[e>>2]=0;e=(c[b+4>>2]|0)+4|0;c[b+4>>2]=e;d=d+-1|0}while((d|0)!=0)}return}function Jh(){var b=0,d=0,e=0;b=i;d=i=i+63&-64;i=i+16|0;Ol(51964);c[12991]=38e3;c[12999]=34188;c[13001]=52020;c[13003]=-1;a[52016]=0;xr(d,c[12992]|0);o=0;da(20,51964,d|0);e=o;o=0;if(e&1){e=Ya()|0;ts(d);ur(51964);Ra(e|0)}else{ts(d);i=b;return}}function Kh(b){b=b|0;var d=0,e=0,f=0;a:do if(!(b&3)){d=b;f=4}else{e=b;d=b;while(1){if(!(a[e>>0]|0))break a;e=e+1|0;d=e;if(!(d&3)){d=e;f=4;break}}}while(0);if((f|0)==4){while(1){e=c[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((a[d>>0]|0)!=0)}return d-b|0}function Lh(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;k=i;i=i+96|0;if(!(gs(k+32|0,k)|0)){g=b;h=k+32|0;j=g+32|0;do{a[g>>0]=a[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Ak(k+64|0,k+32|0,f);d=Rl(b+32|0,c,d,e,k+64|0,f,k)|0;bl(k,32);bl(k+32|0,32);bl(k+64|0,24)}else d=-1;i=k;return d|0}function Mh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;h=i;e=i=i+63&-64;i=i+16|0;f=ec(240)|0;do if(f){c[e>>2]=c[d>>2];e=vg(f,240,b,e)|0;if(e>>>0<240){b=$h(f,e+1|0)|0;c[a>>2]=b|0?b:f;break}nc(f);if((e|0)>=0?(g=ec(e+1|0)|0,c[a>>2]=g,(g|0)!=0):0)e=vg(g,e+1|0,b,d)|0;else e=-1}else e=-1;while(0);i=h;return e|0}function Nh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=i=i+63&-64;i=i+16|0;b=(c[a+24>>2]|0)==0|b;c[a+16>>2]=b;if(!(b&c[a+20>>2])){i=d;return}b=db(16)|0;Ar();c[e>>2]=1;c[e+4>>2]=51280;o=0;Da(20,b|0,46873,e|0);e=o;o=0;if(e&1){e=Ya()|0;Xa(b|0);Ra(e|0)}else sb(b|0,616,40)}function Oh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0.0,f=0,g=0,h=0,j=0;j=i;h=i=i+63&-64;i=i+16|0;if((a|0)==(b|0)){c[d>>2]=4;e=0.0}else{f=Sq()|0;g=c[f>>2]|0;c[f>>2]=0;zq()|0;e=+bu(a,h);a=c[f>>2]|0;if(!a)c[f>>2]=g;if((c[h>>2]|0)==(b|0)){if((a|0)==34)c[d>>2]=4}else{c[d>>2]=4;e=0.0}}i=j;return +e}function Ph(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;h=i;f=i=i+63&-64;i=i+128|0;if((vf(b,0,102)|0)==(b+101|0)){ks(f);e=f+12|0;g=e+102|0;do{a[e>>0]=0;e=e+1|0}while((e|0)<(g|0));c=(Jf(f,c,d,b,f+12|0)|0)==0;up(f);if(!c){e=Li(f+12|0,b,102)|0;bl(f+12|0,102)}else e=-1}else e=-1;i=h;return e|0}function Qh(a,b){a=+a;b=b|0;var d=0,e=0,f=0;h[k>>3]=a;d=c[k>>2]|0;e=c[k+4>>2]|0;f=bo(d|0,e|0,52)|0;switch(f&2047|0){case 0:{if(a!=0.0){a=+Qh(a*18446744073709551616.0,b);d=(c[b>>2]|0)+-64|0}else d=0;c[b>>2]=d;break}case 2047:break;default:{c[b>>2]=(f&2047)+-1022;c[k>>2]=d;c[k+4>>2]=e&-2146435073|1071644672;a=+h[k>>3]}}return +a}function Rh(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;do if(!(c>>>0>64|(d+-1|0)>>>0>63)){if(d>>>0>=256)Wa(42169,42189,77,42361);if(c>>>0>=256)Wa(42268,42189,78,42361);if((b|0)==0|(c|0)==0){Oe(a,d&255,e,f);b=0;break}else{he(a,d&255,b,c&255,e,f);b=0;break}}else b=-1;while(0);return b|0}function Sh(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0;j=Ib[c[(c[b+8>>2]|0)+20>>2]&127](b+8|0)|0;i=a[j+8+3>>0]|0;k=i<<24>>24<0?c[j>>2]|0:j;return Cc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,k,k+((i<<24>>24<0?c[j+4>>2]|0:i&255)<<2)|0)|0}function Th(a,b,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;if(g>>>0>0|(g|0)==0&f>>>0>15){d=Jp(f|0,g|0,-16,-1)|0;i=ff(a,0,e,d,D,e+f+-16|0,h,i,j,k,l)|0}else i=-1;if(b|0){d=(i|0)==0;g=Jp(f|0,g|0,-16,-1)|0;c[b>>2]=d?g:0;c[b+4>>2]=d?D:0}return i|0}function Uh(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0;j=Ib[c[(c[b+8>>2]|0)+20>>2]&127](b+8|0)|0;i=a[j+11>>0]|0;k=i<<24>>24<0?c[j>>2]|0:j;return Bc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,k,k+(i<<24>>24<0?c[j+4>>2]|0:i&255)|0)|0}function Vh(a,b,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;if(g>>>0>0|(g|0)==0&f>>>0>15){d=Jp(f|0,g|0,-16,-1)|0;i=Nf(a,0,e,d,D,e+f+-16|0,h,i,j,k,l)|0}else i=-1;if(b|0){d=(i|0)==0;g=Jp(f|0,g|0,-16,-1)|0;c[b>>2]=d?g:0;c[b+4>>2]=d?D:0}return i|0}function Wh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=i=i+63&-64;i=i+112|0;c[g+32>>2]=0;c[g+32+4>>2]=0;c[g>>2]=c[8460];c[g+4>>2]=c[8461];c[g+8>>2]=c[8462];c[g+12>>2]=c[8463];c[g+16>>2]=c[8464];c[g+20>>2]=c[8465];c[g+24>>2]=c[8466];c[g+28>>2]=c[8467];oe(g,b,d,e)|0;Uf(g,a)|0;i=f;return 0}function Xh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;i=0;j=0;a:while(1){if((d|0)==(e|0)|j>>>0>=f>>>0)break;h=aq(c[a+8>>2]|0)|0;g=As(d,e-d|0,b)|0;if(h|0)aq(h)|0;switch(g|0){case -2:case -1:break a;case 0:{d=d+1|0;g=1;break}default:d=d+g|0}i=g+i|0;j=j+1|0}return i|0}function Yh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=i=i+63&-64;i=i+16|0;Vg(e,a+64|0,16);f=bo(c[a+72>>2]|0,c[a+72+4>>2]|0,3)|0;f=mo((0<0|0==0&(f&127)>>>0<112?112:240)|0,(0<0|0==0&(f&127)>>>0<112?0:0)|0,f&127|0,0)|0;Yd(a,42511,f,D)|0;Yd(a,e,16,0)|0;Vg(b,a,64);bl(a,208);i=d;return 0}function Zh(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if(c>>>0>0|(c|0)==0&b>>>0>4294967295)while(1){e=ym(b|0,c|0,10,0)|0;d=d+-1|0;a[d>>0]=e|48;e=b;b=bs(b|0,c|0,10,0)|0;if(!(c>>>0>9|(c|0)==9&e>>>0>4294967295))break;else c=D}if(b)while(1){d=d+-1|0;a[d>>0]=(b>>>0)%10|0|48;if(b>>>0<10)break;else b=(b>>>0)/10|0}return d|0}function _h(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0,g=0,h=0;h=i;g=i=i+63&-64;i=i+112|0;d=g;f=d+112|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(f|0));c[g+4>>2]=a;c[g+8>>2]=-1;c[g+44>>2]=a;c[g+76>>2]=-1;Ml(g,0);e=+gc(g,2,1);d=(c[g+4>>2]|0)-(c[g+8>>2]|0)+(c[g+108>>2]|0)|0;if(b|0)c[b>>2]=d|0?a+d|0:a;i=h;return +e}function $h(a,b){a=a|0;b=b|0;var d=0,e=0;if(!a){a=ec(b)|0;return a|0}if(b>>>0>4294967231){c[(Sq()|0)>>2]=12;a=0;return a|0}d=Wc(a+-8|0,b>>>0<11?16:b+11&-8)|0;if(d|0){a=d+8|0;return a|0}d=ec(b)|0;if(!d){a=0;return a|0}e=c[a+-4>>2]|0;e=(e&-8)-((e&3|0)==0?8:4)|0;bi(d|0,a|0,(e>>>0<b>>>0?e:b)|0)|0;nc(a);a=d;return a|0}function ai(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0;if(!e)c=0;else{f=a[b>>0]|0;a:do if(!(f<<24>>24))f=0;else while(1){e=e+-1|0;g=a[c>>0]|0;if(!(f<<24>>24==g<<24>>24&((e|0)!=0&g<<24>>24!=0)))break a;b=b+1|0;c=c+1|0;f=a[b>>0]|0;if(!(f<<24>>24)){f=0;break}}while(0);c=(f&255)-(d[c>>0]|0)|0}return c|0}function bi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return eb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if(!e)return f|0;a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function ci(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0;do if(!((b+-1|0)>>>0>63|g>>>0>64)){if(b>>>0>=256)Wa(42169,42189,36,42288);if(g>>>0<256){Sg(a,c,f,b&255,d,e,g&255,h,i);j=0;break}else Wa(42268,42189,37,42288)}else j=-1;while(0);return j|0}function di(b,d){b=b|0;d=d|0;var e=0,f=0;e=a[b+11>>0]|0;if(e<<24>>24<0)f=c[b+4>>2]|0;else f=e&255;do if(f>>>0>=d>>>0)if(e<<24>>24<0){a[(c[b>>2]|0)+d>>0]=0;c[b+4>>2]=d;break}else{a[b+d>>0]=0;a[b+11>>0]=d;break}else fh(b,d-f|0);while(0);return}function ei(b,c){b=b|0;c=c|0;var e=0,f=0;e=i;f=i=i+63&-64;i=i+160|0;td(f+80|0,c+80|0);ic(f+40|0,c,f+80|0);ic(f,c+40|0,f+80|0);Rd(b,f);Rd(f+120|0,f+40|0);a[b+31>>0]=(d[b+31>>0]|0)^(d[f+120>>0]|0)<<7;i=e;return}function fi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a=Ib[c[(c[a+8>>2]|0)+4>>2]&127](a+8|0)|0;d=(xc(d,e,a,a+288|0,g,f,0)|0)-a|0;if((d|0)<288)c[b>>2]=((d|0)/12|0|0)%12|0;return}function gi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a=Ib[c[(c[a+8>>2]|0)+4>>2]&127](a+8|0)|0;d=(zc(d,e,a,a+288|0,g,f,0)|0)-a|0;if((d|0)<288)c[b>>2]=((d|0)/12|0|0)%12|0;return}function hi(b,c,e,f){b=b|0;c=c|0;e=e|0;f=f|0;var g=0,h=0;if(!(f>>>0<2147483647&f<<1>>>0<c>>>0))Ta();if(!f)c=0;else{c=0;do{h=d[e+c>>0]|0;g=c<<1;a[b+g>>0]=(h>>>4)+87+(((h>>>4)+65526|0)>>>8&217);a[b+(g|1)>>0]=(((h&15)<<8)+22272+((h&15)+65526&55552)|0)>>>8;c=c+1|0}while((c|0)!=(f|0));c=f<<1}a[b+c>>0]=0;return b|0}function ii(b){b=b|0;var c=0,e=0;c=0;while(1){if((d[44433+c>>0]|0)==(b|0)){e=2;break}c=c+1|0;if((c|0)==87){c=87;b=44521;e=5;break}}if((e|0)==2)if(!c)c=44521;else{b=44521;e=5}if((e|0)==5)while(1){do{e=b;b=b+1|0}while((a[e>>0]|0)!=0);c=c+-1|0;if(!c){c=b;break}else e=5}return c|0}function ji(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;g=i;h=i=i+63&-64;i=i+208|0;c[h+64>>2]=0;c[h+64+4>>2]=0;c[h+64+8>>2]=0;c[h+64+12>>2]=0;f=h;j=400;k=f+64|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));Yd(h,b,d,e)|0;Yh(h,a)|0;i=g;return 0}function ki(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a=Ib[c[c[a+8>>2]>>2]&127](a+8|0)|0;d=(xc(d,e,a,a+168|0,g,f,0)|0)-a|0;if((d|0)<168)c[b>>2]=((d|0)/12|0|0)%7|0;return}function li(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a=Ib[c[c[a+8>>2]>>2]&127](a+8|0)|0;d=(zc(d,e,a,a+168|0,g,f,0)|0)-a|0;if((d|0)<168)c[b>>2]=((d|0)/12|0|0)%7|0;return}function mi(b){b=b|0;var d=0;d=a[b+74>>0]|0;a[b+74>>0]=d+255|d;if((c[b+20>>2]|0)>>>0>(c[b+44>>2]|0)>>>0)Kb[c[b+36>>2]&63](b,0,0)|0;c[b+16>>2]=0;c[b+28>>2]=0;c[b+20>>2]=0;d=c[b>>2]|0;if(d&20)if(!(d&4))d=-1;else{c[b>>2]=d|32;d=-1}else{d=c[b+44>>2]|0;c[b+8>>2]=d;c[b+4>>2]=d;d=0}return d|0}function ni(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if(e>>>0>4294967279)lk();if(e>>>0<11){a[b+11>>0]=e;if(e)f=6}else{f=Rj(e+16&-16)|0;c[b>>2]=f;c[b+8>>2]=e+16&-16|-2147483648;c[b+4>>2]=e;b=f;f=6}if((f|0)==6)bi(b|0,d|0,e|0)|0;a[b+e>>0]=0;return}function oi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if(d>>>0>4294967279)lk();if(d>>>0<11){a[b+11>>0]=d;if(d)f=6}else{f=Rj(d+16&-16)|0;c[b>>2]=f;c[b+8>>2]=d+16&-16|-2147483648;c[b+4>>2]=d;b=f;f=6}if((f|0)==6)Yi(b|0,e|0,d|0)|0;a[b+d>>0]=0;return}function pi(){var b=0,d=0,e=0;do if((c[8538]|0)>=0?(Zv()|0)!=0:0){if((a[34151]|0)!=10?(b=c[8524]|0,b>>>0<(c[8523]|0)>>>0):0){c[8524]=b+1;a[b>>0]=10;break}ih(34076,10)|0}else e=3;while(0);do if((e|0)==3){if((a[34151]|0)!=10?(d=c[8524]|0,d>>>0<(c[8523]|0)>>>0):0){c[8524]=d+1;a[d>>0]=10;break}ih(34076,10)|0}while(0);return}function qi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+4>>2]|0;e=c[a>>2]|0;a:do if(d-e>>2>>>0>=b>>>0){if(d-e>>2>>>0>b>>>0)while(1){if((d|0)==(e+(b<<2)|0))break a;f=d+-4|0;c[a+4>>2]=f;d=f}}else Gf(a,b-(d-e>>2)|0);while(0);return}function ri(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;do if(!(c>>>0>64|(d+-1|0)>>>0>63)){if(d>>>0>=256)Wa(42169,42189,53,42329);if(c>>>0>=256)Wa(42268,42189,54,42329);if((b|0)==0|(c|0)==0){dg(a,d&255);b=0;break}else{mf(a,d&255,b,c&255);b=0;break}}else b=-1;while(0);return b|0}function si(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=i=i+63&-64;i=i+112|0;c[h>>2]=0;c[h+4>>2]=a;c[h+44>>2]=a;c[h+8>>2]=(a|0)<0?-1:a+2147483647|0;c[h+76>>2]=-1;Ml(h,0);e=sc(h,d,1,e,f)|0;if(b|0)c[b>>2]=a+((c[h+4>>2]|0)+(c[h+108>>2]|0)-(c[h+8>>2]|0));i=g;return e|0}function ti(a){a=a|0;var b=0,d=0;if((c[a+20>>2]|0)>>>0>(c[a+28>>2]|0)>>>0?(Kb[c[a+36>>2]&63](a,0,0)|0,(c[a+20>>2]|0)==0):0)b=-1;else{b=c[a+4>>2]|0;d=c[a+8>>2]|0;if(b>>>0<d>>>0)Kb[c[a+40>>2]&63](a,b-d|0,1)|0;c[a+16>>2]=0;c[a+28>>2]=0;c[a+20>>2]=0;c[a+8>>2]=0;c[a+4>>2]=0;b=0}return b|0}function ui(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;b=c;while(1){if((e|0)==(f|0)){h=7;break}if((b|0)==(d|0)){e=-1;break}c=a[b>>0]|0;g=a[e>>0]|0;if(c<<24>>24<g<<24>>24){e=-1;break}if(g<<24>>24<c<<24>>24){e=1;break}e=e+1|0;b=b+1|0}if((h|0)==7)e=(b|0)!=(d|0)&1;return e|0}
function dc(e,f,g,h,j,k,l,m,n,p,q){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=i;D=i=i+63&-64;i=i+512|0;c[D+88>>2]=q;c[D+80>>2]=D+96;c[D+80+4>>2]=140;c[D+72>>2]=D+96;c[D+68>>2]=D+96+400;c[D+56>>2]=0;c[D+56+4>>2]=0;c[D+56+8>>2]=0;q=0;while(1){if((q|0)==3)break;c[D+56+(q<<2)>>2]=0;q=q+1|0}c[D+44>>2]=0;c[D+44+4>>2]=0;c[D+44+8>>2]=0;q=0;while(1){if((q|0)==3)break;c[D+44+(q<<2)>>2]=0;q=q+1|0}c[D+32>>2]=0;c[D+32+4>>2]=0;c[D+32+8>>2]=0;q=0;while(1){if((q|0)==3)break;c[D+32+(q<<2)>>2]=0;q=q+1|0}c[D+20>>2]=0;c[D+20+4>>2]=0;c[D+20+8>>2]=0;q=0;while(1){if((q|0)==3)break;c[D+20+(q<<2)>>2]=0;q=q+1|0}c[D+8>>2]=0;c[D+8+4>>2]=0;c[D+8+8>>2]=0;q=0;while(1){if((q|0)==3)break;c[D+8+(q<<2)>>2]=0;q=q+1|0}o=0;ta(18,g|0,h|0,D+500|0,D+497|0,D+496|0,D+56|0,D+44|0,D+32|0,D+20|0,D+4|0);B=o;o=0;a:do if(B&1)q=Ya()|0;else{c[p>>2]=c[n>>2];y=D+32+11|0;z=D+20+11|0;w=D+96|0;x=0;B=0;b:while(1){if(x>>>0>=4){A=249;break}q=c[e>>2]|0;do if(q){if((c[q+12>>2]|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=37;break b}if((q|0)==-1){c[e>>2]=0;q=0;break}else{q=c[e>>2]|0;break}}}else q=0;while(0);q=(q|0)==0;do if(f){if((c[f+12>>2]|0)!=(c[f+16>>2]|0))if(q)break;else{A=249;break b}o=0;g=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=37;break b}if((g|0)!=-1){if(!q){A=249;break b}}else A=30}else A=30;while(0);if((A|0)==30){A=0;if(q){f=0;A=249;break}else f=0}c:do switch(a[D+500+x>>0]|0){case 1:{if((x|0)!=3){q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;A=o;o=0;if(A&1){A=37;break b}}else q=d[g>>0]|0;if((q&255)<<24>>24<=-1){A=55;break b}if(!(b[(c[m+8>>2]|0)+(q<<24>>24<<1)>>1]&8192)){A=55;break b}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+40>>2]|0,q|0)|0;A=o;o=0;if(A&1){A=37;break b}}else{c[q+12>>2]=g+1;q=d[g>>0]|0}o=0;da(61,D+8|0,q&255|0);A=o;o=0;if(A&1){A=37;break b}else{q=f;r=f;A=57}}else{q=w;g=B}break}case 0:{if((x|0)==3){q=w;g=B}else{q=f;r=f;A=57}break}case 3:{g=a[y>>0]|0;q=g<<24>>24<0?c[D+32+4>>2]|0:g&255;h=a[z>>0]|0;r=h<<24>>24<0?c[D+20+4>>2]|0:h&255;if((q|0)==(0-r|0)){q=w;g=B}else{if(!q){q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=37;break b}h=a[z>>0]|0}else q=d[g>>0]|0;if((q&255)<<24>>24!=(a[(h<<24>>24<0?c[D+20>>2]|0:D+20|0)>>0]|0)){q=w;g=B;break c}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;ha(c[(c[q>>2]|0)+40>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=37;break b}g=a[z>>0]|0}else{c[q+12>>2]=g+1;g=h}a[l>>0]=1;q=w;g=(g<<24>>24<0?c[D+20+4>>2]|0:g&255)>>>0>1?D+20|0:B;break c}s=c[e>>2]|0;t=c[s+12>>2]|0;h=c[s+16>>2]|0;if(!r){if((t|0)==(h|0)){o=0;q=ha(c[(c[s>>2]|0)+36>>2]|0,s|0)|0;v=o;o=0;if(v&1){A=37;break b}h=a[y>>0]|0}else{q=d[t>>0]|0;h=g}if((q&255)<<24>>24!=(a[(h<<24>>24<0?c[D+32>>2]|0:D+32|0)>>0]|0)){a[l>>0]=1;q=w;g=B;break c}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;ha(c[(c[q>>2]|0)+40>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=37;break b}g=a[y>>0]|0}else{c[q+12>>2]=g+1;g=h}q=w;g=(g<<24>>24<0?c[D+32+4>>2]|0:g&255)>>>0>1?D+32|0:B;break c}if((t|0)==(h|0)){o=0;q=ha(c[(c[s>>2]|0)+36>>2]|0,s|0)|0;v=o;o=0;if(v&1){A=37;break b}h=c[e>>2]|0;g=a[y>>0]|0;s=h;t=c[h+12>>2]|0;h=c[h+16>>2]|0}else q=d[t>>0]|0;r=s+12|0;h=(t|0)==(h|0);if((q&255)<<24>>24==(a[(g<<24>>24<0?c[D+32>>2]|0:D+32|0)>>0]|0)){if(h){o=0;ha(c[(c[s>>2]|0)+40>>2]|0,s|0)|0;v=o;o=0;if(v&1){A=37;break b}g=a[y>>0]|0}else c[r>>2]=t+1;q=w;g=(g<<24>>24<0?c[D+32+4>>2]|0:g&255)>>>0>1?D+32|0:B;break c}if(h){o=0;q=ha(c[(c[s>>2]|0)+36>>2]|0,s|0)|0;v=o;o=0;if(v&1){A=37;break b}}else q=d[t>>0]|0;h=a[z>>0]|0;if((q&255)<<24>>24!=(a[(h<<24>>24<0?c[D+20>>2]|0:D+20|0)>>0]|0)){A=122;break b}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;ha(c[(c[q>>2]|0)+40>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=37;break b}g=a[z>>0]|0}else{c[q+12>>2]=g+1;g=h}a[l>>0]=1;q=w;g=(g<<24>>24<0?c[D+20+4>>2]|0:g&255)>>>0>1?D+20|0:B}break}case 2:{if(!(x>>>0<2|(B|0)!=0)?!((j&512|0)!=0|(x|0)==2&(a[D+500+3>>0]|0)!=0):0){q=w;g=0;break c}t=a[D+44+11>>0]|0;u=c[D+44>>2]|0;g=t<<24>>24<0?u:D+44|0;d:do if((x|0)!=0?(d[D+500+(x+-1)>>0]|0)<2:0){q=g+(t<<24>>24<0?c[D+44+4>>2]|0:t&255)|0;v=g;while(1){h=v;if((h|0)==(q|0))break;r=a[h>>0]|0;if(r<<24>>24<=-1)break;if(!(b[(c[m+8>>2]|0)+(r<<24>>24<<1)>>1]&8192))break;v=h+1|0}s=v-g|0;q=a[D+8+11>>0]|0;h=q<<24>>24<0?c[D+8+4>>2]|0:q&255;if(s>>>0<=h>>>0){r=(q<<24>>24<0?c[D+8>>2]|0:D+8|0)+h|0;h=g;q=r+(0-s)|0;while(1){if((q|0)==(r|0)){s=f;h=t;q=u;r=f;g=v;break d}if((a[q>>0]|0)!=(a[h>>0]|0)){s=f;h=t;q=u;r=f;break d}h=h+1|0;q=q+1|0}}else{s=f;h=t;q=u;r=f}}else{s=f;h=t;q=u;r=f}while(0);e:while(1){t=h<<24>>24<0;q=(t?q:D+44|0)+(t?c[D+44+4>>2]|0:h&255)|0;t=g;if((t|0)==(q|0))break;q=c[e>>2]|0;do if(q){if((c[q+12>>2]|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=34;break b}if((q|0)==-1){c[e>>2]=0;q=0;break}else{q=c[e>>2]|0;break}}}else q=0;while(0);g=(q|0)==0;do if(r){if((c[r+12>>2]|0)!=(c[r+16>>2]|0))if(g){h=s;break}else{q=t;break e}o=0;q=ha(c[(c[r>>2]|0)+36>>2]|0,r|0)|0;v=o;o=0;if(v&1){A=34;break b}if((q|0)!=-1)if(g^(s|0)==0){h=s;r=s}else{q=t;break e}else{q=0;f=0;A=149}}else{q=s;A=149}while(0);if((A|0)==149){A=0;if(g){q=t;break}else{h=q;r=0}}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=34;break b}}else q=d[g>>0]|0;if((q&255)<<24>>24!=(a[t>>0]|0)){q=t;break}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;ha(c[(c[q>>2]|0)+40>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=34;break b}}else c[q+12>>2]=g+1;s=h;h=a[D+44+11>>0]|0;q=c[D+44>>2]|0;g=t+1|0}if(j&512|0?(v=a[D+44+11>>0]|0,(q|0)!=((v<<24>>24<0?c[D+44>>2]|0:D+44|0)+(v<<24>>24<0?c[D+44+4>>2]|0:v&255)|0)):0){A=161;break b}else{q=w;g=B}break}case 4:{v=a[D+496>>0]|0;g=f;t=f;q=w;u=0;f:while(1){h=c[e>>2]|0;do if(h){if((c[h+12>>2]|0)==(c[h+16>>2]|0)){o=0;h=ha(c[(c[h>>2]|0)+36>>2]|0,h|0)|0;w=o;o=0;if(w&1){A=36;break b}if((h|0)==-1){c[e>>2]=0;h=0;break}else{h=c[e>>2]|0;break}}}else h=0;while(0);r=(h|0)==0;do if(t){if((c[t+12>>2]|0)!=(c[t+16>>2]|0))if(r){s=g;break}else{s=g;break f}o=0;h=ha(c[(c[t>>2]|0)+36>>2]|0,t|0)|0;w=o;o=0;if(w&1){A=36;break b}if((h|0)!=-1)if(r^(g|0)==0){s=g;t=g}else{s=g;break f}else{g=0;f=0;A=173}}else A=173;while(0);if((A|0)==173){A=0;if(r){s=g;break}else{s=g;t=0}}g=c[e>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0)){o=0;g=ha(c[(c[g>>2]|0)+36>>2]|0,g|0)|0;w=o;o=0;if(w&1){A=36;break b}}else g=d[h>>0]|0;h=g&255;if(h<<24>>24>-1?(b[(c[m+8>>2]|0)+(g<<24>>24<<1)>>1]&2048)!=0:0){g=c[p>>2]|0;if((g|0)==(c[D+88>>2]|0)){o=0;Da(21,n|0,p|0,D+88|0);w=o;o=0;if(w&1){A=36;break b}g=c[p>>2]|0}c[p>>2]=g+1;a[g>>0]=h;r=u+1|0}else{w=a[D+56+11>>0]|0;if(!(h<<24>>24==v<<24>>24&(u|0?((w<<24>>24<0?c[D+56+4>>2]|0:w&255)|0)!=0:0)))break;if((q|0)==(c[D+68>>2]|0)){o=0;Da(22,D+80|0,D+72|0,D+68|0);w=o;o=0;if(w&1){A=36;break b}q=c[D+72>>2]|0}r=q+4|0;c[D+72>>2]=r;c[q>>2]=u;q=r;r=0}g=c[e>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0)){o=0;ha(c[(c[g>>2]|0)+40>>2]|0,g|0)|0;w=o;o=0;if(w&1){A=36;break b}else{g=s;u=r;continue}}else{c[g+12>>2]=h+1;g=s;u=r;continue}}if(u|0?(c[D+80>>2]|0)!=(q|0):0){if((q|0)==(c[D+68>>2]|0)){o=0;Da(22,D+80|0,D+72|0,D+68|0);w=o;o=0;if(w&1){A=37;break b}q=c[D+72>>2]|0}w=q+4|0;c[D+72>>2]=w;c[q>>2]=u;q=w}r=c[D+4>>2]|0;g:do if((r|0)>0){g=c[e>>2]|0;do if(g){if((c[g+12>>2]|0)==(c[g+16>>2]|0)){o=0;g=ha(c[(c[g>>2]|0)+36>>2]|0,g|0)|0;w=o;o=0;if(w&1){A=37;break b}if((g|0)==-1){c[e>>2]=0;g=0;break}else{g=c[e>>2]|0;break}}}else g=0;while(0);h=(g|0)==0;do if(s){if((c[s+12>>2]|0)==(c[s+16>>2]|0)){o=0;g=ha(c[(c[s>>2]|0)+36>>2]|0,s|0)|0;w=o;o=0;if(w&1){A=37;break b}if((g|0)==-1){f=0;A=209;break}}if(!h){A=214;break b}}else A=209;while(0);if((A|0)==209){A=0;if(h){A=214;break b}else s=0}g=c[e>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0)){o=0;g=ha(c[(c[g>>2]|0)+36>>2]|0,g|0)|0;w=o;o=0;if(w&1){A=37;break b}}else g=d[h>>0]|0;if((g&255)<<24>>24!=(a[D+497>>0]|0)){A=214;break b}g=c[e>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0)){o=0;ha(c[(c[g>>2]|0)+40>>2]|0,g|0)|0;w=o;o=0;if(w&1){A=37;break b}else{g=s;t=s}}else{c[g+12>>2]=h+1;g=s;t=s}while(1){if((r|0)<=0)break g;h=c[e>>2]|0;do if(h){if((c[h+12>>2]|0)==(c[h+16>>2]|0)){o=0;h=ha(c[(c[h>>2]|0)+36>>2]|0,h|0)|0;w=o;o=0;if(w&1){A=35;break b}if((h|0)==-1){c[e>>2]=0;h=0;break}else{h=c[e>>2]|0;break}}}else h=0;while(0);s=(h|0)==0;do if(t){if((c[t+12>>2]|0)!=(c[t+16>>2]|0))if(s){s=g;break}else{A=237;break b}o=0;h=ha(c[(c[t>>2]|0)+36>>2]|0,t|0)|0;w=o;o=0;if(w&1){A=35;break b}if((h|0)==-1){g=0;f=0;A=230;break}if(s^(g|0)==0){s=g;t=g}else{A=237;break b}}else A=230;while(0);if((A|0)==230){A=0;if(s){A=237;break b}else{s=g;t=0}}g=c[e>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0)){o=0;g=ha(c[(c[g>>2]|0)+36>>2]|0,g|0)|0;w=o;o=0;if(w&1){A=35;break b}}else g=d[h>>0]|0;if((g&255)<<24>>24<=-1){A=237;break b}if(!(b[(c[m+8>>2]|0)+(g<<24>>24<<1)>>1]&2048)){A=237;break b}if((c[p>>2]|0)==(c[D+88>>2]|0)?(o=0,Da(21,n|0,p|0,D+88|0),w=o,o=0,w&1):0){A=35;break b}g=c[e>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0)){o=0;g=ha(c[(c[g>>2]|0)+36>>2]|0,g|0)|0;w=o;o=0;if(w&1){A=35;break b}}else g=d[h>>0]|0;h=c[p>>2]|0;c[p>>2]=h+1;a[h>>0]=g;r=r+-1|0;c[D+4>>2]=r;g=c[e>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0)){o=0;ha(c[(c[g>>2]|0)+40>>2]|0,g|0)|0;w=o;o=0;if(w&1){A=35;break b}else{g=s;continue}}else{c[g+12>>2]=h+1;g=s;continue}}}while(0);if((c[p>>2]|0)==(c[n>>2]|0)){A=247;break b}else g=B;break}default:{q=w;g=B}}while(0);h:do if((A|0)==57)while(1){A=0;g=c[e>>2]|0;do if(g){if((c[g+12>>2]|0)==(c[g+16>>2]|0)){o=0;g=ha(c[(c[g>>2]|0)+36>>2]|0,g|0)|0;v=o;o=0;if(v&1){A=33;break b}if((g|0)==-1){c[e>>2]=0;g=0;break}else{g=c[e>>2]|0;break}}}else g=0;while(0);h=(g|0)==0;do if(r){if((c[r+12>>2]|0)!=(c[r+16>>2]|0))if(h){h=q;break}else{q=w;g=B;break h}o=0;g=ha(c[(c[r>>2]|0)+36>>2]|0,r|0)|0;v=o;o=0;if(v&1){A=33;break b}if((g|0)!=-1)if(h^(q|0)==0){h=q;r=q}else{q=w;g=B;break h}else{q=0;f=0;A=68}}else A=68;while(0);if((A|0)==68){A=0;if(h){q=w;g=B;break h}else{h=q;r=0}}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=33;break b}}else q=d[g>>0]|0;if((q&255)<<24>>24<=-1){q=w;g=B;break h}if(!(b[(c[m+8>>2]|0)+(q<<24>>24<<1)>>1]&8192)){q=w;g=B;break h}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+40>>2]|0,q|0)|0;A=o;o=0;if(A&1){A=33;break b}}else{c[q+12>>2]=g+1;q=d[g>>0]|0}o=0;da(61,D+8|0,q&255|0);A=o;o=0;if(A&1){A=33;break b}else{q=h;A=57}}while(0);w=q;x=x+1|0;B=g}i:switch(A|0){case 33:{q=Ya()|0;break a}case 34:{q=Ya()|0;break a}case 35:{q=Ya()|0;break a}case 36:{q=Ya()|0;break a}case 37:{q=Ya()|0;break a}case 55:{c[k>>2]=c[k>>2]|4;q=0;break}case 122:{c[k>>2]=c[k>>2]|4;q=0;break}case 161:{c[k>>2]=c[k>>2]|4;q=0;break}case 214:{c[k>>2]=c[k>>2]|4;q=0;break}case 237:{c[k>>2]=c[k>>2]|4;q=0;break}case 247:{c[k>>2]=c[k>>2]|4;q=0;break}case 249:{j:do if(B|0){r=B+11|0;s=B+4|0;h=1;k:while(1){q=a[r>>0]|0;if(q<<24>>24<0)q=c[s>>2]|0;else q=q&255;if(h>>>0>=q>>>0)break j;q=c[e>>2]|0;do if(q){if((c[q+12>>2]|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;p=o;o=0;if(p&1){A=32;break k}if((q|0)==-1){c[e>>2]=0;q=0;break}else{q=c[e>>2]|0;break}}}else q=0;while(0);q=(q|0)==0;do if(f){if((c[f+12>>2]|0)==(c[f+16>>2]|0)){o=0;g=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;p=o;o=0;if(p&1){A=32;break k}if((g|0)==-1){A=266;break}}if(!q){A=273;break k}}else A=266;while(0);if((A|0)==266){A=0;if(q){A=273;break}else f=0}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;p=o;o=0;if(p&1){A=32;break}}else q=d[g>>0]|0;if((a[r>>0]|0)<0)g=c[B>>2]|0;else g=B;if((q&255)<<24>>24!=(a[g+h>>0]|0)){A=273;break}h=h+1|0;q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;ha(c[(c[q>>2]|0)+40>>2]|0,q|0)|0;p=o;o=0;if(p&1){A=32;break}else continue}else{c[q+12>>2]=g+1;continue}}if((A|0)==32){q=Ya()|0;break a}else if((A|0)==273){c[k>>2]=c[k>>2]|4;q=0;break i}}while(0);f=c[D+80>>2]|0;if((f|0)!=(w|0)){c[D>>2]=0;If(D+56|0,f,w,D);if(!(c[D>>2]|0)){q=1;break}else{c[k>>2]=c[k>>2]|4;q=0;break}}else q=1;break}}rq(D+8|0);rq(D+20|0);rq(D+32|0);rq(D+44|0);rq(D+56|0);f=c[D+80>>2]|0;c[D+80>>2]=0;if(f|0?(o=0,ba(c[D+80+4>>2]|0,f|0),D=o,o=0,D&1):0){D=Za(0)|0;lt(D)}i=C;return q|0}while(0);rq(D+8|0);rq(D+20|0);rq(D+32|0);rq(D+44|0);rq(D+56|0);f=c[D+80>>2]|0;c[D+80>>2]=0;if(f|0?(o=0,ba(c[D+80+4>>2]|0,f|0),D=o,o=0,D&1):0){D=Za(0)|0;lt(D)}Ra(q|0);return 0}function ec(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;G=i;o=i=i+63&-64;i=i+16|0;do if(a>>>0<245){p=a>>>0<11?16:a+11&-8;g=c[12696]|0;if(g>>>(p>>>3)&3|0){a=50824+((g>>>(p>>>3)&1^1)+(p>>>3)<<1<<2)|0;b=c[a+8>>2]|0;d=c[b+8>>2]|0;do if((a|0)!=(d|0)){if(d>>>0<(c[12700]|0)>>>0)Ta();if((c[d+12>>2]|0)==(b|0)){c[d+12>>2]=a;c[a+8>>2]=d;break}else Ta()}else c[12696]=g&~(1<<(g>>>(p>>>3)&1^1)+(p>>>3));while(0);F=(g>>>(p>>>3)&1^1)+(p>>>3)<<3;c[b+4>>2]=F|3;c[b+F+4>>2]=c[b+F+4>>2]|1;F=b+8|0;i=G;return F|0}b=c[12698]|0;if(p>>>0>b>>>0){if(g>>>(p>>>3)|0){a=g>>>(p>>>3)<<(p>>>3)&(2<<(p>>>3)|0-(2<<(p>>>3)));f=((a&0-a)+-1|0)>>>(((a&0-a)+-1|0)>>>12&16);e=f>>>(f>>>5&8)>>>(f>>>(f>>>5&8)>>>2&4);e=(f>>>5&8|((a&0-a)+-1|0)>>>12&16|f>>>(f>>>5&8)>>>2&4|e>>>1&2|e>>>(e>>>1&2)>>>1&1)+(e>>>(e>>>1&2)>>>(e>>>(e>>>1&2)>>>1&1))|0;f=c[50824+(e<<1<<2)+8>>2]|0;a=c[f+8>>2]|0;do if((50824+(e<<1<<2)|0)!=(a|0)){if(a>>>0<(c[12700]|0)>>>0)Ta();if((c[a+12>>2]|0)==(f|0)){c[a+12>>2]=50824+(e<<1<<2);c[50824+(e<<1<<2)+8>>2]=a;h=c[12698]|0;break}else Ta()}else{c[12696]=g&~(1<<e);h=b}while(0);c[f+4>>2]=p|3;c[f+p+4>>2]=(e<<3)-p|1;c[f+p+((e<<3)-p)>>2]=(e<<3)-p;if(h|0){d=c[12701]|0;b=h>>>3;a=c[12696]|0;if(a&1<<b){a=c[50824+(b<<1<<2)+8>>2]|0;if(a>>>0<(c[12700]|0)>>>0)Ta();else{j=50824+(b<<1<<2)+8|0;k=a}}else{c[12696]=a|1<<b;j=50824+(b<<1<<2)+8|0;k=50824+(b<<1<<2)|0}c[j>>2]=d;c[k+12>>2]=d;c[d+8>>2]=k;c[d+12>>2]=50824+(b<<1<<2)}c[12698]=(e<<3)-p;c[12701]=f+p;F=f+8|0;i=G;return F|0}a=c[12697]|0;if(a){j=((a&0-a)+-1|0)>>>(((a&0-a)+-1|0)>>>12&16);k=j>>>(j>>>5&8)>>>(j>>>(j>>>5&8)>>>2&4);k=c[51088+((j>>>5&8|((a&0-a)+-1|0)>>>12&16|j>>>(j>>>5&8)>>>2&4|k>>>1&2|k>>>(k>>>1&2)>>>1&1)+(k>>>(k>>>1&2)>>>(k>>>(k>>>1&2)>>>1&1))<<2)>>2]|0;j=(c[k+4>>2]&-8)-p|0;b=k;while(1){a=c[b+16>>2]|0;if(!a){a=c[b+20>>2]|0;if(!a)break}b=(c[a+4>>2]&-8)-p|0;F=b>>>0<j>>>0;j=F?b:j;b=a;k=F?a:k}f=c[12700]|0;if(k>>>0<f>>>0)Ta();h=k+p|0;if(k>>>0>=h>>>0)Ta();g=c[k+24>>2]|0;a=c[k+12>>2]|0;do if((a|0)==(k|0)){b=k+20|0;a=c[b>>2]|0;if(!a){b=k+16|0;a=c[b>>2]|0;if(!a){l=0;break}}while(1){d=a+20|0;e=c[d>>2]|0;if(e|0){a=e;b=d;continue}d=a+16|0;e=c[d>>2]|0;if(!e)break;else{a=e;b=d}}if(b>>>0<f>>>0)Ta();else{c[b>>2]=0;l=a;break}}else{b=c[k+8>>2]|0;if(b>>>0<f>>>0)Ta();if((c[b+12>>2]|0)!=(k|0))Ta();if((c[a+8>>2]|0)==(k|0)){c[b+12>>2]=a;c[a+8>>2]=b;l=a;break}else Ta()}while(0);do if(g|0){a=c[k+28>>2]|0;if((k|0)==(c[51088+(a<<2)>>2]|0)){c[51088+(a<<2)>>2]=l;if(!l){c[12697]=c[12697]&~(1<<a);break}}else{if(g>>>0<(c[12700]|0)>>>0)Ta();if((c[g+16>>2]|0)==(k|0))c[g+16>>2]=l;else c[g+20>>2]=l;if(!l)break}b=c[12700]|0;if(l>>>0<b>>>0)Ta();c[l+24>>2]=g;a=c[k+16>>2]|0;do if(a|0)if(a>>>0<b>>>0)Ta();else{c[l+16>>2]=a;c[a+24>>2]=l;break}while(0);a=c[k+20>>2]|0;if(a|0)if(a>>>0<(c[12700]|0)>>>0)Ta();else{c[l+20>>2]=a;c[a+24>>2]=l;break}}while(0);if(j>>>0<16){F=j+p|0;c[k+4>>2]=F|3;F=k+F+4|0;c[F>>2]=c[F>>2]|1}else{c[k+4>>2]=p|3;c[h+4>>2]=j|1;c[h+j>>2]=j;b=c[12698]|0;if(b|0){d=c[12701]|0;a=c[12696]|0;if(a&1<<(b>>>3)){a=c[50824+(b>>>3<<1<<2)+8>>2]|0;if(a>>>0<(c[12700]|0)>>>0)Ta();else{m=50824+(b>>>3<<1<<2)+8|0;n=a}}else{c[12696]=a|1<<(b>>>3);m=50824+(b>>>3<<1<<2)+8|0;n=50824+(b>>>3<<1<<2)|0}c[m>>2]=d;c[n+12>>2]=d;c[d+8>>2]=n;c[d+12>>2]=50824+(b>>>3<<1<<2)}c[12698]=j;c[12701]=h}F=k+8|0;i=G;return F|0}}}else if(a>>>0<=4294967231){p=a+11&-8;j=c[12697]|0;if(j){if((a+11|0)>>>8)if(p>>>0>16777215)h=31;else{h=(a+11|0)>>>8<<((((a+11|0)>>>8)+1048320|0)>>>16&8);h=14-((h+520192|0)>>>16&4|(((a+11|0)>>>8)+1048320|0)>>>16&8|((h<<((h+520192|0)>>>16&4))+245760|0)>>>16&2)+(h<<((h+520192|0)>>>16&4)<<(((h<<((h+520192|0)>>>16&4))+245760|0)>>>16&2)>>>15)|0;h=p>>>(h+7|0)&1|h<<1}else h=0;b=c[51088+(h<<2)>>2]|0;a:do if(!b){d=0-p|0;a=0;b=0;y=86}else{d=0-p|0;a=0;f=p<<((h|0)==31?0:25-(h>>>1)|0);g=b;b=0;while(1){e=c[g+4>>2]&-8;if((e-p|0)>>>0<d>>>0)if((e|0)==(p|0)){d=e-p|0;a=g;b=g;y=90;break a}else{d=e-p|0;b=g}e=c[g+20>>2]|0;g=c[g+16+(f>>>31<<2)>>2]|0;a=(e|0)==0|(e|0)==(g|0)?a:e;e=(g|0)==0;if(e){y=86;break}else f=f<<(e&1^1)}}while(0);if((y|0)==86){if((a|0)==0&(b|0)==0){a=2<<h;if(!(j&(a|0-a)))break;m=(j&(a|0-a)&0-(j&(a|0-a)))+-1|0;n=m>>>(m>>>12&16)>>>(m>>>(m>>>12&16)>>>5&8);a=n>>>(n>>>2&4)>>>(n>>>(n>>>2&4)>>>1&2);a=c[51088+((m>>>(m>>>12&16)>>>5&8|m>>>12&16|n>>>2&4|n>>>(n>>>2&4)>>>1&2|a>>>1&1)+(a>>>(a>>>1&1))<<2)>>2]|0}if(!a){j=d;k=b}else y=90}if((y|0)==90)while(1){y=0;n=(c[a+4>>2]&-8)-p|0;e=n>>>0<d>>>0;d=e?n:d;b=e?a:b;e=c[a+16>>2]|0;if(e|0){a=e;y=90;continue}a=c[a+20>>2]|0;if(!a){j=d;k=b;break}else y=90}if((k|0)!=0?j>>>0<((c[12698]|0)-p|0)>>>0:0){f=c[12700]|0;if(k>>>0<f>>>0)Ta();h=k+p|0;if(k>>>0>=h>>>0)Ta();g=c[k+24>>2]|0;a=c[k+12>>2]|0;do if((a|0)==(k|0)){b=k+20|0;a=c[b>>2]|0;if(!a){b=k+16|0;a=c[b>>2]|0;if(!a){r=0;break}}while(1){d=a+20|0;e=c[d>>2]|0;if(e|0){a=e;b=d;continue}d=a+16|0;e=c[d>>2]|0;if(!e)break;else{a=e;b=d}}if(b>>>0<f>>>0)Ta();else{c[b>>2]=0;r=a;break}}else{b=c[k+8>>2]|0;if(b>>>0<f>>>0)Ta();if((c[b+12>>2]|0)!=(k|0))Ta();if((c[a+8>>2]|0)==(k|0)){c[b+12>>2]=a;c[a+8>>2]=b;r=a;break}else Ta()}while(0);do if(g|0){a=c[k+28>>2]|0;if((k|0)==(c[51088+(a<<2)>>2]|0)){c[51088+(a<<2)>>2]=r;if(!r){c[12697]=c[12697]&~(1<<a);break}}else{if(g>>>0<(c[12700]|0)>>>0)Ta();if((c[g+16>>2]|0)==(k|0))c[g+16>>2]=r;else c[g+20>>2]=r;if(!r)break}b=c[12700]|0;if(r>>>0<b>>>0)Ta();c[r+24>>2]=g;a=c[k+16>>2]|0;do if(a|0)if(a>>>0<b>>>0)Ta();else{c[r+16>>2]=a;c[a+24>>2]=r;break}while(0);a=c[k+20>>2]|0;if(a|0)if(a>>>0<(c[12700]|0)>>>0)Ta();else{c[r+20>>2]=a;c[a+24>>2]=r;break}}while(0);do if(j>>>0>=16){c[k+4>>2]=p|3;c[h+4>>2]=j|1;c[h+j>>2]=j;b=j>>>3;if(j>>>0<256){a=c[12696]|0;if(a&1<<b){a=c[50824+(b<<1<<2)+8>>2]|0;if(a>>>0<(c[12700]|0)>>>0)Ta();else{s=50824+(b<<1<<2)+8|0;t=a}}else{c[12696]=a|1<<b;s=50824+(b<<1<<2)+8|0;t=50824+(b<<1<<2)|0}c[s>>2]=h;c[t+12>>2]=h;c[h+8>>2]=t;c[h+12>>2]=50824+(b<<1<<2);break}a=j>>>8;if(a)if(j>>>0>16777215)d=31;else{d=a<<((a+1048320|0)>>>16&8)<<(((a<<((a+1048320|0)>>>16&8))+520192|0)>>>16&4);d=14-(((a<<((a+1048320|0)>>>16&8))+520192|0)>>>16&4|(a+1048320|0)>>>16&8|(d+245760|0)>>>16&2)+(d<<((d+245760|0)>>>16&2)>>>15)|0;d=j>>>(d+7|0)&1|d<<1}else d=0;e=51088+(d<<2)|0;c[h+28>>2]=d;c[h+16+4>>2]=0;c[h+16>>2]=0;a=c[12697]|0;b=1<<d;if(!(a&b)){c[12697]=a|b;c[e>>2]=h;c[h+24>>2]=e;c[h+12>>2]=h;c[h+8>>2]=h;break}d=j<<((d|0)==31?0:25-(d>>>1)|0);e=c[e>>2]|0;while(1){if((c[e+4>>2]&-8|0)==(j|0)){y=148;break}b=e+16+(d>>>31<<2)|0;a=c[b>>2]|0;if(!a){y=145;break}else{d=d<<1;e=a}}if((y|0)==145)if(b>>>0<(c[12700]|0)>>>0)Ta();else{c[b>>2]=h;c[h+24>>2]=e;c[h+12>>2]=h;c[h+8>>2]=h;break}else if((y|0)==148){a=e+8|0;b=c[a>>2]|0;F=c[12700]|0;if(b>>>0>=F>>>0&e>>>0>=F>>>0){c[b+12>>2]=h;c[a>>2]=h;c[h+8>>2]=b;c[h+12>>2]=e;c[h+24>>2]=0;break}else Ta()}}else{F=j+p|0;c[k+4>>2]=F|3;F=k+F+4|0;c[F>>2]=c[F>>2]|1}while(0);F=k+8|0;i=G;return F|0}}}else p=-1;while(0);d=c[12698]|0;if(d>>>0>=p>>>0){a=d-p|0;b=c[12701]|0;if(a>>>0>15){F=b+p|0;c[12701]=F;c[12698]=a;c[F+4>>2]=a|1;c[F+a>>2]=a;c[b+4>>2]=p|3}else{c[12698]=0;c[12701]=0;c[b+4>>2]=d|3;c[b+d+4>>2]=c[b+d+4>>2]|1}F=b+8|0;i=G;return F|0}a=c[12699]|0;if(a>>>0>p>>>0){D=a-p|0;c[12699]=D;F=c[12702]|0;E=F+p|0;c[12702]=E;c[E+4>>2]=D|1;c[F+4>>2]=p|3;F=F+8|0;i=G;return F|0}if(!(c[12814]|0)){c[12816]=4096;c[12815]=4096;c[12817]=-1;c[12818]=-1;c[12819]=0;c[12807]=0;c[o>>2]=o&-16^1431655768;c[12814]=o&-16^1431655768}f=p+48|0;d=c[12816]|0;g=p+47|0;h=d+g&0-d;if(h>>>0<=p>>>0){F=0;i=G;return F|0}a=c[12806]|0;if(a|0?(t=c[12804]|0,(t+h|0)>>>0<=t>>>0|(t+h|0)>>>0>a>>>0):0){F=0;i=G;return F|0}b:do if(!(c[12807]&4)){b=c[12702]|0;c:do if(b){e=51232;while(1){a=c[e>>2]|0;if(a>>>0<=b>>>0?(q=e+4|0,(a+(c[q>>2]|0)|0)>>>0>b>>>0):0)break;a=c[e+8>>2]|0;if(!a){y=171;break c}else e=a}a=d+g-(c[12699]|0)&0-d;if(a>>>0<2147483647){b=cb(a|0)|0;if((b|0)==((c[e>>2]|0)+(c[q>>2]|0)|0)){if((b|0)!=(-1|0)){h=b;g=a;y=191;break b}}else y=181}}else y=171;while(0);do if((y|0)==171?(u=cb(0)|0,(u|0)!=(-1|0)):0){a=c[12815]|0;if(!(a+-1&u))a=h;else a=h-u+(a+-1+u&0-a)|0;b=c[12804]|0;d=b+a|0;if(a>>>0>p>>>0&a>>>0<2147483647){t=c[12806]|0;if(t|0?d>>>0<=b>>>0|d>>>0>t>>>0:0)break;b=cb(a|0)|0;if((b|0)==(u|0)){h=u;g=a;y=191;break b}else y=181}}while(0);d:do if((y|0)==181){d=0-a|0;do if(f>>>0>a>>>0&(a>>>0<2147483647&(b|0)!=(-1|0))?(v=c[12816]|0,v=g-a+v&0-v,v>>>0<2147483647):0)if((cb(v|0)|0)==(-1|0)){cb(d|0)|0;break d}else{a=v+a|0;break}while(0);if((b|0)!=(-1|0)){h=b;g=a;y=191;break b}}while(0);c[12807]=c[12807]|4;y=188}else y=188;while(0);if((((y|0)==188?h>>>0<2147483647:0)?(w=cb(h|0)|0,x=cb(0)|0,w>>>0<x>>>0&((w|0)!=(-1|0)&(x|0)!=(-1|0))):0)?(x-w|0)>>>0>(p+40|0)>>>0:0){h=w;g=x-w|0;y=191}if((y|0)==191){a=(c[12804]|0)+g|0;c[12804]=a;if(a>>>0>(c[12805]|0)>>>0)c[12805]=a;l=c[12702]|0;do if(l){f=51232;while(1){a=c[f>>2]|0;b=f+4|0;d=c[b>>2]|0;if((h|0)==(a+d|0)){y=201;break}e=c[f+8>>2]|0;if(!e)break;else f=e}if(((y|0)==201?(c[f+12>>2]&8|0)==0:0)?l>>>0<h>>>0&l>>>0>=a>>>0:0){c[b>>2]=d+g;E=(l+8&7|0)==0?0:0-(l+8)&7;F=g-E+(c[12699]|0)|0;c[12702]=l+E;c[12699]=F;c[l+E+4>>2]=F|1;c[l+E+F+4>>2]=40;c[12703]=c[12818];break}a=c[12700]|0;if(h>>>0<a>>>0){c[12700]=h;k=h}else k=a;b=h+g|0;a=51232;while(1){if((c[a>>2]|0)==(b|0)){y=209;break}a=c[a+8>>2]|0;if(!a){b=51232;break}}if((y|0)==209)if(!(c[a+12>>2]&8)){c[a>>2]=h;n=a+4|0;c[n>>2]=(c[n>>2]|0)+g;n=h+8|0;n=h+((n&7|0)==0?0:0-n&7)|0;a=b+((b+8&7|0)==0?0:0-(b+8)&7)|0;m=n+p|0;j=a-n-p|0;c[n+4>>2]=p|3;do if((a|0)!=(l|0)){if((a|0)==(c[12701]|0)){F=(c[12698]|0)+j|0;c[12698]=F;c[12701]=m;c[m+4>>2]=F|1;c[m+F>>2]=F;break}h=c[a+4>>2]|0;if((h&3|0)==1){e:do if(h>>>0>=256){g=c[a+24>>2]|0;b=c[a+12>>2]|0;do if((b|0)==(a|0)){b=c[a+16+4>>2]|0;if(!b){b=c[a+16>>2]|0;if(!b){D=0;break}else f=a+16|0}else f=a+16+4|0;while(1){d=b+20|0;e=c[d>>2]|0;if(e|0){b=e;f=d;continue}d=b+16|0;e=c[d>>2]|0;if(!e)break;else{b=e;f=d}}if(f>>>0<k>>>0)Ta();else{c[f>>2]=0;D=b;break}}else{d=c[a+8>>2]|0;if(d>>>0<k>>>0)Ta();if((c[d+12>>2]|0)!=(a|0))Ta();if((c[b+8>>2]|0)==(a|0)){c[d+12>>2]=b;c[b+8>>2]=d;D=b;break}else Ta()}while(0);if(!g)break;b=c[a+28>>2]|0;do if((a|0)!=(c[51088+(b<<2)>>2]|0)){if(g>>>0<(c[12700]|0)>>>0)Ta();if((c[g+16>>2]|0)==(a|0))c[g+16>>2]=D;else c[g+20>>2]=D;if(!D)break e}else{c[51088+(b<<2)>>2]=D;if(D|0)break;c[12697]=c[12697]&~(1<<b);break e}while(0);d=c[12700]|0;if(D>>>0<d>>>0)Ta();c[D+24>>2]=g;b=c[a+16>>2]|0;do if(b|0)if(b>>>0<d>>>0)Ta();else{c[D+16>>2]=b;c[b+24>>2]=D;break}while(0);b=c[a+16+4>>2]|0;if(!b)break;if(b>>>0<(c[12700]|0)>>>0)Ta();else{c[D+20>>2]=b;c[b+24>>2]=D;break}}else{b=c[a+8>>2]|0;d=c[a+12>>2]|0;do if((b|0)!=(50824+(h>>>3<<1<<2)|0)){if(b>>>0<k>>>0)Ta();if((c[b+12>>2]|0)==(a|0))break;Ta()}while(0);if((d|0)==(b|0)){c[12696]=c[12696]&~(1<<(h>>>3));break}do if((d|0)==(50824+(h>>>3<<1<<2)|0))B=d+8|0;else{if(d>>>0<k>>>0)Ta();if((c[d+8>>2]|0)==(a|0)){B=d+8|0;break}Ta()}while(0);c[b+12>>2]=d;c[B>>2]=b}while(0);a=a+(h&-8)|0;f=(h&-8)+j|0}else f=j;b=a+4|0;c[b>>2]=c[b>>2]&-2;c[m+4>>2]=f|1;c[m+f>>2]=f;b=f>>>3;if(f>>>0<256){a=c[12696]|0;do if(!(a&1<<b)){c[12696]=a|1<<b;E=50824+(b<<1<<2)+8|0;F=50824+(b<<1<<2)|0}else{a=c[50824+(b<<1<<2)+8>>2]|0;if(a>>>0>=(c[12700]|0)>>>0){E=50824+(b<<1<<2)+8|0;F=a;break}Ta()}while(0);c[E>>2]=m;c[F+12>>2]=m;c[m+8>>2]=F;c[m+12>>2]=50824+(b<<1<<2);break}a=f>>>8;do if(!a)d=0;else{if(f>>>0>16777215){d=31;break}d=a<<((a+1048320|0)>>>16&8)<<(((a<<((a+1048320|0)>>>16&8))+520192|0)>>>16&4);d=14-(((a<<((a+1048320|0)>>>16&8))+520192|0)>>>16&4|(a+1048320|0)>>>16&8|(d+245760|0)>>>16&2)+(d<<((d+245760|0)>>>16&2)>>>15)|0;d=f>>>(d+7|0)&1|d<<1}while(0);e=51088+(d<<2)|0;c[m+28>>2]=d;c[m+16+4>>2]=0;c[m+16>>2]=0;a=c[12697]|0;b=1<<d;if(!(a&b)){c[12697]=a|b;c[e>>2]=m;c[m+24>>2]=e;c[m+12>>2]=m;c[m+8>>2]=m;break}d=f<<((d|0)==31?0:25-(d>>>1)|0);e=c[e>>2]|0;while(1){if((c[e+4>>2]&-8|0)==(f|0)){y=279;break}b=e+16+(d>>>31<<2)|0;a=c[b>>2]|0;if(!a){y=276;break}else{d=d<<1;e=a}}if((y|0)==276)if(b>>>0<(c[12700]|0)>>>0)Ta();else{c[b>>2]=m;c[m+24>>2]=e;c[m+12>>2]=m;c[m+8>>2]=m;break}else if((y|0)==279){a=e+8|0;b=c[a>>2]|0;F=c[12700]|0;if(b>>>0>=F>>>0&e>>>0>=F>>>0){c[b+12>>2]=m;c[a>>2]=m;c[m+8>>2]=b;c[m+12>>2]=e;c[m+24>>2]=0;break}else Ta()}}else{F=(c[12699]|0)+j|0;c[12699]=F;c[12702]=m;c[m+4>>2]=F|1}while(0);F=n+8|0;i=G;return F|0}else b=51232;while(1){a=c[b>>2]|0;if(a>>>0<=l>>>0?(z=a+(c[b+4>>2]|0)|0,z>>>0>l>>>0):0)break;b=c[b+8>>2]|0}f=z+-47+((z+-47+8&7|0)==0?0:0-(z+-47+8)&7)|0;f=f>>>0<(l+16|0)>>>0?l:f;a=h+8|0;a=(a&7|0)==0?0:0-a&7;F=h+a|0;a=g+-40-a|0;c[12702]=F;c[12699]=a;c[F+4>>2]=a|1;c[F+a+4>>2]=40;c[12703]=c[12818];c[f+4>>2]=27;c[f+8>>2]=c[12808];c[f+8+4>>2]=c[12809];c[f+8+8>>2]=c[12810];c[f+8+12>>2]=c[12811];c[12808]=h;c[12809]=g;c[12811]=0;c[12810]=f+8;a=f+24|0;do{a=a+4|0;c[a>>2]=7}while((a+4|0)>>>0<z>>>0);if((f|0)!=(l|0)){c[f+4>>2]=c[f+4>>2]&-2;c[l+4>>2]=f-l|1;c[f>>2]=f-l;if((f-l|0)>>>0<256){b=50824+((f-l|0)>>>3<<1<<2)|0;a=c[12696]|0;if(a&1<<((f-l|0)>>>3)){a=c[b+8>>2]|0;if(a>>>0<(c[12700]|0)>>>0)Ta();else{A=b+8|0;C=a}}else{c[12696]=a|1<<((f-l|0)>>>3);A=b+8|0;C=b}c[A>>2]=l;c[C+12>>2]=l;c[l+8>>2]=C;c[l+12>>2]=b;break}if((f-l|0)>>>8)if((f-l|0)>>>0>16777215)d=31;else{d=(f-l|0)>>>8<<((((f-l|0)>>>8)+1048320|0)>>>16&8);d=14-((d+520192|0)>>>16&4|(((f-l|0)>>>8)+1048320|0)>>>16&8|((d<<((d+520192|0)>>>16&4))+245760|0)>>>16&2)+(d<<((d+520192|0)>>>16&4)<<(((d<<((d+520192|0)>>>16&4))+245760|0)>>>16&2)>>>15)|0;d=(f-l|0)>>>(d+7|0)&1|d<<1}else d=0;e=51088+(d<<2)|0;c[l+28>>2]=d;c[l+20>>2]=0;c[l+16>>2]=0;a=c[12697]|0;b=1<<d;if(!(a&b)){c[12697]=a|b;c[e>>2]=l;c[l+24>>2]=e;c[l+12>>2]=l;c[l+8>>2]=l;break}d=f-l<<((d|0)==31?0:25-(d>>>1)|0);e=c[e>>2]|0;while(1){if((c[e+4>>2]&-8|0)==(f-l|0)){y=305;break}b=e+16+(d>>>31<<2)|0;a=c[b>>2]|0;if(!a){y=302;break}else{d=d<<1;e=a}}if((y|0)==302)if(b>>>0<(c[12700]|0)>>>0)Ta();else{c[b>>2]=l;c[l+24>>2]=e;c[l+12>>2]=l;c[l+8>>2]=l;break}else if((y|0)==305){a=e+8|0;b=c[a>>2]|0;F=c[12700]|0;if(b>>>0>=F>>>0&e>>>0>=F>>>0){c[b+12>>2]=l;c[a>>2]=l;c[l+8>>2]=b;c[l+12>>2]=e;c[l+24>>2]=0;break}else Ta()}}}else{F=c[12700]|0;if((F|0)==0|h>>>0<F>>>0)c[12700]=h;c[12808]=h;c[12809]=g;c[12811]=0;c[12705]=c[12814];c[12704]=-1;a=0;do{F=50824+(a<<1<<2)|0;c[F+12>>2]=F;c[F+8>>2]=F;a=a+1|0}while((a|0)!=32);F=h+8|0;F=(F&7|0)==0?0:0-F&7;E=h+F|0;F=g+-40-F|0;c[12702]=E;c[12699]=F;c[E+4>>2]=F|1;c[E+F+4>>2]=40;c[12703]=c[12818]}while(0);a=c[12699]|0;if(a>>>0>p>>>0){D=a-p|0;c[12699]=D;F=c[12702]|0;E=F+p|0;c[12702]=E;c[E+4>>2]=D|1;c[F+4>>2]=p|3;F=F+8|0;i=G;return F|0}}c[(Sq()|0)>>2]=12;F=0;i=G;return F|0}function fc(b){b=b|0;var c=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0;e=d[b>>0]|0;j=_n(d[b+1>>0]|0|0,0,8)|0;S=D;_=d[b+2>>0]|0;x=_n(_|0,0,16)|0;Z=_n(d[b+3>>0]|0|0,0,8)|0;C=D;Y=_n(d[b+4>>0]|0|0,0,16)|0;C=C|D;m=d[b+5>>0]|0;n=_n(m|0,0,24)|0;C=bo(Z|_|Y|n|0,C|D|0,5)|0;n=_n(d[b+6>>0]|0|0,0,8)|0;Y=D;_=d[b+7>>0]|0;Z=_n(_|0,0,16)|0;Y=bo(n|m|Z|0,Y|D|0,2)|0;Z=_n(d[b+8>>0]|0|0,0,8)|0;m=D;n=_n(d[b+9>>0]|0|0,0,16)|0;m=m|D;na=d[b+10>>0]|0;va=_n(na|0,0,24)|0;m=bo(Z|_|n|va|0,m|D|0,7)|0;va=_n(d[b+11>>0]|0|0,0,8)|0;n=D;_=_n(d[b+12>>0]|0|0,0,16)|0;n=n|D;Z=d[b+13>>0]|0;oa=_n(Z|0,0,24)|0;n=bo(va|na|_|oa|0,n|D|0,4)|0;oa=_n(d[b+14>>0]|0|0,0,8)|0;_=D;na=d[b+15>>0]|0;va=_n(na|0,0,16)|0;_=bo(oa|Z|va|0,_|D|0,1)|0;va=_n(d[b+16>>0]|0|0,0,8)|0;Z=D;oa=_n(d[b+17>>0]|0|0,0,16)|0;Z=Z|D;xa=d[b+18>>0]|0;ya=_n(xa|0,0,24)|0;Z=bo(va|na|oa|ya|0,Z|D|0,6)|0;ya=_n(d[b+19>>0]|0|0,0,8)|0;oa=D;na=_n(d[b+20>>0]|0|0,0,16)|0;oa=bo(ya|xa|na|0,oa|D|0,3)|0;na=D;xa=d[b+21>>0]|0;ya=_n(d[b+22>>0]|0|0,0,8)|0;va=D;N=d[b+23>>0]|0;wa=_n(N|0,0,16)|0;U=_n(d[b+24>>0]|0|0,0,8)|0;ka=D;ua=_n(d[b+25>>0]|0|0,0,16)|0;ka=ka|D;fa=d[b+26>>0]|0;Ca=_n(fa|0,0,24)|0;ka=bo(U|N|ua|Ca|0,ka|D|0,5)|0;Ca=_n(d[b+27>>0]|0|0,0,8)|0;ua=D;N=d[b+28>>0]|0;U=_n(N|0,0,16)|0;ua=bo(Ca|fa|U|0,ua|D|0,2)|0;U=_n(d[b+29>>0]|0|0,0,8)|0;fa=D;Ca=_n(d[b+30>>0]|0|0,0,16)|0;fa=fa|D;A=d[b+31>>0]|0;g=_n(A|0,0,24)|0;fa=bo(U|N|Ca|g|0,fa|D|0,7)|0;g=_n(d[b+32>>0]|0|0,0,8)|0;Ca=D;N=_n(d[b+33>>0]|0|0,0,16)|0;Ca=Ca|D;U=d[b+34>>0]|0;I=_n(U|0,0,24)|0;Ca=bo(g|A|N|I|0,Ca|D|0,4)|0;I=_n(d[b+35>>0]|0|0,0,8)|0;N=D;A=d[b+36>>0]|0;g=_n(A|0,0,16)|0;N=bo(I|U|g|0,N|D|0,1)|0;g=_n(d[b+37>>0]|0|0,0,8)|0;U=D;I=_n(d[b+38>>0]|0|0,0,16)|0;U=U|D;K=d[b+39>>0]|0;L=_n(K|0,0,24)|0;U=bo(g|A|I|L|0,U|D|0,6)|0;L=_n(d[b+40>>0]|0|0,0,8)|0;I=D;A=_n(d[b+41>>0]|0|0,0,16)|0;I=bo(L|K|A|0,I|D|0,3)|0;A=D;K=d[b+42>>0]|0;L=_n(d[b+43>>0]|0|0,0,8)|0;g=D;X=d[b+44>>0]|0;W=_n(X|0,0,16)|0;G=_n(d[b+45>>0]|0|0,0,8)|0;t=D;ha=_n(d[b+46>>0]|0|0,0,16)|0;t=t|D;Da=d[b+47>>0]|0;u=_n(Da|0,0,24)|0;t=bo(G|X|ha|u|0,t|D|0,5)|0;u=_n(d[b+48>>0]|0|0,0,8)|0;ha=D;X=d[b+49>>0]|0;G=_n(X|0,0,16)|0;ha=bo(u|Da|G|0,ha|D|0,2)|0;G=_n(d[b+50>>0]|0|0,0,8)|0;Da=D;u=_n(d[b+51>>0]|0|0,0,16)|0;Da=Da|D;s=d[b+52>>0]|0;q=_n(s|0,0,24)|0;Da=bo(G|X|u|q|0,Da|D|0,7)|0;q=_n(d[b+53>>0]|0|0,0,8)|0;u=D;X=_n(d[b+54>>0]|0|0,0,16)|0;u=u|D;G=d[b+55>>0]|0;f=_n(G|0,0,24)|0;u=bo(q|s|X|f|0,u|D|0,4)|0;f=_n(d[b+56>>0]|0|0,0,8)|0;X=D;s=d[b+57>>0]|0;q=_n(s|0,0,16)|0;X=bo(f|G|q|0,X|D|0,1)|0;q=_n(d[b+58>>0]|0|0,0,8)|0;G=D;f=_n(d[b+59>>0]|0|0,0,16)|0;G=G|D;E=d[b+60>>0]|0;v=_n(E|0,0,24)|0;G=bo(q|s|f|v|0,G|D|0,6)|0;v=_n(d[b+61>>0]|0|0,0,8)|0;f=D;s=_n(d[b+62>>0]|0|0,0,16)|0;f=f|D;q=_n(d[b+63>>0]|0|0,0,24)|0;f=bo(v|E|s|q|0,f|D|0,3)|0;q=D;s=_m(f|0,q|0,666643,0)|0;E=D;v=_m(f|0,q|0,470296,0)|0;o=D;B=_m(f|0,q|0,654183,0)|0;Q=D;$=_m(f|0,q|0,-997805,-1)|0;i=D;h=_m(f|0,q|0,136657,0)|0;p=D;q=_m(f|0,q|0,-683901,-1)|0;g=Jp(q|0,D|0,L|K|W&2031616|0,g|0)|0;W=D;K=_m(G&2097151|0,0,666643,0)|0;L=D;q=_m(G&2097151|0,0,470296,0)|0;f=D;qa=_m(G&2097151|0,0,654183,0)|0;l=D;J=_m(G&2097151|0,0,-997805,-1)|0;w=D;V=_m(G&2097151|0,0,136657,0)|0;P=D;G=_m(G&2097151|0,0,-683901,-1)|0;r=D;c=_m(X&2097151|0,0,666643,0)|0;O=D;T=_m(X&2097151|0,0,470296,0)|0;ga=D;aa=_m(X&2097151|0,0,654183,0)|0;y=D;za=_m(X&2097151|0,0,-997805,-1)|0;pa=D;H=_m(X&2097151|0,0,136657,0)|0;k=D;X=_m(X&2097151|0,0,-683901,-1)|0;U=Jp(X|0,D|0,U&2097151|0,0)|0;P=Jp(U|0,D|0,V|0,P|0)|0;i=Jp(P|0,D|0,$|0,i|0)|0;$=D;P=_m(u&2097151|0,0,666643,0)|0;V=D;U=_m(u&2097151|0,0,470296,0)|0;X=D;ra=_m(u&2097151|0,0,654183,0)|0;z=D;ca=_m(u&2097151|0,0,-997805,-1)|0;ba=D;Ba=_m(u&2097151|0,0,136657,0)|0;Aa=D;u=_m(u&2097151|0,0,-683901,-1)|0;M=D;F=_m(Da&2097151|0,0,666643,0)|0;R=D;la=_m(Da&2097151|0,0,470296,0)|0;ma=D;ja=_m(Da&2097151|0,0,654183,0)|0;ia=D;ta=_m(Da&2097151|0,0,-997805,-1)|0;sa=D;ea=_m(Da&2097151|0,0,136657,0)|0;da=D;Da=_m(Da&2097151|0,0,-683901,-1)|0;Ca=Jp(Da|0,D|0,Ca&2097151|0,0)|0;Aa=Jp(Ca|0,D|0,Ba|0,Aa|0)|0;pa=Jp(Aa|0,D|0,za|0,pa|0)|0;l=Jp(pa|0,D|0,qa|0,l|0)|0;o=Jp(l|0,D|0,v|0,o|0)|0;v=D;l=_m(ha&2097151|0,0,666643,0)|0;Z=Jp(l|0,D|0,Z&2097151|0,0)|0;l=D;qa=_m(ha&2097151|0,0,470296,0)|0;pa=D;za=_m(ha&2097151|0,0,654183,0)|0;va=Jp(za|0,D|0,ya|xa|wa&2031616|0,va|0)|0;ma=Jp(va|0,D|0,la|0,ma|0)|0;V=Jp(ma|0,D|0,P|0,V|0)|0;P=D;ma=_m(ha&2097151|0,0,-997805,-1)|0;la=D;va=_m(ha&2097151|0,0,136657,0)|0;ua=Jp(va|0,D|0,ua&2097151|0,0)|0;sa=Jp(ua|0,D|0,ta|0,sa|0)|0;z=Jp(sa|0,D|0,ra|0,z|0)|0;ga=Jp(z|0,D|0,T|0,ga|0)|0;L=Jp(ga|0,D|0,K|0,L|0)|0;K=D;ha=_m(ha&2097151|0,0,-683901,-1)|0;ga=D;T=Jp(Z|0,l|0,1048576,0)|0;T=bo(T|0,D|0,21)|0;z=D;na=Jp(qa|0,pa|0,oa|0,na|0)|0;na=Jp(na|0,D|0,T|0,z|0)|0;R=Jp(na|0,D|0,F|0,R|0)|0;F=D;z=_n(T|0,z|0,21)|0;z=mo(Z|0,l|0,z|0,D|0)|0;l=D;Z=Jp(V|0,P|0,1048576,0)|0;Z=bo(Z|0,D|0,21)|0;T=D;ka=Jp(ma|0,la|0,ka&2097151|0,0)|0;ia=Jp(ka|0,D|0,ja|0,ia|0)|0;X=Jp(ia|0,D|0,U|0,X|0)|0;O=Jp(X|0,D|0,c|0,O|0)|0;O=Jp(O|0,D|0,Z|0,T|0)|0;c=D;T=_n(Z|0,T|0,21)|0;Z=D;X=Jp(L|0,K|0,1048576,0)|0;X=ln(X|0,D|0,21)|0;U=D;fa=Jp(ha|0,ga|0,fa&2097151|0,0)|0;da=Jp(fa|0,D|0,ea|0,da|0)|0;ba=Jp(da|0,D|0,ca|0,ba|0)|0;y=Jp(ba|0,D|0,aa|0,y|0)|0;f=Jp(y|0,D|0,q|0,f|0)|0;E=Jp(f|0,D|0,s|0,E|0)|0;E=Jp(E|0,D|0,X|0,U|0)|0;s=D;U=_n(X|0,U|0,21)|0;X=D;f=Jp(o|0,v|0,1048576,0)|0;f=ln(f|0,D|0,21)|0;q=D;N=Jp(u|0,M|0,N&2097151|0,0)|0;k=Jp(N|0,D|0,H|0,k|0)|0;w=Jp(k|0,D|0,J|0,w|0)|0;Q=Jp(w|0,D|0,B|0,Q|0)|0;Q=Jp(Q|0,D|0,f|0,q|0)|0;B=D;q=_n(f|0,q|0,21)|0;q=mo(o|0,v|0,q|0,D|0)|0;v=D;o=Jp(i|0,$|0,1048576,0)|0;o=ln(o|0,D|0,21)|0;f=D;A=Jp(G|0,r|0,I|0,A|0)|0;p=Jp(A|0,D|0,h|0,p|0)|0;p=Jp(p|0,D|0,o|0,f|0)|0;h=D;f=_n(o|0,f|0,21)|0;f=mo(i|0,$|0,f|0,D|0)|0;$=D;i=Jp(g|0,W|0,1048576,0)|0;i=ln(i|0,D|0,21)|0;o=D;t=Jp(i|0,o|0,t&2097151|0,0)|0;A=D;o=_n(i|0,o|0,21)|0;o=mo(g|0,W|0,o|0,D|0)|0;W=D;g=Jp(R|0,F|0,1048576,0)|0;g=bo(g|0,D|0,21)|0;i=D;I=_n(g|0,i|0,21)|0;I=mo(R|0,F|0,I|0,D|0)|0;F=D;R=Jp(O|0,c|0,1048576,0)|0;R=ln(R|0,D|0,21)|0;r=D;G=_n(R|0,r|0,21)|0;G=mo(O|0,c|0,G|0,D|0)|0;c=D;O=Jp(E|0,s|0,1048576,0)|0;O=ln(O|0,D|0,21)|0;w=D;v=Jp(q|0,v|0,O|0,w|0)|0;q=D;w=_n(O|0,w|0,21)|0;w=mo(E|0,s|0,w|0,D|0)|0;s=D;E=Jp(Q|0,B|0,1048576,0)|0;E=ln(E|0,D|0,21)|0;O=D;$=Jp(E|0,O|0,f|0,$|0)|0;f=D;O=_n(E|0,O|0,21)|0;O=mo(Q|0,B|0,O|0,D|0)|0;B=D;Q=Jp(p|0,h|0,1048576,0)|0;Q=ln(Q|0,D|0,21)|0;E=D;W=Jp(Q|0,E|0,o|0,W|0)|0;o=D;E=_n(Q|0,E|0,21)|0;E=mo(p|0,h|0,E|0,D|0)|0;h=D;p=_m(t|0,A|0,666643,0)|0;_=Jp(p|0,D|0,_&2097151|0,0)|0;p=D;Q=_m(t|0,A|0,470296,0)|0;Q=Jp(z|0,l|0,Q|0,D|0)|0;l=D;z=_m(t|0,A|0,654183,0)|0;z=Jp(I|0,F|0,z|0,D|0)|0;F=D;I=_m(t|0,A|0,-997805,-1)|0;J=D;k=_m(t|0,A|0,136657,0)|0;k=Jp(G|0,c|0,k|0,D|0)|0;c=D;A=_m(t|0,A|0,-683901,-1)|0;t=D;r=Jp(L|0,K|0,R|0,r|0)|0;X=mo(r|0,D|0,U|0,X|0)|0;t=Jp(X|0,D|0,A|0,t|0)|0;A=D;X=_m(W|0,o|0,666643,0)|0;n=Jp(X|0,D|0,n&2097151|0,0)|0;X=D;U=_m(W|0,o|0,470296,0)|0;U=Jp(_|0,p|0,U|0,D|0)|0;p=D;_=_m(W|0,o|0,654183,0)|0;_=Jp(Q|0,l|0,_|0,D|0)|0;l=D;Q=_m(W|0,o|0,-997805,-1)|0;Q=Jp(z|0,F|0,Q|0,D|0)|0;F=D;z=_m(W|0,o|0,136657,0)|0;r=D;o=_m(W|0,o|0,-683901,-1)|0;o=Jp(k|0,c|0,o|0,D|0)|0;c=D;k=_m(E|0,h|0,666643,0)|0;m=Jp(k|0,D|0,m&2097151|0,0)|0;k=D;W=_m(E|0,h|0,470296,0)|0;W=Jp(n|0,X|0,W|0,D|0)|0;X=D;n=_m(E|0,h|0,654183,0)|0;n=Jp(U|0,p|0,n|0,D|0)|0;p=D;U=_m(E|0,h|0,-997805,-1)|0;U=Jp(_|0,l|0,U|0,D|0)|0;l=D;_=_m(E|0,h|0,136657,0)|0;_=Jp(Q|0,F|0,_|0,D|0)|0;F=D;h=_m(E|0,h|0,-683901,-1)|0;E=D;i=Jp(V|0,P|0,g|0,i|0)|0;Z=mo(i|0,D|0,T|0,Z|0)|0;J=Jp(Z|0,D|0,I|0,J|0)|0;r=Jp(J|0,D|0,z|0,r|0)|0;E=Jp(r|0,D|0,h|0,E|0)|0;h=D;r=_m($|0,f|0,666643,0)|0;z=D;J=_m($|0,f|0,470296,0)|0;I=D;Z=_m($|0,f|0,654183,0)|0;T=D;i=_m($|0,f|0,-997805,-1)|0;g=D;P=_m($|0,f|0,136657,0)|0;P=Jp(U|0,l|0,P|0,D|0)|0;l=D;f=_m($|0,f|0,-683901,-1)|0;f=Jp(_|0,F|0,f|0,D|0)|0;F=D;_=_m(O|0,B|0,666643,0)|0;$=D;U=_m(O|0,B|0,470296,0)|0;V=D;Q=_m(O|0,B|0,654183,0)|0;R=D;K=_m(O|0,B|0,-997805,-1)|0;L=D;G=_m(O|0,B|0,136657,0)|0;H=D;B=_m(O|0,B|0,-683901,-1)|0;B=Jp(P|0,l|0,B|0,D|0)|0;l=D;P=_m(v|0,q|0,666643,0)|0;S=Jp(P|0,D|0,j|e|x&2031616|0,S|0)|0;x=D;e=_m(v|0,q|0,470296,0)|0;j=D;P=_m(v|0,q|0,654183,0)|0;Y=Jp(P|0,D|0,Y&2097151|0,0)|0;z=Jp(Y|0,D|0,r|0,z|0)|0;V=Jp(z|0,D|0,U|0,V|0)|0;U=D;z=_m(v|0,q|0,-997805,-1)|0;r=D;Y=_m(v|0,q|0,136657,0)|0;Y=Jp(W|0,X|0,Y|0,D|0)|0;T=Jp(Y|0,D|0,Z|0,T|0)|0;L=Jp(T|0,D|0,K|0,L|0)|0;K=D;q=_m(v|0,q|0,-683901,-1)|0;v=D;T=Jp(S|0,x|0,1048576,0)|0;T=ln(T|0,D|0,21)|0;Z=D;C=Jp(e|0,j|0,C&2097151|0,0)|0;$=Jp(C|0,D|0,_|0,$|0)|0;$=Jp($|0,D|0,T|0,Z|0)|0;_=D;Z=_n(T|0,Z|0,21)|0;Z=mo(S|0,x|0,Z|0,D|0)|0;x=D;S=Jp(V|0,U|0,1048576,0)|0;S=ln(S|0,D|0,21)|0;T=D;r=Jp(m|0,k|0,z|0,r|0)|0;I=Jp(r|0,D|0,J|0,I|0)|0;R=Jp(I|0,D|0,Q|0,R|0)|0;R=Jp(R|0,D|0,S|0,T|0)|0;Q=D;T=_n(S|0,T|0,21)|0;S=D;I=Jp(L|0,K|0,1048576,0)|0;I=ln(I|0,D|0,21)|0;J=D;v=Jp(n|0,p|0,q|0,v|0)|0;g=Jp(v|0,D|0,i|0,g|0)|0;H=Jp(g|0,D|0,G|0,H|0)|0;H=Jp(H|0,D|0,I|0,J|0)|0;G=D;J=_n(I|0,J|0,21)|0;I=D;g=Jp(B|0,l|0,1048576,0)|0;g=ln(g|0,D|0,21)|0;i=D;F=Jp(f|0,F|0,g|0,i|0)|0;f=D;i=_n(g|0,i|0,21)|0;i=mo(B|0,l|0,i|0,D|0)|0;l=D;B=Jp(E|0,h|0,1048576,0)|0;B=ln(B|0,D|0,21)|0;g=D;c=Jp(o|0,c|0,B|0,g|0)|0;o=D;g=_n(B|0,g|0,21)|0;g=mo(E|0,h|0,g|0,D|0)|0;h=D;E=Jp(t|0,A|0,1048576,0)|0;E=ln(E|0,D|0,21)|0;B=D;s=Jp(w|0,s|0,E|0,B|0)|0;w=D;B=_n(E|0,B|0,21)|0;B=mo(t|0,A|0,B|0,D|0)|0;A=D;t=Jp($|0,_|0,1048576,0)|0;t=ln(t|0,D|0,21)|0;E=D;v=_n(t|0,E|0,21)|0;q=D;p=Jp(R|0,Q|0,1048576,0)|0;p=ln(p|0,D|0,21)|0;n=D;r=_n(p|0,n|0,21)|0;z=D;k=Jp(H|0,G|0,1048576,0)|0;k=ln(k|0,D|0,21)|0;m=D;l=Jp(i|0,l|0,k|0,m|0)|0;i=D;m=_n(k|0,m|0,21)|0;k=D;C=Jp(F|0,f|0,1048576,0)|0;C=ln(C|0,D|0,21)|0;j=D;h=Jp(g|0,h|0,C|0,j|0)|0;g=D;j=_n(C|0,j|0,21)|0;j=mo(F|0,f|0,j|0,D|0)|0;f=D;F=Jp(c|0,o|0,1048576,0)|0;F=ln(F|0,D|0,21)|0;C=D;A=Jp(B|0,A|0,F|0,C|0)|0;B=D;C=_n(F|0,C|0,21)|0;C=mo(c|0,o|0,C|0,D|0)|0;o=D;c=Jp(s|0,w|0,1048576,0)|0;c=ln(c|0,D|0,21)|0;F=D;e=_n(c|0,F|0,21)|0;e=mo(s|0,w|0,e|0,D|0)|0;w=D;s=_m(c|0,F|0,666643,0)|0;s=Jp(Z|0,x|0,s|0,D|0)|0;x=D;Z=_m(c|0,F|0,470296,0)|0;Y=D;X=_m(c|0,F|0,654183,0)|0;W=D;P=_m(c|0,F|0,-997805,-1)|0;O=D;N=_m(c|0,F|0,136657,0)|0;M=D;F=_m(c|0,F|0,-683901,-1)|0;c=D;u=ln(s|0,x|0,21)|0;y=D;Y=Jp($|0,_|0,Z|0,Y|0)|0;Y=Jp(Y|0,D|0,u|0,y|0)|0;q=mo(Y|0,D|0,v|0,q|0)|0;v=D;y=_n(u|0,y|0,21)|0;y=mo(s|0,x|0,y|0,D|0)|0;x=D;s=ln(q|0,v|0,21)|0;u=D;U=Jp(X|0,W|0,V|0,U|0)|0;S=mo(U|0,D|0,T|0,S|0)|0;E=Jp(S|0,D|0,t|0,E|0)|0;E=Jp(E|0,D|0,s|0,u|0)|0;t=D;u=_n(s|0,u|0,21)|0;u=mo(q|0,v|0,u|0,D|0)|0;v=D;q=ln(E|0,t|0,21)|0;s=D;O=Jp(R|0,Q|0,P|0,O|0)|0;z=mo(O|0,D|0,r|0,z|0)|0;z=Jp(z|0,D|0,q|0,s|0)|0;r=D;s=_n(q|0,s|0,21)|0;s=mo(E|0,t|0,s|0,D|0)|0;t=D;E=ln(z|0,r|0,21)|0;q=D;K=Jp(N|0,M|0,L|0,K|0)|0;I=mo(K|0,D|0,J|0,I|0)|0;n=Jp(I|0,D|0,p|0,n|0)|0;n=Jp(n|0,D|0,E|0,q|0)|0;p=D;q=_n(E|0,q|0,21)|0;q=mo(z|0,r|0,q|0,D|0)|0;r=D;z=ln(n|0,p|0,21)|0;E=D;c=Jp(H|0,G|0,F|0,c|0)|0;k=mo(c|0,D|0,m|0,k|0)|0;k=Jp(k|0,D|0,z|0,E|0)|0;m=D;E=_n(z|0,E|0,21)|0;E=mo(n|0,p|0,E|0,D|0)|0;p=D;n=ln(k|0,m|0,21)|0;z=D;i=Jp(l|0,i|0,n|0,z|0)|0;l=D;z=_n(n|0,z|0,21)|0;z=mo(k|0,m|0,z|0,D|0)|0;m=D;k=ln(i|0,l|0,21)|0;n=D;f=Jp(k|0,n|0,j|0,f|0)|0;j=D;n=_n(k|0,n|0,21)|0;n=mo(i|0,l|0,n|0,D|0)|0;l=D;i=ln(f|0,j|0,21)|0;k=D;g=Jp(h|0,g|0,i|0,k|0)|0;h=D;k=_n(i|0,k|0,21)|0;k=mo(f|0,j|0,k|0,D|0)|0;j=D;f=ln(g|0,h|0,21)|0;i=D;o=Jp(f|0,i|0,C|0,o|0)|0;C=D;i=_n(f|0,i|0,21)|0;i=mo(g|0,h|0,i|0,D|0)|0;h=D;g=ln(o|0,C|0,21)|0;f=D;B=Jp(A|0,B|0,g|0,f|0)|0;A=D;f=_n(g|0,f|0,21)|0;f=mo(o|0,C|0,f|0,D|0)|0;C=D;o=ln(B|0,A|0,21)|0;g=D;w=Jp(o|0,g|0,e|0,w|0)|0;e=D;g=_n(o|0,g|0,21)|0;g=mo(B|0,A|0,g|0,D|0)|0;A=D;B=ln(w|0,e|0,21)|0;o=D;c=_n(B|0,o|0,21)|0;c=mo(w|0,e|0,c|0,D|0)|0;e=D;w=_m(B|0,o|0,666643,0)|0;x=Jp(w|0,D|0,y|0,x|0)|0;y=D;w=_m(B|0,o|0,470296,0)|0;w=Jp(u|0,v|0,w|0,D|0)|0;v=D;u=_m(B|0,o|0,654183,0)|0;u=Jp(s|0,t|0,u|0,D|0)|0;t=D;s=_m(B|0,o|0,-997805,-1)|0;s=Jp(q|0,r|0,s|0,D|0)|0;r=D;q=_m(B|0,o|0,136657,0)|0;q=Jp(E|0,p|0,q|0,D|0)|0;p=D;o=_m(B|0,o|0,-683901,-1)|0;o=Jp(z|0,m|0,o|0,D|0)|0;m=D;z=ln(x|0,y|0,21)|0;B=D;v=Jp(w|0,v|0,z|0,B|0)|0;w=D;B=_n(z|0,B|0,21)|0;B=mo(x|0,y|0,B|0,D|0)|0;y=D;x=ln(v|0,w|0,21)|0;z=D;t=Jp(u|0,t|0,x|0,z|0)|0;u=D;z=_n(x|0,z|0,21)|0;z=mo(v|0,w|0,z|0,D|0)|0;w=D;v=ln(t|0,u|0,21)|0;x=D;r=Jp(s|0,r|0,v|0,x|0)|0;s=D;x=_n(v|0,x|0,21)|0;x=mo(t|0,u|0,x|0,D|0)|0;u=D;t=ln(r|0,s|0,21)|0;v=D;p=Jp(q|0,p|0,t|0,v|0)|0;q=D;v=_n(t|0,v|0,21)|0;v=mo(r|0,s|0,v|0,D|0)|0;s=D;r=ln(p|0,q|0,21)|0;t=D;m=Jp(o|0,m|0,r|0,t|0)|0;o=D;t=_n(r|0,t|0,21)|0;t=mo(p|0,q|0,t|0,D|0)|0;q=D;p=ln(m|0,o|0,21)|0;r=D;l=Jp(p|0,r|0,n|0,l|0)|0;n=D;r=_n(p|0,r|0,21)|0;r=mo(m|0,o|0,r|0,D|0)|0;o=D;m=ln(l|0,n|0,21)|0;p=D;j=Jp(m|0,p|0,k|0,j|0)|0;k=D;p=_n(m|0,p|0,21)|0;p=mo(l|0,n|0,p|0,D|0)|0;n=D;l=ln(j|0,k|0,21)|0;m=D;h=Jp(l|0,m|0,i|0,h|0)|0;i=D;m=_n(l|0,m|0,21)|0;m=mo(j|0,k|0,m|0,D|0)|0;k=D;j=ln(h|0,i|0,21)|0;l=D;C=Jp(j|0,l|0,f|0,C|0)|0;f=D;l=_n(j|0,l|0,21)|0;l=mo(h|0,i|0,l|0,D|0)|0;i=D;h=ln(C|0,f|0,21)|0;j=D;A=Jp(h|0,j|0,g|0,A|0)|0;g=D;j=_n(h|0,j|0,21)|0;j=mo(C|0,f|0,j|0,D|0)|0;f=D;C=ln(A|0,g|0,21)|0;h=D;e=Jp(C|0,h|0,c|0,e|0)|0;c=D;h=_n(C|0,h|0,21)|0;h=mo(A|0,g|0,h|0,D|0)|0;g=D;a[b>>0]=B;A=bo(B|0,y|0,8)|0;a[b+1>>0]=A;y=bo(B|0,y|0,16)|0;B=D;A=_n(z|0,w|0,5)|0;a[b+2>>0]=A|y;y=bo(z|0,w|0,3)|0;a[b+3>>0]=y;y=bo(z|0,w|0,11)|0;a[b+4>>0]=y;w=bo(z|0,w|0,19)|0;z=D;y=_n(x|0,u|0,2)|0;a[b+5>>0]=y|w;w=bo(x|0,u|0,6)|0;a[b+6>>0]=w;u=bo(x|0,u|0,14)|0;x=D;w=_n(v|0,s|0,7)|0;a[b+7>>0]=w|u;u=bo(v|0,s|0,1)|0;a[b+8>>0]=u;u=bo(v|0,s|0,9)|0;a[b+9>>0]=u;s=bo(v|0,s|0,17)|0;v=D;u=_n(t|0,q|0,4)|0;a[b+10>>0]=u|s;s=bo(t|0,q|0,4)|0;a[b+11>>0]=s;s=bo(t|0,q|0,12)|0;a[b+12>>0]=s;q=bo(t|0,q|0,20)|0;t=D;s=_n(r|0,o|0,1)|0;a[b+13>>0]=s|q;q=bo(r|0,o|0,7)|0;a[b+14>>0]=q;o=bo(r|0,o|0,15)|0;r=D;q=_n(p|0,n|0,6)|0;a[b+15>>0]=q|o;o=bo(p|0,n|0,2)|0;a[b+16>>0]=o;o=bo(p|0,n|0,10)|0;a[b+17>>0]=o;n=bo(p|0,n|0,18)|0;p=D;o=_n(m|0,k|0,3)|0;a[b+18>>0]=o|n;n=bo(m|0,k|0,5)|0;a[b+19>>0]=n;k=bo(m|0,k|0,13)|0;a[b+20>>0]=k;a[b+21>>0]=l;k=bo(l|0,i|0,8)|0;a[b+22>>0]=k;i=bo(l|0,i|0,16)|0;l=D;k=_n(j|0,f|0,5)|0;a[b+23>>0]=k|i;i=bo(j|0,f|0,3)|0;a[b+24>>0]=i;i=bo(j|0,f|0,11)|0;a[b+25>>0]=i;f=bo(j|0,f|0,19)|0;j=D;i=_n(h|0,g|0,2)|0;a[b+26>>0]=i|f;f=bo(h|0,g|0,6)|0;a[b+27>>0]=f;g=bo(h|0,g|0,14)|0;h=D;f=_n(e|0,c|0,7)|0;a[b+28>>0]=g|f;f=bo(e|0,c|0,1)|0;a[b+29>>0]=f;f=bo(e|0,c|0,9)|0;a[b+30>>0]=f;c=bo(e|0,c|0,17)|0;a[b+31>>0]=c;return}function gc(b,e,f){b=b|0;e=e|0;f=f|0;var g=0.0,h=0,j=0.0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0,r=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,G=0,H=0,I=0,J=0.0;I=i;C=i=i+63&-64;i=i+512|0;switch(e|0){case 0:{H=24;E=-149;A=4;break}case 1:{H=53;E=-1074;A=4;break}case 2:{H=53;E=-1074;A=4;break}default:g=0.0}a:do if((A|0)==4){do{e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0}else e=ug(b)|0}while((Kt(e)|0)!=0);b:do switch(e|0){case 43:case 45:{h=1-(((e|0)==45&1)<<1)|0;e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0;G=h;break b}else{e=ug(b)|0;G=h;break b}}default:G=1}while(0);h=e;e=0;do{if((h|32|0)!=(a[46363+e>>0]|0))break;do if(e>>>0<7){h=c[b+4>>2]|0;if(h>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=h+1;h=d[h>>0]|0;break}else{h=ug(b)|0;break}}while(0);e=e+1|0}while(e>>>0<8);c:do switch(e|0){case 8:break;case 3:{A=23;break}default:{if((f|0)!=0&e>>>0>3)if((e|0)==8)break c;else{A=23;break c}d:do if(!e){e=0;do{if((h|32|0)!=(a[46372+e>>0]|0))break d;do if(e>>>0<2){h=c[b+4>>2]|0;if(h>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=h+1;h=d[h>>0]|0;break}else{h=ug(b)|0;break}}while(0);e=e+1|0}while(e>>>0<3)}while(0);switch(e|0){case 3:{e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0}else e=ug(b)|0;if((e|0)==40)e=1;else{if(!(c[b+100>>2]|0)){g=s;break a}c[b+4>>2]=(c[b+4>>2]|0)+-1;g=s;break a}while(1){h=c[b+4>>2]|0;if(h>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=h+1;h=d[h>>0]|0}else h=ug(b)|0;if(!((h+-48|0)>>>0<10|(h+-65|0)>>>0<26)?!((h|0)==95|(h+-97|0)>>>0<26):0)break;e=e+1|0}if((h|0)==41){g=s;break a}h=(c[b+100>>2]|0)==0;if(!h)c[b+4>>2]=(c[b+4>>2]|0)+-1;if(!f){c[(Sq()|0)>>2]=22;Ml(b,0);g=0.0;break a}if(!e){g=s;break a}while(1){e=e+-1|0;if(!h)c[b+4>>2]=(c[b+4>>2]|0)+-1;if(!e){g=s;break a}}}case 0:{do if((h|0)==48){e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0}else e=ug(b)|0;if((e|32|0)!=120){if(!(c[b+100>>2]|0)){e=48;break}c[b+4>>2]=(c[b+4>>2]|0)+-1;e=48;break}e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0;k=0}else{e=ug(b)|0;k=0}e:while(1){switch(e|0){case 46:{A=74;break e}case 48:break;default:{y=0;l=0;x=0;h=0;u=k;w=0;v=0;o=1.0;k=0;g=0.0;break e}}e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0;k=1;continue}else{e=ug(b)|0;k=1;continue}}if((A|0)==74){e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0}else e=ug(b)|0;if((e|0)==48){k=0;h=0;do{e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0}else e=ug(b)|0;k=Jp(k|0,h|0,-1,-1)|0;h=D}while((e|0)==48);y=0;l=0;x=k;u=1;w=1;v=0;o=1.0;k=0;g=0.0}else{y=0;l=0;x=0;h=0;u=k;w=1;v=0;o=1.0;k=0;g=0.0}}while(1){n=e+-48|0;m=e|32;if(n>>>0>=10){q=(e|0)==46;if(!(q|(m+-97|0)>>>0<6))break;if(q)if(!w){q=l;h=y;n=y;w=1;m=v;j=o}else{e=46;break}else A=86}else A=86;if((A|0)==86){A=0;e=(e|0)>57?m+-87|0:n;do if(!((y|0)<0|(y|0)==0&l>>>0<8)){if((y|0)<0|(y|0)==0&l>>>0<14){r=o*.0625;m=v;j=r;g=g+r*+(e|0);break}if((v|0)!=0|(e|0)==0){m=v;j=o}else{m=1;j=o;g=g+o*.5}}else{m=v;j=o;k=e+(k<<4)|0}while(0);l=Jp(l|0,y|0,1,0)|0;q=x;n=D;u=1}e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;y=n;x=q;e=d[e>>0]|0;v=m;o=j;continue}else{y=n;x=q;e=ug(b)|0;v=m;o=j;continue}}if(!u){e=(c[b+100>>2]|0)==0;if(!e)c[b+4>>2]=(c[b+4>>2]|0)+-1;if(f){if(!e?(z=c[b+4>>2]|0,c[b+4>>2]=z+-1,w|0):0)c[b+4>>2]=z+-2}else Ml(b,0);g=+(G|0)*0.0;break a}m=(w|0)==0;n=m?l:x;m=m?y:h;if((y|0)<0|(y|0)==0&l>>>0<8){h=y;do{k=k<<4;l=Jp(l|0,h|0,1,0)|0;h=D}while((h|0)<0|(h|0)==0&l>>>0<8)}if((e|32|0)==112){h=ae(b,f)|0;e=D;if((h|0)==0&(e|0)==-2147483648){if(!f){Ml(b,0);g=0.0;break a}if(!(c[b+100>>2]|0)){h=0;e=0}else{c[b+4>>2]=(c[b+4>>2]|0)+-1;h=0;e=0}}}else if(!(c[b+100>>2]|0)){h=0;e=0}else{c[b+4>>2]=(c[b+4>>2]|0)+-1;h=0;e=0}C=_n(n|0,m|0,2)|0;C=Jp(C|0,D|0,-32,-1)|0;e=Jp(C|0,D|0,h|0,e|0)|0;h=D;if(!k){g=+(G|0)*0.0;break a}if((h|0)>0|(h|0)==0&e>>>0>(0-E|0)>>>0){c[(Sq()|0)>>2]=34;g=+(G|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break a}C=E+-106|0;if((h|0)<(((C|0)<0)<<31>>31|0)|(h|0)==(((C|0)<0)<<31>>31|0)&e>>>0<C>>>0){c[(Sq()|0)>>2]=34;g=+(G|0)*2.2250738585072014e-308*2.2250738585072014e-308;break a}if((k|0)>-1)while(1){C=!(g>=.5);k=C&1|k<<1;g=g+(C?g:g+-1.0);e=Jp(e|0,h|0,-1,-1)|0;h=D;if((k|0)>-1)k=k^1;else{l=e;k=k^1;o=g;break}}else{l=e;o=g}e=mo(32,0,E|0,((E|0)<0)<<31>>31|0)|0;e=Jp(l|0,h|0,e|0,D|0)|0;E=D;if(0>(E|0)|0==(E|0)&H>>>0>e>>>0)if((e|0)<0){e=0;A=127}else A=125;else{e=H;A=125}if((A|0)==125)if((e|0)<53)A=127;else{h=e;j=+(G|0);g=0.0}if((A|0)==127){g=+(G|0);h=e;j=g;g=+hu(+yh(1.0,84-e|0),g)}H=(k&1|0)==0&(o!=0.0&(h|0)<32);g=j*(H?0.0:o)+(g+j*+(((H&1)+k|0)>>>0))-g;if(!(g!=0.0))c[(Sq()|0)>>2]=34;g=+iu(g,l);break a}else e=h;while(0);B=E+H|0;l=0;f:while(1){switch(e|0){case 46:{A=138;break f}case 48:break;default:{h=0;k=0;q=0;break f}}e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0;l=1;continue}else{e=ug(b)|0;l=1;continue}}if((A|0)==138){e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0}else e=ug(b)|0;if((e|0)==48){h=0;e=0;while(1){h=Jp(h|0,e|0,-1,-1)|0;k=D;e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0}else e=ug(b)|0;if((e|0)==48)e=k;else{l=1;q=1;break}}}else{h=0;k=0;q=1}}c[C>>2]=0;n=e+-48|0;m=(e|0)==46;g:do if(m|n>>>0<10){u=0;x=0;y=0;z=0;A=0;h:while(1){do if(m)if(!q){h=u;k=x;q=1;v=A}else break h;else{v=Jp(u|0,x|0,1,0)|0;m=D;w=(e|0)!=48;if((z|0)>=125){if(!w){u=v;x=m;v=A;break}c[C+496>>2]=c[C+496>>2]|1;u=v;x=m;v=A;break}l=C+(z<<2)|0;if(y)n=e+-48+((c[l>>2]|0)*10|0)|0;c[l>>2]=n;n=y+1|0;u=v;x=m;l=1;y=(n|0)==9?0:n;z=((n|0)==9&1)+z|0;v=w?v:A}while(0);e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0}else e=ug(b)|0;n=e+-48|0;m=(e|0)==46;if(!(m|n>>>0<10)){n=z;m=v;A=161;break g}else A=v}q=x;l=(l|0)!=0;e=y;n=z;m=A;A=169}else{u=0;x=0;y=0;n=0;m=0;A=161}while(0);do if((A|0)==161){z=(q|0)==0;h=z?u:h;k=z?x:k;l=(l|0)!=0;if(!((e|32|0)==101&l))if((e|0)>-1){q=x;e=y;A=169;break}else{q=x;e=y;A=171;break}l=ae(b,f)|0;e=D;if((l|0)==0&(e|0)==-2147483648){if(!f){Ml(b,0);g=0.0;break}if(!(c[b+100>>2]|0)){l=0;e=0}else{c[b+4>>2]=(c[b+4>>2]|0)+-1;l=0;e=0}}h=Jp(l|0,e|0,h|0,k|0)|0;k=D;q=x;e=y;A=173}while(0);if((A|0)==169)if(c[b+100>>2]|0){c[b+4>>2]=(c[b+4>>2]|0)+-1;if(l)A=173;else A=172}else A=171;if((A|0)==171)if(l)A=173;else A=172;do if((A|0)==172){c[(Sq()|0)>>2]=22;Ml(b,0);g=0.0}else if((A|0)==173){l=c[C>>2]|0;if(!l){g=+(G|0)*0.0;break}if(((q|0)<0|(q|0)==0&u>>>0<10)&((h|0)==(u|0)&(k|0)==(q|0))?H>>>0>30|(l>>>H|0)==0:0){g=+(G|0)*+(l>>>0);break}b=(E|0)/-2|0;if((k|0)>(((b|0)<0)<<31>>31|0)|(k|0)==(((b|0)<0)<<31>>31|0)&h>>>0>b>>>0){c[(Sq()|0)>>2]=34;g=+(G|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break}b=E+-106|0;if((k|0)<(((b|0)<0)<<31>>31|0)|(k|0)==(((b|0)<0)<<31>>31|0)&h>>>0<b>>>0){c[(Sq()|0)>>2]=34;g=+(G|0)*2.2250738585072014e-308*2.2250738585072014e-308;break}if(!e)l=n;else{if((e|0)<9){k=C+(n<<2)|0;l=c[k>>2]|0;do{l=l*10|0;e=e+1|0}while((e|0)!=9);c[k>>2]=l}l=n+1|0}if((m|0)<9?(m|0)<=(h|0)&(h|0)<18:0){if((h|0)==9){g=+(G|0)*+((c[C>>2]|0)>>>0);break}if((h|0)<9){g=+(G|0)*+((c[C>>2]|0)>>>0)/+(c[37600+(8-h<<2)>>2]|0);break}b=H+27+(S(h,-3)|0)|0;e=c[C>>2]|0;if((b|0)>30|(e>>>b|0)==0){g=+(G|0)*+(e>>>0)*+(c[37600+(h+-10<<2)>>2]|0);break}}e=(h|0)%9|0;if(!e){k=0;e=0}else{q=(h|0)>-1?e:e+9|0;e=c[37600+(8-q<<2)>>2]|0;if(l){k=0;m=0;n=0;do{z=C+(n<<2)|0;f=c[z>>2]|0;b=((f>>>0)/(e>>>0)|0)+m|0;c[z>>2]=b;m=S((f>>>0)%(e>>>0)|0,1e9/(e|0)|0)|0;b=(n|0)==(k|0)&(b|0)==0;n=n+1|0;h=b?h+-9|0:h;k=b?n&127:k}while((n|0)!=(l|0));if(m){c[C+(l<<2)>>2]=m;l=l+1|0}}else{k=0;l=0}e=0;h=9-q+h|0}i:while(1){u=(h|0)<18;v=(h|0)==18;w=C+(k<<2)|0;do{if(!u){if(!v){x=l;break i}if((c[w>>2]|0)>>>0>=9007199){h=18;x=l;break i}}n=0;m=l+127|0;while(1){q=m&127;m=_n(c[C+(q<<2)>>2]|0,0,29)|0;m=Jp(m|0,D|0,n|0,0)|0;n=D;if(n>>>0>0|(n|0)==0&m>>>0>1e9){b=bs(m|0,n|0,1e9,0)|0;m=ym(m|0,n|0,1e9,0)|0;n=b}else n=0;c[C+(q<<2)>>2]=m;b=(q|0)==(k|0);l=(q|0)!=(l+127&127|0)|b?l:(m|0)==0?q:l;if(b)break;else m=q+-1|0}e=e+-29|0}while(!(n|0));k=k+127&127;if((k|0)==(l|0)){b=l+127&127;l=C+((l+126&127)<<2)|0;c[l>>2]=c[l>>2]|c[C+(b<<2)>>2];l=b}c[C+(k<<2)>>2]=n;h=h+9|0}j:while(1){l=x+1&127;w=C+((x+127&127)<<2)|0;while(1){u=(h|0)==18;v=(h|0)>27?9:1;while(1){n=k&127;q=(n|0)==(x|0);do if(!q){m=c[C+(n<<2)>>2]|0;if(m>>>0<9007199){A=219;break}if(m>>>0>9007199)break;m=k+1&127;if((m|0)==(x|0)){A=219;break}m=c[C+(m<<2)>>2]|0;if(m>>>0<254740991){A=219;break}if(!(m>>>0>254740991|u^1)){h=n;l=x;break j}}else A=219;while(0);if((A|0)==219?(A=0,u):0){A=220;break j}e=e+v|0;if((k|0)==(x|0))k=x;else break}m=k;n=0;do{z=C+(k<<2)|0;f=c[z>>2]|0;b=(f>>>v)+n|0;c[z>>2]=b;n=S(f&(1<<v)+-1,1e9>>>v)|0;b=(k|0)==(m|0)&(b|0)==0;k=k+1&127;h=b?h+-9|0:h;m=b?k:m}while((k|0)!=(x|0));if(!n){k=m;continue}if((l|0)!=(m|0))break;c[w>>2]=c[w>>2]|1;k=m}c[C+(x<<2)>>2]=n;k=m;x=l}if((A|0)==220)if(q){c[C+(l+-1<<2)>>2]=0;h=x}else{h=n;l=x}g=+((c[C+(h<<2)>>2]|0)>>>0);h=k+1&127;if((h|0)==(l|0)){l=k+2&127;c[C+(l+-1<<2)>>2]=0}r=+(G|0);j=r*(g*1.0e9+ +((c[C+(h<<2)>>2]|0)>>>0));u=e+53|0;n=u-E|0;q=(n|0)<(H|0);m=q?((n|0)<0?0:n):H;if((m|0)<53){J=+hu(+yh(1.0,105-m|0),j);o=+vu(j,+yh(1.0,53-m|0));p=J;g=o;o=J+(j-o)}else{p=0.0;g=0.0;o=j}h=k+2&127;do if((h|0)==(l|0))j=g;else{h=c[C+(h<<2)>>2]|0;do if(h>>>0>=5e8){if(h>>>0>5e8){g=r*.75+g;break}if((k+3&127|0)==(l|0)){g=r*.5+g;break}else{g=r*.75+g;break}}else{if((h|0)==0?(k+3&127|0)==(l|0):0)break;g=r*.25+g}while(0);if((53-m|0)<=1){j=g;break}if(+vu(g,1.0)!=0.0){j=g;break}j=g+1.0}while(0);g=o+j-p;do if((u&2147483647|0)>(-2-B|0)){if(!(+F(+g)>=9007199254740992.0))h=q&1;else{h=q&(m|0)==(n|0)?0:q&1;e=e+1|0;g=g*.5}if((e+50|0)<=(0-B|0)?!(j!=0.0&(h|0)!=0):0)break;c[(Sq()|0)>>2]=34}while(0);g=+iu(g,e)}while(0);break a}default:{if(c[b+100>>2]|0)c[b+4>>2]=(c[b+4>>2]|0)+-1;c[(Sq()|0)>>2]=22;Ml(b,0);g=0.0;break a}}}}while(0);if((A|0)==23){h=(c[b+100>>2]|0)==0;if(!h)c[b+4>>2]=(c[b+4>>2]|0)+-1;if((f|0)!=0&e>>>0>3)do{if(!h)c[b+4>>2]=(c[b+4>>2]|0)+-1;e=e+-1|0}while(e>>>0>3)}g=+(G|0)*t}while(0);i=I;return +g}function hc(e,f,g,j,l){e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0.0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;P=i;O=i=i+63&-64;i=i+624|0;K=O+536+40|0;M=O+588|0;N=O+576+12|0;L=O+588+9|0;m=0;n=0;r=0;w=f;a:while(1){do if((m|0)>-1)if((n|0)>(2147483647-m|0)){c[(Sq()|0)>>2]=75;m=-1;break}else{m=n+m|0;break}while(0);f=a[w>>0]|0;if(!(f<<24>>24)){J=244;break}else n=w;b:while(1){switch(f<<24>>24){case 37:{f=n;J=9;break b}case 0:{f=n;break b}default:{}}I=n+1|0;f=a[I>>0]|0;n=I}c:do if((J|0)==9)while(1){J=0;if((a[f+1>>0]|0)!=37)break c;n=n+1|0;f=f+2|0;if((a[f>>0]|0)==37)J=9;else break}while(0);v=n-w|0;if(e|0?(c[e>>2]&32|0)==0:0)Zf(w,v,e)|0;if((n|0)!=(w|0)){n=v;w=f;continue}o=f+1|0;n=a[o>>0]|0;if(((n<<24>>24)+-48|0)>>>0<10){I=(a[f+2>>0]|0)==36;o=I?f+3|0:o;q=a[o>>0]|0;u=I?(n<<24>>24)+-48|0:-1;r=I?1:r}else{q=n;u=-1}f=q<<24>>24;d:do if((f&-32|0)==32){n=q;q=0;do{if(!(1<<f+-32&75913))break d;q=1<<(n<<24>>24)+-32|q;o=o+1|0;n=a[o>>0]|0;f=n<<24>>24}while((f&-32|0)==32)}else{n=q;q=0}while(0);do if(n<<24>>24==42){n=o+1|0;f=(a[n>>0]|0)+-48|0;if(f>>>0<10?(a[o+2>>0]|0)==36:0){c[l+(f<<2)>>2]=10;f=1;o=o+3|0;n=c[j+((a[n>>0]|0)+-48<<3)>>2]|0}else{if(r|0){m=-1;break a}if(!e){t=q;I=0;o=n;H=0;break}f=(c[g>>2]|0)+(4-1)&~(4-1);I=c[f>>2]|0;c[g>>2]=f+4;f=0;o=n;n=I}if((n|0)<0){t=q|8192;I=f;H=0-n|0}else{t=q;I=f;H=n}}else{f=(n<<24>>24)+-48|0;if(f>>>0<10){n=0;do{n=(n*10|0)+f|0;o=o+1|0;f=(a[o>>0]|0)+-48|0}while(f>>>0<10);if((n|0)<0){m=-1;break a}else{t=q;I=r;H=n}}else{t=q;I=r;H=0}}while(0);e:do if((a[o>>0]|0)==46){f=o+1|0;q=a[f>>0]|0;if(q<<24>>24!=42){if(((q<<24>>24)+-48|0)>>>0<10){n=0;o=(q<<24>>24)+-48|0}else{r=0;break}while(1){n=(n*10|0)+o|0;f=f+1|0;o=(a[f>>0]|0)+-48|0;if(o>>>0>=10){r=n;break e}}}f=o+2|0;n=(a[f>>0]|0)+-48|0;if(n>>>0<10?(a[o+3>>0]|0)==36:0){c[l+(n<<2)>>2]=10;r=c[j+((a[f>>0]|0)+-48<<3)>>2]|0;f=o+4|0;break}if(I|0){m=-1;break a}if(e|0){G=(c[g>>2]|0)+(4-1)&~(4-1);r=c[G>>2]|0;c[g>>2]=G+4}else r=0}else{r=-1;f=o}while(0);q=0;while(1){n=(a[f>>0]|0)+-65|0;if(n>>>0>57){m=-1;break a}G=f+1|0;n=a[43943+(q*58|0)+n>>0]|0;if(((n&255)+-1|0)>>>0<8){f=G;q=n&255}else break}if(!(n<<24>>24)){m=-1;break}o=(u|0)>-1;do if(n<<24>>24==19)if(o){m=-1;break a}else J=52;else{if(o){c[l+(u<<2)>>2]=n&255;F=j+(u<<3)|0;J=c[F+4>>2]|0;c[O>>2]=c[F>>2];c[O+4>>2]=J;J=52;break}if(!e){m=0;break a}Zd(O,n&255,g)}while(0);if((J|0)==52?(J=0,(e|0)==0):0){n=v;r=I;w=G;continue}E=a[f>>0]|0;E=(q|0)!=0&(E&15|0)==3?E&-33:E;o=t&-65537;F=(t&8192|0)==0?t:o;f:do switch(E|0){case 110:switch(q|0){case 0:{c[c[O>>2]>>2]=m;n=v;r=I;w=G;continue a}case 1:{c[c[O>>2]>>2]=m;n=v;r=I;w=G;continue a}case 2:{n=c[O>>2]|0;c[n>>2]=m;c[n+4>>2]=((m|0)<0)<<31>>31;n=v;r=I;w=G;continue a}case 3:{b[c[O>>2]>>1]=m;n=v;r=I;w=G;continue a}case 4:{a[c[O>>2]>>0]=m;n=v;r=I;w=G;continue a}case 6:{c[c[O>>2]>>2]=m;n=v;r=I;w=G;continue a}case 7:{n=c[O>>2]|0;c[n>>2]=m;c[n+4>>2]=((m|0)<0)<<31>>31;n=v;r=I;w=G;continue a}default:{n=v;r=I;w=G;continue a}}case 112:{t=F|8;r=r>>>0>8?r:8;u=120;J=64;break}case 88:case 120:{t=F;u=E;J=64;break}case 111:{n=c[O>>2]|0;o=c[O+4>>2]|0;if((n|0)==0&(o|0)==0)f=K;else{f=K;do{f=f+-1|0;a[f>>0]=n&7|48;n=bo(n|0,o|0,3)|0;o=D}while(!((n|0)==0&(o|0)==0))}if(!(F&8)){n=F;t=0;q=44423;J=77}else{t=K-f|0;n=F;r=(r|0)>(t|0)?r:t+1|0;t=0;q=44423;J=77}break}case 105:case 100:{f=c[O>>2]|0;n=c[O+4>>2]|0;if((n|0)<0){f=mo(0,0,f|0,n|0)|0;n=D;c[O>>2]=f;c[O+4>>2]=n;o=1;q=44423;J=76;break f}if(!(F&2048)){o=F&1;q=(F&1|0)==0?44423:44425;J=76}else{o=1;q=44424;J=76}break}case 117:{f=c[O>>2]|0;n=c[O+4>>2]|0;o=0;q=44423;J=76;break}case 99:{a[O+536+39>>0]=c[O>>2];f=O+536+39|0;u=1;w=0;v=44423;n=K;break}case 109:{n=ii(c[(Sq()|0)>>2]|0)|0;J=82;break}case 115:{n=c[O>>2]|0;n=n|0?n:46325;J=82;break}case 67:{c[O+8>>2]=c[O>>2];c[O+8+4>>2]=0;c[O>>2]=O+8;f=O+8|0;r=-1;J=86;break}case 83:{f=c[O>>2]|0;if(!r){Ig(e,32,H,0,F);f=0;J=97}else J=86;break}case 65:case 71:case 70:case 69:case 97:case 103:case 102:case 101:{p=+h[O>>3];c[O+16>>2]=0;h[k>>3]=p;if((c[k+4>>2]|0)>=0)if(!(F&2048)){B=F&1;C=(F&1|0)==0?46333:46338}else{B=1;C=46335}else{p=-p;B=1;C=46332}h[k>>3]=p;A=c[k+4>>2]&2146435072;do if(A>>>0<2146435072|(A|0)==2146435072&0<0){p=+lu(p,O+16|0)*2.0;if(p!=0.0)c[O+16>>2]=(c[O+16>>2]|0)+-1;if((E|32|0)==97){u=(E&32|0)==0?C:C+9|0;t=B|2;f=12-r|0;do if(!(r>>>0>11|(f|0)==0)){s=8.0;do{f=f+-1|0;s=s*16.0}while((f|0)!=0);if((a[u>>0]|0)==45){p=-(s+(-p-s));break}else{p=p+s-s;break}}while(0);n=c[O+16>>2]|0;f=(n|0)<0?0-n|0:n;f=Zh(f,((f|0)<0)<<31>>31,O+576+12|0)|0;if((f|0)==(O+576+12|0)){a[O+576+11>>0]=48;f=O+576+11|0}a[f+-1>>0]=(n>>31&2)+43;q=f+-2|0;a[q>>0]=E+15;o=(r|0)<1;f=O+588|0;while(1){C=~~p;n=f+1|0;a[f>>0]=d[44407+C>>0]|E&32;p=(p-+(C|0))*16.0;do if((n-M|0)==1){if((F&8|0)==0&(o&p==0.0))break;a[n>>0]=46;n=f+2|0}while(0);if(!(p!=0.0))break;else f=n}f=(r|0)!=0&(-2-M+n|0)<(r|0)?N+2+r-q|0:N-M-q+n|0;Ig(e,32,H,f+t|0,F);if(!(c[e>>2]&32))Zf(u,t,e)|0;Ig(e,48,H,f+t|0,F^65536);if(!(c[e>>2]&32))Zf(O+588|0,n-M|0,e)|0;Ig(e,48,f-(n-M+(N-q))|0,0,0);if(!(c[e>>2]&32))Zf(q,N-q|0,e)|0;Ig(e,32,H,f+t|0,F^8192);f=(f+t|0)<(H|0)?H:f+t|0;break}f=(r|0)<0?6:r;if(p!=0.0){n=(c[O+16>>2]|0)+-28|0;c[O+16>>2]=n;p=p*268435456.0}else n=c[O+16>>2]|0;A=(n|0)<0?O+24|0:O+24+288|0;q=A;do{z=~~p>>>0;c[q>>2]=z;q=q+4|0;p=(p-+(z>>>0))*1.0e9}while(p!=0.0);n=c[O+16>>2]|0;if((n|0)>0){o=A;do{t=(n|0)>29?29:n;n=q+-4|0;do if(n>>>0>=o>>>0){r=0;do{y=_n(c[n>>2]|0,0,t|0)|0;y=Jp(y|0,D|0,r|0,0)|0;z=D;x=ym(y|0,z|0,1e9,0)|0;c[n>>2]=x;r=bs(y|0,z|0,1e9,0)|0;n=n+-4|0}while(n>>>0>=o>>>0);if(!r)break;o=o+-4|0;c[o>>2]=r}while(0);while(1){if(q>>>0<=o>>>0)break;n=q+-4|0;if(!(c[n>>2]|0))q=n;else break}n=(c[O+16>>2]|0)-t|0;c[O+16>>2]=n}while((n|0)>0)}else o=A;if((n|0)<0){do{t=0-n|0;t=(t|0)>9?9:t;do if(o>>>0<q>>>0){r=0;n=o;do{z=c[n>>2]|0;c[n>>2]=(z>>>t)+r;r=S(z&(1<<t)+-1,1e9>>>t)|0;n=n+4|0}while(n>>>0<q>>>0);n=(c[o>>2]|0)==0?o+4|0:o;if(!r){o=n;n=q;break}c[q>>2]=r;o=n;n=q+4|0}else{o=(c[o>>2]|0)==0?o+4|0:o;n=q}while(0);q=(E|32|0)==102?A:o;q=(n-q>>2|0)>(((f+25|0)/9|0)+1|0)?q+(((f+25|0)/9|0)+1<<2)|0:n;n=(c[O+16>>2]|0)+t|0;c[O+16>>2]=n}while((n|0)<0);n=o}else n=o;do if(n>>>0<q>>>0){o=(A-n>>2)*9|0;t=c[n>>2]|0;if(t>>>0<10)break;else r=10;do{r=r*10|0;o=o+1|0}while(t>>>0>=r>>>0)}else o=0;while(0);r=f-((E|32|0)!=102?o:0)+(((f|0)!=0&(E|32|0)==103)<<31>>31)|0;if((r|0)<(((q-A>>2)*9|0)+-9|0)){x=A+4+(((r+9216|0)/9|0)+-1024<<2)|0;if((((r+9216|0)%9|0)+1|0)<9){t=10;u=((r+9216|0)%9|0)+1|0;while(1){r=t*10|0;u=u+1|0;if((u|0)==9)break;else t=r}}else r=10;v=c[x>>2]|0;w=(v>>>0)%(r>>>0)|0;t=(x+4|0)==(q|0);do if(t&(w|0)==0)r=x;else{s=(((v>>>0)/(r>>>0)|0)&1|0)==0?9007199254740992.0:9007199254740994.0;u=(r|0)/2|0;if(w>>>0<u>>>0)p=.5;else p=t&(w|0)==(u|0)?1.0:1.5;do if(B){if((a[C>>0]|0)!=45)break;s=-s;p=-p}while(0);c[x>>2]=v-w;if(!(s+p!=s)){r=x;break}z=v-w+r|0;c[x>>2]=z;if(z>>>0>999999999){o=x;while(1){r=o+-4|0;c[o>>2]=0;if(r>>>0<n>>>0){n=n+-4|0;c[n>>2]=0}z=(c[r>>2]|0)+1|0;c[r>>2]=z;if(z>>>0>999999999)o=r;else break}}else r=x;o=(A-n>>2)*9|0;u=c[n>>2]|0;if(u>>>0<10)break;else t=10;do{t=t*10|0;o=o+1|0}while(u>>>0>=t>>>0)}while(0);y=r+4|0;z=n;n=q>>>0>y>>>0?y:q}else{z=n;n=q}u=0-o|0;y=n;while(1){if(y>>>0<=z>>>0){w=0;break}n=y+-4|0;if(!(c[n>>2]|0))y=n;else{w=1;break}}do if((E|32|0)==103){if((((f|0)!=0^1)+f|0)>(o|0)&(o|0)>-5){t=E+-1|0;f=((f|0)!=0^1)+f+-1-o|0}else{t=E+-2|0;f=((f|0)!=0^1)+f+-1|0}if(F&8|0){r=F&8;break}do if(w){n=c[y+-4>>2]|0;if(!n){q=9;break}if(!((n>>>0)%10|0)){r=10;q=0}else{q=0;break}do{r=r*10|0;q=q+1|0}while(!((n>>>0)%(r>>>0)|0|0))}else q=9;while(0);n=((y-A>>2)*9|0)+-9|0;if((t|32|0)==102){r=n-q|0;r=(r|0)<0?0:r;f=(f|0)<(r|0)?f:r;r=0;break}else{r=n+o-q|0;r=(r|0)<0?0:r;f=(f|0)<(r|0)?f:r;r=0;break}}else{t=E;r=F&8}while(0);v=f|r;q=(t|32|0)==102;if(q){n=(o|0)>0?o:0;u=0}else{n=(o|0)<0?u:o;n=Zh(n,((n|0)<0)<<31>>31,O+576+12|0)|0;if((N-n|0)<2)do{n=n+-1|0;a[n>>0]=48}while((N-n|0)<2);a[n+-1>>0]=(o>>31&2)+43;u=n+-2|0;a[u>>0]=t;n=N-u|0}x=B+1+f+((v|0)!=0&1)+n|0;Ig(e,32,H,x,F);if(!(c[e>>2]&32))Zf(C,B,e)|0;Ig(e,48,H,x,F^65536);do if(q){q=z>>>0>A>>>0?A:z;o=q;do{n=Zh(c[o>>2]|0,0,L)|0;do if((o|0)==(q|0)){if((n|0)!=(L|0))break;a[O+588+8>>0]=48;n=O+588+8|0}else{if(n>>>0<=(O+588|0)>>>0)break;Yi(O+588|0,48,n-M|0)|0;do n=n+-1|0;while(n>>>0>(O+588|0)>>>0)}while(0);if(!(c[e>>2]&32))Zf(n,L-n|0,e)|0;o=o+4|0}while(o>>>0<=A>>>0);do if(v|0){if(c[e>>2]&32|0)break;Zf(46382,1,e)|0}while(0);if((f|0)>0&o>>>0<y>>>0)while(1){n=Zh(c[o>>2]|0,0,L)|0;if(n>>>0>(O+588|0)>>>0){Yi(O+588|0,48,n-M|0)|0;do n=n+-1|0;while(n>>>0>(O+588|0)>>>0)}if(!(c[e>>2]&32))Zf(n,(f|0)>9?9:f,e)|0;o=o+4|0;n=f+-9|0;if(!((f|0)>9&o>>>0<y>>>0)){f=n;break}else f=n}Ig(e,48,f+9|0,9,0)}else{t=w?y:z+4|0;if((f|0)>-1){r=(r|0)==0;q=z;do{n=Zh(c[q>>2]|0,0,L)|0;if((n|0)==(L|0)){a[O+588+8>>0]=48;n=O+588+8|0}do if((q|0)==(z|0)){o=n+1|0;if(!(c[e>>2]&32))Zf(n,1,e)|0;if(r&(f|0)<1){n=o;break}if(c[e>>2]&32|0){n=o;break}Zf(46382,1,e)|0;n=o}else{if(n>>>0<=(O+588|0)>>>0)break;Yi(O+588|0,48,n+(0-M)|0)|0;do n=n+-1|0;while(n>>>0>(O+588|0)>>>0)}while(0);o=L-n|0;if(!(c[e>>2]&32))Zf(n,(f|0)>(o|0)?o:f,e)|0;f=f-o|0;q=q+4|0}while(q>>>0<t>>>0&(f|0)>-1)}Ig(e,48,f+18|0,18,0);if(c[e>>2]&32|0)break;Zf(u,N-u|0,e)|0}while(0);Ig(e,32,H,x,F^8192);f=(x|0)<(H|0)?H:x}else{q=p!=p|0.0!=0.0;n=q?0:B;Ig(e,32,H,n+3|0,o);f=c[e>>2]|0;if(!(f&32)){Zf(C,n,e)|0;f=c[e>>2]|0}if(!(f&32))Zf(q?(E&32|0?46372:46359):E&32|0?46351:46355,3,e)|0;Ig(e,32,H,n+3|0,F^8192);f=(n+3|0)<(H|0)?H:n+3|0}while(0);n=f;r=I;w=G;continue a}default:{f=w;o=F;u=r;w=0;v=44423;n=K}}while(0);g:do if((J|0)==64){n=c[O>>2]|0;o=c[O+4>>2]|0;q=u&32;if(!((n|0)==0&(o|0)==0)){f=K;do{f=f+-1|0;a[f>>0]=d[44407+(n&15)>>0]|q;n=bo(n|0,o|0,4)|0;o=D}while(!((n|0)==0&(o|0)==0));if((t&8|0)==0|(c[O>>2]|0)==0&(c[O+4>>2]|0)==0){n=t;t=0;q=44423;J=77}else{n=t;t=2;q=44423+(u>>4)|0;J=77}}else{f=K;n=t;t=0;q=44423;J=77}}else if((J|0)==76){f=Zh(f,n,K)|0;n=F;t=o;J=77}else if((J|0)==82){J=0;F=vf(n,0,r)|0;f=n;u=(F|0)==0?r:F-n|0;w=0;v=44423;n=(F|0)==0?n+r|0:F}else if((J|0)==86){J=0;o=0;n=0;t=f;while(1){q=c[t>>2]|0;if(!q)break;n=Nr(O+528|0,q)|0;if((n|0)<0|n>>>0>(r-o|0)>>>0)break;o=n+o|0;if(r>>>0>o>>>0)t=t+4|0;else break}if((n|0)<0){m=-1;break a}Ig(e,32,H,o,F);if(!o){f=0;J=97}else{q=0;while(1){n=c[f>>2]|0;if(!n){f=o;J=97;break g}n=Nr(O+528|0,n)|0;q=n+q|0;if((q|0)>(o|0)){f=o;J=97;break g}if(!(c[e>>2]&32))Zf(O+528|0,n,e)|0;if(q>>>0>=o>>>0){f=o;J=97;break}else f=f+4|0}}}while(0);if((J|0)==97){J=0;Ig(e,32,H,f,F^8192);n=(H|0)>(f|0)?H:f;r=I;w=G;continue}if((J|0)==77){J=0;o=(r|0)>-1?n&-65537:n;n=(c[O>>2]|0)!=0|(c[O+4>>2]|0)!=0;if((r|0)!=0|n){u=(n&1^1)+(K-f)|0;u=(r|0)>(u|0)?r:u;w=t;v=q;n=K}else{f=K;u=0;w=t;v=q;n=K}}t=n-f|0;q=(u|0)<(t|0)?t:u;r=w+q|0;n=(H|0)<(r|0)?r:H;Ig(e,32,n,r,o);if(!(c[e>>2]&32))Zf(v,w,e)|0;Ig(e,48,n,r,o^65536);Ig(e,48,q,t,0);if(!(c[e>>2]&32))Zf(f,t,e)|0;Ig(e,32,n,r,o^8192);r=I;w=G}h:do if((J|0)==244)if(!e)if(!r)m=0;else{m=1;while(1){f=c[l+(m<<2)>>2]|0;if(!f){f=0;break}Zd(j+(m<<3)|0,f,g);m=m+1|0;if((m|0)>=10){m=1;break h}}while(1){m=m+1|0;if(f|0){m=-1;break h}if((m|0)>=10){m=1;break h}f=c[l+(m<<2)>>2]|0}}while(0);i=P;return m|0}function ic(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0;o=c[b>>2]|0;n=c[b+4>>2]|0;k=c[b+8>>2]|0;fa=c[b+12>>2]|0;N=c[b+16>>2]|0;M=c[b+20>>2]|0;g=c[b+24>>2]|0;ea=c[b+28>>2]|0;L=c[b+32>>2]|0;q=c[b+36>>2]|0;I=c[d>>2]|0;Oc=c[d+4>>2]|0;cc=c[d+8>>2]|0;sb=c[d+12>>2]|0;Ia=c[d+16>>2]|0;jc=c[d+20>>2]|0;Db=c[d+24>>2]|0;Ta=c[d+28>>2]|0;ga=c[d+32>>2]|0;Pc=c[d+36>>2]|0;Mc=_m(I|0,((I|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;Lc=D;wc=_m(Oc|0,((Oc|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;vc=D;ub=_m(cc|0,((cc|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;tb=D;Ka=_m(sb|0,((sb|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;Ja=D;mc=_m(Ia|0,((Ia|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;lc=D;Gb=_m(jc|0,((jc|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;Fb=D;Wa=_m(Db|0,((Db|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;Va=D;ja=_m(Ta|0,((Ta|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;ia=D;P=_m(ga|0,((ga|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;O=D;o=_m(Pc|0,((Pc|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;l=D;dc=_m(I|0,((I|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;ec=D;yb=_m(Oc|0,((Oc|0)<0)<<31>>31|0,n<<1|0,((n<<1|0)<0)<<31>>31|0)|0;xb=D;Ma=_m(cc|0,((cc|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;La=D;oc=_m(sb|0,((sb|0)<0)<<31>>31|0,n<<1|0,((n<<1|0)<0)<<31>>31|0)|0;nc=D;Ib=_m(Ia|0,((Ia|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;Hb=D;Ya=_m(jc|0,((jc|0)<0)<<31>>31|0,n<<1|0,((n<<1|0)<0)<<31>>31|0)|0;Xa=D;la=_m(Db|0,((Db|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;ka=D;R=_m(Ta|0,((Ta|0)<0)<<31>>31|0,n<<1|0,((n<<1|0)<0)<<31>>31|0)|0;Q=D;t=_m(ga|0,((ga|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;s=D;d=((Pc*19|0)<0)<<31>>31;n=_m(Pc*19|0,d|0,n<<1|0,((n<<1|0)<0)<<31>>31|0)|0;p=D;wb=_m(I|0,((I|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;vb=D;Qa=_m(Oc|0,((Oc|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;Pa=D;qc=_m(cc|0,((cc|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;pc=D;Kb=_m(sb|0,((sb|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;Jb=D;_a=_m(Ia|0,((Ia|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;Za=D;na=_m(jc|0,((jc|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;ma=D;T=_m(Db|0,((Db|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;S=D;v=_m(Ta|0,((Ta|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;u=D;ha=((ga*19|0)<0)<<31>>31;yc=_m(ga*19|0,ha|0,k|0,((k|0)<0)<<31>>31|0)|0;xc=D;k=_m(Pc*19|0,d|0,k|0,((k|0)<0)<<31>>31|0)|0;j=D;Oa=_m(I|0,((I|0)<0)<<31>>31|0,fa|0,((fa|0)<0)<<31>>31|0)|0;Na=D;uc=_m(Oc|0,((Oc|0)<0)<<31>>31|0,fa<<1|0,((fa<<1|0)<0)<<31>>31|0)|0;tc=D;Mb=_m(cc|0,((cc|0)<0)<<31>>31|0,fa|0,((fa|0)<0)<<31>>31|0)|0;Lb=D;ab=_m(sb|0,((sb|0)<0)<<31>>31|0,fa<<1|0,((fa<<1|0)<0)<<31>>31|0)|0;$a=D;pa=_m(Ia|0,((Ia|0)<0)<<31>>31|0,fa|0,((fa|0)<0)<<31>>31|0)|0;oa=D;V=_m(jc|0,((jc|0)<0)<<31>>31|0,fa<<1|0,((fa<<1|0)<0)<<31>>31|0)|0;U=D;x=_m(Db|0,((Db|0)<0)<<31>>31|0,fa|0,((fa|0)<0)<<31>>31|0)|0;w=D;Ua=((Ta*19|0)<0)<<31>>31;Ac=_m(Ta*19|0,Ua|0,fa<<1|0,((fa<<1|0)<0)<<31>>31|0)|0;zc=D;Sb=_m(ga*19|0,ha|0,fa|0,((fa|0)<0)<<31>>31|0)|0;Rb=D;fa=_m(Pc*19|0,d|0,fa<<1|0,((fa<<1|0)<0)<<31>>31|0)|0;f=D;sc=_m(I|0,((I|0)<0)<<31>>31|0,N|0,((N|0)<0)<<31>>31|0)|0;rc=D;Qb=_m(Oc|0,((Oc|0)<0)<<31>>31|0,N|0,((N|0)<0)<<31>>31|0)|0;Pb=D;cb=_m(cc|0,((cc|0)<0)<<31>>31|0,N|0,((N|0)<0)<<31>>31|0)|0;bb=D;ra=_m(sb|0,((sb|0)<0)<<31>>31|0,N|0,((N|0)<0)<<31>>31|0)|0;qa=D;X=_m(Ia|0,((Ia|0)<0)<<31>>31|0,N|0,((N|0)<0)<<31>>31|0)|0;W=D;z=_m(jc|0,((jc|0)<0)<<31>>31|0,N|0,((N|0)<0)<<31>>31|0)|0;y=D;Eb=((Db*19|0)<0)<<31>>31;Cc=_m(Db*19|0,Eb|0,N|0,((N|0)<0)<<31>>31|0)|0;Bc=D;Ub=_m(Ta*19|0,Ua|0,N|0,((N|0)<0)<<31>>31|0)|0;Tb=D;ib=_m(ga*19|0,ha|0,N|0,((N|0)<0)<<31>>31|0)|0;hb=D;N=_m(Pc*19|0,d|0,N|0,((N|0)<0)<<31>>31|0)|0;e=D;Ob=_m(I|0,((I|0)<0)<<31>>31|0,M|0,((M|0)<0)<<31>>31|0)|0;Nb=D;gb=_m(Oc|0,((Oc|0)<0)<<31>>31|0,M<<1|0,((M<<1|0)<0)<<31>>31|0)|0;fb=D;ta=_m(cc|0,((cc|0)<0)<<31>>31|0,M|0,((M|0)<0)<<31>>31|0)|0;sa=D;Z=_m(sb|0,((sb|0)<0)<<31>>31|0,M<<1|0,((M<<1|0)<0)<<31>>31|0)|0;Y=D;B=_m(Ia|0,((Ia|0)<0)<<31>>31|0,M|0,((M|0)<0)<<31>>31|0)|0;A=D;kc=((jc*19|0)<0)<<31>>31;Ec=_m(jc*19|0,kc|0,M<<1|0,((M<<1|0)<0)<<31>>31|0)|0;Dc=D;Wb=_m(Db*19|0,Eb|0,M|0,((M|0)<0)<<31>>31|0)|0;Vb=D;kb=_m(Ta*19|0,Ua|0,M<<1|0,((M<<1|0)<0)<<31>>31|0)|0;jb=D;Aa=_m(ga*19|0,ha|0,M|0,((M|0)<0)<<31>>31|0)|0;za=D;b=_m(Pc*19|0,d|0,M<<1|0,((M<<1|0)<0)<<31>>31|0)|0;M=D;eb=_m(I|0,((I|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;db=D;xa=_m(Oc|0,((Oc|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;wa=D;$=_m(cc|0,((cc|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;_=D;E=_m(sb|0,((sb|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;C=D;Gc=_m(Ia*19|0,((Ia*19|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;Fc=D;Yb=_m(jc*19|0,kc|0,g|0,((g|0)<0)<<31>>31|0)|0;Xb=D;mb=_m(Db*19|0,Eb|0,g|0,((g|0)<0)<<31>>31|0)|0;lb=D;Ca=_m(Ta*19|0,Ua|0,g|0,((g|0)<0)<<31>>31|0)|0;Ba=D;m=_m(ga*19|0,ha|0,g|0,((g|0)<0)<<31>>31|0)|0;r=D;g=_m(Pc*19|0,d|0,g|0,((g|0)<0)<<31>>31|0)|0;ya=D;va=_m(I|0,((I|0)<0)<<31>>31|0,ea|0,((ea|0)<0)<<31>>31|0)|0;ua=D;da=_m(Oc|0,((Oc|0)<0)<<31>>31|0,ea<<1|0,((ea<<1|0)<0)<<31>>31|0)|0;ca=D;G=_m(cc|0,((cc|0)<0)<<31>>31|0,ea|0,((ea|0)<0)<<31>>31|0)|0;F=D;Ic=_m(sb*19|0,((sb*19|0)<0)<<31>>31|0,ea<<1|0,((ea<<1|0)<0)<<31>>31|0)|0;Hc=D;_b=_m(Ia*19|0,((Ia*19|0)<0)<<31>>31|0,ea|0,((ea|0)<0)<<31>>31|0)|0;Zb=D;ob=_m(jc*19|0,kc|0,ea<<1|0,((ea<<1|0)<0)<<31>>31|0)|0;nb=D;Ea=_m(Db*19|0,Eb|0,ea|0,((ea|0)<0)<<31>>31|0)|0;Da=D;gc=_m(Ta*19|0,Ua|0,ea<<1|0,((ea<<1|0)<0)<<31>>31|0)|0;fc=D;Ab=_m(ga*19|0,ha|0,ea|0,((ea|0)<0)<<31>>31|0)|0;zb=D;ea=_m(Pc*19|0,d|0,ea<<1|0,((ea<<1|0)<0)<<31>>31|0)|0;i=D;ba=_m(I|0,((I|0)<0)<<31>>31|0,L|0,((L|0)<0)<<31>>31|0)|0;aa=D;K=_m(Oc|0,((Oc|0)<0)<<31>>31|0,L|0,((L|0)<0)<<31>>31|0)|0;J=D;Kc=_m(cc*19|0,((cc*19|0)<0)<<31>>31|0,L|0,((L|0)<0)<<31>>31|0)|0;Jc=D;ac=_m(sb*19|0,((sb*19|0)<0)<<31>>31|0,L|0,((L|0)<0)<<31>>31|0)|0;$b=D;qb=_m(Ia*19|0,((Ia*19|0)<0)<<31>>31|0,L|0,((L|0)<0)<<31>>31|0)|0;pb=D;Ga=_m(jc*19|0,kc|0,L|0,((L|0)<0)<<31>>31|0)|0;Fa=D;ic=_m(Db*19|0,Eb|0,L|0,((L|0)<0)<<31>>31|0)|0;hc=D;Cb=_m(Ta*19|0,Ua|0,L|0,((L|0)<0)<<31>>31|0)|0;Bb=D;Sa=_m(ga*19|0,ha|0,L|0,((L|0)<0)<<31>>31|0)|0;Ra=D;L=_m(Pc*19|0,d|0,L|0,((L|0)<0)<<31>>31|0)|0;h=D;I=_m(I|0,((I|0)<0)<<31>>31|0,q|0,((q|0)<0)<<31>>31|0)|0;H=D;Oc=_m(Oc*19|0,((Oc*19|0)<0)<<31>>31|0,q<<1|0,((q<<1|0)<0)<<31>>31|0)|0;Nc=D;cc=_m(cc*19|0,((cc*19|0)<0)<<31>>31|0,q|0,((q|0)<0)<<31>>31|0)|0;bc=D;sb=_m(sb*19|0,((sb*19|0)<0)<<31>>31|0,q<<1|0,((q<<1|0)<0)<<31>>31|0)|0;rb=D;Ia=_m(Ia*19|0,((Ia*19|0)<0)<<31>>31|0,q|0,((q|0)<0)<<31>>31|0)|0;Ha=D;kc=_m(jc*19|0,kc|0,q<<1|0,((q<<1|0)<0)<<31>>31|0)|0;jc=D;Eb=_m(Db*19|0,Eb|0,q|0,((q|0)<0)<<31>>31|0)|0;Db=D;Ua=_m(Ta*19|0,Ua|0,q<<1|0,((q<<1|0)<0)<<31>>31|0)|0;Ta=D;ha=_m(ga*19|0,ha|0,q|0,((q|0)<0)<<31>>31|0)|0;ga=D;q=_m(Pc*19|0,d|0,q<<1|0,((q<<1|0)<0)<<31>>31|0)|0;d=D;Lc=Jp(Oc|0,Nc|0,Mc|0,Lc|0)|0;Jc=Jp(Lc|0,D|0,Kc|0,Jc|0)|0;Hc=Jp(Jc|0,D|0,Ic|0,Hc|0)|0;Fc=Jp(Hc|0,D|0,Gc|0,Fc|0)|0;Dc=Jp(Fc|0,D|0,Ec|0,Dc|0)|0;Bc=Jp(Dc|0,D|0,Cc|0,Bc|0)|0;zc=Jp(Bc|0,D|0,Ac|0,zc|0)|0;xc=Jp(zc|0,D|0,yc|0,xc|0)|0;p=Jp(xc|0,D|0,n|0,p|0)|0;n=D;ec=Jp(wc|0,vc|0,dc|0,ec|0)|0;dc=D;rc=Jp(uc|0,tc|0,sc|0,rc|0)|0;pc=Jp(rc|0,D|0,qc|0,pc|0)|0;nc=Jp(pc|0,D|0,oc|0,nc|0)|0;lc=Jp(nc|0,D|0,mc|0,lc|0)|0;jc=Jp(lc|0,D|0,kc|0,jc|0)|0;hc=Jp(jc|0,D|0,ic|0,hc|0)|0;fc=Jp(hc|0,D|0,gc|0,fc|0)|0;r=Jp(fc|0,D|0,m|0,r|0)|0;M=Jp(r|0,D|0,b|0,M|0)|0;b=D;r=Jp(p|0,n|0,33554432,0)|0;r=ln(r|0,D|0,26)|0;m=D;bc=Jp(ec|0,dc|0,cc|0,bc|0)|0;$b=Jp(bc|0,D|0,ac|0,$b|0)|0;Zb=Jp($b|0,D|0,_b|0,Zb|0)|0;Xb=Jp(Zb|0,D|0,Yb|0,Xb|0)|0;Vb=Jp(Xb|0,D|0,Wb|0,Vb|0)|0;Tb=Jp(Vb|0,D|0,Ub|0,Tb|0)|0;Rb=Jp(Tb|0,D|0,Sb|0,Rb|0)|0;j=Jp(Rb|0,D|0,k|0,j|0)|0;j=Jp(j|0,D|0,r|0,m|0)|0;k=D;m=_n(r|0,m|0,26)|0;m=mo(p|0,n|0,m|0,D|0)|0;n=D;p=Jp(M|0,b|0,33554432,0)|0;p=ln(p|0,D|0,26)|0;r=D;Nb=Jp(Qb|0,Pb|0,Ob|0,Nb|0)|0;Lb=Jp(Nb|0,D|0,Mb|0,Lb|0)|0;Jb=Jp(Lb|0,D|0,Kb|0,Jb|0)|0;Hb=Jp(Jb|0,D|0,Ib|0,Hb|0)|0;Fb=Jp(Hb|0,D|0,Gb|0,Fb|0)|0;Db=Jp(Fb|0,D|0,Eb|0,Db|0)|0;Bb=Jp(Db|0,D|0,Cb|0,Bb|0)|0;zb=Jp(Bb|0,D|0,Ab|0,zb|0)|0;ya=Jp(zb|0,D|0,g|0,ya|0)|0;ya=Jp(ya|0,D|0,p|0,r|0)|0;g=D;r=_n(p|0,r|0,26)|0;r=mo(M|0,b|0,r|0,D|0)|0;b=D;M=Jp(j|0,k|0,16777216,0)|0;M=ln(M|0,D|0,25)|0;p=D;vb=Jp(yb|0,xb|0,wb|0,vb|0)|0;tb=Jp(vb|0,D|0,ub|0,tb|0)|0;rb=Jp(tb|0,D|0,sb|0,rb|0)|0;pb=Jp(rb|0,D|0,qb|0,pb|0)|0;nb=Jp(pb|0,D|0,ob|0,nb|0)|0;lb=Jp(nb|0,D|0,mb|0,lb|0)|0;jb=Jp(lb|0,D|0,kb|0,jb|0)|0;hb=Jp(jb|0,D|0,ib|0,hb|0)|0;f=Jp(hb|0,D|0,fa|0,f|0)|0;f=Jp(f|0,D|0,M|0,p|0)|0;fa=D;p=_n(M|0,p|0,25)|0;p=mo(j|0,k|0,p|0,D|0)|0;k=D;j=Jp(ya|0,g|0,16777216,0)|0;j=ln(j|0,D|0,25)|0;M=D;db=Jp(gb|0,fb|0,eb|0,db|0)|0;bb=Jp(db|0,D|0,cb|0,bb|0)|0;$a=Jp(bb|0,D|0,ab|0,$a|0)|0;Za=Jp($a|0,D|0,_a|0,Za|0)|0;Xa=Jp(Za|0,D|0,Ya|0,Xa|0)|0;Va=Jp(Xa|0,D|0,Wa|0,Va|0)|0;Ta=Jp(Va|0,D|0,Ua|0,Ta|0)|0;Ra=Jp(Ta|0,D|0,Sa|0,Ra|0)|0;i=Jp(Ra|0,D|0,ea|0,i|0)|0;i=Jp(i|0,D|0,j|0,M|0)|0;ea=D;M=_n(j|0,M|0,25)|0;M=mo(ya|0,g|0,M|0,D|0)|0;g=D;ya=Jp(f|0,fa|0,33554432,0)|0;ya=ln(ya|0,D|0,26)|0;j=D;Na=Jp(Qa|0,Pa|0,Oa|0,Na|0)|0;La=Jp(Na|0,D|0,Ma|0,La|0)|0;Ja=Jp(La|0,D|0,Ka|0,Ja|0)|0;Ha=Jp(Ja|0,D|0,Ia|0,Ha|0)|0;Fa=Jp(Ha|0,D|0,Ga|0,Fa|0)|0;Da=Jp(Fa|0,D|0,Ea|0,Da|0)|0;Ba=Jp(Da|0,D|0,Ca|0,Ba|0)|0;za=Jp(Ba|0,D|0,Aa|0,za|0)|0;e=Jp(za|0,D|0,N|0,e|0)|0;e=Jp(e|0,D|0,ya|0,j|0)|0;N=D;j=_n(ya|0,j|0,26)|0;j=mo(f|0,fa|0,j|0,D|0)|0;fa=Jp(i|0,ea|0,33554432,0)|0;fa=ln(fa|0,D|0,26)|0;f=D;ua=Jp(xa|0,wa|0,va|0,ua|0)|0;sa=Jp(ua|0,D|0,ta|0,sa|0)|0;qa=Jp(sa|0,D|0,ra|0,qa|0)|0;oa=Jp(qa|0,D|0,pa|0,oa|0)|0;ma=Jp(oa|0,D|0,na|0,ma|0)|0;ka=Jp(ma|0,D|0,la|0,ka|0)|0;ia=Jp(ka|0,D|0,ja|0,ia|0)|0;ga=Jp(ia|0,D|0,ha|0,ga|0)|0;h=Jp(ga|0,D|0,L|0,h|0)|0;h=Jp(h|0,D|0,fa|0,f|0)|0;L=D;f=_n(fa|0,f|0,26)|0;f=mo(i|0,ea|0,f|0,D|0)|0;ea=Jp(e|0,N|0,16777216,0)|0;ea=ln(ea|0,D|0,25)|0;i=D;b=Jp(ea|0,i|0,r|0,b|0)|0;r=D;i=_n(ea|0,i|0,25)|0;i=mo(e|0,N|0,i|0,D|0)|0;N=Jp(h|0,L|0,16777216,0)|0;N=ln(N|0,D|0,25)|0;e=D;aa=Jp(da|0,ca|0,ba|0,aa|0)|0;_=Jp(aa|0,D|0,$|0,_|0)|0;Y=Jp(_|0,D|0,Z|0,Y|0)|0;W=Jp(Y|0,D|0,X|0,W|0)|0;U=Jp(W|0,D|0,V|0,U|0)|0;S=Jp(U|0,D|0,T|0,S|0)|0;Q=Jp(S|0,D|0,R|0,Q|0)|0;O=Jp(Q|0,D|0,P|0,O|0)|0;d=Jp(O|0,D|0,q|0,d|0)|0;d=Jp(d|0,D|0,N|0,e|0)|0;q=D;e=_n(N|0,e|0,25)|0;e=mo(h|0,L|0,e|0,D|0)|0;L=Jp(b|0,r|0,33554432,0)|0;L=ln(L|0,D|0,26)|0;h=D;g=Jp(M|0,g|0,L|0,h|0)|0;h=_n(L|0,h|0,26)|0;h=mo(b|0,r|0,h|0,D|0)|0;r=Jp(d|0,q|0,33554432,0)|0;r=ln(r|0,D|0,26)|0;b=D;H=Jp(K|0,J|0,I|0,H|0)|0;F=Jp(H|0,D|0,G|0,F|0)|0;C=Jp(F|0,D|0,E|0,C|0)|0;A=Jp(C|0,D|0,B|0,A|0)|0;y=Jp(A|0,D|0,z|0,y|0)|0;w=Jp(y|0,D|0,x|0,w|0)|0;u=Jp(w|0,D|0,v|0,u|0)|0;s=Jp(u|0,D|0,t|0,s|0)|0;l=Jp(s|0,D|0,o|0,l|0)|0;l=Jp(l|0,D|0,r|0,b|0)|0;o=D;b=_n(r|0,b|0,26)|0;b=mo(d|0,q|0,b|0,D|0)|0;q=Jp(l|0,o|0,16777216,0)|0;q=ln(q|0,D|0,25)|0;d=D;r=_m(q|0,d|0,19,0)|0;n=Jp(r|0,D|0,m|0,n|0)|0;m=D;d=_n(q|0,d|0,25)|0;d=mo(l|0,o|0,d|0,D|0)|0;o=Jp(n|0,m|0,33554432,0)|0;o=ln(o|0,D|0,26)|0;l=D;k=Jp(p|0,k|0,o|0,l|0)|0;l=_n(o|0,l|0,26)|0;l=mo(n|0,m|0,l|0,D|0)|0;c[a>>2]=l;c[a+4>>2]=k;c[a+8>>2]=j;c[a+12>>2]=i;c[a+16>>2]=h;c[a+20>>2]=g;c[a+24>>2]=f;c[a+28>>2]=e;c[a+32>>2]=b;c[a+36>>2]=d;return}function jc(e,f,j){e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=i;z=i=i+63&-64;i=i+304|0;k=a[f>>0]|0;a:do if(k<<24>>24){y=z+33+10|0;m=k;k=0;q=f;s=0;l=0;f=0;b:while(1){c:do if(!(Kt(m&255)|0)){m=m<<24>>24==37;d:do if(m){p=q+1|0;n=a[p>>0]|0;e:do switch(n<<24>>24){case 37:break d;case 42:{m=0;p=q+2|0;break}default:{if(((n&255)+-48|0)>>>0<10?(a[q+2>>0]|0)==36:0){c[z+16>>2]=c[j>>2];n=(n&255)+-48|0;while(1){x=(c[z+16>>2]|0)+(4-1)&~(4-1);m=c[x>>2]|0;c[z+16>>2]=x+4;if(n>>>0>1)n=n+-1|0;else break}p=q+3|0;break e}x=(c[j>>2]|0)+(4-1)&~(4-1);m=c[x>>2]|0;c[j>>2]=x+4}}while(0);n=a[p>>0]|0;if(((n&255)+-48|0)>>>0<10){r=n&255;n=0;while(1){q=(n*10|0)+-48+r|0;p=p+1|0;n=a[p>>0]|0;r=n&255;if((r+-48|0)>>>0>=10){r=q;break}else n=q}}else r=0;if(n<<24>>24==109){p=p+1|0;n=a[p>>0]|0;x=(m|0)!=0&1;l=0;f=0}else x=0;q=p+1|0;switch(n&255|0){case 104:{w=(a[q>>0]|0)==104;n=w?p+2|0:q;p=w?-2:-1;break}case 108:{w=(a[q>>0]|0)==108;n=w?p+2|0:q;p=w?3:1;break}case 106:{n=q;p=3;break}case 116:case 122:{n=q;p=1;break}case 76:{n=q;p=2;break}case 110:case 112:case 67:case 83:case 91:case 99:case 115:case 88:case 71:case 70:case 69:case 65:case 103:case 102:case 101:case 97:case 120:case 117:case 111:case 105:case 100:{n=p;p=0;break}default:{A=152;break b}}v=d[n>>0]|0;u=(v&47|0)==3?v|32:v;v=(v&47|0)==3?1:p;switch(u|0){case 99:{w=s;t=(r|0)<1?1:r;break}case 91:{w=s;t=r;break}case 110:{if(!m){p=s;break c}switch(v|0){case -2:{a[m>>0]=s;p=s;break c}case -1:{b[m>>1]=s;p=s;break c}case 0:{c[m>>2]=s;p=s;break c}case 1:{c[m>>2]=s;p=s;break c}case 3:{p=m;c[p>>2]=s;c[p+4>>2]=((s|0)<0)<<31>>31;p=s;break c}default:{p=s;break c}}}default:{Ml(e,0);do{p=c[e+4>>2]|0;if(p>>>0<(c[e+100>>2]|0)>>>0){c[e+4>>2]=p+1;p=d[p>>0]|0}else p=ug(e)|0}while((Kt(p)|0)!=0);if(!(c[e+100>>2]|0))p=c[e+4>>2]|0;else{p=(c[e+4>>2]|0)+-1|0;c[e+4>>2]=p}w=(c[e+108>>2]|0)+s+p-(c[e+8>>2]|0)|0;t=r}}Ml(e,t);p=c[e+4>>2]|0;q=c[e+100>>2]|0;if(p>>>0<q>>>0)c[e+4>>2]=p+1;else{if((ug(e)|0)<0){A=152;break b}q=c[e+100>>2]|0}if(q|0)c[e+4>>2]=(c[e+4>>2]|0)+-1;f:do switch(u|0){case 91:case 99:case 115:{g:do if((u|16|0)==115){Yi(z+33|0,-1,257)|0;a[z+33>>0]=0;if((u|0)==115){a[z+33+33>>0]=0;a[y>>0]=0;a[y+1>>0]=0;a[y+2>>0]=0;a[y+3>>0]=0;a[y+4>>0]=0}}else{s=n+1|0;p=(a[s>>0]|0)==94;n=p?n+2|0:s;Yi(z+33|0,p&1|0,257)|0;a[z+33>>0]=0;switch(a[n>>0]|0){case 45:{a[z+33+46>>0]=p&1^1;s=(p&1^1)&255;n=n+1|0;break}case 93:{a[z+33+94>>0]=p&1^1;s=(p&1^1)&255;n=n+1|0;break}default:s=(p&1^1)&255}while(1){p=a[n>>0]|0;h:do switch(p<<24>>24){case 0:{A=152;break b}case 93:break g;case 45:{r=n+1|0;p=a[r>>0]|0;switch(p<<24>>24){case 93:case 0:{p=45;break h}default:{}}n=a[n+-1>>0]|0;if((n&255)<(p&255)){n=n&255;do{n=n+1|0;a[z+33+n>>0]=s;p=a[r>>0]|0}while((n|0)<(p&255|0));n=r}else n=r;break}default:{}}while(0);a[z+33+((p&255)+1)>>0]=s;n=n+1|0}}while(0);r=(u|0)==99?t+1|0:31;s=(x|0)!=0;i:do if((v|0)==1){if(s){f=ec(r<<2)|0;if(!f){l=0;A=152;break b}}else f=m;c[z+8>>2]=0;c[z+8+4>>2]=0;l=0;j:while(1){q=(f|0)==0;do{k:while(1){p=c[e+4>>2]|0;if(p>>>0<(c[e+100>>2]|0)>>>0){c[e+4>>2]=p+1;p=d[p>>0]|0}else p=ug(e)|0;if(!(a[z+33+(p+1)>>0]|0))break j;a[z+32>>0]=p;switch(Pe(z,z+32|0,1,z+8|0)|0){case -1:{l=0;A=152;break b}case -2:break;default:break k}}if(!q){c[f+(l<<2)>>2]=c[z>>2];l=l+1|0}}while(!(s&(l|0)==(r|0)));l=r<<1|1;p=$h(f,l<<2)|0;if(!p){l=0;A=152;break b}else{q=r;r=l;f=p;l=q}}if(!(ds(z+8|0)|0)){l=0;A=152;break b}else{q=l;l=0}}else{if(s){l=ec(r)|0;if(!l){l=0;f=0;A=152;break b}else p=0;while(1){do{f=c[e+4>>2]|0;if(f>>>0<(c[e+100>>2]|0)>>>0){c[e+4>>2]=f+1;f=d[f>>0]|0}else f=ug(e)|0;if(!(a[z+33+(f+1)>>0]|0)){q=p;f=0;break i}a[l+p>>0]=f;p=p+1|0}while((p|0)!=(r|0));f=r<<1|1;p=$h(l,f)|0;if(!p){f=0;A=152;break b}else{q=r;r=f;l=p;p=q}}}if(!m){l=q;while(1){f=c[e+4>>2]|0;if(f>>>0<l>>>0){c[e+4>>2]=f+1;f=d[f>>0]|0}else f=ug(e)|0;if(!(a[z+33+(f+1)>>0]|0)){q=0;l=0;f=0;break i}l=c[e+100>>2]|0}}else{l=0;while(1){f=c[e+4>>2]|0;if(f>>>0<q>>>0){c[e+4>>2]=f+1;f=d[f>>0]|0}else f=ug(e)|0;if(!(a[z+33+(f+1)>>0]|0)){q=l;l=m;f=0;break i}a[m+l>>0]=f;q=c[e+100>>2]|0;l=l+1|0}}}while(0);if(!(c[e+100>>2]|0))p=c[e+4>>2]|0;else{p=(c[e+4>>2]|0)+-1|0;c[e+4>>2]=p}p=p-(c[e+8>>2]|0)+(c[e+108>>2]|0)|0;if(!p){m=x;break b}if(!((p|0)==(t|0)|(u|0)==99^1)){m=x;break b}do if(s)if((v|0)==1){c[m>>2]=f;break}else{c[m>>2]=l;break}while(0);if((u|0)!=99){if(f|0)c[f+(q<<2)>>2]=0;if(!l){l=0;break f}a[l+q>>0]=0}break}case 120:case 88:case 112:{p=16;A=134;break}case 111:{p=8;A=134;break}case 117:case 100:{p=10;A=134;break}case 105:{p=0;A=134;break}case 71:case 103:case 70:case 102:case 69:case 101:case 65:case 97:{o=+gc(e,v,0);if((c[e+108>>2]|0)==((c[e+8>>2]|0)-(c[e+4>>2]|0)|0)){m=x;break b}if(m)switch(v|0){case 0:{g[m>>2]=o;break f}case 1:{h[m>>3]=o;break f}case 2:{h[m>>3]=o;break f}default:break f}break}default:{}}while(0);l:do if((A|0)==134){A=0;p=sc(e,p,0,-1,-1)|0;if((c[e+108>>2]|0)==((c[e+8>>2]|0)-(c[e+4>>2]|0)|0)){m=x;break b}if((m|0)!=0&(u|0)==112){c[m>>2]=p;break}if(m)switch(v|0){case -2:{a[m>>0]=p;break l}case -1:{b[m>>1]=p;break l}case 0:{c[m>>2]=p;break l}case 1:{c[m>>2]=p;break l}case 3:{x=m;c[x>>2]=p;c[x+4>>2]=D;break l}default:break l}}while(0);k=((m|0)!=0&1)+k|0;p=(c[e+108>>2]|0)+w+(c[e+4>>2]|0)-(c[e+8>>2]|0)|0;break c}while(0);n=q+(m&1)|0;Ml(e,0);m=c[e+4>>2]|0;if(m>>>0<(c[e+100>>2]|0)>>>0){c[e+4>>2]=m+1;m=d[m>>0]|0}else m=ug(e)|0;if((m|0)!=(d[n>>0]|0)){A=20;break b}p=s+1|0}else{n=q;while(1){m=n+1|0;if(!(Kt(d[m>>0]|0)|0))break;else n=m}Ml(e,0);do{m=c[e+4>>2]|0;if(m>>>0<(c[e+100>>2]|0)>>>0){c[e+4>>2]=m+1;m=d[m>>0]|0}else m=ug(e)|0}while((Kt(m)|0)!=0);if(!(c[e+100>>2]|0))m=c[e+4>>2]|0;else{m=(c[e+4>>2]|0)+-1|0;c[e+4>>2]=m}p=(c[e+108>>2]|0)+s+m-(c[e+8>>2]|0)|0}while(0);q=n+1|0;m=a[q>>0]|0;if(!(m<<24>>24))break a;else s=p}if((A|0)==20){if(c[e+100>>2]|0)c[e+4>>2]=(c[e+4>>2]|0)+-1;if((k|0)!=0|(m|0)>-1)break;else{k=0;A=153}}else if((A|0)==152)if(!k){k=x;A=153}else m=x;if((A|0)==153){m=k;k=-1}if(m){nc(l);nc(f)}}else k=0;while(0);i=B;return k|0}function kc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0;l=c[b>>2]|0;n=c[b+4>>2]|0;k=c[b+8>>2]|0;f=c[b+12>>2]|0;u=c[b+16>>2]|0;t=c[b+20>>2]|0;g=c[b+24>>2]|0;v=c[b+28>>2]|0;s=c[b+32>>2]|0;q=c[b+36>>2]|0;cb=_m(l|0,((l|0)<0)<<31>>31|0,l|0,((l|0)<0)<<31>>31|0)|0;bb=D;o=((l<<1|0)<0)<<31>>31;Ua=_m(l<<1|0,o|0,n|0,((n|0)<0)<<31>>31|0)|0;Ta=D;Oa=_m(k|0,((k|0)<0)<<31>>31|0,l<<1|0,o|0)|0;Na=D;Ea=_m(f|0,((f|0)<0)<<31>>31|0,l<<1|0,o|0)|0;Da=D;sa=_m(u|0,((u|0)<0)<<31>>31|0,l<<1|0,o|0)|0;ra=D;ia=_m(t|0,((t|0)<0)<<31>>31|0,l<<1|0,o|0)|0;ha=D;_=_m(g|0,((g|0)<0)<<31>>31|0,l<<1|0,o|0)|0;Z=D;Q=_m(v|0,((v|0)<0)<<31>>31|0,l<<1|0,o|0)|0;P=D;G=_m(s|0,((s|0)<0)<<31>>31|0,l<<1|0,o|0)|0;F=D;o=_m(q|0,((q|0)<0)<<31>>31|0,l<<1|0,o|0)|0;l=D;p=((n<<1|0)<0)<<31>>31;Ma=_m(n<<1|0,p|0,n|0,((n|0)<0)<<31>>31|0)|0;La=D;Ca=_m(n<<1|0,p|0,k|0,((k|0)<0)<<31>>31|0)|0;Ba=D;w=((f<<1|0)<0)<<31>>31;wa=_m(f<<1|0,w|0,n<<1|0,p|0)|0;va=D;ma=_m(u|0,((u|0)<0)<<31>>31|0,n<<1|0,p|0)|0;la=D;aa=_m(t<<1|0,((t<<1|0)<0)<<31>>31|0,n<<1|0,p|0)|0;$=D;S=_m(g|0,((g|0)<0)<<31>>31|0,n<<1|0,p|0)|0;R=D;I=_m(v<<1|0,((v<<1|0)<0)<<31>>31|0,n<<1|0,p|0)|0;H=D;m=_m(s|0,((s|0)<0)<<31>>31|0,n<<1|0,p|0)|0;r=D;b=((q*38|0)<0)<<31>>31;p=_m(q*38|0,b|0,n<<1|0,p|0)|0;n=D;ua=_m(k|0,((k|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;ta=D;ka=_m(k<<1|0,((k<<1|0)<0)<<31>>31|0,f|0,((f|0)<0)<<31>>31|0)|0;ja=D;ca=_m(u|0,((u|0)<0)<<31>>31|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;ba=D;W=_m(t|0,((t|0)<0)<<31>>31|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;V=D;O=_m(g|0,((g|0)<0)<<31>>31|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;N=D;z=_m(v|0,((v|0)<0)<<31>>31|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;y=D;Y=((s*19|0)<0)<<31>>31;Ya=_m(s*19|0,Y|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;Xa=D;k=_m(q*38|0,b|0,k|0,((k|0)<0)<<31>>31|0)|0;j=D;ea=_m(f<<1|0,w|0,f|0,((f|0)<0)<<31>>31|0)|0;da=D;U=_m(f<<1|0,w|0,u|0,((u|0)<0)<<31>>31|0)|0;T=D;K=_m(t<<1|0,((t<<1|0)<0)<<31>>31|0,f<<1|0,w|0)|0;J=D;E=_m(g|0,((g|0)<0)<<31>>31|0,f<<1|0,w|0)|0;C=D;qa=((v*38|0)<0)<<31>>31;_a=_m(v*38|0,qa|0,f<<1|0,w|0)|0;Za=D;Qa=_m(s*19|0,Y|0,f<<1|0,w|0)|0;Pa=D;w=_m(q*38|0,b|0,f<<1|0,w|0)|0;f=D;M=_m(u|0,((u|0)<0)<<31>>31|0,u|0,((u|0)<0)<<31>>31|0)|0;L=D;B=_m(u<<1|0,((u<<1|0)<0)<<31>>31|0,t|0,((t|0)<0)<<31>>31|0)|0;A=D;ab=_m(g*19|0,((g*19|0)<0)<<31>>31|0,u<<1|0,((u<<1|0)<0)<<31>>31|0)|0;$a=D;Sa=_m(v*38|0,qa|0,u|0,((u|0)<0)<<31>>31|0)|0;Ra=D;Ga=_m(s*19|0,Y|0,u<<1|0,((u<<1|0)<0)<<31>>31|0)|0;Fa=D;u=_m(q*38|0,b|0,u|0,((u|0)<0)<<31>>31|0)|0;e=D;eb=_m(t*38|0,((t*38|0)<0)<<31>>31|0,t|0,((t|0)<0)<<31>>31|0)|0;db=D;Wa=_m(g*19|0,((g*19|0)<0)<<31>>31|0,t<<1|0,((t<<1|0)<0)<<31>>31|0)|0;Va=D;Ia=_m(v*38|0,qa|0,t<<1|0,((t<<1|0)<0)<<31>>31|0)|0;Ha=D;ya=_m(s*19|0,Y|0,t<<1|0,((t<<1|0)<0)<<31>>31|0)|0;xa=D;t=_m(q*38|0,b|0,t<<1|0,((t<<1|0)<0)<<31>>31|0)|0;d=D;Ka=_m(g*19|0,((g*19|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;Ja=D;Aa=_m(v*38|0,qa|0,g|0,((g|0)<0)<<31>>31|0)|0;za=D;oa=_m(s*19|0,Y|0,g<<1|0,((g<<1|0)<0)<<31>>31|0)|0;na=D;g=_m(q*38|0,b|0,g|0,((g|0)<0)<<31>>31|0)|0;x=D;qa=_m(v*38|0,qa|0,v|0,((v|0)<0)<<31>>31|0)|0;pa=D;ga=_m(s*19|0,Y|0,v<<1|0,((v<<1|0)<0)<<31>>31|0)|0;fa=D;v=_m(q*38|0,b|0,v<<1|0,((v<<1|0)<0)<<31>>31|0)|0;i=D;Y=_m(s*19|0,Y|0,s|0,((s|0)<0)<<31>>31|0)|0;X=D;s=_m(q*38|0,b|0,s|0,((s|0)<0)<<31>>31|0)|0;h=D;q=_m(q*38|0,b|0,q|0,((q|0)<0)<<31>>31|0)|0;b=D;bb=Jp(eb|0,db|0,cb|0,bb|0)|0;$a=Jp(bb|0,D|0,ab|0,$a|0)|0;Za=Jp($a|0,D|0,_a|0,Za|0)|0;Xa=Jp(Za|0,D|0,Ya|0,Xa|0)|0;n=Jp(Xa|0,D|0,p|0,n|0)|0;p=D;Ta=Jp(Wa|0,Va|0,Ua|0,Ta|0)|0;Ra=Jp(Ta|0,D|0,Sa|0,Ra|0)|0;Pa=Jp(Ra|0,D|0,Qa|0,Pa|0)|0;j=Jp(Pa|0,D|0,k|0,j|0)|0;k=D;La=Jp(Oa|0,Na|0,Ma|0,La|0)|0;Ja=Jp(La|0,D|0,Ka|0,Ja|0)|0;Ha=Jp(Ja|0,D|0,Ia|0,Ha|0)|0;Fa=Jp(Ha|0,D|0,Ga|0,Fa|0)|0;f=Jp(Fa|0,D|0,w|0,f|0)|0;w=D;Ba=Jp(Ea|0,Da|0,Ca|0,Ba|0)|0;za=Jp(Ba|0,D|0,Aa|0,za|0)|0;xa=Jp(za|0,D|0,ya|0,xa|0)|0;e=Jp(xa|0,D|0,u|0,e|0)|0;u=D;ta=Jp(wa|0,va|0,ua|0,ta|0)|0;ra=Jp(ta|0,D|0,sa|0,ra|0)|0;pa=Jp(ra|0,D|0,qa|0,pa|0)|0;na=Jp(pa|0,D|0,oa|0,na|0)|0;d=Jp(na|0,D|0,t|0,d|0)|0;t=D;ja=Jp(ma|0,la|0,ka|0,ja|0)|0;ha=Jp(ja|0,D|0,ia|0,ha|0)|0;fa=Jp(ha|0,D|0,ga|0,fa|0)|0;x=Jp(fa|0,D|0,g|0,x|0)|0;g=D;ba=Jp(ea|0,da|0,ca|0,ba|0)|0;$=Jp(ba|0,D|0,aa|0,$|0)|0;Z=Jp($|0,D|0,_|0,Z|0)|0;X=Jp(Z|0,D|0,Y|0,X|0)|0;i=Jp(X|0,D|0,v|0,i|0)|0;v=D;T=Jp(W|0,V|0,U|0,T|0)|0;R=Jp(T|0,D|0,S|0,R|0)|0;P=Jp(R|0,D|0,Q|0,P|0)|0;h=Jp(P|0,D|0,s|0,h|0)|0;s=D;L=Jp(O|0,N|0,M|0,L|0)|0;J=Jp(L|0,D|0,K|0,J|0)|0;H=Jp(J|0,D|0,I|0,H|0)|0;F=Jp(H|0,D|0,G|0,F|0)|0;b=Jp(F|0,D|0,q|0,b|0)|0;q=D;A=Jp(E|0,C|0,B|0,A|0)|0;y=Jp(A|0,D|0,z|0,y|0)|0;r=Jp(y|0,D|0,m|0,r|0)|0;l=Jp(r|0,D|0,o|0,l|0)|0;o=D;p=_n(n|0,p|0,1)|0;n=D;k=_n(j|0,k|0,1)|0;j=D;w=_n(f|0,w|0,1)|0;f=D;u=_n(e|0,u|0,1)|0;e=D;t=_n(d|0,t|0,1)|0;d=D;g=_n(x|0,g|0,1)|0;x=D;v=_n(i|0,v|0,1)|0;i=D;s=_n(h|0,s|0,1)|0;h=D;q=_n(b|0,q|0,1)|0;b=D;o=_n(l|0,o|0,1)|0;l=D;r=Jp(p|0,n|0,33554432,0)|0;r=ln(r|0,D|0,26)|0;m=D;j=Jp(r|0,m|0,k|0,j|0)|0;k=D;m=_n(r|0,m|0,26)|0;m=mo(p|0,n|0,m|0,D|0)|0;n=D;p=Jp(t|0,d|0,33554432,0)|0;p=ln(p|0,D|0,26)|0;r=D;x=Jp(p|0,r|0,g|0,x|0)|0;g=D;r=_n(p|0,r|0,26)|0;r=mo(t|0,d|0,r|0,D|0)|0;d=D;t=Jp(j|0,k|0,16777216,0)|0;t=ln(t|0,D|0,25)|0;p=D;f=Jp(t|0,p|0,w|0,f|0)|0;w=D;p=_n(t|0,p|0,25)|0;p=mo(j|0,k|0,p|0,D|0)|0;k=D;j=Jp(x|0,g|0,16777216,0)|0;j=ln(j|0,D|0,25)|0;t=D;i=Jp(j|0,t|0,v|0,i|0)|0;v=D;t=_n(j|0,t|0,25)|0;t=mo(x|0,g|0,t|0,D|0)|0;g=D;x=Jp(f|0,w|0,33554432,0)|0;x=ln(x|0,D|0,26)|0;j=D;e=Jp(x|0,j|0,u|0,e|0)|0;u=D;j=_n(x|0,j|0,26)|0;j=mo(f|0,w|0,j|0,D|0)|0;w=Jp(i|0,v|0,33554432,0)|0;w=ln(w|0,D|0,26)|0;f=D;h=Jp(w|0,f|0,s|0,h|0)|0;s=D;f=_n(w|0,f|0,26)|0;f=mo(i|0,v|0,f|0,D|0)|0;v=Jp(e|0,u|0,16777216,0)|0;v=ln(v|0,D|0,25)|0;i=D;d=Jp(v|0,i|0,r|0,d|0)|0;r=D;i=_n(v|0,i|0,25)|0;i=mo(e|0,u|0,i|0,D|0)|0;u=Jp(h|0,s|0,16777216,0)|0;u=ln(u|0,D|0,25)|0;e=D;b=Jp(u|0,e|0,q|0,b|0)|0;q=D;e=_n(u|0,e|0,25)|0;e=mo(h|0,s|0,e|0,D|0)|0;s=Jp(d|0,r|0,33554432,0)|0;s=ln(s|0,D|0,26)|0;h=D;g=Jp(t|0,g|0,s|0,h|0)|0;h=_n(s|0,h|0,26)|0;h=mo(d|0,r|0,h|0,D|0)|0;r=Jp(b|0,q|0,33554432,0)|0;r=ln(r|0,D|0,26)|0;d=D;l=Jp(r|0,d|0,o|0,l|0)|0;o=D;d=_n(r|0,d|0,26)|0;d=mo(b|0,q|0,d|0,D|0)|0;q=Jp(l|0,o|0,16777216,0)|0;q=ln(q|0,D|0,25)|0;b=D;r=_m(q|0,b|0,19,0)|0;n=Jp(r|0,D|0,m|0,n|0)|0;m=D;b=_n(q|0,b|0,25)|0;b=mo(l|0,o|0,b|0,D|0)|0;o=Jp(n|0,m|0,33554432,0)|0;o=ln(o|0,D|0,26)|0;l=D;k=Jp(p|0,k|0,o|0,l|0)|0;l=_n(o|0,l|0,26)|0;l=mo(n|0,m|0,l|0,D|0)|0;c[a>>2]=l;c[a+4>>2]=k;c[a+8>>2]=j;c[a+12>>2]=i;c[a+16>>2]=h;c[a+20>>2]=g;c[a+24>>2]=f;c[a+28>>2]=e;c[a+32>>2]=d;c[a+36>>2]=b;return}function lc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0;l=c[b>>2]|0;p=c[b+4>>2]|0;k=c[b+8>>2]|0;f=c[b+12>>2]|0;C=c[b+16>>2]|0;d=c[b+20>>2]|0;g=c[b+24>>2]|0;O=c[b+28>>2]|0;A=c[b+32>>2]|0;q=c[b+36>>2]|0;cb=_m(l|0,((l|0)<0)<<31>>31|0,l|0,((l|0)<0)<<31>>31|0)|0;bb=D;o=((l<<1|0)<0)<<31>>31;Ia=_m(l<<1|0,o|0,p|0,((p|0)<0)<<31>>31|0)|0;Ha=D;Wa=_m(k|0,((k|0)<0)<<31>>31|0,l<<1|0,o|0)|0;Va=D;Ua=_m(f|0,((f|0)<0)<<31>>31|0,l<<1|0,o|0)|0;Ta=D;Oa=_m(C|0,((C|0)<0)<<31>>31|0,l<<1|0,o|0)|0;Na=D;ya=_m(d|0,((d|0)<0)<<31>>31|0,l<<1|0,o|0)|0;xa=D;ga=_m(g|0,((g|0)<0)<<31>>31|0,l<<1|0,o|0)|0;fa=D;R=_m(O|0,((O|0)<0)<<31>>31|0,l<<1|0,o|0)|0;Q=D;F=_m(A|0,((A|0)<0)<<31>>31|0,l<<1|0,o|0)|0;E=D;o=_m(q|0,((q|0)<0)<<31>>31|0,l<<1|0,o|0)|0;l=D;n=((p<<1|0)<0)<<31>>31;ta=_m(p<<1|0,n|0,p|0,((p|0)<0)<<31>>31|0)|0;ua=D;ba=_m(p<<1|0,n|0,k|0,((k|0)<0)<<31>>31|0)|0;ca=D;P=((f<<1|0)<0)<<31>>31;Sa=_m(f<<1|0,P|0,p<<1|0,n|0)|0;Ra=D;Ca=_m(C|0,((C|0)<0)<<31>>31|0,p<<1|0,n|0)|0;Ba=D;ia=_m(d<<1|0,((d<<1|0)<0)<<31>>31|0,p<<1|0,n|0)|0;ha=D;T=_m(g|0,((g|0)<0)<<31>>31|0,p<<1|0,n|0)|0;S=D;H=_m(O<<1|0,((O<<1|0)<0)<<31>>31|0,p<<1|0,n|0)|0;G=D;t=_m(A|0,((A|0)<0)<<31>>31|0,p<<1|0,n|0)|0;s=D;b=((q*38|0)<0)<<31>>31;n=_m(q*38|0,b|0,p<<1|0,n|0)|0;p=D;Qa=_m(k|0,((k|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;Pa=D;Aa=_m(k<<1|0,((k<<1|0)<0)<<31>>31|0,f|0,((f|0)<0)<<31>>31|0)|0;za=D;ka=_m(C|0,((C|0)<0)<<31>>31|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;ja=D;X=_m(d|0,((d|0)<0)<<31>>31|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;W=D;N=_m(g|0,((g|0)<0)<<31>>31|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;M=D;v=_m(O|0,((O|0)<0)<<31>>31|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;u=D;ea=((A*19|0)<0)<<31>>31;Ya=_m(A*19|0,ea|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;Xa=D;k=_m(q*38|0,b|0,k|0,((k|0)<0)<<31>>31|0)|0;j=D;ma=_m(f<<1|0,P|0,f|0,((f|0)<0)<<31>>31|0)|0;la=D;V=_m(f<<1|0,P|0,C|0,((C|0)<0)<<31>>31|0)|0;U=D;J=_m(d<<1|0,((d<<1|0)<0)<<31>>31|0,f<<1|0,P|0)|0;I=D;z=_m(g|0,((g|0)<0)<<31>>31|0,f<<1|0,P|0)|0;y=D;Ma=((O*38|0)<0)<<31>>31;_a=_m(O*38|0,Ma|0,f<<1|0,P|0)|0;Za=D;Ea=_m(A*19|0,ea|0,f<<1|0,P|0)|0;Da=D;P=_m(q*38|0,b|0,f<<1|0,P|0)|0;f=D;L=_m(C|0,((C|0)<0)<<31>>31|0,C|0,((C|0)<0)<<31>>31|0)|0;K=D;x=_m(C<<1|0,((C<<1|0)<0)<<31>>31|0,d|0,((d|0)<0)<<31>>31|0)|0;w=D;ab=_m(g*19|0,((g*19|0)<0)<<31>>31|0,C<<1|0,((C<<1|0)<0)<<31>>31|0)|0;$a=D;Ga=_m(O*38|0,Ma|0,C|0,((C|0)<0)<<31>>31|0)|0;Fa=D;oa=_m(A*19|0,ea|0,C<<1|0,((C<<1|0)<0)<<31>>31|0)|0;na=D;C=_m(q*38|0,b|0,C|0,((C|0)<0)<<31>>31|0)|0;e=D;eb=_m(d*38|0,((d*38|0)<0)<<31>>31|0,d|0,((d|0)<0)<<31>>31|0)|0;db=D;Ka=_m(g*19|0,((g*19|0)<0)<<31>>31|0,d<<1|0,((d<<1|0)<0)<<31>>31|0)|0;Ja=D;qa=_m(O*38|0,Ma|0,d<<1|0,((d<<1|0)<0)<<31>>31|0)|0;pa=D;_=_m(A*19|0,ea|0,d<<1|0,((d<<1|0)<0)<<31>>31|0)|0;Z=D;d=_m(q*38|0,b|0,d<<1|0,((d<<1|0)<0)<<31>>31|0)|0;B=D;sa=_m(g*19|0,((g*19|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;ra=D;aa=_m(O*38|0,Ma|0,g|0,((g|0)<0)<<31>>31|0)|0;$=D;m=_m(A*19|0,ea|0,g<<1|0,((g<<1|0)<0)<<31>>31|0)|0;r=D;g=_m(q*38|0,b|0,g|0,((g|0)<0)<<31>>31|0)|0;Y=D;Ma=_m(O*38|0,Ma|0,O|0,((O|0)<0)<<31>>31|0)|0;La=D;wa=_m(A*19|0,ea|0,O<<1|0,((O<<1|0)<0)<<31>>31|0)|0;va=D;O=_m(q*38|0,b|0,O<<1|0,((O<<1|0)<0)<<31>>31|0)|0;i=D;ea=_m(A*19|0,ea|0,A|0,((A|0)<0)<<31>>31|0)|0;da=D;A=_m(q*38|0,b|0,A|0,((A|0)<0)<<31>>31|0)|0;h=D;q=_m(q*38|0,b|0,q|0,((q|0)<0)<<31>>31|0)|0;b=D;bb=Jp(eb|0,db|0,cb|0,bb|0)|0;$a=Jp(bb|0,D|0,ab|0,$a|0)|0;Za=Jp($a|0,D|0,_a|0,Za|0)|0;Xa=Jp(Za|0,D|0,Ya|0,Xa|0)|0;p=Jp(Xa|0,D|0,n|0,p|0)|0;n=D;ua=Jp(Wa|0,Va|0,ta|0,ua|0)|0;ta=D;ca=Jp(Ua|0,Ta|0,ba|0,ca|0)|0;ba=D;Pa=Jp(Sa|0,Ra|0,Qa|0,Pa|0)|0;Na=Jp(Pa|0,D|0,Oa|0,Na|0)|0;La=Jp(Na|0,D|0,Ma|0,La|0)|0;r=Jp(La|0,D|0,m|0,r|0)|0;B=Jp(r|0,D|0,d|0,B|0)|0;d=D;r=Jp(p|0,n|0,33554432,0)|0;r=ln(r|0,D|0,26)|0;m=D;Ha=Jp(Ka|0,Ja|0,Ia|0,Ha|0)|0;Fa=Jp(Ha|0,D|0,Ga|0,Fa|0)|0;Da=Jp(Fa|0,D|0,Ea|0,Da|0)|0;j=Jp(Da|0,D|0,k|0,j|0)|0;j=Jp(j|0,D|0,r|0,m|0)|0;k=D;m=_n(r|0,m|0,26)|0;m=mo(p|0,n|0,m|0,D|0)|0;n=D;p=Jp(B|0,d|0,33554432,0)|0;p=ln(p|0,D|0,26)|0;r=D;za=Jp(Ca|0,Ba|0,Aa|0,za|0)|0;xa=Jp(za|0,D|0,ya|0,xa|0)|0;va=Jp(xa|0,D|0,wa|0,va|0)|0;Y=Jp(va|0,D|0,g|0,Y|0)|0;Y=Jp(Y|0,D|0,p|0,r|0)|0;g=D;r=_n(p|0,r|0,26)|0;r=mo(B|0,d|0,r|0,D|0)|0;d=D;B=Jp(j|0,k|0,16777216,0)|0;B=ln(B|0,D|0,25)|0;p=D;ra=Jp(ua|0,ta|0,sa|0,ra|0)|0;pa=Jp(ra|0,D|0,qa|0,pa|0)|0;na=Jp(pa|0,D|0,oa|0,na|0)|0;f=Jp(na|0,D|0,P|0,f|0)|0;f=Jp(f|0,D|0,B|0,p|0)|0;P=D;p=_n(B|0,p|0,25)|0;p=mo(j|0,k|0,p|0,D|0)|0;k=D;j=Jp(Y|0,g|0,16777216,0)|0;j=ln(j|0,D|0,25)|0;B=D;ja=Jp(ma|0,la|0,ka|0,ja|0)|0;ha=Jp(ja|0,D|0,ia|0,ha|0)|0;fa=Jp(ha|0,D|0,ga|0,fa|0)|0;da=Jp(fa|0,D|0,ea|0,da|0)|0;i=Jp(da|0,D|0,O|0,i|0)|0;i=Jp(i|0,D|0,j|0,B|0)|0;O=D;B=_n(j|0,B|0,25)|0;B=mo(Y|0,g|0,B|0,D|0)|0;g=D;Y=Jp(f|0,P|0,33554432,0)|0;Y=ln(Y|0,D|0,26)|0;j=D;$=Jp(ca|0,ba|0,aa|0,$|0)|0;Z=Jp($|0,D|0,_|0,Z|0)|0;e=Jp(Z|0,D|0,C|0,e|0)|0;e=Jp(e|0,D|0,Y|0,j|0)|0;C=D;j=_n(Y|0,j|0,26)|0;j=mo(f|0,P|0,j|0,D|0)|0;P=Jp(i|0,O|0,33554432,0)|0;P=ln(P|0,D|0,26)|0;f=D;U=Jp(X|0,W|0,V|0,U|0)|0;S=Jp(U|0,D|0,T|0,S|0)|0;Q=Jp(S|0,D|0,R|0,Q|0)|0;h=Jp(Q|0,D|0,A|0,h|0)|0;h=Jp(h|0,D|0,P|0,f|0)|0;A=D;f=_n(P|0,f|0,26)|0;f=mo(i|0,O|0,f|0,D|0)|0;O=Jp(e|0,C|0,16777216,0)|0;O=ln(O|0,D|0,25)|0;i=D;d=Jp(O|0,i|0,r|0,d|0)|0;r=D;i=_n(O|0,i|0,25)|0;i=mo(e|0,C|0,i|0,D|0)|0;C=Jp(h|0,A|0,16777216,0)|0;C=ln(C|0,D|0,25)|0;e=D;K=Jp(N|0,M|0,L|0,K|0)|0;I=Jp(K|0,D|0,J|0,I|0)|0;G=Jp(I|0,D|0,H|0,G|0)|0;E=Jp(G|0,D|0,F|0,E|0)|0;b=Jp(E|0,D|0,q|0,b|0)|0;b=Jp(b|0,D|0,C|0,e|0)|0;q=D;e=_n(C|0,e|0,25)|0;e=mo(h|0,A|0,e|0,D|0)|0;A=Jp(d|0,r|0,33554432,0)|0;A=ln(A|0,D|0,26)|0;h=D;g=Jp(B|0,g|0,A|0,h|0)|0;h=_n(A|0,h|0,26)|0;h=mo(d|0,r|0,h|0,D|0)|0;r=Jp(b|0,q|0,33554432,0)|0;r=ln(r|0,D|0,26)|0;d=D;w=Jp(z|0,y|0,x|0,w|0)|0;u=Jp(w|0,D|0,v|0,u|0)|0;s=Jp(u|0,D|0,t|0,s|0)|0;l=Jp(s|0,D|0,o|0,l|0)|0;l=Jp(l|0,D|0,r|0,d|0)|0;o=D;d=_n(r|0,d|0,26)|0;d=mo(b|0,q|0,d|0,D|0)|0;q=Jp(l|0,o|0,16777216,0)|0;q=ln(q|0,D|0,25)|0;b=D;r=_m(q|0,b|0,19,0)|0;n=Jp(r|0,D|0,m|0,n|0)|0;m=D;b=_n(q|0,b|0,25)|0;b=mo(l|0,o|0,b|0,D|0)|0;o=Jp(n|0,m|0,33554432,0)|0;o=ln(o|0,D|0,26)|0;l=D;k=Jp(p|0,k|0,o|0,l|0)|0;l=_n(o|0,l|0,26)|0;l=mo(n|0,m|0,l|0,D|0)|0;c[a>>2]=l;c[a+4>>2]=k;c[a+8>>2]=j;c[a+12>>2]=i;c[a+16>>2]=h;c[a+20>>2]=g;c[a+24>>2]=f;c[a+28>>2]=e;c[a+32>>2]=d;c[a+36>>2]=b;return}function mc(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;m=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;p=d[g+4>>0]|d[g+4+1>>0]<<8|d[g+4+2>>0]<<16|d[g+4+3>>0]<<24;h=d[g+8>>0]|d[g+8+1>>0]<<8|d[g+8+2>>0]<<16|d[g+8+3>>0]<<24;i=d[g+8+4>>0]|d[g+8+4+1>>0]<<8|d[g+8+4+2>>0]<<16|d[g+8+4+3>>0]<<24;f=_n(e|0,f|0,56)|0;g=D;if((c+e+(0-(e&7))|0)==(c|0)){r=h^2037671283;l=i^1952801890;o=m^1886610805;k=p^1936682341;j=h^1852075885;s=i^1685025377;i=m^1852142177;h=p^1819895653}else{u=c;r=h^2037671283;l=i^1952801890;o=m^1886610805;n=p^1936682341;k=h^1852075885;j=i^1685025377;i=m^1852142177;h=p^1819895653;while(1){v=u;t=d[v>>0]|d[v+1>>0]<<8|d[v+2>>0]<<16|d[v+3>>0]<<24;v=d[v+4>>0]|d[v+4+1>>0]<<8|d[v+4+2>>0]<<16|d[v+4+3>>0]<<24;p=t^r;r=v^l;m=Jp(o|0,n|0,k|0,j|0)|0;n=D;q=_n(k|0,j|0,13)|0;s=D;x=bo(k|0,j|0,51)|0;s=(s|D)^n;h=Jp(p|0,r|0,i|0,h|0)|0;i=D;o=_n(p|0,r|0,16)|0;j=D;k=bo(p|0,r|0,48)|0;j=(j|D)^i;n=Jp((o|k)^h|0,j|0,n|0,m|0)|0;r=D;l=_n((o|k)^h|0,j|0,21)|0;p=D;j=bo((o|k)^h|0,j|0,43)|0;p=(p|D)^r;i=Jp(h|0,i|0,(q|x)^m|0,s|0)|0;h=D;k=_n((q|x)^m|0,s|0,17)|0;o=D;s=bo((q|x)^m|0,s|0,47)|0;o=h^(o|D);r=Jp(n|0,r|0,i^(k|s)|0,o|0)|0;m=D;x=_n(i^(k|s)|0,o|0,13)|0;q=D;o=bo(i^(k|s)|0,o|0,51)|0;q=(q|D)^m;i=Jp((l|j)^n|0,p|0,h|0,i|0)|0;h=D;s=_n((l|j)^n|0,p|0,16)|0;k=D;p=bo((l|j)^n|0,p|0,48)|0;k=(k|D)^h;m=Jp((s|p)^i|0,k|0,m|0,r|0)|0;n=D;j=_n((s|p)^i|0,k|0,21)|0;l=D;k=bo((s|p)^i|0,k|0,43)|0;l=(l|D)^n;h=Jp(i|0,h|0,(x|o)^r|0,q|0)|0;i=D;p=_n((x|o)^r|0,q|0,17)|0;s=D;q=bo((x|o)^r|0,q|0,47)|0;s=(s|D)^i;u=u+8|0;if((u|0)==(c+e+(0-(e&7))|0)){c=c+e+(0-(e&7))|0;r=(j|k)^m;o=m^t;k=n^v;j=(p|q)^h;break}else{r=(j|k)^m;o=m^t;n=n^v;k=(p|q)^h;j=s}}}switch(e&7|0){case 7:{f=_n(d[c+6>>0]|0|0,0,48)|0|f;g=D|g;w=5;break}case 6:{w=5;break}case 5:{w=6;break}case 4:{w=7;break}case 3:{w=8;break}case 2:{w=9;break}case 1:{w=10;break}default:{}}if((w|0)==5){x=_n(d[c+5>>0]|0|0,0,40)|0;g=D|g;f=x|f;w=6}if((w|0)==6){g=d[c+4>>0]|0|g;w=7}if((w|0)==7){x=_n(d[c+3>>0]|0|0,0,24)|0;f=x|f;g=D|g;w=8}if((w|0)==8){x=_n(d[c+2>>0]|0|0,0,16)|0;f=x|f;g=D|g;w=9}if((w|0)==9){x=_n(d[c+1>>0]|0|0,0,8)|0;f=x|f;g=D|g;w=10}if((w|0)==10)f=d[c>>0]|0|f;u=f^r;n=g^l;e=Jp(o|0,k|0,j|0,s|0)|0;q=D;m=_n(j|0,s|0,13)|0;r=D;p=bo(j|0,s|0,51)|0;r=(r|D)^q;v=Jp(u|0,n|0,i|0,h|0)|0;c=D;w=_n(u|0,n|0,16)|0;x=D;n=bo(u|0,n|0,48)|0;x=(x|D)^c;q=Jp((w|n)^v|0,x|0,q|0,e|0)|0;u=D;o=_n((w|n)^v|0,x|0,21)|0;t=D;x=bo((w|n)^v|0,x|0,43)|0;t=(t|D)^u;c=Jp(v|0,c|0,(m|p)^e|0,r|0)|0;v=D;n=_n((m|p)^e|0,r|0,17)|0;w=D;r=bo((m|p)^e|0,r|0,47)|0;w=v^(w|D);u=Jp(q|0,u|0,c^(n|r)|0,w|0)|0;e=D;p=_n(c^(n|r)|0,w|0,13)|0;s=D;w=bo(c^(n|r)|0,w|0,51)|0;s=(s|D)^e;c=Jp((o|x)^q|0,t|0,v|0,c|0)|0;v=D;r=_n((o|x)^q|0,t|0,16)|0;n=D;t=bo((o|x)^q|0,t|0,48)|0;n=(n|D)^v;e=Jp((r|t)^c|0,n|0,e|0,u|0)|0;q=D;x=_n((r|t)^c|0,n|0,21)|0;o=D;n=bo((r|t)^c|0,n|0,43)|0;o=(o|D)^q;v=Jp(c|0,v|0,(p|w)^u|0,s|0)|0;c=D;t=_n((p|w)^u|0,s|0,17)|0;r=D;s=bo((p|w)^u|0,s|0,47)|0;r=(r|D)^c;q=Jp(e^f|0,q^g|0,(t|s)^v|0,r|0)|0;u=D;w=_n((t|s)^v|0,r|0,13)|0;p=D;r=bo((t|s)^v|0,r|0,51)|0;p=u^(p|D);v=Jp((x|n)^e|0,o|0,c^255|0,v|0)|0;c=D;s=_n((x|n)^e|0,o|0,16)|0;t=D;o=bo((x|n)^e|0,o|0,48)|0;t=(t|D)^c;u=Jp((s|o)^v|0,t|0,u|0,q|0)|0;e=D;n=_n((s|o)^v|0,t|0,21)|0;x=D;t=bo((s|o)^v|0,t|0,43)|0;x=(x|D)^e;c=Jp(v|0,c|0,q^(w|r)|0,p|0)|0;v=D;o=_n(q^(w|r)|0,p|0,17)|0;s=D;p=bo(q^(w|r)|0,p|0,47)|0;s=(s|D)^v;e=Jp(u|0,e|0,(o|p)^c|0,s|0)|0;r=D;w=_n((o|p)^c|0,s|0,13)|0;q=D;s=bo((o|p)^c|0,s|0,51)|0;q=(q|D)^r;c=Jp((n|t)^u|0,x|0,v|0,c|0)|0;v=D;p=_n((n|t)^u|0,x|0,16)|0;o=D;x=bo((n|t)^u|0,x|0,48)|0;o=(o|D)^v;r=Jp((p|x)^c|0,o|0,r|0,e|0)|0;u=D;t=_n((p|x)^c|0,o|0,21)|0;n=D;o=bo((p|x)^c|0,o|0,43)|0;n=(n|D)^u;v=Jp(c|0,v|0,(w|s)^e|0,q|0)|0;c=D;x=_n((w|s)^e|0,q|0,17)|0;p=D;q=bo((w|s)^e|0,q|0,47)|0;p=(p|D)^c;u=Jp(r|0,u|0,(x|q)^v|0,p|0)|0;e=D;s=_n((x|q)^v|0,p|0,13)|0;w=D;p=bo((x|q)^v|0,p|0,51)|0;w=(w|D)^e;v=Jp((t|o)^r|0,n|0,c|0,v|0)|0;c=D;q=_n((t|o)^r|0,n|0,16)|0;x=D;n=bo((t|o)^r|0,n|0,48)|0;x=(x|D)^c;e=Jp((q|n)^v|0,x|0,e|0,u|0)|0;r=D;o=_n((q|n)^v|0,x|0,21)|0;t=D;x=bo((q|n)^v|0,x|0,43)|0;t=(t|D)^r;c=Jp(v|0,c|0,(s|p)^u|0,w|0)|0;v=D;n=_n((s|p)^u|0,w|0,17)|0;q=D;w=bo((s|p)^u|0,w|0,47)|0;q=(q|D)^v;r=Jp(e|0,r|0,(n|w)^c|0,q|0)|0;u=D;p=_n((n|w)^c|0,q|0,13)|0;s=D;q=bo((n|w)^c|0,q|0,51)|0;u=(s|D)^u;c=Jp((o|x)^e|0,t|0,v|0,c|0)|0;v=D;s=_n((o|x)^e|0,t|0,16)|0;w=D;t=bo((o|x)^e|0,t|0,48)|0;w=(w|D)^v;e=_n((s|t)^c|0,w|0,21)|0;x=D;w=bo((s|t)^c|0,w|0,43)|0;x=x|D;v=Jp(c|0,v|0,(p|q)^r|0,u|0)|0;c=D;t=_n((p|q)^r|0,u|0,17)|0;s=D;u=bo((p|q)^r|0,u|0,47)|0;x=(s|D)^c^v^x;a[b>>0]=(t|u)^v^c^(e|w);a[b+1>>0]=((t|u)^v^c^(e|w))>>8;a[b+2>>0]=((t|u)^v^c^(e|w))>>16;a[b+3>>0]=((t|u)^v^c^(e|w))>>24;a[b+4>>0]=x;a[b+4+1>>0]=x>>8;a[b+4+2>>0]=x>>16;a[b+4+3>>0]=x>>24;return 0}function nc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!a)return;h=c[12700]|0;if((a+-8|0)>>>0<h>>>0)Ta();b=c[a+-4>>2]|0;if((b&3|0)==1)Ta();n=a+-8+(b&-8)|0;do if(!(b&1)){e=c[a+-8>>2]|0;if(!(b&3))return;k=a+-8+(0-e)|0;j=e+(b&-8)|0;if(k>>>0<h>>>0)Ta();if((k|0)==(c[12701]|0)){a=c[n+4>>2]|0;if((a&3|0)!=3){q=k;f=j;break}c[12698]=j;c[n+4>>2]=a&-2;c[k+4>>2]=j|1;c[k+j>>2]=j;return}if(e>>>0<256){a=c[k+8>>2]|0;b=c[k+12>>2]|0;if((a|0)!=(50824+(e>>>3<<1<<2)|0)){if(a>>>0<h>>>0)Ta();if((c[a+12>>2]|0)!=(k|0))Ta()}if((b|0)==(a|0)){c[12696]=c[12696]&~(1<<(e>>>3));q=k;f=j;break}if((b|0)!=(50824+(e>>>3<<1<<2)|0)){if(b>>>0<h>>>0)Ta();if((c[b+8>>2]|0)!=(k|0))Ta();else d=b+8|0}else d=b+8|0;c[a+12>>2]=b;c[d>>2]=a;q=k;f=j;break}g=c[k+24>>2]|0;a=c[k+12>>2]|0;do if((a|0)==(k|0)){a=c[k+16+4>>2]|0;if(!a){a=c[k+16>>2]|0;if(!a){i=0;break}else e=k+16|0}else e=k+16+4|0;while(1){b=a+20|0;d=c[b>>2]|0;if(d|0){a=d;e=b;continue}b=a+16|0;d=c[b>>2]|0;if(!d)break;else{a=d;e=b}}if(e>>>0<h>>>0)Ta();else{c[e>>2]=0;i=a;break}}else{b=c[k+8>>2]|0;if(b>>>0<h>>>0)Ta();if((c[b+12>>2]|0)!=(k|0))Ta();if((c[a+8>>2]|0)==(k|0)){c[b+12>>2]=a;c[a+8>>2]=b;i=a;break}else Ta()}while(0);if(g){a=c[k+28>>2]|0;if((k|0)==(c[51088+(a<<2)>>2]|0)){c[51088+(a<<2)>>2]=i;if(!i){c[12697]=c[12697]&~(1<<a);q=k;f=j;break}}else{if(g>>>0<(c[12700]|0)>>>0)Ta();if((c[g+16>>2]|0)==(k|0))c[g+16>>2]=i;else c[g+20>>2]=i;if(!i){q=k;f=j;break}}b=c[12700]|0;if(i>>>0<b>>>0)Ta();c[i+24>>2]=g;a=c[k+16>>2]|0;do if(a|0)if(a>>>0<b>>>0)Ta();else{c[i+16>>2]=a;c[a+24>>2]=i;break}while(0);a=c[k+16+4>>2]|0;if(a)if(a>>>0<(c[12700]|0)>>>0)Ta();else{c[i+20>>2]=a;c[a+24>>2]=i;q=k;f=j;break}else{q=k;f=j}}else{q=k;f=j}}else{q=a+-8|0;f=b&-8}while(0);if(q>>>0>=n>>>0)Ta();d=c[n+4>>2]|0;if(!(d&1))Ta();if(!(d&2)){if((n|0)==(c[12702]|0)){p=(c[12699]|0)+f|0;c[12699]=p;c[12702]=q;c[q+4>>2]=p|1;if((q|0)!=(c[12701]|0))return;c[12701]=0;c[12698]=0;return}if((n|0)==(c[12701]|0)){p=(c[12698]|0)+f|0;c[12698]=p;c[12701]=q;c[q+4>>2]=p|1;c[q+p>>2]=p;return}f=(d&-8)+f|0;do if(d>>>0>=256){g=c[n+24>>2]|0;a=c[n+12>>2]|0;do if((a|0)==(n|0)){a=c[n+16+4>>2]|0;if(!a){a=c[n+16>>2]|0;if(!a){m=0;break}else e=n+16|0}else e=n+16+4|0;while(1){b=a+20|0;d=c[b>>2]|0;if(d|0){a=d;e=b;continue}b=a+16|0;d=c[b>>2]|0;if(!d)break;else{a=d;e=b}}if(e>>>0<(c[12700]|0)>>>0)Ta();else{c[e>>2]=0;m=a;break}}else{b=c[n+8>>2]|0;if(b>>>0<(c[12700]|0)>>>0)Ta();if((c[b+12>>2]|0)!=(n|0))Ta();if((c[a+8>>2]|0)==(n|0)){c[b+12>>2]=a;c[a+8>>2]=b;m=a;break}else Ta()}while(0);if(g|0){a=c[n+28>>2]|0;if((n|0)==(c[51088+(a<<2)>>2]|0)){c[51088+(a<<2)>>2]=m;if(!m){c[12697]=c[12697]&~(1<<a);break}}else{if(g>>>0<(c[12700]|0)>>>0)Ta();if((c[g+16>>2]|0)==(n|0))c[g+16>>2]=m;else c[g+20>>2]=m;if(!m)break}b=c[12700]|0;if(m>>>0<b>>>0)Ta();c[m+24>>2]=g;a=c[n+16>>2]|0;do if(a|0)if(a>>>0<b>>>0)Ta();else{c[m+16>>2]=a;c[a+24>>2]=m;break}while(0);a=c[n+16+4>>2]|0;if(a|0)if(a>>>0<(c[12700]|0)>>>0)Ta();else{c[m+20>>2]=a;c[a+24>>2]=m;break}}}else{a=c[n+8>>2]|0;b=c[n+12>>2]|0;if((a|0)!=(50824+(d>>>3<<1<<2)|0)){if(a>>>0<(c[12700]|0)>>>0)Ta();if((c[a+12>>2]|0)!=(n|0))Ta()}if((b|0)==(a|0)){c[12696]=c[12696]&~(1<<(d>>>3));break}if((b|0)!=(50824+(d>>>3<<1<<2)|0)){if(b>>>0<(c[12700]|0)>>>0)Ta();if((c[b+8>>2]|0)!=(n|0))Ta();else l=b+8|0}else l=b+8|0;c[a+12>>2]=b;c[l>>2]=a}while(0);c[q+4>>2]=f|1;c[q+f>>2]=f;if((q|0)==(c[12701]|0)){c[12698]=f;return}}else{c[n+4>>2]=d&-2;c[q+4>>2]=f|1;c[q+f>>2]=f}b=f>>>3;if(f>>>0<256){a=c[12696]|0;if(a&1<<b){a=c[50824+(b<<1<<2)+8>>2]|0;if(a>>>0<(c[12700]|0)>>>0)Ta();else{o=50824+(b<<1<<2)+8|0;p=a}}else{c[12696]=a|1<<b;o=50824+(b<<1<<2)+8|0;p=50824+(b<<1<<2)|0}c[o>>2]=q;c[p+12>>2]=q;c[q+8>>2]=p;c[q+12>>2]=50824+(b<<1<<2);return}a=f>>>8;if(a)if(f>>>0>16777215)d=31;else{d=a<<((a+1048320|0)>>>16&8)<<(((a<<((a+1048320|0)>>>16&8))+520192|0)>>>16&4);d=14-(((a<<((a+1048320|0)>>>16&8))+520192|0)>>>16&4|(a+1048320|0)>>>16&8|(d+245760|0)>>>16&2)+(d<<((d+245760|0)>>>16&2)>>>15)|0;d=f>>>(d+7|0)&1|d<<1}else d=0;e=51088+(d<<2)|0;c[q+28>>2]=d;c[q+20>>2]=0;c[q+16>>2]=0;a=c[12697]|0;b=1<<d;do if(a&b){d=f<<((d|0)==31?0:25-(d>>>1)|0);e=c[e>>2]|0;while(1){if((c[e+4>>2]&-8|0)==(f|0)){a=130;break}b=e+16+(d>>>31<<2)|0;a=c[b>>2]|0;if(!a){a=127;break}else{d=d<<1;e=a}}if((a|0)==127)if(b>>>0<(c[12700]|0)>>>0)Ta();else{c[b>>2]=q;c[q+24>>2]=e;c[q+12>>2]=q;c[q+8>>2]=q;break}else if((a|0)==130){a=e+8|0;b=c[a>>2]|0;p=c[12700]|0;if(b>>>0>=p>>>0&e>>>0>=p>>>0){c[b+12>>2]=q;c[a>>2]=q;c[q+8>>2]=b;c[q+12>>2]=e;c[q+24>>2]=0;break}else Ta()}}else{c[12697]=a|b;c[e>>2]=q;c[q+24>>2]=e;c[q+12>>2]=q;c[q+8>>2]=q}while(0);q=(c[12704]|0)+-1|0;c[12704]=q;if(!q)a=51240;else return;while(1){a=c[a>>2]|0;if(!a)break;else a=a+8|0}c[12704]=-1;return}function oc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c[a+4>>2]|0;do if(!(d&1)){l=c[a>>2]|0;if(!(d&3))return;j=c[12700]|0;if((a+(0-l)|0)>>>0<j>>>0)Ta();if((a+(0-l)|0)==(c[12701]|0)){d=c[a+b+4>>2]|0;if((d&3|0)!=3){q=a+(0-l)|0;h=l+b|0;break}c[12698]=l+b;c[a+b+4>>2]=d&-2;c[a+(0-l)+4>>2]=l+b|1;c[a+(0-l)+(l+b)>>2]=l+b;return}if(l>>>0<256){d=c[a+(0-l)+8>>2]|0;e=c[a+(0-l)+12>>2]|0;if((d|0)!=(50824+(l>>>3<<1<<2)|0)){if(d>>>0<j>>>0)Ta();if((c[d+12>>2]|0)!=(a+(0-l)|0))Ta()}if((e|0)==(d|0)){c[12696]=c[12696]&~(1<<(l>>>3));q=a+(0-l)|0;h=l+b|0;break}if((e|0)!=(50824+(l>>>3<<1<<2)|0)){if(e>>>0<j>>>0)Ta();if((c[e+8>>2]|0)!=(a+(0-l)|0))Ta();else f=e+8|0}else f=e+8|0;c[d+12>>2]=e;c[f>>2]=d;q=a+(0-l)|0;h=l+b|0;break}i=c[a+(0-l)+24>>2]|0;d=c[a+(0-l)+12>>2]|0;do if((d|0)==(a+(0-l)|0)){e=a+(0-l)+16|0;d=c[e+4>>2]|0;if(!d){d=c[e>>2]|0;if(!d){k=0;break}}else e=e+4|0;while(1){f=d+20|0;g=c[f>>2]|0;if(g|0){d=g;e=f;continue}f=d+16|0;g=c[f>>2]|0;if(!g)break;else{d=g;e=f}}if(e>>>0<j>>>0)Ta();else{c[e>>2]=0;k=d;break}}else{e=c[a+(0-l)+8>>2]|0;if(e>>>0<j>>>0)Ta();if((c[e+12>>2]|0)!=(a+(0-l)|0))Ta();if((c[d+8>>2]|0)==(a+(0-l)|0)){c[e+12>>2]=d;c[d+8>>2]=e;k=d;break}else Ta()}while(0);if(i){d=c[a+(0-l)+28>>2]|0;if((a+(0-l)|0)==(c[51088+(d<<2)>>2]|0)){c[51088+(d<<2)>>2]=k;if(!k){c[12697]=c[12697]&~(1<<d);q=a+(0-l)|0;h=l+b|0;break}}else{if(i>>>0<(c[12700]|0)>>>0)Ta();if((c[i+16>>2]|0)==(a+(0-l)|0))c[i+16>>2]=k;else c[i+20>>2]=k;if(!k){q=a+(0-l)|0;h=l+b|0;break}}e=c[12700]|0;if(k>>>0<e>>>0)Ta();c[k+24>>2]=i;d=c[a+(0-l)+16>>2]|0;do if(d|0)if(d>>>0<e>>>0)Ta();else{c[k+16>>2]=d;c[d+24>>2]=k;break}while(0);d=c[a+(0-l)+16+4>>2]|0;if(d)if(d>>>0<(c[12700]|0)>>>0)Ta();else{c[k+20>>2]=d;c[d+24>>2]=k;q=a+(0-l)|0;h=l+b|0;break}else{q=a+(0-l)|0;h=l+b|0}}else{q=a+(0-l)|0;h=l+b|0}}else{q=a;h=b}while(0);j=c[12700]|0;if((a+b|0)>>>0<j>>>0)Ta();f=c[a+b+4>>2]|0;if(!(f&2)){if((a+b|0)==(c[12702]|0)){p=(c[12699]|0)+h|0;c[12699]=p;c[12702]=q;c[q+4>>2]=p|1;if((q|0)!=(c[12701]|0))return;c[12701]=0;c[12698]=0;return}if((a+b|0)==(c[12701]|0)){p=(c[12698]|0)+h|0;c[12698]=p;c[12701]=q;c[q+4>>2]=p|1;c[q+p>>2]=p;return}h=(f&-8)+h|0;do if(f>>>0>=256){i=c[a+b+24>>2]|0;d=c[a+b+12>>2]|0;do if((d|0)==(a+b|0)){d=c[a+b+16+4>>2]|0;if(!d){d=c[a+b+16>>2]|0;if(!d){n=0;break}else g=a+b+16|0}else g=a+b+16+4|0;while(1){e=d+20|0;f=c[e>>2]|0;if(f|0){d=f;g=e;continue}e=d+16|0;f=c[e>>2]|0;if(!f)break;else{d=f;g=e}}if(g>>>0<j>>>0)Ta();else{c[g>>2]=0;n=d;break}}else{e=c[a+b+8>>2]|0;if(e>>>0<j>>>0)Ta();if((c[e+12>>2]|0)!=(a+b|0))Ta();if((c[d+8>>2]|0)==(a+b|0)){c[e+12>>2]=d;c[d+8>>2]=e;n=d;break}else Ta()}while(0);if(i|0){d=c[a+b+28>>2]|0;if((a+b|0)==(c[51088+(d<<2)>>2]|0)){c[51088+(d<<2)>>2]=n;if(!n){c[12697]=c[12697]&~(1<<d);break}}else{if(i>>>0<(c[12700]|0)>>>0)Ta();if((c[i+16>>2]|0)==(a+b|0))c[i+16>>2]=n;else c[i+20>>2]=n;if(!n)break}e=c[12700]|0;if(n>>>0<e>>>0)Ta();c[n+24>>2]=i;d=c[a+b+16>>2]|0;do if(d|0)if(d>>>0<e>>>0)Ta();else{c[n+16>>2]=d;c[d+24>>2]=n;break}while(0);d=c[a+b+16+4>>2]|0;if(d|0)if(d>>>0<(c[12700]|0)>>>0)Ta();else{c[n+20>>2]=d;c[d+24>>2]=n;break}}}else{d=c[a+b+8>>2]|0;e=c[a+b+12>>2]|0;if((d|0)!=(50824+(f>>>3<<1<<2)|0)){if(d>>>0<j>>>0)Ta();if((c[d+12>>2]|0)!=(a+b|0))Ta()}if((e|0)==(d|0)){c[12696]=c[12696]&~(1<<(f>>>3));break}if((e|0)!=(50824+(f>>>3<<1<<2)|0)){if(e>>>0<j>>>0)Ta();if((c[e+8>>2]|0)!=(a+b|0))Ta();else m=e+8|0}else m=e+8|0;c[d+12>>2]=e;c[m>>2]=d}while(0);c[q+4>>2]=h|1;c[q+h>>2]=h;if((q|0)==(c[12701]|0)){c[12698]=h;return}}else{c[a+b+4>>2]=f&-2;c[q+4>>2]=h|1;c[q+h>>2]=h}e=h>>>3;if(h>>>0<256){d=c[12696]|0;if(d&1<<e){d=c[50824+(e<<1<<2)+8>>2]|0;if(d>>>0<(c[12700]|0)>>>0)Ta();else{o=50824+(e<<1<<2)+8|0;p=d}}else{c[12696]=d|1<<e;o=50824+(e<<1<<2)+8|0;p=50824+(e<<1<<2)|0}c[o>>2]=q;c[p+12>>2]=q;c[q+8>>2]=p;c[q+12>>2]=50824+(e<<1<<2);return}d=h>>>8;if(d)if(h>>>0>16777215)f=31;else{f=d<<((d+1048320|0)>>>16&8)<<(((d<<((d+1048320|0)>>>16&8))+520192|0)>>>16&4);f=14-(((d<<((d+1048320|0)>>>16&8))+520192|0)>>>16&4|(d+1048320|0)>>>16&8|(f+245760|0)>>>16&2)+(f<<((f+245760|0)>>>16&2)>>>15)|0;f=h>>>(f+7|0)&1|f<<1}else f=0;g=51088+(f<<2)|0;c[q+28>>2]=f;c[q+20>>2]=0;c[q+16>>2]=0;d=c[12697]|0;e=1<<f;if(!(d&e)){c[12697]=d|e;c[g>>2]=q;c[q+24>>2]=g;c[q+12>>2]=q;c[q+8>>2]=q;return}f=h<<((f|0)==31?0:25-(f>>>1)|0);g=c[g>>2]|0;while(1){if((c[g+4>>2]&-8|0)==(h|0)){d=127;break}e=g+16+(f>>>31<<2)|0;d=c[e>>2]|0;if(!d){d=124;break}else{f=f<<1;g=d}}if((d|0)==124){if(e>>>0<(c[12700]|0)>>>0)Ta();c[e>>2]=q;c[q+24>>2]=g;c[q+12>>2]=q;c[q+8>>2]=q;return}else if((d|0)==127){d=g+8|0;e=c[d>>2]|0;p=c[12700]|0;if(!(e>>>0>=p>>>0&g>>>0>=p>>>0))Ta();c[e+12>>2]=q;c[d>>2]=q;c[q+8>>2]=e;c[q+12>>2]=g;c[q+24>>2]=0;return}}function pc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;U=i;T=i=i+63&-64;i=i+64|0;if(!((g|0)==0&(h|0)==0)){if(h>>>0>63|(h|0)==63&g>>>0>4294967232)Ta();F=c[b>>2]|0;G=c[b+4>>2]|0;H=c[b+8>>2]|0;I=c[b+12>>2]|0;J=c[b+16>>2]|0;K=c[b+20>>2]|0;L=c[b+24>>2]|0;M=c[b+28>>2]|0;N=c[b+32>>2]|0;O=c[b+36>>2]|0;P=c[b+40>>2]|0;Q=c[b+44>>2]|0;R=c[b+56>>2]|0;S=c[b+60>>2]|0;j=0;l=c[b+48>>2]|0;C=c[b+52>>2]|0;while(1){E=h>>>0<0|(h|0)==0&g>>>0<64;if(E){j=T;k=j+64|0;do{a[j>>0]=0;j=j+1|0}while((j|0)<(k|0));j=0;do{a[T+j>>0]=a[e+j>>0]|0;j=j+1|0}while(0<h>>>0|0==(h|0)&j>>>0<g>>>0);e=T;B=T;j=f}else B=f;f=20;k=F;m=G;n=P;o=Q;p=l;q=C;r=R;s=S;t=H;u=I;v=J;w=K;x=L;y=M;z=N;A=O;do{ma=k+v|0;ba=ma^p;aa=(ba<<16|ba>>>16)+z|0;la=aa^v;ba=(la<<12|la>>>20)+ma^(ba<<16|ba>>>16);V=(ba<<8|ba>>>24)+aa^(la<<12|la>>>20);ia=m+w|0;X=ia^q;W=(X<<16|X>>>16)+A|0;ha=W^w;X=(ha<<12|ha>>>20)+ia^(X<<16|X>>>16);ja=(X<<8|X>>>24)+W^(ha<<12|ha>>>20);da=t+x|0;Y=da^r;ka=(Y<<16|Y>>>16)+n|0;ca=ka^x;Y=(ca<<12|ca>>>20)+da^(Y<<16|Y>>>16);ea=(Y<<8|Y>>>24)+ka^(ca<<12|ca>>>20);Z=u+y|0;ga=Z^s;fa=(ga<<16|ga>>>16)+o|0;_=fa^y;ga=(_<<12|_>>>20)+Z^(ga<<16|ga>>>16);$=(ga<<8|ga>>>24)+fa^(_<<12|_>>>20);ma=(ja<<7|ja>>>25)+((la<<12|la>>>20)+ma)|0;la=(ma^(ga<<8|ga>>>24))<<16|(ma^(ga<<8|ga>>>24))>>>16;ja=la+((Y<<8|Y>>>24)+ka)^(ja<<7|ja>>>25);k=(ja<<12|ja>>>20)+ma|0;ma=k^la;s=ma<<8|ma>>>24;n=s+(la+((Y<<8|Y>>>24)+ka))|0;ja=n^(ja<<12|ja>>>20);w=ja<<7|ja>>>25;ia=(ea<<7|ea>>>25)+((ha<<12|ha>>>20)+ia)|0;ha=(ia^(ba<<8|ba>>>24))<<16|(ia^(ba<<8|ba>>>24))>>>16;ea=ha+((ga<<8|ga>>>24)+fa)^(ea<<7|ea>>>25);m=(ea<<12|ea>>>20)+ia|0;ia=m^ha;p=ia<<8|ia>>>24;o=p+(ha+((ga<<8|ga>>>24)+fa))|0;ea=o^(ea<<12|ea>>>20);x=ea<<7|ea>>>25;da=($<<7|$>>>25)+((ca<<12|ca>>>20)+da)|0;ca=(da^(X<<8|X>>>24))<<16|(da^(X<<8|X>>>24))>>>16;$=ca+((ba<<8|ba>>>24)+aa)^($<<7|$>>>25);t=($<<12|$>>>20)+da|0;da=t^ca;q=da<<8|da>>>24;z=q+(ca+((ba<<8|ba>>>24)+aa))|0;$=z^($<<12|$>>>20);y=$<<7|$>>>25;Z=(V<<7|V>>>25)+((_<<12|_>>>20)+Z)|0;Y=(Z^(Y<<8|Y>>>24))<<16|(Z^(Y<<8|Y>>>24))>>>16;V=Y+((X<<8|X>>>24)+W)^(V<<7|V>>>25);u=(V<<12|V>>>20)+Z|0;Z=u^Y;r=Z<<8|Z>>>24;A=r+(Y+((X<<8|X>>>24)+W))|0;V=A^(V<<12|V>>>20);v=V<<7|V>>>25;f=f+-2|0}while((f|0)!=0);f=(d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24)^k+F;Z=e+4|0;Z=(d[Z>>0]|d[Z+1>>0]<<8|d[Z+2>>0]<<16|d[Z+3>>0]<<24)^m+G;_=e+8|0;_=(d[_>>0]|d[_+1>>0]<<8|d[_+2>>0]<<16|d[_+3>>0]<<24)^t+H;$=e+12|0;$=(d[$>>0]|d[$+1>>0]<<8|d[$+2>>0]<<16|d[$+3>>0]<<24)^u+I;aa=e+16|0;aa=(d[aa>>0]|d[aa+1>>0]<<8|d[aa+2>>0]<<16|d[aa+3>>0]<<24)^v+J;ba=e+20|0;ba=(d[ba>>0]|d[ba+1>>0]<<8|d[ba+2>>0]<<16|d[ba+3>>0]<<24)^w+K;ca=e+24|0;ca=(d[ca>>0]|d[ca+1>>0]<<8|d[ca+2>>0]<<16|d[ca+3>>0]<<24)^x+L;da=e+28|0;da=(d[da>>0]|d[da+1>>0]<<8|d[da+2>>0]<<16|d[da+3>>0]<<24)^y+M;ea=e+32|0;ea=(d[ea>>0]|d[ea+1>>0]<<8|d[ea+2>>0]<<16|d[ea+3>>0]<<24)^z+N;fa=e+36|0;fa=(d[fa>>0]|d[fa+1>>0]<<8|d[fa+2>>0]<<16|d[fa+3>>0]<<24)^A+O;ga=e+40|0;ga=(d[ga>>0]|d[ga+1>>0]<<8|d[ga+2>>0]<<16|d[ga+3>>0]<<24)^n+P;ha=e+44|0;ha=(d[ha>>0]|d[ha+1>>0]<<8|d[ha+2>>0]<<16|d[ha+3>>0]<<24)^o+Q;ia=e+48|0;ia=(d[ia>>0]|d[ia+1>>0]<<8|d[ia+2>>0]<<16|d[ia+3>>0]<<24)^p+l;ja=e+52|0;ja=(d[ja>>0]|d[ja+1>>0]<<8|d[ja+2>>0]<<16|d[ja+3>>0]<<24)^q+C;ka=e+56|0;ka=(d[ka>>0]|d[ka+1>>0]<<8|d[ka+2>>0]<<16|d[ka+3>>0]<<24)^r+R;la=e+60|0;la=(d[la>>0]|d[la+1>>0]<<8|d[la+2>>0]<<16|d[la+3>>0]<<24)^s+S;l=l+1|0;k=((l|0)==0&1)+C|0;a[B>>0]=f;a[B+1>>0]=f>>8;a[B+2>>0]=f>>16;a[B+3>>0]=f>>24;ma=B+4|0;a[ma>>0]=Z;a[ma+1>>0]=Z>>8;a[ma+2>>0]=Z>>16;a[ma+3>>0]=Z>>24;ma=B+8|0;a[ma>>0]=_;a[ma+1>>0]=_>>8;a[ma+2>>0]=_>>16;a[ma+3>>0]=_>>24;ma=B+12|0;a[ma>>0]=$;a[ma+1>>0]=$>>8;a[ma+2>>0]=$>>16;a[ma+3>>0]=$>>24;ma=B+16|0;a[ma>>0]=aa;a[ma+1>>0]=aa>>8;a[ma+2>>0]=aa>>16;a[ma+3>>0]=aa>>24;ma=B+20|0;a[ma>>0]=ba;a[ma+1>>0]=ba>>8;a[ma+2>>0]=ba>>16;a[ma+3>>0]=ba>>24;ma=B+24|0;a[ma>>0]=ca;a[ma+1>>0]=ca>>8;a[ma+2>>0]=ca>>16;a[ma+3>>0]=ca>>24;ma=B+28|0;a[ma>>0]=da;a[ma+1>>0]=da>>8;a[ma+2>>0]=da>>16;a[ma+3>>0]=da>>24;ma=B+32|0;a[ma>>0]=ea;a[ma+1>>0]=ea>>8;a[ma+2>>0]=ea>>16;a[ma+3>>0]=ea>>24;ma=B+36|0;a[ma>>0]=fa;a[ma+1>>0]=fa>>8;a[ma+2>>0]=fa>>16;a[ma+3>>0]=fa>>24;ma=B+40|0;a[ma>>0]=ga;a[ma+1>>0]=ga>>8;a[ma+2>>0]=ga>>16;a[ma+3>>0]=ga>>24;ma=B+44|0;a[ma>>0]=ha;a[ma+1>>0]=ha>>8;a[ma+2>>0]=ha>>16;a[ma+3>>0]=ha>>24;ma=B+48|0;a[ma>>0]=ia;a[ma+1>>0]=ia>>8;a[ma+2>>0]=ia>>16;a[ma+3>>0]=ia>>24;ma=B+52|0;a[ma>>0]=ja;a[ma+1>>0]=ja>>8;a[ma+2>>0]=ja>>16;a[ma+3>>0]=ja>>24;ma=B+56|0;a[ma>>0]=ka;a[ma+1>>0]=ka>>8;a[ma+2>>0]=ka>>16;a[ma+3>>0]=ka>>24;ma=B+60|0;a[ma>>0]=la;a[ma+1>>0]=la>>8;a[ma+2>>0]=la>>16;a[ma+3>>0]=la>>24;if(h>>>0<0|(h|0)==0&g>>>0<65)break;C=Jp(g|0,h|0,-64,-1)|0;e=e+64|0;f=B+64|0;h=D;g=C;C=k}if((E?g|0:0)?(a[j>>0]=f,(g|0)!=1):0){e=1;do{a[j+e>>0]=a[B+e>>0]|0;e=e+1|0}while((e|0)!=(g|0))}c[b+48>>2]=l;c[b+52>>2]=k}i=U;return}function qc(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,p=0,q=0;q=i;p=i=i+63&-64;i=i+112|0;if(b){n=wq(e,54052)|0;b=c[n>>2]|0;if(d){Gb[c[b+44>>2]&127](p+108|0,n);d=c[p+108>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;Gb[c[(c[n>>2]|0)+32>>2]&127](p+96|0,n);if((a[l+11>>0]|0)<0){a[c[l>>2]>>0]=0;c[l+4>>2]=0}else{a[l>>0]=0;a[l+11>>0]=0}o=0;ba(142,l|0);f=o;o=0;if(f&1){f=Za(0)|0;lt(f)}c[l>>2]=c[p+96>>2];c[l+4>>2]=c[p+96+4>>2];c[l+8>>2]=c[p+96+8>>2];b=0;while(1){if((b|0)==3)break;c[p+96+(b<<2)>>2]=0;b=b+1|0}rq(p+96|0);e=n}else{Gb[c[b+40>>2]&127](p+92|0,n);d=c[p+92>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;Gb[c[(c[n>>2]|0)+28>>2]&127](p+80|0,n);if((a[l+11>>0]|0)<0){a[c[l>>2]>>0]=0;c[l+4>>2]=0}else{a[l>>0]=0;a[l+11>>0]=0}o=0;ba(142,l|0);f=o;o=0;if(f&1){f=Za(0)|0;lt(f)}c[l>>2]=c[p+80>>2];c[l+4>>2]=c[p+80+4>>2];c[l+8>>2]=c[p+80+8>>2];b=0;while(1){if((b|0)==3)break;c[p+80+(b<<2)>>2]=0;b=b+1|0}rq(p+80|0);e=n}a[g>>0]=Ib[c[(c[n>>2]|0)+12>>2]&127](n)|0;a[h>>0]=Ib[c[(c[n>>2]|0)+16>>2]&127](n)|0;Gb[c[(c[e>>2]|0)+20>>2]&127](p+68|0,n);if((a[j+11>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0}else{a[j>>0]=0;a[j+11>>0]=0}o=0;ba(142,j|0);h=o;o=0;if(h&1){h=Za(0)|0;lt(h)}c[j>>2]=c[p+68>>2];c[j+4>>2]=c[p+68+4>>2];c[j+8>>2]=c[p+68+8>>2];b=0;while(1){if((b|0)==3)break;c[p+68+(b<<2)>>2]=0;b=b+1|0}rq(p+68|0);Gb[c[(c[e>>2]|0)+24>>2]&127](p+56|0,n);if((a[k+11>>0]|0)<0){a[c[k>>2]>>0]=0;c[k+4>>2]=0}else{a[k>>0]=0;a[k+11>>0]=0}o=0;ba(142,k|0);h=o;o=0;if(h&1){h=Za(0)|0;lt(h)}c[k>>2]=c[p+56>>2];c[k+4>>2]=c[p+56+4>>2];c[k+8>>2]=c[p+56+8>>2];b=0;while(1){if((b|0)==3)break;c[p+56+(b<<2)>>2]=0;b=b+1|0}rq(p+56|0);b=Ib[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{n=wq(e,54044)|0;b=c[n>>2]|0;if(d){Gb[c[b+44>>2]&127](p+52|0,n);d=c[p+52>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;Gb[c[(c[n>>2]|0)+32>>2]&127](p+40|0,n);if((a[l+11>>0]|0)<0){a[c[l>>2]>>0]=0;c[l+4>>2]=0}else{a[l>>0]=0;a[l+11>>0]=0}o=0;ba(142,l|0);f=o;o=0;if(f&1){f=Za(0)|0;lt(f)}c[l>>2]=c[p+40>>2];c[l+4>>2]=c[p+40+4>>2];c[l+8>>2]=c[p+40+8>>2];b=0;while(1){if((b|0)==3)break;c[p+40+(b<<2)>>2]=0;b=b+1|0}rq(p+40|0);e=n}else{Gb[c[b+40>>2]&127](p+36|0,n);d=c[p+36>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;Gb[c[(c[n>>2]|0)+28>>2]&127](p+24|0,n);if((a[l+11>>0]|0)<0){a[c[l>>2]>>0]=0;c[l+4>>2]=0}else{a[l>>0]=0;a[l+11>>0]=0}o=0;ba(142,l|0);f=o;o=0;if(f&1){f=Za(0)|0;lt(f)}c[l>>2]=c[p+24>>2];c[l+4>>2]=c[p+24+4>>2];c[l+8>>2]=c[p+24+8>>2];b=0;while(1){if((b|0)==3)break;c[p+24+(b<<2)>>2]=0;b=b+1|0}rq(p+24|0);e=n}a[g>>0]=Ib[c[(c[n>>2]|0)+12>>2]&127](n)|0;a[h>>0]=Ib[c[(c[n>>2]|0)+16>>2]&127](n)|0;Gb[c[(c[e>>2]|0)+20>>2]&127](p+12|0,n);if((a[j+11>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0}else{a[j>>0]=0;a[j+11>>0]=0}o=0;ba(142,j|0);h=o;o=0;if(h&1){h=Za(0)|0;lt(h)}c[j>>2]=c[p+12>>2];c[j+4>>2]=c[p+12+4>>2];c[j+8>>2]=c[p+12+8>>2];b=0;while(1){if((b|0)==3)break;c[p+12+(b<<2)>>2]=0;b=b+1|0}rq(p+12|0);Gb[c[(c[e>>2]|0)+24>>2]&127](p,n);if((a[k+11>>0]|0)<0){a[c[k>>2]>>0]=0;c[k+4>>2]=0}else{a[k>>0]=0;a[k+11>>0]=0}o=0;ba(142,k|0);h=o;o=0;if(h&1){h=Za(0)|0;lt(h)}c[k>>2]=c[p>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];b=0;while(1){if((b|0)==3)break;c[p+(b<<2)>>2]=0;b=b+1|0}rq(p);b=Ib[c[(c[n>>2]|0)+36>>2]&127](n)|0}c[m>>2]=b;i=q;return}function rc(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,p=0;p=i;n=i=i+63&-64;i=i+112|0;if(b){e=wq(e,54068)|0;b=c[e>>2]|0;if(d){Gb[c[b+44>>2]&127](n+108|0,e);d=c[n+108>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;Gb[c[(c[e>>2]|0)+32>>2]&127](n+96|0,e);if((a[l+8+3>>0]|0)<0){c[c[l>>2]>>2]=0;c[l+4>>2]=0}else{c[l>>2]=0;a[l+8+3>>0]=0}o=0;ba(144,l|0);f=o;o=0;if(f&1){f=Za(0)|0;lt(f)}c[l>>2]=c[n+96>>2];c[l+4>>2]=c[n+96+4>>2];c[l+8>>2]=c[n+96+8>>2];b=0;while(1){if((b|0)==3)break;c[n+96+(b<<2)>>2]=0;b=b+1|0}dq(n+96|0)}else{Gb[c[b+40>>2]&127](n+92|0,e);d=c[n+92>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;Gb[c[(c[e>>2]|0)+28>>2]&127](n+80|0,e);if((a[l+8+3>>0]|0)<0){c[c[l>>2]>>2]=0;c[l+4>>2]=0}else{c[l>>2]=0;a[l+8+3>>0]=0}o=0;ba(144,l|0);f=o;o=0;if(f&1){f=Za(0)|0;lt(f)}c[l>>2]=c[n+80>>2];c[l+4>>2]=c[n+80+4>>2];c[l+8>>2]=c[n+80+8>>2];b=0;while(1){if((b|0)==3)break;c[n+80+(b<<2)>>2]=0;b=b+1|0}dq(n+80|0)}c[g>>2]=Ib[c[(c[e>>2]|0)+12>>2]&127](e)|0;c[h>>2]=Ib[c[(c[e>>2]|0)+16>>2]&127](e)|0;Gb[c[(c[e>>2]|0)+20>>2]&127](n+68|0,e);if((a[j+11>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0}else{a[j>>0]=0;a[j+11>>0]=0}o=0;ba(142,j|0);h=o;o=0;if(h&1){h=Za(0)|0;lt(h)}c[j>>2]=c[n+68>>2];c[j+4>>2]=c[n+68+4>>2];c[j+8>>2]=c[n+68+8>>2];b=0;while(1){if((b|0)==3)break;c[n+68+(b<<2)>>2]=0;b=b+1|0}rq(n+68|0);Gb[c[(c[e>>2]|0)+24>>2]&127](n+56|0,e);if((a[k+8+3>>0]|0)<0){c[c[k>>2]>>2]=0;c[k+4>>2]=0}else{c[k>>2]=0;a[k+8+3>>0]=0}o=0;ba(144,k|0);h=o;o=0;if(h&1){h=Za(0)|0;lt(h)}c[k>>2]=c[n+56>>2];c[k+4>>2]=c[n+56+4>>2];c[k+8>>2]=c[n+56+8>>2];b=0;while(1){if((b|0)==3)break;c[n+56+(b<<2)>>2]=0;b=b+1|0}dq(n+56|0);b=Ib[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{e=wq(e,54060)|0;b=c[e>>2]|0;if(d){Gb[c[b+44>>2]&127](n+52|0,e);d=c[n+52>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;Gb[c[(c[e>>2]|0)+32>>2]&127](n+40|0,e);if((a[l+8+3>>0]|0)<0){c[c[l>>2]>>2]=0;c[l+4>>2]=0}else{c[l>>2]=0;a[l+8+3>>0]=0}o=0;ba(144,l|0);f=o;o=0;if(f&1){f=Za(0)|0;lt(f)}c[l>>2]=c[n+40>>2];c[l+4>>2]=c[n+40+4>>2];c[l+8>>2]=c[n+40+8>>2];b=0;while(1){if((b|0)==3)break;c[n+40+(b<<2)>>2]=0;b=b+1|0}dq(n+40|0)}else{Gb[c[b+40>>2]&127](n+36|0,e);d=c[n+36>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;Gb[c[(c[e>>2]|0)+28>>2]&127](n+24|0,e);if((a[l+8+3>>0]|0)<0){c[c[l>>2]>>2]=0;c[l+4>>2]=0}else{c[l>>2]=0;a[l+8+3>>0]=0}o=0;ba(144,l|0);f=o;o=0;if(f&1){f=Za(0)|0;lt(f)}c[l>>2]=c[n+24>>2];c[l+4>>2]=c[n+24+4>>2];c[l+8>>2]=c[n+24+8>>2];b=0;while(1){if((b|0)==3)break;c[n+24+(b<<2)>>2]=0;b=b+1|0}dq(n+24|0)}c[g>>2]=Ib[c[(c[e>>2]|0)+12>>2]&127](e)|0;c[h>>2]=Ib[c[(c[e>>2]|0)+16>>2]&127](e)|0;Gb[c[(c[e>>2]|0)+20>>2]&127](n+12|0,e);if((a[j+11>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0}else{a[j>>0]=0;a[j+11>>0]=0}o=0;ba(142,j|0);h=o;o=0;if(h&1){h=Za(0)|0;lt(h)}c[j>>2]=c[n+12>>2];c[j+4>>2]=c[n+12+4>>2];c[j+8>>2]=c[n+12+8>>2];b=0;while(1){if((b|0)==3)break;c[n+12+(b<<2)>>2]=0;b=b+1|0}rq(n+12|0);Gb[c[(c[e>>2]|0)+24>>2]&127](n,e);if((a[k+8+3>>0]|0)<0){c[c[k>>2]>>2]=0;c[k+4>>2]=0}else{c[k>>2]=0;a[k+8+3>>0]=0}o=0;ba(144,k|0);h=o;o=0;if(h&1){h=Za(0)|0;lt(h)}c[k>>2]=c[n>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}dq(n);b=Ib[c[(c[e>>2]|0)+36>>2]&127](e)|0}c[m>>2]=b;i=p;return}function sc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a:do if(e>>>0>36){c[(Sq()|0)>>2]=22;h=0;g=0}else{do{i=c[b+4>>2]|0;if(i>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=i+1;i=d[i>>0]|0}else i=ug(b)|0}while((Kt(i)|0)!=0);b:do switch(i|0){case 43:case 45:{j=((i|0)==45)<<31>>31;i=c[b+4>>2]|0;if(i>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=i+1;i=d[i>>0]|0;p=j;break b}else{i=ug(b)|0;p=j;break b}}default:p=0}while(0);do if((e|16|0)==16&(i|0)==48){i=c[b+4>>2]|0;if(i>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=i+1;i=d[i>>0]|0}else i=ug(b)|0;if((i|32|0)!=120)if(!e){e=8;n=46;break}else{n=32;break}e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;i=d[e>>0]|0}else i=ug(b)|0;if((d[43678+i>>0]|0)>15){g=(c[b+100>>2]|0)==0;if(!g)c[b+4>>2]=(c[b+4>>2]|0)+-1;if(!f){Ml(b,0);h=0;g=0;break a}if(g){h=0;g=0;break a}c[b+4>>2]=(c[b+4>>2]|0)+-1;h=0;g=0;break a}else{e=16;n=46}}else{e=(e|0)==0?10:e;if((d[43678+i>>0]|0)>>>0<e>>>0)n=32;else{if(c[b+100>>2]|0)c[b+4>>2]=(c[b+4>>2]|0)+-1;Ml(b,0);c[(Sq()|0)>>2]=22;h=0;g=0;break a}}while(0);if((n|0)==32)if((e|0)==10){e=i+-48|0;if(e>>>0<10){j=0;do{j=(j*10|0)+e|0;e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;i=d[e>>0]|0}else i=ug(b)|0;e=i+-48|0}while(e>>>0<10&j>>>0<429496729);f=0}else{j=0;f=0}e=i+-48|0;if(e>>>0<10){do{k=_m(j|0,f|0,10,0)|0;l=D;m=((e|0)<0)<<31>>31;if(l>>>0>~m>>>0|(l|0)==(~m|0)&k>>>0>~e>>>0)break;j=Jp(k|0,l|0,e|0,m|0)|0;f=D;e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;i=d[e>>0]|0}else i=ug(b)|0;e=i+-48|0}while(e>>>0<10&(f>>>0<429496729|(f|0)==429496729&j>>>0<2576980378));if(e>>>0>9){i=j;e=p}else{e=10;n=72}}else{i=j;e=p}}else n=46;c:do if((n|0)==46){if(!(e+-1&e)){n=a[43934+((e*23|0)>>>5&7)>>0]|0;j=a[43678+i>>0]|0;if((j&255)>>>0<e>>>0){f=j&255;k=0;do{k=f|k<<n;i=c[b+4>>2]|0;if(i>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=i+1;i=d[i>>0]|0}else i=ug(b)|0;j=a[43678+i>>0]|0;f=j&255}while(k>>>0<134217728&f>>>0<e>>>0);f=0}else{f=0;k=0}l=bo(-1,-1,n|0)|0;m=D;if((j&255)>>>0>=e>>>0|(f>>>0>m>>>0|(f|0)==(m|0)&k>>>0>l>>>0)){j=k;n=72;break}while(1){k=_n(k|0,f|0,n|0)|0;f=D;k=j&255|k;i=c[b+4>>2]|0;if(i>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=i+1;i=d[i>>0]|0}else i=ug(b)|0;j=a[43678+i>>0]|0;if((j&255)>>>0>=e>>>0|(f>>>0>m>>>0|(f|0)==(m|0)&k>>>0>l>>>0)){j=k;n=72;break c}}}j=a[43678+i>>0]|0;if((j&255)>>>0<e>>>0){f=j&255;k=0;do{k=f+(S(k,e)|0)|0;i=c[b+4>>2]|0;if(i>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=i+1;i=d[i>>0]|0}else i=ug(b)|0;j=a[43678+i>>0]|0;f=j&255}while(k>>>0<119304647&f>>>0<e>>>0);f=0}else{k=0;f=0}if((j&255)>>>0<e>>>0){n=bs(-1,-1,e|0,0)|0;o=D;while(1){if(f>>>0>o>>>0|(f|0)==(o|0)&k>>>0>n>>>0){j=k;n=72;break c}l=_m(k|0,f|0,e|0,0)|0;m=D;j=j&255;if(m>>>0>4294967295|(m|0)==-1&l>>>0>~j>>>0){j=k;n=72;break c}k=Jp(j|0,0,l|0,m|0)|0;f=D;i=c[b+4>>2]|0;if(i>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=i+1;i=d[i>>0]|0}else i=ug(b)|0;j=a[43678+i>>0]|0;if((j&255)>>>0>=e>>>0){j=k;n=72;break}}}else{j=k;n=72}}while(0);if((n|0)==72)if((d[43678+i>>0]|0)>>>0<e>>>0){do{i=c[b+4>>2]|0;if(i>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=i+1;i=d[i>>0]|0}else i=ug(b)|0}while((d[43678+i>>0]|0)>>>0<e>>>0);c[(Sq()|0)>>2]=34;f=h;i=g;e=(g&1|0)==0&0==0?p:0}else{i=j;e=p}if(c[b+100>>2]|0)c[b+4>>2]=(c[b+4>>2]|0)+-1;if(!(f>>>0<h>>>0|(f|0)==(h|0)&i>>>0<g>>>0)){if(!((g&1|0)!=0|0!=0|(e|0)!=0)){c[(Sq()|0)>>2]=34;g=Jp(g|0,h|0,-1,-1)|0;h=D;break}if(f>>>0>h>>>0|(f|0)==(h|0)&i>>>0>g>>>0){c[(Sq()|0)>>2]=34;break}}g=((e|0)<0)<<31>>31;g=mo(i^e|0,f^g|0,e|0,g|0)|0;h=D}while(0);D=h;return g|0}function tc(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,p=0;p=i;n=i=i+63&-64;i=i+112|0;if(b){d=wq(d,54068)|0;Gb[c[(c[d>>2]|0)+44>>2]&127](n+100|0,d);b=c[n+100>>2]|0;a[e>>0]=b;a[e+1>>0]=b>>8;a[e+2>>0]=b>>16;a[e+3>>0]=b>>24;Gb[c[(c[d>>2]|0)+32>>2]&127](n+88|0,d);if((a[l+8+3>>0]|0)<0){c[c[l>>2]>>2]=0;c[l+4>>2]=0}else{c[l>>2]=0;a[l+8+3>>0]=0}o=0;ba(144,l|0);e=o;o=0;if(e&1){e=Za(0)|0;lt(e)}c[l>>2]=c[n+88>>2];c[l+4>>2]=c[n+88+4>>2];c[l+8>>2]=c[n+88+8>>2];b=0;while(1){if((b|0)==3)break;c[n+88+(b<<2)>>2]=0;b=b+1|0}dq(n+88|0);Gb[c[(c[d>>2]|0)+28>>2]&127](n+76|0,d);if((a[k+8+3>>0]|0)<0){c[c[k>>2]>>2]=0;c[k+4>>2]=0}else{c[k>>2]=0;a[k+8+3>>0]=0}o=0;ba(144,k|0);e=o;o=0;if(e&1){e=Za(0)|0;lt(e)}c[k>>2]=c[n+76>>2];c[k+4>>2]=c[n+76+4>>2];c[k+8>>2]=c[n+76+8>>2];b=0;while(1){if((b|0)==3)break;c[n+76+(b<<2)>>2]=0;b=b+1|0}dq(n+76|0);c[f>>2]=Ib[c[(c[d>>2]|0)+12>>2]&127](d)|0;c[g>>2]=Ib[c[(c[d>>2]|0)+16>>2]&127](d)|0;Gb[c[(c[d>>2]|0)+20>>2]&127](n+64|0,d);if((a[h+11>>0]|0)<0){a[c[h>>2]>>0]=0;c[h+4>>2]=0}else{a[h>>0]=0;a[h+11>>0]=0}o=0;ba(142,h|0);g=o;o=0;if(g&1){g=Za(0)|0;lt(g)}c[h>>2]=c[n+64>>2];c[h+4>>2]=c[n+64+4>>2];c[h+8>>2]=c[n+64+8>>2];b=0;while(1){if((b|0)==3)break;c[n+64+(b<<2)>>2]=0;b=b+1|0}rq(n+64|0);Gb[c[(c[d>>2]|0)+24>>2]&127](n+52|0,d);if((a[j+8+3>>0]|0)<0){c[c[j>>2]>>2]=0;c[j+4>>2]=0}else{c[j>>2]=0;a[j+8+3>>0]=0}o=0;ba(144,j|0);g=o;o=0;if(g&1){g=Za(0)|0;lt(g)}c[j>>2]=c[n+52>>2];c[j+4>>2]=c[n+52+4>>2];c[j+8>>2]=c[n+52+8>>2];b=0;while(1){if((b|0)==3)break;c[n+52+(b<<2)>>2]=0;b=b+1|0}dq(n+52|0);b=Ib[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{d=wq(d,54060)|0;Gb[c[(c[d>>2]|0)+44>>2]&127](n+48|0,d);b=c[n+48>>2]|0;a[e>>0]=b;a[e+1>>0]=b>>8;a[e+2>>0]=b>>16;a[e+3>>0]=b>>24;Gb[c[(c[d>>2]|0)+32>>2]&127](n+36|0,d);if((a[l+8+3>>0]|0)<0){c[c[l>>2]>>2]=0;c[l+4>>2]=0}else{c[l>>2]=0;a[l+8+3>>0]=0}o=0;ba(144,l|0);e=o;o=0;if(e&1){e=Za(0)|0;lt(e)}c[l>>2]=c[n+36>>2];c[l+4>>2]=c[n+36+4>>2];c[l+8>>2]=c[n+36+8>>2];b=0;while(1){if((b|0)==3)break;c[n+36+(b<<2)>>2]=0;b=b+1|0}dq(n+36|0);Gb[c[(c[d>>2]|0)+28>>2]&127](n+24|0,d);if((a[k+8+3>>0]|0)<0){c[c[k>>2]>>2]=0;c[k+4>>2]=0}else{c[k>>2]=0;a[k+8+3>>0]=0}o=0;ba(144,k|0);e=o;o=0;if(e&1){e=Za(0)|0;lt(e)}c[k>>2]=c[n+24>>2];c[k+4>>2]=c[n+24+4>>2];c[k+8>>2]=c[n+24+8>>2];b=0;while(1){if((b|0)==3)break;c[n+24+(b<<2)>>2]=0;b=b+1|0}dq(n+24|0);c[f>>2]=Ib[c[(c[d>>2]|0)+12>>2]&127](d)|0;c[g>>2]=Ib[c[(c[d>>2]|0)+16>>2]&127](d)|0;Gb[c[(c[d>>2]|0)+20>>2]&127](n+12|0,d);if((a[h+11>>0]|0)<0){a[c[h>>2]>>0]=0;c[h+4>>2]=0}else{a[h>>0]=0;a[h+11>>0]=0}o=0;ba(142,h|0);g=o;o=0;if(g&1){g=Za(0)|0;lt(g)}c[h>>2]=c[n+12>>2];c[h+4>>2]=c[n+12+4>>2];c[h+8>>2]=c[n+12+8>>2];b=0;while(1){if((b|0)==3)break;c[n+12+(b<<2)>>2]=0;b=b+1|0}rq(n+12|0);Gb[c[(c[d>>2]|0)+24>>2]&127](n,d);if((a[j+8+3>>0]|0)<0){c[c[j>>2]>>2]=0;c[j+4>>2]=0}else{c[j>>2]=0;a[j+8+3>>0]=0}o=0;ba(144,j|0);g=o;o=0;if(g&1){g=Za(0)|0;lt(g)}c[j>>2]=c[n>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}dq(n);b=Ib[c[(c[d>>2]|0)+36>>2]&127](d)|0}c[m>>2]=b;i=p;return}function uc(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,p=0;p=i;n=i=i+63&-64;i=i+112|0;if(b){d=wq(d,54052)|0;Gb[c[(c[d>>2]|0)+44>>2]&127](n+100|0,d);b=c[n+100>>2]|0;a[e>>0]=b;a[e+1>>0]=b>>8;a[e+2>>0]=b>>16;a[e+3>>0]=b>>24;Gb[c[(c[d>>2]|0)+32>>2]&127](n+88|0,d);if((a[l+11>>0]|0)<0){a[c[l>>2]>>0]=0;c[l+4>>2]=0}else{a[l>>0]=0;a[l+11>>0]=0}o=0;ba(142,l|0);e=o;o=0;if(e&1){e=Za(0)|0;lt(e)}c[l>>2]=c[n+88>>2];c[l+4>>2]=c[n+88+4>>2];c[l+8>>2]=c[n+88+8>>2];b=0;while(1){if((b|0)==3)break;c[n+88+(b<<2)>>2]=0;b=b+1|0}rq(n+88|0);Gb[c[(c[d>>2]|0)+28>>2]&127](n+76|0,d);if((a[k+11>>0]|0)<0){a[c[k>>2]>>0]=0;c[k+4>>2]=0}else{a[k>>0]=0;a[k+11>>0]=0}o=0;ba(142,k|0);e=o;o=0;if(e&1){e=Za(0)|0;lt(e)}c[k>>2]=c[n+76>>2];c[k+4>>2]=c[n+76+4>>2];c[k+8>>2]=c[n+76+8>>2];b=0;while(1){if((b|0)==3)break;c[n+76+(b<<2)>>2]=0;b=b+1|0}rq(n+76|0);a[f>>0]=Ib[c[(c[d>>2]|0)+12>>2]&127](d)|0;a[g>>0]=Ib[c[(c[d>>2]|0)+16>>2]&127](d)|0;Gb[c[(c[d>>2]|0)+20>>2]&127](n+64|0,d);if((a[h+11>>0]|0)<0){a[c[h>>2]>>0]=0;c[h+4>>2]=0}else{a[h>>0]=0;a[h+11>>0]=0}o=0;ba(142,h|0);g=o;o=0;if(g&1){g=Za(0)|0;lt(g)}c[h>>2]=c[n+64>>2];c[h+4>>2]=c[n+64+4>>2];c[h+8>>2]=c[n+64+8>>2];b=0;while(1){if((b|0)==3)break;c[n+64+(b<<2)>>2]=0;b=b+1|0}rq(n+64|0);Gb[c[(c[d>>2]|0)+24>>2]&127](n+52|0,d);if((a[j+11>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0}else{a[j>>0]=0;a[j+11>>0]=0}o=0;ba(142,j|0);g=o;o=0;if(g&1){g=Za(0)|0;lt(g)}c[j>>2]=c[n+52>>2];c[j+4>>2]=c[n+52+4>>2];c[j+8>>2]=c[n+52+8>>2];b=0;while(1){if((b|0)==3)break;c[n+52+(b<<2)>>2]=0;b=b+1|0}rq(n+52|0);b=Ib[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{d=wq(d,54044)|0;Gb[c[(c[d>>2]|0)+44>>2]&127](n+48|0,d);b=c[n+48>>2]|0;a[e>>0]=b;a[e+1>>0]=b>>8;a[e+2>>0]=b>>16;a[e+3>>0]=b>>24;Gb[c[(c[d>>2]|0)+32>>2]&127](n+36|0,d);if((a[l+11>>0]|0)<0){a[c[l>>2]>>0]=0;c[l+4>>2]=0}else{a[l>>0]=0;a[l+11>>0]=0}o=0;ba(142,l|0);e=o;o=0;if(e&1){e=Za(0)|0;lt(e)}c[l>>2]=c[n+36>>2];c[l+4>>2]=c[n+36+4>>2];c[l+8>>2]=c[n+36+8>>2];b=0;while(1){if((b|0)==3)break;c[n+36+(b<<2)>>2]=0;b=b+1|0}rq(n+36|0);Gb[c[(c[d>>2]|0)+28>>2]&127](n+24|0,d);if((a[k+11>>0]|0)<0){a[c[k>>2]>>0]=0;c[k+4>>2]=0}else{a[k>>0]=0;a[k+11>>0]=0}o=0;ba(142,k|0);e=o;o=0;if(e&1){e=Za(0)|0;lt(e)}c[k>>2]=c[n+24>>2];c[k+4>>2]=c[n+24+4>>2];c[k+8>>2]=c[n+24+8>>2];b=0;while(1){if((b|0)==3)break;c[n+24+(b<<2)>>2]=0;b=b+1|0}rq(n+24|0);a[f>>0]=Ib[c[(c[d>>2]|0)+12>>2]&127](d)|0;a[g>>0]=Ib[c[(c[d>>2]|0)+16>>2]&127](d)|0;Gb[c[(c[d>>2]|0)+20>>2]&127](n+12|0,d);if((a[h+11>>0]|0)<0){a[c[h>>2]>>0]=0;c[h+4>>2]=0}else{a[h>>0]=0;a[h+11>>0]=0}o=0;ba(142,h|0);g=o;o=0;if(g&1){g=Za(0)|0;lt(g)}c[h>>2]=c[n+12>>2];c[h+4>>2]=c[n+12+4>>2];c[h+8>>2]=c[n+12+8>>2];b=0;while(1){if((b|0)==3)break;c[n+12+(b<<2)>>2]=0;b=b+1|0}rq(n+12|0);Gb[c[(c[d>>2]|0)+24>>2]&127](n,d);if((a[j+11>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0}else{a[j>>0]=0;a[j+11>>0]=0}o=0;ba(142,j|0);g=o;o=0;if(g&1){g=Za(0)|0;lt(g)}c[j>>2]=c[n>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}rq(n);b=Ib[c[(c[d>>2]|0)+36>>2]&127](d)|0}c[m>>2]=b;i=p;return}function vc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0;p=i;r=i=i+63&-64;i=i+320|0;c[r+192>>2]=0;c[r+192+4>>2]=0;c[r+192+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[r+192+(b<<2)>>2]=0;b=b+1|0}b=Wm(f)|0;o=0;f=va(32,b|0,52364)|0;n=o;o=0;if(!(n&1)?(o=0,Ba(c[(c[f>>2]|0)+48>>2]|0,f|0,47202,47228,r+208|0)|0,n=o,o=0,!(n&1)):0){en(b);c[r+180>>2]=0;c[r+180+4>>2]=0;c[r+180+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[r+180+(b<<2)>>2]=0;b=b+1|0}n=r+180+11|0;if((a[n>>0]|0)<0)b=(c[r+180+8>>2]&2147483647)+-1|0;else b=10;o=0;da(59,r+180|0,b|0);m=o;o=0;a:do if(!(m&1)){k=(a[n>>0]|0)<0?c[r+180>>2]|0:r+180|0;c[r+176>>2]=k;c[r+8>>2]=r+16;c[r+4>>2]=0;f=c[d>>2]|0;b:while(1){if(f){b=c[f+12>>2]|0;if((b|0)==(c[f+16>>2]|0)){o=0;b=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;m=o;o=0;if(m&1){q=34;break}}else b=c[b>>2]|0;if((b|0)==-1){c[d>>2]=0;m=0;f=1}else{m=f;f=0}}else{m=0;f=1}j=c[e>>2]|0;do if(j){b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){o=0;b=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;l=o;o=0;if(l&1){q=34;break b}}else b=c[b>>2]|0;if((b|0)!=-1)if(f)break;else{b=k;break b}else{c[e>>2]=0;q=25;break}}else q=25;while(0);if((q|0)==25){q=0;if(f){j=0;b=k;break}else j=0}f=a[n>>0]|0;f=f<<24>>24<0?c[r+180+4>>2]|0:f&255;if((c[r+176>>2]|0)==(k+f|0)){o=0;da(59,r+180|0,f<<1|0);l=o;o=0;if(l&1){q=34;break}if((a[n>>0]|0)<0)b=(c[r+180+8>>2]&2147483647)+-1|0;else b=10;o=0;da(59,r+180|0,b|0);l=o;o=0;if(l&1){q=34;break}b=(a[n>>0]|0)<0?c[r+180>>2]|0:r+180|0;c[r+176>>2]=b+f}else b=k;k=m+12|0;f=c[k>>2]|0;l=m+16|0;if((f|0)==(c[l>>2]|0)){o=0;f=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;s=o;o=0;if(s&1){q=34;break}}else f=c[f>>2]|0;if(me(f,16,b,r+176|0,r+4|0,0,r+192|0,r+16|0,r+8|0,r+208|0)|0)break;f=c[k>>2]|0;if((f|0)==(c[l>>2]|0)){o=0;ha(c[(c[m>>2]|0)+40>>2]|0,m|0)|0;s=o;o=0;if(s&1){q=34;break}else{f=m;k=b;continue}}else{c[k>>2]=f+4;f=m;k=b;continue}}if((q|0)==34){b=Ya()|0;break}o=0;da(59,r+180|0,(c[r+176>>2]|0)-b|0);s=o;o=0;if(!(s&1)){l=a[n>>0]|0;n=c[r+180>>2]|0;s=zq()|0;c[r>>2]=h;if((Ik(l<<24>>24<0?n:r+180|0,s,0,r)|0)!=1)c[g>>2]=4;if(m){b=c[m+12>>2]|0;if((b|0)==(c[m+16>>2]|0)){o=0;b=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;s=o;o=0;if(s&1){q=35;break}}else b=c[b>>2]|0;if((b|0)==-1){c[d>>2]=0;f=1}else f=0}else f=1;do if(j){b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){o=0;b=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;s=o;o=0;if(s&1){q=35;break a}}else b=c[b>>2]|0;if((b|0)!=-1)if(f)break;else{q=61;break}else{c[e>>2]=0;q=59;break}}else q=59;while(0);if((q|0)==59?f:0)q=61;if((q|0)==61)c[g>>2]=c[g>>2]|2;s=c[d>>2]|0;rq(r+180|0);rq(r+192|0);i=p;return s|0}else q=35}else q=35;while(0);if((q|0)==35)b=Ya()|0;rq(r+180|0)}else{s=Ya()|0;en(b);b=s}rq(r+192|0);Ra(b|0);return 0}function wc(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0;j=i;k=i=i+63&-64;i=i+320|0;h=k+280|0;g=h+32|0;do{a[h>>0]=a[e>>0]|0;h=h+1|0;e=e+1|0}while((h|0)<(g|0));a[k+280>>0]=(d[k+280>>0]|0)&248;a[k+280+31>>0]=(d[k+280+31>>0]|0)&63|64;Vc(k+240|0,f);fo(k+200|0);Zp(k+160|0);Fh(k+120|0,k+240|0);fo(k+80|0);e=254;g=0;while(1){B=g;g=(d[k+280+((e|0)/8|0)>>0]|0)>>>(e&7)&1;B=g^B;Ie(k+200|0,k+120|0,B);Ie(k+160|0,k+80|0,B);hg(k+40|0,k+120|0,k+80|0);hg(k,k+200|0,k+160|0);ig(k+200|0,k+200|0,k+160|0);ig(k+160|0,k+120|0,k+80|0);ic(k+80|0,k+40|0,k+200|0);ic(k+160|0,k+160|0,k);lc(k+40|0,k);lc(k,k+200|0);ig(k+120|0,k+80|0,k+160|0);hg(k+160|0,k+80|0,k+160|0);ic(k+200|0,k,k+40|0);hg(k,k,k+40|0);lc(k+160|0,k+160|0);B=c[k>>2]|0;A=c[k+4>>2]|0;z=c[k+8>>2]|0;y=c[k+12>>2]|0;x=c[k+16>>2]|0;s=c[k+20>>2]|0;v=c[k+24>>2]|0;E=c[k+28>>2]|0;t=c[k+32>>2]|0;C=c[k+36>>2]|0;B=_m(B|0,((B|0)<0)<<31>>31|0,121666,0)|0;q=D;A=_m(A|0,((A|0)<0)<<31>>31|0,121666,0)|0;r=D;z=_m(z|0,((z|0)<0)<<31>>31|0,121666,0)|0;o=D;y=_m(y|0,((y|0)<0)<<31>>31|0,121666,0)|0;p=D;x=_m(x|0,((x|0)<0)<<31>>31|0,121666,0)|0;m=D;s=_m(s|0,((s|0)<0)<<31>>31|0,121666,0)|0;n=D;v=_m(v|0,((v|0)<0)<<31>>31|0,121666,0)|0;f=D;E=_m(E|0,((E|0)<0)<<31>>31|0,121666,0)|0;l=D;t=_m(t|0,((t|0)<0)<<31>>31|0,121666,0)|0;u=D;C=_m(C|0,((C|0)<0)<<31>>31|0,121666,0)|0;h=D;F=Jp(C|0,h|0,16777216,0)|0;F=ln(F|0,D|0,25)|0;w=D;G=_m(F|0,w|0,19,0)|0;q=Jp(G|0,D|0,B|0,q|0)|0;B=D;w=_n(F|0,w|0,25)|0;w=mo(C|0,h|0,w|0,D|0)|0;h=D;C=Jp(A|0,r|0,16777216,0)|0;C=ln(C|0,D|0,25)|0;F=D;o=Jp(C|0,F|0,z|0,o|0)|0;z=D;F=_n(C|0,F|0,25)|0;F=mo(A|0,r|0,F|0,D|0)|0;r=D;A=Jp(y|0,p|0,16777216,0)|0;A=ln(A|0,D|0,25)|0;C=D;m=Jp(A|0,C|0,x|0,m|0)|0;x=D;C=_n(A|0,C|0,25)|0;C=mo(y|0,p|0,C|0,D|0)|0;p=D;y=Jp(s|0,n|0,16777216,0)|0;y=ln(y|0,D|0,25)|0;A=D;f=Jp(y|0,A|0,v|0,f|0)|0;v=D;A=_n(y|0,A|0,25)|0;A=mo(s|0,n|0,A|0,D|0)|0;n=D;s=Jp(E|0,l|0,16777216,0)|0;s=ln(s|0,D|0,25)|0;y=D;u=Jp(s|0,y|0,t|0,u|0)|0;t=D;y=_n(s|0,y|0,25)|0;y=mo(E|0,l|0,y|0,D|0)|0;l=D;E=Jp(q|0,B|0,33554432,0)|0;E=ln(E|0,D|0,26)|0;s=D;r=Jp(F|0,r|0,E|0,s|0)|0;s=_n(E|0,s|0,26)|0;s=mo(q|0,B|0,s|0,D|0)|0;B=Jp(o|0,z|0,33554432,0)|0;B=ln(B|0,D|0,26)|0;q=D;p=Jp(C|0,p|0,B|0,q|0)|0;q=_n(B|0,q|0,26)|0;q=mo(o|0,z|0,q|0,D|0)|0;z=Jp(m|0,x|0,33554432,0)|0;z=ln(z|0,D|0,26)|0;o=D;n=Jp(A|0,n|0,z|0,o|0)|0;o=_n(z|0,o|0,26)|0;o=mo(m|0,x|0,o|0,D|0)|0;x=Jp(f|0,v|0,33554432,0)|0;x=ln(x|0,D|0,26)|0;m=D;l=Jp(y|0,l|0,x|0,m|0)|0;m=_n(x|0,m|0,26)|0;m=mo(f|0,v|0,m|0,D|0)|0;v=Jp(u|0,t|0,33554432,0)|0;v=ln(v|0,D|0,26)|0;f=D;h=Jp(w|0,h|0,v|0,f|0)|0;f=_n(v|0,f|0,26)|0;f=mo(u|0,t|0,f|0,D|0)|0;c[k+80>>2]=s;c[k+80+4>>2]=r;c[k+80+8>>2]=q;c[k+80+12>>2]=p;c[k+80+16>>2]=o;c[k+80+20>>2]=n;c[k+80+24>>2]=m;c[k+80+28>>2]=l;c[k+80+32>>2]=f;c[k+80+36>>2]=h;lc(k+120|0,k+120|0);ig(k+40|0,k+40|0,k+80|0);ic(k+80|0,k+240|0,k+160|0);ic(k+160|0,k,k+40|0);if((e|0)<=0)break;else e=e+-1|0}Ie(k+200|0,k+120|0,g);Ie(k+160|0,k+80|0,g);td(k+160|0,k+160|0);ic(k+200|0,k+200|0,k+160|0);Rd(b,k+200|0);i=j;return 0}function xc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;x=i;l=i=i+63&-64;i=i+112|0;do if(((f-e|0)/12|0)>>>0>100){l=ec((f-e|0)/12|0)|0;if((l|0)==0?(o=0,Fa(20),w=o,o=0,w&1):0){k=0;p=6;break}k=l;p=11}else{k=0;p=11}while(0);a:do if((p|0)==11){p=e;r=0;n=(f-e|0)/12|0;q=l;while(1){if((p|0)==(f|0))break;m=a[p+8+3>>0]|0;if(m<<24>>24<0)m=c[p+4>>2]|0;else m=m&255;if(!m){a[q>>0]=2;m=r+1|0;n=n+-1|0}else{a[q>>0]=1;m=r}p=p+12|0;r=m;q=q+1|0}w=0;s=n;b:while(1){m=c[b>>2]|0;do if(m){n=c[m+12>>2]|0;if((n|0)==(c[m+16>>2]|0)){o=0;m=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;v=o;o=0;if(v&1){p=5;break b}}else m=c[n>>2]|0;if((m|0)==-1){c[b>>2]=0;p=1;break}else{p=(c[b>>2]|0)==0;break}}else p=1;while(0);if(!d){q=0;m=1;d=0}else{m=c[d+12>>2]|0;if((m|0)==(c[d+16>>2]|0)){o=0;m=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;v=o;o=0;if(v&1){p=5;break}}else m=c[m>>2]|0;v=(m|0)==-1;q=v?0:d;m=v;d=v?0:d}n=c[b>>2]|0;if(!((s|0)!=0&(p^m))){p=34;break}m=c[n+12>>2]|0;if((m|0)==(c[n+16>>2]|0)){o=0;m=ha(c[(c[n>>2]|0)+36>>2]|0,n|0)|0;v=o;o=0;if(v&1){p=5;break}}else m=c[m>>2]|0;if(!j){o=0;m=va(c[(c[g>>2]|0)+28>>2]|0,g|0,m|0)|0;v=o;o=0;if(v&1){p=5;break}}v=w+1|0;q=0;t=e;u=s;s=l;while(1){if((t|0)==(f|0))break;do if((a[s>>0]|0)==1){p=t+8+3|0;if((a[p>>0]|0)<0)n=c[t>>2]|0;else n=t;n=c[n+(w<<2)>>2]|0;if(!j){o=0;n=va(c[(c[g>>2]|0)+28>>2]|0,g|0,n|0)|0;y=o;o=0;if(y&1){p=4;break b}}if((m|0)!=(n|0)){a[s>>0]=0;n=q;p=u+-1|0;break}n=a[p>>0]|0;if(n<<24>>24<0)n=c[t+4>>2]|0;else n=n&255;if((n|0)==(v|0)){a[s>>0]=2;n=1;r=r+1|0;p=u+-1|0}else{n=1;p=u}}else{n=q;p=u}while(0);q=n;t=t+12|0;u=p;s=s+1|0}if(!q){w=v;s=u;continue}m=c[b>>2]|0;n=c[m+12>>2]|0;if((n|0)==(c[m+16>>2]|0)){o=0;ha(c[(c[m>>2]|0)+40>>2]|0,m|0)|0;y=o;o=0;if(y&1){p=5;break}}else c[m+12>>2]=n+4;if((r+u|0)>>>0>1){q=e;m=r;p=l}else{w=v;s=u;continue}while(1){if((q|0)==(f|0)){w=v;r=m;s=u;continue b}if((a[p>>0]|0)==2){n=a[q+8+3>>0]|0;if(n<<24>>24<0)n=c[q+4>>2]|0;else n=n&255;if((n|0)!=(v|0)){a[p>>0]=0;m=m+-1|0}}q=q+12|0;p=p+1|0}}if((p|0)==4){e=Ya()|0;break}else if((p|0)==5){e=Ya()|0;break}else if((p|0)==34){do if(n){m=c[n+12>>2]|0;if((m|0)==(c[n+16>>2]|0)){o=0;m=ha(c[(c[n>>2]|0)+36>>2]|0,n|0)|0;y=o;o=0;if(y&1){p=6;break a}}else m=c[m>>2]|0;if((m|0)==-1){c[b>>2]=0;n=1;break}else{n=(c[b>>2]|0)==0;break}}else n=1;while(0);if(q){m=c[q+12>>2]|0;if((m|0)==(c[q+16>>2]|0)){o=0;m=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;y=o;o=0;if(y&1){p=6;break}}else m=c[m>>2]|0;if((m|0)!=-1){if(!n)p=82}else p=80}else p=80;if((p|0)==80)if(n)p=82;if((p|0)==82)c[h>>2]=c[h>>2]|2;while(1){if((e|0)==(f|0)){p=86;break}if((a[l>>0]|0)==2)break;e=e+12|0;l=l+1|0}if((p|0)==86){c[h>>2]=c[h>>2]|4;e=f}if(k|0)nc(k);i=x;return e|0}}while(0);if((p|0)==6)e=Ya()|0;if(k|0)nc(k);Ra(e|0);return 0}function yc(b,c,e,f){b=b|0;c=c|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;if(!f){H=1634760805;I=857760878;J=2036477234;G=1797285236}else{H=d[f>>0]|d[f+1>>0]<<8|d[f+2>>0]<<16|d[f+3>>0]<<24;I=d[f+4>>0]|d[f+4+1>>0]<<8|d[f+4+2>>0]<<16|d[f+4+3>>0]<<24;J=d[f+8>>0]|d[f+8+1>>0]<<8|d[f+8+2>>0]<<16|d[f+8+3>>0]<<24;G=d[f+12>>0]|d[f+12+1>>0]<<8|d[f+12+2>>0]<<16|d[f+12+3>>0]<<24}F=d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24;z=d[e+4>>0]|d[e+4+1>>0]<<8|d[e+4+2>>0]<<16|d[e+4+3>>0]<<24;A=d[e+8>>0]|d[e+8+1>>0]<<8|d[e+8+2>>0]<<16|d[e+8+3>>0]<<24;B=d[e+12>>0]|d[e+12+1>>0]<<8|d[e+12+2>>0]<<16|d[e+12+3>>0]<<24;C=d[c>>0]|d[c+1>>0]<<8|d[c+2>>0]<<16|d[c+3>>0]<<24;D=d[c+4>>0]|d[c+4+1>>0]<<8|d[c+4+2>>0]<<16|d[c+4+3>>0]<<24;E=d[c+8>>0]|d[c+8+1>>0]<<8|d[c+8+2>>0]<<16|d[c+8+3>>0]<<24;v=d[c+12>>0]|d[c+12+1>>0]<<8|d[c+12+2>>0]<<16|d[c+12+3>>0]<<24;w=d[e+16>>0]|d[e+16+1>>0]<<8|d[e+16+2>>0]<<16|d[e+16+3>>0]<<24;x=d[e+20>>0]|d[e+20+1>>0]<<8|d[e+20+2>>0]<<16|d[e+20+3>>0]<<24;y=d[e+24>>0]|d[e+24+1>>0]<<8|d[e+24+2>>0]<<16|d[e+24+3>>0]<<24;f=d[e+28>>0]|d[e+28+1>>0]<<8|d[e+28+2>>0]<<16|d[e+28+3>>0]<<24;c=20;e=H;g=F;h=J;i=w;j=x;k=y;l=f;m=G;n=z;o=A;p=B;q=I;r=C;s=D;t=E;u=v;while(1){T=e+j|0;T=(T>>>25|T<<7)^p;Q=T+e|0;Q=(Q>>>23|Q<<9)^t;N=((Q+T|0)>>>19|Q+T<<13)^j;W=((N+Q|0)>>>14|N+Q<<18)^e;P=g+q|0;P=(P>>>25|P<<7)^u;M=P+q|0;M=(M>>>23|M<<9)^k;Z=((M+P|0)>>>19|M+P<<13)^g;S=((Z+M|0)>>>14|Z+M<<18)^q;L=r+h|0;L=(L>>>25|L<<7)^l;Y=L+h|0;Y=(Y>>>23|Y<<9)^n;V=((Y+L|0)>>>19|Y+L<<13)^r;O=((V+Y|0)>>>14|V+Y<<18)^h;X=i+m|0;X=o^(X>>>25|X<<7);U=X+m|0;U=(U>>>23|U<<9)^s;R=((U+X|0)>>>19|U+X<<13)^i;K=((R+U|0)>>>14|R+U<<18)^m;g=((W+X|0)>>>25|W+X<<7)^Z;Z=g+W|0;n=(Z>>>23|Z<<9)^Y;Y=n+g|0;o=(Y>>>19|Y<<13)^X;X=o+n|0;e=(X>>>14|X<<18)^W;r=((S+T|0)>>>25|S+T<<7)^V;V=r+S|0;s=(V>>>23|V<<9)^U;U=s+r|0;p=(U>>>19|U<<13)^T;T=p+s|0;q=(T>>>14|T<<18)^S;i=((O+P|0)>>>25|O+P<<7)^R;R=i+O|0;t=(R>>>23|R<<9)^Q;Q=t+i|0;u=(Q>>>19|Q<<13)^P;P=u+t|0;h=(P>>>14|P<<18)^O;j=((K+L|0)>>>25|K+L<<7)^N;N=j+K|0;k=(N>>>23|N<<9)^M;M=k+j|0;l=(M>>>19|M<<13)^L;L=l+k|0;m=(L>>>14|L<<18)^K;if((c|0)<=2)break;else c=c+-2|0}K=e+H|0;L=g+F|0;M=n+z|0;N=o+A|0;O=p+B|0;P=q+I|0;Q=r+C|0;R=s+D|0;S=t+E|0;T=u+v|0;U=h+J|0;V=i+w|0;W=j+x|0;X=k+y|0;Y=l+f|0;Z=m+G|0;a[b>>0]=K;a[b+1>>0]=K>>8;a[b+2>>0]=K>>16;a[b+3>>0]=K>>24;a[b+4>>0]=L;a[b+4+1>>0]=L>>8;a[b+4+2>>0]=L>>16;a[b+4+3>>0]=L>>24;a[b+8>>0]=M;a[b+8+1>>0]=M>>8;a[b+8+2>>0]=M>>16;a[b+8+3>>0]=M>>24;a[b+12>>0]=N;a[b+12+1>>0]=N>>8;a[b+12+2>>0]=N>>16;a[b+12+3>>0]=N>>24;a[b+16>>0]=O;a[b+16+1>>0]=O>>8;a[b+16+2>>0]=O>>16;a[b+16+3>>0]=O>>24;a[b+20>>0]=P;a[b+20+1>>0]=P>>8;a[b+20+2>>0]=P>>16;a[b+20+3>>0]=P>>24;a[b+24>>0]=Q;a[b+24+1>>0]=Q>>8;a[b+24+2>>0]=Q>>16;a[b+24+3>>0]=Q>>24;a[b+28>>0]=R;a[b+28+1>>0]=R>>8;a[b+28+2>>0]=R>>16;a[b+28+3>>0]=R>>24;a[b+32>>0]=S;a[b+32+1>>0]=S>>8;a[b+32+2>>0]=S>>16;a[b+32+3>>0]=S>>24;a[b+36>>0]=T;a[b+36+1>>0]=T>>8;a[b+36+2>>0]=T>>16;a[b+36+3>>0]=T>>24;a[b+40>>0]=U;a[b+40+1>>0]=U>>8;a[b+40+2>>0]=U>>16;a[b+40+3>>0]=U>>24;a[b+44>>0]=V;a[b+44+1>>0]=V>>8;a[b+44+2>>0]=V>>16;a[b+44+3>>0]=V>>24;a[b+48>>0]=W;a[b+48+1>>0]=W>>8;a[b+48+2>>0]=W>>16;a[b+48+3>>0]=W>>24;a[b+52>>0]=X;a[b+52+1>>0]=X>>8;a[b+52+2>>0]=X>>16;a[b+52+3>>0]=X>>24;a[b+56>>0]=Y;a[b+56+1>>0]=Y>>8;a[b+56+2>>0]=Y>>16;a[b+56+3>>0]=Y>>24;a[b+60>>0]=Z;a[b+60+1>>0]=Z>>8;a[b+60+2>>0]=Z>>16;a[b+60+3>>0]=Z>>24;return 0}function zc(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;y=i;m=i=i+63&-64;i=i+112|0;do if(((g-f|0)/12|0)>>>0>100){m=ec((g-f|0)/12|0)|0;if((m|0)==0?(o=0,Fa(20),x=o,o=0,x&1):0){l=0;s=6;break}l=m;s=11}else{l=0;s=11}while(0);a:do if((s|0)==11){q=f;s=0;p=(g-f|0)/12|0;r=m;while(1){if((q|0)==(g|0))break;n=a[q+11>>0]|0;if(n<<24>>24<0)n=c[q+4>>2]|0;else n=n&255;if(!n){a[r>>0]=2;n=s+1|0;p=p+-1|0}else{a[r>>0]=1;n=s}q=q+12|0;s=n;r=r+1|0}x=0;t=p;b:while(1){n=c[b>>2]|0;do if(n){if((c[n+12>>2]|0)==(c[n+16>>2]|0)){o=0;n=ha(c[(c[n>>2]|0)+36>>2]|0,n|0)|0;w=o;o=0;if(w&1){s=5;break b}if((n|0)==-1){c[b>>2]=0;n=0;break}else{n=c[b>>2]|0;break}}}else n=0;while(0);p=(n|0)==0;if(e)if((c[e+12>>2]|0)==(c[e+16>>2]|0)){o=0;n=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;w=o;o=0;if(w&1){s=5;break}r=(n|0)==-1?0:e;e=(n|0)==-1?0:e}else r=e;else{r=0;e=0}q=(r|0)==0;n=c[b>>2]|0;if(!((t|0)!=0&(p^q))){s=32;break}p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){o=0;n=ha(c[(c[n>>2]|0)+36>>2]|0,n|0)|0;w=o;o=0;if(w&1){s=5;break}}else n=d[p>>0]|0;n=n&255;if(!k){o=0;n=va(c[(c[h>>2]|0)+12>>2]|0,h|0,n|0)|0;w=o;o=0;if(w&1){s=5;break}}w=x+1|0;r=0;u=f;v=t;t=m;while(1){if((u|0)==(g|0))break;do if((a[t>>0]|0)==1){q=u+11|0;if((a[q>>0]|0)<0)p=c[u>>2]|0;else p=u;p=a[p+x>>0]|0;if(!k){o=0;p=va(c[(c[h>>2]|0)+12>>2]|0,h|0,p|0)|0;z=o;o=0;if(z&1){s=4;break b}}if(n<<24>>24!=p<<24>>24){a[t>>0]=0;p=r;q=v+-1|0;break}p=a[q>>0]|0;if(p<<24>>24<0)p=c[u+4>>2]|0;else p=p&255;if((p|0)==(w|0)){a[t>>0]=2;p=1;s=s+1|0;q=v+-1|0}else{p=1;q=v}}else{p=r;q=v}while(0);r=p;u=u+12|0;v=q;t=t+1|0}if(!r){x=w;t=v;continue}n=c[b>>2]|0;p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){o=0;ha(c[(c[n>>2]|0)+40>>2]|0,n|0)|0;z=o;o=0;if(z&1){s=5;break}}else c[n+12>>2]=p+1;if((s+v|0)>>>0>1){r=f;n=s;q=m}else{x=w;t=v;continue}while(1){if((r|0)==(g|0)){x=w;s=n;t=v;continue b}if((a[q>>0]|0)==2){p=a[r+11>>0]|0;if(p<<24>>24<0)p=c[r+4>>2]|0;else p=p&255;if((p|0)!=(w|0)){a[q>>0]=0;n=n+-1|0}}r=r+12|0;q=q+1|0}}if((s|0)==4){f=Ya()|0;break}else if((s|0)==5){f=Ya()|0;break}else if((s|0)==32){do if(n){if((c[n+12>>2]|0)==(c[n+16>>2]|0)){o=0;n=ha(c[(c[n>>2]|0)+36>>2]|0,n|0)|0;z=o;o=0;if(z&1){s=6;break a}if((n|0)==-1){c[b>>2]=0;n=0;break}else{n=c[b>>2]|0;break}}}else n=0;while(0);p=(n|0)==0;do if(!q){if((c[r+12>>2]|0)==(c[r+16>>2]|0)){o=0;n=ha(c[(c[r>>2]|0)+36>>2]|0,r|0)|0;z=o;o=0;if(z&1){s=6;break a}if((n|0)==-1){s=77;break}}if(!p)s=78}else s=77;while(0);if((s|0)==77)if(p)s=78;if((s|0)==78)c[j>>2]=c[j>>2]|2;while(1){if((f|0)==(g|0)){s=82;break}if((a[m>>0]|0)==2)break;f=f+12|0;m=m+1|0}if((s|0)==82){c[j>>2]=c[j>>2]|4;f=g}if(l|0)nc(l);i=y;return f|0}}while(0);if((s|0)==6)f=Ya()|0;if(l|0)nc(l);Ra(f|0);return 0}function Ac(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0;q=i;s=i=i+63&-64;i=i+240|0;c[s+192>>2]=0;c[s+192+4>>2]=0;c[s+192+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[s+192+(b<<2)>>2]=0;b=b+1|0}b=Wm(g)|0;o=0;g=va(32,b|0,52332)|0;p=o;o=0;if(!(p&1)?(o=0,Ba(c[(c[g>>2]|0)+32>>2]|0,g|0,47202,47228,s+204|0)|0,p=o,o=0,!(p&1)):0){en(b);c[s+180>>2]=0;c[s+180+4>>2]=0;c[s+180+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[s+180+(b<<2)>>2]=0;b=b+1|0}p=s+180+11|0;if((a[p>>0]|0)<0)b=(c[s+180+8>>2]&2147483647)+-1|0;else b=10;o=0;da(59,s+180|0,b|0);n=o;o=0;a:do if(!(n&1)){m=(a[p>>0]|0)<0?c[s+180>>2]|0:s+180|0;c[s+176>>2]=m;c[s+8>>2]=s+16;c[s+4>>2]=0;b=c[e>>2]|0;b:while(1){if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)){o=0;g=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;n=o;o=0;if(n&1){r=33;break}if((g|0)==-1){c[e>>2]=0;b=0}}}else b=0;g=(b|0)==0;l=c[f>>2]|0;do if(l){if((c[l+12>>2]|0)!=(c[l+16>>2]|0))if(g)break;else{g=m;break b}o=0;k=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;n=o;o=0;if(n&1){r=33;break b}if((k|0)!=-1)if(g)break;else{g=m;break b}else{c[f>>2]=0;r=24;break}}else r=24;while(0);if((r|0)==24){r=0;if(g){b=0;l=0;g=m;break}else l=0}k=a[p>>0]|0;k=k<<24>>24<0?c[s+180+4>>2]|0:k&255;if((c[s+176>>2]|0)==(m+k|0)){o=0;da(59,s+180|0,k<<1|0);n=o;o=0;if(n&1){r=33;break}if((a[p>>0]|0)<0)g=(c[s+180+8>>2]&2147483647)+-1|0;else g=10;o=0;da(59,s+180|0,g|0);n=o;o=0;if(n&1){r=33;break}g=(a[p>>0]|0)<0?c[s+180>>2]|0:s+180|0;c[s+176>>2]=g+k}else g=m;m=b+12|0;k=c[m>>2]|0;n=b+16|0;if((k|0)==(c[n>>2]|0)){o=0;k=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;t=o;o=0;if(t&1){r=33;break}}else k=d[k>>0]|0;if(le(k&255,16,g,s+176|0,s+4|0,0,s+192|0,s+16|0,s+8|0,s+204|0)|0)break;k=c[m>>2]|0;if((k|0)==(c[n>>2]|0)){o=0;ha(c[(c[b>>2]|0)+40>>2]|0,b|0)|0;t=o;o=0;if(t&1){r=33;break}else{m=g;continue}}else{c[m>>2]=k+1;m=g;continue}}if((r|0)==33){b=Ya()|0;break}o=0;da(59,s+180|0,(c[s+176>>2]|0)-g|0);t=o;o=0;if(!(t&1)){n=a[p>>0]|0;p=c[s+180>>2]|0;t=zq()|0;c[s>>2]=j;if((Ik(n<<24>>24<0?p:s+180|0,t,0,s)|0)!=1)c[h>>2]=4;if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)){o=0;g=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;t=o;o=0;if(t&1){r=34;break}if((g|0)==-1){c[e>>2]=0;b=0}}}else b=0;g=(b|0)==0;do if(l){if((c[l+12>>2]|0)==(c[l+16>>2]|0)){o=0;b=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=34;break a}if((b|0)==-1){c[f>>2]=0;r=57;break}}if(!g)r=58}else r=57;while(0);if((r|0)==57?g:0)r=58;if((r|0)==58)c[h>>2]=c[h>>2]|2;t=c[e>>2]|0;rq(s+180|0);rq(s+192|0);i=q;return t|0}else r=34}else r=34;while(0);if((r|0)==34)b=Ya()|0;rq(s+180|0)}else{t=Ya()|0;en(b);b=t}rq(s+192|0);Ra(b|0);return 0}function Bc(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=i;w=i=i+63&-64;i=i+16|0;n=Wm(h)|0;o=0;u=va(32,n|0,52332)|0;t=o;o=0;if(t&1){y=Ya()|0;en(n);Ra(y|0)}en(n);c[j>>2]=0;n=0;a:while(1){r=(l|0)!=(m|0);p=f;while(1){if(!(r&(n|0)==0)){n=p;l=g;break a}f=p;if(p)if((c[p+12>>2]|0)==(c[p+16>>2]|0)){s=(Ib[c[(c[p>>2]|0)+36>>2]&127](p)|0)==-1;n=s?0:p;f=s?0:f;s=s?0:p}else{n=p;s=p}else{n=0;s=0}q=(n|0)==0;p=g;do if(g){if((c[g+12>>2]|0)==(c[g+16>>2]|0)?(Ib[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1:0){g=0;x=12;break}if(!q){x=13;break a}}else{g=p;x=12}while(0);if((x|0)==12){x=0;if(q){n=0;g=0;x=13;break a}else{p=g;g=0}}if((Kb[c[(c[u>>2]|0)+36>>2]&63](u,a[l>>0]|0,0)|0)<<24>>24==37){x=16;break}f=a[l>>0]|0;if(f<<24>>24>-1?(v=c[u+8>>2]|0,b[v+(f<<24>>24<<1)>>1]&8192):0){x=25;break}p=n+12|0;f=c[p>>2]|0;q=n+16|0;if((f|0)==(c[q>>2]|0))f=Ib[c[(c[n>>2]|0)+36>>2]&127](n)|0;else f=d[f>>0]|0;t=Pb[c[(c[u>>2]|0)+12>>2]&63](u,f&255)|0;if(t<<24>>24==(Pb[c[(c[u>>2]|0)+12>>2]&63](u,a[l>>0]|0)|0)<<24>>24){x=50;break}c[j>>2]=4;n=4;p=s}b:do if((x|0)==16){x=0;q=l+1|0;if((q|0)==(m|0)){x=17;break a}s=Kb[c[(c[u>>2]|0)+36>>2]&63](u,a[q>>0]|0,0)|0;switch(s<<24>>24){case 48:case 69:{r=l+2|0;if((r|0)==(m|0)){x=22;break a}l=q;q=Kb[c[(c[u>>2]|0)+36>>2]&63](u,a[r>>0]|0,0)|0;n=s;break}default:{q=s;n=0}}t=c[(c[e>>2]|0)+36>>2]|0;c[w+4>>2]=f;c[w>>2]=p;c[w+8>>2]=c[w+4>>2];c[w+12>>2]=c[w>>2];l=l+2|0;f=Vb[t&31](e,w+8|0,w+12|0,h,j,k,q,n)|0}else if((x|0)==25){while(1){x=0;l=l+1|0;if((l|0)==(m|0)){l=m;break}f=a[l>>0]|0;if(f<<24>>24<=-1)break;if(!(b[v+(f<<24>>24<<1)>>1]&8192))break;else x=25}p=g;r=g;f=s;while(1){if(n){if((c[n+12>>2]|0)==(c[n+16>>2]|0)){t=(Ib[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1;n=t?0:n;f=t?0:f}}else n=0;q=(n|0)==0;do if(r){if((c[r+12>>2]|0)!=(c[r+16>>2]|0))if(q){t=p;s=r;break}else break b;if((Ib[c[(c[r>>2]|0)+36>>2]&127](r)|0)!=-1)if(q^(p|0)==0){t=p;s=p}else break b;else{p=0;g=0;x=36}}else x=36;while(0);if((x|0)==36){x=0;if(q)break b;else{t=p;s=0}}q=n+12|0;p=c[q>>2]|0;r=n+16|0;if((p|0)==(c[r>>2]|0))p=Ib[c[(c[n>>2]|0)+36>>2]&127](n)|0;else p=d[p>>0]|0;if((p&255)<<24>>24<=-1)break b;if(!(b[(c[u+8>>2]|0)+(p<<24>>24<<1)>>1]&8192))break b;p=c[q>>2]|0;if((p|0)==(c[r>>2]|0)){Ib[c[(c[n>>2]|0)+40>>2]&127](n)|0;p=t;r=s;continue}else{c[q>>2]=p+1;p=t;r=s;continue}}}else if((x|0)==50){x=0;f=c[p>>2]|0;if((f|0)==(c[q>>2]|0))Ib[c[(c[n>>2]|0)+40>>2]&127](n)|0;else c[p>>2]=f+1;l=l+1|0;f=s}while(0);n=c[j>>2]|0}if((x|0)==13){c[j>>2]=4;l=g}else if((x|0)==17){c[j>>2]=4;l=g}else if((x|0)==22){c[j>>2]=4;l=g}if(n){if((c[n+12>>2]|0)==(c[n+16>>2]|0)){w=(Ib[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1;n=w?0:n}}else n=0;g=(n|0)==0;do if(l){if((c[l+12>>2]|0)==(c[l+16>>2]|0)?(Ib[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1:0){x=63;break}if(!g)x=64}else x=63;while(0);if((x|0)==63?g:0)x=64;if((x|0)==64)c[j>>2]=c[j>>2]|2;i=y;return n|0}function Cc(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;u=i;s=i=i+63&-64;i=i+16|0;k=Wm(e)|0;o=0;r=va(32,k|0,52364)|0;q=o;o=0;if(q&1){u=Ya()|0;en(k);Ra(u|0)}en(k);c[f>>2]=0;k=0;a:while(1){q=(h|0)!=(j|0);while(1){if(!(q&(k|0)==0)){k=b;b=d;break a}l=b;if(!b){k=0;n=1;p=l;b=0}else{k=c[b+12>>2]|0;if((k|0)==(c[b+16>>2]|0))k=Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0;else k=c[k>>2]|0;m=(k|0)==-1;k=m?0:b;n=m;p=m?0:l;b=m?0:b}m=d;if(d){l=c[d+12>>2]|0;if((l|0)==(c[d+16>>2]|0))l=Ib[c[(c[d>>2]|0)+36>>2]&127](d)|0;else l=c[l>>2]|0;if((l|0)!=-1){if(!n){t=17;break a}}else{d=0;t=15}}else{d=m;t=15}if((t|0)==15){t=0;if(n){d=0;t=17;break a}else{m=d;d=0}}if((Kb[c[(c[r>>2]|0)+52>>2]&63](r,c[h>>2]|0,0)|0)<<24>>24==37){t=20;break}if(Kb[c[(c[r>>2]|0)+12>>2]&63](r,8192,c[h>>2]|0)|0){t=28;break}m=k+12|0;l=c[m>>2]|0;n=k+16|0;if((l|0)==(c[n>>2]|0))l=Ib[c[(c[k>>2]|0)+36>>2]&127](k)|0;else l=c[l>>2]|0;p=Pb[c[(c[r>>2]|0)+28>>2]&63](r,l)|0;if((p|0)==(Pb[c[(c[r>>2]|0)+28>>2]&63](r,c[h>>2]|0)|0)){t=54;break}c[f>>2]=4;k=4}b:do if((t|0)==20){t=0;b=h+4|0;if((b|0)==(j|0)){t=21;break a}n=Kb[c[(c[r>>2]|0)+52>>2]&63](r,c[b>>2]|0,0)|0;switch(n<<24>>24){case 48:case 69:{l=h+8|0;if((l|0)==(j|0)){t=26;break a}h=b;b=Kb[c[(c[r>>2]|0)+52>>2]&63](r,c[l>>2]|0,0)|0;k=n;break}default:{b=n;k=0}}q=c[(c[a>>2]|0)+36>>2]|0;c[s+4>>2]=p;c[s>>2]=m;c[s+8>>2]=c[s+4>>2];c[s+12>>2]=c[s>>2];h=h+8|0;b=Vb[q&31](a,s+8|0,s+12|0,e,f,g,b,k)|0}else if((t|0)==28){while(1){t=0;h=h+4|0;if((h|0)==(j|0)){h=j;break}if(Kb[c[(c[r>>2]|0)+12>>2]&63](r,8192,c[h>>2]|0)|0)t=28;else break}n=d;q=d;while(1){if(!k){m=1;k=0}else{l=c[k+12>>2]|0;if((l|0)==(c[k+16>>2]|0))l=Ib[c[(c[k>>2]|0)+36>>2]&127](k)|0;else l=c[l>>2]|0;p=(l|0)==-1;m=p;k=p?0:k;b=p?0:b}if(q){l=c[q+12>>2]|0;if((l|0)==(c[q+16>>2]|0))l=Ib[c[(c[q>>2]|0)+36>>2]&127](q)|0;else l=c[l>>2]|0;if((l|0)!=-1)if(m^(n|0)==0){l=n;q=n}else break b;else{l=0;d=0;t=41}}else{l=n;t=41}if((t|0)==41){t=0;if(m)break b;else q=0}n=k+12|0;m=c[n>>2]|0;p=k+16|0;if((m|0)==(c[p>>2]|0))m=Ib[c[(c[k>>2]|0)+36>>2]&127](k)|0;else m=c[m>>2]|0;if(!(Kb[c[(c[r>>2]|0)+12>>2]&63](r,8192,m)|0))break b;m=c[n>>2]|0;if((m|0)==(c[p>>2]|0)){Ib[c[(c[k>>2]|0)+40>>2]&127](k)|0;n=l;continue}else{c[n>>2]=m+4;n=l;continue}}}else if((t|0)==54){t=0;l=c[m>>2]|0;if((l|0)==(c[n>>2]|0))Ib[c[(c[k>>2]|0)+40>>2]&127](k)|0;else c[m>>2]=l+4;h=h+4|0}while(0);k=c[f>>2]|0}if((t|0)==17){c[f>>2]=4;b=d}else if((t|0)==21){c[f>>2]=4;b=d}else if((t|0)==26){c[f>>2]=4;b=d}if(!k){k=0;h=1}else{d=c[k+12>>2]|0;if((d|0)==(c[k+16>>2]|0))d=Ib[c[(c[k>>2]|0)+36>>2]&127](k)|0;else d=c[d>>2]|0;h=(d|0)==-1;k=h?0:k}if(b){d=c[b+12>>2]|0;if((d|0)==(c[b+16>>2]|0))d=Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0;else d=c[d>>2]|0;if((d|0)!=-1){if(!h)t=72}else t=70}else t=70;if((t|0)==70?h:0)t=72;if((t|0)==72)c[f>>2]=c[f>>2]|2;i=u;return k|0}function Dc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;u=i;v=i=i+63&-64;i=i+16|0;t=wq(c[j>>2]|0,52332)|0;r=wq(c[j>>2]|0,52344)|0;Gb[c[(c[r>>2]|0)+20>>2]&127](v,r);c[h>>2]=f;j=a[b>>0]|0;switch(j<<24>>24){case 43:case 45:{o=0;j=va(c[(c[t>>2]|0)+28>>2]|0,t|0,j|0)|0;s=o;o=0;if(s&1)s=6;else{l=c[h>>2]|0;c[h>>2]=l+1;a[l>>0]=j;l=b+1|0;s=8}break}default:{l=b;s=8}}a:do if((s|0)==8){b:do if((e-l|0)>1?(a[l>>0]|0)==48:0){k=l+1|0;switch(a[k>>0]|0){case 88:case 120:break;default:{j=l;s=17;break b}}o=0;j=va(c[(c[t>>2]|0)+28>>2]|0,t|0,48)|0;q=o;o=0;if(q&1){s=6;break a}q=c[h>>2]|0;c[h>>2]=q+1;a[q>>0]=j;l=l+2|0;o=0;j=va(c[(c[t>>2]|0)+28>>2]|0,t|0,a[k>>0]|0)|0;q=o;o=0;if(q&1){s=6;break a}q=c[h>>2]|0;c[h>>2]=q+1;a[q>>0]=j;j=l;while(1){if(j>>>0>=e>>>0){q=j;break b}q=a[j>>0]|0;zq()|0;if(!(Du(q<<24>>24)|0)){q=j;break b}j=j+1|0}}else{j=l;s=17}while(0);c:do if((s|0)==17)while(1){s=0;if(j>>>0>=e>>>0){q=j;break c}q=a[j>>0]|0;zq()|0;if(!(mu(q<<24>>24)|0)){q=j;break c}j=j+1|0;s=17}while(0);p=a[v+11>>0]|0;d:do if((p<<24>>24<0?c[v+4>>2]|0:p&255)|0){e:do if((l|0)!=(q|0)){j=q;k=l;while(1){j=j+-1|0;if(k>>>0>=j>>>0)break e;p=a[k>>0]|0;a[k>>0]=a[j>>0]|0;a[j>>0]=p;k=k+1|0}}while(0);o=0;n=ha(c[(c[r>>2]|0)+16>>2]|0,r|0)|0;p=o;o=0;if(p&1){s=6;break a}j=0;k=0;p=l;while(1){if(p>>>0>=q>>>0)break;m=a[((a[v+11>>0]|0)<0?c[v>>2]|0:v)+k>>0]|0;if(m<<24>>24>0&(j|0)==(m<<24>>24|0)){j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=n;j=a[v+11>>0]|0;m=0;k=(k>>>0<((j<<24>>24<0?c[v+4>>2]|0:j&255)+-1|0)>>>0&1)+k|0}else m=j;o=0;j=va(c[(c[t>>2]|0)+28>>2]|0,t|0,a[p>>0]|0)|0;w=o;o=0;if(w&1){s=5;break}w=c[h>>2]|0;c[h>>2]=w+1;a[w>>0]=j;j=m+1|0;p=p+1|0}if((s|0)==5){j=Ya()|0;break a}k=f+(l-b)|0;j=c[h>>2]|0;if((k|0)==(j|0))k=t;else while(1){j=j+-1|0;if(k>>>0>=j>>>0){k=t;break d}w=a[k>>0]|0;a[k>>0]=a[j>>0]|0;a[j>>0]=w;k=k+1|0}}else{o=0;Ba(c[(c[t>>2]|0)+32>>2]|0,t|0,l|0,q|0,c[h>>2]|0)|0;w=o;o=0;if(w&1){s=6;break a}c[h>>2]=(c[h>>2]|0)+(q-l);k=t}while(0);l=q;while(1){if(l>>>0>=e>>>0){j=l;break}j=a[l>>0]|0;if(j<<24>>24==46){s=39;break}o=0;j=va(c[(c[k>>2]|0)+28>>2]|0,t|0,j|0)|0;w=o;o=0;if(w&1){s=4;break}w=c[h>>2]|0;c[h>>2]=w+1;a[w>>0]=j;l=l+1|0}if((s|0)==4){j=Ya()|0;break}if((s|0)==39){o=0;j=ha(c[(c[r>>2]|0)+12>>2]|0,r|0)|0;w=o;o=0;if(w&1){s=6;break}w=c[h>>2]|0;c[h>>2]=w+1;a[w>>0]=j;j=l+1|0}o=0;Ba(c[(c[t>>2]|0)+32>>2]|0,t|0,j|0,e|0,c[h>>2]|0)|0;w=o;o=0;if(w&1)s=6;else{w=(c[h>>2]|0)+(e-j)|0;c[h>>2]=w;c[g>>2]=(d|0)==(e|0)?w:f+(d-b)|0;rq(v);i=u;return}}while(0);if((s|0)==6)j=Ya()|0;rq(v);Ra(j|0)}function Ec(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;u=i;v=i=i+63&-64;i=i+16|0;t=wq(c[j>>2]|0,52364)|0;r=wq(c[j>>2]|0,52372)|0;Gb[c[(c[r>>2]|0)+20>>2]&127](v,r);c[h>>2]=f;j=a[b>>0]|0;switch(j<<24>>24){case 43:case 45:{o=0;j=va(c[(c[t>>2]|0)+44>>2]|0,t|0,j|0)|0;s=o;o=0;if(s&1)s=6;else{l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=j;l=b+1|0;s=8}break}default:{l=b;s=8}}a:do if((s|0)==8){b:do if((e-l|0)>1?(a[l>>0]|0)==48:0){k=l+1|0;switch(a[k>>0]|0){case 88:case 120:break;default:{j=l;s=17;break b}}o=0;j=va(c[(c[t>>2]|0)+44>>2]|0,t|0,48)|0;q=o;o=0;if(q&1){s=6;break a}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=j;l=l+2|0;o=0;j=va(c[(c[t>>2]|0)+44>>2]|0,t|0,a[k>>0]|0)|0;q=o;o=0;if(q&1){s=6;break a}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=j;j=l;while(1){if(j>>>0>=e>>>0)break b;q=a[j>>0]|0;zq()|0;if(!(Du(q<<24>>24)|0))break b;j=j+1|0}}else{j=l;s=17}while(0);c:do if((s|0)==17)while(1){s=0;if(j>>>0>=e>>>0)break c;q=a[j>>0]|0;zq()|0;if(!(mu(q<<24>>24)|0))break c;j=j+1|0;s=17}while(0);q=a[v+11>>0]|0;d:do if((q<<24>>24<0?c[v+4>>2]|0:q&255)|0){e:do if((l|0)!=(j|0)){k=j;m=l;while(1){k=k+-1|0;if(m>>>0>=k>>>0)break e;q=a[m>>0]|0;a[m>>0]=a[k>>0]|0;a[k>>0]=q;m=m+1|0}}while(0);o=0;p=ha(c[(c[r>>2]|0)+16>>2]|0,r|0)|0;q=o;o=0;if(q&1){s=6;break a}m=0;n=0;q=l;while(1){if(q>>>0>=j>>>0)break;k=a[v+11>>0]|0;w=a[(k<<24>>24<0?c[v>>2]|0:v)+n>>0]|0;if(w<<24>>24>0&(m|0)==(w<<24>>24|0)){m=c[h>>2]|0;c[h>>2]=m+4;c[m>>2]=p;m=0;n=(n>>>0<((k<<24>>24<0?c[v+4>>2]|0:k&255)+-1|0)>>>0&1)+n|0}o=0;k=va(c[(c[t>>2]|0)+44>>2]|0,t|0,a[q>>0]|0)|0;w=o;o=0;if(w&1){s=5;break}w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=k;m=m+1|0;q=q+1|0}if((s|0)==5){j=Ya()|0;break a}k=f+(l-b<<2)|0;m=c[h>>2]|0;if((k|0)==(m|0))n=t;else{l=m;while(1){l=l+-4|0;if(k>>>0>=l>>>0){n=t;k=m;break d}w=c[k>>2]|0;c[k>>2]=c[l>>2];c[l>>2]=w;k=k+4|0}}}else{o=0;Ba(c[(c[t>>2]|0)+48>>2]|0,t|0,l|0,j|0,c[h>>2]|0)|0;w=o;o=0;if(w&1){s=6;break a}k=(c[h>>2]|0)+(j-l<<2)|0;c[h>>2]=k;n=t}while(0);l=j;while(1){if(l>>>0>=e>>>0){j=l;break}j=a[l>>0]|0;if(j<<24>>24==46){s=39;break}o=0;j=va(c[(c[n>>2]|0)+44>>2]|0,t|0,j|0)|0;w=o;o=0;if(w&1){s=4;break}k=c[h>>2]|0;c[h>>2]=k+4;c[k>>2]=j;k=k+4|0;l=l+1|0}if((s|0)==4){j=Ya()|0;break}if((s|0)==39){o=0;j=ha(c[(c[r>>2]|0)+12>>2]|0,r|0)|0;w=o;o=0;if(w&1){s=6;break}k=c[h>>2]|0;c[h>>2]=k+4;c[k>>2]=j;k=k+4|0;j=l+1|0}o=0;Ba(c[(c[t>>2]|0)+48>>2]|0,t|0,j|0,e|0,k|0)|0;w=o;o=0;if(w&1)s=6;else{w=(c[h>>2]|0)+(e-j<<2)|0;c[h>>2]=w;c[g>>2]=(d|0)==(e|0)?w:f+(d-b<<2)|0;rq(v);i=u;return}}while(0);if((s|0)==6)j=Ya()|0;rq(v);Ra(j|0)}function Fc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,p=0,q=0;n=i;m=i=i+63&-64;i=i+16|0;c[g>>2]=0;k=Wm(f)|0;o=0;l=va(32,k|0,52364)|0;q=o;o=0;if(q&1){q=Ya()|0;en(k);Ra(q|0)}en(k);do switch(j<<24>>24|0){case 65:case 97:{ki(b,h+24|0,d,c[e>>2]|0,g,l);p=28;break}case 104:case 66:case 98:{fi(b,h+16|0,d,c[e>>2]|0,g,l);p=28;break}case 99:{q=Ib[c[(c[b+8>>2]|0)+12>>2]&127](b+8|0)|0;p=a[q+8+3>>0]|0;j=p<<24>>24<0?c[q>>2]|0:q;c[d>>2]=Cc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,j,j+((p<<24>>24<0?c[q+4>>2]|0:p&255)<<2)|0)|0;p=28;break}case 101:case 100:{ij(h+12|0,d,c[e>>2]|0,g,l);p=28;break}case 68:{c[d>>2]=Cc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,38744,38776)|0;p=28;break}case 70:{c[d>>2]=Cc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,38776,38808)|0;p=28;break}case 72:{yj(h+8|0,d,c[e>>2]|0,g,l);p=28;break}case 73:{ej(h+8|0,d,c[e>>2]|0,g,l);p=28;break}case 106:{jj(h+28|0,d,c[e>>2]|0,g,l);p=28;break}case 109:{nj(h+16|0,d,c[e>>2]|0,g,l);p=28;break}case 77:{tj(h+4|0,d,c[e>>2]|0,g,l);p=28;break}case 116:case 110:{Sd(d,c[e>>2]|0,g,l);p=28;break}case 112:{fg(b,h+8|0,d,c[e>>2]|0,g,l);p=28;break}case 114:{c[d>>2]=Cc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,38808,38852)|0;p=28;break}case 82:{c[d>>2]=Cc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,38852,38872)|0;p=28;break}case 83:{sj(h,d,c[e>>2]|0,g,l);p=28;break}case 84:{c[d>>2]=Cc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,38872,38904)|0;p=28;break}case 119:{rj(h+24|0,d,c[e>>2]|0,g,l);p=28;break}case 120:{k=c[(c[b>>2]|0)+20>>2]|0;c[m+4>>2]=c[d>>2];c[m>>2]=c[e>>2];c[m+8>>2]=c[m+4>>2];c[m+12>>2]=c[m>>2];k=Hb[k&63](b,m+8|0,m+12|0,f,g,h)|0;break}case 88:{q=Ib[c[(c[b+8>>2]|0)+24>>2]&127](b+8|0)|0;p=a[q+8+3>>0]|0;j=p<<24>>24<0?c[q>>2]|0:q;c[d>>2]=Cc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,j,j+((p<<24>>24<0?c[q+4>>2]|0:p&255)<<2)|0)|0;p=28;break}case 121:{Mi(h+20|0,d,c[e>>2]|0,g,l);p=28;break}case 89:{_j(h+20|0,d,c[e>>2]|0,g,l);p=28;break}case 37:{Kd(d,c[e>>2]|0,g,l);p=28;break}default:{c[g>>2]=c[g>>2]|4;p=28}}while(0);if((p|0)==28)k=c[d>>2]|0;i=n;return k|0}function Gc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,p=0,q=0;n=i;m=i=i+63&-64;i=i+16|0;c[g>>2]=0;k=Wm(f)|0;o=0;l=va(32,k|0,52332)|0;q=o;o=0;if(q&1){q=Ya()|0;en(k);Ra(q|0)}en(k);do switch(j<<24>>24|0){case 65:case 97:{li(b,h+24|0,d,c[e>>2]|0,g,l);p=28;break}case 104:case 66:case 98:{gi(b,h+16|0,d,c[e>>2]|0,g,l);p=28;break}case 99:{q=Ib[c[(c[b+8>>2]|0)+12>>2]&127](b+8|0)|0;p=a[q+11>>0]|0;j=p<<24>>24<0?c[q>>2]|0:q;c[d>>2]=Bc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,j,j+(p<<24>>24<0?c[q+4>>2]|0:p&255)|0)|0;p=28;break}case 101:case 100:{kj(h+12|0,d,c[e>>2]|0,g,l);p=28;break}case 68:{c[d>>2]=Bc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,47684,47692)|0;p=28;break}case 70:{c[d>>2]=Bc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,47692,47700)|0;p=28;break}case 72:{zj(h+8|0,d,c[e>>2]|0,g,l);p=28;break}case 73:{fj(h+8|0,d,c[e>>2]|0,g,l);p=28;break}case 106:{lj(h+28|0,d,c[e>>2]|0,g,l);p=28;break}case 109:{oj(h+16|0,d,c[e>>2]|0,g,l);p=28;break}case 77:{wj(h+4|0,d,c[e>>2]|0,g,l);p=28;break}case 116:case 110:{Wd(d,c[e>>2]|0,g,l);p=28;break}case 112:{gg(b,h+8|0,d,c[e>>2]|0,g,l);p=28;break}case 114:{c[d>>2]=Bc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,47700,47711)|0;p=28;break}case 82:{c[d>>2]=Bc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,47711,47716)|0;p=28;break}case 83:{vj(h,d,c[e>>2]|0,g,l);p=28;break}case 84:{c[d>>2]=Bc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,47716,47724)|0;p=28;break}case 119:{uj(h+24|0,d,c[e>>2]|0,g,l);p=28;break}case 120:{k=c[(c[b>>2]|0)+20>>2]|0;c[m+4>>2]=c[d>>2];c[m>>2]=c[e>>2];c[m+8>>2]=c[m+4>>2];c[m+12>>2]=c[m>>2];k=Hb[k&63](b,m+8|0,m+12|0,f,g,h)|0;break}case 88:{q=Ib[c[(c[b+8>>2]|0)+24>>2]&127](b+8|0)|0;p=a[q+11>>0]|0;j=p<<24>>24<0?c[q>>2]|0:q;c[d>>2]=Bc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,j,j+(p<<24>>24<0?c[q+4>>2]|0:p&255)|0)|0;p=28;break}case 121:{Ni(h+20|0,d,c[e>>2]|0,g,l);p=28;break}case 89:{$j(h+20|0,d,c[e>>2]|0,g,l);p=28;break}case 37:{Pd(d,c[e>>2]|0,g,l);p=28;break}default:{c[g>>2]=c[g>>2]|4;p=28}}while(0);if((p|0)==28)k=c[d>>2]|0;i=n;return k|0}function Hc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+224|0;switch(c[f+4>>2]&74|0){case 64:{q=8;break}case 8:{q=16;break}case 0:{q=0;break}default:q=10}og(t+184|0,f,t+198|0,t+196|0);c[t+172>>2]=0;c[t+172+4>>2]=0;c[t+172+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[t+172+(f<<2)>>2]=0;f=f+1|0}p=t+172+11|0;if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);n=o;o=0;a:do if(n&1)s=30;else{k=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=k;c[t+4>>2]=t+8;c[t>>2]=0;n=a[t+196>>0]|0;j=b;l=e;b:while(1){if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;m=o;o=0;if(m&1){s=29;break}j=(f|0)==-1?0:j;b=(f|0)==-1?0:b}}else j=0;f=(j|0)==0;do if(l){if((c[l+12>>2]|0)!=(c[l+16>>2]|0))if(f){m=l;break}else{e=l;break b}o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;m=o;o=0;if(m&1){s=29;break b}if((e|0)!=-1)if(f)m=l;else{e=l;break b}else s=21}else s=21;while(0);if((s|0)==21){s=0;if(f){j=0;e=0;break}else m=0}e=a[p>>0]|0;e=e<<24>>24<0?c[t+172+4>>2]|0:e&255;if((c[t+168>>2]|0)==(k+e|0)){o=0;da(59,t+172|0,e<<1|0);l=o;o=0;if(l&1){s=29;break}if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);l=o;o=0;if(l&1){s=29;break}k=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=k+e}e=j+12|0;f=c[e>>2]|0;l=j+16|0;if((f|0)==(c[l>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=29;break}}else f=d[f>>0]|0;if(le(f&255,q,k,t+168|0,t,n,t+184|0,t+8|0,t+4|0,t+198|0)|0){e=m;break}f=c[e>>2]|0;if((f|0)==(c[l>>2]|0)){o=0;ha(c[(c[j>>2]|0)+40>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=29;break}else{l=m;continue}}else{c[e>>2]=f+1;l=m;continue}}if((s|0)==29){f=Ya()|0;break}u=a[t+184+11>>0]|0;f=c[t+4>>2]|0;if(((u<<24>>24<0?c[t+184+4>>2]|0:u&255)|0)!=0?(f-(t+8)|0)<160:0){u=c[t>>2]|0;c[t+4>>2]=f+4;c[f>>2]=u;f=f+4|0}u=Cg(k,c[t+168>>2]|0,g,q)|0;c[h>>2]=u;c[h+4>>2]=D;If(t+184|0,t+8|0,f,g);if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=30;break}j=(f|0)==-1?0:j;b=(f|0)==-1?0:b}}else j=0;j=(j|0)==0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)){o=0;f=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;u=o;o=0;if(u&1){s=30;break a}if((f|0)==-1){s=51;break}}if(!j)s=52}else s=51;while(0);if((s|0)==51?j:0)s=52;if((s|0)==52)c[g>>2]=c[g>>2]|2;rq(t+172|0);rq(t+184|0);i=r;return b|0}while(0);if((s|0)==30)f=Ya()|0;rq(t+172|0);rq(t+184|0);Ra(f|0);return 0}function Ic(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+224|0;switch(c[f+4>>2]&74|0){case 64:{q=8;break}case 8:{q=16;break}case 0:{q=0;break}default:q=10}og(t+184|0,f,t+198|0,t+196|0);c[t+172>>2]=0;c[t+172+4>>2]=0;c[t+172+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[t+172+(f<<2)>>2]=0;f=f+1|0}p=t+172+11|0;if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);n=o;o=0;a:do if(n&1)s=30;else{k=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=k;c[t+4>>2]=t+8;c[t>>2]=0;n=a[t+196>>0]|0;j=b;l=e;b:while(1){if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;m=o;o=0;if(m&1){s=29;break}j=(f|0)==-1?0:j;b=(f|0)==-1?0:b}}else j=0;f=(j|0)==0;do if(l){if((c[l+12>>2]|0)!=(c[l+16>>2]|0))if(f){m=l;break}else{e=l;break b}o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;m=o;o=0;if(m&1){s=29;break b}if((e|0)!=-1)if(f)m=l;else{e=l;break b}else s=21}else s=21;while(0);if((s|0)==21){s=0;if(f){j=0;e=0;break}else m=0}e=a[p>>0]|0;e=e<<24>>24<0?c[t+172+4>>2]|0:e&255;if((c[t+168>>2]|0)==(k+e|0)){o=0;da(59,t+172|0,e<<1|0);l=o;o=0;if(l&1){s=29;break}if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);l=o;o=0;if(l&1){s=29;break}k=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=k+e}e=j+12|0;f=c[e>>2]|0;l=j+16|0;if((f|0)==(c[l>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=29;break}}else f=d[f>>0]|0;if(le(f&255,q,k,t+168|0,t,n,t+184|0,t+8|0,t+4|0,t+198|0)|0){e=m;break}f=c[e>>2]|0;if((f|0)==(c[l>>2]|0)){o=0;ha(c[(c[j>>2]|0)+40>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=29;break}else{l=m;continue}}else{c[e>>2]=f+1;l=m;continue}}if((s|0)==29){f=Ya()|0;break}u=a[t+184+11>>0]|0;f=c[t+4>>2]|0;if(((u<<24>>24<0?c[t+184+4>>2]|0:u&255)|0)!=0?(f-(t+8)|0)<160:0){u=c[t>>2]|0;c[t+4>>2]=f+4;c[f>>2]=u;f=f+4|0}u=Eg(k,c[t+168>>2]|0,g,q)|0;c[h>>2]=u;c[h+4>>2]=D;If(t+184|0,t+8|0,f,g);if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=30;break}j=(f|0)==-1?0:j;b=(f|0)==-1?0:b}}else j=0;j=(j|0)==0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)){o=0;f=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;u=o;o=0;if(u&1){s=30;break a}if((f|0)==-1){s=51;break}}if(!j)s=52}else s=51;while(0);if((s|0)==51?j:0)s=52;if((s|0)==52)c[g>>2]=c[g>>2]|2;rq(t+172|0);rq(t+184|0);i=r;return b|0}while(0);if((s|0)==30)f=Ya()|0;rq(t+172|0);rq(t+184|0);Ra(f|0);return 0}function Jc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0;q=i;s=i=i+63&-64;i=i+304|0;switch(c[e+4>>2]&74|0){case 64:{p=8;break}case 8:{p=16;break}case 0:{p=0;break}default:p=10}ng(s+184|0,e,s+200|0,s+196|0);c[s+172>>2]=0;c[s+172+4>>2]=0;c[s+172+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[s+172+(e<<2)>>2]=0;e=e+1|0}n=s+172+11|0;if((a[n>>0]|0)<0)e=(c[s+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,s+172|0,e|0);m=o;o=0;do if(m&1)r=31;else{h=(a[n>>0]|0)<0?c[s+172>>2]|0:s+172|0;c[s+168>>2]=h;c[s+4>>2]=s+8;c[s>>2]=0;m=c[s+196>>2]|0;j=b;while(1){if(!j){l=0;j=1}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0)){o=0;e=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;l=o;o=0;if(l&1){r=30;break}}else e=c[e>>2]|0;k=(e|0)==-1;l=k?0:j;j=k;b=k?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;k=o;o=0;if(k&1){r=30;break}}else e=c[e>>2]|0;if((e|0)!=-1)if(j)k=d;else break;else r=22}else r=22;if((r|0)==22){r=0;if(j){d=0;break}else k=0}d=a[n>>0]|0;d=d<<24>>24<0?c[s+172+4>>2]|0:d&255;if((c[s+168>>2]|0)==(h+d|0)){o=0;da(59,s+172|0,d<<1|0);j=o;o=0;if(j&1){r=30;break}if((a[n>>0]|0)<0)e=(c[s+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,s+172|0,e|0);j=o;o=0;if(j&1){r=30;break}h=(a[n>>0]|0)<0?c[s+172>>2]|0:s+172|0;c[s+168>>2]=h+d}d=l+12|0;e=c[d>>2]|0;j=l+16|0;if((e|0)==(c[j>>2]|0)){o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=30;break}}else e=c[e>>2]|0;if(me(e,p,h,s+168|0,s,m,s+184|0,s+8|0,s+4|0,s+200|0)|0){d=k;break}e=c[d>>2]|0;if((e|0)==(c[j>>2]|0)){o=0;ha(c[(c[l>>2]|0)+40>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=30;break}else{j=l;d=k;continue}}else{c[d>>2]=e+4;j=l;d=k;continue}}if((r|0)==30){e=Ya()|0;break}t=a[s+184+11>>0]|0;e=c[s+4>>2]|0;if(((t<<24>>24<0?c[s+184+4>>2]|0:t&255)|0)!=0?(e-(s+8)|0)<160:0){t=c[s>>2]|0;c[s+4>>2]=e+4;c[e>>2]=t;e=e+4|0}t=Cg(h,c[s+168>>2]|0,f,p)|0;c[g>>2]=t;c[g+4>>2]=D;If(s+184|0,s+8|0,e,f);if(!l)h=1;else{e=c[l+12>>2]|0;if((e|0)==(c[l+16>>2]|0)){o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=31;break}}else e=c[e>>2]|0;t=(e|0)==-1;h=t;b=t?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;t=o;o=0;if(t&1){r=31;break}}else e=c[e>>2]|0;if((e|0)!=-1){if(!h)r=55}else r=53}else r=53;if((r|0)==53?h:0)r=55;if((r|0)==55)c[f>>2]=c[f>>2]|2;rq(s+172|0);rq(s+184|0);i=q;return b|0}while(0);if((r|0)==31)e=Ya()|0;rq(s+172|0);rq(s+184|0);Ra(e|0);return 0}function Kc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0;q=i;s=i=i+63&-64;i=i+304|0;switch(c[e+4>>2]&74|0){case 64:{p=8;break}case 8:{p=16;break}case 0:{p=0;break}default:p=10}ng(s+184|0,e,s+200|0,s+196|0);c[s+172>>2]=0;c[s+172+4>>2]=0;c[s+172+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[s+172+(e<<2)>>2]=0;e=e+1|0}n=s+172+11|0;if((a[n>>0]|0)<0)e=(c[s+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,s+172|0,e|0);m=o;o=0;do if(m&1)r=31;else{h=(a[n>>0]|0)<0?c[s+172>>2]|0:s+172|0;c[s+168>>2]=h;c[s+4>>2]=s+8;c[s>>2]=0;m=c[s+196>>2]|0;j=b;while(1){if(!j){l=0;j=1}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0)){o=0;e=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;l=o;o=0;if(l&1){r=30;break}}else e=c[e>>2]|0;k=(e|0)==-1;l=k?0:j;j=k;b=k?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;k=o;o=0;if(k&1){r=30;break}}else e=c[e>>2]|0;if((e|0)!=-1)if(j)k=d;else break;else r=22}else r=22;if((r|0)==22){r=0;if(j){d=0;break}else k=0}d=a[n>>0]|0;d=d<<24>>24<0?c[s+172+4>>2]|0:d&255;if((c[s+168>>2]|0)==(h+d|0)){o=0;da(59,s+172|0,d<<1|0);j=o;o=0;if(j&1){r=30;break}if((a[n>>0]|0)<0)e=(c[s+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,s+172|0,e|0);j=o;o=0;if(j&1){r=30;break}h=(a[n>>0]|0)<0?c[s+172>>2]|0:s+172|0;c[s+168>>2]=h+d}d=l+12|0;e=c[d>>2]|0;j=l+16|0;if((e|0)==(c[j>>2]|0)){o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=30;break}}else e=c[e>>2]|0;if(me(e,p,h,s+168|0,s,m,s+184|0,s+8|0,s+4|0,s+200|0)|0){d=k;break}e=c[d>>2]|0;if((e|0)==(c[j>>2]|0)){o=0;ha(c[(c[l>>2]|0)+40>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=30;break}else{j=l;d=k;continue}}else{c[d>>2]=e+4;j=l;d=k;continue}}if((r|0)==30){e=Ya()|0;break}t=a[s+184+11>>0]|0;e=c[s+4>>2]|0;if(((t<<24>>24<0?c[s+184+4>>2]|0:t&255)|0)!=0?(e-(s+8)|0)<160:0){t=c[s>>2]|0;c[s+4>>2]=e+4;c[e>>2]=t;e=e+4|0}t=Eg(h,c[s+168>>2]|0,f,p)|0;c[g>>2]=t;c[g+4>>2]=D;If(s+184|0,s+8|0,e,f);if(!l)h=1;else{e=c[l+12>>2]|0;if((e|0)==(c[l+16>>2]|0)){o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=31;break}}else e=c[e>>2]|0;t=(e|0)==-1;h=t;b=t?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;t=o;o=0;if(t&1){r=31;break}}else e=c[e>>2]|0;if((e|0)!=-1){if(!h)r=55}else r=53}else r=53;if((r|0)==53?h:0)r=55;if((r|0)==55)c[f>>2]=c[f>>2]|2;rq(s+172|0);rq(s+184|0);i=q;return b|0}while(0);if((r|0)==31)e=Ya()|0;rq(s+172|0);rq(s+184|0);Ra(e|0);return 0}function Lc(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;s=i;u=i=i+63&-64;i=i+224|0;switch(c[g+4>>2]&74|0){case 64:{r=8;break}case 8:{r=16;break}case 0:{r=0;break}default:r=10}og(u+184|0,g,u+198|0,u+196|0);c[u+172>>2]=0;c[u+172+4>>2]=0;c[u+172+8>>2]=0;g=0;while(1){if((g|0)==3)break;c[u+172+(g<<2)>>2]=0;g=g+1|0}q=u+172+11|0;if((a[q>>0]|0)<0)g=(c[u+172+8>>2]&2147483647)+-1|0;else g=10;o=0;da(59,u+172|0,g|0);p=o;o=0;a:do if(p&1)t=30;else{l=(a[q>>0]|0)<0?c[u+172>>2]|0:u+172|0;c[u+168>>2]=l;c[u+4>>2]=u+8;c[u>>2]=0;p=a[u+196>>0]|0;k=e;m=f;b:while(1){if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)){o=0;g=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;n=o;o=0;if(n&1){t=29;break}k=(g|0)==-1?0:k;e=(g|0)==-1?0:e}}else k=0;g=(k|0)==0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(g){n=m;break}else{f=m;break b}o=0;f=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;n=o;o=0;if(n&1){t=29;break b}if((f|0)!=-1)if(g)n=m;else{f=m;break b}else t=21}else t=21;while(0);if((t|0)==21){t=0;if(g){k=0;f=0;break}else n=0}f=a[q>>0]|0;f=f<<24>>24<0?c[u+172+4>>2]|0:f&255;if((c[u+168>>2]|0)==(l+f|0)){o=0;da(59,u+172|0,f<<1|0);m=o;o=0;if(m&1){t=29;break}if((a[q>>0]|0)<0)g=(c[u+172+8>>2]&2147483647)+-1|0;else g=10;o=0;da(59,u+172|0,g|0);m=o;o=0;if(m&1){t=29;break}l=(a[q>>0]|0)<0?c[u+172>>2]|0:u+172|0;c[u+168>>2]=l+f}f=k+12|0;g=c[f>>2]|0;m=k+16|0;if((g|0)==(c[m>>2]|0)){o=0;g=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=29;break}}else g=d[g>>0]|0;if(le(g&255,r,l,u+168|0,u,p,u+184|0,u+8|0,u+4|0,u+198|0)|0){f=n;break}g=c[f>>2]|0;if((g|0)==(c[m>>2]|0)){o=0;ha(c[(c[k>>2]|0)+40>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=29;break}else{m=n;continue}}else{c[f>>2]=g+1;m=n;continue}}if((t|0)==29){g=Ya()|0;break}v=a[u+184+11>>0]|0;g=c[u+4>>2]|0;if(((v<<24>>24<0?c[u+184+4>>2]|0:v&255)|0)!=0?(g-(u+8)|0)<160:0){v=c[u>>2]|0;c[u+4>>2]=g+4;c[g>>2]=v;g=g+4|0}b[j>>1]=tg(l,c[u+168>>2]|0,h,r)|0;If(u+184|0,u+8|0,g,h);if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)){o=0;g=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=30;break}k=(g|0)==-1?0:k;e=(g|0)==-1?0:e}}else k=0;k=(k|0)==0;do if(f){if((c[f+12>>2]|0)==(c[f+16>>2]|0)){o=0;g=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;v=o;o=0;if(v&1){t=30;break a}if((g|0)==-1){t=51;break}}if(!k)t=52}else t=51;while(0);if((t|0)==51?k:0)t=52;if((t|0)==52)c[h>>2]=c[h>>2]|2;rq(u+172|0);rq(u+184|0);i=s;return e|0}while(0);if((t|0)==30)g=Ya()|0;rq(u+172|0);rq(u+184|0);Ra(g|0);return 0}function Mc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+224|0;switch(c[f+4>>2]&74|0){case 64:{q=8;break}case 8:{q=16;break}case 0:{q=0;break}default:q=10}og(t+184|0,f,t+198|0,t+196|0);c[t+172>>2]=0;c[t+172+4>>2]=0;c[t+172+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[t+172+(f<<2)>>2]=0;f=f+1|0}p=t+172+11|0;if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);n=o;o=0;a:do if(n&1)s=30;else{k=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=k;c[t+4>>2]=t+8;c[t>>2]=0;n=a[t+196>>0]|0;j=b;l=e;b:while(1){if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;m=o;o=0;if(m&1){s=29;break}j=(f|0)==-1?0:j;b=(f|0)==-1?0:b}}else j=0;f=(j|0)==0;do if(l){if((c[l+12>>2]|0)!=(c[l+16>>2]|0))if(f){m=l;break}else{e=l;break b}o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;m=o;o=0;if(m&1){s=29;break b}if((e|0)!=-1)if(f)m=l;else{e=l;break b}else s=21}else s=21;while(0);if((s|0)==21){s=0;if(f){j=0;e=0;break}else m=0}e=a[p>>0]|0;e=e<<24>>24<0?c[t+172+4>>2]|0:e&255;if((c[t+168>>2]|0)==(k+e|0)){o=0;da(59,t+172|0,e<<1|0);l=o;o=0;if(l&1){s=29;break}if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);l=o;o=0;if(l&1){s=29;break}k=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=k+e}e=j+12|0;f=c[e>>2]|0;l=j+16|0;if((f|0)==(c[l>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=29;break}}else f=d[f>>0]|0;if(le(f&255,q,k,t+168|0,t,n,t+184|0,t+8|0,t+4|0,t+198|0)|0){e=m;break}f=c[e>>2]|0;if((f|0)==(c[l>>2]|0)){o=0;ha(c[(c[j>>2]|0)+40>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=29;break}else{l=m;continue}}else{c[e>>2]=f+1;l=m;continue}}if((s|0)==29){f=Ya()|0;break}u=a[t+184+11>>0]|0;f=c[t+4>>2]|0;if(((u<<24>>24<0?c[t+184+4>>2]|0:u&255)|0)!=0?(f-(t+8)|0)<160:0){u=c[t>>2]|0;c[t+4>>2]=f+4;c[f>>2]=u;f=f+4|0}c[h>>2]=wg(k,c[t+168>>2]|0,g,q)|0;If(t+184|0,t+8|0,f,g);if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=30;break}j=(f|0)==-1?0:j;b=(f|0)==-1?0:b}}else j=0;j=(j|0)==0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)){o=0;f=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;u=o;o=0;if(u&1){s=30;break a}if((f|0)==-1){s=51;break}}if(!j)s=52}else s=51;while(0);if((s|0)==51?j:0)s=52;if((s|0)==52)c[g>>2]=c[g>>2]|2;rq(t+172|0);rq(t+184|0);i=r;return b|0}while(0);if((s|0)==30)f=Ya()|0;rq(t+172|0);rq(t+184|0);Ra(f|0);return 0}function Nc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+224|0;switch(c[f+4>>2]&74|0){case 64:{q=8;break}case 8:{q=16;break}case 0:{q=0;break}default:q=10}og(t+184|0,f,t+198|0,t+196|0);c[t+172>>2]=0;c[t+172+4>>2]=0;c[t+172+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[t+172+(f<<2)>>2]=0;f=f+1|0}p=t+172+11|0;if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);n=o;o=0;a:do if(n&1)s=30;else{k=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=k;c[t+4>>2]=t+8;c[t>>2]=0;n=a[t+196>>0]|0;j=b;l=e;b:while(1){if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;m=o;o=0;if(m&1){s=29;break}j=(f|0)==-1?0:j;b=(f|0)==-1?0:b}}else j=0;f=(j|0)==0;do if(l){if((c[l+12>>2]|0)!=(c[l+16>>2]|0))if(f){m=l;break}else{e=l;break b}o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;m=o;o=0;if(m&1){s=29;break b}if((e|0)!=-1)if(f)m=l;else{e=l;break b}else s=21}else s=21;while(0);if((s|0)==21){s=0;if(f){j=0;e=0;break}else m=0}e=a[p>>0]|0;e=e<<24>>24<0?c[t+172+4>>2]|0:e&255;if((c[t+168>>2]|0)==(k+e|0)){o=0;da(59,t+172|0,e<<1|0);l=o;o=0;if(l&1){s=29;break}if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);l=o;o=0;if(l&1){s=29;break}k=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=k+e}e=j+12|0;f=c[e>>2]|0;l=j+16|0;if((f|0)==(c[l>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=29;break}}else f=d[f>>0]|0;if(le(f&255,q,k,t+168|0,t,n,t+184|0,t+8|0,t+4|0,t+198|0)|0){e=m;break}f=c[e>>2]|0;if((f|0)==(c[l>>2]|0)){o=0;ha(c[(c[j>>2]|0)+40>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=29;break}else{l=m;continue}}else{c[e>>2]=f+1;l=m;continue}}if((s|0)==29){f=Ya()|0;break}u=a[t+184+11>>0]|0;f=c[t+4>>2]|0;if(((u<<24>>24<0?c[t+184+4>>2]|0:u&255)|0)!=0?(f-(t+8)|0)<160:0){u=c[t>>2]|0;c[t+4>>2]=f+4;c[f>>2]=u;f=f+4|0}c[h>>2]=Vf(k,c[t+168>>2]|0,g,q)|0;If(t+184|0,t+8|0,f,g);if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=30;break}j=(f|0)==-1?0:j;b=(f|0)==-1?0:b}}else j=0;j=(j|0)==0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)){o=0;f=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;u=o;o=0;if(u&1){s=30;break a}if((f|0)==-1){s=51;break}}if(!j)s=52}else s=51;while(0);if((s|0)==51?j:0)s=52;if((s|0)==52)c[g>>2]=c[g>>2]|2;rq(t+172|0);rq(t+184|0);i=r;return b|0}while(0);if((s|0)==30)f=Ya()|0;rq(t+172|0);rq(t+184|0);Ra(f|0);return 0}function Oc(b,e,f,h,j){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;s=i;u=i=i+63&-64;i=i+240|0;Qf(u+184|0,f,u+200|0,u+199|0,u+198|0);c[u+172>>2]=0;c[u+172+4>>2]=0;c[u+172+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[u+172+(f<<2)>>2]=0;f=f+1|0}r=u+172+11|0;if((a[r>>0]|0)<0)f=(c[u+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,u+172|0,f|0);q=o;o=0;a:do if(q&1)t=26;else{l=(a[r>>0]|0)<0?c[u+172>>2]|0:u+172|0;c[u+168>>2]=l;c[u+4>>2]=u+8;c[u>>2]=0;a[u+197>>0]=1;a[u+196>>0]=69;p=a[u+199>>0]|0;q=a[u+198>>0]|0;k=b;m=e;b:while(1){if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)){o=0;f=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;n=o;o=0;if(n&1){t=25;break}k=(f|0)==-1?0:k;b=(f|0)==-1?0:b}}else k=0;f=(k|0)==0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(f){n=m;break}else{e=m;break b}o=0;e=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;n=o;o=0;if(n&1){t=25;break b}if((e|0)!=-1)if(f)n=m;else{e=m;break b}else t=17}else t=17;while(0);if((t|0)==17){t=0;if(f){k=0;e=0;break}else n=0}e=a[r>>0]|0;e=e<<24>>24<0?c[u+172+4>>2]|0:e&255;if((c[u+168>>2]|0)==(l+e|0)){o=0;da(59,u+172|0,e<<1|0);m=o;o=0;if(m&1){t=25;break}if((a[r>>0]|0)<0)f=(c[u+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,u+172|0,f|0);m=o;o=0;if(m&1){t=25;break}l=(a[r>>0]|0)<0?c[u+172>>2]|0:u+172|0;c[u+168>>2]=l+e}e=k+12|0;f=c[e>>2]|0;m=k+16|0;if((f|0)==(c[m>>2]|0)){o=0;f=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=25;break}}else f=d[f>>0]|0;if(Ld(f&255,u+197|0,u+196|0,l,u+168|0,p,q,u+184|0,u+8|0,u+4|0,u,u+200|0)|0){e=n;break}f=c[e>>2]|0;if((f|0)==(c[m>>2]|0)){o=0;ha(c[(c[k>>2]|0)+40>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=25;break}else{m=n;continue}}else{c[e>>2]=f+1;m=n;continue}}if((t|0)==25){f=Ya()|0;break}v=a[u+184+11>>0]|0;f=c[u+4>>2]|0;if(!((a[u+197>>0]|0)==0?1:((v<<24>>24<0?c[u+184+4>>2]|0:v&255)|0)==0)?(f-(u+8)|0)<160:0){v=c[u>>2]|0;c[u+4>>2]=f+4;c[f>>2]=v;f=f+4|0}g[j>>2]=+Oh(l,c[u+168>>2]|0,h);If(u+184|0,u+8|0,f,h);if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)){o=0;f=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=26;break}k=(f|0)==-1?0:k;b=(f|0)==-1?0:b}}else k=0;k=(k|0)==0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)){o=0;f=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;v=o;o=0;if(v&1){t=26;break a}if((f|0)==-1){t=47;break}}if(!k)t=48}else t=47;while(0);if((t|0)==47?k:0)t=48;if((t|0)==48)c[h>>2]=c[h>>2]|2;rq(u+172|0);rq(u+184|0);i=s;return b|0}while(0);if((t|0)==26)f=Ya()|0;rq(u+172|0);rq(u+184|0);Ra(f|0);return 0}function Pc(b,e,f,g,j){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;s=i;u=i=i+63&-64;i=i+240|0;Qf(u+184|0,f,u+200|0,u+199|0,u+198|0);c[u+172>>2]=0;c[u+172+4>>2]=0;c[u+172+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[u+172+(f<<2)>>2]=0;f=f+1|0}r=u+172+11|0;if((a[r>>0]|0)<0)f=(c[u+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,u+172|0,f|0);q=o;o=0;a:do if(q&1)t=26;else{l=(a[r>>0]|0)<0?c[u+172>>2]|0:u+172|0;c[u+168>>2]=l;c[u+4>>2]=u+8;c[u>>2]=0;a[u+197>>0]=1;a[u+196>>0]=69;p=a[u+199>>0]|0;q=a[u+198>>0]|0;k=b;m=e;b:while(1){if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)){o=0;f=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;n=o;o=0;if(n&1){t=25;break}k=(f|0)==-1?0:k;b=(f|0)==-1?0:b}}else k=0;f=(k|0)==0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(f){n=m;break}else{e=m;break b}o=0;e=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;n=o;o=0;if(n&1){t=25;break b}if((e|0)!=-1)if(f)n=m;else{e=m;break b}else t=17}else t=17;while(0);if((t|0)==17){t=0;if(f){k=0;e=0;break}else n=0}e=a[r>>0]|0;e=e<<24>>24<0?c[u+172+4>>2]|0:e&255;if((c[u+168>>2]|0)==(l+e|0)){o=0;da(59,u+172|0,e<<1|0);m=o;o=0;if(m&1){t=25;break}if((a[r>>0]|0)<0)f=(c[u+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,u+172|0,f|0);m=o;o=0;if(m&1){t=25;break}l=(a[r>>0]|0)<0?c[u+172>>2]|0:u+172|0;c[u+168>>2]=l+e}e=k+12|0;f=c[e>>2]|0;m=k+16|0;if((f|0)==(c[m>>2]|0)){o=0;f=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=25;break}}else f=d[f>>0]|0;if(Ld(f&255,u+197|0,u+196|0,l,u+168|0,p,q,u+184|0,u+8|0,u+4|0,u,u+200|0)|0){e=n;break}f=c[e>>2]|0;if((f|0)==(c[m>>2]|0)){o=0;ha(c[(c[k>>2]|0)+40>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=25;break}else{m=n;continue}}else{c[e>>2]=f+1;m=n;continue}}if((t|0)==25){f=Ya()|0;break}v=a[u+184+11>>0]|0;f=c[u+4>>2]|0;if(!((a[u+197>>0]|0)==0?1:((v<<24>>24<0?c[u+184+4>>2]|0:v&255)|0)==0)?(f-(u+8)|0)<160:0){v=c[u>>2]|0;c[u+4>>2]=f+4;c[f>>2]=v;f=f+4|0}h[j>>3]=+Oh(l,c[u+168>>2]|0,g);If(u+184|0,u+8|0,f,g);if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)){o=0;f=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=26;break}k=(f|0)==-1?0:k;b=(f|0)==-1?0:b}}else k=0;k=(k|0)==0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)){o=0;f=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;v=o;o=0;if(v&1){t=26;break a}if((f|0)==-1){t=47;break}}if(!k)t=48}else t=47;while(0);if((t|0)==47?k:0)t=48;if((t|0)==48)c[g>>2]=c[g>>2]|2;rq(u+172|0);rq(u+184|0);i=s;return b|0}while(0);if((t|0)==26)f=Ya()|0;rq(u+172|0);rq(u+184|0);Ra(f|0);return 0}function Qc(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+304|0;switch(c[f+4>>2]&74|0){case 64:{q=8;break}case 8:{q=16;break}case 0:{q=0;break}default:q=10}ng(t+184|0,f,t+200|0,t+196|0);c[t+172>>2]=0;c[t+172+4>>2]=0;c[t+172+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[t+172+(f<<2)>>2]=0;f=f+1|0}p=t+172+11|0;if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);n=o;o=0;do if(n&1)s=31;else{j=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=j;c[t+4>>2]=t+8;c[t>>2]=0;n=c[t+196>>2]|0;k=d;while(1){if(!k){m=0;k=1}else{f=c[k+12>>2]|0;if((f|0)==(c[k+16>>2]|0)){o=0;f=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;m=o;o=0;if(m&1){s=30;break}}else f=c[f>>2]|0;l=(f|0)==-1;m=l?0:k;k=l;d=l?0:d}if(e){f=c[e+12>>2]|0;if((f|0)==(c[e+16>>2]|0)){o=0;f=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;l=o;o=0;if(l&1){s=30;break}}else f=c[f>>2]|0;if((f|0)!=-1)if(k)l=e;else break;else s=22}else s=22;if((s|0)==22){s=0;if(k){e=0;break}else l=0}e=a[p>>0]|0;e=e<<24>>24<0?c[t+172+4>>2]|0:e&255;if((c[t+168>>2]|0)==(j+e|0)){o=0;da(59,t+172|0,e<<1|0);k=o;o=0;if(k&1){s=30;break}if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);k=o;o=0;if(k&1){s=30;break}j=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=j+e}e=m+12|0;f=c[e>>2]|0;k=m+16|0;if((f|0)==(c[k>>2]|0)){o=0;f=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=30;break}}else f=c[f>>2]|0;if(me(f,q,j,t+168|0,t,n,t+184|0,t+8|0,t+4|0,t+200|0)|0){e=l;break}f=c[e>>2]|0;if((f|0)==(c[k>>2]|0)){o=0;ha(c[(c[m>>2]|0)+40>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=30;break}else{k=m;e=l;continue}}else{c[e>>2]=f+4;k=m;e=l;continue}}if((s|0)==30){f=Ya()|0;break}u=a[t+184+11>>0]|0;f=c[t+4>>2]|0;if(((u<<24>>24<0?c[t+184+4>>2]|0:u&255)|0)!=0?(f-(t+8)|0)<160:0){u=c[t>>2]|0;c[t+4>>2]=f+4;c[f>>2]=u;f=f+4|0}b[h>>1]=tg(j,c[t+168>>2]|0,g,q)|0;If(t+184|0,t+8|0,f,g);if(!m)j=1;else{f=c[m+12>>2]|0;if((f|0)==(c[m+16>>2]|0)){o=0;f=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=31;break}}else f=c[f>>2]|0;u=(f|0)==-1;j=u;d=u?0:d}if(e){f=c[e+12>>2]|0;if((f|0)==(c[e+16>>2]|0)){o=0;f=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;u=o;o=0;if(u&1){s=31;break}}else f=c[f>>2]|0;if((f|0)!=-1){if(!j)s=55}else s=53}else s=53;if((s|0)==53?j:0)s=55;if((s|0)==55)c[g>>2]=c[g>>2]|2;rq(t+172|0);rq(t+184|0);i=r;return d|0}while(0);if((s|0)==31)f=Ya()|0;rq(t+172|0);rq(t+184|0);Ra(f|0);return 0}function Rc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0;q=i;s=i=i+63&-64;i=i+304|0;switch(c[e+4>>2]&74|0){case 64:{p=8;break}case 8:{p=16;break}case 0:{p=0;break}default:p=10}ng(s+184|0,e,s+200|0,s+196|0);c[s+172>>2]=0;c[s+172+4>>2]=0;c[s+172+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[s+172+(e<<2)>>2]=0;e=e+1|0}n=s+172+11|0;if((a[n>>0]|0)<0)e=(c[s+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,s+172|0,e|0);m=o;o=0;do if(m&1)r=31;else{h=(a[n>>0]|0)<0?c[s+172>>2]|0:s+172|0;c[s+168>>2]=h;c[s+4>>2]=s+8;c[s>>2]=0;m=c[s+196>>2]|0;j=b;while(1){if(!j){l=0;j=1}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0)){o=0;e=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;l=o;o=0;if(l&1){r=30;break}}else e=c[e>>2]|0;k=(e|0)==-1;l=k?0:j;j=k;b=k?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;k=o;o=0;if(k&1){r=30;break}}else e=c[e>>2]|0;if((e|0)!=-1)if(j)k=d;else break;else r=22}else r=22;if((r|0)==22){r=0;if(j){d=0;break}else k=0}d=a[n>>0]|0;d=d<<24>>24<0?c[s+172+4>>2]|0:d&255;if((c[s+168>>2]|0)==(h+d|0)){o=0;da(59,s+172|0,d<<1|0);j=o;o=0;if(j&1){r=30;break}if((a[n>>0]|0)<0)e=(c[s+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,s+172|0,e|0);j=o;o=0;if(j&1){r=30;break}h=(a[n>>0]|0)<0?c[s+172>>2]|0:s+172|0;c[s+168>>2]=h+d}d=l+12|0;e=c[d>>2]|0;j=l+16|0;if((e|0)==(c[j>>2]|0)){o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=30;break}}else e=c[e>>2]|0;if(me(e,p,h,s+168|0,s,m,s+184|0,s+8|0,s+4|0,s+200|0)|0){d=k;break}e=c[d>>2]|0;if((e|0)==(c[j>>2]|0)){o=0;ha(c[(c[l>>2]|0)+40>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=30;break}else{j=l;d=k;continue}}else{c[d>>2]=e+4;j=l;d=k;continue}}if((r|0)==30){e=Ya()|0;break}t=a[s+184+11>>0]|0;e=c[s+4>>2]|0;if(((t<<24>>24<0?c[s+184+4>>2]|0:t&255)|0)!=0?(e-(s+8)|0)<160:0){t=c[s>>2]|0;c[s+4>>2]=e+4;c[e>>2]=t;e=e+4|0}c[g>>2]=wg(h,c[s+168>>2]|0,f,p)|0;If(s+184|0,s+8|0,e,f);if(!l)h=1;else{e=c[l+12>>2]|0;if((e|0)==(c[l+16>>2]|0)){o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=31;break}}else e=c[e>>2]|0;t=(e|0)==-1;h=t;b=t?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;t=o;o=0;if(t&1){r=31;break}}else e=c[e>>2]|0;if((e|0)!=-1){if(!h)r=55}else r=53}else r=53;if((r|0)==53?h:0)r=55;if((r|0)==55)c[f>>2]=c[f>>2]|2;rq(s+172|0);rq(s+184|0);i=q;return b|0}while(0);if((r|0)==31)e=Ya()|0;rq(s+172|0);rq(s+184|0);Ra(e|0);return 0}function Sc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0;q=i;s=i=i+63&-64;i=i+304|0;switch(c[e+4>>2]&74|0){case 64:{p=8;break}case 8:{p=16;break}case 0:{p=0;break}default:p=10}ng(s+184|0,e,s+200|0,s+196|0);c[s+172>>2]=0;c[s+172+4>>2]=0;c[s+172+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[s+172+(e<<2)>>2]=0;e=e+1|0}n=s+172+11|0;if((a[n>>0]|0)<0)e=(c[s+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,s+172|0,e|0);m=o;o=0;do if(m&1)r=31;else{h=(a[n>>0]|0)<0?c[s+172>>2]|0:s+172|0;c[s+168>>2]=h;c[s+4>>2]=s+8;c[s>>2]=0;m=c[s+196>>2]|0;j=b;while(1){if(!j){l=0;j=1}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0)){o=0;e=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;l=o;o=0;if(l&1){r=30;break}}else e=c[e>>2]|0;k=(e|0)==-1;l=k?0:j;j=k;b=k?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;k=o;o=0;if(k&1){r=30;break}}else e=c[e>>2]|0;if((e|0)!=-1)if(j)k=d;else break;else r=22}else r=22;if((r|0)==22){r=0;if(j){d=0;break}else k=0}d=a[n>>0]|0;d=d<<24>>24<0?c[s+172+4>>2]|0:d&255;if((c[s+168>>2]|0)==(h+d|0)){o=0;da(59,s+172|0,d<<1|0);j=o;o=0;if(j&1){r=30;break}if((a[n>>0]|0)<0)e=(c[s+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,s+172|0,e|0);j=o;o=0;if(j&1){r=30;break}h=(a[n>>0]|0)<0?c[s+172>>2]|0:s+172|0;c[s+168>>2]=h+d}d=l+12|0;e=c[d>>2]|0;j=l+16|0;if((e|0)==(c[j>>2]|0)){o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=30;break}}else e=c[e>>2]|0;if(me(e,p,h,s+168|0,s,m,s+184|0,s+8|0,s+4|0,s+200|0)|0){d=k;break}e=c[d>>2]|0;if((e|0)==(c[j>>2]|0)){o=0;ha(c[(c[l>>2]|0)+40>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=30;break}else{j=l;d=k;continue}}else{c[d>>2]=e+4;j=l;d=k;continue}}if((r|0)==30){e=Ya()|0;break}t=a[s+184+11>>0]|0;e=c[s+4>>2]|0;if(((t<<24>>24<0?c[s+184+4>>2]|0:t&255)|0)!=0?(e-(s+8)|0)<160:0){t=c[s>>2]|0;c[s+4>>2]=e+4;c[e>>2]=t;e=e+4|0}c[g>>2]=Vf(h,c[s+168>>2]|0,f,p)|0;If(s+184|0,s+8|0,e,f);if(!l)h=1;else{e=c[l+12>>2]|0;if((e|0)==(c[l+16>>2]|0)){o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=31;break}}else e=c[e>>2]|0;t=(e|0)==-1;h=t;b=t?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;t=o;o=0;if(t&1){r=31;break}}else e=c[e>>2]|0;if((e|0)!=-1){if(!h)r=55}else r=53}else r=53;if((r|0)==53?h:0)r=55;if((r|0)==55)c[f>>2]=c[f>>2]|2;rq(s+172|0);rq(s+184|0);i=q;return b|0}while(0);if((r|0)==31)e=Ya()|0;rq(s+172|0);rq(s+184|0);Ra(e|0);return 0}function Tc(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+352|0;Pf(t+184|0,e,t+208|0,t+200|0,t+196|0);c[t+172>>2]=0;c[t+172+4>>2]=0;c[t+172+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[t+172+(e<<2)>>2]=0;e=e+1|0}q=t+172+11|0;if((a[q>>0]|0)<0)e=(c[t+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,t+172|0,e|0);p=o;o=0;do if(p&1)s=27;else{j=(a[q>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=j;c[t+4>>2]=t+8;c[t>>2]=0;a[t+337>>0]=1;a[t+336>>0]=69;n=c[t+200>>2]|0;p=c[t+196>>2]|0;k=b;while(1){if(!k){m=0;k=1}else{e=c[k+12>>2]|0;if((e|0)==(c[k+16>>2]|0)){o=0;e=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;m=o;o=0;if(m&1){s=26;break}}else e=c[e>>2]|0;l=(e|0)==-1;m=l?0:k;k=l;b=l?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;l=o;o=0;if(l&1){s=26;break}}else e=c[e>>2]|0;if((e|0)!=-1)if(k)l=d;else break;else s=18}else s=18;if((s|0)==18){s=0;if(k){d=0;break}else l=0}d=a[q>>0]|0;d=d<<24>>24<0?c[t+172+4>>2]|0:d&255;if((c[t+168>>2]|0)==(j+d|0)){o=0;da(59,t+172|0,d<<1|0);k=o;o=0;if(k&1){s=26;break}if((a[q>>0]|0)<0)e=(c[t+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,t+172|0,e|0);k=o;o=0;if(k&1){s=26;break}j=(a[q>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=j+d}d=m+12|0;e=c[d>>2]|0;k=m+16|0;if((e|0)==(c[k>>2]|0)){o=0;e=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=26;break}}else e=c[e>>2]|0;if(Qd(e,t+337|0,t+336|0,j,t+168|0,n,p,t+184|0,t+8|0,t+4|0,t,t+208|0)|0){d=l;break}e=c[d>>2]|0;if((e|0)==(c[k>>2]|0)){o=0;ha(c[(c[m>>2]|0)+40>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=26;break}else{k=m;d=l;continue}}else{c[d>>2]=e+4;k=m;d=l;continue}}if((s|0)==26){e=Ya()|0;break}u=a[t+184+11>>0]|0;e=c[t+4>>2]|0;if(!((a[t+337>>0]|0)==0?1:((u<<24>>24<0?c[t+184+4>>2]|0:u&255)|0)==0)?(e-(t+8)|0)<160:0){u=c[t>>2]|0;c[t+4>>2]=e+4;c[e>>2]=u;e=e+4|0}g[h>>2]=+Oh(j,c[t+168>>2]|0,f);If(t+184|0,t+8|0,e,f);if(!m)j=1;else{e=c[m+12>>2]|0;if((e|0)==(c[m+16>>2]|0)){o=0;e=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=27;break}}else e=c[e>>2]|0;u=(e|0)==-1;j=u;b=u?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;u=o;o=0;if(u&1){s=27;break}}else e=c[e>>2]|0;if((e|0)!=-1){if(!j)s=51}else s=49}else s=49;if((s|0)==49?j:0)s=51;if((s|0)==51)c[f>>2]=c[f>>2]|2;rq(t+172|0);rq(t+184|0);i=r;return b|0}while(0);if((s|0)==27)e=Ya()|0;rq(t+172|0);rq(t+184|0);Ra(e|0);return 0}function Uc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+352|0;Pf(t+184|0,e,t+208|0,t+200|0,t+196|0);c[t+172>>2]=0;c[t+172+4>>2]=0;c[t+172+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[t+172+(e<<2)>>2]=0;e=e+1|0}q=t+172+11|0;if((a[q>>0]|0)<0)e=(c[t+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,t+172|0,e|0);p=o;o=0;do if(p&1)s=27;else{j=(a[q>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=j;c[t+4>>2]=t+8;c[t>>2]=0;a[t+337>>0]=1;a[t+336>>0]=69;n=c[t+200>>2]|0;p=c[t+196>>2]|0;k=b;while(1){if(!k){m=0;k=1}else{e=c[k+12>>2]|0;if((e|0)==(c[k+16>>2]|0)){o=0;e=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;m=o;o=0;if(m&1){s=26;break}}else e=c[e>>2]|0;l=(e|0)==-1;m=l?0:k;k=l;b=l?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;l=o;o=0;if(l&1){s=26;break}}else e=c[e>>2]|0;if((e|0)!=-1)if(k)l=d;else break;else s=18}else s=18;if((s|0)==18){s=0;if(k){d=0;break}else l=0}d=a[q>>0]|0;d=d<<24>>24<0?c[t+172+4>>2]|0:d&255;if((c[t+168>>2]|0)==(j+d|0)){o=0;da(59,t+172|0,d<<1|0);k=o;o=0;if(k&1){s=26;break}if((a[q>>0]|0)<0)e=(c[t+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,t+172|0,e|0);k=o;o=0;if(k&1){s=26;break}j=(a[q>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=j+d}d=m+12|0;e=c[d>>2]|0;k=m+16|0;if((e|0)==(c[k>>2]|0)){o=0;e=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=26;break}}else e=c[e>>2]|0;if(Qd(e,t+337|0,t+336|0,j,t+168|0,n,p,t+184|0,t+8|0,t+4|0,t,t+208|0)|0){d=l;break}e=c[d>>2]|0;if((e|0)==(c[k>>2]|0)){o=0;ha(c[(c[m>>2]|0)+40>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=26;break}else{k=m;d=l;continue}}else{c[d>>2]=e+4;k=m;d=l;continue}}if((s|0)==26){e=Ya()|0;break}u=a[t+184+11>>0]|0;e=c[t+4>>2]|0;if(!((a[t+337>>0]|0)==0?1:((u<<24>>24<0?c[t+184+4>>2]|0:u&255)|0)==0)?(e-(t+8)|0)<160:0){u=c[t>>2]|0;c[t+4>>2]=e+4;c[e>>2]=u;e=e+4|0}h[g>>3]=+Oh(j,c[t+168>>2]|0,f);If(t+184|0,t+8|0,e,f);if(!m)j=1;else{e=c[m+12>>2]|0;if((e|0)==(c[m+16>>2]|0)){o=0;e=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=27;break}}else e=c[e>>2]|0;u=(e|0)==-1;j=u;b=u?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;u=o;o=0;if(u&1){s=27;break}}else e=c[e>>2]|0;if((e|0)!=-1){if(!j)s=51}else s=49}else s=49;if((s|0)==49?j:0)s=51;if((s|0)==51)c[f>>2]=c[f>>2]|2;rq(t+172|0);rq(t+184|0);i=r;return b|0}while(0);if((s|0)==27)e=Ya()|0;rq(t+172|0);rq(t+184|0);Ra(e|0);return 0}function Vc(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0;J=d[b>>0]|0;h=_n(d[b+1>>0]|0|0,0,8)|0;k=D;F=_n(d[b+2>>0]|0|0,0,16)|0;k=k|D;E=_n(d[b+3>>0]|0|0,0,24)|0;k=k|D;B=d[b+4>>0]|0;C=_n(d[b+5>>0]|0|0,0,8)|0;j=D;l=_n(d[b+6>>0]|0|0,0,16)|0;j=_n(C|B|l|0,j|D|0,6)|0;l=D;B=d[b+7>>0]|0;C=_n(d[b+8>>0]|0|0,0,8)|0;w=D;i=_n(d[b+9>>0]|0|0,0,16)|0;w=_n(C|B|i|0,w|D|0,5)|0;i=D;B=d[b+10>>0]|0;C=_n(d[b+11>>0]|0|0,0,8)|0;H=D;G=_n(d[b+12>>0]|0|0,0,16)|0;H=_n(C|B|G|0,H|D|0,3)|0;G=D;B=d[b+13>>0]|0;C=_n(d[b+14>>0]|0|0,0,8)|0;s=D;g=_n(d[b+15>>0]|0|0,0,16)|0;s=_n(C|B|g|0,s|D|0,2)|0;g=D;B=d[b+16>>0]|0;C=_n(d[b+17>>0]|0|0,0,8)|0;y=D;A=_n(d[b+18>>0]|0|0,0,16)|0;y=y|D;z=_n(d[b+19>>0]|0|0,0,24)|0;y=y|D;q=d[b+20>>0]|0;x=_n(d[b+21>>0]|0|0,0,8)|0;p=D;e=_n(d[b+22>>0]|0|0,0,16)|0;p=_n(x|q|e|0,p|D|0,7)|0;e=D;q=d[b+23>>0]|0;x=_n(d[b+24>>0]|0|0,0,8)|0;v=D;u=_n(d[b+25>>0]|0|0,0,16)|0;v=_n(x|q|u|0,v|D|0,5)|0;u=D;q=d[b+26>>0]|0;x=_n(d[b+27>>0]|0|0,0,8)|0;n=D;o=_n(d[b+28>>0]|0|0,0,16)|0;n=_n(x|q|o|0,n|D|0,4)|0;o=D;q=d[b+29>>0]|0;x=_n(d[b+30>>0]|0|0,0,8)|0;r=D;b=_n(d[b+31>>0]|0|0,0,16)|0;r=_n(x|q|b|0,r|D|0,2)|0;b=Jp(r&33554428|0,0,16777216,0)|0;b=bo(b|0,D|0,25)|0;q=D;x=mo(0,0,b|0,q|0)|0;k=Jp(x&19|0,0,h|J|F|E|0,k|0)|0;E=D;q=_n(b|0,q|0,25)|0;b=D;F=Jp(j|0,l|0,16777216,0)|0;F=bo(F|0,D|0,25)|0;J=D;i=Jp(w|0,i|0,F|0,J|0)|0;w=D;J=_n(F|0,J|0,25)|0;J=mo(j|0,l|0,J|0,D|0)|0;l=D;j=Jp(H|0,G|0,16777216,0)|0;j=bo(j|0,D|0,25)|0;F=D;g=Jp(s|0,g|0,j|0,F|0)|0;s=D;F=_n(j|0,F|0,25)|0;j=D;h=Jp(C|B|A|z|0,y|0,16777216,0)|0;h=bo(h|0,D|0,25)|0;x=D;e=Jp(p|0,e|0,h|0,x|0)|0;p=D;x=_n(h|0,x|0,25)|0;h=D;f=Jp(v|0,u|0,16777216,0)|0;f=bo(f|0,D|0,25)|0;t=D;o=Jp(n|0,o|0,f|0,t|0)|0;n=D;t=_n(f|0,t|0,25)|0;f=D;I=Jp(k|0,E|0,33554432,0)|0;I=ln(I|0,D|0,26)|0;m=D;l=Jp(J|0,l|0,I|0,m|0)|0;m=_n(I|0,m|0,26)|0;m=mo(k|0,E|0,m|0,D|0)|0;E=Jp(i|0,w|0,33554432,0)|0;E=ln(E|0,D|0,26)|0;k=D;G=Jp(E|0,k|0,H|0,G|0)|0;j=mo(G|0,D|0,F|0,j|0)|0;k=_n(E|0,k|0,26)|0;k=mo(i|0,w|0,k|0,D|0)|0;w=Jp(g|0,s|0,33554432,0)|0;w=ln(w|0,D|0,26)|0;i=D;y=Jp(w|0,i|0,C|B|A|z|0,y|0)|0;h=mo(y|0,D|0,x|0,h|0)|0;i=_n(w|0,i|0,26)|0;i=mo(g|0,s|0,i|0,D|0)|0;s=Jp(e|0,p|0,33554432,0)|0;s=ln(s|0,D|0,26)|0;g=D;u=Jp(s|0,g|0,v|0,u|0)|0;f=mo(u|0,D|0,t|0,f|0)|0;g=_n(s|0,g|0,26)|0;g=mo(e|0,p|0,g|0,D|0)|0;p=Jp(o|0,n|0,33554432,0)|0;p=ln(p|0,D|0,26)|0;e=D;r=Jp(r&33554428|0,0,p|0,e|0)|0;b=mo(r|0,D|0,q|0,b|0)|0;e=_n(p|0,e|0,26)|0;e=mo(o|0,n|0,e|0,D|0)|0;c[a>>2]=m;c[a+4>>2]=l;c[a+8>>2]=k;c[a+12>>2]=j;c[a+16>>2]=i;c[a+20>>2]=h;c[a+24>>2]=g;c[a+28>>2]=f;c[a+32>>2]=e;c[a+36>>2]=b;return}function Wc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;n=c[a+4>>2]|0;k=a+(n&-8)|0;i=c[12700]|0;if(!((n&3|0)!=1&a>>>0>=i>>>0&a>>>0<k>>>0))Ta();m=c[k+4>>2]|0;if(!(m&1))Ta();if(!(n&3)){if(b>>>0<256){a=0;return a|0}if((n&-8)>>>0>=(b+4|0)>>>0?((n&-8)-b|0)>>>0<=c[12816]<<1>>>0:0)return a|0;a=0;return a|0}if((n&-8)>>>0>=b>>>0){if(((n&-8)-b|0)>>>0<=15)return a|0;c[a+4>>2]=n&1|b|2;c[a+b+4>>2]=(n&-8)-b|3;c[a+b+((n&-8)-b)+4>>2]=c[a+b+((n&-8)-b)+4>>2]|1;oc(a+b|0,(n&-8)-b|0);return a|0}if((k|0)==(c[12702]|0)){d=(c[12699]|0)+(n&-8)|0;if(d>>>0<=b>>>0){a=0;return a|0}c[a+4>>2]=n&1|b|2;c[a+b+4>>2]=d-b|1;c[12702]=a+b;c[12699]=d-b;return a|0}if((k|0)==(c[12701]|0)){d=(c[12698]|0)+(n&-8)|0;if(d>>>0<b>>>0){a=0;return a|0}if((d-b|0)>>>0>15){c[a+4>>2]=n&1|b|2;c[a+b+4>>2]=d-b|1;c[a+b+(d-b)>>2]=d-b;c[a+b+(d-b)+4>>2]=c[a+b+(d-b)+4>>2]&-2;e=a+b|0;d=d-b|0}else{c[a+4>>2]=n&1|d|2;c[a+d+4>>2]=c[a+d+4>>2]|1;e=0;d=0}c[12698]=d;c[12701]=e;return a|0}if(m&2|0){a=0;return a|0}if(((m&-8)+(n&-8)|0)>>>0<b>>>0){a=0;return a|0}l=(m&-8)+(n&-8)-b|0;do if(m>>>0>=256){h=c[k+24>>2]|0;d=c[k+12>>2]|0;do if((d|0)==(k|0)){d=c[k+16+4>>2]|0;if(!d){d=c[k+16>>2]|0;if(!d){j=0;break}else g=k+16|0}else g=k+16+4|0;while(1){e=d+20|0;f=c[e>>2]|0;if(f|0){d=f;g=e;continue}e=d+16|0;f=c[e>>2]|0;if(!f)break;else{d=f;g=e}}if(g>>>0<i>>>0)Ta();else{c[g>>2]=0;j=d;break}}else{e=c[k+8>>2]|0;if(e>>>0<i>>>0)Ta();if((c[e+12>>2]|0)!=(k|0))Ta();if((c[d+8>>2]|0)==(k|0)){c[e+12>>2]=d;c[d+8>>2]=e;j=d;break}else Ta()}while(0);if(h|0){d=c[k+28>>2]|0;if((k|0)==(c[51088+(d<<2)>>2]|0)){c[51088+(d<<2)>>2]=j;if(!j){c[12697]=c[12697]&~(1<<d);break}}else{if(h>>>0<(c[12700]|0)>>>0)Ta();if((c[h+16>>2]|0)==(k|0))c[h+16>>2]=j;else c[h+20>>2]=j;if(!j)break}e=c[12700]|0;if(j>>>0<e>>>0)Ta();c[j+24>>2]=h;d=c[k+16>>2]|0;do if(d|0)if(d>>>0<e>>>0)Ta();else{c[j+16>>2]=d;c[d+24>>2]=j;break}while(0);d=c[k+16+4>>2]|0;if(d|0)if(d>>>0<(c[12700]|0)>>>0)Ta();else{c[j+20>>2]=d;c[d+24>>2]=j;break}}}else{d=c[k+8>>2]|0;e=c[k+12>>2]|0;if((d|0)!=(50824+(m>>>3<<1<<2)|0)){if(d>>>0<i>>>0)Ta();if((c[d+12>>2]|0)!=(k|0))Ta()}if((e|0)==(d|0)){c[12696]=c[12696]&~(1<<(m>>>3));break}if((e|0)!=(50824+(m>>>3<<1<<2)|0)){if(e>>>0<i>>>0)Ta();if((c[e+8>>2]|0)!=(k|0))Ta();else f=e+8|0}else f=e+8|0;c[d+12>>2]=e;c[f>>2]=d}while(0);if(l>>>0<16){c[a+4>>2]=(m&-8)+(n&-8)|n&1|2;c[a+((m&-8)+(n&-8))+4>>2]=c[a+((m&-8)+(n&-8))+4>>2]|1;return a|0}else{c[a+4>>2]=n&1|b|2;c[a+b+4>>2]=l|3;c[a+b+l+4>>2]=c[a+b+l+4>>2]|1;oc(a+b|0,l);return a|0}return 0}
function vi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;c[b+12>>2]=0;c[b+16>>2]=f;do if(d)if(d>>>0<29&(a[f+112>>0]|0)==0){a[f+112>>0]=1;break}else{f=Rj(d<<2)|0;break}else f=0;while(0);c[b>>2]=f;e=f+(e<<2)|0;c[b+8>>2]=e;c[b+4>>2]=e;c[b+12>>2]=f+(d<<2);return}function wi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=c[b+16>>2]|0;do if(f){if((f|0)!=(d|0)){c[b+36>>2]=(c[b+36>>2]|0)+1;c[b+24>>2]=2;a[b+54>>0]=1;break}if((c[b+24>>2]|0)==2)c[b+24>>2]=e}else{c[b+16>>2]=d;c[b+24>>2]=e;c[b+36>>2]=1}while(0);return}function xi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;g=0;while(1){if((g|0)>=(e|0))break;f=c[b+12>>2]|0;if(f>>>0<(c[b+16>>2]|0)>>>0){c[b+12>>2]=f+1;f=a[f>>0]|0}else{f=Ib[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((f|0)==-1)break;f=f&255}a[d>>0]=f;d=d+1|0;g=g+1|0}return g|0}function yi(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;k=i=i+63&-64;i=i+16|0;a[k>>0]=37;a[k+1>>0]=g;a[k+2>>0]=h;a[k+3>>0]=0;if(h<<24>>24){a[k+1>>0]=h;a[k+2>>0]=g}c[e>>2]=d+(ab(d|0,(c[e>>2]|0)-d|0,k|0,f|0,c[b>>2]|0)|0);i=j;return}function zi(a,b,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;if(f>>>0>4294967295|(f|0)==-1&e>>>0>4294967279)Ta();Lf(a,a+e|0,0,d,e,f,g,h,i,0,k,l)|0;if(b|0){j=Jp(e|0,f|0,16,0)|0;c[b>>2]=j;c[b+4>>2]=D}return 0}function Ai(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;a=i;b=i=i+63&-64;i=i+16|0;c[b+4>>2]=d;c[b>>2]=g;h=Dd(d,e,b+4|0,g,h,b,1114111,0)|0;c[f>>2]=c[b+4>>2];c[j>>2]=c[b>>2];i=a;return h|0}function Bi(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;a=i;b=i=i+63&-64;i=i+16|0;c[b+4>>2]=d;c[b>>2]=g;h=yd(d,e,b+4|0,g,h,b,1114111,0)|0;c[f>>2]=c[b+4>>2];c[j>>2]=c[b>>2];i=a;return h|0}function Ci(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;a=i;b=i=i+63&-64;i=i+16|0;c[b+4>>2]=d;c[b>>2]=g;h=be(d,e,b+4|0,g,h,b,1114111,0)|0;c[f>>2]=c[b+4>>2];c[j>>2]=c[b>>2];i=a;return h|0}function Di(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;a=i;b=i=i+63&-64;i=i+16|0;c[b+4>>2]=d;c[b>>2]=g;h=Ed(d,e,b+4|0,g,h,b,1114111,0)|0;c[f>>2]=c[b+4>>2];c[j>>2]=c[b>>2];i=a;return h|0}function Ei(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=b;while(1){if((e|0)==(f|0)){h=7;break}if((a|0)==(d|0)){e=-1;break}b=c[a>>2]|0;g=c[e>>2]|0;if((b|0)<(g|0)){e=-1;break}if((g|0)<(b|0)){e=1;break}e=e+4|0;a=a+4|0}if((h|0)==7)e=(a|0)!=(d|0)&1;return e|0}function Fi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;f=0;while(1){if((f|0)>=(d|0))break;e=c[a+12>>2]|0;if(e>>>0>=(c[a+16>>2]|0)>>>0){e=Ib[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((e|0)==-1)break}else{c[a+12>>2]=e+4;e=c[e>>2]|0}c[b>>2]=e;b=b+4|0;f=f+1|0}return f|0}function Gi(a,b,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;if(f>>>0>4294967295|(f|0)==-1&e>>>0>4294967279)Ta();lg(a,a+e|0,0,d,e,f,g,h,i,0,k,l)|0;if(b|0){j=Jp(e|0,f|0,16,0)|0;c[b>>2]=j;c[b+4>>2]=D}return 0}function Hi(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0;f=i;g=i=i+63&-64;i=i+160|0;ji(c,e,32,0)|0;a[c>>0]=(d[c>>0]|0)&248;a[c+31>>0]=(d[c+31>>0]|0)&63|64;ge(g,c);ei(b,g);Lk(c|0,e|0,32)|0;Lk(c+32|0,b|0,32)|0;i=f;return 0}function Ii(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;do if(!((b+-1|0)>>>0>63|g>>>0>64)){if(b>>>0>=256)Wa(42169,42189,18,42241);if(g>>>0<256){ph(a,c,f,b&255,d,e,g&255);h=0;break}else Wa(42268,42189,19,42241)}else h=-1;while(0);return h|0}function Ji(a){a=a|0;var b=0,d=0;c[a>>2]=40592;d=0;while(1){b=c[a+8>>2]|0;if(d>>>0>=(c[a+12>>2]|0)-b>>2>>>0)break;b=c[b+(d<<2)>>2]|0;if(b|0)en(b);d=d+1|0}rq(a+144|0);mj(a+8|0);return}function Ki(a){a=a|0;var b=0;if(!a){if(!(c[8603]|0))a=0;else a=Ki(c[8603]|0)|0;Qa(50748);b=c[12686]|0;if(b)do{if((c[b+20>>2]|0)>>>0>(c[b+28>>2]|0)>>>0)a=ti(b)|0|a;b=c[b+56>>2]|0}while((b|0)!=0);ob(50748)}else a=ti(a)|0;return a|0}function Li(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;g=i;f=i=i+63&-64;i=i+16|0;c[f+4>>2]=b;c[f>>2]=d;if(!e)b=0;else{b=0;d=0;do{b=a[(c[f>>2]|0)+d>>0]^a[(c[f+4>>2]|0)+d>>0]|b;d=d+1|0}while((d|0)!=(e|0))}i=g;return (((b&255)+511|0)>>>8&1)+-1|0}function Mi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=gd(b,d,e,f,4)|0;if(!(c[e>>2]&4)){if((b|0)<69)b=b+2e3|0;else b=(b+-69|0)>>>0<31?b+1900|0:b;c[a>>2]=b+-1900}return}function Ni(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=nd(b,d,e,f,4)|0;if(!(c[e>>2]&4)){if((b|0)<69)b=b+2e3|0;else b=(b+-69|0)>>>0<31?b+1900|0:b;c[a>>2]=b+-1900}return}function Oi(b){b=b|0;var d=0,e=0,f=0;d=c[b+4>>2]|0;e=c[b+8>>2]|0;while(1){if((e|0)==(d|0))break;f=e+-4|0;c[b+8>>2]=f;e=f}e=c[b>>2]|0;do if(e|0){d=c[b+16>>2]|0;if((d|0)==(e|0)){a[d+112>>0]=0;break}else{$u(e);break}}while(0);return}function Pi(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;g=i;h=i=i+63&-64;i=i+64|0;ji(h,d,32,0)|0;d=c;e=h;f=d+32|0;do{a[d>>0]=a[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));bl(h,64);h=Qr(b,c)|0;i=g;return h|0}function Qi(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;f=i;g=i=i+63&-64;i=i+64|0;ji(g,c,32,0)|0;a[g>>0]=(d[g>>0]|0)&248;a[g+31>>0]=(d[g+31>>0]|0)&63|64;c=g;e=b+32|0;do{a[b>>0]=a[c>>0]|0;b=b+1|0;c=c+1|0}while((b|0)<(e|0));bl(g,64);i=f;return 0}function Ri(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;if(e>>>0<0|(e|0)==0&d>>>0<32)b=-1;else{eo(b,c,d,e,f,g)|0;d=Jp(d|0,e|0,-32,-1)|0;rp(b+16|0,b+32|0,d,D,b)|0;d=b+16|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(d|0));b=0}return b|0}function Si(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;a:do if(!(a[b+44>>0]|0)){f=d;d=0;while(1){if((d|0)>=(e|0))break a;if((Pb[c[(c[b>>2]|0)+52>>2]&63](b,c[f>>2]|0)|0)==-1)break a;f=f+4|0;d=d+1|0}}else d=gn(d,4,e,c[b+32>>2]|0)|0;while(0);return d|0}function Ti(b,e,f){b=b|0;e=e|0;f=f|0;var g=0;a:do if(!(a[b+44>>0]|0)){g=e;e=0;while(1){if((e|0)>=(f|0))break a;if((Pb[c[(c[b>>2]|0)+52>>2]&63](b,d[g>>0]|0)|0)==-1)break a;g=g+1|0;e=e+1|0}}else e=gn(e,1,f,c[b+32>>2]|0)|0;while(0);return e|0}function Ui(b,d){b=b|0;d=d|0;d=wq(c[d>>2]|0,54132)|0;c[b+36>>2]=d;c[b+44>>2]=Ib[c[(c[d>>2]|0)+24>>2]&127](d)|0;d=c[b+36>>2]|0;a[b+53>>0]=(Ib[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[b+44>>2]|0)>8)ll(46913);else return}function Vi(b,d){b=b|0;d=d|0;d=wq(c[d>>2]|0,54124)|0;c[b+36>>2]=d;c[b+44>>2]=Ib[c[(c[d>>2]|0)+24>>2]&127](d)|0;d=c[b+36>>2]|0;a[b+53>>0]=(Ib[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[b+44>>2]|0)>8)ll(46913);else return}function Wi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=c[a+4>>2]|0;if(!(h&1))i=h>>8;else i=c[(c[e>>2]|0)+(h>>8)>>2]|0;a=c[a>>2]|0;Mb[c[(c[a>>2]|0)+20>>2]&31](a,b,d,e+i|0,h&2|0?f:2,g);return}function Xi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if(a-b>>2>>>0<d>>>0){if(d|0)do{d=d+-1|0;c[a+(d<<2)>>2]=c[b+(d<<2)>>2]}while((d|0)!=0)}else if(d|0){e=a;while(1){d=d+-1|0;c[e>>2]=c[b>>2];if(!d)break;else{b=b+4|0;e=e+4|0}}}return a|0}function Yi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b>>0]=d;b=b+1|0}}while((b|0)<(f&~3|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b>>0]=d;b=b+1|0}return b-e|0}function Zi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;if((a|0)==(c[b+8>>2]|0))Ng(b,d,e,f);else{a=c[a+8>>2]|0;Mb[c[(c[a>>2]|0)+20>>2]&31](a,b,d,e,f,g)}return}function _i(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;i=i+480|0;xf(g,f,32)|0;Lq(g,c,d,e)|0;Kl(g,g+416|0)|0;d=g+416|0;e=b+32|0;do{a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0}while((b|0)<(e|0));i=g;return 0}function $i(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;f=i;e=i=i+63&-64;i=i+32|0;c[e>>2]=c[a+60>>2];c[e+4>>2]=0;c[e+8>>2]=b;c[e+12>>2]=e+20;c[e+16>>2]=d;if((rr(xb(140,e|0)|0)|0)<0){c[e+20>>2]=-1;a=-1}else a=c[e+20>>2]|0;i=f;return a|0}function aj(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;h=i;g=i=i+63&-64;i=i+32|0;if(d>>>0<0|(d|0)==0&c>>>0<48)c=-1;else{Ak(g,b,e);c=Jp(c|0,d|0,-32,-1)|0;c=$k(a,b+32|0,c,D,g,b,f)|0}i=h;return c|0}function bj(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;Lb[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0)}function cj(a){a=a|0;var b=0,e=0;b=c[a+4>>2]|0;e=b>>>0<(c[a+8>>2]|0)>>>0;do if((c[a+76>>2]|0)<0)if(e){c[a+4>>2]=b+1;b=d[b>>0]|0;break}else{b=Dk(a)|0;break}else if(e){c[a+4>>2]=b+1;b=d[b>>0]|0;break}else{b=Dk(a)|0;break}while(0);return b|0}function dj(b,d){b=b|0;d=d|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;if((a[d+11>>0]|0)<0)ni(b,c[d>>2]|0,c[d+4>>2]|0);else{c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2]}return}function ej(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=gd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b+-1|0)>>>0<12&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function fj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=nd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b+-1|0)>>>0<12&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function gj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=c[a+4>>2]|0;if(!(g&1))h=g>>8;else h=c[(c[d>>2]|0)+(g>>8)>>2]|0;a=c[a>>2]|0;Db[c[(c[a>>2]|0)+24>>2]&31](a,b,d+h|0,g&2|0?e:2,f);return}function hj(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;j=i;h=i=i+63&-64;i=i+32|0;if(!(Hk(h,f,g)|0)){c=po(a,b,c,d,e,h)|0;bl(h,32)}else c=-1;i=j;return c|0}function ij(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=gd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b+-1|0)>>>0<31&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function jj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=gd(b,d,e,f,3)|0;f=c[e>>2]|0;if((b|0)<366&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function kj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=nd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b+-1|0)>>>0<31&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function lj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=nd(b,d,e,f,3)|0;f=c[e>>2]|0;if((b|0)<366&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function mj(b){b=b|0;var d=0,e=0,f=0;d=c[b>>2]|0;do if(d|0){e=c[b+4>>2]|0;while(1){if((e|0)==(d|0))break;f=e+-4|0;c[b+4>>2]=f;e=f}if((b+16|0)==(d|0)){a[b+128>>0]=0;break}else{$u(d);break}}while(0);return}function nj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=gd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b|0)<13&(f&4|0)==0)c[a>>2]=b+-1;else c[e>>2]=f|4;return}function oj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=nd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b|0)<13&(f&4|0)==0)c[a>>2]=b+-1;else c[e>>2]=f|4;return}function pj(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;m=i=i+63&-64;i=i+16|0;ks(m);d=dd(m,a,b,c,d,e,f,g,h,j,k)|0;up(m);i=l;return d|0}function qj(a){a=a|0;o=0;ba(129,51460);a=o;o=0;if(((!(a&1)?(o=0,ba(130,51544),a=o,o=0,!(a&1)):0)?(o=0,ba(129,51796),a=o,o=0,!(a&1)):0)?(o=0,ba(130,51880),a=o,o=0,!(a&1)):0)return;a=Za(0)|0;lt(a)}function rj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=gd(b,d,e,f,1)|0;f=c[e>>2]|0;if((b|0)<7&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function sj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=gd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b|0)<61&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function tj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=gd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b|0)<60&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function uj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=nd(b,d,e,f,1)|0;f=c[e>>2]|0;if((b|0)<7&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function vj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=nd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b|0)<61&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function wj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=nd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b|0)<60&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function xj(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;j=i;h=i=i+63&-64;i=i+32|0;if(!(Hk(h,f,g)|0)){c=To(a,b,c,d,e,h)|0;bl(h,32)}else c=-1;i=j;return c|0}function yj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=gd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b|0)<24&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function zj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=nd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b|0)<24&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function Aj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=c[a+4>>2]|0;if(!(f&1))g=f>>8;else g=c[(c[d>>2]|0)+(f>>8)>>2]|0;a=c[a>>2]|0;Xb[c[(c[a>>2]|0)+28>>2]&31](a,b,d+g|0,f&2|0?e:2);return}function Bj(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=i=i+63&-64;i=i+80|0;c[b+36>>2]=18;if((c[b>>2]&64|0)==0?(c[g>>2]=c[b+60>>2],c[g+4>>2]=21505,c[g+8>>2]=g+12,nb(54,g|0)|0):0)a[b+75>>0]=-1;g=ue(b,d,e)|0;i=f;return g|0}function Cj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;f=i;e=i=i+63&-64;i=i+16|0;Tb[c[(c[a>>2]|0)+12>>2]&31](e,a,b);if((c[e+4>>2]|0)==(c[d+4>>2]|0))b=(c[e>>2]|0)==(c[d>>2]|0);else b=0;i=f;return b|0}function Dj(b,d){b=b|0;d=d|0;var e=0;do if((b|0)!=-1){if((c[d+8>>2]|0)==0?mi(d)|0:0){b=-1;break}e=c[d+4>>2]|0;if(e>>>0>((c[d+44>>2]|0)+-8|0)>>>0){c[d+4>>2]=e+-1;a[e+-1>>0]=b;c[d>>2]=c[d>>2]&-17}else b=-1}else b=-1;while(0);return b|0}function Ej(b,d){b=b|0;d=d|0;var e=0;if(d>>>0>1073741823)mk();if(d>>>0<29&(a[b+128>>0]|0)==0){a[b+128>>0]=1;e=b+16|0}else e=Rj(d<<2)|0;c[b+4>>2]=e;c[b>>2]=e;c[b+8>>2]=e+(d<<2);return}function Fj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;f=i;g=i=i+63&-64;i=i+112|0;e=g;h=e+112|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(h|0));c[g+32>>2]=45;c[g+44>>2]=a;c[g+76>>2]=-1;c[g+84>>2]=a;h=jc(g,b,d)|0;i=f;return h|0}function Gj(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;oa(7,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function Hj(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;oa(6,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function Ij(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;oa(5,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function Jj(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;oa(4,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function Kj(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;oa(3,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function Lj(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;oa(2,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function Mj(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;oa(1,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function Nj(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;oa(0,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function Oj(a){a=a|0;var b=0,d=0;b=aq(c[a+8>>2]|0)|0;d=uf(0,0,4)|0;if(b|0)aq(b)|0;if(!d){b=c[a+8>>2]|0;if(b){b=aq(b)|0;if(!b)b=0;else{aq(b)|0;b=0}}else b=1}else b=-1;return b|0}function Pj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;if((a|0)==(c[b+8>>2]|0))wi(b,d,e);else{a=c[a+8>>2]|0;Xb[c[(c[a>>2]|0)+28>>2]&31](a,b,d,e)}return}function Qj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=i;d=i=i+63&-64;i=i+16|0;f=Nn(d,b)|0;c[(Sq()|0)>>2]=f;if(!f)d=c[d>>2]|0;else{c[d>>2]=0;d=0}c[a>>2]=d;c[a+4>>2]=d;c[a+8>>2]=d|0?b:0;i=e;return d|0}function Rj(a){a=a|0;var b=0,c=0;b=(a|0)==0?1:a;while(1){c=ec(b)|0;if(c|0){a=6;break}a=bt()|0;if(!a){a=5;break}Ub[a&31]()}if((a|0)==5){c=db(4)|0;eu(c);sb(c|0,1944,114)}else if((a|0)==6)return c|0;return 0}function Sj(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;k=i=i+63&-64;i=i+32|0;ad(k,e,h,0)|0;Vd(a,b,c,d,e+16|0,f,g,k)|0;bl(k,32);i=j;return 0}function Tj(b,c){b=b|0;c=c|0;var d=0,e=0;e=a[b>>0]|0;d=a[c>>0]|0;if(e<<24>>24==0?1:e<<24>>24!=d<<24>>24)c=e;else{do{b=b+1|0;c=c+1|0;e=a[b>>0]|0;d=a[c>>0]|0}while(!(e<<24>>24==0?1:e<<24>>24!=d<<24>>24));c=e}return (c&255)-(d&255)|0}function Uj(a){a=a|0;var b=0,d=0;b=i;d=i=i+63&-64;i=i+32|0;c[d>>2]=a;c[d+4>>2]=131;c[d+8>>2]=0;if((c[a>>2]|0)!=-1){c[d+16>>2]=d;c[d+12>>2]=d+16;ef(a,d+12|0)}i=b;return (c[a+4>>2]|0)+-1|0}function Vj(b){b=b|0;var d=0;d=a[b+74>>0]|0;a[b+74>>0]=d+255|d;d=c[b>>2]|0;if(!(d&8)){c[b+8>>2]=0;c[b+4>>2]=0;d=c[b+44>>2]|0;c[b+28>>2]=d;c[b+20>>2]=d;c[b+16>>2]=d+(c[b+48>>2]|0);d=0}else{c[b>>2]=d|32;d=-1}return d|0}function Wj(a){a=a|0;var b=0;c[a>>2]=37640;o=0;ba(126,a|0);b=o;o=0;if(b&1){b=Za(0)|0;lt(b)}else{ts(a+28|0);nc(c[a+32>>2]|0);nc(c[a+36>>2]|0);nc(c[a+48>>2]|0);nc(c[a+60>>2]|0);return}}function Xj(b,d){b=b|0;d=d|0;var e=0;if(((a[b>>0]|0)!=0?(Tj(b,47235)|0)!=0:0)?(Tj(b,46376)|0)!=0:0)d=0;else e=4;do if((e|0)==4)if(!d)if(!(c[12693]|0)){c[12693]=1;d=50776;break}else{d=ao(4)|0;break}while(0);return d|0}function Yj(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;j=i;i=i+32|0;if(!(lr(j,g,h)|0)){d=Le(a,b,c,d,e,f,j)|0;bl(j,32)}else d=-1;i=j;return d|0}function Zj(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;j=i;i=i+32|0;if(!(lr(j,g,h)|0)){se(a,b,c,d,e,f,j)|0;bl(j,32);d=0}else d=-1;i=j;return d|0}function _j(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=gd(b,d,e,f,4)|0;if(!(c[e>>2]&4))c[a>>2]=b+-1900;return}function $j(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=nd(b,d,e,f,4)|0;if(!(c[e>>2]&4))c[a>>2]=b+-1900;return}function ak(a,b){a=a|0;b=b|0;var d=0;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0&1;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+32|0;d=b+40|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));Al(a+28|0);return}function bk(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0;h=d;while(1){if((h|0)==(f|0))break;a=c[h>>2]|0;if(a>>>0<128)a=e[41512+(a<<1)>>1]|0;else a=0;b[g>>1]=a;g=g+2|0;h=h+4|0}return d+((f-d|0)>>>2<<2)|0}function ck(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Cc(a,c[b>>2]|0,c[d>>2]|0,e,f,g,38712,38744)|0}function dk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Bc(a,c[b>>2]|0,c[d>>2]|0,e,f,g,47676,47684)|0}function ek(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=i=i+63&-64;i=i+16|0;c[h>>2]=f;f=aq(d)|0;d=vg(a,b,e,h)|0;if(f|0)aq(f)|0;i=g;return d|0}function fk(a){a=a|0;c[a+32>>2]=0;c[a+32+4>>2]=0;c[a>>2]=c[8460];c[a+4>>2]=c[8461];c[a+8>>2]=c[8462];c[a+12>>2]=c[8463];c[a+16>>2]=c[8464];c[a+20>>2]=c[8465];c[a+24>>2]=c[8466];c[a+28>>2]=c[8467];return 0}function gk(a,b,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;if((l|0)==1)b=gh(a,b,d,e,f,g,h,i,j,k,1)|0;else{c[(Sq()|0)>>2]=22;b=-1}return b|0}function hk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Tc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function ik(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Uc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function jk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Oc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function kk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Pc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function lk(){var a=0,b=0;a=db(8)|0;o=0;da(63,a|0,49300);b=o;o=0;if(b&1){b=Ya()|0;Xa(a|0);Ra(b|0)}else{c[a>>2]=41184;sb(a|0,1992,116)}}function mk(){var a=0,b=0;a=db(8)|0;o=0;da(63,a|0,49268);b=o;o=0;if(b&1){b=Ya()|0;Xa(a|0);Ra(b|0)}else{c[a>>2]=41184;sb(a|0,1992,116)}}function nk(b,d){b=b|0;d=d|0;a[b>>0]=0;c[b+4>>2]=d;d=d+(c[(c[d>>2]|0)+-12>>2]|0)|0;if(!(c[d+16>>2]|0)){d=c[d+72>>2]|0;if(d|0)Je(d);a[b>>0]=1}return}function ok(b,d){b=b|0;d=d|0;a[b>>0]=0;c[b+4>>2]=d;d=d+(c[(c[d>>2]|0)+-12>>2]|0)|0;if(!(c[d+16>>2]|0)){d=c[d+72>>2]|0;if(d|0)Ke(d);a[b>>0]=1}return}function pk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;f=c[a+84>>2]|0;e=vf(f,0,d+256|0)|0;e=(e|0)==0?d+256|0:e-f|0;d=e>>>0<d>>>0?e:d;bi(b|0,f|0,d|0)|0;c[a+4>>2]=f+d;c[a+8>>2]=f+e;c[a+84>>2]=f+e;return d|0}function qk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Jc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function rk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Qc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function sk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Rc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function tk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Hc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function uk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Lc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function vk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Mc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function wk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Kc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function xk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Sc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function yk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Ic(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function zk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Nc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function Ak(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=i=i+63&-64;i=i+368|0;Rq(e,0,0,24)|0;uq(e,b,32,0)|0;uq(e,c,32,0)|0;Cr(e,a,24)|0;i=d;return}function Bk(a,b){a=a|0;b=b|0;c[a+4>>2]=b+-1;c[a>>2]=40704;c[a+8>>2]=46;c[a+12>>2]=44;c[a+16>>2]=0;c[a+16+4>>2]=0;c[a+16+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+16+(b<<2)>>2]=0;b=b+1|0}return}function Ck(a){a=a|0;var b=0,d=0;b=c[c[a>>2]>>2]|0;a=c[b+4>>2]|0;d=c[b+8>>2]|0;b=(c[b>>2]|0)+(d>>1)|0;if(d&1)a=c[(c[b>>2]|0)+a>>2]|0;Fb[a&255](b);return}function Dk(a){a=a|0;var b=0,e=0;e=i;b=i=i+63&-64;i=i+16|0;if((c[a+8>>2]|0)==0?(mi(a)|0)!=0:0)a=-1;else if((Kb[c[a+32>>2]&63](a,b,1)|0)==1)a=d[b>>0]|0;else a=-1;i=e;return a|0}function Ek(b,d){b=b|0;d=d|0;c[b+4>>2]=d+-1;c[b>>2]=40664;a[b+8>>0]=46;a[b+9>>0]=44;c[b+12>>2]=0;c[b+12+4>>2]=0;c[b+12+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+12+(d<<2)>>2]=0;d=d+1|0}return}function Fk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=i=i+63&-64;i=i+16|0;c[g>>2]=e;e=aq(b)|0;b=Mh(a,d,g)|0;if(e|0)aq(e)|0;i=f;return b|0}function Gk(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;return Jb[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0)|0}function Hk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=i;d=i=i+63&-64;i=i+32|0;if(!(Wk(d,c,b)|0)){ad(a,54276,d,0)|0;a=0}else a=-1;i=e;return a|0}function Ik(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;d=i=i+63&-64;i=i+16|0;c[d>>2]=e;b=aq(b)|0;d=Fj(a,47237,d)|0;if(b|0)aq(b)|0;i=f;return d|0}function Jk(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;i=i+32|0;_i(f,b,c,d,e)|0;e=wm(a,f)|0;e=((f|0)==(a|0)?-1:e)|(Li(f,a,32)|0);i=f;return e|0}function Kk(a,b){a=+a;b=+b;var d=0;h[k>>3]=b;d=c[k+4>>2]|0;b=+F(+a);h[k>>3]=b;d=d&-2147483648|c[k+4>>2];c[k>>2]=c[k>>2];c[k+4>>2]=d;return +(+h[k>>3])}function Lk(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b>>0]=a[c>>0]|0}b=e}else bi(b,c,d)|0;return b|0}function Mk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=S(b&65535,a&65535)|0;e=(c>>>16)+(S(b&65535,a>>>16)|0)|0;d=S(b>>>16,a&65535)|0;return (D=(e>>>16)+(S(b>>>16,a>>>16)|0)+(((e&65535)+d|0)>>>16)|0,e+d<<16|c&65535|0)|0}function Nk(b){b=b|0;if((a[50208]|0)==0?sr(50208)|0:0){c[13499]=0;c[13500]=0;c[13501]=0;vh(53996,39920,$p(39920)|0);rb(139,53996,n|0)|0}return 53996}function Ok(b){b=b|0;if((a[50200]|0)==0?sr(50200)|0:0){c[13496]=0;c[13497]=0;c[13498]=0;vh(53984,39872,$p(39872)|0);rb(139,53984,n|0)|0}return 53984}function Pk(b){b=b|0;if((a[50192]|0)==0?sr(50192)|0:0){c[13493]=0;c[13494]=0;c[13495]=0;vh(53972,39788,$p(39788)|0);rb(139,53972,n|0)|0}return 53972}function Qk(b){b=b|0;if((a[50216]|0)==0?sr(50216)|0:0){c[13502]=0;c[13503]=0;c[13504]=0;vh(54008,39956,$p(39956)|0);rb(139,54008,n|0)|0}return 54008}function Rk(a,b){a=a|0;b=b|0;ic(a,b,b+120|0);ic(a+40|0,b+40|0,b+80|0);ic(a+80|0,b+80|0,b+120|0);ic(a+120|0,b,b+40|0);return}function Sk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;if((a|0)==(c[b+8>>2]|0))Ng(b,d,e,f);return}function Tk(b,d){b=b|0;d=d|0;Ib[c[(c[b>>2]|0)+24>>2]&127](b)|0;d=wq(c[d>>2]|0,54132)|0;c[b+36>>2]=d;a[b+44>>0]=(Ib[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;return}function Uk(b,d){b=b|0;d=d|0;Ib[c[(c[b>>2]|0)+24>>2]&127](b)|0;d=wq(c[d>>2]|0,54124)|0;c[b+36>>2]=d;a[b+44>>0]=(Ib[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;return}function Vk(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;b=d;while(1){if((b|0)==(e|0))break;h=c[b>>2]|0;a[g>>0]=h>>>0<128?h&255:f;g=g+1|0;b=b+4|0}return d+((e-d|0)>>>2<<2)|0}function Wk(b,c,d){b=b|0;c=c|0;d=d|0;if(!(wc(b,c,d)|0)){c=0;d=0;do{c=a[b+d>>0]|c;d=d+1|0}while((d|0)!=32);c=0-(((c&255)+511|0)>>>8&1)|0}else c=-1;return c|0}function Xk(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;i=i+64|0;Dl(f,b,c,d,e)|0;e=vm(a,f)|0;e=((f|0)==(a|0)?-1:e)|(Li(f,a,64)|0);i=f;return e|0}function Yk(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;i=i+32|0;El(f,b,c,d,e)|0;e=wm(a,f)|0;e=((f|0)==(a|0)?-1:e)|(Li(f,a,32)|0);i=f;return e|0}function Zk(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=i=i+63&-64;i=i+32|0;ad(g,d,e,0)|0;Me(a,b,c,d+16|0,g)|0;bl(g,32);i=f;return 0}function _k(a,b){a=a|0;b=b|0;var e=0,f=0,g=0;g=0;e=0;do{f=vf(42710,d[b>>0]|0,65)|0;if(!f){b=0;e=0;break}b=b+1|0;e=f-42710<<g|e;g=g+6|0}while(g>>>0<30);c[a>>2]=e;return b|0}function $k(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;if(d>>>0<0|(d|0)==0&c>>>0<16)c=-1;else{c=Jp(c|0,d|0,-16,-1)|0;c=Yj(a,b+16|0,b,c,D,e,f,g)|0}return c|0}function al(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=i=i+63&-64;i=i+16|0;He(g,b,c,d,e)|0;e=xm(a,g)|0;i=f;return e|0}function bl(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=i=i+63&-64;i=i+16|0;c[f>>2]=b;if(d|0){b=0;do{a[(c[f>>2]|0)+b>>0]=0;b=b+1|0}while((b|0)!=(d|0))}i=e;return}function cl(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;while(1){if((e|0)==(f|0)){e=f;break}a=c[e>>2]|0;if(a>>>0>=128)break;if(!((b[41512+(a<<1)>>1]&d)<<16>>16))break;e=e+4|0}return e|0}function dl(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=b;while(1){if((e|0)==(d|0))break;a=c[e>>2]|0;if(a>>>0<128)a=c[36576+(a<<2)>>2]|0;c[e>>2]=a;e=e+4|0}return b+((d-b|0)>>>2<<2)|0}function el(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=b;while(1){if((e|0)==(d|0))break;a=c[e>>2]|0;if(a>>>0<128)a=c[35040+(a<<2)>>2]|0;c[e>>2]=a;e=e+4|0}return b+((d-b|0)>>>2<<2)|0}function fl(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=0;do{g=b+(d<<3)|0;e=a+(d<<3)|0;f=c[e+4>>2]^c[g+4>>2];c[e>>2]=c[e>>2]^c[g>>2];c[e+4>>2]=f;d=d+1|0}while((d|0)!=128);return}function gl(b){b=b|0;if((a[50120]|0)==0?sr(50120)|0:0){c[13293]=0;c[13294]=0;c[13295]=0;ni(53172,47966,11);rb(135,53172,n|0)|0}return 53172}function hl(b){b=b|0;if((a[50112]|0)==0?sr(50112)|0:0){c[13290]=0;c[13291]=0;c[13292]=0;ni(53160,47945,20);rb(135,53160,n|0)|0}return 53160}function il(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if(d>>>0<0|(d|0)==0&c>>>0<16)c=-1;else{c=Jp(c|0,d|0,-16,-1)|0;c=Le(a,b+16|0,b,c,D,e,f)|0}return c|0}function jl(b){b=b|0;if((a[50128]|0)==0?sr(50128)|0:0){c[13296]=0;c[13297]=0;c[13298]=0;ni(53184,47978,8);rb(135,53184,n|0)|0}return 53184}function kl(b){b=b|0;if((a[50136]|0)==0?sr(50136)|0:0){c[13299]=0;c[13300]=0;c[13301]=0;ni(53196,47987,8);rb(135,53196,n|0)|0}return 53196}function ll(a){a=a|0;var b=0;b=db(8)|0;o=0;da(60,b|0,a|0);a=o;o=0;if(a&1){a=Ya()|0;Xa(b|0);Ra(a|0)}else sb(b|0,1976,118)}function ml(a,b,d){a=a|0;b=b|0;d=d|0;if((d|0)==1){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;ni(a,46837,35)}else qm(a,d);return}function nl(a){a=a|0;var b=0,d=0;b=c[a+40>>2]|0;while(1){if(!b)break;d=b+-1|0;Tb[c[(c[a+32>>2]|0)+(d<<2)>>2]&31](0,a,c[(c[a+36>>2]|0)+(d<<2)>>2]|0);b=d}return}function ol(b){b=b|0;var c=0;c=a[m+(b&255)>>0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)>>0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)>>0]|0;if((c|0)<8)return c+16|0;return (a[m+(b>>>24)>>0]|0)+24|0}function pl(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;yg(a,d,e);return}function ql(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;wh(a,d,e);return}function rl(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ka(7,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function sl(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ka(6,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function tl(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ka(5,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function ul(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ka(4,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function vl(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ka(3,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function wl(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ka(2,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function xl(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ka(1,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function yl(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ka(0,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function zl(b,c){b=b|0;c=c|0;var d=0,e=0;e=i;i=i+64|0;Kl(b,e)|0;b=e;d=c+32|0;do{a[c>>0]=a[b>>0]|0;c=c+1|0;b=b+1|0}while((c|0)<(d|0));i=e;return 0}function Al(a){a=a|0;var b=0,d=0;o=0;b=za(18)|0;d=o;o=0;if(d&1){d=Za(0)|0;lt(d)}else{d=c[b>>2]|0;c[a>>2]=d;hs(d);return}}function Bl(b,c,d){b=b|0;c=c|0;d=d|0;if(!(d>>>0<1|(d|0)==1&c>>>0<0))Wa(43612,43632,172,43658);if(c|0){d=0;do{a[b+d>>0]=_a(0)|0;d=d+1|0}while((d|0)!=(c|0))}return}function Cl(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;Ob[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)}function Dl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;i=i+416|0;xf(f,e,32)|0;Yd(f,b,c,d)|0;Kl(f,a)|0;i=f;return 0}function El(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;i=i+208|0;zf(f,e,32)|0;oe(f,b,c,d)|0;Ll(f,a)|0;i=f;return 0}function Fl(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;while(1){if((e|0)==(f|0)){e=f;break}a=c[e>>2]|0;if(a>>>0<128?(b[41512+(a<<1)>>1]&d)<<16>>16:0)break;e=e+4|0}return e|0}function Gl(a){a=a|0;var b=0,d=0;c[a+64>>2]=0;c[a+64+4>>2]=0;c[a+64+8>>2]=0;c[a+64+12>>2]=0;b=400;d=a+64|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(d|0));return 0}function Hl(b,d,e){b=b|0;d=d|0;e=e|0;b=d;while(1){if((b|0)==(e|0))break;d=a[b>>0]|0;if(d<<24>>24>-1)d=c[36576+(d<<24>>24<<2)>>2]&255;a[b>>0]=d;b=b+1|0}return e|0}function Il(b,d,e){b=b|0;d=d|0;e=e|0;b=d;while(1){if((b|0)==(e|0))break;d=a[b>>0]|0;if(d<<24>>24>-1)d=c[35040+(d<<24>>24<<2)>>2]&255;a[b>>0]=d;b=b+1|0}return e|0}function Jl(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;if((a|0)==(c[b+8>>2]|0))wi(b,d,e);return}function Kl(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+64|0;Yh(a,c)|0;Yd(a+208|0,c,64,0)|0;Yh(a+208|0,b)|0;bl(c,64);i=c;return 0}function Ll(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+32|0;Uf(a,c)|0;oe(a+104|0,c,32,0)|0;Uf(a+104|0,b)|0;bl(c,32);i=c;return 0}function Ml(a,b){a=a|0;b=b|0;var d=0,e=0;c[a+104>>2]=b;d=c[a+8>>2]|0;e=c[a+4>>2]|0;c[a+108>>2]=d-e;if((b|0)!=0&(d-e|0)>(b|0))c[a+100>>2]=e+b;else c[a+100>>2]=d;return}function Nl(a){a=a|0;c[a>>2]=37720;Al(a+4|0);c[a+8>>2]=0;c[a+8+4>>2]=0;c[a+8+8>>2]=0;c[a+8+12>>2]=0;c[a+8+16>>2]=0;c[a+8+20>>2]=0;return}function Ol(a){a=a|0;c[a>>2]=37656;Al(a+4|0);c[a+8>>2]=0;c[a+8+4>>2]=0;c[a+8+8>>2]=0;c[a+8+12>>2]=0;c[a+8+16>>2]=0;c[a+8+20>>2]=0;return}function Pl(a,b){a=a|0;b=b|0;if(Hm(a,b)|0)return c[(c[a+8>>2]|0)+(b<<2)>>2]|0;else{a=db(4)|0;fu(a);sb(a|0,2008,121)}return 0}function Ql(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;while(1){if((c|0)==(d|0))break;b=a[c>>0]|0;a[f>>0]=b<<24>>24>-1?b:e;f=f+1|0;c=c+1|0}return d|0}function Rl(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;if(d>>>0>0|(d|0)==0&c>>>0>4294967279)c=-1;else c=Zj(a+16|0,a,b,c,d,e,f,g)|0;return c|0}function Sl(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;if(e>>>0>0|(e|0)==0&d>>>0>4294967295){c[(Sq()|0)>>2]=27;d=-1}else d=((Qs(a,b,d)|0)!=0)<<31>>31;return d|0}function Tl(){var a=0,b=0;a=i;b=i=i+63&-64;i=i+16|0;if(!(mb(54248,22)|0)){b=kb(c[13563]|0)|0;i=a;return b|0}else no(49490,b);return 0}function Ul(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if(d>>>0>0|(d|0)==0&c>>>0>4294967279)c=-1;else{se(a+16|0,a,b,c,d,e,f)|0;c=0}return c|0}function Vl(a){a=a|0;return (0-(a^62)|0)>>>8&43^43|(a+65510|0)>>>8&255&a+65|(0-(a^63)|0)>>>8&47^47|(a+65484|0)>>>8&a+71&((a+65510|0)>>>8&255^255)|(a+65474|0)>>>8&a+252&((a+65484|0)>>>8&255^255)|0}function Wl(a){a=a|0;var b=0;if((Ib[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1)a=-1;else{b=c[a+12>>2]|0;c[a+12>>2]=b+4;a=c[b>>2]|0}return a|0}function Xl(a){a=a|0;var b=0;if((Ib[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1)a=-1;else{b=c[a+12>>2]|0;c[a+12>>2]=b+1;a=d[b>>0]|0}return a|0}function Yl(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=0;while(1){if((b|0)==(d|0))break;e=(c[b>>2]|0)+(a<<4)|0;a=((e&-268435456)>>>24|e&-268435456)^e;b=b+4|0}return a|0}function Zl(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=0;while(1){if((c|0)==(d|0))break;e=(a[c>>0]|0)+(b<<4)|0;b=((e&-268435456)>>>24|e&-268435456)^e;c=c+1|0}return b|0}function _l(a){a=a|0;var b=0,d=0;b=i;d=i=i+63&-64;i=i+16|0;nc(a);if(!(qb(c[13563]|0,0)|0)){i=b;return}else no(49387,d)}function $l(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ua(7,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function am(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ua(6,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function bm(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ua(5,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function cm(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ua(4,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function dm(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ua(3,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function em(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ua(2,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function fm(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ua(1,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function gm(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ua(0,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function hm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;f=c[a+20>>2]|0;e=(c[a+16>>2]|0)-f|0;e=e>>>0>d>>>0?d:e;bi(f|0,b|0,e|0)|0;c[a+20>>2]=(c[a+20>>2]|0)+e;return d|0}function im(a,b){a=a|0;b=b|0;var d=0,e=0;e=Kh(b)|0;d=Rj(e+13|0)|0;c[d>>2]=e;c[d+4>>2]=e;c[d+8>>2]=0;bi(d+12|0,b|0,e+1|0)|0;c[a>>2]=d+12;return}function jm(a,b){a=a|0;b=b|0;ic(a,b,b+120|0);ic(a+40|0,b+40|0,b+80|0);ic(a+80|0,b+80|0,b+120|0);return}function km(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=-1;c[a+8+4>>2]=-1;return}function lm(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=i=i+63&-64;i=i+32|0;fn(d,32);Hi(a,b,d)|0;bl(d,32);i=c;return 0}function mm(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;V(9)}function nm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if(d|0){e=a;while(1){d=d+-1|0;c[e>>2]=c[b>>2];if(!d)break;else{b=b+4|0;e=e+4|0}}}return a|0}function om(a){a=a|0;var b=0;if(a>>>0<2)b=0;else{do b=_a(0)|0;while(b>>>0<(((0-a|0)>>>0)%(a>>>0)|0)>>>0);b=(b>>>0)%(a>>>0)|0}return b|0}function pm(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Vb[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function qm(a,b){a=a|0;b=b|0;b=ii(b)|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;ni(a,b,Kh(b)|0);return}function rm(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=i=i+63&-64;i=i+16|0;c[g>>2]=e;e=vg(a,b,d,g)|0;i=f;return e|0}function sm(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+(b<<2)>>2]=0;b=b+1|0}return}function tm(a,b,c){a=a|0;b=b|0;c=c|0;Ef(a,b,c&255);Ef(a+40|0,b+40|0,c&255);Ef(a+80|0,b+80|0,c&255);return}function um(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;e=d;do{if(!e){d=0;break}e=e+-1|0;d=b+e|0}while((a[d>>0]|0)!=(c&255)<<24>>24);return d|0}function vm(b,c){b=b|0;c=c|0;var d=0,e=0;d=0;e=0;do{d=(a[c+e>>0]^a[b+e>>0])&255|d;e=e+1|0}while((e|0)!=64);return ((d+511|0)>>>8&1)+-1|0}function wm(b,c){b=b|0;c=c|0;var d=0,e=0;d=0;e=0;do{d=(a[c+e>>0]^a[b+e>>0])&255|d;e=e+1|0}while((e|0)!=32);return ((d+511|0)>>>8&1)+-1|0}function xm(b,c){b=b|0;c=c|0;var d=0,e=0;d=0;e=0;do{d=(a[c+e>>0]^a[b+e>>0])&255|d;e=e+1|0}while((e|0)!=16);return ((d+511|0)>>>8&1)+-1|0}function ym(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+16|0;od(a,b,d,e,f|0)|0;i=f;return (D=c[f+4>>2]|0,c[f>>2]|0)|0}function zm(a){a=a|0;a=c[a+8>>2]|0;if(a){a=aq(a)|0;if(!a)a=4;else{aq(a)|0;a=4}}else a=1;return a|0}function Am(){var a=0,b=0;a=i;b=i=i+63&-64;i=i+16|0;if(!(Sa(54252,174)|0)){i=a;return}else no(49440,b)}function Bm(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=-1;c[a+8+4>>2]=-1;return}function Cm(b,d){b=b|0;d=d|0;c[b>>2]=41164;im(b+4|0,(a[d+11>>0]|0)<0?c[d>>2]|0:d);return}function Dm(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;vh(a,40756,$p(40756)|0);return}function Em(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;vh(a,40736,$p(40736)|0);return}function Fm(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[f>>2]=d;c[i>>2]=g;return 3}function Gm(a){a=a|0;var b=0,d=0;b=i;d=i=i+63&-64;i=i+16|0;c[d>>2]=c[a+60>>2];a=rr(ub(6,d|0)|0)|0;i=b;return a|0}function Hm(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;if((c[a+12>>2]|0)-d>>2>>>0>b>>>0)d=(c[d+(b<<2)>>2]|0)!=0;else d=0;return d|0}function Im(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;while(1){if((c|0)==(d|0))break;a[e>>0]=a[c>>0]|0;e=e+1|0;c=c+1|0}return d|0}function Jm(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Cb[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Km(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;while(1){if((d|0)==(e|0))break;c[f>>2]=a[d>>0];f=f+4|0;d=d+1|0}return e|0}function Lm(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ia(7,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Mm(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ia(6,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Nm(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ia(5,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Om(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ia(4,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Pm(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ia(3,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Qm(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ia(2,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Rm(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ia(1,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Sm(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ia(0,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Tm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if(d|0){e=a;while(1){d=d+-1|0;c[e>>2]=b;if(!d)break;else e=e+4|0}}return a|0}function Um(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;xh(a,1,45);return}function Vm(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;oi(a,1,45);return}function Wm(a){a=a|0;var b=0,d=0;d=i;b=i=i+63&-64;i=i+16|0;xr(b,c[a+28>>2]|0);i=d;return c[b>>2]|0}function Xm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=i=i+63&-64;i=i+16|0;c[f>>2]=d;d=Fj(a,b,f)|0;i=e;return d|0}function Ym(a){a=a|0;var b=0,d=0;d=(c[a>>2]|0)+-4|0;b=c[d>>2]|0;c[d>>2]=b+-1;if((b+-1|0)<0)$u((c[a>>2]|0)+-12|0);return}function Zm(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Nb[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function _m(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Mk(a,c)|0;f=D;return (D=(S(b,c)|0)+(S(d,a)|0)+f|f&0,e|0|0)|0}function $m(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;ni(a,49241,5);return}function an(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;ni(a,49236,4);return}function bn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Fd(c,d,e,1114111,0)|0}function cn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Id(c,d,e,1114111,0)|0}function dn(a,b,c){a=a|0;b=b|0;c=c|0;if(c>>>0<256)return ze(a,b,c&255)|0;else Wa(42169,42189,106,42407);return 0}function en(a){a=a|0;var b=0;b=c[a+4>>2]|0;c[a+4>>2]=b+-1;if(!b)Fb[c[(c[a>>2]|0)+8>>2]&255](a);return}function fn(b,c){b=b|0;c=c|0;var d=0;if(c|0){d=0;do{a[b+d>>0]=_a(0)|0;d=d+1|0}while((d|0)!=(c|0))}return}function gn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=S(c,b)|0;d=Zf(a,e,d)|0;if((d|0)!=(e|0))c=(d>>>0)/(b>>>0)|0;return c|0}function hn(a,b,d){a=a|0;b=b|0;d=d|0;Cf(a,c[d>>2]|0,c[d+4>>2]|0,b);c[a>>2]=37944;return}function jn(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return ve(a,b,c,d,e,f,g,h)|0}function kn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Hb[a&63](b|0,c|0,d|0,e|0,f|0,g|0)|0}function ln(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){D=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}D=(b|0)<0?-1:0;return b>>c-32|0}function mn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Le(a,b,c,d,e,f,g)|0}function nn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Y(7,a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function on(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Y(6,a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function pn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Y(5,a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function qn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Y(4,a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function rn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Y(3,a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function sn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Y(2,a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function tn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Y(1,a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function un(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Y(0,a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function vn(a){a=a|0;$g(a,50448,Uj(54100)|0);return}function wn(a){a=a|0;$g(a,50440,Uj(54092)|0);return}function xn(a){a=a|0;$g(a,50432,Uj(54084)|0);return}function yn(a){a=a|0;$g(a,50424,Uj(54076)|0);return}function zn(a){a=a|0;$g(a,50504,Uj(54036)|0);return}function An(a){a=a|0;$g(a,50488,Uj(54028)|0);return}function Bn(a){a=a|0;$g(a,50472,Uj(54020)|0);return}function Cn(a){a=a|0;$g(a,50456,Uj(53208)|0);return}function Dn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;return Eb[a&31](b|0,c|0,d|0,e|0,f|0,+g)|0}function En(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;V(7);return 0}function Fn(){var a=0;a=ib(30)|0;if((a|0)>0)c[12679]=a;else a=c[12679]|0;if(a>>>0<16)Ta();else{fn(54324,16);return}}function Gn(a){a=a|0;$g(a,50384,Uj(52396)|0);return}function Hn(a){a=a|0;$g(a,50376,Uj(52388)|0);return}function In(a){a=a|0;$g(a,50368,Uj(52380)|0);return}function Jn(a){a=a|0;$g(a,50360,Uj(52356)|0);return}function Kn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return hj(a,b,c,d,e,f,g)|0}function Ln(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return pe(a,b,c,d,e,f,g)|0}function Mn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;se(a,b,c,d,e,f,g)|0;return 0}function Nn(a,b){a=a|0;b=b|0;var d=0;if(b>>>0<=4294967168?(d=Af(b)|0,(d|0)!=0):0){c[a>>2]=d;d=0}else d=12;return d|0}function On(a,b){a=a|0;b=b|0;Mg(a,b,$p(b)|0);return}function Pn(a,b){a=a|0;b=b|0;Og(a,b,Kh(b)|0);return}function Qn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Mb[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function Rn(a){a=a|0;var b=0;c[a>>2]=40544;b=c[a+8>>2]|0;if((b|0)!=(zq()|0))$u(c[a+8>>2]|0);return}function Sn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sa(7,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Tn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sa(6,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Un(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sa(5,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Vn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sa(4,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Wn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sa(3,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Xn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sa(2,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Yn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sa(1,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Zn(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sa(0,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function _n(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){D=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}D=a<<c-32;return 0}function $n(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return xj(a,b,c,d,e,f,g)|0}function ao(a){a=a|0;var b=0;b=ec(a)|0;if(!b)return b|0;if(!(c[b+-4>>2]&3))return b|0;Yi(b|0,0,a|0)|0;return b|0}function bo(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){D=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}D=0;return b>>>c-32|0}function co(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Ii(a,b,c,d,e,f,g)|0}function eo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Sj(a,b,c,d,e,0,0,f)|0;return 0}function fo(a){a=a|0;var b=0;c[a>>2]=1;a=a+4|0;b=a+36|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(b|0));return}function go(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ((d-c|0)>>>0<e>>>0?d-c|0:e)|0}function ho(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Pg(a,b,c,d,e,f,g)|0}function io(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Vd(a,b,c,d,e,0,0,f)|0;return 0}function jo(a){a=a|0;c[a+16>>2]=c[a+16>>2]|1;if(!(c[a+20>>2]&1))return;else tb()}function ko(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Hf(a,b,1,c,d,e,16,f,g,0,0)|0}function lo(){}function mo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=b-d-(c>>>0>a>>>0|0)>>>0;return (D=d,a-c>>>0|0)|0}function no(a,b){a=a|0;b=b|0;var d=0;d=i=i+63&-64;i=i+16|0;c[d>>2]=b;Df(34076,a,d)|0;pi();Ta()}function oo(a,c,d){a=a|0;c=c|0;d=d|0;if(d>>>0<128)d=(b[41512+(d<<1)>>1]&c)<<16>>16!=0;else d=0;return d|0}function po(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Gh(a,b,c,d,e,f)|0}function qo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Qb[a&63](b|0,c|0,d|0,e|0,f|0)|0}function ro(a,b,d){a=a|0;b=b|0;d=d|0;return ((c[b>>2]|0)==(d|0)?(c[b+4>>2]|0)==(a|0):0)|0}function so(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return pe(a,b,c,d,e,0,f)|0}function to(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ga(7,a|0,b|0,c|0,d|0,e|0,f|0)|0}function uo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ga(6,a|0,b|0,c|0,d|0,e|0,f|0)|0}function vo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ga(5,a|0,b|0,c|0,d|0,e|0,f|0)|0}function wo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ga(4,a|0,b|0,c|0,d|0,e|0,f|0)|0}function xo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ga(3,a|0,b|0,c|0,d|0,e|0,f|0)|0}function yo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ga(2,a|0,b|0,c|0,d|0,e|0,f|0)|0}function zo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ga(1,a|0,b|0,c|0,d|0,e|0,f|0)|0}function Ao(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ga(0,a|0,b|0,c|0,d|0,e|0,f|0)|0}function Bo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return Wb[a&31](b|0,c|0,d|0,e|0,+f)|0}function Co(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Kf(a,b,c,d,e,f)|0;return 0}function Do(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return al(a,b,c,d,e)|0}function Eo(a){a=a|0;Ur(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function Fo(a){a=a|0;Vr(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function Go(){if((a[50704]|0)==0?sr(50704)|0:0){jp();c[13542]=54164}return c[13542]|0}function Ho(){if((a[50536]|0)==0?sr(50536)|0:0){Gs();c[13540]=54156}return c[13540]|0}function Io(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;V(12)}function Jo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Hf(a,b,1,c,d,e,16,0,32,f,128)|0}function Ko(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return aa(7,a|0,b|0,c|0,d|0,e|0,+f)|0}function Lo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return aa(6,a|0,b|0,c|0,d|0,e|0,+f)|0}function Mo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return aa(5,a|0,b|0,c|0,d|0,e|0,+f)|0}function No(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return aa(4,a|0,b|0,c|0,d|0,e|0,+f)|0}function Oo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return aa(3,a|0,b|0,c|0,d|0,e|0,+f)|0}function Po(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return aa(2,a|0,b|0,c|0,d|0,e|0,+f)|0}function Qo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return aa(1,a|0,b|0,c|0,d|0,e|0,+f)|0}function Ro(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return aa(0,a|0,b|0,c|0,d|0,e|0,+f)|0}function So(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ve(a,b,c,d,e,0,0,f)|0}function To(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Ri(a,b,c,d,e,f)|0}function Uo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Db[a&31](b|0,c|0,d|0,e|0,f|0)}function Vo(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eo(a,b,c,d,e,f)|0;return 0}function Wo(a){a=a|0;$g(a,50288,Uj(54140)|0);return}function Xo(a){a=a|0;$g(a,50296,Uj(54148)|0);return}function Yo(a){a=a|0;Xg(a,49384,2);return}function Zo(a){a=a|0;$g(a,50272,Uj(54132)|0);return}function _o(a){a=a|0;$g(a,50264,Uj(54124)|0);return}function $o(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qa(7,a|0,b|0,c|0,d|0,e|0,f|0)}function ap(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qa(6,a|0,b|0,c|0,d|0,e|0,f|0)}function bp(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qa(5,a|0,b|0,c|0,d|0,e|0,f|0)}function cp(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qa(4,a|0,b|0,c|0,d|0,e|0,f|0)}function dp(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qa(3,a|0,b|0,c|0,d|0,e|0,f|0)}function ep(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qa(2,a|0,b|0,c|0,d|0,e|0,f|0)}function fp(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qa(1,a|0,b|0,c|0,d|0,e|0,f|0)}function gp(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qa(0,a|0,b|0,c|0,d|0,e|0,f|0)}function hp(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return po(a,b,c,d,e,f)|0}function ip(a,b){a=a|0;b=b|0;c[a+4>>2]=b+-1;c[a>>2]=40544;c[a+8>>2]=zq()|0;return}function jp(){var a=0;a=c[(Ho()|0)>>2]|0;c[13541]=a;hs(a);return}function kp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return te(a,b,c,d,e)|0}function lp(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Eh(a,b,c,d,e,f)|0}function mp(a){a=a|0;$g(a,50416,Uj(54068)|0);return}function np(a){a=a|0;$g(a,50408,Uj(54060)|0);return}function op(a){a=a|0;$g(a,50400,Uj(54052)|0);return}function pp(a){a=a|0;$g(a,50392,Uj(54044)|0);return}function qp(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function rp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return He(a,b,c,d,e)|0}function sp(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function tp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Do(a,b,c,d,e)|0}function up(a){a=a|0;var b=0;b=c[a>>2]|0;if(b|0)nc(b);c[a+4>>2]=0;c[a>>2]=0;c[a+8>>2]=0;return}function vp(b){b=b|0;var d=0;c[b>>2]=40612;d=c[b+8>>2]|0;if(d|0?a[b+12>>0]|0:0)Xu(d);return}function wp(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return To(a,b,c,d,e,f)|0}function xp(a){a=a|0;$g(a,50328,Uj(52372)|0);return}function yp(a){a=a|0;$g(a,50304,Uj(52344)|0);return}function zp(a){a=a|0;$g(a,50528,Uj(54116)|0);return}function Ap(a){a=a|0;$g(a,50520,Uj(54108)|0);return}function Bp(a){a=a|0;$g(a,50232,Uj(52324)|0);return}function Cp(a){a=a|0;$g(a,50224,Uj(52316)|0);return}function Dp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Sb[a&31](b|0,c|0,d|0,e|0)|0}function Ep(){var a=0;if(!(c[12678]|0)){Bu();Fn();c[12678]=1;a=0}else a=1;return a|0}function Fp(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return sh(a,b,c,d,e,f)|0}function Gp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Oq(a,b,c,d)|0}function Hp(a){a=a|0;$g(a,50256,Uj(52364)|0);return}function Ip(a){a=a|0;$g(a,50240,Uj(52332)|0);return}function Jp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return (D=b+d+(a+c>>>0>>>0<a>>>0|0)>>>0,a+c>>>0|0)|0}function Kp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Jk(a,b,c,d,e)|0}function Lp(a){a=a|0;var b=0;b=c[a>>2]|0;if((b|0)!=(zq()|0))$u(c[a>>2]|0);return}function Mp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ya(7,a|0,b|0,c|0,d|0,e|0)|0}function Np(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ya(6,a|0,b|0,c|0,d|0,e|0)|0}function Op(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ya(5,a|0,b|0,c|0,d|0,e|0)|0}function Pp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ya(4,a|0,b|0,c|0,d|0,e|0)|0}function Qp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ya(3,a|0,b|0,c|0,d|0,e|0)|0}function Rp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ya(2,a|0,b|0,c|0,d|0,e|0)|0}function Sp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ya(1,a|0,b|0,c|0,d|0,e|0)|0}function Tp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ya(0,a|0,b|0,c|0,d|0,e|0)|0}function Up(a,b){a=a|0;b=b|0;dj(a,b+16|0);return}function Vp(a,b){a=a|0;b=b|0;dj(a,b+12|0);return}function Wp(a){a=a|0;Wj(a+(c[(c[a>>2]|0)+-12>>2]|0)+4|0);return}function Xp(a){a=a|0;Wj(a+(c[(c[a>>2]|0)+-12>>2]|0)+8|0);return}function Yp(a,b){a=a|0;b=b|0;if(b<<24>>24>-1)b=c[35040+(b<<24>>24<<2)>>2]&255;return b|0}function Zp(a){a=a|0;var b=0;b=a+40|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(b|0));return}function _p(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;mc(a,b,c,d,e)|0;return 0}function $p(a){a=a|0;var b=0;b=a;while(1)if(!(c[b>>2]|0))break;else b=b+4|0;return b-a>>2|0}function aq(a){a=a|0;var b=0,d=0;b=(Zv()|0)+180|0;d=c[b>>2]|0;if(a|0)c[b>>2]=a;return d|0}function bq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return rp(a,b,c,d,e)|0}function cq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;af(a,b,c,d);return 0}function dq(b){b=b|0;if((a[b+8+3>>0]|0)<0)$u(c[b>>2]|0);return}function eq(a,b,c){a=a|0;b=b|0;c=c|0;return -1}function fq(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;V(19);return 0}function gq(a,b){a=a|0;b=b|0;if(b<<24>>24>-1)b=c[36576+((b&255)<<2)>>2]&255;return b|0}function hq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ka(7,a|0,b|0,c|0,d|0,+e)|0}function iq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ka(6,a|0,b|0,c|0,d|0,+e)|0}function jq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ka(5,a|0,b|0,c|0,d|0,+e)|0}function kq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ka(4,a|0,b|0,c|0,d|0,+e)|0}function lq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ka(3,a|0,b|0,c|0,d|0,+e)|0}function mq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ka(2,a|0,b|0,c|0,d|0,+e)|0}function nq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ka(1,a|0,b|0,c|0,d|0,+e)|0}function oq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ka(0,a|0,b|0,c|0,d|0,+e)|0}function pq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Lq(a,b,c,d)|0;return 0}function qq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return qe(a,b,c,d,e)|0}function rq(b){b=b|0;if((a[b+11>>0]|0)<0)$u(c[b>>2]|0);return}function sq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Xb[a&31](b|0,c|0,d|0,e|0)}function tq(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;return}function uq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;cq(a,b,c,d)|0;return 0}function vq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_i(a,b,c,d,e)|0;return 0}function wq(a,b){a=a|0;b=b|0;return Pl(a,Uj(b)|0)|0}function xq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Zk(a,b,c,d,e)|0;return 0}function yq(a,b){a=a|0;b=b|0;fn(b,32);return Qr(a,b)|0}function zq(){if((a[50056]|0)==0?sr(50056)|0:0)c[13088]=Xj(47235,0)|0;return c[13088]|0}function Aq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_(7,a|0,b|0,c|0,d|0,e|0)}function Bq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_(6,a|0,b|0,c|0,d|0,e|0)}function Cq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_(5,a|0,b|0,c|0,d|0,e|0)}function Dq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_(4,a|0,b|0,c|0,d|0,e|0)}function Eq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_(3,a|0,b|0,c|0,d|0,e|0)}function Fq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_(2,a|0,b|0,c|0,d|0,e|0)}function Gq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_(1,a|0,b|0,c|0,d|0,e|0)}function Hq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_(0,a|0,b|0,c|0,d|0,e|0)}function Iq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Gp(a,b,c,d)|0}function Jq(a){a=a|0;c[a>>2]=40704;rq(a+16|0);return}function Kq(a){a=a|0;c[a>>2]=40664;rq(a+12|0);return}function Lq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Yd(a,b,c,d)|0;return 0}function Mq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;oe(a,b,c,d)|0;return 0}function Nq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Sl(a,b,c,d)|0}function Oq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ke(a,b,c,d);return 0}function Pq(a){a=a|0;if(a|0)Fb[c[(c[a>>2]|0)+4>>2]&255](a);return}function Qq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ye(a,b,c,d,e)|0}function Rq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ri(a,b,c,d)|0}function Sq(){var a=0;if(!(c[12680]|0))a=50764;else a=c[(Zv()|0)+64>>2]|0;return a|0}function Tq(a){a=a|0;c[a>>2]=37720;ts(a+4|0);$u(a);return}function Uq(a){a=a|0;c[a>>2]=37656;ts(a+4|0);$u(a);return}function Vq(a){a=a|0;Lp(a+8|0);$u(a);return}function Wq(a,b,c){a=a|0;b=b|0;c=c|0;return Pi(a,b,c)|0}function Xq(a,b){a=a|0;b=b|0;if(b>>>0<128)b=c[36576+(b<<2)>>2]|0;return b|0}function Yq(a,b){a=a|0;b=b|0;if(b>>>0<128)b=c[35040+(b<<2)>>2]|0;return b|0}function Zq(a,b){a=a|0;b=b|0;c[a>>2]=41164;im(a+4|0,b);return}function _q(a,b){a=a|0;b=b|0;c[a>>2]=41144;im(a+4|0,b);return}function $q(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Kb[a&63](b|0,c|0,d|0)|0}function ar(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;V(0);return 0}function br(a){a=a|0;var b=0;b=c[13085]|0;c[13085]=b+1;c[a+4>>2]=b+1;return}function cr(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)Xi(a,b,c)|0;return}function dr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ca(7,a|0,b|0,c|0,d|0)|0}function er(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ca(6,a|0,b|0,c|0,d|0)|0}function fr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ca(5,a|0,b|0,c|0,d|0)|0}function gr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ca(4,a|0,b|0,c|0,d|0)|0}function hr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ca(3,a|0,b|0,c|0,d|0)|0}function ir(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ca(2,a|0,b|0,c|0,d|0)|0}function jr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ca(1,a|0,b|0,c|0,d|0)|0}function kr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ca(0,a|0,b|0,c|0,d|0)|0}function lr(a,b,c){a=a|0;b=b|0;c=c|0;return Hk(a,b,c)|0}function mr(a,b,c){a=a|0;b=b|0;c=c|0;if(b|0)Tm(a,c,b)|0;return}function nr(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)nm(a,b,c)|0;return}function or(b,c){b=b|0;c=c|0;b=kg(b,c)|0;return ((a[b>>0]|0)==(c&255)<<24>>24?b:0)|0}function pr(a){a=a|0;if((a+-48|0)>>>0<10)a=1;else a=((a|32)+-97|0)>>>0<6;return a&1|0}function qr(a,b,c){a=a|0;b=b|0;c=c|0;xf(a,b,c)|0;return 0}function rr(a){a=a|0;if(a>>>0>4294963200){c[(Sq()|0)>>2]=0-a;a=-1}return a|0}function sr(b){b=b|0;if((a[b>>0]|0)==1)b=0;else{a[b>>0]=1;b=1}return b|0}function tr(a){a=a|0;c[a>>2]=37720;ts(a+4|0);return}function ur(a){a=a|0;c[a>>2]=37656;ts(a+4|0);return}function vr(a,b,c){a=a|0;b=b|0;c=c|0;Hi(a,b,c)|0;return 0}function wr(a){a=a|0;Lp(a+8|0);return}function xr(a,b){a=a|0;b=b|0;c[a>>2]=b;hs(b);return}function yr(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;V(11)}function zr(){var a=0;a=db(4)|0;eu(a);sb(a|0,1944,114)}function Ar(){if((a[50048]|0)==0?sr(50048)|0:0)c[12820]=37964;return}function Br(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Tb[a&31](b|0,c|0,d|0)}function Cr(a,b,c){a=a|0;b=b|0;c=c|0;return dn(a,b,c)|0}function Dr(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+15&-16;return b|0}function Er(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ji(a,b,c,d)|0;return 0}function Fr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ma(7,a|0,b|0,c|0,d|0)}function Gr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ma(6,a|0,b|0,c|0,d|0)}function Hr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ma(5,a|0,b|0,c|0,d|0)}function Ir(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ma(4,a|0,b|0,c|0,d|0)}function Jr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ma(3,a|0,b|0,c|0,d|0)}function Kr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ma(2,a|0,b|0,c|0,d|0)}function Lr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ma(1,a|0,b|0,c|0,d|0)}function Mr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ma(0,a|0,b|0,c|0,d|0)}function Nr(a,b){a=a|0;b=b|0;if(!a)a=0;else a=Wg(a,b)|0;return a|0}function Or(a,b,c){a=a|0;b=b|0;c=c|0;return (b>>>0<128?b&255:c)|0}function Pr(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;V(5);return 0}function Qr(a,b){a=a|0;b=b|0;return Dg(a,b)|0}function Rr(a,b){a=a|0;b=b|0;return Es(a,b)|0}function Sr(a,b,c){a=a|0;b=b|0;c=c|0;return (b<<24>>24>-1?b:c)|0}function Tr(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function Ur(a){a=a|0;Wj(a+4|0);$u(a);return}function Vr(a){a=a|0;Wj(a+8|0);$u(a);return}function Wr(a){a=a|0;tr(a);$u(a);return}function Xr(a){a=a|0;ur(a);$u(a);return}function Yr(a){a=a|0;c[a>>2]=41164;Ym(a+4|0);return}function Zr(a,b){a=a|0;b=b|0;return We(a,b)|0}function _r(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;V(2);return 0}function $r(a,b,c){a=a|0;b=b|0;c=c|0;a=si(a,b,c,0,-2147483648)|0;return a|0}function as(a){a=a|0;c[a>>2]=41144;Ym(a+4|0);return}function bs(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return od(a,b,c,d,0)|0}function cs(a,b,c){a=a|0;b=b|0;c=c|0;return Wk(a,b,c)|0}function ds(a){a=a|0;if(!a)a=1;else a=(c[a>>2]|0)==0;return a&1|0}function es(a){a=a|0;Rn(a);$u(a);return}function fs(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;V(10)}function gs(a,b){a=a|0;b=b|0;return yq(a,b)|0}function hs(a){a=a|0;c[a+4>>2]=(c[a+4>>2]|0)+1;return}function is(a,b,c){a=a|0;b=b|0;c=c|0;return Pb[a&63](b|0,c|0)|0}function js(a,b,c){a=a|0;b=b|0;c=c|0;a=si(a,b,c,-1,-1)|0;return a|0}function ks(a){a=a|0;c[a+4>>2]=0;c[a>>2]=0;c[a+8>>2]=0;return}function ls(a,b,c){a=a|0;b=b|0;c=c|0;return ma(7,a|0,b|0,c|0)|0}function ms(a,b,c){a=a|0;b=b|0;c=c|0;return ma(6,a|0,b|0,c|0)|0}function ns(a,b,c){a=a|0;b=b|0;c=c|0;return ma(5,a|0,b|0,c|0)|0}function os(a,b,c){a=a|0;b=b|0;c=c|0;return ma(4,a|0,b|0,c|0)|0}function ps(a,b,c){a=a|0;b=b|0;c=c|0;return ma(3,a|0,b|0,c|0)|0}function qs(a,b,c){a=a|0;b=b|0;c=c|0;return ma(2,a|0,b|0,c|0)|0}function rs(a,b,c){a=a|0;b=b|0;c=c|0;return ma(1,a|0,b|0,c|0)|0}function ss(a,b,c){a=a|0;b=b|0;c=c|0;return ma(0,a|0,b|0,c|0)|0}function ts(a){a=a|0;en(c[a>>2]|0);return}function us(a,b){a=a|0;b=b|0;return Rr(a,b)|0}function vs(a){a=a|0;Wj(a+4|0);return}function ws(a){a=a|0;Wj(a+8|0);return}function xs(a){a=a|0;return 2}function ys(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;V(14);return 0}function zs(a,b){a=a|0;b=b|0;Lk(a|0,b+32|0,32)|0;return 0}function As(a,b,c){a=a|0;b=b|0;c=c|0;return Pe(0,a,b,c|0?c:50780)|0}function Bs(a,b){a=a|0;b=b|0;return Qr(a,b)|0}function Cs(a,b){a=a|0;b=b|0;return Zr(a,b)|0}function Ds(a,b,c){a=a|0;b=b|0;c=c|0;a=js(a,b,c)|0;return a|0}function Es(a,b){a=a|0;b=b|0;$d(a,b);return 0}function Fs(a,b,c){a=a|0;b=b|0;c=c|0;sb(a|0,b|0,c|0)}function Gs(){Yc(50544,1);c[13539]=50544;return}function Hs(a,b){a=a|0;b=b|0;if(!o){o=a;p=b}}function Is(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;V(20);return 0}function Js(a,b){a=a|0;b=b|0;Lk(a|0,b|0,32)|0;return 0}function Ks(a){a=a|0;return de(a,0)|0}function Ls(a){a=a|0;return ce(a,0)|0}function Ms(){ie();rb(128,56412,n|0)|0;return}function Ns(a,b,c){a=a|0;b=b|0;c=c|0;Gb[a&127](b|0,c|0)}function Os(a,b,c){a=a|0;b=b|0;c=c|0;a=$r(a,b,c)|0;return a|0}function Ps(a,b){a=a|0;b=b|0;lm(a,b)|0;return 0}function Qs(a,b,c){a=a|0;b=b|0;c=c|0;return hf(a,b,c)|0}function Rs(a,b){a=a|0;b=b|0;return -1}function Ss(a){a=a|0;return de(a,1)|0}function Ts(a){a=a|0;return ce(a,1)|0}function Us(a,b,c){a=a|0;b=b|0;c=c|0;Ea(7,a|0,b|0,c|0)}function Vs(a,b,c){a=a|0;b=b|0;c=c|0;Ea(6,a|0,b|0,c|0)}function Ws(a,b,c){a=a|0;b=b|0;c=c|0;Ea(5,a|0,b|0,c|0)}function Xs(a,b,c){a=a|0;b=b|0;c=c|0;Ea(4,a|0,b|0,c|0)}function Ys(a,b,c){a=a|0;b=b|0;c=c|0;Ea(3,a|0,b|0,c|0)}function Zs(a,b,c){a=a|0;b=b|0;c=c|0;Ea(2,a|0,b|0,c|0)}function _s(a,b,c){a=a|0;b=b|0;c=c|0;Ea(1,a|0,b|0,c|0)}function $s(a,b,c){a=a|0;b=b|0;c=c|0;Ea(0,a|0,b|0,c|0)}function at(a){a=a|0;Jt(a);$u(a);return}function bt(){var a=0;a=c[13564]|0;c[13564]=a+0;return a|0}function ct(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;V(1)}function dt(a,b){a=a|0;b=b|0;return um(a,b,(Kh(a)|0)+1|0)|0}function et(a,b,c){a=a|0;b=b|0;c=c|0;return pk(a,b,c)|0}function ft(a){a=a|0;Ji(a);$u(a);return}function gt(a){a=a|0;Jq(a);$u(a);return}function ht(a){a=a|0;Kq(a);$u(a);return}function it(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;V(16);return 0}function jt(a){a=a|0;Yr(a);$u(a);return}function kt(a,b){a=a|0;b=b|0;return Ib[a&127](b|0)|0}function lt(a){a=a|0;jb(a|0)|0;$e()}function mt(a){a=a|0;return c[a+12>>2]|0}function nt(a,b){a=a|0;b=b|0;return b<<24>>24|0}function ot(a){a=a|0;Wj(a);$u(a);return}function pt(a){a=a|0;vp(a);$u(a);return}function qt(a){a=a|0;as(a);$u(a);return}function rt(a){a=a|0;return c[a+8>>2]|0}function st(a){a=a|0;Jt(a);return}function tt(b){b=b|0;return a[b+9>>0]|0}function ut(b){b=b|0;return a[b+8>>0]|0}function vt(a,b){a=a|0;b=b|0;bi(a|0,b|0,1024)|0;return}function wt(a){a=a|0;return -1}function xt(a,b){a=a|0;b=b|0;return wa(7,a|0,b|0)|0}function yt(a,b){a=a|0;b=b|0;return wa(6,a|0,b|0)|0}function zt(a,b){a=a|0;b=b|0;return wa(5,a|0,b|0)|0}function At(a,b){a=a|0;b=b|0;return wa(4,a|0,b|0)|0}function Bt(a,b){a=a|0;b=b|0;return wa(3,a|0,b|0)|0}function Ct(a,b){a=a|0;b=b|0;return wa(2,a|0,b|0)|0}function Dt(a,b){a=a|0;b=b|0;return wa(1,a|0,b|0)|0}function Et(a,b){a=a|0;b=b|0;return wa(0,a|0,b|0)|0}function Ft(a,b){a=a|0;b=b|0;i=a;j=b}function Gt(a){a=a|0;return 2147483647}function Ht(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;V(21)}function It(a){a=a|0;return Uu(a|0)|0}function Jt(a){a=a|0;Yr(a);return}function Kt(a){a=a|0;return ((a|0)==32|(a+-9|0)>>>0<5)&1|0}function Lt(a,b){a=a|0;b=b|0;Fb[a&255](b|0)}function Mt(a){a=a|0;return 4}function Nt(a,b){a=a|0;b=b|0;return b|0}function Ot(a){a=a|0;return 127}function Pt(a,b){a=a|0;b=b|0;ea(7,a|0,b|0)}function Qt(a,b){a=a|0;b=b|0;ea(6,a|0,b|0)}function Rt(a,b){a=a|0;b=b|0;ea(5,a|0,b|0)}function St(a,b){a=a|0;b=b|0;ea(4,a|0,b|0)}function Tt(a,b){a=a|0;b=b|0;ea(3,a|0,b|0)}function Ut(a,b){a=a|0;b=b|0;ea(2,a|0,b|0)}function Vt(a,b){a=a|0;b=b|0;ea(1,a|0,b|0)}function Wt(a,b){a=a|0;b=b|0;ea(0,a|0,b|0)}function Xt(a){a=a|0;return 1}function Yt(a,b){a=a|0;b=b|0;return}function Zt(a,b,c){a=a|0;b=b|0;c=c|0;V(8);return 0}function _t(a){a=a|0;return c[a+4>>2]|0}function $t(){return 1073741824}function au(){return 16777216}function bu(a,b){a=a|0;b=b|0;return +(+_h(a,b))}function cu(a){a=a|0;Yi(a|0,0,1024)|0;return}function du(){return 524288}function eu(a){a=a|0;c[a>>2]=41124;return}function fu(a){a=a|0;c[a>>2]=41204;return}function gu(a){a=a|0;return 46828}function hu(a,b){a=+a;b=+b;return +(+Kk(a,b))}function iu(a,b){a=+a;b=b|0;return +(+yh(a,b))}function ju(a,b,c){a=a|0;b=b|0;c=c|0;V(17)}function ku(a){a=a|0;return Rb[a&31]()|0}function lu(a,b){a=+a;b=b|0;return +(+Qh(a,b))}function mu(a){a=a|0;return (a+-48|0)>>>0<10|0}function nu(a){a=a|0;return ia(7,a|0)|0}function ou(a){a=a|0;return ia(6,a|0)|0}function pu(a){a=a|0;return ia(5,a|0)|0}function qu(a){a=a|0;return ia(4,a|0)|0}function ru(a){a=a|0;return ia(3,a|0)|0}function su(a){a=a|0;return ia(2,a|0)|0}function tu(a){a=a|0;return ia(1,a|0)|0}function uu(a){a=a|0;return ia(0,a|0)|0}function vu(a,b){a=+a;b=+b;return +(+sd(a,b))}function wu(a,b){a=a|0;b=b|0;V(13);return 0}function xu(){return 42775}function yu(){return _a(0)|0}function zu(){return 102}function Au(a){a=a|0;Ub[a&31]()}function Bu(){gb(1);return}function Cu(a){a=a|0;return 49917}function Du(a){a=a|0;return pr(a)|0}function Eu(a){a=a|0;return 49995}function Fu(){return 33554432}function Gu(){return 536870912}function Hu(){return 12}function Iu(){return 134217728}function Ju(a){a=a|0;ca(7,a|0)}function Ku(a){a=a|0;ca(6,a|0)}function Lu(a){a=a|0;ca(5,a|0)}function Mu(a){a=a|0;ca(4,a|0)}function Nu(a){a=a|0;ca(3,a|0)}function Ou(a){a=a|0;ca(2,a|0)}function Pu(a){a=a|0;ca(1,a|0)}function Qu(a){a=a|0;ca(0,a|0)}function Ru(a,b){a=a|0;b=b|0;V(4)}function Su(){return 42866}function Tu(){return 416}function Uu(a){a=a|0;return 0}function Vu(){return 4}function Wu(){fb()}function Xu(a){a=a|0;$u(a);return}function Yu(a){a=a|0;i=a}function Zu(){return 42639}function _u(){return 42051}function $u(a){a=a|0;nc(a);return}function av(a){a=a|0;D=a}function bv(){return 42779}function cv(){return 6}function dv(){return 256}function ev(){return 208}function fv(){return 104}function gv(){return 384}function hv(){return 42807}function iv(){return 42790}function jv(){tb()}function kv(a){a=a|0;V(6);return 0}function lv(){return 3}function mv(){return 9}function nv(a){a=a|0;return a|0}function ov(){return 42857}function pv(){return 42692}function qv(){return 42702}function rv(){return 43670}function sv(){return 42817}function tv(){return 1}function uv(){return 42440}function vv(a){a=a|0;return}function wv(){return}function xv(){return 128}function yv(){return 42024}function zv(){return Aa(7)|0}function Av(){return Aa(6)|0}function Bv(){return Aa(5)|0}function Cv(){return Aa(4)|0}function Dv(){return Aa(3)|0}function Ev(){return Aa(2)|0}function Fv(){return Aa(1)|0}function Gv(){return Aa(0)|0}function Hv(){return 8}function Iv(){return 24}function Jv(){return D|0}function Kv(){return 48}function Lv(){return 16}function Mv(){return i|0}function Nv(){return 64}function Ov(){return 32}function Pv(a){a=a|0;V(3)}function Qv(){V(15);return 0}function Rv(){Ga(7)}function Sv(){Ga(6)}function Tv(){Ga(5)}function Uv(){Ga(4)}function Vv(){Ga(3)}function Wv(){Ga(2)}function Xv(){Ga(1)}function Yv(){Ga(0)}function Zv(){return 0}function _v(){V(18)}

// EMSCRIPTEN_END_FUNCS
var Cb=[ar,un,tn,sn,rn,qn,pn,on,nn,ar,ar,ar,ar,ar,ar,ar,ar,ar,rg,xg,fd,rd,ed,pd,zc,xc,ar,ar,ar,ar,ar,ar];var Db=[ct,Hq,Gq,Fq,Eq,Dq,Cq,Bq,Aq,ct,ct,ct,ct,ct,ct,ct,ct,ct,Tg,Se,ud,ct,ct,ct,ct,ct,ct,ct,ct,ct,ct,ct];var Eb=[_r,Ro,Qo,Po,Oo,No,Mo,Lo,Ko,_r,_r,_r,_r,_r,_r,_r,_r,_r,_c,Xc,_r,_r,_r,_r,_r,_r,_r,_r,_r,_r,_r,_r];var Fb=[Pv,Qu,Pu,Ou,Nu,Mu,Lu,Ku,Ju,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Wj,ot,ur,Uq,tr,Tq,ws,Vr,Xp,Fo,ws,Vr,Xp,Fo,vs,Ur,Wp,Eo,vs,Ur,Wp,Eo,st,at,vv,Xu,Xr,Wr,Xr,Wr,vv,Xu,Pq,vv,Xu,vv,Xu,vv,Xu,vv,Xu,vv,Xu,vv,Xu,vv,Xu,wr,Vq,wr,Vq,vv,Xu,vv,Xu,vv,Xu,vv,Xu,vv,Xu,vv,Xu,vv,Xu,vv,Xu,vv,Xu,vv,Xu,vv,Xu,Xu,Rn,es,Ji,ft,vp,pt,Kq,ht,Jq,gt,Xu,Xu,Xu,Xu,Xu,Jt,jt,vv,Xu,vv,vv,Xu,vv,Xu,as,qt,Yr,jt,qt,vv,Xu,Xu,vv,vv,nl,jo,qj,Ke,Je,br,cg,Fe,Ge,rq,bg,Ee,De,dq,vv,ll,Qe,nc,fe,Cp,Bp,Ip,Hp,_o,Zo,Wo,Xo,yp,xp,Jn,In,Hn,Gn,pp,op,np,mp,yn,xn,wn,vn,Cn,Bn,An,zn,Ap,zp,Ck,_l,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv,Pv];var Gb=[Ru,Wt,Vt,Ut,Tt,St,Rt,Qt,Pt,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Yt,Yt,Vi,Ui,Uk,Tk,sm,sm,sm,Vm,qp,qp,sm,sm,sm,Vm,qp,qp,sm,sm,sm,Um,qp,qp,sm,sm,sm,Um,qp,qp,Yt,Yt,Vp,an,$m,Up,Em,Dm,ok,Nh,nk,di,Zq,ah,Yg,_q,Ih,Ej,qi,Cm,no,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru,Ru];var Hb=[Pr,Ao,zo,yo,xo,wo,vo,uo,to,Pr,Pr,Pr,Pr,Pr,Pr,Pr,Pr,Pr,Hd,zk,yk,uk,vk,vk,tk,jk,kk,kk,Ac,Gd,xk,wk,rk,sk,sk,qk,hk,ik,ik,vc,tf,sf,qf,pf,dk,Uh,oh,nh,uh,ck,Sh,mh,lh,th,jd,id,Te,Re,Pr,Pr,Pr,Pr,Pr,Pr];var Ib=[kv,uu,tu,su,ru,qu,pu,ou,nu,kv,kv,kv,kv,kv,kv,kv,kv,kv,Gm,Uu,Uu,wt,Xl,Uu,Uu,wt,Wl,_t,gu,Ls,Ts,Ks,Ss,jh,jh,xs,Be,Nd,dh,hl,gl,jl,kl,xs,Ae,Md,ch,Pk,Ok,Nk,Qk,Ot,Ot,Uu,Ot,Ot,Uu,Gt,Gt,Uu,Gt,Gt,Uu,Uu,Uu,Mt,Oj,Uu,zm,ut,tt,rt,mt,Xt,Xt,Xt,Uu,Uu,Mt,Cu,_t,Eu,It,It,It,Rj,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv,kv];var Jb=[En,yl,xl,wl,vl,ul,tl,sl,rl,En,En,En,En,En,En,En,En,En,dc,cc,En,En,En,En,En,En,En,En,En,En,En,En];var Kb=[Zt,ss,rs,qs,ps,os,ns,ms,ls,Zt,Zt,Zt,Zt,Zt,Zt,Zt,Zt,Zt,ue,$i,Ff,Bj,hm,Tr,xi,zh,Tr,Fi,Bh,Cj,ro,Ti,Si,Zl,Yl,eq,eq,Hl,Il,Sr,oo,dl,el,Or,Rg,et,Zt,Zt,Zt,Zt,Zt,Zt,Zt,Zt,Zt,Zt,Zt,Zt,Zt,Zt,Zt,Zt,Zt,Zt];var Lb=[mm,Nj,Mj,Lj,Kj,Jj,Ij,Hj,Gj,mm,mm,mm,mm,mm,mm,mm,mm,mm,bd,cd,mm,mm,mm,mm,mm,mm,mm,mm,mm,mm,mm,mm];var Mb=[fs,gp,fp,ep,dp,cp,bp,ap,$o,fs,fs,fs,fs,fs,fs,fs,fs,fs,km,km,xe,vd,Sk,Zi,lf,fs,fs,fs,fs,fs,fs,fs];var Nb=[yr,Zn,Yn,Xn,Wn,Vn,Un,Tn,Sn,yr,yr,yr,yr,yr,yr,yr,yr,yr,ld,Dc,md,Ec,yr,yr,yr,yr,yr,yr,yr,yr,yr,yr];var Ob=[Io,gm,fm,em,dm,cm,bm,am,$l,Io,Io,Io,Io,Io,Io,Io,Io,Io,uc,tc,qc,rc,Io,Io,Io,Io,Io,Io,Io,Io,Io,Io];var Pb=[wu,Et,Dt,Ct,Bt,At,zt,yt,xt,wu,wu,wu,wu,wu,wu,wu,wu,wu,Rs,Rs,Rs,Rs,jf,gf,df,cf,gq,Yp,Nt,Xq,Yq,nt,wq,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu,wu];var Qb=[ys,Tp,Sp,Rp,Qp,Pp,Op,Np,Mp,ys,ys,ys,ys,ys,ys,ys,ys,ys,ui,Ei,Ud,Ze,Ye,_e,Xd,Ve,Xe,Ue,sp,cn,Jg,Xh,Ql,Vk,sp,go,sp,bn,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys,ys];var Rb=[Qv,Gv,Fv,Ev,Dv,Cv,Bv,Av,zv,Qv,Qv,Qv,Qv,Qv,Qv,Qv,Qv,Qv,Go,Tl,Qv,Qv,Qv,Qv,Qv,Qv,Qv,Qv,Qv,Qv,Qv,Qv];var Sb=[it,kr,jr,ir,hr,gr,fr,er,dr,it,it,it,it,it,it,it,it,it,Im,bk,Fl,cl,Km,Fk,it,it,it,it,it,it,it,it];var Tb=[ju,$s,_s,Zs,Ys,Xs,Ws,Vs,Us,ju,ju,ju,ju,ju,ju,ju,ju,ju,tq,ml,hn,sg,qg,Tf,qg,Sf,ni,Fs,Xg,nf,ju,ju];var Ub=[_v,Yv,Xv,Wv,Vv,Uv,Tv,Sv,Rv,_v,_v,_v,_v,_v,_v,_v,_v,_v,_f,Wu,zr,jv,Am,_v,_v,_v,_v,_v,_v,_v,_v,_v];var Vb=[fq,Sm,Rm,Qm,Pm,Om,Nm,Mm,Lm,fq,fq,fq,fq,fq,fq,fq,fq,fq,Gc,Fc,Ci,Di,_d,Od,Fm,Fm,Ai,Bi,fq,fq,fq,fq];var Wb=[Is,oq,nq,mq,lq,kq,jq,iq,hq,Is,Is,Is,Is,Is,Is,Is,Is,Is,Cd,Bd,Ad,zd,Is,Is,Is,Is,Is,Is,Is,Is,Is,Is];var Xb=[Ht,Mr,Lr,Kr,Jr,Ir,Hr,Gr,Fr,Ht,Ht,Ht,Ht,Ht,Ht,Ht,Ht,Ht,Bm,Bm,ql,pl,Jl,Pj,Qg,Ht,Ht,Ht,Ht,Ht,Ht,Ht];return{_crypto_onetimeauth_poly1305_init:Zr,_crypto_hash_sha512_init:Gl,_crypto_hash_primitive:uv,_crypto_onetimeauth_bytes:Lv,_crypto_box_open:Kn,_crypto_stream_chacha20_ietf_noncebytes:Hu,_crypto_stream_salsa20_xor:io,_randombytes_buf:fn,_crypto_auth_hmacsha512_verify:Xk,_crypto_generichash_blake2b_keybytes_min:Lv,_crypto_sign_open:lp,_crypto_pwhash_scryptsalsa208sha256_memlimit_sensitive:$t,_crypto_sign_ed25519_keypair:lm,_crypto_scalarmult_curve25519_base:Qr,_crypto_stream_salsa20:Me,_crypto_sign_ed25519_open:Eh,_sodium_init:Ep,_crypto_pwhash_scryptsalsa208sha256:kh,_crypto_scalarmult_primitive:bv,_crypto_box_noncebytes:Iv,_crypto_aead_chacha20poly1305_ietf_keybytes:Ov,_crypto_aead_chacha20poly1305_ietf_encrypt_detached:Lf,_crypto_scalarmult_base:Bs,_crypto_aead_chacha20poly1305_abytes:Lv,_crypto_auth_bytes:Ov,_crypto_pwhash_opslimit_sensitive:Hv,_crypto_pwhash_strbytes:xv,_crypto_auth_hmacsha512256_update:pq,_memcpy:bi,_crypto_onetimeauth_poly1305:rp,_crypto_sign_secretkeybytes:Nv,_crypto_generichash_primitive:_u,_crypto_auth_hmacsha512256:_i,_crypto_box_seed_keypair:Wq,_crypto_auth_hmacsha512_init:xf,_crypto_generichash_blake2b_keybytes_max:Nv,_crypto_box_curve25519xsalsa20poly1305_macbytes:Lv,_bitshift64Lshr:bo,_crypto_pwhash_scryptsalsa208sha256_memlimit_interactive:au,_crypto_sign_ed25519_sk_to_pk:zs,_crypto_verify_16_bytes:Lv,_crypto_stream_xsalsa20:Zk,_crypto_scalarmult_curve25519:Wk,_crypto_box_open_easy_afternm:il,_crypto_auth_hmacsha512:Dl,_crypto_stream_chacha20_ietf_xor_ic:Ln,_pthread_cond_broadcast:Uu,_crypto_hash:Er,_crypto_box_curve25519xsalsa20poly1305_seedbytes:Ov,_crypto_box_zerobytes:Ov,_crypto_stream_salsa20_keybytes:Ov,_crypto_auth_hmacsha512256_keybytes:Ov,_crypto_aead_chacha20poly1305_keybytes:Ov,_crypto_hash_sha512_bytes:Nv,_crypto_verify_32:wm,_crypto_generichash_blake2b_final:dn,_crypto_generichash_blake2b_init_salt_personal:Rh,_crypto_box_seal:Lh,_crypto_core_hsalsa20_outputbytes:Ov,_free:nc,_crypto_sign_ed25519_publickeybytes:Ov,_crypto_core_hsalsa20_keybytes:Ov,_crypto_sign_primitive:sv,_crypto_scalarmult_curve25519_bytes:Ov,_crypto_auth_keybytes:Ov,_crypto_box:$n,_crypto_stream_xsalsa20_noncebytes:Iv,_crypto_onetimeauth_poly1305_keybytes:Ov,_crypto_box_beforenm:lr,_crypto_box_curve25519xsalsa20poly1305_open_afternm:po,_crypto_pwhash_scryptsalsa208sha256_saltbytes:Ov,_crypto_aead_chacha20poly1305_npubbytes:Hv,_crypto_stream_primitive:ov,_crypto_pwhash_argon2i_str_verify:Sl,_crypto_pwhash_memlimit_sensitive:Gu,_crypto_shorthash:_p,_crypto_onetimeauth_poly1305_bytes:Lv,_crypto_secretbox_detached:se,_crypto_box_curve25519xsalsa20poly1305_seed_keypair:Pi,_crypto_box_primitive:yv,_crypto_pwhash_str:ho,_crypto_box_detached_afternm:Mn,_crypto_stream_salsa20_xor_ic:Vd,_crypto_secretbox_xsalsa20poly1305_boxzerobytes:Lv,_crypto_core_salsa20_constbytes:Lv,_crypto_auth_hmacsha512_keybytes:Ov,_crypto_auth:vq,_crypto_auth_hmacsha512256_final:zl,_randombytes_random:yu,_crypto_stream_chacha20_keybytes:Ov,_crypto_pwhash_str_verify:Nq,_crypto_sign_keypair:Ps,_crypto_auth_hmacsha256_statebytes:ev,_crypto_generichash_keybytes_min:Lv,_crypto_generichash_statebytes:gv,_randombytes:Bl,_crypto_aead_chacha20poly1305_encrypt_detached:lg,_randombytes_implementation_name:Su,_crypto_core_salsa20_keybytes:Ov,_sodium_library_version_major:mv,_crypto_hash_sha256_statebytes:fv,_crypto_pwhash_strprefix:pv,_crypto_box_afternm:wp,_crypto_secretbox_primitive:iv,_i64Add:Jp,_malloc:ec,_crypto_scalarmult_curve25519_scalarbytes:Ov,_crypto_box_curve25519xsalsa20poly1305_keypair:yq,_crypto_hash_sha256_init:fk,_crypto_sign_ed25519_detached:Kf,_crypto_pwhash_scryptsalsa208sha256_str_verify:Ph,_crypto_generichash_init:Rq,_crypto_generichash_keybytes_max:Nv,_crypto_sign_ed25519_pk_to_curve25519:Ah,_crypto_stream_chacha20_ietf_xor:so,_crypto_verify_64:vm,_crypto_sign_publickeybytes:Ov,_crypto_shorthash_siphash24:mc,_crypto_box_beforenmbytes:Ov,_crypto_stream_chacha20_ietf:qq,_crypto_generichash:co,_crypto_sign_ed25519:sh,_crypto_box_curve25519xsalsa20poly1305_open:hj,_crypto_pwhash_opslimit_interactive:Vu,_sodium_hex2bin:kf,_crypto_onetimeauth_poly1305_final:Rr,_crypto_auth_hmacsha256_init:zf,_crypto_aead_chacha20poly1305_ietf_encrypt:zi,_crypto_aead_chacha20poly1305_ietf_nsecbytes:Zv,_crypto_box_curve25519xsalsa20poly1305_noncebytes:Iv,_crypto_secretbox:To,_crypto_box_boxzerobytes:Lv,_crypto_pwhash_argon2i_saltbytes:Lv,_crypto_hash_sha512_update:Yd,_crypto_onetimeauth_poly1305_verify:Do,_crypto_box_curve25519xsalsa20poly1305_beforenmbytes:Ov,_crypto_generichash_blake2b_init:ri,_crypto_aead_chacha20poly1305_ietf_decrypt:Th,_crypto_auth_hmacsha512256_init:qr,_crypto_pwhash_primitive:qv,_crypto_onetimeauth_keybytes:Ov,_crypto_pwhash_argon2i:gh,_crypto_auth_hmacsha512_final:Kl,_crypto_sign_ed25519_seedbytes:Ov,_crypto_auth_hmacsha512256_verify:Jk,_crypto_auth_hmacsha256_final:Ll,_crypto_box_secretkeybytes:Ov,_crypto_verify_16:xm,_crypto_stream_chacha20_noncebytes:Hv,_crypto_onetimeauth_update:Iq,_crypto_aead_chacha20poly1305_encrypt:Gi,_crypto_core_salsa20:yc,_pthread_mutex_lock:Uu,_crypto_pwhash_scryptsalsa208sha256_ll:pj,_crypto_box_detached:Zj,_crypto_stream_xsalsa20_xor:eo,_crypto_sign_seedbytes:Ov,_memset:Yi,_crypto_pwhash_scryptsalsa208sha256_str:ag,_crypto_generichash_blake2b_saltbytes:Lv,_bitshift64Ashr:ln,_bitshift64Shl:_n,_sodium_version_string:rv,_crypto_box_open_detached:Yj,_crypto_scalarmult_bytes:Ov,_crypto_secretbox_xsalsa20poly1305:Ri,_crypto_pwhash:gk,_crypto_auth_verify:Kp,_crypto_sign_ed25519_seed_keypair:Hi,_crypto_secretbox_xsalsa20poly1305_zerobytes:Ov,_crypto_onetimeauth_poly1305_update:Gp,_crypto_sign_detached:Co,_crypto_verify_32_bytes:Ov,_crypto_box_curve25519xsalsa20poly1305_zerobytes:Ov,_crypto_generichash_blake2b_keybytes:Ov,_crypto_sign_ed25519_secretkeybytes:Nv,_crypto_stream_xor:Vo,_crypto_stream_xsalsa20_xor_ic:Sj,_crypto_verify_64_bytes:Nv,_randombytes_stir:Bu,_crypto_secretbox_easy:Ul,_crypto_pwhash_argon2i_strprefix:pv,_crypto_auth_hmacsha256_update:Mq,_crypto_pwhash_scryptsalsa208sha256_strbytes:zu,_crypto_stream_chacha20:Qq,_crypto_stream_xsalsa20_keybytes:Ov,_crypto_sign:Fp,_crypto_pwhash_argon2i_str:Pg,_crypto_box_open_detached_afternm:mn,_crypto_pwhash_argon2i_memlimit_sensitive:Gu,_crypto_box_sealbytes:Kv,_crypto_onetimeauth:bq,_crypto_auth_hmacsha512_statebytes:Tu,_crypto_secretbox_boxzerobytes:Lv,_i64Subtract:mo,_crypto_pwhash_alg_default:tv,_crypto_pwhash_scryptsalsa208sha256_strprefix:xu,_crypto_onetimeauth_primitive:Zu,_crypto_box_seedbytes:Ov,_crypto_hash_sha256_update:oe,_crypto_core_hsalsa20_constbytes:Lv,_crypto_box_curve25519xsalsa20poly1305:xj,_crypto_generichash_blake2b_statebytes:gv,_crypto_box_curve25519xsalsa20poly1305_boxzerobytes:Lv,_crypto_generichash_blake2b_bytes_min:Lv,_crypto_pwhash_opslimit_moderate:cv,_crypto_secretbox_open:po,_crypto_hash_sha256_bytes:Ov,_crypto_core_salsa20_inputbytes:Lv,_crypto_box_macbytes:Lv,_crypto_shorthash_bytes:Hv,_crypto_box_publickeybytes:Ov,___udivdi3:bs,_crypto_aead_chacha20poly1305_decrypt_detached:Nf,_crypto_auth_hmacsha256_verify:Yk,_crypto_pwhash_argon2i_strbytes:xv,___muldsi3:Mk,_sodium_library_version_minor:lv,_crypto_scalarmult_scalarbytes:Ov,_crypto_onetimeauth_statebytes:dv,_crypto_auth_hmacsha256_bytes:Ov,_crypto_sign_seed_keypair:vr,_crypto_pwhash_argon2i_opslimit_interactive:Vu,_crypto_stream_salsa20_noncebytes:Hv,_crypto_shorthash_keybytes:Lv,___udivmoddi4:od,_crypto_box_curve25519xsalsa20poly1305_afternm:To,_crypto_stream_noncebytes:Iv,_crypto_aead_chacha20poly1305_decrypt:Vh,_sodium_bin2hex:hi,_crypto_secretbox_open_easy:il,_crypto_aead_chacha20poly1305_ietf_decrypt_detached:ff,_crypto_pwhash_memlimit_interactive:Fu,_crypto_hash_sha512_final:Yh,_crypto_generichash_final:Cr,_crypto_secretbox_xsalsa20poly1305_keybytes:Ov,_crypto_auth_hmacsha512_update:Lq,_crypto_pwhash_saltbytes:Lv,_crypto_auth_hmacsha256:El,_pthread_self:Zv,_crypto_secretbox_noncebytes:Iv,_crypto_box_keypair:gs,_crypto_secretbox_xsalsa20poly1305_macbytes:Lv,_crypto_box_open_afternm:hp,_crypto_auth_hmacsha512_bytes:Nv,_crypto_generichash_keybytes:Ov,_crypto_hash_bytes:Nv,_crypto_generichash_bytes_min:Lv,_crypto_pwhash_argon2i_alg_argon2i13:tv,_crypto_secretbox_macbytes:Lv,_crypto_secretbox_keybytes:Ov,_crypto_auth_hmacsha256_keybytes:Ov,_crypto_pwhash_argon2i_opslimit_sensitive:Hv,_crypto_aead_chacha20poly1305_ietf_abytes:Lv,_randombytes_close:Zv,_crypto_pwhash_argon2i_memlimit_moderate:Iu,_crypto_generichash_blake2b_bytes_max:Nv,_crypto_generichash_blake2b:Ii,_crypto_generichash_bytes:Ov,_crypto_generichash_bytes_max:Nv,_crypto_secretbox_open_detached:Le,_crypto_sign_ed25519_sk_to_seed:Js,_crypto_sign_ed25519_sk_to_curve25519:Qi,_crypto_core_salsa20_outputbytes:Nv,_crypto_box_easy_afternm:Ul,___muldi3:_m,_crypto_generichash_blake2b_personalbytes:Lv,_crypto_stream_chacha20_xor_ic:jn,___uremdi3:ym,_crypto_sign_verify_detached:kp,_crypto_pwhash_argon2i_opslimit_moderate:cv,_crypto_onetimeauth_verify:tp,_crypto_box_open_easy:$k,_crypto_stream:xq,_crypto_pwhash_scryptsalsa208sha256_opslimit_sensitive:Fu,_crypto_box_curve25519xsalsa20poly1305_secretkeybytes:Ov,_crypto_aead_chacha20poly1305_nsecbytes:Zv,_crypto_hash_sha512_statebytes:ev,_crypto_sign_bytes:Nv,_crypto_secretbox_zerobytes:Ov,_crypto_generichash_update:uq,_pthread_mutex_unlock:Uu,_crypto_scalarmult:cs,_crypto_shorthash_primitive:hv,_crypto_hash_sha512:ji,_llvm_cttz_i32:ol,_crypto_stream_chacha20_xor:So,_crypto_box_seal_open:aj,_crypto_box_easy:Rl,_crypto_sign_ed25519_verify_detached:te,_memmove:Lk,_crypto_sign_ed25519_bytes:Nv,_crypto_generichash_blake2b_update:cq,_crypto_hash_sha256:Wh,_crypto_box_curve25519xsalsa20poly1305_beforenm:Hk,_crypto_pwhash_alg_argon2i13:tv,_crypto_core_hsalsa20_inputbytes:Lv,_crypto_onetimeauth_final:us,_crypto_generichash_blake2b_bytes:Ov,_crypto_auth_hmacsha512256_bytes:Ov,_crypto_generichash_blake2b_salt_personal:ci,_randombytes_uniform:om,_crypto_shorthash_siphash24_bytes:Hv,_crypto_auth_hmacsha512256_statebytes:Tu,_crypto_shorthash_siphash24_keybytes:Lv,_crypto_secretbox_xsalsa20poly1305_noncebytes:Iv,_crypto_pwhash_scryptsalsa208sha256_opslimit_interactive:du,_crypto_core_hsalsa20:ad,_crypto_pwhash_argon2i_memlimit_interactive:Fu,_crypto_hash_sha256_final:Uf,_crypto_secretbox_xsalsa20poly1305_open:Gh,_crypto_stream_keybytes:Ov,_crypto_box_curve25519xsalsa20poly1305_publickeybytes:Ov,_crypto_onetimeauth_init:Cs,_crypto_aead_chacha20poly1305_ietf_npubbytes:Hu,_crypto_pwhash_memlimit_moderate:Iu,__GLOBAL__I_000101:Ms,__GLOBAL__sub_I_iostream_cpp:wv,runPostSets:lo,stackAlloc:Dr,stackSave:Mv,stackRestore:Yu,establishStackSpace:Ft,setThrew:Hs,setTempRet0:av,getTempRet0:Jv,dynCall_iiiiiiii:Jm,dynCall_viiiii:Uo,dynCall_iiiiiid:Dn,dynCall_vi:Lt,dynCall_vii:Ns,dynCall_iiiiiii:kn,dynCall_ii:kt,dynCall_iiiiiiiiiiii:Gk,dynCall_iiii:$q,dynCall_viiiiiiiiiiiiiii:bj,dynCall_viiiiii:Qn,dynCall_viiiiiii:Zm,dynCall_viiiiiiiiii:Cl,dynCall_iii:is,dynCall_iiiiii:qo,dynCall_i:ku,dynCall_iiiii:Dp,dynCall_viii:Br,dynCall_v:Au,dynCall_iiiiiiiii:pm,dynCall_iiiiid:Bo,dynCall_viiii:sq}})


// EMSCRIPTEN_END_ASM
(Module.asmGlobalArg,Module.asmLibraryArg,buffer);var _crypto_onetimeauth_poly1305_init=Module["_crypto_onetimeauth_poly1305_init"]=asm["_crypto_onetimeauth_poly1305_init"];var _crypto_hash_sha512_init=Module["_crypto_hash_sha512_init"]=asm["_crypto_hash_sha512_init"];var _crypto_stream_xsalsa20_noncebytes=Module["_crypto_stream_xsalsa20_noncebytes"]=asm["_crypto_stream_xsalsa20_noncebytes"];var _crypto_auth_hmacsha256_verify=Module["_crypto_auth_hmacsha256_verify"]=asm["_crypto_auth_hmacsha256_verify"];var __GLOBAL__sub_I_iostream_cpp=Module["__GLOBAL__sub_I_iostream_cpp"]=asm["__GLOBAL__sub_I_iostream_cpp"];var _crypto_generichash_blake2b_update=Module["_crypto_generichash_blake2b_update"]=asm["_crypto_generichash_blake2b_update"];var _crypto_onetimeauth_bytes=Module["_crypto_onetimeauth_bytes"]=asm["_crypto_onetimeauth_bytes"];var _crypto_shorthash_primitive=Module["_crypto_shorthash_primitive"]=asm["_crypto_shorthash_primitive"];var _crypto_box_open=Module["_crypto_box_open"]=asm["_crypto_box_open"];var _crypto_stream_chacha20_ietf_noncebytes=Module["_crypto_stream_chacha20_ietf_noncebytes"]=asm["_crypto_stream_chacha20_ietf_noncebytes"];var _crypto_stream_salsa20_xor=Module["_crypto_stream_salsa20_xor"]=asm["_crypto_stream_salsa20_xor"];var _crypto_auth_hmacsha512_verify=Module["_crypto_auth_hmacsha512_verify"]=asm["_crypto_auth_hmacsha512_verify"];var _crypto_generichash_blake2b_keybytes_min=Module["_crypto_generichash_blake2b_keybytes_min"]=asm["_crypto_generichash_blake2b_keybytes_min"];var _crypto_generichash_blake2b_bytes=Module["_crypto_generichash_blake2b_bytes"]=asm["_crypto_generichash_blake2b_bytes"];var _crypto_pwhash_saltbytes=Module["_crypto_pwhash_saltbytes"]=asm["_crypto_pwhash_saltbytes"];var _crypto_pwhash_scryptsalsa208sha256_memlimit_sensitive=Module["_crypto_pwhash_scryptsalsa208sha256_memlimit_sensitive"]=asm["_crypto_pwhash_scryptsalsa208sha256_memlimit_sensitive"];var _crypto_generichash_keybytes=Module["_crypto_generichash_keybytes"]=asm["_crypto_generichash_keybytes"];var _crypto_scalarmult_curve25519_base=Module["_crypto_scalarmult_curve25519_base"]=asm["_crypto_scalarmult_curve25519_base"];var _bitshift64Lshr=Module["_bitshift64Lshr"]=asm["_bitshift64Lshr"];var _sodium_bin2hex=Module["_sodium_bin2hex"]=asm["_sodium_bin2hex"];var _crypto_pwhash_scryptsalsa208sha256=Module["_crypto_pwhash_scryptsalsa208sha256"]=asm["_crypto_pwhash_scryptsalsa208sha256"];var _crypto_scalarmult_primitive=Module["_crypto_scalarmult_primitive"]=asm["_crypto_scalarmult_primitive"];var _crypto_secretbox_xsalsa20poly1305_open=Module["_crypto_secretbox_xsalsa20poly1305_open"]=asm["_crypto_secretbox_xsalsa20poly1305_open"];var _crypto_box_noncebytes=Module["_crypto_box_noncebytes"]=asm["_crypto_box_noncebytes"];var _crypto_aead_chacha20poly1305_ietf_keybytes=Module["_crypto_aead_chacha20poly1305_ietf_keybytes"]=asm["_crypto_aead_chacha20poly1305_ietf_keybytes"];var _crypto_aead_chacha20poly1305_ietf_encrypt_detached=Module["_crypto_aead_chacha20poly1305_ietf_encrypt_detached"]=asm["_crypto_aead_chacha20poly1305_ietf_encrypt_detached"];var _crypto_scalarmult_base=Module["_crypto_scalarmult_base"]=asm["_crypto_scalarmult_base"];var _crypto_aead_chacha20poly1305_abytes=Module["_crypto_aead_chacha20poly1305_abytes"]=asm["_crypto_aead_chacha20poly1305_abytes"];var _crypto_auth_bytes=Module["_crypto_auth_bytes"]=asm["_crypto_auth_bytes"];var _crypto_onetimeauth=Module["_crypto_onetimeauth"]=asm["_crypto_onetimeauth"];var _crypto_stream_chacha20_keybytes=Module["_crypto_stream_chacha20_keybytes"]=asm["_crypto_stream_chacha20_keybytes"];var _crypto_sign_open=Module["_crypto_sign_open"]=asm["_crypto_sign_open"];var _crypto_auth_hmacsha512256_update=Module["_crypto_auth_hmacsha512256_update"]=asm["_crypto_auth_hmacsha512256_update"];var _memcpy=Module["_memcpy"]=asm["_memcpy"];var _crypto_onetimeauth_poly1305=Module["_crypto_onetimeauth_poly1305"]=asm["_crypto_onetimeauth_poly1305"];var _crypto_sign_ed25519_keypair=Module["_crypto_sign_ed25519_keypair"]=asm["_crypto_sign_ed25519_keypair"];var _crypto_pwhash=Module["_crypto_pwhash"]=asm["_crypto_pwhash"];var _crypto_auth_hmacsha512256=Module["_crypto_auth_hmacsha512256"]=asm["_crypto_auth_hmacsha512256"];var _crypto_shorthash_siphash24_keybytes=Module["_crypto_shorthash_siphash24_keybytes"]=asm["_crypto_shorthash_siphash24_keybytes"];var _crypto_box_seed_keypair=Module["_crypto_box_seed_keypair"]=asm["_crypto_box_seed_keypair"];var _crypto_auth_hmacsha512_init=Module["_crypto_auth_hmacsha512_init"]=asm["_crypto_auth_hmacsha512_init"];var _crypto_generichash_blake2b_keybytes_max=Module["_crypto_generichash_blake2b_keybytes_max"]=asm["_crypto_generichash_blake2b_keybytes_max"];var _crypto_box_beforenmbytes=Module["_crypto_box_beforenmbytes"]=asm["_crypto_box_beforenmbytes"];var _crypto_pwhash_scryptsalsa208sha256_memlimit_interactive=Module["_crypto_pwhash_scryptsalsa208sha256_memlimit_interactive"]=asm["_crypto_pwhash_scryptsalsa208sha256_memlimit_interactive"];var _crypto_sign_ed25519_sk_to_pk=Module["_crypto_sign_ed25519_sk_to_pk"]=asm["_crypto_sign_ed25519_sk_to_pk"];var _crypto_auth_hmacsha512_update=Module["_crypto_auth_hmacsha512_update"]=asm["_crypto_auth_hmacsha512_update"];var ___udivmoddi4=Module["___udivmoddi4"]=asm["___udivmoddi4"];var _crypto_stream_xsalsa20=Module["_crypto_stream_xsalsa20"]=asm["_crypto_stream_xsalsa20"];var _crypto_scalarmult_curve25519=Module["_crypto_scalarmult_curve25519"]=asm["_crypto_scalarmult_curve25519"];var _crypto_box_open_easy_afternm=Module["_crypto_box_open_easy_afternm"]=asm["_crypto_box_open_easy_afternm"];var _crypto_auth_hmacsha512=Module["_crypto_auth_hmacsha512"]=asm["_crypto_auth_hmacsha512"];var _crypto_stream_chacha20_ietf_xor_ic=Module["_crypto_stream_chacha20_ietf_xor_ic"]=asm["_crypto_stream_chacha20_ietf_xor_ic"];var _crypto_hash_sha256_update=Module["_crypto_hash_sha256_update"]=asm["_crypto_hash_sha256_update"];var _crypto_box_curve25519xsalsa20poly1305_seedbytes=Module["_crypto_box_curve25519xsalsa20poly1305_seedbytes"]=asm["_crypto_box_curve25519xsalsa20poly1305_seedbytes"];var _crypto_box_zerobytes=Module["_crypto_box_zerobytes"]=asm["_crypto_box_zerobytes"];var _crypto_stream_salsa20_keybytes=Module["_crypto_stream_salsa20_keybytes"]=asm["_crypto_stream_salsa20_keybytes"];var _crypto_auth_hmacsha512256_keybytes=Module["_crypto_auth_hmacsha512256_keybytes"]=asm["_crypto_auth_hmacsha512256_keybytes"];var _randombytes_uniform=Module["_randombytes_uniform"]=asm["_randombytes_uniform"];var _crypto_aead_chacha20poly1305_keybytes=Module["_crypto_aead_chacha20poly1305_keybytes"]=asm["_crypto_aead_chacha20poly1305_keybytes"];var _crypto_hash_sha512_bytes=Module["_crypto_hash_sha512_bytes"]=asm["_crypto_hash_sha512_bytes"];var _crypto_onetimeauth_statebytes=Module["_crypto_onetimeauth_statebytes"]=asm["_crypto_onetimeauth_statebytes"];var _crypto_generichash_blake2b_final=Module["_crypto_generichash_blake2b_final"]=asm["_crypto_generichash_blake2b_final"];var _crypto_generichash_blake2b_init_salt_personal=Module["_crypto_generichash_blake2b_init_salt_personal"]=asm["_crypto_generichash_blake2b_init_salt_personal"];var _crypto_box_seal=Module["_crypto_box_seal"]=asm["_crypto_box_seal"];var _crypto_sign_ed25519_publickeybytes=Module["_crypto_sign_ed25519_publickeybytes"]=asm["_crypto_sign_ed25519_publickeybytes"];var _free=Module["_free"]=asm["_free"];var runPostSets=Module["runPostSets"]=asm["runPostSets"];var _crypto_core_hsalsa20_keybytes=Module["_crypto_core_hsalsa20_keybytes"]=asm["_crypto_core_hsalsa20_keybytes"];var _crypto_sign_primitive=Module["_crypto_sign_primitive"]=asm["_crypto_sign_primitive"];var ___uremdi3=Module["___uremdi3"]=asm["___uremdi3"];var _crypto_scalarmult_curve25519_bytes=Module["_crypto_scalarmult_curve25519_bytes"]=asm["_crypto_scalarmult_curve25519_bytes"];var _crypto_auth_keybytes=Module["_crypto_auth_keybytes"]=asm["_crypto_auth_keybytes"];var _crypto_box=Module["_crypto_box"]=asm["_crypto_box"];var _crypto_onetimeauth_poly1305_keybytes=Module["_crypto_onetimeauth_poly1305_keybytes"]=asm["_crypto_onetimeauth_poly1305_keybytes"];var _crypto_box_curve25519xsalsa20poly1305_open_afternm=Module["_crypto_box_curve25519xsalsa20poly1305_open_afternm"]=asm["_crypto_box_curve25519xsalsa20poly1305_open_afternm"];var _crypto_pwhash_scryptsalsa208sha256_saltbytes=Module["_crypto_pwhash_scryptsalsa208sha256_saltbytes"]=asm["_crypto_pwhash_scryptsalsa208sha256_saltbytes"];var _crypto_aead_chacha20poly1305_npubbytes=Module["_crypto_aead_chacha20poly1305_npubbytes"]=asm["_crypto_aead_chacha20poly1305_npubbytes"];var _crypto_stream_primitive=Module["_crypto_stream_primitive"]=asm["_crypto_stream_primitive"];var _crypto_pwhash_argon2i_str_verify=Module["_crypto_pwhash_argon2i_str_verify"]=asm["_crypto_pwhash_argon2i_str_verify"];var _crypto_onetimeauth_poly1305_final=Module["_crypto_onetimeauth_poly1305_final"]=asm["_crypto_onetimeauth_poly1305_final"];var _crypto_shorthash=Module["_crypto_shorthash"]=asm["_crypto_shorthash"];var _crypto_onetimeauth_poly1305_bytes=Module["_crypto_onetimeauth_poly1305_bytes"]=asm["_crypto_onetimeauth_poly1305_bytes"];var _crypto_secretbox_detached=Module["_crypto_secretbox_detached"]=asm["_crypto_secretbox_detached"];var _crypto_box_curve25519xsalsa20poly1305_seed_keypair=Module["_crypto_box_curve25519xsalsa20poly1305_seed_keypair"]=asm["_crypto_box_curve25519xsalsa20poly1305_seed_keypair"];var _crypto_box_primitive=Module["_crypto_box_primitive"]=asm["_crypto_box_primitive"];var _crypto_pwhash_str=Module["_crypto_pwhash_str"]=asm["_crypto_pwhash_str"];var _crypto_box_detached_afternm=Module["_crypto_box_detached_afternm"]=asm["_crypto_box_detached_afternm"];var _crypto_stream_salsa20_xor_ic=Module["_crypto_stream_salsa20_xor_ic"]=asm["_crypto_stream_salsa20_xor_ic"];var _crypto_secretbox_xsalsa20poly1305_boxzerobytes=Module["_crypto_secretbox_xsalsa20poly1305_boxzerobytes"]=asm["_crypto_secretbox_xsalsa20poly1305_boxzerobytes"];var _crypto_auth_hmacsha256_init=Module["_crypto_auth_hmacsha256_init"]=asm["_crypto_auth_hmacsha256_init"];var _crypto_auth_hmacsha512_keybytes=Module["_crypto_auth_hmacsha512_keybytes"]=asm["_crypto_auth_hmacsha512_keybytes"];var _crypto_auth=Module["_crypto_auth"]=asm["_crypto_auth"];var _crypto_auth_hmacsha512256_final=Module["_crypto_auth_hmacsha512256_final"]=asm["_crypto_auth_hmacsha512256_final"];var _randombytes_random=Module["_randombytes_random"]=asm["_randombytes_random"];var _crypto_onetimeauth_verify=Module["_crypto_onetimeauth_verify"]=asm["_crypto_onetimeauth_verify"];var _crypto_pwhash_str_verify=Module["_crypto_pwhash_str_verify"]=asm["_crypto_pwhash_str_verify"];var _crypto_sign_keypair=Module["_crypto_sign_keypair"]=asm["_crypto_sign_keypair"];var _crypto_sign_ed25519_open=Module["_crypto_sign_ed25519_open"]=asm["_crypto_sign_ed25519_open"];var _crypto_generichash_keybytes_min=Module["_crypto_generichash_keybytes_min"]=asm["_crypto_generichash_keybytes_min"];var _crypto_generichash_statebytes=Module["_crypto_generichash_statebytes"]=asm["_crypto_generichash_statebytes"];var _crypto_aead_chacha20poly1305_encrypt_detached=Module["_crypto_aead_chacha20poly1305_encrypt_detached"]=asm["_crypto_aead_chacha20poly1305_encrypt_detached"];var _crypto_core_salsa20_keybytes=Module["_crypto_core_salsa20_keybytes"]=asm["_crypto_core_salsa20_keybytes"];var _crypto_aead_chacha20poly1305_ietf_nsecbytes=Module["_crypto_aead_chacha20poly1305_ietf_nsecbytes"]=asm["_crypto_aead_chacha20poly1305_ietf_nsecbytes"];var _crypto_pwhash_strprefix=Module["_crypto_pwhash_strprefix"]=asm["_crypto_pwhash_strprefix"];var _crypto_box_afternm=Module["_crypto_box_afternm"]=asm["_crypto_box_afternm"];var _crypto_auth_hmacsha512256_bytes=Module["_crypto_auth_hmacsha512256_bytes"]=asm["_crypto_auth_hmacsha512256_bytes"];var _crypto_box_curve25519xsalsa20poly1305_keypair=Module["_crypto_box_curve25519xsalsa20poly1305_keypair"]=asm["_crypto_box_curve25519xsalsa20poly1305_keypair"];var _crypto_hash_sha256_init=Module["_crypto_hash_sha256_init"]=asm["_crypto_hash_sha256_init"];var _crypto_pwhash_scryptsalsa208sha256_opslimit_sensitive=Module["_crypto_pwhash_scryptsalsa208sha256_opslimit_sensitive"]=asm["_crypto_pwhash_scryptsalsa208sha256_opslimit_sensitive"];var _crypto_pwhash_scryptsalsa208sha256_str_verify=Module["_crypto_pwhash_scryptsalsa208sha256_str_verify"]=asm["_crypto_pwhash_scryptsalsa208sha256_str_verify"];var _crypto_hash_primitive=Module["_crypto_hash_primitive"]=asm["_crypto_hash_primitive"];var _crypto_scalarmult_curve25519_scalarbytes=Module["_crypto_scalarmult_curve25519_scalarbytes"]=asm["_crypto_scalarmult_curve25519_scalarbytes"];var _crypto_sign_ed25519_pk_to_curve25519=Module["_crypto_sign_ed25519_pk_to_curve25519"]=asm["_crypto_sign_ed25519_pk_to_curve25519"];var _crypto_verify_64=Module["_crypto_verify_64"]=asm["_crypto_verify_64"];var _crypto_aead_chacha20poly1305_nsecbytes=Module["_crypto_aead_chacha20poly1305_nsecbytes"]=asm["_crypto_aead_chacha20poly1305_nsecbytes"];var _crypto_shorthash_siphash24=Module["_crypto_shorthash_siphash24"]=asm["_crypto_shorthash_siphash24"];var _crypto_box_curve25519xsalsa20poly1305_macbytes=Module["_crypto_box_curve25519xsalsa20poly1305_macbytes"]=asm["_crypto_box_curve25519xsalsa20poly1305_macbytes"];var _crypto_stream_chacha20_ietf=Module["_crypto_stream_chacha20_ietf"]=asm["_crypto_stream_chacha20_ietf"];var _crypto_generichash=Module["_crypto_generichash"]=asm["_crypto_generichash"];var _crypto_sign_ed25519=Module["_crypto_sign_ed25519"]=asm["_crypto_sign_ed25519"];var _crypto_core_hsalsa20_outputbytes=Module["_crypto_core_hsalsa20_outputbytes"]=asm["_crypto_core_hsalsa20_outputbytes"];var _crypto_pwhash_opslimit_interactive=Module["_crypto_pwhash_opslimit_interactive"]=asm["_crypto_pwhash_opslimit_interactive"];var _crypto_box_curve25519xsalsa20poly1305_noncebytes=Module["_crypto_box_curve25519xsalsa20poly1305_noncebytes"]=asm["_crypto_box_curve25519xsalsa20poly1305_noncebytes"];var _crypto_pwhash_memlimit_sensitive=Module["_crypto_pwhash_memlimit_sensitive"]=asm["_crypto_pwhash_memlimit_sensitive"];var _crypto_core_salsa20_constbytes=Module["_crypto_core_salsa20_constbytes"]=asm["_crypto_core_salsa20_constbytes"];var _crypto_box_boxzerobytes=Module["_crypto_box_boxzerobytes"]=asm["_crypto_box_boxzerobytes"];var _sodium_library_version_major=Module["_sodium_library_version_major"]=asm["_sodium_library_version_major"];var _crypto_verify_16_bytes=Module["_crypto_verify_16_bytes"]=asm["_crypto_verify_16_bytes"];var _crypto_aead_chacha20poly1305_ietf_encrypt=Module["_crypto_aead_chacha20poly1305_ietf_encrypt"]=asm["_crypto_aead_chacha20poly1305_ietf_encrypt"];var _crypto_pwhash_argon2i_saltbytes=Module["_crypto_pwhash_argon2i_saltbytes"]=asm["_crypto_pwhash_argon2i_saltbytes"];var _crypto_hash_sha512_update=Module["_crypto_hash_sha512_update"]=asm["_crypto_hash_sha512_update"];var _crypto_onetimeauth_poly1305_verify=Module["_crypto_onetimeauth_poly1305_verify"]=asm["_crypto_onetimeauth_poly1305_verify"];var _crypto_box_beforenm=Module["_crypto_box_beforenm"]=asm["_crypto_box_beforenm"];var _crypto_generichash_blake2b_init=Module["_crypto_generichash_blake2b_init"]=asm["_crypto_generichash_blake2b_init"];var _crypto_aead_chacha20poly1305_ietf_decrypt=Module["_crypto_aead_chacha20poly1305_ietf_decrypt"]=asm["_crypto_aead_chacha20poly1305_ietf_decrypt"];var _crypto_stream_chacha20_ietf_xor=Module["_crypto_stream_chacha20_ietf_xor"]=asm["_crypto_stream_chacha20_ietf_xor"];var _crypto_pwhash_primitive=Module["_crypto_pwhash_primitive"]=asm["_crypto_pwhash_primitive"];var _crypto_scalarmult=Module["_crypto_scalarmult"]=asm["_crypto_scalarmult"];var _crypto_onetimeauth_keybytes=Module["_crypto_onetimeauth_keybytes"]=asm["_crypto_onetimeauth_keybytes"];var _crypto_pwhash_argon2i=Module["_crypto_pwhash_argon2i"]=asm["_crypto_pwhash_argon2i"];var _crypto_auth_hmacsha512256_verify=Module["_crypto_auth_hmacsha512256_verify"]=asm["_crypto_auth_hmacsha512256_verify"];var _crypto_auth_hmacsha256_final=Module["_crypto_auth_hmacsha256_final"]=asm["_crypto_auth_hmacsha256_final"];var _crypto_box_secretkeybytes=Module["_crypto_box_secretkeybytes"]=asm["_crypto_box_secretkeybytes"];var _crypto_verify_16=Module["_crypto_verify_16"]=asm["_crypto_verify_16"];var _crypto_aead_chacha20poly1305_ietf_npubbytes=Module["_crypto_aead_chacha20poly1305_ietf_npubbytes"]=asm["_crypto_aead_chacha20poly1305_ietf_npubbytes"];var _crypto_onetimeauth_update=Module["_crypto_onetimeauth_update"]=asm["_crypto_onetimeauth_update"];var _crypto_aead_chacha20poly1305_encrypt=Module["_crypto_aead_chacha20poly1305_encrypt"]=asm["_crypto_aead_chacha20poly1305_encrypt"];var _crypto_secretbox_zerobytes=Module["_crypto_secretbox_zerobytes"]=asm["_crypto_secretbox_zerobytes"];var _crypto_core_salsa20=Module["_crypto_core_salsa20"]=asm["_crypto_core_salsa20"];var _llvm_cttz_i32=Module["_llvm_cttz_i32"]=asm["_llvm_cttz_i32"];var _pthread_mutex_lock=Module["_pthread_mutex_lock"]=asm["_pthread_mutex_lock"];var _crypto_box_curve25519xsalsa20poly1305_beforenmbytes=Module["_crypto_box_curve25519xsalsa20poly1305_beforenmbytes"]=asm["_crypto_box_curve25519xsalsa20poly1305_beforenmbytes"];var _crypto_pwhash_scryptsalsa208sha256_ll=Module["_crypto_pwhash_scryptsalsa208sha256_ll"]=asm["_crypto_pwhash_scryptsalsa208sha256_ll"];var _crypto_box_detached=Module["_crypto_box_detached"]=asm["_crypto_box_detached"];var _randombytes_buf=Module["_randombytes_buf"]=asm["_randombytes_buf"];var _crypto_box_open_detached_afternm=Module["_crypto_box_open_detached_afternm"]=asm["_crypto_box_open_detached_afternm"];var _crypto_sign_seedbytes=Module["_crypto_sign_seedbytes"]=asm["_crypto_sign_seedbytes"];var _crypto_pwhash_scryptsalsa208sha256_strbytes=Module["_crypto_pwhash_scryptsalsa208sha256_strbytes"]=asm["_crypto_pwhash_scryptsalsa208sha256_strbytes"];var _crypto_box_seal_open=Module["_crypto_box_seal_open"]=asm["_crypto_box_seal_open"];var _crypto_generichash_blake2b_saltbytes=Module["_crypto_generichash_blake2b_saltbytes"]=asm["_crypto_generichash_blake2b_saltbytes"];var _bitshift64Ashr=Module["_bitshift64Ashr"]=asm["_bitshift64Ashr"];var _crypto_box_open_detached=Module["_crypto_box_open_detached"]=asm["_crypto_box_open_detached"];var _crypto_scalarmult_bytes=Module["_crypto_scalarmult_bytes"]=asm["_crypto_scalarmult_bytes"];var _crypto_secretbox_xsalsa20poly1305=Module["_crypto_secretbox_xsalsa20poly1305"]=asm["_crypto_secretbox_xsalsa20poly1305"];var _pthread_self=Module["_pthread_self"]=asm["_pthread_self"];var _crypto_auth_verify=Module["_crypto_auth_verify"]=asm["_crypto_auth_verify"];var _crypto_sign_ed25519_seed_keypair=Module["_crypto_sign_ed25519_seed_keypair"]=asm["_crypto_sign_ed25519_seed_keypair"];var _crypto_secretbox_xsalsa20poly1305_zerobytes=Module["_crypto_secretbox_xsalsa20poly1305_zerobytes"]=asm["_crypto_secretbox_xsalsa20poly1305_zerobytes"];var _crypto_onetimeauth_poly1305_update=Module["_crypto_onetimeauth_poly1305_update"]=asm["_crypto_onetimeauth_poly1305_update"];var _crypto_auth_hmacsha512256_init=Module["_crypto_auth_hmacsha512256_init"]=asm["_crypto_auth_hmacsha512256_init"];var _crypto_auth_hmacsha256=Module["_crypto_auth_hmacsha256"]=asm["_crypto_auth_hmacsha256"];var _crypto_pwhash_strbytes=Module["_crypto_pwhash_strbytes"]=asm["_crypto_pwhash_strbytes"];var _crypto_stream_xor=Module["_crypto_stream_xor"]=asm["_crypto_stream_xor"];var _crypto_stream_xsalsa20_xor_ic=Module["_crypto_stream_xsalsa20_xor_ic"]=asm["_crypto_stream_xsalsa20_xor_ic"];var _crypto_verify_64_bytes=Module["_crypto_verify_64_bytes"]=asm["_crypto_verify_64_bytes"];var _randombytes_stir=Module["_randombytes_stir"]=asm["_randombytes_stir"];var _crypto_secretbox_easy=Module["_crypto_secretbox_easy"]=asm["_crypto_secretbox_easy"];var _crypto_box_open_easy=Module["_crypto_box_open_easy"]=asm["_crypto_box_open_easy"];var _crypto_pwhash_argon2i_strprefix=Module["_crypto_pwhash_argon2i_strprefix"]=asm["_crypto_pwhash_argon2i_strprefix"];var _crypto_auth_hmacsha256_update=Module["_crypto_auth_hmacsha256_update"]=asm["_crypto_auth_hmacsha256_update"];var _crypto_pwhash_scryptsalsa208sha256_str=Module["_crypto_pwhash_scryptsalsa208sha256_str"]=asm["_crypto_pwhash_scryptsalsa208sha256_str"];var _memset=Module["_memset"]=asm["_memset"];var _crypto_stream_salsa20=Module["_crypto_stream_salsa20"]=asm["_crypto_stream_salsa20"];var _crypto_pwhash_argon2i_str=Module["_crypto_pwhash_argon2i_str"]=asm["_crypto_pwhash_argon2i_str"];var _crypto_hash=Module["_crypto_hash"]=asm["_crypto_hash"];var _crypto_pwhash_argon2i_memlimit_sensitive=Module["_crypto_pwhash_argon2i_memlimit_sensitive"]=asm["_crypto_pwhash_argon2i_memlimit_sensitive"];var _crypto_pwhash_argon2i_opslimit_sensitive=Module["_crypto_pwhash_argon2i_opslimit_sensitive"]=asm["_crypto_pwhash_argon2i_opslimit_sensitive"];var _crypto_box_sealbytes=Module["_crypto_box_sealbytes"]=asm["_crypto_box_sealbytes"];var _crypto_auth_hmacsha512_final=Module["_crypto_auth_hmacsha512_final"]=asm["_crypto_auth_hmacsha512_final"];var _crypto_auth_hmacsha512_statebytes=Module["_crypto_auth_hmacsha512_statebytes"]=asm["_crypto_auth_hmacsha512_statebytes"];var _crypto_secretbox_boxzerobytes=Module["_crypto_secretbox_boxzerobytes"]=asm["_crypto_secretbox_boxzerobytes"];var _i64Subtract=Module["_i64Subtract"]=asm["_i64Subtract"];var _crypto_pwhash_alg_default=Module["_crypto_pwhash_alg_default"]=asm["_crypto_pwhash_alg_default"];var _crypto_pwhash_scryptsalsa208sha256_strprefix=Module["_crypto_pwhash_scryptsalsa208sha256_strprefix"]=asm["_crypto_pwhash_scryptsalsa208sha256_strprefix"];var _crypto_onetimeauth_primitive=Module["_crypto_onetimeauth_primitive"]=asm["_crypto_onetimeauth_primitive"];var _crypto_box_seedbytes=Module["_crypto_box_seedbytes"]=asm["_crypto_box_seedbytes"];var _crypto_stream_chacha20=Module["_crypto_stream_chacha20"]=asm["_crypto_stream_chacha20"];var _crypto_core_hsalsa20_constbytes=Module["_crypto_core_hsalsa20_constbytes"]=asm["_crypto_core_hsalsa20_constbytes"];var _crypto_generichash_bytes=Module["_crypto_generichash_bytes"]=asm["_crypto_generichash_bytes"];var _crypto_secretbox=Module["_crypto_secretbox"]=asm["_crypto_secretbox"];var _crypto_generichash_blake2b_statebytes=Module["_crypto_generichash_blake2b_statebytes"]=asm["_crypto_generichash_blake2b_statebytes"];var _crypto_box_open_afternm=Module["_crypto_box_open_afternm"]=asm["_crypto_box_open_afternm"];var _crypto_generichash_blake2b_bytes_min=Module["_crypto_generichash_blake2b_bytes_min"]=asm["_crypto_generichash_blake2b_bytes_min"];var _crypto_pwhash_opslimit_moderate=Module["_crypto_pwhash_opslimit_moderate"]=asm["_crypto_pwhash_opslimit_moderate"];var _crypto_secretbox_open=Module["_crypto_secretbox_open"]=asm["_crypto_secretbox_open"];var _crypto_auth_hmacsha512_bytes=Module["_crypto_auth_hmacsha512_bytes"]=asm["_crypto_auth_hmacsha512_bytes"];var _crypto_core_salsa20_inputbytes=Module["_crypto_core_salsa20_inputbytes"]=asm["_crypto_core_salsa20_inputbytes"];var _crypto_box_macbytes=Module["_crypto_box_macbytes"]=asm["_crypto_box_macbytes"];var _crypto_secretbox_macbytes=Module["_crypto_secretbox_macbytes"]=asm["_crypto_secretbox_macbytes"];var _crypto_shorthash_bytes=Module["_crypto_shorthash_bytes"]=asm["_crypto_shorthash_bytes"];var _crypto_box_publickeybytes=Module["_crypto_box_publickeybytes"]=asm["_crypto_box_publickeybytes"];var _pthread_cond_broadcast=Module["_pthread_cond_broadcast"]=asm["_pthread_cond_broadcast"];var _crypto_generichash_primitive=Module["_crypto_generichash_primitive"]=asm["_crypto_generichash_primitive"];var _crypto_sign_secretkeybytes=Module["_crypto_sign_secretkeybytes"]=asm["_crypto_sign_secretkeybytes"];var _crypto_pwhash_argon2i_strbytes=Module["_crypto_pwhash_argon2i_strbytes"]=asm["_crypto_pwhash_argon2i_strbytes"];var ___muldsi3=Module["___muldsi3"]=asm["___muldsi3"];var _crypto_hash_sha512_statebytes=Module["_crypto_hash_sha512_statebytes"]=asm["_crypto_hash_sha512_statebytes"];var _crypto_scalarmult_scalarbytes=Module["_crypto_scalarmult_scalarbytes"]=asm["_crypto_scalarmult_scalarbytes"];var _crypto_verify_32=Module["_crypto_verify_32"]=asm["_crypto_verify_32"];var _crypto_auth_hmacsha256_bytes=Module["_crypto_auth_hmacsha256_bytes"]=asm["_crypto_auth_hmacsha256_bytes"];var _crypto_auth_hmacsha256_statebytes=Module["_crypto_auth_hmacsha256_statebytes"]=asm["_crypto_auth_hmacsha256_statebytes"];var _crypto_pwhash_argon2i_opslimit_interactive=Module["_crypto_pwhash_argon2i_opslimit_interactive"]=asm["_crypto_pwhash_argon2i_opslimit_interactive"];var _crypto_aead_chacha20poly1305_decrypt=Module["_crypto_aead_chacha20poly1305_decrypt"]=asm["_crypto_aead_chacha20poly1305_decrypt"];var _crypto_stream_salsa20_noncebytes=Module["_crypto_stream_salsa20_noncebytes"]=asm["_crypto_stream_salsa20_noncebytes"];var _crypto_shorthash_keybytes=Module["_crypto_shorthash_keybytes"]=asm["_crypto_shorthash_keybytes"];var _malloc=Module["_malloc"]=asm["_malloc"];var _crypto_stream_noncebytes=Module["_crypto_stream_noncebytes"]=asm["_crypto_stream_noncebytes"];var _crypto_generichash_keybytes_max=Module["_crypto_generichash_keybytes_max"]=asm["_crypto_generichash_keybytes_max"];var _sodium_version_string=Module["_sodium_version_string"]=asm["_sodium_version_string"];var _memmove=Module["_memmove"]=asm["_memmove"];var _crypto_aead_chacha20poly1305_ietf_decrypt_detached=Module["_crypto_aead_chacha20poly1305_ietf_decrypt_detached"]=asm["_crypto_aead_chacha20poly1305_ietf_decrypt_detached"];var _crypto_hash_sha512_final=Module["_crypto_hash_sha512_final"]=asm["_crypto_hash_sha512_final"];var _crypto_pwhash_memlimit_interactive=Module["_crypto_pwhash_memlimit_interactive"]=asm["_crypto_pwhash_memlimit_interactive"];var _crypto_secretbox_xsalsa20poly1305_keybytes=Module["_crypto_secretbox_xsalsa20poly1305_keybytes"]=asm["_crypto_secretbox_xsalsa20poly1305_keybytes"];var _crypto_aead_chacha20poly1305_decrypt_detached=Module["_crypto_aead_chacha20poly1305_decrypt_detached"]=asm["_crypto_aead_chacha20poly1305_decrypt_detached"];var _crypto_sign=Module["_crypto_sign"]=asm["_crypto_sign"];var _crypto_box_curve25519xsalsa20poly1305_zerobytes=Module["_crypto_box_curve25519xsalsa20poly1305_zerobytes"]=asm["_crypto_box_curve25519xsalsa20poly1305_zerobytes"];var _crypto_secretbox_noncebytes=Module["_crypto_secretbox_noncebytes"]=asm["_crypto_secretbox_noncebytes"];var _crypto_box_keypair=Module["_crypto_box_keypair"]=asm["_crypto_box_keypair"];var _crypto_secretbox_xsalsa20poly1305_macbytes=Module["_crypto_secretbox_xsalsa20poly1305_macbytes"]=asm["_crypto_secretbox_xsalsa20poly1305_macbytes"];var _crypto_box_curve25519xsalsa20poly1305_boxzerobytes=Module["_crypto_box_curve25519xsalsa20poly1305_boxzerobytes"]=asm["_crypto_box_curve25519xsalsa20poly1305_boxzerobytes"];var _crypto_hash_sha256_bytes=Module["_crypto_hash_sha256_bytes"]=asm["_crypto_hash_sha256_bytes"];var ___udivdi3=Module["___udivdi3"]=asm["___udivdi3"];var _crypto_hash_bytes=Module["_crypto_hash_bytes"]=asm["_crypto_hash_bytes"];var _sodium_hex2bin=Module["_sodium_hex2bin"]=asm["_sodium_hex2bin"];var _sodium_init=Module["_sodium_init"]=asm["_sodium_init"];var _crypto_box_curve25519xsalsa20poly1305_afternm=Module["_crypto_box_curve25519xsalsa20poly1305_afternm"]=asm["_crypto_box_curve25519xsalsa20poly1305_afternm"];var _crypto_auth_hmacsha256_keybytes=Module["_crypto_auth_hmacsha256_keybytes"]=asm["_crypto_auth_hmacsha256_keybytes"];var _crypto_secretbox_keybytes=Module["_crypto_secretbox_keybytes"]=asm["_crypto_secretbox_keybytes"];var _crypto_box_easy=Module["_crypto_box_easy"]=asm["_crypto_box_easy"];var _randombytes=Module["_randombytes"]=asm["_randombytes"];var _crypto_sign_publickeybytes=Module["_crypto_sign_publickeybytes"]=asm["_crypto_sign_publickeybytes"];var _randombytes_close=Module["_randombytes_close"]=asm["_randombytes_close"];var _crypto_pwhash_argon2i_memlimit_moderate=Module["_crypto_pwhash_argon2i_memlimit_moderate"]=asm["_crypto_pwhash_argon2i_memlimit_moderate"];var _crypto_generichash_blake2b_bytes_max=Module["_crypto_generichash_blake2b_bytes_max"]=asm["_crypto_generichash_blake2b_bytes_max"];var _crypto_generichash_blake2b=Module["_crypto_generichash_blake2b"]=asm["_crypto_generichash_blake2b"];var __GLOBAL__I_000101=Module["__GLOBAL__I_000101"]=asm["__GLOBAL__I_000101"];var _crypto_stream_chacha20_noncebytes=Module["_crypto_stream_chacha20_noncebytes"]=asm["_crypto_stream_chacha20_noncebytes"];var _crypto_hash_sha256_statebytes=Module["_crypto_hash_sha256_statebytes"]=asm["_crypto_hash_sha256_statebytes"];var _crypto_secretbox_open_detached=Module["_crypto_secretbox_open_detached"]=asm["_crypto_secretbox_open_detached"];var _crypto_sign_ed25519_sk_to_seed=Module["_crypto_sign_ed25519_sk_to_seed"]=asm["_crypto_sign_ed25519_sk_to_seed"];var _crypto_core_salsa20_outputbytes=Module["_crypto_core_salsa20_outputbytes"]=asm["_crypto_core_salsa20_outputbytes"];var _crypto_sign_ed25519_secretkeybytes=Module["_crypto_sign_ed25519_secretkeybytes"]=asm["_crypto_sign_ed25519_secretkeybytes"];var _crypto_pwhash_opslimit_sensitive=Module["_crypto_pwhash_opslimit_sensitive"]=asm["_crypto_pwhash_opslimit_sensitive"];var ___muldi3=Module["___muldi3"]=asm["___muldi3"];var _crypto_generichash_blake2b_personalbytes=Module["_crypto_generichash_blake2b_personalbytes"]=asm["_crypto_generichash_blake2b_personalbytes"];var _bitshift64Shl=Module["_bitshift64Shl"]=asm["_bitshift64Shl"];var _crypto_box_curve25519xsalsa20poly1305_open=Module["_crypto_box_curve25519xsalsa20poly1305_open"]=asm["_crypto_box_curve25519xsalsa20poly1305_open"];var _crypto_sign_verify_detached=Module["_crypto_sign_verify_detached"]=asm["_crypto_sign_verify_detached"];var _crypto_pwhash_argon2i_opslimit_moderate=Module["_crypto_pwhash_argon2i_opslimit_moderate"]=asm["_crypto_pwhash_argon2i_opslimit_moderate"];var _crypto_pwhash_alg_argon2i13=Module["_crypto_pwhash_alg_argon2i13"]=asm["_crypto_pwhash_alg_argon2i13"];var _randombytes_implementation_name=Module["_randombytes_implementation_name"]=asm["_randombytes_implementation_name"];var _crypto_box_curve25519xsalsa20poly1305=Module["_crypto_box_curve25519xsalsa20poly1305"]=asm["_crypto_box_curve25519xsalsa20poly1305"];var _crypto_stream=Module["_crypto_stream"]=asm["_crypto_stream"];var _crypto_sign_ed25519_detached=Module["_crypto_sign_ed25519_detached"]=asm["_crypto_sign_ed25519_detached"];var _crypto_generichash_init=Module["_crypto_generichash_init"]=asm["_crypto_generichash_init"];var _i64Add=Module["_i64Add"]=asm["_i64Add"];var _crypto_sign_ed25519_sk_to_curve25519=Module["_crypto_sign_ed25519_sk_to_curve25519"]=asm["_crypto_sign_ed25519_sk_to_curve25519"];var _crypto_sign_bytes=Module["_crypto_sign_bytes"]=asm["_crypto_sign_bytes"];var _crypto_secretbox_primitive=Module["_crypto_secretbox_primitive"]=asm["_crypto_secretbox_primitive"];var _crypto_generichash_update=Module["_crypto_generichash_update"]=asm["_crypto_generichash_update"];var _pthread_mutex_unlock=Module["_pthread_mutex_unlock"]=asm["_pthread_mutex_unlock"];var _crypto_verify_32_bytes=Module["_crypto_verify_32_bytes"]=asm["_crypto_verify_32_bytes"];var _crypto_aead_chacha20poly1305_ietf_abytes=Module["_crypto_aead_chacha20poly1305_ietf_abytes"]=asm["_crypto_aead_chacha20poly1305_ietf_abytes"];var _crypto_generichash_blake2b_keybytes=Module["_crypto_generichash_blake2b_keybytes"]=asm["_crypto_generichash_blake2b_keybytes"];var _crypto_generichash_bytes_min=Module["_crypto_generichash_bytes_min"]=asm["_crypto_generichash_bytes_min"];var _crypto_box_curve25519xsalsa20poly1305_secretkeybytes=Module["_crypto_box_curve25519xsalsa20poly1305_secretkeybytes"]=asm["_crypto_box_curve25519xsalsa20poly1305_secretkeybytes"];var _crypto_stream_xsalsa20_xor=Module["_crypto_stream_xsalsa20_xor"]=asm["_crypto_stream_xsalsa20_xor"];var _crypto_sign_detached=Module["_crypto_sign_detached"]=asm["_crypto_sign_detached"];var _crypto_hash_sha512=Module["_crypto_hash_sha512"]=asm["_crypto_hash_sha512"];var _crypto_generichash_bytes_max=Module["_crypto_generichash_bytes_max"]=asm["_crypto_generichash_bytes_max"];var _crypto_box_easy_afternm=Module["_crypto_box_easy_afternm"]=asm["_crypto_box_easy_afternm"];var _crypto_stream_chacha20_xor_ic=Module["_crypto_stream_chacha20_xor_ic"]=asm["_crypto_stream_chacha20_xor_ic"];var _crypto_sign_ed25519_verify_detached=Module["_crypto_sign_ed25519_verify_detached"]=asm["_crypto_sign_ed25519_verify_detached"];var _crypto_sign_ed25519_bytes=Module["_crypto_sign_ed25519_bytes"]=asm["_crypto_sign_ed25519_bytes"];var _crypto_stream_xsalsa20_keybytes=Module["_crypto_stream_xsalsa20_keybytes"]=asm["_crypto_stream_xsalsa20_keybytes"];var _crypto_hash_sha256=Module["_crypto_hash_sha256"]=asm["_crypto_hash_sha256"];var _crypto_sign_ed25519_seedbytes=Module["_crypto_sign_ed25519_seedbytes"]=asm["_crypto_sign_ed25519_seedbytes"];var _sodium_library_version_minor=Module["_sodium_library_version_minor"]=asm["_sodium_library_version_minor"];var _crypto_core_hsalsa20_inputbytes=Module["_crypto_core_hsalsa20_inputbytes"]=asm["_crypto_core_hsalsa20_inputbytes"];var _crypto_onetimeauth_final=Module["_crypto_onetimeauth_final"]=asm["_crypto_onetimeauth_final"];var _crypto_secretbox_open_easy=Module["_crypto_secretbox_open_easy"]=asm["_crypto_secretbox_open_easy"];var _crypto_generichash_final=Module["_crypto_generichash_final"]=asm["_crypto_generichash_final"];var _crypto_generichash_blake2b_salt_personal=Module["_crypto_generichash_blake2b_salt_personal"]=asm["_crypto_generichash_blake2b_salt_personal"];var _crypto_pwhash_argon2i_alg_argon2i13=Module["_crypto_pwhash_argon2i_alg_argon2i13"]=asm["_crypto_pwhash_argon2i_alg_argon2i13"];var _crypto_shorthash_siphash24_bytes=Module["_crypto_shorthash_siphash24_bytes"]=asm["_crypto_shorthash_siphash24_bytes"];var _crypto_auth_hmacsha512256_statebytes=Module["_crypto_auth_hmacsha512256_statebytes"]=asm["_crypto_auth_hmacsha512256_statebytes"];var _crypto_sign_seed_keypair=Module["_crypto_sign_seed_keypair"]=asm["_crypto_sign_seed_keypair"];var _crypto_secretbox_xsalsa20poly1305_noncebytes=Module["_crypto_secretbox_xsalsa20poly1305_noncebytes"]=asm["_crypto_secretbox_xsalsa20poly1305_noncebytes"];var _crypto_pwhash_scryptsalsa208sha256_opslimit_interactive=Module["_crypto_pwhash_scryptsalsa208sha256_opslimit_interactive"]=asm["_crypto_pwhash_scryptsalsa208sha256_opslimit_interactive"];var _crypto_box_curve25519xsalsa20poly1305_beforenm=Module["_crypto_box_curve25519xsalsa20poly1305_beforenm"]=asm["_crypto_box_curve25519xsalsa20poly1305_beforenm"];var _crypto_pwhash_argon2i_memlimit_interactive=Module["_crypto_pwhash_argon2i_memlimit_interactive"]=asm["_crypto_pwhash_argon2i_memlimit_interactive"];var _crypto_hash_sha256_final=Module["_crypto_hash_sha256_final"]=asm["_crypto_hash_sha256_final"];var _crypto_stream_chacha20_xor=Module["_crypto_stream_chacha20_xor"]=asm["_crypto_stream_chacha20_xor"];var _crypto_stream_keybytes=Module["_crypto_stream_keybytes"]=asm["_crypto_stream_keybytes"];var _crypto_box_curve25519xsalsa20poly1305_publickeybytes=Module["_crypto_box_curve25519xsalsa20poly1305_publickeybytes"]=asm["_crypto_box_curve25519xsalsa20poly1305_publickeybytes"];var _crypto_onetimeauth_init=Module["_crypto_onetimeauth_init"]=asm["_crypto_onetimeauth_init"];var _crypto_core_hsalsa20=Module["_crypto_core_hsalsa20"]=asm["_crypto_core_hsalsa20"];var _crypto_pwhash_memlimit_moderate=Module["_crypto_pwhash_memlimit_moderate"]=asm["_crypto_pwhash_memlimit_moderate"];var dynCall_iiiiiiii=Module["dynCall_iiiiiiii"]=asm["dynCall_iiiiiiii"];var dynCall_viiiii=Module["dynCall_viiiii"]=asm["dynCall_viiiii"];var dynCall_iiiiiid=Module["dynCall_iiiiiid"]=asm["dynCall_iiiiiid"];var dynCall_vi=Module["dynCall_vi"]=asm["dynCall_vi"];var dynCall_vii=Module["dynCall_vii"]=asm["dynCall_vii"];var dynCall_iiiiiii=Module["dynCall_iiiiiii"]=asm["dynCall_iiiiiii"];var dynCall_ii=Module["dynCall_ii"]=asm["dynCall_ii"];var dynCall_iiiiiiiiiiii=Module["dynCall_iiiiiiiiiiii"]=asm["dynCall_iiiiiiiiiiii"];var dynCall_iiii=Module["dynCall_iiii"]=asm["dynCall_iiii"];var dynCall_viiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiii"]=asm["dynCall_viiiiiiiiiiiiiii"];var dynCall_viiiiii=Module["dynCall_viiiiii"]=asm["dynCall_viiiiii"];var dynCall_viiiiiii=Module["dynCall_viiiiiii"]=asm["dynCall_viiiiiii"];var dynCall_viiiiiiiiii=Module["dynCall_viiiiiiiiii"]=asm["dynCall_viiiiiiiiii"];var dynCall_iii=Module["dynCall_iii"]=asm["dynCall_iii"];var dynCall_iiiiii=Module["dynCall_iiiiii"]=asm["dynCall_iiiiii"];var dynCall_i=Module["dynCall_i"]=asm["dynCall_i"];var dynCall_iiiii=Module["dynCall_iiiii"]=asm["dynCall_iiiii"];var dynCall_viii=Module["dynCall_viii"]=asm["dynCall_viii"];var dynCall_v=Module["dynCall_v"]=asm["dynCall_v"];var dynCall_iiiiiiiii=Module["dynCall_iiiiiiiii"]=asm["dynCall_iiiiiiiii"];var dynCall_iiiiid=Module["dynCall_iiiiid"]=asm["dynCall_iiiiid"];var dynCall_viiii=Module["dynCall_viiii"]=asm["dynCall_viiii"];Runtime.stackAlloc=asm["stackAlloc"];Runtime.stackSave=asm["stackSave"];Runtime.stackRestore=asm["stackRestore"];Runtime.establishStackSpace=asm["establishStackSpace"];Runtime.setTempRet0=asm["setTempRet0"];Runtime.getTempRet0=asm["getTempRet0"];function ExitStatus(status){this.name="ExitStatus";this.message="Program terminated with exit("+status+")";this.status=status}ExitStatus.prototype=new Error;ExitStatus.prototype.constructor=ExitStatus;var initialStackTop;var preloadStartTime=null;var calledMain=false;dependenciesFulfilled=function runCaller(){if(!Module["calledRun"])run();if(!Module["calledRun"])dependenciesFulfilled=runCaller};Module["callMain"]=Module.callMain=function callMain(args){args=args||[];ensureInitRuntime();var argc=args.length+1;function pad(){for(var i=0;i<4-1;i++){argv.push(0)}}var argv=[allocate(intArrayFromString(Module["thisProgram"]),"i8",ALLOC_NORMAL)];pad();for(var i=0;i<argc-1;i=i+1){argv.push(allocate(intArrayFromString(args[i]),"i8",ALLOC_NORMAL));pad()}argv.push(0);argv=allocate(argv,"i32",ALLOC_NORMAL);try{var ret=Module["_main"](argc,argv,0);exit(ret,true)}catch(e){if(e instanceof ExitStatus){return}else if(e=="SimulateInfiniteLoop"){Module["noExitRuntime"]=true;return}else{if(e&&typeof e==="object"&&e.stack)Module.printErr("exception thrown: "+[e,e.stack]);throw e}}finally{calledMain=true}};function run(args){args=args||Module["arguments"];if(preloadStartTime===null)preloadStartTime=Date.now();if(runDependencies>0){return}preRun();if(runDependencies>0)return;if(Module["calledRun"])return;function doRun(){if(Module["calledRun"])return;Module["calledRun"]=true;if(ABORT)return;ensureInitRuntime();preMain();if(Module["onRuntimeInitialized"])Module["onRuntimeInitialized"]();if(Module["_main"]&&shouldRunNow)Module["callMain"](args);postRun()}if(Module["setStatus"]){Module["setStatus"]("Running...");setTimeout((function(){setTimeout((function(){Module["setStatus"]("")}),1);doRun()}),1)}else{doRun()}}Module["run"]=Module.run=run;function exit(status,implicit){if(implicit&&Module["noExitRuntime"]){return}if(Module["noExitRuntime"]){}else{ABORT=true;EXITSTATUS=status;STACKTOP=initialStackTop;exitRuntime();if(Module["onExit"])Module["onExit"](status)}if(ENVIRONMENT_IS_NODE){process["exit"](status)}else if(ENVIRONMENT_IS_SHELL&&typeof quit==="function"){quit(status)}throw new ExitStatus(status)}Module["exit"]=Module.exit=exit;var abortDecorators=[];function abort(what){if(what!==undefined){Module.print(what);Module.printErr(what);what=JSON.stringify(what)}else{what=""}ABORT=true;EXITSTATUS=1;var extra="\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";var output="abort("+what+") at "+stackTrace()+extra;if(abortDecorators){abortDecorators.forEach((function(decorator){output=decorator(output,what)}))}throw output}Module["abort"]=Module.abort=abort;if(Module["preInit"]){if(typeof Module["preInit"]=="function")Module["preInit"]=[Module["preInit"]];while(Module["preInit"].length>0){Module["preInit"].pop()()}}var shouldRunNow=true;if(Module["noInitialRun"]){shouldRunNow=false}run()




    ENVIRONMENT_IS_NODE && !process.removeAllListeners("uncaughtException");
    return Module;
}));
